/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 *
 */

var UWAWidget = (function () {

    var NV_HOST = 'www.netvibes.com';
    var NV_PATH = '/';
    var NV_STATIC = '';
    var NV_MODULES = 'nvmodules.netvibes.com';

    var ifproxyUrl = location.href.replace(/ox\.html(.*)$/, "") + "proxy.html";
    
    var UWAWidget = function (parameters) {
        this.url_params = {};
        this.configuration = {    title : "UWA Widget",
                                height: "250px",
                                border: "0px",
                                color:    "#000000",
                                displayTitle: false,
                                displayFooter: false,
                                autoresize: false    };
        for (key in parameters) {
           this[key] = parameters[key];
        }
        if(typeof this.container === undefined) {
            triggerEvent('OX_New_Error', 2 ,"No container defined for one or more UWA widgets");
        }
        if(typeof this.moduleUrl === undefined) {
            triggerEvent('OX_New_Error', 2 ,"No URI defined for one or more UWA widgets");
        }    
        if(typeof this.id === undefined) {
            triggerEvent('OX_New_Error', 2 ,"No id defined for one or more UWA widgets");
        }          
        this.moduleId = this.id.replace(/\s/g, "_") + (new Date()).getTime();
        this.iframe;
        this.renderWidget();  
        this.updateLayout();
    };
    
    UWAWidget.prototype = {
    
        setConfiguration : function (oConfiguration){
            for(var sProp in oConfiguration) {
              this.configuration[sProp] = oConfiguration[sProp];
             }
            this.updateLayout();        
        },
        setBorderWidth : function (){
            
        },
        setBorder : function (){
            
        },
        setColor : function (){
            
        },
        setTitle : function (){
            
        },
        setHeight : function (sHeight){
            this.configuration.height = sHeight;
            this.updateLayout();
        },
        setCommUrl : function (){
            
        },
        setDatas : function (){
            
        },
        setPreferencesValues : function (url_params){
            this.url_params = url_params;
            this.updateIframeUrl();
        },
        diplayTitle : function (){
            
        },
        displayFooter : function (){
            
        },
        updateIframeUrl : function (){
            this.iframe.src = this.getIframeUrl();
        },
        getIframeUrl : function (){
            var sUrl = "";
            if (typeof this.standalone == "boolean" && this.standalone) {
                sUrl = this.moduleUrl;
            } else {
                sUrl = "http://" + NV_MODULES + "/widget/frame/?id=" + 
                this.moduleId + "&uwaUrl=" + encodeURIComponent(this.moduleUrl) + 
                "&ifproxyUrl=" + encodeURIComponent(ifproxyUrl);
            }
            if (this.url_params && this.url_params.length != 0) {
                for (var sParam in this.url_params) {
                    var param = this.url_params[sParam];
                    // take care of garbage
                    if (!param || typeof param !== "string" || isEmpty(trimStr(param))) {
                        continue;
                    }
                    sUrl += (sUrl.match("\\?") ? "&" : "?") + sParam + "=" + param.format();
                }
            }
            return sUrl;
        },
        updateLayout : function (){
            //this.iframe.style.height = this.configuration.height;
            this.iframe.style.border =  this.configuration.border;
            this.iframe.style.color = this.configuration.color;
            this.iframe.setAttribute('height', this.configuration.height);
            this.iframe.setAttribute('frameBorder', 0);
            this.iframe.setAttribute('scrolling', 'auto');
            this.iframe.style.width = '100%';
        },
        renderWidget : function (){
            this.iframe = newnode("iframe", 0, { src: this.getIframeUrl(), id: "frame_" + this.moduleId });
            this.container.appendChild(this.iframe);
        }
    };
    
    return UWAWidget;
    
}());
/*
License:
  Copyright (c) 2005-2008 Netvibes (http://www.netvibes.org/).

  This file is part of Netvibes Widget Platform.

  Netvibes Widget Platform is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Netvibes Widget Platform is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with Netvibes Widget Platform.  If not, see <http://www.gnu.org/licenses/>.
*/

if (typeof UWA == 'undefined') UWA = {};

UWA.iFrameMessaging = function() {};

UWA.iFrameMessaging.prototype = {
    _options : {},
    
    init: function(options){
        var _this = this;
        
        if (typeof options!='object' || !options.eventHandler) {
            return;
        }
        
        this._options  = options;
        
        if (typeof document.postMessage === 'function' || typeof window.postMessage === 'function') {
            window.addEventListener('message',  function(msg){
                var origin = msg.origin;
                if (origin){ // Common case
                    origin = origin.split('//')[1];
                } else { // Opera case
                    origin = msg.domain;
                }

                _this.dispatch(msg.data, origin, 'postMessage');
            }, false);
        }
    },
    
    dispatch: function(msg, msgOrigin, msgCommType){
        var options = this._options;
        msgOrigin = unescape(msgOrigin);
        if (typeof options.trustedOrigin == 'undefined' || msgOrigin==options.trustedOrigin){
            var msg = this.decodeJson(msg);
            if (msg) {
                msg.commType = msgCommType;
                options.eventHandler(msg);
            };
        } else {
             throw new Error('Origin ' + msgOrigin + ' is not trusted.');
        }
    },
    
    decodeJson: function(json){
        var ret = false;
        if ((/^[,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]*$/).test(unescape(json).replace(/\\./g, '@').replace(/"[^"\\\n\r]*"/g, ''))) {
            ret = eval('(' + unescape(json) + ')');
        }
        return ret;
    }
};

/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Matthias Biggeleben <matthias.biggeleben@open-xchange.com>
 *
 */

/*jslint bitwise: false, nomen: false, onevar: false, plusplus: false, regexp: false, white: true, browser: true, devel: true, evil: true, forin: true, undef: true, eqeqeq: true, immed: true, continue: true */

/*global ox, jQuery, registerModule, _, PortalItem, registerView, showNode, hideNode,
cPortal, OXCache, register, triggerEvent, configuration_changed_fields,
getFullImgSrc, PortalExternalItem, url, UWA, internalCache, Join, clone,
addTranslated, getGreetingPhrase, newtext, IE, isEmpty, trimStr */

registerModule("portal", _("Start Page"), 1);

var bPortalNeedsRepaint = false;
var oPortalObject = null;

// -------

var oPortal = (function ($) {

    // dom nodes
    var dom = {};

    // widgets
    var widgets = [];
    var grid = [];

    // layout nodes
    var layoutNodes = $();

    // placeholder for DnD
    var placeholder = $("<div/>").addClass("ox-portal-placeholder");

    // config shortcut/keys
    var config = $.noop;
    var keyInternal = "gui.portal.internalcontents";

    // current layout
    var currentLayout = 2;

    // DnD
    var dnd = {};
    (function () {

        var gridX = [], gridY = {};

        var px, py;
        var ppx, ppy;
        var outer, width, height;
        var iframes;

        var numSort = function (a, b) {
            return a - b;
        };

        var getGridPosition = function (x, y) {
            // consider dimensions
            x = x + (width >> 1);
            // transform mouse position to grid position
            px = 0;
            py = -1;
            var i, $i;
            for (i = 0, $i = gridX.length; i < $i; i++) {
                if (x > gridX[i]) {
                    px = i;
                }
            }
            if (gridY[px] !== undefined) {
                for (i = 0, $i = gridY[px].length; i < $i; i++) {
                    if (y > gridY[px][i]) {
                        py = i;
                    }
                }
            }
        };

        dnd.getWidget = function (x, y) {
            // loop widgets
            var i = 0, $i = grid.length, obj;
            for (; i < $i; i++) {
                obj = grid[i];
                if (obj.x === x && obj.y === y) {
                    return obj;
                }
            }
            return null;
        };

        dnd.start = function (n) {

            // remember
            outer = n;
            width = n.outerWidth();
            height = n.outerHeight();

            // resize placeholder
            placeholder.height((height - 4) + "px");

            // vars
            var i, $i, node, offset, x, y;

            // get vertical borders
            gridX = [];
            for (i = 0, $i = layoutNodes.length; i < $i; i++) {
                // get node
                node = layoutNodes.eq(i);
                // get offset
                offset = node.offset();
                // floor
                x = offset.left >> 0;
                // add
                gridX.push(x);
            }

            // get horizontal borders
            gridY = {};
            // loop widgets
            for (i = 0, $i = grid.length; i < $i; i++) {
                // get node
                node = grid[i].node;
                x = grid[i].x;
                // get offset
                offset = node.offset();
                // floor
                y = (offset.top >> 0);
                if (gridY[x] === undefined) {
                    gridY[x] = [];
                }
                gridY[x].push(y);
            }
            // sort x
            gridX.sort(numSort);
            // sort y
            for (x in gridY) {
                gridY[x].sort(numSort);
            }

            // apply iframe fix
            iframes = dom.container.find("iframe").overlay();
        };

        dnd.update = function (x, y) {
            // add scroll position
            y += dom.container.scrollTop();
            // get grid position (set globalish px/py)
            getGridPosition(x, y);
            // change position?
            if (px !== ppx || py !== ppy) {
                if (py === -1) {
                    // add as first
                    placeholder.prependTo(layoutNodes.eq(px).children());
                } else {
                    var widget = dnd.getWidget(px, py);
                    if (widget) {
                        // insert after
                        placeholder.insertAfter(widget.node);
                    } else {
                        // append
                        placeholder.appendTo(layoutNodes.eq(px).children());
                    }
                }
                ppx = px;
                ppy = py;
            }
        };

        dnd.stop = function () {

            // remove iframe fix
            iframes.overlay(false);

            // insert after
            outer.insertAfter(placeholder);
            // remove placeholder
            placeholder.remove();
            // show
            outer.show();
            // clear grid
            grid = [];
            // reset dnd
            ppx = ppy = undefined;

            // loop over layoutNodes
            layoutNodes.each(function (x, node) {
                $(node).children().first().children().each(function (y, node) {
                    // get widget
                    var widget = $(node).data("widget");
                    // update grid
                    grid.push({
                        widget: widget,
                        node: $(node),
                        x: x,
                        y: y
                    });
                });
            });

            // update configuration
            dnd.store();
        };

        dnd.store = function () {

            // clone grid
            var tmp = grid.slice();

            var getPosition = function (key, value) {
                var i = 0, $i = tmp.length, obj, pos = null;
                for (; i < $i; i++) {
                    obj = tmp[i];
                    if (obj.widget[key] === value && value !== undefined) {
                        pos = { x: obj.x, y: obj.y };
                        break;
                    }
                }
                return pos;
            };

            var updatePositions = function (internal, list) {
                var i = 0, $i = list.length, obj, pos;
                for (; i < $i; i++) {
                    obj = list[i];
                    if (internal) {
                        pos = getPosition("module", obj.module);
                    } else {
                        pos = getPosition("id", obj.id || obj.title);
                    }
                    if (pos) {
                        obj.adj = pos;
                        // updating external
                        if (!internal && obj.visible === true) {
                            ox.uwa.update(obj);
                        }
                    }
                }
                return list;
            };

            // update internal
            config.set(keyInternal, updatePositions(true, config.get(keyInternal)));

            // updating external positions
            if (ox.api.config.get("modules.uwaWidgets.enabled") === true) {
                ox.uwa.list(function (data) {
                    updatePositions(false, data);
                });
            };

            configuration_changed_fields.gui = true;
        };

        dnd.close = function (data) {

            var key, value, list, obj;
            var isInternal = data.module !== undefined;
            var i = 0, $i;

            // internal?
            if (isInternal) {
                key = "module";
                value = data.module;
                list = config.get(keyInternal);

                // loop
                for ($i = list.length; i < $i; i++) {
                    obj = list[i];
                    if (obj[key] === value) {
                        // set invisible
                        obj.visible = false;
                        if (isInternal) {
                            // update limit
                            obj.params.limit = 0;
                        }
                        break;
                    }
                }

                // update config
                config.set(keyInternal, list);
            } else {
                obj = ox.uwa.get(data.id || data.title);
                if (obj) {
                    obj.visible = false;
                    ox.uwa.update(obj);
                }
            }
            configuration_changed_fields.gui = true;
        };

    }());

    /*
     * Widget registry. Can be used by plugins to add pseudo-internal widgets
     */
    var registry = (function () {

        var getHash = function (list) {
            var i = 0, $i = list.length, obj, tmp = {};
            for (; i < $i; i++) {
                obj = list[i];
                if (obj.id !== undefined) {
                    tmp[obj.id] = i;
                }
            }
            return tmp;
        };

        var widgets = {};

        return {

            merge: function (list) {
                try {
                    // get hash
                    var tmp = getHash(list);
                    // loop over widgets
                    var id, widget;
                    for (id in widgets) {
                        // get widget
                        widget = widgets[id];
                        // not in list?
                        if (tmp[id] === undefined) {
                            list.push(widget.data);
                        }
                    }
                    // remove undefined custom widgets
                    var i = 0, obj;
                    for (; i < list.length;) {
                        obj = list[i];
                        if (obj.module === "custom" && widgets[obj.id] === undefined) {
                            list.splice(i, 1);
                        } else {
                            i++;
                        }
                    }
                } catch (e) {
                    if (url.dev) {
                        console.error(e);
                    }
                }
                return list;
            },

            add: function (options) {

                var opt = $.extend({
                    x: 0,
                    y: 0,
                    paint: $.noop,
                    title: _("Custom Widget")
                }, options);

                if (opt.id !== undefined) {
                    // add widget
                    widgets[opt.id] = {
                        data: {
                            id: opt.id,
                            adj: {
                                x: opt.x,
                                y: opt.y
                            },
                            module: "custom",
                            external: false,
                            visible: true,
                            params: { limit: 0 },
                            "protected": true // no close allowed
                        },
                        painter: opt.paint,
                        title: opt.title
                    };
                }
            },

            getPainter: function (id) {
                return widgets[id] !== undefined ? widgets[id].painter : $.noop;
            },

            getTitle: function (id) {
                return widgets[id] !== undefined ? widgets[id].title : _("Custom Widget");
            }
        };

    }());

    // local functions
    var paint, drawCheckboxes, drawWidget, enable;

    drawWidget = function (node, data, isInternal) {

        var outer, header, title, inner;
        var close = $();

        // protected - no close allowed
        if (data["protected"] !== true) {
            close = $("<img/>")
                .attr({
                    src: getFullImgSrc("img/dummy.gif"),
                    alt: ""
                })
                .addClass("ox-portal-close")
                .bind("click", function () {
                    dnd.close(data);
                    drawCheckboxes();
                    oPortal.repaint();
                });
        }

        outer = $("<div/>")
            .addClass("ox-portal-widget").css({
                position: "relative"
            })
            .append(
                header = $("<div/>")
                    .addClass("ox-portal-header")
                    .attr('data-ox-module', data.module || '')
                    .append(
                        close
                    )
                    .append(
                        title = $("<div/>").text("\u00a0").addClass("ox-portal-header-handle")
                    )
            )
            .append(
                inner = $("<div/>")
                    .css({
                        position: "relative",
                        minHeight: "50px",
                        padding: "8px"
                    })
            )
            .appendTo(node);

        // set title
        switch (data.module) {
        case "calendar":
            title.text(String(_("Calendar")));
            break;
        case "mail":
            title.text(String(_("E-Mail")));
            break;
        case "contacts":
            title.text(String(_("Contacts")));
            break;
        case "tasks":
            title.text(String(_("Tasks")));
            break;
        case "infostore":
            title.text(String(_("InfoStore")));
            break;
        case "custom":
            title.text(String(registry.getTitle(data.id)));
            break;
        default: // external
            title.text(String(data.title));
            break;
        }

        // prevent selection
        if (ox.browser.Gecko) {
            // Firefox
            outer.css("MozUserSelect", "-moz-none");
        } else {
            // IE, WebKit
            outer.bind("selectstart", function () {
                return false;
            });
        }

        // create new portal object
        var widget;
        if (isInternal) {
            widget = new PortalItem(
                data.module,
                inner.get(0),
                header.get(0),
                data.params.limit,
                data.adj,
                $("<div/>").get(0),
                dom.container.get(0)
            );
        } else {
            widget = new PortalExternalItem(
                data.id || data.title, // id
                data.module,
                inner.get(0),
                header.get(0),
                (data.parameter || data.parameters),
                data.adj,
                $("<div/>").get(0),
                dom.container.get(0),
                data.url
            );
            widget.autorefresh = data.autorefresh;
            widget.standalone = data.standalone;
        }

        outer.data("widget", widget);

        // make draggable
        outer.draggable({
            handle: ".ox-portal-header, .ox-portal-header-handle",
            helper: function () {
                // "clone" fix for jQuery (>1.5), since clone's default is now "true"
                return $(this).clone(false);
            },
            opacity: 0.75,
            revert: false,
            start: function (e, ui) {
                ui.helper.css({
                    width: outer.width() + "px",
                    height: outer.height() + "px",
                    zIndex: 65000
                }).find("iframe").remove();
                // get grid
                dnd.start(outer);
                // hide
                outer.hide();
            },
            drag: function (e, ui) {
                dnd.update(ui.position.left, ui.position.top);
            },
            stop: function (e, ui) {
                ui.helper.remove();
                dnd.stop();
                outer.show();
                placeholder.remove();
            }
        });

        return {
            x: data.adj.x,
            y: data.adj.y,
            node: outer,
            widget: widget
        };
    };

    var getAllData = function () {

        var meta = [];

        var success = function (response) {
            // loop over response
            var i = 0, $i = response.length, data, widget;
            for (; i < $i; i++) {
                // get widget
                widget = meta[i].widget;
                // error?
                if (response[i].error) {
                    widget.setError(response[i]);
                } else {
                    // set data
                    widget.setData(
                        response[i].data,
                        meta[i].index,
                        response[i].timestamp,
                        meta[i].limit
                    );
                }
            }

            enable();

            meta = response = data = widget = null;
        };

        // loop over internal widget instances
        var i = 0, $i = widgets.length, widget, req, all = [], j, $j;
        for (; i < $i; i++) {
            // get
            widget = widgets[i];
            // internal?
            if (!widget.extern) {
                // get requests
                req = widget.getRequests();
                // add
                for (j = 0, $j = req.length; j < $j; j++) {
                    all.push(req[j]);
                    meta.push({ widget: widget, index: j, limit: req[j].limit });
                }
            }
        }

        if (all.length !== 0) {
            // send "multiple" server request
            ox.api.http.PUT({
                module: "multiple",
                data: all,
                success: success
            });
        }
    };

    /*
     * Layout
     */

    var applyLayout = function () {

        // event
        triggerEvent('OX_Portal_BeforeLayoutChanged');

        var tmpl = $("<div/>").css({
            "float": "left",
            width: "100%"
        }).append(
            $("<div/>").css({
                marginRight: "15px",
                minHeight: "1px"
            })
        );

        // park widgets
        dom.container.find(".ox-portal-widget").detach();

        // clear
        layoutNodes.remove();
        layoutNodes = $();

        var add = function (node, last) {
            if (last) {
                node.children().first().css("marginRight", "0px");
            }
            layoutNodes = layoutNodes.add(
                node.appendTo(dom.columnContainer)
            );
        };

        // layout #1? (for IE7 one percent less than 100!)
        switch (currentLayout) {
        case 1:
            add(tmpl.clone().css({ width: "100%" }), true);
            break;
        case 2:
            add(tmpl.clone().css({ width: "50%" }));
            add(tmpl.clone().css({ width: "50%" }), true);
            break;
        case 3:
            add(tmpl.clone().css({ width: "33%" }));
            add(tmpl.clone().css({ width: "33%" }));
            add(tmpl.clone().css({ width: "34%" }), true);
            break;
        case 4:
            add(tmpl.clone().css({ width: "40%" }));
            add(tmpl.clone().css({ width: "60%" }), true);
            break;
        case 5:
            add(tmpl.clone().css({ width: "60%" }));
            add(tmpl.clone().css({ width: "40%" }), true);
            break;
        }

        // event
        triggerEvent('OX_Portal_LayoutChanged');
    };

    var getLayoutNode = function (adj) {
        var $l = layoutNodes.length, index = Math.max(0, Math.min(adj.x || 0, $l - 1));
        return layoutNodes.eq(index).children().first();
    };

    var refreshLayout = function () {
        // apply layout
        applyLayout();
        // loop over grid
        var i = 0, $i = grid.length, obj, node;
        for (; i < $i; i++) {
            obj = grid[i];
            // get layout node
            node = getLayoutNode({ x: obj.x, y: obj.y });
            // append
            node.append(obj.node);
        }
    };

    var drawPortal = function () {

        // apply layout
        applyLayout();

        // get internal objects
        var internal = config.get(keyInternal);
        var inbox = config.get("mail.folder.inbox");

        // concat array holding all widgets
        var concat = [];

        var sorter = function (a, b) {
            if (a.adj !== undefined && b.adj !== undefined) {
                return a.adj.y - b.adj.y;
            } else {
                return -1;
            }
        };

        // clear list
        widgets = [];
        grid = [];

        // add custom widgets?
        internal = registry.merge(internal);
        config.set(keyInternal, internal);

        // loop over internal widgets
        var i = 0;
        for (; i < internal.length; i++) {
            // get
            var item = internal[i];
            // defined?
            if (item.adj !== undefined) {
                // inbox missing?
                if (item.module === "mail" && inbox === null) {
                    item.visible = false;
                }
                // visible?
                if (item.visible) {
                    item.internal = true;
                    concat.push(item);
                }
            }
        }

        // finally build the grid
        var join = new Join(function () {

            // sort positions
            concat.sort(sorter);

            // building final grid
            var i = 0, $i = concat.length, item, node, obj;
            for (; i < $i; i++) {

                item = concat[i];

                // just in case no positions given!
                if (item.adj === undefined) {
                    item.adj = { x: 1, y: 1 };
                }

                // get layout node
                node = getLayoutNode(item.adj);
                // draw widget (returns instance of PortalItem)
                obj = drawWidget(node, item, item.internal);
                widgets.push(obj.widget);
                grid.push(obj);

                // paint frame for external widgets
                if (item.internal === false) {
                    obj.widget.appendFrame();
                } else if (item.module === "custom") {
                    // paint custom widget
                    $.proxy(registry.getPainter(item.id), $(obj.widget.container))();
                }
            }
            // get all data
            getAllData();
        });

        var last = join.add();

        // get external uwas
        if (ox.api.config.get("modules.uwaWidgets.enabled") === true) {
            ox.uwa.list(join.add(function (external) {
                external = clone(external);
                if (url.external !== 0) {
                    // loop over external widgets
                    var i = 0, $i = external.length, item;
                    for (; i < $i; i++) {
                        // get object
                        item = external[i];
                        // visible?
                        if (item.visible) {
                            item.internal = false;
                            concat.push(item);
                        }
                    }
                }
            }));
        }

        last();
    };

    drawCheckboxes = function () {

        var limits = { mail: 10, calendar: 10, contacts: 0, tasks: 10, infostore: 5 };

        var fnChange = function (e) {
            // get module
            var module = e.data.module;
            var checked = $(this).is(":checked");
            // get internal widgets
            var i = 0, list = config.get(keyInternal), $i = list.length, obj;
            for (; i < $i; i++) {
                obj = list[i];
                if (obj.module === module) {
                    obj.visible = checked;
                    obj.params.limit = checked ? limits[module] : 0;
                    break;
                }
            }
            // update config
            config.set(keyInternal, list);
            // repaint
            paint(true);
        };

        var isChecked = function (module) {
            // get internal widgets
            var i = 0, list = config.get(keyInternal), $i = list.length, obj, checked = false;
            for (; i < $i; i++) {
                obj = list[i];
                if (obj.module === module) {
                    checked = obj.visible;
                    break;
                }
            }
            return checked;
        };

        var checkbox = function (module, title) {

            // consider features
            var hasFeature = ox.upsell.matrix.hasFeature(module),
                // get checkbox
                box = $.checkbox(
                    "ox-portal-show-" + module, // id
                    "1", // value
                    hasFeature && isChecked(module), // checked
                    title, // label
                    fnChange, // callback
                    { module: module }, // data
                    hasFeature // enabled
                );
            // upsell?
            if (!hasFeature) {
                box
                .css("opacity", "0.60")
                .bind("click", module, function (e) {
                    // trigger
                    triggerEvent("Feature_Not_Available", "modules/" + module, window, "portal", e);
                    return false;
                });
            }
            // return
            return $().add(box).add($("<br/>"));
        };

        // clear
        dom.checkboxes1.empty();
        dom.checkboxes2.empty();

        // add
        if (ox.upsell.isVisible("mail")) {
            dom.checkboxes1.append(checkbox("mail", addTranslated("Show mails"))); /*i18n*/
        }
        if (ox.upsell.isVisible("calendar")) {
            dom.checkboxes1.append(checkbox("calendar", addTranslated("Show appointments"))); /*i18n*/
        }
        if (ox.upsell.isVisible("contacts")) {
            dom.checkboxes1.append(checkbox("contacts", addTranslated("Show contacts"))); /*i18n*/
        }
        if (ox.upsell.isVisible("tasks")) {
            dom.checkboxes2.append(checkbox("tasks", addTranslated("Show tasks"))); /*i18n*/
        }
        if (ox.upsell.isVisible("infostore")) {
            dom.checkboxes2.append(checkbox("infostore", addTranslated("Show files"))); /*i18n*/
        }
    };

    paint = function (force) {

        var isFirst = false, className = "", link;

        if (dom.container === undefined) {

            // set shortcut
            config = ox.api.config;

            // get layout
            currentLayout = config.get("gui.portal.layout", 2);

            // topbar
            dom.topbar = $("<div/>")
                .addClass("ox-portal-topbar")
                .css({
                    position: "absolute",
                    top: "0px",
                    right: "0px",
                    height: "30px",
                    lineHeight: "30px",
                    left: "0px",
                    padding: "0px 28px 0px 10px",
                    textAlign: "left",
                    zIndex: 2
                })
                .append(
                    $("<i/>")
                        .append(addTranslated(getGreetingPhrase()))
                        .append(newtext(", "))
                )
                .append($("<b/>").text(""))
                .append($("<span/>").text(". \u00a0 "))
                .append(
                    link = $("<a/>")
                )
                .appendTo("#portalContainer");

            var id = config.get("identifier");
            var setName = function(data) {
                dom.topbar.children().eq(1).text(String(data[id].display_name));
            };
            internalCache.getUsers([id], setName);
            internalCache.registerUpdate(setName);

            var fnChangeLayout = function (e) {
                // get nodes
                var nodes = dom.controls.find(".ox-portal-layout");
                // remove class
                nodes.eq(currentLayout - 1).removeClass("active");
                // set new layout
                currentLayout = e.data.layout || 2;
                // update config
                config.set("gui.portal.layout", currentLayout);
                configuration_changed_fields.gui = true;
                // add class
                nodes.eq(currentLayout - 1).addClass("active");
                // refresh layout
                refreshLayout();
            };

            // controls
            dom.controls = $("<div/>")
                .addClass("ox-portal-controls")
                .css({
                    position: "absolute",
                    top: "30px",
                    right: "0px",
                    height: "60px",
                    left: "0px",
                    padding: "10px",
                    zIndex: 1
                })
                .append(
                    $("<table/>", { border: "0", cellPadding: "0", cellSpacing: "0" })
                        .append(
                            $("<tbody/>")
                                .append(
                                    $("<tr/>")
                                        .append(
                                            $("<td>")
                                                .append(
                                                    $("<img/>", { src: getFullImgSrc("img/dummy.gif"), alt: "" })
                                                        .addClass("ox-portal-layout one")
                                                        .bind("click", { layout: 1 }, fnChangeLayout)
                                                )
                                                .css("padding", "0")
                                        )
                                        .append(
                                            $("<td>")
                                                .append(
                                                    $("<img/>", { src: getFullImgSrc("img/dummy.gif"), alt: "" })
                                                        .addClass("ox-portal-layout two")
                                                        .bind("click", { layout: 2 }, fnChangeLayout)
                                                )
                                                .css("padding", "0")
                                        )
                                        .append(
                                            $("<td>")
                                                .append(
                                                    $("<img/>", { src: getFullImgSrc("img/dummy.gif"), alt: "" })
                                                        .addClass("ox-portal-layout three")
                                                        .bind("click", { layout: 3 }, fnChangeLayout)
                                                )
                                                .css("padding", "0")
                                        )
                                        .append(
                                            $("<td>")
                                                .append(
                                                    $("<img/>", { src: getFullImgSrc("img/dummy.gif"), alt: "" })
                                                        .addClass("ox-portal-layout four")
                                                        .bind("click", { layout: 4 }, fnChangeLayout)
                                                )
                                                .css("padding", "0")
                                        )
                                        .append(
                                            $("<td>")
                                                .append(
                                                    $("<img/>", { src: getFullImgSrc("img/dummy.gif"), alt: "" })
                                                        .addClass("ox-portal-layout five")
                                                        .bind("click", { layout: 5 }, fnChangeLayout)
                                                )
                                                .css("padding", "0")
                                        )
                                        .append(
                                            dom.checkboxes1 = $("<td/>")
                                                .css({
                                                    verticalAlign: "top",
                                                    height: "60px",
                                                    paddingRight: "20px"
                                                })
                                        )
                                        .append(
                                            dom.checkboxes2 = $("<td/>")
                                                .css({
                                                    verticalAlign: "top",
                                                    height: "60px",
                                                    paddingRight: "20px"
                                                })
                                        )
                                )
                        )
                )
                .hide()
                .appendTo("#portalContainer");

            // add jump into UWA config
            if (ox.api.config.get("modules.uwaWidgets.enabled") === true) {
                dom.controls.find("tr").append(
                    $("<td/>")
                        .css({
                            verticalAlign: "top",
                            height: "60px",
                            padding: "10px 20px 0px 0px"
                        }).append(
                            $.button({
                                title: "UWA Widgets...", /*i18n*/
                                theme: "dark",
                                click: function () {
                                    // jump
                                    ox.UIController.setModule({
                                        module: "configuration",
                                        view: "configuration/portal/external",
                                        success: function () {
                                            ox.widgets.configTree.get("configuration/portal").open();
                                            ox.widgets.configTree.selection.click("configuration/portal/external", false, false, true);
                                        }
                                    });
                                }
                            })
                        )
                );
            }

            drawCheckboxes();

            // which browser?
            if (ox.browser.Gecko) {
                className = "firefox";
            } else if (ox.browser.WebKit) {
                className = "webkit";
            } else if (ox.browser.IE) {
                className = "IE";
            }

            // main container
            var parent = $("#portalContainer").addClass(className);
            dom.container = $("<div>")
                .addClass("ox-portal")
                .css({
                    position: "absolute",
                    top: "30px",
                    right: "0px",
                    bottom: "0px",
                    left: "0px",
                    padding: "10px",
                    paddingRight: IE <= 7 ? "28px" : "10px", // IE7 hack
                    overflow: "hidden",
                    overflowX: "hidden",
                    overflowY: "scroll",
                    zIndex: 3
                })
                .append(
                    dom.columnContainer = $('<div>').addClass('ox-portal-column-container')
                )
                .appendTo(parent);

            // turn into quick config
            $.quickConfig(
                dom.container,
                dom.controls,
                link,
                "Change layout", /*i18n*/
                "Close configuration" /*i18n*/
            );

            // mark active layout
            dom.controls.find(".ox-portal-layout").eq(currentLayout - 1).addClass("active");

            isFirst = true;
        }
        if (isFirst || force) {
            drawPortal();
        } else {
            enable();
        }
        return isFirst;
    };

    /**
     * Enables all portal items.
     * Called automatically when the user enters the portal view.
     */
    enable = function () {
        var i = 0, $i = widgets.length, widget;
        for (; i < $i; i++) {
            widget = widgets[i];
            if (ox.util.isFunction(widget.update)) {
                widget.update();
            }
        }
    };

    // public function/variables
    return {

        // initialize
        paint: paint,

        repaint: function () {
            paint(true);
            drawCheckboxes();
        },

        refresh: function () {
            if (ox.UIController.getModule() === "portal") {
                getAllData();
            } else {
                bPortalNeedsRepaint = true;
            }
        },

        getGrid: function () {
            return grid;
        },

        refreshLayout: function () {
            refreshLayout();
        },

        applyConfig: function () {
            if (ox.UIController.getModule() === "portal") {
                drawCheckboxes();
                getAllData();
            } else {
                bPortalNeedsRepaint = true;
            }
        },

        /**
         * Disables all portal items.
         * Should be called when the user leaves the portal view.
         */
        disable: function () {
            var i = 0, $i = widgets.length, widget;
            for (; i < $i; i++) {
                widget = widgets[i];
                // uwa widgets cannot be disabled, so...
                if (ox.util.isFunction(widget.disable)) {
                    widget.disable();
                }
            }
        },

        /* widget registry */
        registry: registry
    };

}(jQuery));

// -------

registerView(
    "portal",
    // show
    function () {
        showNode("portal");
    },
    // enter
    function () {
        // use auto refresh?
        var autoRefresh = ox.api.config.get("ui.portal.autoRefresh", false) === true;
        

        if (bPortalNeedsRepaint) {
            // repaint
            oPortal.repaint(); // includes drawCheckboxes, getAllData
            bPortalNeedsRepaint = autoRefresh;
        } else {
            if (oPortal.paint()) {
                // set default folder for current module
                ox.api.ui.setFolder();
                // register
                register("OX_Refresh", oPortal.refresh);
                register("OX_Configuration_Changed", oPortal.applyConfig);
                bPortalNeedsRepaint = autoRefresh;
            }
        }

        // update toolbar
        ox.ToolBarController.processSelection("default", false, [], true);
    },
    // leave
    function () {
        //unregister("OX_Refresh", oPortal.refresh);
        oPortal.disable();
    },
    // hide
    function () {
        hideNode("portal");
    },
    // change
    function () {
    }
);

function fn_clickedItem(sModule, oObj) {
    OXCache.newRequest(null, sModule, { objects: [oObj] }, null, function () {
        triggerEvent("OX_Direct_Linking", sModule, oObj);
    });
}

register("OX_Portal_Click_Item", fn_clickedItem);

register("OX_Save_Configuration", function () {
    if (ox.api.ui.isModule("portal")) {
        // make sure changes got saved
        ox.uwa.save(jQuery.noop);
    }
});

/*
 * UWA Messaging
 */

(function () {

    var msgHandler = function (message) {
        var id = message.id;
        switch (message.action) {
        case "resizeHeight":
            var frame = document.getElementById('frame_' + id);
            if (frame) {
                // set height
                frame.setAttribute("height", message.value);
                // fix flicker (assumption: widgets that tell about their height don't need scroll bars)
                frame.setAttribute("scrolling", "no");
            }
            break;
        }
    };

    UWA.MessageHandler = new UWA.iFrameMessaging();
    UWA.MessageHandler.init({
        'eventHandler': msgHandler
    });

}());

ox.uwa = { util: {}, toStore: {} };

ox.uwa.list = function (cont) {
    function load() {
        ox.api.http.GET({
            module: "uwaWidgets",
            params: { action: "all" },
            appendColumns: false,
            success: function (response) {
                ox.uwa.cache = response;
                cont(ox.uwa.cache);
            }
        });
    }

    if (ox.api.config.contains("gui.portal.externalcontents") &&
            ox.api.config.get("gui.portal.externalcontents_migration") !== true) {
        ox.uwa.util.migrateUWAs("externalcontents", load);
    } else if (ox.uwa.cache !== undefined) {
        cont(ox.uwa.cache);
    } else {
        load();
    }
};

ox.uwa.exists = function (id) {
    return ox.uwa.get(id) ? true : false;
};

ox.uwa.get = function (id) {
    if (ox.uwa.cache) {
        var i;
        for (i in ox.uwa.cache) {
            if (ox.uwa.cache[i].id === id) {
                return ox.uwa.cache[i];
            }
        }
    }
    return null;
};

ox.uwa.add = function (uwa) {
    // do already exists or is name empty?
    if (isEmpty(uwa.title) || isEmpty(uwa)) {
        return null;
    }
    uwa.id = "tmpid" + ox.util.now();
    // required
    if (!uwa.adj) {
        uwa.adj = { x: 1, y: 1 };
    }

    ox.uwa.cache.push(uwa);
    ox.uwa.toStore[uwa.id] = "new";
    return uwa;
};

ox.uwa.update = function (uwa) {
    // mandatory fields set
    if ((isEmpty(uwa.title) || isEmpty(uwa.url)) && !ox.uwa.exists(uwa.id)) {
        return null;
    }
    var tmpUwa = ox.uwa.get(uwa.id);
    if (tmpUwa) {
        var i;
        for (i in uwa) {
            tmpUwa[i] = uwa[i];
        }
        // it's a new one, so just delete it
        if (!ox.uwa.toStore[tmpUwa.id] && ox.uwa.toStore[tmpUwa.id] !== "new") {
            ox.uwa.toStore[tmpUwa.id] = "update"; // store id for saving
        }
    }
    return tmpUwa;
};

ox.uwa.remove = function (ids) {

    if (typeof ids !== "object") {
        ids = [ ids ];
    }

    var i, ia, $l1 = ids.length;
    for (i = 0; i < ox.uwa.cache.length; i++) {
        for (ia = 0; ia < $l1; ia++) {
            if (ox.uwa.cache[i] && ox.uwa.cache[i].id === ids[ia]) {
                ox.uwa.cache.splice(i, 1);
                // it's a new one, so just delete it
                if (ox.uwa.toStore[ids[ia]] && ox.uwa.toStore[ids[ia]] === "new") {
                    delete ox.uwa.toStore[ids[ia]];
                } else {
                    ox.uwa.toStore[ids[ia]] = "delete"; // store id for saving
                }
            }
        }
    }
};

ox.uwa.save = function (cont) {
    var toStore = [];

    // prepare final object
    var i;
    for (i in ox.uwa.toStore) {
        var status = ox.uwa.toStore[i];
        var object = { action: status, module: "uwaWidgets" };
        if (status === "delete") {
            // delete looks different
            object.id = i;
        } else {
            var tmp = clone(ox.uwa.get(i));
            if (!tmp) {
                // ups, object does not exists
                continue;
            }
            // re-convert from ugly params format
            if (tmp.parameters && typeof tmp.patameters === "string") {
                tmp.parameters =  ox.uwa.util.convertParameters(tmp.parameters);
            }
            // only param adj is allowed for protected widgets
            if (tmp["protected"] === true && tmp.adj) {
                tmp = { id: tmp.id, adj: tmp.adj };
            }
            // set data object
            object.data = tmp;
        }
        // mix it back to final object
        toStore.push(object);
    }

    // store it to the server
    if (toStore.length !== 0) {
        ox.api.http.PUT({
            module: "multiple",
            appendColumns: false,
            processData: false,
            data: toStore,
            success: function (data) {
                // reset temp cache
                ox.uwa.toStore = {};
                if (cont) {
                    cont(data);
                }
            }
        });
    } else {
        // nothing to do
        if (cont) {
            cont(null);
        }
    }
};

ox.uwa.reset = function () {
    ox.uwa.cache = undefined;
    ox.uwa.toStore = {};
};

ox.uwa.util.convertParameters = function (parameters) {

    if (!parameters) {
        return parameters;
    }

    var formatedParams = "", a, i;

    // re-convert from ugly params format
    if (typeof parameters === "string") {
        formatedParams = {};
        var params1 = parameters.split(",");
        for (a = 0; a < params1.length; a++) {
            var params2 = params1[a].split(":", 1);
            if (params2.length === 1) {
                var key = params2[0];
                formatedParams[trimStr(key)] = trimStr(params1[a].substr(key.length + 1));
            }
        }

    } else if (typeof parameters === "object") {
        for (i in (parameters || {})) {
            var param = parameters[i];
            formatedParams += i + ": " + param + ", ";
        }
        formatedParams = formatedParams.replace(/,(\s+)?$/, "");
    }

    return formatedParams;
};

ox.uwa.util.migrateUWAs = function (type, cont) {
    var uwas = ox.api.config.get("gui.portal." + type, null);
    // nothing to migrate, continue
    if (uwas === null || uwas.length === 0 
            || ox.api.config.get("gui.portal." + type + "_migration") === true) {
        cont();
        return;
    }

    var toStore = [], i = 0, uwa;
    for (; i < uwas.length; i++) {
        // get
        uwa = uwas[i];
        // adj is required, otherwise won't be able to save it
        if (uwa.adj === undefined) {
            uwa.adj = "";
        }
        // new servlet accepts parameters, not parameter
        if (uwa.parameter !== undefined) {
            uwa.parameters = uwa.parameter;
        }
        // prepare multiple
        toStore.push({ action: "new", module: "uwaWidgets", data: uwa });
    }

    // store it to the server
    ox.api.http.PUT({
        module: "multiple",
        appendColumns: false,
        processData: false,
        data: toStore,
        success: function (data) {
            ox.api.config.set("gui.portal." + type + "_migration", true);
            configuration_changed_fields.gui = true;
            triggerEvent("OX_Save_Configuration", false, true);
            cont(data);
        }
    });
};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
function PortalExternalItem(sId,sModule,oDOMContainerDiv,oDOMHeaderDiv,oParams,oAdj,oCell,oResizeDiv,sUrl){
	this.module = sModule;
	this.id = sId;
	this.resize_div = oResizeDiv;
	this.adjust = oAdj;
	
	this.autorefresh  = false;
	this.standalone = false;
	
	this.params = oParams;
	
	this.oDOMTD = oCell;
	this.container = oDOMContainerDiv;
	this.header = oDOMHeaderDiv;
	this.newportal = true;
	
	this.uwa;
	this.url = sUrl;
	
	this.privheader;
	
	this.extern = true;
}
PortalExternalItem.prototype = {
	deleteFrame: function (){
		removeChildNodes(this.container);
		this.uwa = null;
	},
	appendFrame: function () {
		this.uwa = new UWAWidget({
		    inline: false, id:this.id, container: this.container,
		    moduleUrl: this.url, standalone: this.standalone
		});
		this.uwa.setConfiguration({
		    'title':'',  'borderWidth':'0', 
			'color':'#aaaaaa', 'displayTitle':false, 'displayFooter':false
		});
		this.uwa.setPreferencesValues(this.params);
	},
	update_content:function (newdata){
		this.uwa.setPreferencesValues(newdata.parameter || newdata.parameters);
		this.uwa.moduleUrl = newdata.url;
		this.uwa.updateIframeUrl();
		removeChildNodes(this.privheader);
		this.module = newdata.title;
		var oHeaderTextNode = document.createTextNode(this.module);
		this.privheader.appendChild(newnode('div',{paddingLeft:"30px"},0,[oHeaderTextNode]));
		this.autorefresh = newdata.autorefresh;
	},
	update: function () {
		if (this.autorefresh) {
			this.uwa.updateIframeUrl();
		}
	}
};

function PortalItem(sModule, oDOMContainerDiv, oDOMHeaderDiv, limitParam, oAdj, oCell, oResizeDiv) {
	this.module = sModule;
	this.id = this.module;
	this.resize_div = oResizeDiv;
	this.adjust = oAdj;
	this.oDOMTD = oCell;
	this.container = oDOMContainerDiv;
	this.header = oDOMHeaderDiv;
	this.newportal = true;
 	this.limit_count = limitParam;
 	this.live_grid = null;

	//comma separated list of columns which be displayed
	this.columns = initColumns(sModule);
	this.sDate = 0;
	this.error;
	this.data = new Array();	
	this.id_assoc = new Object();
	this.timestamp;
	
	this.sort = initSortParam(sModule);
	this.order = initOrderParam(sModule);
	
	this.column_heads = initColHeads(sModule);
	this.column_functions = initColFunctions(sModule);
	this.col_width = getArrayWidth(sModule);
	var Self = this;
	this.style = getStyle(sModule);
	this.ranges = getRanges(sModule);
	var UserArray = new Array();
	function getRanges(sModule) {
		var aRanges = new Array();
		switch (sModule){
			case "calendar":
					var t = new Date(now());
					t.setUTCHours(0);	
					t.setUTCMinutes(0);
					t.setUTCSeconds(0);
					t.setUTCMilliseconds(0);
					var nStartDay = t.getUTCDay();
					tend = new Date(t);
					tend.setUTCDate(tend.getUTCDate() + 1);
					for(var nIndx=nStartDay;nIndx<=7;nIndx++)
					{
						if(nIndx == nStartDay)
							var sHeadName = "Today"; /*i18n*/
						else
							var sHeadName = weekdays.untranslated[t.getUTCDay()];
						var lgObj = Self.createLg(sHeadName);
						aRanges.push({name:sHeadName,range:{start:t.getTime(),end:tend.getTime()},limit:Infinity,lg:lgObj.lg,section:lgObj.section});
						t.setUTCDate(t.getUTCDate()+1);						
						tend.setUTCDate(tend.getUTCDate()+1);
					}
					// check for limitations
					if (Self.limit_count !== undefined) {
						// show this week elements only?
						if (Self.limit_count !== -2) {
							tend.setUTCDate(tend.getUTCDate()-1);
							tnextend = new Date(tend);
							tnextend.setUTCDate(tnextend.getUTCDate()+7);
							var lgObj = Self.createLg("Next Week");
							aRanges.push({
								name:"Next Week", /*i18n*/
							    range: {
									start: tend.getTime(),
									end: tnextend.getTime()		
								},
								limit: Infinity,
								lg: lgObj.lg, 
								section: lgObj.section
							});
						}
						// show later elements?
						if (Self.limit_count > 0 || Self.linit_count === -2) {
	    					var tnextyear = new Date();
	    					tnextyear.setUTCHours(0);
	    					tnextyear.setUTCMinutes(0);
	    					tnextyear.setUTCSeconds(0);
	    					tnextyear.setUTCMilliseconds(0);
	    					tnextyear.setUTCFullYear(tnextyear.getUTCFullYear()+1);
	    					tnextyear.setUTCDate(tnextyear.getUTCDate()+1);
	    					var lgObj = Self.createLg("Later");	
	    					aRanges.push({
	    						name: "Later", /*i18n*/
	    					    range: {
	    							start: tnextend.getTime(),
	    							end: tnextyear.getTime(),
	    							limit: Self.limit_count
	    						},
	    						lg: lgObj.lg,
	    						section: lgObj.section	
	    					});
						}
					}
					break;
			case "tasks":
					var t = new Date();		
					t.setUTCHours(0);	
					t.setUTCMinutes(0);
					t.setUTCSeconds(0);
					var nStartDay = t.getUTCDay();
					tend = new Date(t);
					tend.setUTCDate(tend.getUTCDate()+1);					
					for(var nIndx=nStartDay;nIndx<=7;nIndx++)
					{
						if(nIndx == nStartDay)
							var sHeadName = "Today"; /*i18n*/
						else
							var sHeadName = weekdays.untranslated[t.getUTCDay()];						
						var lgObj = Self.createLg(sHeadName);
						aRanges.push({name:sHeadName,range:{start:t.getTime(),end:tend.getTime()},limit:Infinity,lg:lgObj.lg,section:lgObj.section});							
						t.setUTCDate(t.getUTCDate()+1);						
						tend.setUTCDate(tend.getUTCDate()+1);
					}
					// check for limitations
					if (Self.limit_count !== undefined) {
						// show this week elements only?
						if (Self.limit_count !== -2) {
							tend.setUTCDate(tend.getUTCDate()-1);
							tnextend = new Date(tend);
							tnextend.setUTCDate(tnextend.getUTCDate()+7);
							var lgObj = Self.createLg("Next Week");
							aRanges.push({
								name:"Next Week", /*i18n*/
							    range: {
									start: tend.getTime(),
									end: tnextend.getTime()		
								},
								limit: Infinity,
								lg: lgObj.lg, 
								section: lgObj.section
							});
						}
						// show later elements?
						if (Self.limit_count > 0 || Self.linit_count === -2) {
	    					var tnextyear = new Date();
	    					tnextyear.setUTCHours(0);
	    					tnextyear.setUTCMinutes(0);
	    					tnextyear.setUTCSeconds(0);
	    					tnextyear.setUTCMilliseconds(0);
	    					tnextyear.setUTCFullYear(tnextyear.getUTCFullYear()+1);
	    					tnextyear.setUTCDate(tnextyear.getUTCDate()+1);
	    					var lgObj = Self.createLg("Later");	
	    					aRanges.push({
	    						name: "Later", /*i18n*/
	    					    range: {
	    							start: tnextend.getTime(),
	    							end: tnextyear.getTime(),
	    							limit: Self.limit_count
	    						},
	    						lg: lgObj.lg,
	    						section: lgObj.section	
	    					});
						}
					}
					break;				
			case "mail": 
					var lgObj = Self.createLg("Inbox" /*i18n*/);				
					aRanges = [{name:"Inbox" /*i18n*/, range:{folder:"INBOX"}, limit:Self.limit_count,lg:lgObj.lg,section:lgObj.section}];			
					break;			
			case "infostore": 
					var lgObjMy = Self.createLg("My Infostore");						
					var lgObjAll = Self.createLg("All folders");							
					aRanges = [{name:"My Infostore", /*i18n*/
					    range:{folder:configGetKey("folder.infostore")},limit:Self.limit_count,lg:lgObjMy.lg,section:lgObjMy.section},
													{name:"All folders", /*i18n*/
													    range:{},limit:Self.limit_count,lg:lgObjAll.lg,section:lgObjAll.section}];
					break;
			case "contacts":
			        var obj = Self.createLg(null);
			        aRanges = [ { 
			            name: "Contacts",
			            range: { 
			                folder: configGetKey("folder.contacts")
			            },
			            lg: obj.lg, 
                        section: obj.section
			        }];
			        break;
		}
		
		applyEmptyHeader(sModule);
		
		return aRanges;
	}
	
	function applyEmptyHeader(sModule) {
	    Self.portletEmptyMSG =  newnode("div",
                { display: "none", position: "absolute", textAlign: "center",
                 width: "100%", marginTop: "5px"}, { className:"font-color-disabled" },
                [ addTranslated(getEmptyText(sModule)) ]);
	    Self.container.appendChild(Self.portletEmptyMSG);
	}
	
	function doNothing(arg) {
		return document.createTextNode(arg || "");
	}
	
	function setUser(arg,DOMtd) {
		var aIds = new Array();
		var TT = DOMtd;
		aIds.push(arg);
		function fillTds(result){
		    jQuery(TT).text(result[arg].display_name); 
		}
		internalCache.getUsers(aIds,fillTds);
		return document.createTextNode("");
	}
	
	function setDate(arg) {
		var dateString = "";
		if (null != arg) dateString = formatDate(arg, "date");
		return document.createTextNode(dateString);
	}
	
	function setDateTime(arg) {
		var dateString = "";
		if (null != arg) dateString = formatDate(arg, "date")  + " " + formatDate(arg, "time");
		return document.createTextNode(dateString);
	}
	
	function setTime(arg) {
		var timeString = '';
		if (null != arg) timeString = formatDate(arg, "time");
		return document.createTextNode(timeString);
	}
	
	function setPriority(arg,td) {
		var DOMImg;
		if (arg == 3) 
		{
			DOMImg = newnode('img',0,{ src: getFullImgSrc("img/tasks/taskprio3.gif") });
		}
		else if (arg == 1) 
			DOMImg = newnode('img',0,{ src: getFullImgSrc("img/tasks/taskprio1.gif") });
		else 
			DOMImg = newnode('img',0,{ src: getFullImgSrc("img/tasks/taskprio2.gif") });
		return DOMImg;
	}
	
	function setGroupIcon(arg,td) {
	    return (jQuery("<img>").css({ verticalAlign: "middle" }).attr({ width: 16, height: 16, src: 
	        getFullImgSrc((isGroupAppointment(arg) ? "img/calendar/group.gif" : "img/dummy.gif"))}))[0];
	}
	
	function setMailAdress(arg) {
	    var text = arg ? getAdressString(arg, true) : "";
		return document.createTextNode(text.replace(/(^"|"$)/g, ""));
	}
	
	function getArrayWidth(sModuleParam) {
		var aWidth = new Array();
		switch (sModuleParam){
			case "calendar": aWidth = {201:"7em",401:"6em",200:""};break;
			case "tasks": aWidth ={200:"",202:"7em",220:"2.3em",309:"4em"};break;
			case "mail": aWidth = {603:"",607:"",610:"12em"};break;
			case "infostore": aWidth = {700:"",3:"",5:"8em"};break;
			default: oFunctions = new Object();
		}
		return aWidth;
	}
	
	function getStyle(sModuleParam) {
		var aWidth = new Array();
		switch (sModuleParam){
			case "calendar": aWidth = {201:{color:"gray"},401:{color:"gray"},200:{}};break;
			case "tasks": aWidth ={200:{},201:{},202:{color:"gray"},220:{}, 309:{}};break;
			case "mail": aWidth = {603:{},607:{color:"gray"},610:{color:"gray"}};break;
			case "infostore": aWidth = {700:{},3:{color:"gray"},5:{color:"gray"}};break;
			default: oFunctions = new Object();
		}
		return aWidth;
	}
	
	function initColFunctions(sModuleParam) {
		var oFunctions;
		switch (sModuleParam){
			case "calendar": oFunctions = {201:setDate,401:setTime,200:doNothing};break;
			case "tasks": oFunctions = {201:setDate,200:doNothing,202:setDate,220:setGroupIcon,309:setPriority};break;
			case "mail": oFunctions = {603:setMailAdress,607:doNothing,610:setDateTime};break;	
			case "infostore": oFunctions ={700:doNothing,3:setUser,5:setDate};break;
			default: oFunctions = new Object();
		}
		return oFunctions;
	}
	
	function initColHeads(sModuleParam) {
		var oHeads;
		switch (sModuleParam){
            case "calendar":
                oHeads = { 201: _("Start date"), 401: _("Start time"),
                           200: _("Description") };
                break;
            case "tasks":
                oHeads = { 201: _("Start date"), 200: _("Subject"),
                           202: _("End date"), 220: _("Group Task"),
                           309: _("Priority") };
                break;
            case "contacts":
                oHeads = { 500: _("Display name") };
                break;
            case "mail":
			    oHeads = { 603: pgettext("who", "From"), 607: _("Subject"),
                           610: _("Received") };
                break;
			case "infostore":
			    oHeads = { 700: pgettext("description", "Title"),
			               3: _("Changed by"), 5: _("Changed on") };
			    break;
			default: oHeads = new Object();
		}
		return oHeads;
	}
	
	function initSortParam(sModuleParam) {
		var nSortColumn;
		switch (sModuleParam) {
			case "calendar": nSortColumn = '201';break;
			case "tasks": nSortColumn = '202';break;
			case "mail": nSortColumn = "610";break;	
			//4 = creation date
			case "infostore": nSortColumn = "5";break;
			default: nSortColumn = null;
		}
		return nSortColumn;
	}
	
	function initOrderParam(sModuleParam) {
		var sSortOrder = 'asc';
		if (sModuleParam == 'infostore' || sModuleParam == 'mail') {
			sSortOrder = 'desc';
		}
		return sSortOrder;
	}
	
	function initColumns(sModuleParam) {
		var sColumns;
		switch (sModuleParam) {
			case "calendar": sColumns = "1,20,201,401,200,207"; break;
			case "tasks": sColumns = "1,20,202,220,309,200,301"; break;
			case "mail": sColumns = "600,601,603,607,610,611"; break;
			case "infostore": sColumns = "1,20,700,3,5"; break;
			case "contacts": sColumns = "1,20,602,500"; break;
			default: sColumns = "";
		}
		return sColumns;
	}	
}

PortalItem.prototype = {
	setColumns: function(sColumns) {
		this.columns = sColumns;
	},
	
	setError: function (oRespData) {
		this.error = oRespData;
	},
	
	// set data
	setData: function (oData, index, nTimestamp, limit) {
	    // mail?
	    if (this.module === "mail") {
	        var sortByFlag = function (a, b) {
	            var aSeen = a[5] & 32, bSeen = b[5] & 32;
	            return aSeen !== bSeen ? aSeen - bSeen : b[4] - a[4];
	        };
	        oData.sort(sortByFlag);
	    }
	    
	    // truncate
	    if (limit != undefined) {
	        oData = oData.slice(0, limit);
	    }
	    // set
		this.data = oData;
		this.timestamp = nTimestamp;
		this.ranges[index]["data"] = oData;
		this.ranges[index]["timestamp"] = nTimestamp;
	},
	
	update: function () {
		if (this.error) {
			newServerError(this.error);
			return;
		}

		var bContentPresent = false;
		for (var dataIndx in this.ranges) {
		    if (this.ranges[dataIndx] == undefined) continue;

			if (this.ranges[dataIndx].data.length > 0) {
				bContentPresent = true;
			}
			if (this.ranges[dataIndx]["lg"] == undefined) {
				this.createLg(this.ranges[dataIndx]);
			} else {
				this.update_grid(this.ranges[dataIndx]);
			}
		}
		
		if (this.portletEmptyMSG) {
			// show/hide "empty" message
		    this.portletEmptyMSG.style.display = bContentPresent ? "none" : "block";
		    // contacts need fixed height
			if (this.module === "contacts") {
			    jQuery(this.container).css({
			        height: bContentPresent ? "315px" : "",
			        overflow: "auto",
			        overflowX: "hidden",
			        overflowY: "auto",
			        margin: "5px 7px 0 0"
			    });
			}
		}
	},
	
	disable : function () {
		for (var dataIndx in this.ranges) {
			if (this.ranges[dataIndx]["lg"]) {
				this.ranges[dataIndx]["lg"].disable();
			}
		}
	},
	
	getRequests : function () {
		//reset old data
		this.data = new Array();
		var aAllRequests = new Array();
		for (var nRange=0; nRange < this.ranges.length; nRange++) {
			//create request objects
			var oRequestObj = new Object();
			var oRequestBody = new Object();
			oRequestBody['pattern'] = "";
			oRequestObj['module'] = this.module;
			if (this.module == 'mail' || this.module == 'contacts') {
				oRequestObj['action'] = 'all'; // instead of newmsgs
				oRequestObj['folder'] = this.ranges[nRange].folder;
                if (this.module == "mail") {
                    oRequestObj["left_hand_limit"] = 0;
                    oRequestObj["right_hand_limit"] = 100; // do not fetch all
                }
				oRequestBody = null;
			} else if(this.module == 'calendar') {
				oRequestObj['action'] = 'newappointments';
			} else {
				oRequestObj['action'] = 'search';
			}
			oRequestObj['columns'] = this.columns;
			if (this.sort != null) {
    			oRequestObj['sort'] = this.sort;
    			oRequestObj['order'] = this.order;
			}

			//limit required
			if (this.ranges[nRange].limit) {
			    oRequestObj['limit'] = this.ranges[nRange].limit == Infinity ? 9999 : this.ranges[nRange].limit;
			}
			
			if (this.module == 'calendar' || this.module == 'tasks') {
				var oDate = new Date();
				oDate.setUTCHours(0);
				oDate.setUTCMinutes(0);
				oDate.setUTCSeconds(0);
				oRequestObj['start'] = oDate.getTime();
				oDate.setUTCFullYear(oDate.getUTCFullYear()+1);
				oDate.setUTCDate(oDate.getUTCDate() + 1);
				oRequestObj['end'] = oDate.getTime();
			}
			for(var nProp in this.ranges[nRange].range){
				oRequestObj[nProp] = this.ranges[nRange].range[nProp];
			}
			if (oRequestBody) {
			    oRequestObj['data'] = oRequestBody;
			}
			aAllRequests.push(oRequestObj);
		}
		return aAllRequests;
	},
	
	getLgColDef: function (nColumnNum,index) {
		var fn = this.column_functions[nColumnNum];
		var resObj = new Object();
		if (nColumnNum == 401) {
			resObj =  {
				text: this.column_heads[nColumnNum],
				width: this.col_width[nColumnNum],
				style: this.style[nColumnNum],
				set: function  (div, text){
					removeChildNodes(div);
					div.appendChild((text[3]) ? document.createTextNode("") : fn(text[2],div));
				},
				clear: LiveGrid.makeClear("")
			};
		} else if (nColumnNum == 200 && this.module == "tasks") {
			resObj =  {		
				text: this.column_heads[nColumnNum],
				width: this.col_width[nColumnNum],
				style: this.style[nColumnNum],
				set: function  (div, content) {
					if (!div.firstChild) {
						div.appendChild(document.createTextNode("\u00a0"));
					}
					if (content[5]) {
						div.firstChild.data = content[5];
						if (content[6] && content[6] == 100) {
							div.className = "cell font-color-disabled";
							div.style.textDecoration = "line-through";
						} else if (content[2] && getDays(new Date()-new Date(content[2])) > 0) {
							div.style.textDecoration = "line-through";
							div.style.color = "red";
						} else {
							div.className = "cell";
							div.style.textDecoration = "none";
						}
					} else {
						div.firstChild.data = "\u00a0";
					}
				},
				clear: LiveGrid.makeClear("")
			};
		} else if (this.module === "mail") {
		    resObj =  {
                index: index,   
                text: this.column_heads[nColumnNum],
                style: this.style[nColumnNum],      
                width: this.col_width[nColumnNum],
                set: function  (div, text, data) {
		            var node = jQuery(div), flags = data[5];
		            // unread?
                    if ((flags & 32) !== 32) {
                        node.css({ fontWeight: "bold", color: "black" });
                    } else {
                        node.css({ fontWeight: "", color: index >= 3 ? "gray" : "" });
                    }
                    // deleted?
                    node.css({ textDecoration: (flags & 2) !== 2 ? "" : "line-through" });
                    // update
                    removeChildNodes(div);
                    div.appendChild(fn(text, div));
                },
                clear: LiveGrid.makeClear("")
            };
		} else if (this.module === "contacts") {
		    resObj = {
		        text: "\u00a0",
		        sortable: false,
		        height: "70px",
		        style: { height: "70px" },
    		    set: function (div, data) {
		            
		            // shortcut
		            var $ = jQuery,
		                node,
		                src,
		                address,
		                hasImage,
		                obj, css, img;
		            
		            // clear
		            div = $(div).removeClass("cell").empty();
		            
		            // container
		            node = $("<div/>").css({
		                position: "relative",
		                height: "64px",
		                lineHeight: "1.4em",
		                borderBottom: "1px solid #f5f5f5"
		            });
		            
		            // set image
		            hasImage = !!data[7];
		            src = hasImage ? data[7] : getFullImgSrc("img/contacts/dummypicture.gif");
		            css = {
		                position: "absolute",
                        top: "5px",
                        left: "5px",
                        height: "50px",
                        width: "50px",
                        border: hasImage ? "0px none" : "1px solid #ddd",
                        opacity: hasImage ? 1.0 : 0.15,
                        overflow: "hidden"
		            };
		            if (IE <= 7) {
		                img = $("<img/>", { src: src, alt: "", width: "50px", height: "auto" });
		            } else {
		                $.extend(css, {
		                    background: "url('" + src + "') no-repeat scroll 50% 50% transparent",
                            MozBackgroundSize: "100% 100%",
                            WebkitBackgroundSize: "100% 100%",
                            backgroundPosition: "center center",
                            backgroundSize: "cover"
		                });
		                img = $();
		            }
                    $("<div/>")
                        .css(css)
                        .append(img)
                        .appendTo(node);
                    
		            // address
                    node.append(
    		            address = $("<div/>").css({
    		                position: "absolute",
    		                top: "4px",
    		                right: "5px",
    		                bottom: "5px",
    		                left: "65px",
    		                whiteSpace: "nowrap"
                        })
                    );
		            
		            // display name
                    obj = {
                        first_name: trimStr(data[8]),
                        last_name: trimStr(data[9]),
                        //title: trimStr(data[10]),
                        display_name: trimStr(data[3])
                    };
                    if (obj.last_name) {
                        obj.display_name = obj.last_name;
                        if (obj.first_name) {
                            obj.display_name += ", " + obj.first_name
                        }
                    }
	                address.append(
                        $("<div/>").css({
                            fontSize: "10pt",
                            fontWeight: "bold",
                            overflow: "hidden",
                            textOverflow: "ellipsis"
                        }).text(obj.display_name)
                    );
	                
		            // email
		            if (data[5]) {
		                address.append(
                            $("<div/>")
                                .addClass("font-color-person")
                                .css({
                                    overflow: "hidden",
                                    textOverflow: "ellipsis",
                                    cursor: "pointer"
                                })
                                // might be missing in custom themes
//                                .append(
//                                    $("<img/>").css({
//                                        marginRight: "5px"
//    		                        }).attr({
//                                        src: getFullImgSrc("icons/16/unread.png"),
//                                        align: "absmiddle"
//                                    })
//                                )
                                .append(
                                    newtext(data[5])
                                )
                                .hover(
                                    function () {
                                        $(this).css("textDecoration", "underline");
                                    },
                                    function () {
                                        $(this).css("textDecoration", "");
                                    }
                                )
                                .bind("click", false) // keep this! strange? yeah
                                .bind("mousedown", data[5], function (e) {
                                    setTimeout(function () {
                                        ox.api.mail.compose({
                                            data: {
                                                to: [[e.data]]
                                            }
                                        });
                                    }, 0);
                                    return false;
                                })
                        );
		            }
		            
		            // business phone
		            if (data[6]) {
		                address.append(
	                        $("<div/>")
	                            .css({
                                    overflow: "hidden",
                                    textOverflow: "ellipsis"
                                })
                                // might be missing in custom themes
//    	                        .append(
//                                    $("<img/>").css({
//                                        marginRight: "5px"
//                                    }).attr({
//                                        src: getFullImgSrc("img/menu/call.png"),
//                                        align: "absmiddle"
//                                    })
//    	                        )
    	                        .append(
                                    newtext(data[6])
                                )
                        );
		            }
		            
		            node.appendTo(div);
		        },
    		    clear: LiveGrid.makeClear("")
		    };
		} else {
			resObj =  {
				index: index,	
				text: this.column_heads[nColumnNum],
				style: this.style[nColumnNum],		
				width: this.col_width[nColumnNum],
				set: function  (div, text, data) {
					removeChildNodes(div);
					div.appendChild(fn(text,div));	
				},
				clear: LiveGrid.makeClear("")
			};
		}
		
		if (resObj["width"] == '') {
			delete resObj["width"];
		}
		
		return resObj;
	},
	
	createLg: function (sHeadName) {
		var oDOMHead, oDOMBody;
		var oTableNewSection = newnode("table",{width:"100%",height:"100%",display:"none"},{ cellpadding:"0",cellspacing:"0"},
								[newnode("tbody",0,0
											,[newnode('tr',0,0,[oDOMHead = newnode('td')]),
														newnode('tr',0,0,[oDOMBody = newnode('td')])])]);
		
		//create live grid definition array
		var aColumnNums = this.columns.split(',');
		var aColDefs = new Array();
		for (var nColumn=0; nColumn < aColumnNums.length; nColumn++) {
			if (aColumnNums[nColumn].length > 0 && nColumn > 1 && 
			        this.column_heads[aColumnNums[nColumn]] != undefined) {
				aColDefs.push(this.getLgColDef(aColumnNums[nColumn], nColumn));
			}
		}
		var hover = { calendar: OXAppointmentHover, tasks: OXTaskHover,
		    contacts: OXContactHover, infostore: OXInfostoreHover,
		    mail: OXMailHover }[this.module];
		var hoverFunction = {
            calendar: function(object) {
                hover.actualHover = hv;
                sectionLG.storage.newIterate([object], emptyFunction, set);
                function set(i, data) {
                    hover.refillContent(object.id, object.folder,
                                        object.recurrence_position);
                }
            },
            mail: function(object, manual) {
                OXMailHover.accordion.setHover(hv);
                sectionLG.storage.newIterate([object], emptyFunction, set);
                function set(i, data) {
                    hover.refillContent(object.id, object.folder);
                }
            }
        }[this.module] || function(object) {
            hover.actualHover = hv;
            sectionLG.storage.newIterate([object], emptyFunction, set);
            function set(i, data) {
                hover.refillContent(object.id, object.folder);
            }
        };
		aColDefs.push({
		    text: "\xa0",
		    width: "20px",
		    style: { padding: 0, verticalAlign: "top" },
		    clear: function(div) {
		        if (div.firstChild) {
		            div.firstChild.style.visibility = "hidden";
		        }
		    },
		    set: function(div, data) {
		        div.oxHoverID = sectionLG.storage.makeID(data);
		        if (div.firstChild) {
		            div.firstChild.style.visibility = "visible";
		        } else {
		            var button = jQuery.button({
		                title: noI18n(IE ? "\xa0\xa0\xa0\xa0" : "\xa0\xa0"),
		                click: function(e) {
		                    e.stopPropagation();
		                    e.preventDefault();
		                    pulldown.manualShow();
		                }
		            }).mousedown(function(e) {
		                e.stopPropagation();
	                }).addClass("context-button hover-only").appendTo(div)[0];
                    var pulldown = new PulldownPopup(button,
                        hover.getContent().node, true);
                    var oldHide;
                    pulldown.onShow = function() {
                        oldHide = hover.hide;
                        hover.hide = function() { pulldown.hide(); };
                        hoverFunction(div.oxHoverID);
                    };
                    pulldown.onHide = function() { hover.hide = oldHide; };
		        }
		    }
		});
		
		var selection =new Selection();
		var sectionLG = new LiveGrid(aColDefs, selection);
		sectionLG.autoWidth = false;
		sectionLG.key_cb = emptyFunction;
		sectionLG.keydown_cb = emptyFunction;
		sectionLG.keypress_cb = emptyFunction;
		sectionLG.mousedown_cb = function (e) {
		    if (e.button == LeftButton) {
		        sectionLG.mousedown(e);
		    }
		};
		sectionLG.selected_cb = function(count, e) {
		    sectionLG.events.trigger("Selected", count, e);
		};
		
		//no style update to disable visible selection
		sectionLG.updateStyles = function () {};
		sectionLG.insertRow = function(index) {
			var row = this.rows[index] = this.rowcache.length ? this.rowcache.pop() : this.createRow();
			row.tr.className = "tr context-button-hover-parent";
			row.tr.style.display = "";
			row.tr.style.top = (index * this.rowHeight) + "px";
			row.tr.oxRowIndex = index;
			this.unfetched[index] = true;
		};
		
		var Self = this;
		sectionLG.events.register("Selected",
		        function (ids, e) {
    				if (sectionLG.selection.getSelected()[0]) {
    					var object = sectionLG.selection.getSelected()[0];
    					//TMP MUST BE REMOVED WHEN OBJECTCACHE IS USED
    					if (Self.module) {
    					    object["module"] = Self.module;
    					}
    					object.folder_id = object.folder;
    					triggerEvent('OX_Portal_Click_Item', Self.module, object);
    				}
		});
		sectionLG.emptylivegridtext = "";
		
		if (sHeadName) {
    		if (!this.newportal) {
    			this.header.appendChild(sectionLG.getHeader());
    		} else {
    			sectionLG.getHeader();
    			var newportalHeader = newnode('div',{borderBottom:"1px solid",paddingLeft:"2px",textAlign:"left",
    							height:"1.6em",width:"100%",overflow:"hidden",whiteSpace:"nowrap"},{className:"font-style-lable border-color-design"});
    			newportalHeader.appendChild(addTranslated(_(sHeadName)));
    			oDOMHead.appendChild(newportalHeader);
    		}
		} else {
		    sectionLG.getHeader();
		    // clean header node if no name given
		    jQuery(oDOMHead).parent().empty();
		}
		
		if (this.module == "contacts") {
		    sectionLG.getTable(this.container);
		} else {
    		this.container.appendChild(oTableNewSection);
    		sectionLG.getTable(oDOMBody);
		}
		sectionLG.heightDiv.style.cursor = "pointer";
		sectionTB = oTableNewSection;
		
        var hv = sectionLG.addHover(hover.getContent().node, hoverFunction);
        hv.setSize(hover.contentobject.node);
 		return { lg: sectionLG, section: sectionTB };
	},
	
	update_grid: function (aData) {
	    var serialize = this.module === "calendar" ? function(x) {
	        return x.folder + "." + x.id + "." + x.recurrence_position;
        } : function(x) {
            return x.folder + "." + x.id;
        };
        var makeID = this.module === "calendar" ? function(x) {
            return { id: x[0], folder: x[1], recurrence_position: x[5] };
        } : function(x) {
            return { id: x[0], folder: x[1] };
        };
        var url = null, data = [];
        if (this.module === "contacts") {
            url = AjaxRoot + "/contacts?action=list&columns=1,20,602,500,569,555,542,606,501,502,505&session=" + session;
            jQuery.each(aData.data, function(i, x) {
                // null/false is okay
                if (x[2] === null || x[2] === false) {
                    data.push({ id: x[0], folder:  x[1] });
                }
            });
        }
        
	    var storage = new Storage(0, data, url, null, null, serialize, makeID);
	    // only non-contact modules 
	    if (this.module !== "contacts") {
            storage.append(aData.data);
	    }
	    
		aData['section'].style.display = "";
		if (aData.data.length == 0) {
			aData['section'].style.display = "none";
		}
		aData['lg'].disablehover = !configGetKey("gui.effects.hover.portal");
		aData['lg'].enable(storage);
	}
};

function getEmptyText(sModule) {
	var sModuleName;
	switch (sModule){
		case 'calendar' : sModuleName = _("No appointments today"); break;
		case 'mail' : sModuleName = _("No new E-Mails in this folder"); break;
		case 'tasks' : sModuleName = _("No tasks today"); break;
		case 'infostore' : sModuleName = _("No Info Items in this folder"); break;
		case 'contacts' : sModuleName = _("No contacts in this folder"); break;
		default: sModuleName = noI18n("");
	}
	return sModuleName;
}

function getNameModule(sModule) {
	var sModuleName;
	switch (sModule){
		case 'calendar' : sModuleName = _("Calendar"); break;
		case 'mail' : sModuleName = _("E-Mail"); break;
		case 'tasks' : sModuleName = _("Tasks"); break;
		case 'infostore' : sModuleName = _("InfoStore"); break;
		case 'contacts': sModuleName = _("Contacts"); break;
		default: sModuleName = noI18n("&#xa0;");
	}
	return sModuleName;
}

fileloaded();
