/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

registerView("configuration/folder",
        function() { 
            showNode("folder_props");  
            jQuery("#folder_props").show();
            jQuery("#folder_tree").show();
        },
        function() {    
          register("OX_SAVE_OBJECT",cf_saveConfiguration);
          register("OX_Cancel_Object",cf_cancelConfiguration);      
          register("OX_Configuration_Delete_Folder",deleteFolderConfig);            
          
        },
        function() {
            unLoadFolderProps();
             unregister("OX_SAVE_OBJECT",cf_saveConfiguration);
            unregister("OX_Cancel_Object",cf_cancelConfiguration);
             unregister("OX_Configuration_Delete_Folder",deleteFolderConfig);            
            
        },
        function() { 
            hideNode("folder_props");  
            jQuery("#folder_props").hide(); 
            
            // hack to disable origin folder tree if we stay at the config
            if (currentpath2.join("/").match(/^configuration/)) {
                jQuery("#config_folder_tree").show();
                jQuery("#configComplete").show();
                jQuery("#folder_tree").hide();
            }
        },
        function() { }
    );

registerView("configuration/folder/overview",
        function() {
            $("tab_props1").style.display="block";
            $("panel_props1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";

            // toolbar
            if (!configToolbars.folderOverview) {
                configToolbars.folderOverview =
                    temporary.configuration.newToolbar(
                        _("Folder"), [
                            {
                                title: _("Save"),
                                id: "save",
                                buttons: [{
                                    title: _("Save"),
                                    id: "save",
                                    icons: ["img/menu/btn_save.gif"],
                                    big: true,
                                    event: "OX_SAVE_OBJECT"
                                }]
                            },
                            {
                                title: _("Folder"),
                                id: "folder",
                                buttons: [{
                                    title: _("Move"),
                                    id: "move",
                                    icons: ["img/menu/move_folder.gif",
                                            "img/menu/userrights_d.gif"],
                                    event: "OX_Configuration_Move_Folder"
                                }, {
                                    title: _("Delete"),
                                    id: "delete",
                                    icons: ["img/menu/delete_folder.gif",
                                            "img/menu/delete_folder_d.gif"],
                                    event: "OX_Configuration_Delete_Folder"
                                }]
                            }
                        ], "folder");
            }
            temporary.configuration.showToolbar(configToolbars.folderOverview);
        },
        function() { },
        null,
        function() {
            $("tab_props1").style.isplay="none";
            $("panel_props1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";
        },
        function() { }
    );

function cf_saveConfiguration() {
    triggerEvent("OX_Save_Configuration",false,false,null,null);
}

var oPermissionsLiveGrid = null;
var permStorage;

registerView(
    "configuration/folder/rights",
    function () {
        
        $("tab_props2").style.display="block";
        $("panel_props2").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";
        
        listUserMappingArray = [];

        temporary.configuration.showToolbar(configToolbars.folderPermissions);
        
        //Create Live Grid Here
        if (oPermissionsLiveGrid == null) {
            oPermissionsLiveGrid = new LiveGrid([ {
                index: 1,            
                text: "",
                i18n: true,
                width: "16px",
                style: {padding: 0},
                //using in infostore defined functions here
                set: function  (div, text) {
                    var sImgStr = (text.groupflag)?getFullImgSrc("img/calendar/group.gif"):getFullImgSrc("img/calendar/user.gif");
                    var sAlt = (text.groupflag)?"Group":"User";
                    if(div.firstChild.src)
                        div.firstChild.src = sImgStr;
                    else{
                        removeChildNodes(div);
                        div.appendChild(newnode("img", 0, {src:sImgStr, alt: sAlt}));
                    }
                },                
                clear: LiveGrid.makeClear("...")
            }, {
                index: 1,            
                text: "User", /*i18n*/
                i18n: true,
                //using in infostore defined functions here
                set: function  (div, text) {
                    jQuery(div).empty().text("...");
                    getDisplayName(text.groupflag, parseInt(text.id), div);
                },                
                clear: LiveGrid.makeClear("...")
            }, {
                index: 2,                
                text: "Folder admin", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                    removeChildNodes(div);
                    var sDisplayString =  (text == 1)?_("Yes"):_("No");            
                    div.appendChild(document.createTextNode(sDisplayString));        
                },            
                clear: LiveGrid.makeClear("...")
            }, {
                index: 3,    
                text: "Admin", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                    removeChildNodes(div);
                    var sDisplayString = expectI18n(text);
                    div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")
            }, {
                index: 4,    
                text: "Read objects", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                removeChildNodes(div);
                var sDisplayString = expectI18n(text);
                div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")
            }, {
                index: 5,                    
                text: "Modify objects", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                removeChildNodes(div);
                var sDisplayString = expectI18n(text);
                div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")
            }, {
                index: 6,                    
                text: "Delete objects", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                removeChildNodes(div);
                var sDisplayString = expectI18n(text);
                div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")                
            }], new Selection());
            
            oPermissionsLiveGrid.emptylivegridtext = "";
            oPermissionsLiveGrid.events.register("Selected", fireSelected);
            $("userRightsHeadContainer").appendChild(oPermissionsLiveGrid.getHeader());
            oPermissionsLiveGrid.getTable($("userRightsTableContainer"));
        }
        permGridEnable();
        fireSelected(0);
        var haveadminrights, lastconfigfolder, privatefolder, lastEntity;
        function fireSelected(count) {
            editEntity = count != 1 ? '' :
                oPermissionsLiveGrid.selection.getSelected()[0];
            if (haveadminrights === undefined || lastconfigfolder != configfolder) {
                ox.api.folder.get({
                    folder: configfolder,
                    success: function (oFolder) {
                        haveadminrights = configparentfolder === -1 && 
                            ox.api.folder.can("changepermissions", oFolder); // admin flag
                        privatefolder = configfolder === 1 || oFolder.type === 1; 
                        handleSelection(count);
                    }
                });
                lastconfigfolder = configfolder;
            } else {
                handleSelection(count);
            }
        }
        function handleSelection (count) {
            var enabled = Boolean(count == 1 && haveadminrights);
            var bits = enabled ? aGlobalPermissions[editEntity].bitmask : 0;
            
            // get sections
            var main = ox.widgets.toolBar.tabs.permissionsMain.getChildren();
            // update section "main"
            updateSection(main[0], haveadminrights, (bits >> 28) & 1, []); // folder admin
            
            ox.api.folder.exists({
                folder: "6",
                success: function (GAL) {
                    // update "add button". Right now it doesn't make sense to allow it if GAL isn't enabled
                    ox.widgets.toolBar.menuItems["permissions-save-add"].setEnabled(GAL);
                    // update "remove button"
                    ox.widgets.toolBar.menuItems["permissions-save-remove"].setEnabled(count > 0 && enabled);
                }
            });
            
            var folders = ox.widgets.toolBar.tabs.permissionsForFolders.getChildren();
            var objects = ox.widgets.toolBar.tabs.permissionsForObjects.getChildren();
            // update section "admin"
            updateSection(folders[0], enabled && !privatefolder, (bits >> 28) & 1, [1, 0]); // folder admin
            // update section "folder permissions"
            updateSection(folders[1], enabled, bits, [0, 1, 2, 4, 64]); // admin
            // update section "read permissions"
            updateSection(objects[0], enabled, bits >> 7, [0, 1, 2, 64]); // read
            // update section "modify permissions"
            updateSection(objects[1], enabled, bits >> 14, [0, 1, 2, 64]); // write
            // update section "delete permissions"
            updateSection(objects[2], enabled, bits >> 21, [0, 1, 2, 64]); // delete
            // validate
            configToolbars.folderPermissions.validate();
            // show default tab
            if (editEntity !== lastEntity) {
                configToolbars.folderPermissions.setPosition(2);
                lastEntity = editEntity;
            }
        }
        function updateSection (section, enabled, value, values) {
            value &= 127;
            var items = section.getChildren();
            for (var i = 0; i < items.length; i++) {
                items[i].setEnabled(enabled);
                items[i].setChecked(enabled && value == values[i]);
            }
        }
    },
    function() {
        //TODO set Private flag and admin flag      
    },
    function() {
        //TODO set Private flag and admin flag  
        triggerEvent('Selected',0);
    },
    function() {
        oPermissionsLiveGrid.disable();
        $("tab_props2").style.display="none";
        $("panel_props2").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";
    },
    function() { }
);

function permGridEnable() {
    if(permStorage != null) {
        oPermissionsLiveGrid.enable(permStorage);
        return;
    }
    var aData = new Array();
    for (var indx in  aViewObjects) {
        var aSubData = new Array();
        var oEachObj = aViewObjects[indx];
        aSubData.push(oEachObj.entity + '_' + ((oEachObj.groupflag)?1:0));
        aSubData.push({id:oEachObj.entity,groupflag:oEachObj.groupflag});        
        aSubData.push(oEachObj.admin);
        aSubData.push(oEachObj.fr);
        aSubData.push(oEachObj.rr);
        aSubData.push(oEachObj.wr);        
        aSubData.push(oEachObj.dr);                
        aData.push(aSubData);
    }
    updateGrid(aData);
}

function updateGrid(aData) {
    permStorage = new Storage(0, [],null,null,null,null, 
       function (x) {
            return x[0];
       });    
    permStorage.append(aData);    
    oPermissionsLiveGrid.enable(permStorage);    
}

function avoidSubmitOnEnter(event) {
    registerFolderChange('title');
    if(event && event.keyCode == 13)
    {
        return false;
    }
}

function cf_cancelConfiguration() {
    configuration_changed_fields["folder"] = false;
}

register("OX_Configuration_Switch_Folder_View", function(param) { menuswitchConfigurationFolderView(param); });

var fdpropsTabsList = new Array('tab_props1','tab_props2');
var fdpropsPanelsList = new Array('panel_props1','panel_props2', 'panel_props3');
var fdpropsEventList = new Array( ['OX_Configuration_Switch_Folder_View','overview'],
                                      ['OX_Configuration_Switch_Folder_View','rights']
                                );
var bNew ;
var bParticipantsLoaded = false;
var bTableCreated = false;
var bValuesInit = false;
var bValuesLoaded = false;
var editEntity = '';

/////////////////////////////////////////////
// search and add users    
var participantObjects;
var selectedParticipants = new Array();
var oPartDialog = null;

function openAddUserDiv(oFolder) {    
    var bDisableGroup = true;
    if(oFolder.module == "mail")
        bDisableGroup = -1;
    if (!oPartDialog) {
        oPartDialog = new ParticipantsSmall(null,addToSelectedUser,true,true,false,false,_("Select Users"), /*i18n*/
                    null,true,false,true);
    }
    oPartDialog.openAddParticipantsWindow();
}    

function participantObj(objFromServer) {
    this.id = objFromServer.id;
    this.display_name = objFromServer.display_name;
    this.type = objFromServer.type;
    this.email = objFromServer.email;
}

var aChangedAttributes = new Object();
function registerFolderChange(sAttribute) {
    aChangedAttributes[sAttribute] = true;
    configuration_changed_fields["folder"]=true;
}

function addToSelectedUser(arg) {
    commitAddUser(arg);
    registerFolderChange("user");
    // if possible, select the last user in the grid (US5761)
    if (oPermissionsLiveGrid) {
        // get number of users (-1)
        var usr_length = (oPermissionsLiveGrid.storage.ids.length || 1) - 1;
        // manually set focus (not sure if required)
        oPermissionsLiveGrid.focus = usr_length;
        // trigger click in grid
        oPermissionsLiveGrid.selection.click(usr_length);
    }
}

function commitAddUser(selectedParticipants) {
    var aPermissionArrayForeign = new Array();
    var aPermissionArraySelf = new Array();    
        
    for (var nIndex = 0;nIndex<selectedParticipants.length;nIndex++) {
        if(selectedParticipants[nIndex].type == 2) {
            var bGroupFlag = true;        
        } else {
            var bGroupFlag = false;
        }
        if (selectedParticipants[nIndex].id == configGetKey("identifier")) {
                    aPermissionArraySelf[0] = {group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                            Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                    
                                           entity:configGetKey("identifier")};
        } else {
            aPermissionArrayForeign.push({group:bGroupFlag,bits:Math.pow(2,0)+Math.pow(2,8)+
                            Math.pow(2,15) + Math.pow(2,22),
                                            entity:selectedParticipants[nIndex].id});
        }
    }
    var aPermissionArray = aPermissionArraySelf.concat(aPermissionArrayForeign);
    selectedParticipants = new Array();
    var aViewObjects = permissionsToViewObjects(aPermissionArray);
    var aData = new Array();
    for (var indx in  aViewObjects) {
        var aSubData = new Array();
        var oEachObj = aViewObjects[indx];
        aSubData.push(oEachObj.entity + '_' + ((oEachObj.groupflag)?1:0));
        aSubData.push({id:oEachObj.entity,groupflag:oEachObj.groupflag});
        aSubData.push(oEachObj.admin);
        aSubData.push(oEachObj.fr);
        aSubData.push(oEachObj.rr);
        aSubData.push(oEachObj.wr);
        aSubData.push(oEachObj.dr);
        aData.push(aSubData);
    }
    //avoid duplicated entries here
    var aFinalArr = new Array();
    for (var indxUser=0;indxUser<aData.length;indxUser++) {
        if(permStorage.data.data[aData[indxUser][0]] == undefined) {
            aFinalArr.push(aData[indxUser]);
        }
    }
    permStorage.append(aFinalArr);
    oPermissionsLiveGrid.enable(permStorage);

}

function removeFolderUser() {        
    registerFolderChange("user");
    var aIdToDel = oPermissionsLiveGrid.selection.getSelected();
    oPermissionsLiveGrid.deleteIDs(aIdToDel);
    //fixed bug #10380
    oPermissionsLiveGrid.selection.reset();
    oPermissionsLiveGrid.focus=undefined;
    oPermissionsLiveGrid.updateStyles();
    for (var indx=0;indx<aIdToDel.length;indx++) {
        delete aGlobalPermissions[aIdToDel[indx]];
    }
}

function unLoadFolderProps() {
    editEntity = '';
    unregister("OX_Configuration_Remove_User",removeFolderUser);
    unregister("OX_Configuration_Add_User",openAddUserDiv);
    $('inFolderName').value = '';
    configuration_changed_fields["folder"] = false;
    bParticipantsLoaded = false;
    aChangedAttributes = new Object();
    bTableCreated = false;
    bValuesInit = false;
    bValuesLoaded = false;
    bconfigFolderUserChanges = false;
    aGlobalPermissions = new Object();
    $("folder.properties.caldav.url").style.display = "none";
    $('checkBoxSubscr').checked = false;
    $('checkBoxSubscr').disabled = false;        
    $('checkBoxSubscrDiv').style.display = "none";
}
    
function getFolderNameTranslated(folderObject) {
    var ids = configGetKey("folder");
    var replacedname = folderObject.title;
    switch (String(folderObject.id)) {
        case String(ids.tasks):
            replacedname = _("Tasks"); /*i18n*/
            break;
        case String(ids.calendar):
            replacedname = _("Calendar"); /*i18n*/
            break;
        case String(ids.contacts):
            replacedname = _("Contacts"); /*i18n*/
            break;
    }
    return replacedname;
}

var aViewObjects;
function loadFolderProps(bPermPropagation,bDisableScrollTo) {
    register("OX_Configuration_Remove_User",removeFolderUser);
    register("OX_Configuration_Add_User",openAddUserDiv);
    permStorage = null;
    bNew = (configparentfolder != -1);
    if(!bParticipantsLoaded) {
        if(!bNew) {
            // get folder
            ox.api.folder.get({
                folder: configfolder,
                success: function (OXFolder) {
                    if (oPermissionsLiveGrid && oPermissionsLiveGrid.selection) {
                        oPermissionsLiveGrid.selection.reset(); // bugfix #9991
                        triggerEvent("SubSelected",[]);
                    }
                    var replacedname = getFolderNameTranslated(OXFolder);
                    setPropsHeadLine(replacedname, false);
                    var aPermissionArray = OXFolder.permissions;
                    var sModule = OXFolder.module;
                    var sIdParam = OXFolder.id;
                    var oOwnRights = OXFolder.own_rights;
                    if (!bValuesInit) {        
                        $('inFolderName').value = replacedname;
                    }
                    configuration_changed_fields["folder"] = false;
                    bValuesInit = true;    
                    loadTabs(sModule,oOwnRights,sIdParam);
                    aViewObjects = permissionsToViewObjects(aPermissionArray);
                    //check acls enabled here
                    if((sModule == "mail" || String(sIdParam).match(/^default(\d+)?/))     //check capabilities here
                                             && !(OXFolder.capabilities & Math.pow(2,0))) 
                     {
                        $("panel_props2").style.display = "none";
                     }
                     else
                     {
                         $("panel_props2").style.display = "block";
                     }
                    if(sModule == "mail"     //check capabilities here
                                             && ox.api.folder.can("subscribe", OXFolder)) 
                    {
                        $('checkBoxSubscrDiv').style.display = "";
                        $('checkBoxSubscr').checked = (OXFolder.subscribed);
                        if(OXFolder.id == "default.INBOX")
                        {
                            $('checkBoxSubscr').disabled = true;
                        }
                    }
                    if (sModule == "calendar" &&
                        configGetKey("modules.caldav.active"))
                    {
                        $('folder.properties.caldav.url').style.display = "";
                        var link = $('folder.properties.caldav.link');
                        link.href = link.firstChild.data =
                            configGetKey("modules.caldav.url")
                                .replace("[hostname]", location.host)
                                .replace("[folderId]", sIdParam);
                    } else {
                        $('folder.properties.caldav.url').style.display = "none";
                    }
                }
            });
        } else {
            if (oPermissionsLiveGrid && oPermissionsLiveGrid.selection) {
                    oPermissionsLiveGrid.selection.reset(); // bugfix #9991
                    triggerEvent("SubSelected",[]);
            }
            // get folder
            ox.api.folder.get({
                folder: configparentfolder,
                success: function (OXFolder) {
    
                    setPropsHeadLine(getFolderNameTranslated(OXFolder),true);                    
    
                    var sModule = OXFolder.module;
                    
                    if((sModule == "mail" || String(OXFolder.id).match(/^default(\d+)?/))     //check capabilities here
                                             && !(OXFolder.capabilities & Math.pow(2,0))) 
                     {
                        $("panel_props2").style.display = "none";
                     }                                        
                     else
                     {
                         $("panel_props2").style.display = "block";
                     }
                         
                    if(!bValuesInit)
                    {
                        $('inFolderName').value = '';
                        configuration_changed_fields["folder"] = false;
                    }
                    bValuesInit = true;        
                    
                    var aPermissionArray = getNewFolderPerms(OXFolder,bPermPropagation);    
                    
                    var aViewObjects = permissionsToViewObjects(aPermissionArray);                    
                    var oOwnRights = aPermissionArray[0];                        
                    loadTabs(sModule,oOwnRights);
                    if(sModule == "mail")
                    {
                        $('checkBoxSubscrDiv').style.display = "";
                        $('checkBoxSubscr').checked = true;
                        $('checkBoxSubscr').disabled = true;
                    }
                    $('folder.properties.caldav.url').style.display = "none";
                }
            });
        }
    }
    triggerEvent("OX_Config_Folder_Changed");
}

function getNewFolderPerms(OXFolder, bPermPropagation) {
    var aPermissionArray = new Array();                    
    //shared folder permissions
    if (OXFolder.type == 3 && OXFolder.created_by != null 
           && OXFolder.created_by != configGetKey("identifier")) {
        aPermissionArray[0] = {group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                                                                    
                               entity:OXFolder.created_by};                        
        aPermissionArray[1] = {group:false,bits:Math.pow(2,0)+Math.pow(2,8)+
            Math.pow(2,15) + Math.pow(2,22),
                            entity:configGetKey("identifier")};
    } else {
        aPermissionArray[0] = {group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                    
                               entity:configGetKey("identifier")};
    }
    if (bPermPropagation) {
        var aPermissionArray = new Array();
        switch(OXFolder.id) {
            case 1: case 2: case 10:                            
                aPermissionArray = aPermissionArray.concat(OXFolder.permissions);                            
                aPermissionArray.push({group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                    Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                    
                                   entity:configGetKey("identifier")});                                               
                break;
            default:
                aPermissionArray = OXFolder.permissions;
                break;
        }        
    }    
    return aPermissionArray;
}

function setPropsHeadLine(stitle, bNewFolderDia){
    removeChildNodes($("folder_prop_headline"));
    if(bNewFolderDia) {
        var oTextNodeDOM = new I18nNode(_("Folder Properties"));
        $("folder_prop_headline").appendChild(oTextNodeDOM.node);
    } else {
        //#. %s is the folder name.
        //#, c-format
        var oTextNodeDOM = new I18nNode(format(_("Folder Properties: %s"),
                                               stitle));
        $("folder_prop_headline").appendChild(oTextNodeDOM.node);
    }
}

function fn_ln2(val) {
    return Math.log(val)/Math.log(2);
}

function changeRights(sType,sRight) {
    registerFolderChange("user");
    var bits = 0;

    if(!aGlobalPermissions[editEntity])
        return;

    switch(sType) {
        case 'FOLDER':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 0);
                        aGlobalPermissions[editEntity]['obj'][0].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][0].string = ox.api.folder.derive("permissions", bits, 0).string;
                        break;
        case 'READ':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 7);
                        aGlobalPermissions[editEntity]['obj'][1].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][1].string = ox.api.folder.derive("permissions", bits, 7).string;    
                        break;
        case 'WRITE':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);                                                        
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 14);
                        aGlobalPermissions[editEntity]['obj'][2].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][2].string = ox.api.folder.derive("permissions", bits, 14).string;
                        break;
        case 'DELETE':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);                    
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 21);
                        aGlobalPermissions[editEntity]['obj'][3].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][3].string = ox.api.folder.derive("permissions", bits, 21).string;
                        break;
        case 'ADMIN':    bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14) +
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21) ;
                        bits += (sRight==0)?0:Math.pow(2,28);                    
                        aGlobalPermissions[editEntity]['obj'][4] = parseInt(sRight);                                    
                        break;
        default:        bits;                
    }
    aGlobalPermissions[editEntity]['bitmask'] = bits;
    var oPermissions = aGlobalPermissions[editEntity]['obj'];    
    var aaA = new Array();    
    aaA.push([editEntity,{id:editEntity.entity,groupflag:editEntity.groupflag},
                                oPermissions[4],
                                    oPermissions[0].string,oPermissions[1].string,
                                                            oPermissions[2].string,oPermissions[3].string]);
    function cb_loc_updt (){
        return function (indx,data)
        {
            data[2] = oPermissions[4];
            data[3] = oPermissions[0].string;
            data[4] = oPermissions[1].string;
            data[5] = oPermissions[2].string;                        
            data[6] = oPermissions[3].string;    
            return data;                                
        };
    }
    oPermissionsLiveGrid.storage.localUpdate([editEntity],cb_loc_updt());
    oPermissionsLiveGrid.events.trigger("Selected",
        oPermissionsLiveGrid.selection.count);
    return bits;
}

var aGlobalPermissions = new Object();
function permissionsToViewObjects(aPermissionArray) {    
    var aViewObjects = new Array();
    if (!aPermissionArray) {
        return aViewObjects;
    }
    for (nEntity=0;nEntity < aPermissionArray.length;nEntity++) {
        var aEntityPermissions = aPermissionArray[nEntity];        
        var nBits = aEntityPermissions.bits;

        aViewObjects[nEntity] = new Object();
        aViewObjects[nEntity]['entity'] = aEntityPermissions.entity;                
        aViewObjects[nEntity]['groupflag'] = aEntityPermissions.group;                        
        
        oPerm = new Array();
        
        oPerm[0] = ox.api.folder.derive("permissions", nBits, 0);
        oPerm[1] = ox.api.folder.derive("permissions", nBits, 7);
        oPerm[2] = ox.api.folder.derive("permissions", nBits, 14);
        oPerm[3] = ox.api.folder.derive("permissions", nBits, 21);
        oPerm[4] = (nBits & Math.pow(2,28))?1:0;    
        
        aViewObjects[nEntity]['fr'] = oPerm[0].string;
        aViewObjects[nEntity]['rr'] = oPerm[1].string;
        aViewObjects[nEntity]['wr'] = oPerm[2].string;                                
        aViewObjects[nEntity]['dr'] = oPerm[3].string;                                                
        aViewObjects[nEntity]['admin'] = oPerm[4];
        
        var sKey = aEntityPermissions.entity + '_' + ((aEntityPermissions.group)?1:0);
        aGlobalPermissions[sKey] = new Object();
        aGlobalPermissions[sKey]['obj'] = oPerm;
        aGlobalPermissions[sKey]['bitmask'] = nBits;
        aGlobalPermissions[sKey]['groupflag'] = aEntityPermissions.group;
    }
    return aViewObjects;
}

var userPermQueue = [];
var userPermTimer;
function getDisplayName(group, id, node) {
    userPermQueue.push({ type: group ? 2 : 1, id: id, node: node });
    if (userPermTimer) {
        return;
    }
    function final_cb(userPermQueue) {
        internalCache.getObjects(userPermQueue, function(data) {
            for (var i=0; i < userPermQueue.length; i++) {
                var obj = userPermQueue[i];
                jQuery(obj.node).text(data[obj.id].display_name || "..."); 
            }
        });
    }
    userPermTimer = setTimeout(function() {
        final_cb(userPermQueue);
        userPermQueue = [];
        userPermTimer = undefined;
    }, 300);
}

function saveFolder(fn_opt) {
    
    var oFolderNEW = getFolderFromForm();

    ox.api.folder.get({
        
        folder: configfolder,
        success: function (oFolder) {
        
	        function success(arg) {

	            var cont = function () {
	                
	                // the folder id must be reseted after mail folder update
	                if (oFolder.module === "mail" && arg && arg.id) {
	                    activefolder = arg.id;
	                    configfolder = activefolder;
	                } else {
	                    activefolder = configfolder;
	                }
	                triggerEvent("OX_New_Info", 4, _("Your settings have been saved"));

	                // workaround for foldertree updates after permission changes to display
	                // shared icons on folders
	                ox.api.cache.folder0.clear();
	                ox.api.cache.folder1.clear();
	                ox.api.cache.folderFlat.clear();
	                
	                ox.api.folder.dispatcher.trigger("modify");

	                ox.util.call(fn_opt);
	            };

	            // got invisible?
	            ox.api.folder.get({
	                folder: configfolder,
	                cache: false,
	                success: cont,
	                error: function () {
	                    // set parent folder
	                    ox.UIController.setFolder({ folder: oFolder.folder_id });
	                    // continue
	                    cont();
	                    // suppress global error
	                    return true;
	                }
	            });
	        }

	        function error() {
	            ox.util.call(fn_opt);
	        }
	        
	        //check Folder default
	        var oFolderdefault = configGetKey("folder");
	        var isDefaultfolder = false;
	        for (var itemF in oFolderdefault) {
	            if (changedFolderId == oFolderdefault[itemF]) {
	                isDefaultfolder = true;
	            }
	        }
	        if (isDefaultfolder || !aChangedAttributes["title"]) {
	            delete oFolderNEW["title"];
	        }
	        if (!aChangedAttributes["user"]) {
	            delete oFolderNEW["permissions"];
	        }
	        if (oFolder != undefined) {
	            ox.api.folder.update({
	                folder: configfolder,
	                data: oFolderNEW,
	                success: success,
	                error: error,
	                event: false
	            });
	        }
	    } 
    });     
}

function getFolderFromForm() {
    var sName = document.forms.folderMainProps.inFolderName.value;
    var bSubscribed = document.forms.folderMainProps.checkBoxSubscr.checked;    
    var sType = "";
    if(!comboboxProps) return;
    changedFolderId = configfolder;        
    var sIDOpt  = comboboxProps.getKey();
    sType = sIDOpt.split("_")[1];
    
    var nPerNum = 0;
    var aPermissionArray = new Array();    
    for (sEnt in aGlobalPermissions) {
        var oPermission = new Object();
        oPermission['bits'] = parseInt(aGlobalPermissions[sEnt].bitmask);
        oPermission['entity'] = sEnt.split("_")[0]; //UserId
        oPermission['rights'] = '';
        oPermission['group'] = (sEnt.split("_")[1] == "0")?false:true;
        aPermissionArray[nPerNum] = oPermission;
        nPerNum++;
    }
    var oFolder  = new Object();
    oFolder['title'] = sName;
    oFolder['module'] = sType;    
    oFolder['permissions'] = aPermissionArray;    
    oFolder['subscribed'] = (bSubscribed)?1:0;        
    return oFolder;
}    

function loadTabs(sModule,oOwnRights,sIdParam){
    setTabLists(fdpropsTabsList, fdpropsPanelsList,fdpropsEventList);    
    if(!bValuesLoaded)
        loadValues(sModule,oOwnRights);    
    bValuesLoaded = true;
}

var comboboxProps = null;
function loadValues(sModule,oOwnRights) {
    // get folder
    var id = (bNew) ? configparentfolder : configfolder;
    ox.api.folder.get({
        folder: id, 
        success: function (folder) {
            var sMod = folder.module;
            var sId = folder.id;    
            var selectedItem = 'm_'+sMod;
            var inputNameField = $('inFolderName');
            var bPermFolderBit = ox.api.folder.derive("permissions", folder, 0).bit;
            if(!ox.api.folder.can("rename", folder) && !bNew) {
                inputNameField.disabled = true;
                inputNameField.className = "background-color-default border-color-design";
            } else {                    
                inputNameField.disabled = false;
                inputNameField.className = "";
            }
            if(bNew && sId != 'default' && sMod != 'infostore' && sMod != 'mail') {        
                if(selectedItem == 'm_system')
                    selectedItem = 'm_calendar';
                comboboxProps = new ComboBox3(window, "SelTypeFolder", "190px", 0, true, "OX_Folder_ModuleComboChanged", null);
                if(configGetKey("modules.calendar.module"))
                    comboboxProps.addElement(_("Calendar"),"m_calendar");    
                if(configGetKey("modules.contacts.module"))    
                    comboboxProps.addElement(_("Contacts"),"m_contacts");                
                if(configGetKey("modules.tasks.module"))
                    comboboxProps.addElement(_("Tasks"),"m_tasks");
                comboboxProps.addElement(_("Messaging"),"m_messaging");
                comboboxProps.addElement(_("System"),"m_system");
                comboboxProps.getDomNode();    
            } else { 
                comboboxProps = new ComboBox3(window, "SelTypeFolder", "190px", 0, true, "OX_Folder_ModuleComboChanged", null);
                comboboxProps.addElement(_("Calendar"),"m_calendar");        
                comboboxProps.addElement(_("Contacts"),"m_contacts");        
                comboboxProps.addElement(_("Tasks"),"m_tasks");                
                comboboxProps.addElement(_("E-Mail"),"m_mail");                        
                comboboxProps.addElement(_("InfoStore"),"m_infostore");
                comboboxProps.addElement(_("Messaging"),"m_messaging");
                comboboxProps.addElement(_("System"),"m_system");
                comboboxProps.getDomNode();
                comboboxProps.disable();
                if (sId == 'default' || ox.api.folder.is("account", folder)) {
                    selectedItem = 'm_mail';
                }
            }
            comboboxProps.setKey(selectedItem);
            
            // disable menu items if required
            ox.widgets.toolBar.menuItems["folder-save-save"].setEnabled(
                ox.api.folder.can("rename", folder));
            ox.widgets.toolBar.menuItems["folder-folder-move"].setEnabled(
                ox.api.folder.can("delete", folder));
            ox.widgets.toolBar.menuItems["folder-folder-delete"].setEnabled(
                ox.api.folder.can("delete", folder));
        }
   });
}

fileloaded();    
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * 
 */

/**
 * Updates reminders.
 * Called by child windows when an item with reminder was created or modified.
 */
var updateReminders;
register("Ready", function () {
    // put it into ready so we can disable it
    // todo: we should consider to implemenet an update event we
    // can unregister instead of overwriting the global var
    if (jQuery.isFunction(updateReminders)) {
        updateReminders();
        register("OX_Refresh", updateReminders);
    }
});

register("OX_Configuration_Loaded_Complete", function() {

	var queue = new LinkedList();
	var reminders = {};
	var json = new JSONX();
	var timer, timerSet = false;
	var status = {cancel: false};

	var m = 6e4, h = 36e5, d = 864e5, w = 6048e5; // ms per min, h, day and week
    var intervals = [5*m, 10*m, 15*m, 45*m, 1*h, 2*h, 4*h, 6*h, 8*h,
                     1*d, 2*d, 3*d, 4*d, 5*d, 6*d, 1*w, 2*w, 3*w, 4*w];
    var combobox = new ComboBox3(window, "remindAlarm", "12em", 0, true, null, 4);
    for (var i = 0; i < intervals.length; i++) {
        combobox.addElement(getInterval(intervals[i]), intervals[i]);
    }
	combobox.getDomNode();
	
	var startDateNode = new I18nNode(function() {
        if (this.node && this.node.parentNode && this.node.parentNode.parentNode)
            this.node.parentNode.parentNode.style.display = this.value ? ""
                                                                       : "none";
        return this.value ? formatDate(this.value, this.format || "datetime") : "";
    });
    $("reminderStartsRow").replaceChild(startDateNode.node,
                                        $("reminderStartsRow").firstChild);
    var endDateNode = new I18nNode(function() {
    	if (this.node && this.node.parentNode && this.node.parentNode.parentNode)
            this.node.parentNode.parentNode.style.display = this.value ? ""
                                                                       : "none";
        return this.value ? formatDate(this.value, this.format || "datetime") : "";
    });
    $("reminderEndsRow").replaceChild(endDateNode.node,
                                      $("reminderEndsRow").firstChild);
	function update() {
		if (ox.api.config.get("modules.calendar.module", false) === false
                && ox.api.config.get("modules.tasks.module", false) === false) {
		    return;
		}
		json.get(AjaxRoot + "/reminder?action=range&session=" + session
			+ "&end=" + encodeURIComponent(now() + 12*60*60*1000), null,
			updatereply);
		function updatereply(reply) {
			var data = reply.data;
			var newR = [];
			for (var i = 0; i < data.length; i++) {
				var n = data[i];
				var o = reminders[n.id];
				newR.push(o && o.last_modified == n.last_modified ? o : n);
			}
			newR.sort(function(x, y) { return x.alarm - y.alarm; });
			queue = new LinkedList();
			reminders = {};
			for (var i = 0; i < newR.length; i++) {
				var reminder = newR[i];
				queue.addLast(reminder);
				reminders[reminder.id] = reminder;
			}
			schedule();
		}
	}
	updateReminders = update;
	function schedule() {
		if (timerSet) {
			clearTimeout(timer);
			timerSet = false;
		}
		var reminder = queue.first;
		if (reminder) {
			timer = setTimeout(display, Math.max(0, reminder.alarm - now()));
			timerSet = true;
		}
		function display() {
			timerSet = false;
			status.cancel = true;
			var mystatus = status = {cancel: false};
			var modules = {
				1: {name: "calendar", columns: "200,201,202,400,401",
				    icon: getFullImgSrc("img/calendar/btnnew_calendar.gif"),
				    title: "Appointment", /*i18n*/
                    //#. Appointment reminder
                    //#. %s is the time, formatted using the messages with context "in"
                    //#, c-format
                    text: "You have the following appointment in %s:", /*i18n*/
				    text2: "The following appointment already started:", /*i18n*/
				    until: 1},
				4: {name: "tasks", columns: "200,201,202",
				    icon: getFullImgSrc("img/tasks/btnnew_task.gif"),
				    title: "Task", /*i18n*/
                    //#. Task reminder
                    //#. %s is the time, formatted using the messages with context "in"
                    //#, c-format
				    text: "The following task is due in %s:", /*i18n*/
				    text2: "The following task is already past due:", /*i18n*/
				    until: 2},
				137: {name: "infostore", columns: "700",
				      icon: getFullImgSrc("img/infostore/infostore.gif"),
				      title: "InfoItem", /*i18n*/
				      text: "You wanted to be reminded about the following InfoItem:"} /*i18n*/
			};
			var module = modules[reminder.module];
			var id = {id: reminder.target_id, folder: reminder.folder};
			if (reminder.recurrence_position)
				id.pos = reminder.recurrence_position;
			json.put(AjaxRoot + "/" + module.name + "?action=list&session=" + session
				+ "&columns=" + module.columns,
				[id], null, listreply, listerror);
			function listerror(reply, status) {
				if (status && reply.code != "TSK-0017"
				           && reply.code != "APP-0001") return false;
				// Deleted in the meantime
				queue.removeFirst();
				schedule();
				return true;
			}
			function listreply(reply) {
				if(!reply.data.length) {
					queue.removeFirst();
					schedule();
					return;
				}
				if (mystatus.cancel) return;
				var data = reply.data[0];
				function set(node, text) {
					node.parentNode.style.display = text ? "" : "none";
					if (text) node.firstChild.data = text;
				}
				$("reminderTitleRow").firstChild.data = data[0] || "";
                startDateNode.value = data[1];
                startDateNode.format = data[4] === true ? "date" : "datetime";
                startDateNode.update();
                endDateNode.value = data[2];
                endDateNode.format = data[4] === true ? "date" : "datetime";
                endDateNode.update();
				set($("reminderLocationRow"), data[3]);
				
				var text = module.text;
				if (module.text2) {
					var interval = data[module.until] - now();
					if (interval < 0)
						text = _(module.text2);
					else
						text = format(_(module.text), getInterval(interval, true));
				}
				$('reminderNotificationText').firstChild.data = text;
				addDOMEvent($("reminderOK"), "click", ok);
				addDOMEvent($("reminderAgain"), "click", again);
				addOnClose($("reminderWindow"), ok);
				showNode("reminderWindow");
				
				with ($('reminderModule')) {
                    src = module.icon;
                    alt = title = _(module.title);
                }
				
				centerPopupWindow($("reminderWindow"));
				$("reminderWindow").style.display = "block";
				function hide() {
					hideNode("reminderWindow");
					$("reminderWindow").style.display = "none";
					removeDOMEvent($("reminderOK"), "click", ok);
					removeDOMEvent($("reminderAgain"), "click", again);
					removeOnClose($("reminderWindow"), ok);
				}
				function again() {
					hide();
					if (mystatus.cancel) return;
					// get interval
					var dt = combobox.getKey();
					// inform server
					var reminder = queue.first;
					// get timestamp from reply
					var timestamp = reply.timestamp;
					if (reminder) {
						// taks and appointments must be treated differently
						switch (reminder.module) {
						case 4:
							// set new alarm
							var alarm = Math.floor(now() / (60*1000)) * 60*1000 + dt;
							// update task
							var changes = { alarm: alarm, notification: false }; // do not notify!
							var request = [{
								action: "remindAgain", module: "reminder",
								data: changes, id: reminder.id
//								id: reminder.target_id, folder: reminder.folder, // target_id (not id!)
//								data: changes, timestamp: timestamp
							}];
							new JSONX().put(AjaxRoot + "/multiple?session=" + session, request, null, function(response) {
								// update cache
								var ids = [{id: reminder.target_id, folder: reminder.folder}];
								OXTaskMapping.editObjects(ids, changes);
							});
							break;
						case 1: // appointment (TODO)
							break;
						}
					}
					// adjust UI timer
					reminder.alarm = Math.floor(now() / (60*1000)) * 60*1000 + dt;
					queue.removeFirst();
					sort: {
						for (var i = queue.first; i; i = i.next) {
							if (i.alarm > reminder.alarm) {
								queue.insertBefore(reminder, i);
								break sort;
							}
						}
						queue.addLast(reminder);
					}
					schedule();
				}
				function ok() {
					hide();
					if (mystatus.cancel) return;
					var id = { id: reminder.id };
					if (reminder.recurrence_position) {
					    id.recurrence_position = reminder.recurrence_position;
					}
					json.put(AjaxRoot + "/reminder?action=delete&session=" + session
						+ "&timestamp=" + encodeURIComponent(reminder.last_modified),
                        id, null, deletereply);
					function deletereply(reply) {
						if (reply.data.length || queue.first !== reminder) // Just in case
							update();
						else {
							queue.removeFirst();
							schedule();
						}
					}
				}
			}
		}
	}
});
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */


function RightsHandling () {
	this.rightshandling_module;
	this.realmodule;
	this.cbyes;
	this.cbno;
	this.newfolder;
	this.object;
	
}
RightsHandling.prototype = {
	checkRights : function(module,folder,object,cbyes,cbno) {

		var Self=this;
		this.cbyes=cbyes;
		this.cbno=cbno;
		this.object=object;
		this.rightshandling_module=module;
		this.realmodule=module;
		if(this.realmodule=="distributionlist") {
			this.realmodule="contacts";
		}
		function checkcreateRight(data) {
			if(data.module != Self.realmodule) {
				Self.newfolder=configGetKey("folder."+Self.realmodule);
				Self.commityes();			
			} 
			else {
				var myrights = ox.api.folder.derive("permissions", data, 0).bit;
				if(myrights>=2) {
					Self.newfolder=data.id;
					Self.commityes();					
				} else {
					Self.newfolder=configGetKey("folder."+Self.realmodule);
					Self.openWindow();					
				}
			}	
		}
		if(!folder) {
			if(object && object.folder_id) {
				folder=object.folder_id;
			}
			else if(!activefolder) {
				folder=configGetKey("folder."+Self.realmodule);
			} else {
				folder=activefolder;
			}
		}
		ox.api.folder.get({
		    folder: folder,
		    success: checkcreateRight
		});
	},
	openWindow : function() {
	    ox.api.setModal(true);
//		showNode("modal-dialog");
//		$("modal-dialog").style.display="block";
		showNode("rightshandling_window");
		centerPopupWindow($("rightshandling_window"));
		$("rightshandling_window").style.display="block";
	},
	commityes : function() {
		if(!this.object) {
			this.object = {};
		} 
		this.object.folder_id=this.newfolder;
		if(!this.cbyes) {
			triggerEvent("OX_Create_Object",this.rightshandling_module,this.newfolder,this.object);
		} else {
			this.cbyes(this.rightshandling_module,this.newfolder,this.object);
		}
		this.closeWindow();
	},
	commitno : function() {
		this.closeWindow();
	},
	closeWindow : function() {
		rightshandling_module=null;
		hideNode("rightshandling_window");
		$("rightshandling_window").style.display="none";
		var childs=	$("modal-dialog").childNodes;
		var closeall=true;
		for(var i=0;i<childs.length;i++) {
			if(childs[i].tagName && childs[i].tagName == "DIV") {
				if(childs[i].style.display && childs[i].style.display != "none" ) {
					closeall=false;
				}
			}
		}
		if(closeall) {
		    ox.api.setModal(false);
//			hideNode("modal-dialog");
//			$("modal-dialog").style.display="none";
		}
	}
};
var rightshandler=new RightsHandling();
register("Loaded",function() {
	addOnClose($('rightshandling_window'),function () { rightshandler.commitno(); });
});
register("Loaded",function() {
	if($('acceptdeny_object')) {
		addOnClose($('acceptdeny_object'),function () { rightshandler.commitno(); });
	}
});
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

function AcceptDenyObject(module,object) {
    this.title=object.title;
    this.location=object.location;
    this.startdate;
    this.enddate;
    this.folder_id=object.folder_id;
    this.created_by=object.created_by;
    if (object.organizer) {
        this.organizer = object.organizer;
    }
    if (object.organizerId) {
        this.organizerId = object.organizerId;
    }
    this.objectid=object.id;
    this.module=module;
    this.confirmation=-1;
    this.com="";

    if(object.start_date) {
        this.startdate=new Date(object.start_date);
    }
    if(object.end_date) {
        this.enddate=new Date(object.end_date);
    }
    for(var i=0;i<object.users.length;i++) {
        if(object.users[i].id == configGetKey("identifier")) {
            this.confirmation=object.users[i].confirmation;
            this.com=object.users[i].confirmmessage;
        }
    }
}
function AcceptDeny(showdetail) {
    this.showdetail=showdetail;
    var Self=this;

    function mkHandler(type) {
        return function () {
            if (Self.showdetail) {
                var objects = [];
                AcceptDeny.storage.newIterate(AcceptDeny.grid.getSelectedIDs(),
                    emptyFunction, function(i, o) { objects.push(o); },
                function() {
                    acceptdeny_updateConfirm(objects, type,
                        $("acceptdeny_comment3").value, function() {
                            var grid = AcceptDeny.grid;
                            grid.deleteIDs(grid.getSelectedIDs());
                            $("acceptdeny_comment3").value=""; // bug #15388
                            if (!grid.storage.ids.length) {
                                Self.removeDomEvents();
                                AcceptDeny.hide();
                            }
                        });
                });
            } else {
                Self.removeDomEvents();
                acceptdeny_updateConfirm(Self.objects, type,
                    $("acceptdeny_comment2").value, AcceptDeny.hide);
            }
        };
    }
    this.acceptdeny_accept = mkHandler(1);
    this.acceptdeny_decline = mkHandler(2);
    this.acceptdeny_tentative = mkHandler(3);

    this.acceptdeny_later = function () {
        Self.acceptdeny_close();
        if (contimestamp && contimestamp > 0) {
            configSetKey("gui.global.confirmtimestamp",contimestamp);
        }
    };
    
    this.acceptdeny_close = function () {
        Self.removeDomEvents();
        AcceptDeny.hide();
    };
    this.addDomEvents = function () {
        this.removeDomEvents();
        addOnClose($("acceptdeny_object"),Self.acceptdeny_close);
        addDOMEvent($("acceptdeny_accept"), "click", Self.acceptdeny_accept);
        addDOMEvent($("acceptdeny_decline"), "click", Self.acceptdeny_decline);
        addDOMEvent($("acceptdeny_tentative"), "click", Self.acceptdeny_tentative);
        addDOMEvent($("acceptdeny_later"), "click", Self.acceptdeny_later);
    };
    this.removeDomEvents = function () {    
        removeOnClose($("acceptdeny_object"),Self.acceptdeny_close);
        removeDOMEvent($("acceptdeny_accept"), "click", Self.acceptdeny_accept);
        removeDOMEvent($("acceptdeny_decline"), "click", Self.acceptdeny_decline);
        removeDOMEvent($("acceptdeny_tentative"), "click", Self.acceptdeny_tentative);
        removeDOMEvent($("acceptdeny_later"), "click", Self.acceptdeny_later);    
    };
}
AcceptDeny.visible = false;
AcceptDeny.hide = function() {
    hideNode("acceptdeny_object");
    $("acceptdeny_object").style.display="none";
    //ox.api.setModal(false);
//    hideNode("modal-dialog");
//    $("modal-dialog").style.display="none";
//    $("modal-dialog").style.width = "100%";
//    $("modal-dialog").style.height = "100%";
    AcceptDeny.visible = false;
};
AcceptDeny.prototype = {
    changeConfirm : function(acceptdenyobjectarray) {
        AcceptDeny.visible = true;
        this.objects = acceptdenyobjectarray;
        $("acceptdeny_nodetail").style.display="";
        $("acceptdeny_list").style.display = "none";
        var comment = this.showdetail ? $("acceptdeny_comment2")
                                      : $("acceptdeny_comment3");
        comment.value="";
        if(acceptdenyobjectarray && acceptdenyobjectarray.length == 1 && acceptdenyobjectarray[0].com) {
            comment.value=acceptdenyobjectarray[0].com;
        }
        //ox.api.setModal(true);
//        showNode("modal-dialog");
//        $("modal-dialog").style.display="block";
        showNode("acceptdeny_object");
        centerPopupWindow($("acceptdeny_object"));
        $("acceptdeny_object").style.display="block";
        this.addDomEvents();
        
    },
    showConfirmation : function (objects) {
        if (!objects.length) return;
        AcceptDeny.visible = true;
        this.objects = objects;
        if (this.showdetail) {
            $("acceptdeny_nodetail").style.display="none";
            $("acceptdeny_list").style.display = "";
            $("acceptdeny_list_message").style.display =
                objects[0].confirmation ? "none" : "";
            var messages = $("acceptdeny_list_message").
                getElementsByTagName("span");
            switch (objects[0].module) {
                case "tasks":
                    messages[0].style.display = "none";
                    messages[1].style.display = "";
                    $("acceptdeny_show").style.display = "none";
                    break;
                case "calendar":
                    messages[0].style.display = "";
                    messages[1].style.display = "none";
                    $("acceptdeny_show").style.display = "";
                    break;
                default:
                    messages[0].style.display = "none";
                    messages[1].style.display = "none";
                    $("acceptdeny_show").style.display = "none";
            }
            var grid = AcceptDeny.grid;
            if (!grid) {
                var defaultClear = LiveGrid.makeClear("");
                grid = AcceptDeny.grid = new LiveGrid([
                {
                    width: "30px",
                    style: { padding: 0, margin: 0 },
                    text: "&#x00a0;",
                    set: function(div, data) {
                        var src = getFullImgSrc("img/calendar/mod_calendar.gif");
                        if (data.module && data.module == "tasks") {
                            src = getFullImgSrc("img/tasks/mod_tasks.gif");
                        }
                        if (!div.firstChild) {
                            div.appendChild(newnode("img", {height : "24px", width : "24px"}, { src: getFullImgSrc("img/dummy.gif"), align: "absmiddle"}));
                        }
                        div.firstChild.src = src;
                    },
                    clear: function(div) {
                        if (!div.firstChild) {
                            div.appendChild(newnode("img", {height : "24px", width : "24px"}, { src: getFullImgSrc("img/dummy.gif"), align: "absmiddle"}));
                        } else {
                            div.firstChild.src = getFullImgSrc("img/dummy.gif");
                        }
                    }
                },{
                    i18n: "description"/*i18n context*/, text: "Title"/*i18n*/,
                    clear: function(div) {
                        if (!div.firstChild) {
                            div.appendChild(newnode("div", 0, 0,
                                [newtext("")]));
                            div.appendChild(newnode("div", 0, 0,
                                [newtext("")]));
                        } else {
                            div.firstChild.firstChild.data = "";
                            div.firstChild.nextSibling.firstChild.data = "";
                        }
                    },
                    set: function(div, data) {
                        var text = data.location
                            //#. Appointment description in the confirmation dialog.
                            //#. %1$s is the title.
                            //#. %2$s is the location.
                            //#, c-format
                            ? format("%1$s - %2$s", (data.title || ""),
                                                    data.location)
                            : (data.title || "");
                        if (!div.firstChild) {
                            div.appendChild(newnode("div", 0, 0,
                                [newtext(text)]));
                            div.appendChild(newnode("div", 0, 0,
                                [newtext("")]));
                        } else {
                            div.firstChild.firstChild.data = text;
                            div.firstChild.nextSibling.firstChild.data = "";
                        }
                        if (data.organizer && !data.organizerId) {
                            div.firstChild.nextSibling.firstChild.data = format(_("organized by %s"), data.organizer);
                        } else {
                            var user = data.organizerId || data.created_by;
                            internalCache.getUsers([ user ], function(u) {
                                var text = 
                                    //#. Second line in the grid of the notification dialog
                                    //#. %s is the name of the appointment creator or organizer
                                    //#, c-format
                                    format(_("created by %s"), u[user].display_name);
                                if (data.organizerId) {
                                    text = format(_("organized by %s"), u[user].display_name);
                                }
                                div.firstChild.nextSibling.firstChild.data = text;
                            });
                        }
                    }
                }, {
                    text: "Start"/*i18n*/, i18n: true, index: "startdate",
                    width: "11em", clear: defaultClear,
                    set: LiveGrid.dateSetTime
                }, {
                    text: "End"/*i18n*/, i18n: true, index: "enddate",
                    width: "11em", clear: defaultClear,
                    set: LiveGrid.dateSetTime
                }], new Selection());
                $("acceptdeny_list_header").appendChild(grid.getHeader());
                grid.columns[1].style = { height: "3.2em" };
                grid.getTable($("acceptdeny_list_body"));
                var setDisabled = classNameSetter("font-color-disabled");
                grid.events.register("Selected", function(count) {
                    $("acceptdeny_all").checked =
                        count == grid.storage.ids.length;
                    setDisabled($("acceptdeny_show"), count != 1);
                    setDisabled($("acceptdeny_accept"), count == 0);
                    setDisabled($("acceptdeny_decline"), count == 0);
                    setDisabled($("acceptdeny_tentative"), count == 0);
                    
                    // change button text - either it's an appointment or a task 
                    var ids = grid.getSelectedIDs();
                    if (ids.length != 1) return;
                    grid.storage.newIterate(ids, emptyFunction,
                        function(i, object) {
                            if (!object.module) return;
                            var butText = _("Show in calendar");
                            if (object.module == "tasks") {
                                butText = _("Show in task");
                            }
                            $("acceptdeny_show-button").firstChild.data = butText;
                        });
                });
                AcceptDeny.storage = new Storage(0, [], 0, 0, 0, 0,
                    function(x) { return x.objectid; });
                addDOMEvent($("acceptdeny_all"), "click", function() {
                    if ($("acceptdeny_all").checked) {
                        grid.selection.select(0, grid.storage.ids.length);
                    } else {
                        grid.selection.reset();
                    }
                });
                addDOMEvent($("acceptdeny_show"), "click", function() {
                    var ids = grid.getSelectedIDs();
                    if (ids.length != 1) return;
                    grid.storage.newIterate(ids, emptyFunction,
                        function(i, object) {
                    		var modulebefore = ox.api.ui.getActiveModule();
                    		
                            activemodule = object.module || "calendar";
                            if (activemodule == "calendar") {
                                activeDay = object.startdate.getUTCDate();
                                activeMonth = object.startdate.getUTCMonth();
                                activeYear = object.startdate.getUTCFullYear();
                            }
                            // change folder
                            ox.UIController.setFolder({
                                folder: object.folder_id,
                                module: "default",
                                success: function() {
                                    // if it's the same module we need to trigger view switch
                                    // to force a redraw
	                            	if (activemodule === modulebefore) {
	                                	triggerEvent("OX_Switch_View", currentpath.join("/"));
	                                }
                            	}
                            });
                        });
                });
            }
            var storage = AcceptDeny.storage;
            storage.remove(0, storage.ids.length);
            storage.append(objects)
            grid.enable(AcceptDeny.storage);
            grid.selection.click(0);
        } else {
            var acceptdenyobject = objects[0];
            $("acceptdeny_nodetail").style.display="";
            $("acceptdeny_list").style.display = "none";
            $("acceptdeny_notnew").style.display =
                acceptdenyobject.confirmation ? "none" : "";
        }
        //ox.api.setModal(true);
//        showNode("modal-dialog");
//        $("modal-dialog").style.display="block";
        showNode("acceptdeny_object");
        centerPopupWindow($("acceptdeny_object"));
        $("acceptdeny_object").style.display="block";
        this.addDomEvents();
    }
}

function acceptdeny_updateConfirm(objects, status, message, callback) {    
    var join = new Join(function() {
        json.put(AjaxRoot + "/multiple?session=" + session, requests, null,
                 finalCallback, finalCallback);
    });
    var last = join.add();
    var requests = new Array();
    for (var i = 0; i < objects.length; i++) {
        ox.api.folder.get({
            folder: objects[i].folder_id,
            success: join.add((function(object) {
                return function(folder) {
                    var owner = folder.type == 3 ?
                        folder.created_by :
                        configGetKey("identifier");
                    requests.push({
                        module: object.module, action: "confirm",
                        folder: object.folder_id, id: object.objectid,
                        data: { id: owner, confirmmessage: message,
                                confirmation: status }
                    });
                };
            })(objects[i]))
        });
    }
    last();
    function finalCallback(resp) {
        // TODO CHECK ERRORS
        
        acceptdeny_update_objects_in_cache(requests,
            acceptdeny_get_timestamp(resp));
        triggerEvent("OX_AcceptDeny_Changed");
        callback();
    }
}

function acceptdeny_get_timestamp(response) {
    return response.timestamp || response[0].timestamp || new Date().getTime();
}

function acceptdeny_update_objects_in_cache(objects, timestamp) {
    
    for (var i in objects) {
        var object = objects[i];
        if (object.module == "calendar") {
            if (storageCache && storageCache.current != null) storageCache.update();
            else lastUpdateOfCalendarTimestamp = timestamp;
            continue; // not implemented right now
            
        }
        
        ox.api.folder.get({
            folder: object.folder,
            success: function (folder) {
                var owner = folder.type == 3 ? folder.created_by : configGetKey("identifier");
                OXCache.moduleMappings[object.module].editObjects(
                      [ { "module": object.module, "folder": object.data.folder_id, "id": object.data.id } ],
                      { "users": 
                        [{ "confirmation": object.data.confirmation,
                           "confirmmessage": object.data.confirmmessage,
                           "id": owner 
                        }],
                        "timestamp": timestamp
                      }
                );
            }
        });
        
    }
}

function acceptdeny_start() {    
    function acceptdeny_fill(response) {
        var conarray=new Array();
        var constrings=new Object();
        for (var ia=0; ia<response.length; ia++) {
            if (!response[ia].data || !response[ia].data.length) continue;
            var data = response[ia].data;
            contimestamp = data.timestamp;
            for (var i=0; i<data.length; i++) {
                var newobject=new Object();
                newobject.id=data[i][0];
                newobject.folder_id=data[i][1];
                newobject.start_date=data[i][2];
                newobject.end_date=data[i][3];
                newobject.users=data[i][5];
                newobject.title=data[i][6];
                newobject.created_by=data[i][7];
                newobject.location=data[i][8];
                if (data[i][9]) {
                    newobject.organizer=data[i][9];
                    newobject.organizerId=data[i][10];
                }
                newobject.module = (ia == 0 ? "calendar" : "tasks");
                for(var i2=0; i2<newobject.users.length; i2++) {
                    if (newobject.users[i2].id == configGetKey("identifier")) {
                        if (newobject.users[i2].confirmation == 0) {
                            if(!constrings[newobject.folder_id+":"+newobject.id]) {
                                constrings[newobject.folder_id+":"+newobject.id]=true;
                                conarray.push(newobject);
                            }
                        }
                        break;
                    }
                }
            }    
        }
        showAllConfirmation(conarray);
    }
    var checkconfirmation=true;
    var columns="1,20,201,202,209,221,200,2";
    var confirmtimestamp=0;
    if (configContainsKey("gui.global.confirmtimestamp")) {
        confirmtimestamp = configGetKey("gui.global.confirmtimestamp");
    }
    if (configContainsKey("gui.global.confirmpopup") && 
            configGetKey("gui.global.confirmpopup") == true) {
        var startDate = new Date().getTime();
        var endDate = startDate+3600000*24*365*5;
        var requests = [];
        if (configGetKey("modules.calendar.module")) {
            requests.push( { module: "calendar", action: "updates", start: startDate, end: endDate, timestamp: confirmtimestamp, ignore: "deleted", columns: columns + ",400,224,227" } );
        }
        if (configGetKey("modules.tasks.module")) {
            requests.push( { module: "tasks", action: "updates", folder: configGetKey("folder.tasks"), start: startDate, end: endDate, timestamp: confirmtimestamp, ignore: "deleted", columns: columns } );
        }
        if (requests.length) {
            (new JSONX).put(AjaxRoot + "/multiple?session=" + session, requests, null, acceptdeny_fill);
        }
    }
}
var globalconfirm = new AcceptDeny(true);

register("Ready", function () {
    // put it into ready so we can disable it
    if (jQuery.isFunction(acceptdeny_start)) {
        acceptdeny_start();
        register("OX_Refresh", acceptdeny_start);
    }
});


var contimestamp;

function showAllConfirmation(acceptdenyarray) {    
    var a = new Array(acceptdenyarray.length);
    for (var i = 0; i < acceptdenyarray.length; i++) {
        a[i] = new AcceptDenyObject(acceptdenyarray[i].module || "calendar", acceptdenyarray[i]);
    }
    globalconfirm.showConfirmation(a);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var globalalert = new AlertPopup();
var globalcreate= new CreatePopup();
function AlertPopup() {    
    this.header;
    this.buttons;
    this.text;
    this.div;
    this.cbresize;
    this.closecb;
    this.cbok;
    this.cbcancel;
    this.cbyes;
    this.cbno;
    this.cbsave;
    this.cbseries;
    this.cbappointment;
    this.cbnocomment;
    this.visibleButtons=[];
}
AlertPopup.SERIESBUTTON=50;
AlertPopup.OK=1;
AlertPopup.CANCEL=2;
AlertPopup.YES=4;
AlertPopup.NO=8;
AlertPopup.APPOINTMENT=16;
AlertPopup.SERIES=32;
AlertPopup.NOCOMMENT=64;
AlertPopup.EDIT=128;
AlertPopup.CONTINUE=256;
AlertPopup.VERSION=67;
AlertPopup.OKCANCEL=3;
AlertPopup.YESNO=12;
AlertPopup.CONTINUECANCEL=258;
AlertPopup.SAVE=512;

if (init && init.i18n) delete init.i18n["alert_window-h-c"];

AlertPopup.open = function () {
    globalalert.visibleButtons = [];
    /*
     * remove keydown event just in case!
     */
    removeDOMEvent(body, "keydown", AlertPopup.key_down);
    if ("Hover" in window) Hover.disable();
    ox.api.setModal(true);
    //showNode("modal-dialog");
    //$("modal-dialog").style.display="block";
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";
    /*
     * enable / disable required buttons
     */
    if ((globalalert.buttons %  2) >= 1) { 
        $("alert_window_ok").style.display="block";
        setFocus($("alert_window_ok"));
        globalalert.visibleButtons.push({id: "alert_window_ok", evt: AlertPopup.commitok});
    } else { 
        $("alert_window_ok").style.display="none"; 
    }
    if ((globalalert.buttons %  4) >= 2) { 
        $("alert_window_cancel").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_cancel", evt: AlertPopup.commitcancel});
    } else { 
        $("alert_window_cancel").style.display="none"; 
    }
    if ((globalalert.buttons %  8) >= 4) { 
        $("alert_window_yes").style.display="block"; 
        setFocus($("alert_window_yes"));
        globalalert.visibleButtons.push({id: "alert_window_yes", evt: AlertPopup.commityes});
    } else { 
        $("alert_window_yes").style.display="none"; 
    }
    if ((globalalert.buttons % 16) >= 8) { 
        $("alert_window_no").style.display="block";
        globalalert.visibleButtons.push({id: "alert_window_no", evt: AlertPopup.commitno});
    } else { 
        $("alert_window_no").style.display="none"; 
    }    
    if ((globalalert.buttons % 64) >= 32) { 
        $("alert_window_series").style.display="block";
        globalalert.visibleButtons.push({id: "alert_window_series", evt: AlertPopup.commitseries});
    } else { 
        $("alert_window_series").style.display="none"; 
    }
    if ((globalalert.buttons % 32) >= 16) { 
        $("alert_window_appointment").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_appointment", evt: AlertPopup.commitappointment});
    } else { 
        $("alert_window_appointment").style.display="none"; 
    }
    if ((globalalert.buttons % 128) >= 64) { 
        $("alert_window_nocomment").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_nocomment", evt: AlertPopup.commitnocomment});
    } else { 
        $("alert_window_nocomment").style.display="none"; 
    }
    if ((globalalert.buttons % 256) >= 128) { 
        $("alert_window_edit").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_edit", evt: AlertPopup.commitedit});
    } else { 
        $("alert_window_edit").style.display="none"; 
    }
    if ((globalalert.buttons % 512) >= 256) { 
        $("alert_window_continue").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_continue", evt: AlertPopup.commitcontinue});
    } else { 
        $("alert_window_continue").style.display="none"; 
    }
    if ((globalalert.buttons % 1024) >= 512) { 
        $("alert_window_save").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_save", evt: AlertPopup.commitsave});
    } else { 
        $("alert_window_save").style.display="none"; 
    }
    if (globalalert.SHOWAGAIN) { 
        $("alert_window_showagain").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_showagain_value", evt: function() {}});
    } else { 
        $("alert_window_showagain").style.display="none"; 
    }
    showNode("alert_window");
    $("alert_window-h-c").firstChild.data = globalalert.header;
    removeChildNodes($("alert_window_text"));
    if (globalalert.div) {        
        $("alert_window_text").appendChild(globalalert.div);
    } else {
        var nText = globalalert.text.split("\n");
        for (var i in nText) {
            $("alert_window_text").appendChild(document.createTextNode(nText[i]));
            $("alert_window_text").appendChild(newnode("br"));
        }
    }
    centerPopupWindow($("alert_window"));    
    $("alert_window").style.display="block";
    addDOMEvent(body, "keydown", AlertPopup.key_down);
    // bind to resize
    if (!globalalert.cbresize) {
        globalalert.cbresize = function() {
            // bind to resize to prevent dialog moved out of view
            // bug #19950 - header offset needs to be checked as its top
            // position is -x :(
            var header = jQuery(".popup_border_lo", $("alert_window"));
            if (header && header.offset().top < 0) {
                jQuery($("alert_window")).css({ top: (header.height() + 1) + "px" });
            } 
        };
        jQuery(window).bind('resize', globalalert.cbresize);
    }
}
AlertPopup.close = function () {
    if ("Hover" in window) Hover.enable();
    removeDOMEvent(body, "keydown", AlertPopup.key_down);
    ox.api.setModal(false);
    hideNode("alert_window");
    $("alert_window").style.display="none";
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs = $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0;i<childs.length;i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display != "none" ) {
                closeall=false;
            }
        }
    }
    globalalert.visibleButtons = {};
    if (closeall === false) {
        ox.api.setModal(true);
    }
    if (globalalert.closecb) {
        globalalert.closecb();
    }
    // unbind resize
    if (globalalert.cbresize) {
        jQuery(window).unbind('resize', globalalert.cbresize);
        globalalert.cbresize = undefined;
    }
}
AlertPopup.commityes = function () {
    AlertPopup.close();
    if(globalalert.cbyes) { globalalert.cbyes(); }
}
AlertPopup.commitno = function () {
    AlertPopup.close();
    if(globalalert.cbno) { globalalert.cbno(); }
}
AlertPopup.commitcancel = function () {
    AlertPopup.close();
    if(globalalert.cbcancel) { globalalert.cbcancel(); }
}
AlertPopup.commitok = function () {
    if (!globalalert.leaveOpen) {
        AlertPopup.close();
    }
    if(globalalert.cbok) { globalalert.cbok(); }
}
AlertPopup.commitseries = function () {
    AlertPopup.close();
    if(globalalert.cbseries) { globalalert.cbseries(); }
}
AlertPopup.commitnocomment = function () {
    AlertPopup.close();
    if(globalalert.cbnocomment) { globalalert.cbnocomment(); }
}
AlertPopup.commitappointment = function () {
    AlertPopup.close();
    if(globalalert.cbappointment) { globalalert.cbappointment(); }
}
AlertPopup.commitedit = function () {
    AlertPopup.close();
    if(globalalert.cbedit) { globalalert.cbedit(); }
}
AlertPopup.commitsave = function () {
    AlertPopup.close();
    if(globalalert.cbsave) { globalalert.cbsave(); }
}
AlertPopup.key_down = function(e) {
    switch (e.keyCode || e.which) {
        case 27: // esc
            AlertPopup.close();
            break;
        case 9: // tab
            if (!globalalert.visibleButtons.length) break;
            if (focusedElement != null) {               
                for (var i=0; i<globalalert.visibleButtons.length; i++) {
                    if (globalalert.visibleButtons[i].id == focusedElement.id) {
                        if (i+1 < globalalert.visibleButtons.length) {
                            setFocus($(globalalert.visibleButtons[i+1].id));
                        } else {
                            setFocus($(globalalert.visibleButtons[0].id));
                        }
                        break;
                    }
                }
            } else {
                setFocus($(globalalert.visibleButtons[0].id));
            }
            break;
        case 13: // enter 
            if (!globalalert.visibleButtons.length) break;
            if (focusedElement != null) {               
                for (var i=0; i<globalalert.visibleButtons.length; i++) {
                    if (globalalert.visibleButtons[i].id == focusedElement.id) {
                        globalalert.visibleButtons[i].evt();
                        break;
                    }
                }
            }
            break;         
        default:
            return;        
    }
    stopEvent(e);
    return false;
}
AlertPopup.prototype = 
{
    setOK : function (cb) {
        this.cbok=cb;
    },
    setCancel : function (cb) {
        this.cbcancel=cb;
    },
    setYes : function (cb) {
        this.cbyes=cb;
    },
    setNo : function (cb) {
        this.cbno=cb;
    },
    setSeries: function (cb) {
        this.cbseries=cb;
    },
    setAppointment: function (cb) {
        this.cbappointment=cb;
    },
    setClose: function (cb) {
        this.closecb=cb;
    },
    setNoComment : function(cb) {
        this.cbnocomment=cb;
    },
    setEdit: function(cb) {
        this.cbedit=cb;
    },
    setSave: function(cb) {
        this.cbsave=cb;
    }
};

function CreatePopup() {    
    this.header;
    this.buttons;
    this.text;
    this.inputtext;
    this.inputvalue;
    this.closecb;
    this.cbok;
    this.cbcancel;
    this.cbadvanced;
    this.cbnocomment;
}
CreatePopup.OK=1;
CreatePopup.CANCEL=2;
CreatePopup.NOCOMMENT=4;
CreatePopup.VERSION=7;
CreatePopup.ADVANCED=64;
CreatePopup.ALL=67;

CreatePopup.open = function () {
    ox.api.setModal(true);
    //showNode("modal-dialog");
    //$("modal-dialog").style.display="block";
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";
    if ((globalcreate.buttons %  4) >= 2) { $("create_window_cancel").style.display="block"; } else { $("create_window_cancel").style.display="none"; }
    if ((globalcreate.buttons %  8) >= 4) { $("create_window_nocomment").style.display="block"; } else { $("create_window_nocomment").style.display="none"; }
    if ((globalcreate.buttons %  2) >= 1) { $("create_window_ok").style.display="block"; } else { $("create_window_ok").style.display="none"; }
    
    if ((globalcreate.buttons % 128) >= 64) { $("create_window_advanced").style.display="block"; } else { $("create_window_advanced").style.display="none"; }
    
    $("create_window-h-c").firstChild.data = globalcreate.header;
    $("create_window_text").firstChild.data = globalcreate.text;
    if(globalcreate.inputtype == "input") {
        $("create_window_table_textarea").style.display="none";
        $("create_window_table_text_input").style.display="block";
        if (globalcreate.inputtext) {
            $("create_window_text_input").style.display="";
            $("create_window_text_input").firstChild.data = globalcreate.inputtext;
        } else {
            $("create_window_text_input").style.display="none";
        }    
        $("create_window_text_field").value=globalcreate.inputvalue;
        setTimeout(function() { 
            if ($("create_window_text_field") && $("create_window_text_field").focus()) $("create_window_text_field").focus(); 
        },500);
    } else if(globalcreate.inputtype == "textarea") {
        $("create_window_table_textarea").style.display="block";
        $("create_window_table_text_input").style.display="none";
        $("create_window_textarea").firstChild.data = globalcreate.inputtext;    
        $("create_window_textarea_field").value=globalcreate.inputvalue;
        setTimeout(function() { 
            if ($("create_window_textarea_field") && $("create_window_textarea_field").focus()) $("create_window_textarea_field").focus(); 
        },500);
    }
    showNode("create_window");
    centerPopupWindow($("create_window"));
    $("create_window").style.display="block";
}
CreatePopup.close = function () {
    ox.api.setModal(false);
    hideNode("create_window");
    $("create_window").style.display="none";
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs= $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0;i<childs.length;i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display != "none" ) {
                closeall=false;
            }
        }
    }
    if (closeall === false) {
        ox.api.setModal(true);
    }
    if(globalcreate.closecb) { globalcreate.closecb(); }

}
CreatePopup.commitcancel = function () {
    CreatePopup.close();
    if(globalcreate.cbcancel) { globalcreate.cbcancel(); }
}
CreatePopup.commitok = function () {
    CreatePopup.close();
    if(globalcreate.cbok) { globalcreate.cbok(); }
}
CreatePopup.commitnocomment = function () {
    CreatePopup.close();
    if(globalcreate.cbnocomment) { globalcreate.cbnocomment(); }
}
CreatePopup.commitadvanced = function () {
    CreatePopup.close();
    if(globalcreate.cbadvanced) { globalcreate.cbadvanced(); }
}

CreatePopup.prototype = 
{
    setOK : function (cb) {
        this.cbok=cb;
    },
    setCancel : function (cb) {
        this.cbcancel=cb;
    },
    setAdvanced: function (cb) {
        this.cbadvanced=cb;
    },
    setClose: function (cb) {
        this.closecb=cb;
    },
    setNoComment : function (cb) {
        this.cbnocomment=cb;
    }
}
function newAlert(headertitle,alerttext,okcb,div) {
    globalalert.header=headertitle;
    globalalert.buttons=CreatePopup.OK;
    globalalert.text=alerttext;
    globalalert.div=div;
    globalalert.closecb=null;
    globalalert.cbok=okcb;
    globalalert.cbcancel=null;
    globalalert.cbnocomment=null;
    globalalert.cbyes=null;
    globalalert.cbno=null;
    globalalert.cbsave=null;
    AlertPopup.open();
}
function newConfirm(headertitle,contenttext,buttons,cbok,cbcancel,cbyes,cbno,cbseries,cbappointment,cbclose,cbnocomment,cbedit,div) {
    globalalert.header=headertitle;
    globalalert.buttons=buttons;
    globalalert.text=contenttext;
    globalalert.div=div;
    globalalert.closecb=cbclose;
    globalalert.cbok=cbok;
    globalalert.cbappointment=cbappointment;
    globalalert.cbseries=cbseries;
    globalalert.cbcancel=cbcancel;
    globalalert.cbedit=cbedit;
    globalalert.cbyes=cbyes;
    globalalert.cbno=cbno;
    globalalert.cbnocomment=cbnocomment;
    AlertPopup.open();    
}
function newInput(headertitle,contenttext,inputtext,inputvalue,buttons,cbok,cbcancel,cbadvanced,cbclose,
                                                                                    inputType,cbnocomment) {
    globalcreate.header=headertitle;
    globalcreate.text=contenttext;
    globalcreate.inputtext=inputtext;
    if(inputvalue)
        globalcreate.inputvalue=inputvalue;
    else
        globalcreate.inputvalue="";
    globalcreate.buttons=buttons;
    globalcreate.closecb=cbclose;
    globalcreate.cbok=cbok;
    globalcreate.cbcancel=cbcancel;
    globalcreate.cbnocomment=cbnocomment;
    globalcreate.cbadvanced=cbadvanced;
    if(inputType)
        globalcreate.inputtype=inputType;
    else
        globalcreate.inputvalue="input";
    CreatePopup.open();    
}
function newAppointmentObject(appointmentobject,myok,mycancel,myadvanced,myclose) {
    if(appointmentobject.start_date && appointmentobject.end_date) {
        var mystring=formatDate(appointmentobject.start_date,"datetime")+ " - "+formatDate(appointmentobject.end_date,"datetime"); 
        newInput(_("New Appointment"),mystring, pgettext("description", "Title"),"",CreatePopup.ALL,myok,mycancel,myadvanced,myclose);
    }
}
register("Loaded",function() {
    addOnClose($('alert_window'),function () {
    	delete(globalalert.leaveOpen);
        AlertPopup.close();
    });
    addOnClose($('create_window'),function () { 
        CreatePopup.close(); 
    });
});
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * @author Stefan Preuss <stefan.preuss@open-xchange.org>
 * 
 */

var globalconflicts = new ConflictsPopup();

function ConflictsPopup() {    
    this.object;
    this.conflicts;
    this.closecb;
    this.cbcancel;
    this.cbignore;
}

ConflictsPopup.tableTemplate;

ConflictsPopup.open = function (object,conflicts,closecb,cbcancel,cbignore) {
    globalconflicts.object = object;
    globalconflicts.conflicts = conflicts;
    globalconflicts.closecb = closecb;
    globalconflicts.cbcancel = cbcancel;
    globalconflicts.cbignore = cbignore;
    
    removeChildNodes($("conflict_window_appointments"));
    $("conflict_window_ignore").style.display = "block";
    $("conflict_recurrence_msg").style.display =
        object.recurrence_type ? "" : "none";
    
    // iterate trough each conflict and draw rows
    for (i in conflicts) {
        var table = newnode("tbody");
        var tmp = conflicts[i];
        var tr = document.createElement("tr");
        
        var img = newnode("img", { cursor:"pointer"}, { src: getFullImgSrc("img/minus.gif"), align:"absmiddle", width:16, height:16 });
        
        // draw each conflict in a seperate tr 
        tr.appendChild(newnode("td", 0, { className:"cell" },
                [ img ]));
        tr.appendChild(newnode("td", 0, { className:"cell" }, 
                [ document.createTextNode(tmp.title || _("Private")) ] ));
        var node_C = newnode("td", 0, { className:"cell" });      
        tr.appendChild(node_C);
        tr.appendChild(newnode("td", 0, { className:"cell" }, 
                [ tmp.start_date ? document.createTextNode(formatDate(tmp.start_date, isToday(tmp.start_date) ? "time" : "datetime")) : _("Private") ]));
                
        tr.appendChild(newnode("td", 0, { className:"cell" }, 
                [ tmp.end_date ? document.createTextNode(formatDate(tmp.end_date, isToday(tmp.end_date) ? "time" : "datetime")) : _("Private") ]));
        table.appendChild(tr);
        
        // resolving creator of appointment
        internalCache.getObjects([{ type:1, id:tmp.created_by }], (function(creator, node) {
            return function(user) {
                node.appendChild(document.createTextNode(user[creator.id].display_name || ""));
            };
        })({ type:1, id:tmp.created_by }, node_C));
            
        // creating participant rows
        var table_P = newnode("tbody");
        var tmp_T = ConflictsPopup.tableTemplate.cloneNode(true);
        tmp_T.style.padding="0px";
        tmp_T.appendChild(table_P);
        
        var tmp_TR = newnode("tr");
        img.onclick = (function(img, tr) {
            return function(e) {
                var isOpen = img.src.match(/minus.gif/gi);
                img.src = isOpen ? getFullImgSrc("img/plus.gif") : getFullImgSrc("img/minus.gif");
                tr.style.display = isOpen ? "none" : "";
            };
        })(img, tmp_TR);
        
        tmp_TR.appendChild(newnode("td",{padding:"0px"},{colSpan:5},[tmp_T])); 
        table.appendChild(tmp_TR);
        
        // using internal cache to resolve display names and append results to the given td node
        if (tmp.participants && tmp.participants.length) {
            internalCache.getObjects(tmp.participants, (function(cbObj, cb_node) {
                    return function(cb_participants) {
                        for (var ia=0; ia < cbObj.participants.length; ia++) {
                            var tmp_dn = cb_participants[cbObj.participants[ia].id].display_name || "";
                            var tr = newnode("tr");
                            
                            // draw each conflict in a seperate tr      
                            tr.appendChild(newnode("td", 0, { className:"cell" },
                                    [ newnode("img", null, { src:getFullImgSrc("img/dummy.gif"), align:"absmiddle", width:"16", height:"16" }) ]));

                            tr.appendChild(newnode("td", 0, { className:"cell" },
                                    [ 
                                        newnode("img", 0, 
                                            { src: getFullImgSrc("img/calendar/" + 
                                                (cb_participants[cbObj.participants[ia].id].type == 1 ? "user" : "ressourcen") + ".gif"), 
                                              align: "absmiddle", width: "16", height: "16" }),
                                        document.createTextNode(" " + tmp_dn) 
                                    ]));
                            
                            var confirmClass = "";
                            var confirmText = _("waiting");                        
                            switch(cbObj.participants[ia].confirmation) {
                                case 1:
                                   confirmClass = "appointmentACCEPTED";
                                   confirmText = _("accepted");
                                   break;
                                case 2:
                                   confirmClass = "appointmentDECLINED";
                                   confirmText = _("declined");
                                   break;
                                case 3:
                                   confirmClass = "appointmentTENTATIVE";
                                   confirmText = _("tentative");
                                   break;
                            }
                            confirmClass += " cell";
                            tr.appendChild(newnode("td", { colSpan:3 }, { className:confirmClass },
                                    [ document.createTextNode(confirmText) ]));
                            
                            cb_node.appendChild(tr);
                        }
                    };
                })(tmp, table_P));
        }
        
        // disable 'ignore conflict button' if any appointment hard conflicts 
        if (tmp.hard_conflict) {
            $("conflict_window_ignore").style.display = "none";
        }
        
        // finally append everything to container
        var finalNode = ConflictsPopup.tableTemplate.cloneNode(true);
        finalNode.style.borderBottom="1px dotted silver";
        finalNode.appendChild(table);
        $("conflict_window_appointments").appendChild(finalNode);
    }

    ox.api.setModal(true);
    //showNode("modal-dialog");
    //$("modal-dialog").style.display="block";
    
    
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";

    showNode("conflict_window");
    centerPopupWindow($("conflict_window"));
    $("conflict_window").style.display="block";
    
};

ConflictsPopup.close = function () {
    if(globalconflicts.closecb) { 
        globalconflicts.closecb(globalconflicts.object); 
    }
    hideNode("conflict_window");
    $("conflict_window").style.display="none";    
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs=    $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0; i<childs.length; i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display != "none" ) {
                closeall=false;
            }
        }
    }
    
    if(closeall) {
        ox.api.setModal(false);
        //hideNode("modal-dialog");
        //$("modal-dialog").style.display="none";
    }
};

ConflictsPopup.commitignore = function() {
    if (globalconflicts.cbignore) { 
        globalconflicts.cbignore(globalconflicts.object); 
    }
    ConflictsPopup.close();
};

ConflictsPopup.commitcancel = function() {
    if (globalconflicts.cbcancel) { 
        globalconflicts.cbcancel(globalconflicts.object); 
    }
    ConflictsPopup.close();
};

ConflictsPopup.prototype = {
    setIgnore : function (cb) {
        this.cbignore=cb;
    },
    setCancel : function (cb) {
        this.cbcancel=cb;
    },
    setClose: function (cb) {
        this.closecb=cb;
    }
};

register("Loaded",function() {
    addOnClose($("conflict_window"), function () { 
            ConflictsPopup.close(); 
        });
    
    // create table template for later use     
    ConflictsPopup.tableTemplate=newnode("table",{tableLayout:"fixed"},{width:"100%",cellPadding:0,cellSpacing:0},
        [
            newnode("colgroup",0,0,
                [
                    newnode("col",{width:"26px"},0),
                    newnode("col",0,0),
                    newnode("col",{width:"13em"},0),
                    newnode("col",{width:"11em"},0),
                    newnode("col",{width:"11em"},0)
                ])
        ]);
});

fileloaded();
