/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

register("OX_Configuration_Loaded", function() {
	var configerrors=false;
	try {
		if (typeof(config.gui) == "string") {
			config.gui = eval("(" + config.gui + ")");
		}
	} catch (e) {
		delete(config.gui);
		//#. %s is the error message.
		//#, c-format
		alert(format(_("Syntax error in config: \n%s"), e.message));
	}
	if (!configContainsKey("identifier") || !configContainsKey("contact_id")) {
		 configerrors=true;
		 alert(_("Configuration damaged, please inform the administrator."));
	} 
	if (!configContainsKey("language")) {
			configSetKey("language","de_DE");
	}
	if (!configContainsKey("timezone")) {
		configSetKey("timezone","Europe/Berlin");
	}
	if (!configContainsKey("folder"))  {
		configSetKey("folder",{});	
	}	
 	if (!configContainsKey("modules.tasks.notifyNewModifiedDeleted")) {
		configSetKey("modules.tasks.notifyNewModifiedDeleted",false);
    }
    if (!configContainsKey("modules.tasks.notifyAcceptedDeclinedAsParticipant")) {
    	configSetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant",true);
    	configuration_changed_fields["module"]=true;
    }
	if(!configContainsKey("mail.deletemail")) {
		configSetKey("mail.deletemail",false);	
	}	
	if(!configContainsKey("gui.menu.menuiteration")) {
		configSetKey("gui.menu.menuiteration",2);
	}
	if(!configContainsKey("gui.mail.notifyacknoledge")) {
		configSetKey("gui.mail.notifyacknoledge",true);
	}
	if(!configContainsKey("gui.mail.select_first_message")) {
        configSetKey("gui.mail.select_first_message",true);
    }
	if(!configContainsKey("mail.appendmailtext")) {
		configSetKey("mail.appendmailtext",true);
	}
	if(!configContainsKey("gui.mail.htmlmessage")) {
		configSetKey("gui.mail.htmlmessage",true);
	}
	if(!configContainsKey("mail.vcard")) {
		configSetKey("mail.vcard",false);
	}
	if(!configContainsKey("gui.mail.editor_featureset")) {
		configSetKey("gui.mail.editor_featureset", 2);
		configSetKey("mail.inlineattachments",true);
		configSetKey("mail.emoticons",true);
		configSetKey("mail.colorquoted",true);
		configuration_changed_fields["mail"]=true;
		configuration_changed_fields["gui"]=true;
	}
	if (!configContainsKey("gui.mail.showname")) {
	    configSetKey("gui.mail.showname", false);
	}
	if(!configContainsKey("gui.mail.formatmessage")) {
		configSetKey("gui.mail.formatmessage","ALTERNATIVE");
	} else if(configGetKey("gui.mail.formatmessage") == "text") {
		configSetKey("gui.mail.formatmessage","ALTERNATIVE");
	}
	if(!configContainsKey("gui.mail.autocomplete")) {
		configSetKey("gui.mail.autocomplete",true)
	}
	if(!configContainsKey("mail.forwardmessage")) {
		configSetKey("mail.forwardmessage","Inline");
	}
	if(!configContainsKey("mail.linewrap")) {
		configSetKey("mail.linewrap",70)
	}
	if(!configContainsKey("gui.calendar.interval")) {
		configSetKey("gui.calendar.interval",30);
	}
	if(!configContainsKey("gui.calendar.starttime")) {
		configSetKey("gui.calendar.starttime",8);
	}
	if(!configContainsKey("gui.calendar.endtime")) {
		configSetKey("gui.calendar.endtime",18);
	}
	if(!configContainsKey("gui.calendar.default_reminder")) {
		configSetKey("gui.calendar.default_reminder",15);
	}
	if(!configContainsKey("gui.calendar.teamview.workingTimeOnly")) {
        configSetKey("gui.calendar.teamview.workingTimeOnly", true);
    }
	
    if (!configContainsKey("gui.calendar.views")) {
        if (configContainsKey("gui.calendar.view")) {
            var view = configGetKey("gui.calendar.view");
            if (!view || typeof view != "object") {
                var match = /^calendar\/([^\/]+)\/([^\/]+)$/.exec(view)
                    || [, "calendar", "day"];
                view = { view: match[1], calendar: match[2], team: match[2],
                         list: match[2], shared: true };
            }
            if(!(   configGetKey("modules.calendar.calendar_freebusy")
                && configGetKey("modules.calendar.calendar_teamview")))
            {
                if (view.view == "team") view.view = "calendar";
            }
        } else {
            var view = { view: "calendar", calendar: "workweek", team: "workweek",
                         list: "workweek", shared: true };
        }
        configSetKey("gui.calendar.views", view);
        configSetKey("gui.calendar.view", getDefaultCalendarView());
    }
	if (!configContainsKey("gui.calendar.allfolders")) {
		configSetKey("gui.calendar.allfolders",true);
		configSetKey("modules.calendar.notifyAcceptedDeclinedAsCreator",true);
    	configSetKey("modules.tasks.notifyAcceptedDeclinedAsCreator",true);
    	configuration_changed_fields["modules"]=true;
	}
	if(!configContainsKey("gui.calendar.day.numberofappointments")) {
		configSetKey("gui.calendar.day.numberofappointments",4);
	}
	if(!configContainsKey("gui.calendar.workweek.numberofappointments")) {
		configSetKey("gui.calendar.workweek.numberofappointments",2);
	}
	if(!configContainsKey("gui.calendar.workweek.startday")) {
		configSetKey("gui.calendar.workweek.startday",1);
	}
	if(!configContainsKey("gui.calendar.workweek.countdays")) {
		configSetKey("gui.calendar.workweek.countdays",5);
	}
	if(!configContainsKey("gui.calendar.custom.countdays")) {
		configSetKey("gui.calendar.custom.countdays",3);
	}
	if(!configContainsKey("gui.calendar.custom.numberofappointments")) {
		configSetKey("gui.calendar.custom.numberofappointments",3);
	}
	if (!configContainsKey("modules.calendar.notifyNewModifiedDeleted")) {
        configSetKey("modules.calendar.notifyNewModifiedDeleted",false);
    } 
    if (!configContainsKey("modules.calendar.notifyAcceptedDeclinedAsParticipant")) {
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant",true);
        configuration_changed_fields["modules"]=true;
    }
	if(!configContainsKey("gui.contacts.view")) {
		configSetKey("gui.contacts.view","contacts/cards");
	}
	if(!configContainsKey("gui.infostore.view")) {
		configSetKey("gui.infostore.view","infostore/split");
	}
	if(!configContainsKey("gui.mail.view")) {
		configSetKey("gui.mail.view","mail/hsplit/unthreaded");
	}
	if(!configContainsKey("gui.mail.signatures")) {
		configSetKey("gui.mail.signatures",new Array());
	}
	if(!configContainsKey("reloadtimes")) {
		configSetKey("reloadtimes",[0]);		
	}
	if(!configContainsKey("gui.global.autorefresh")) {
		configSetKey("gui.global.autorefresh",10);
	} else {
		var isvalid=false;
		var myrel=configGetKey("reloadtimes");		
		for(var i=0;i<myrel.length;i++) {
			if(configGetKey("gui.global.autorefresh")*60000==myrel[i]) {
				isvalid=true;
				break;
			}
		}
		if(!isvalid) {
			configSetKey("gui.global.autorefresh",0);
		}
	}
	if(!configContainsKey("gui.effects.hover.portal")) {
		configSetKey("gui.effects.hover.portal",true);
	}
	if(!configContainsKey("gui.effects.hover.mail")) {
		configSetKey("gui.effects.hover.mail",false);
	}
	if(!configContainsKey("gui.effects.hover.calendar")) {
		configSetKey("gui.effects.hover.calendar",true);
	}
	if(!configContainsKey("gui.effects.hover.contacts")) {
		configSetKey("gui.effects.hover.contacts",true);
	}
	if(!configContainsKey("gui.effects.hover.tasks")) {
		configSetKey("gui.effects.hover.tasks",true);
	}
	if(!configContainsKey("gui.effects.hover.infostore")) {
		configSetKey("gui.effects.hover.infostore",true);
	}
	if(!configContainsKey("gui.effects.hover.speed")) {
		configSetKey("gui.effects.hover.speed",3);
	}
	if(!configContainsKey("gui.effects.global")) {
		configSetKey("gui.effects.global",false);
		configSetKey("gui.effects.fading",false);
	}
	if (!configContainsKey("gui.categories.local")) {
		configSetKey("gui.categories.local", []);
		ox.categories.utils.migrateTags();
	}
//	if (!configContainsKey("gui.FolderTreeState")) {
//		configSetKey("gui.FolderTreeState",new Object);
//	}			
	if (!configContainsKey("gui.contacts.gridsort") || !isNaN(configGetKey("gui.contacts.gridsort")))   {
		configSetKey("gui.contacts.gridsort","last_name");
	}
	if (!configContainsKey("gui.contacts.gridorder")) {
		configSetKey("gui.contacts.gridsort","asc");
	}			
	if (!configContainsKey("gui.contacts.cardsToViewPerColumn")) {
		configSetKey("gui.contacts.cardsToViewPerColumn","auto");
	}
	if (!configContainsKey("gui.tasks.view")) {
		configSetKey("gui.tasks.view","tasks/split");
	}
	if(!configContainsKey("gui.tasks.gridsort")) {
		configSetKey("gui.tasks.gridsort","200");
	}
	if(!configContainsKey("gui.tasks.gridorder")) {
		configSetKey("gui.tasks.gridsort","asc");
	}
	if(!configContainsKey("gui.tasks.interval")) {
		configSetKey("gui.tasks.interval",30);
	}
	if(!configContainsKey("gui.global.save")) {
		configSetKey("gui.global.save",1);
	}
	if(!configContainsKey("gui.global.confirmpopup")) {
		configSetKey("gui.global.confirmpopup",true);
	} else {
		var id=configGetKey("gui.global.save");
		if(id != 0 && id != 1 && id != 2) {
			configSetKey("gui.global.save",2);
		}
	}
	if(!configContainsKey("gui.portal.internalcontents")) {
		configSetKey("gui.portal.internalcontents",new Array());
	}
	if(!configContainsKey("gui.portal.externalcontents")) {
		configSetKey("gui.portal.externalcontents",new Array());
	}
	
	// expert mode
    if (!configContainsKey("ui.global.expert.mode")) {
        configSetKey("ui.global.expert.mode", { value: false, configurable: true });
    }
    
	// embedded windows
	if (!configContainsKey("ui.global.windows.mode")) {
        configSetKey("ui.global.windows.mode", { value: "embedded", configurable: true });
    }
	
	// toolbar
    if (!configContainsKey("ui.global.toolbar.mode")) {
        configSetKey("ui.global.toolbar.mode", { value: "tabbased", configurable: true });
    }
    
    // show contact image
    if (!configContainsKey("ui.mail.showContactImage")) {
        configSetKey("ui.mail.showContactImage", { value: true, configurable: true });
    }
    
    // overwrite backend setting as this is no longer required
    configSetKey("participants.showDialog", true);
	
    if (configuration_changed_outside === true) {
        setTimeout(function() {
            triggerEvent("OX_Save_Configuration",false,true);
            configuration_changed_outside = false;
        }, 5000);
    }
    
	triggerEvent("OX_Configuration_Set_Empty");
});

registerModule("configuration", _("Configuration"), 100);

// Configuration changed?
function configuration_changed() {
	for (var id in configuration_changed_fields) {
		if (configuration_changed_fields[id] === true) {
			return true;
		}
	}
	return false;
}

var configuration_changed_fields=new Object();
var configuration_changed_outside=false;
configuration_changed_fields["timezone"]=false;
configuration_changed_fields["language"]=false;
configuration_changed_fields["gui"]=false;
configuration_changed_fields["mail"]=false;
configuration_changed_fields["folder"]=false;
configuration_changed_fields["calendarnotification"]=false;
configuration_changed_fields["tasknotification"]=false;
configuration_changed_fields["modules"]=false;

var lastViewed = "";
var changed = new Array();
var changed_inv = false;
var foldersChanged = 0;
var j = 0;
var configVisited = false;
var configToolbars = {};

(function() {
	register("Loaded", function() {});
})();

//because already defined in configtree.js
/*
registerView("configuration",
	function (){},
	function() { 
	},
	function() {		
	},
	function() {
	},
	null
);*/
register("OX_Configuration_GUI_Changed",function () {
	configuration_changed_fields["gui"]=true;
});

/**
 * Asks the user to save changes before leaving a configuration page.
 * If the changes need to be saved, the event OX_SAVE_OBJECT is triggered.
 * If the changes should be discarded, the event OX_Cancel_Object is triggered.
 * @param {Function} callback An optional callback which is called if the page
 * change is not cancelled.
 */
function configuration_askforSave(callback) {
    if(configuration_changed()) {
        newConfirm(_("Configuration changed"),
            _("Do you want to save your configuration?"),
            AlertPopup.YESNO, null, null,
            function() {
                triggerEvent("OX_SAVE_OBJECT");
                if (callback) callback();
            },
            function() {
                triggerEvent("OX_Cancel_Object");
                if (callback) callback();
            });     
    } else {
        if(callback) callback();
    }
}

register("OX_Save_Configuration",configuration_saveObject);
function configuration_saveObject(force,hidemessage,myok,myerror,optParam) {
    var showmessage=true;
    var openrequests=0;
    var iserror=false;
    var errormessage="";
    
    function successcb(r) {
        openrequests--;
        if(openrequests==0) {
            afterRequest();
        }
    }
    if(!myok) {
        myok=successcb;
    }
    
    function errorcb(result,status) {
        openrequests--;
        iserror=true;
        if(status != 200) {
            errormessage=_("The configuration could not be saved, because of the following error:") +
                //#. HTTP Errors from the server
                //#. %1$s is the numeric HTTP status code
                //#. %2$s is the corresponding HTTP status text
                //#, c-format
                format(_("Error: %1$s - %2$s"), status, result);
        }
        if (openrequests==0) {
            afterRequest();
        }
    }
	if(!myerror) {
		myerror=errorcb;
	}

	function afterRequest() {
		if (iserror) {
			if(!hidemessage) triggerEvent("OX_New_Error",errormessage);
		} else {
			if(!hidemessage) {
				triggerEvent("OX_New_Info",4,_("Your settings have been saved"));
			}
			if (!force) {
				if(activemodule=="configuration") {
					triggerEvent("OX_Configuration_Changed",currentpath2.join("/"));
				} else {
					triggerEvent("OX_Configuration_Changed","");
				}
			}
		}
		// make sure all config fields are marked as "not changed"
		for (var id in configuration_changed_fields) {
		    configuration_changed_fields[id] = false;
		}
	}
	
    var ro_ConfigSettings = [
        "addresses", "availableModules", "availableTimeZones", "contact_id",
        "context_id", "currentTime", "defaultaddress", "folder",
        "global_categories", "identifier", "maxUploadIdleTimeout",
        "mail.addresses", "mail.defaultaddress", "mail.folder",
        "mail.spambutton", "modules", "participants.showDialog",
        "participants.showWithoutEmail", "reloadtimes", "serverVersion",
        "spambutton", "ui"
    ];
	
	function saveConfigtoServer(path,params,success1,error1) {
		showmessage=true;
		var reqstring= "config"; //AjaxRoot + "/config";
		var myparams;
		if (path && path != "") {
			reqstring=reqstring+"/"+path;
		}
		//reqstring=reqstring+"?session="+session;
		if (params && params != "") {
			myparams=configGetKey(params);
		} else {
			myparams=clone(config);
		}
        // going to remove read-only settings
		for (i in ro_ConfigSettings) {			
			var splitkey = ro_ConfigSettings[i].split(".");			
			var tmp = myparams;
			for (var ia=0; ia<splitkey.length-1; ia++) {
		        if (tmp[splitkey[ia]] != undefined) {
		            tmp=tmp[splitkey[ia]];
		        } else {
		            break;
		        }
		    }		       	            
            if (!splitkey || !splitkey.length) continue;
            delete tmp[splitkey[splitkey.length-1]];
		}
		// use http api (fixes IE9 logout bug)
		ox.api.http.PUT({
		    module: reqstring,
            appendColumns: false,
		    data: myparams,
		    success: success1,
		    error: error1
		});
		//myjson.put(reqstring, myparams, null, success1, error1);
	}
	if(force) {
		for (var i in configuration_changed_fields) {
			configuration_changed_fields[i] = false;
		}
		saveConfigtoServer("","",myok,myerror);
		configuration_changed_outside=false;
	}
    if (temporary.folderTabs.viewModified()) {
        temporary.folderTabs.saveView(configuration_changed_fields.folder ?
            emptyFunction :
            function() {
        		ox.api.folder.refresh({ folders: [temporary.folderTabs.folder.id] });
                /*
        		oMain-FolderTree.cache.updateFolders(
                    [temporary.folderTabs.folder.id],
                    function() {
                        oMain-FolderTree.load_view(
                            oMain-FolderTree.cache.folders.root,
                            oMain-FolderTree.tree, true, false);
                    
        			});*/
            });
        showmessage = false;
    }
	if(configuration_changed_fields["folder"] == true) {
		saveFolder(optParam);
		configuration_changed_fields["folder"]=false;
		showmessage=false;
	}
	if(configuration_changed_fields["mail"] == true) {
		saveConfigtoServer("mail","mail",myok,myerror);
		openrequests++;
		configuration_changed_fields["mail"] = false;
	}
	
	function timezoneChanged(data) {
	    if (data) {
	        configSetKey("currentTime", data.currentTime);
	        configSetKey("availableTimeZones", data.availableTimeZones);
	        // redraw timezone combo-box
            cs_drawTimezoneCombo(data.availableTimeZones);
            // update reminders
            if (jQuery.isFunction(updateReminders)) {
                updateReminders();
            }
	    }
	    triggerEvent("OX_SetTime");
	    triggerEvent("TimezoneChanged", configGetKey("timezone"));
	    myok();
	}
	
	if (configuration_changed_fields["timezone"] === true
	        || configuration_changed_fields["language"] === true) {
	    ox.api.http.PUT({
	        module: "config",
	        processData: false,
	        data: { 
	            "timezone": ox.api.config.get("timezone"),
                "language": ox.api.config.get("language")
	        },
	        success: function (data) {
	            ox.api.http.PUT({
	                module: "multiple",
	                appendColumns: false,
	                processData: false,
	                data: [
	                   { module: "config/currentTime", action: "GET" },
	                   { module: "config/availableTimeZones", action: "GET" }
                    ],
	                success: function (response) {
	                    // response not empty?
	                    if (!response && !response.length) {
	                        openrequests--;
	                        return;
	                    }
	                    data = { "currentTime": response[0].data, 
	                            "availableTimeZones": response[1].data
	                    };
	                    timezoneChanged(data);
                        //workaround for foldertree updates after language changes
                        ox.api.cache.folder0.clear();
                        ox.api.cache.folder1.clear();
                        ox.api.cache.folderFlat.clear();
                        ox.api.folder.dispatcher.trigger("modify");
	                    configuration_changed_fields["timezone"] = false;
	                    configuration_changed_fields["language"] = false;
	                    openrequests--;
	                }
	            });
	        },
	        error: myerror
	    });
	    openrequests++;
	}
	if(configuration_changed_fields["gui"] == true) {
		saveConfigtoServer("gui","gui",function(){
		    myok();
		    triggerEvent("OX_Calendar_Teamlist_Changed");}
		,myerror);
		
		openrequests++;
		configuration_changed_fields["gui"] = false;
	}
	if(configuration_changed_fields["ui"] == true) {
	    saveConfigtoServer("ui", "ui", myok, myerror);
        openrequests++;
        configuration_changed_fields["ui"] = false;
    }
	if (configuration_changed_fields["tasknotification"] == true) {		
        delete(config["tasknotification"]);
		// todo: each modules section should have an own area later!!
		configuration_changed_fields["modules"] = true;
		configuration_changed_fields["tasknotification"] = false;
	}
	if (configuration_changed_fields["calendarnotification"] == true) {
		delete(config["calendarnotification"]);
		// todo: each modules section should have an own area later!!
        configuration_changed_fields["modules"] = true;
		configuration_changed_fields["calendarnotification"] = false;
	}
	if(configuration_changed_fields["modules"] == true) {
		saveConfigtoServer("modules","modules",myok,myerror);
		openrequests++;
		configuration_changed_fields["modules"] = false;
	}
	if(openrequests==0 && showmessage) {
		afterRequest();
	}
}

function selectValue(rObj, setValue) {
	var fieldValue = new Array();
	var j;
	for (var i=0; i < rObj.length; i++) {
		if (rObj[i].value == setValue) {
			j = i;
			break;
		} else {
			j = 0;
		}
	}
	return j;
}

function cancelConfigGUI() {
	if (cloned != "") {
		config = new Object();
		config = copy(cloned);
	}
	changed = new Array();
}

function displaySignatureConfig(val) {
	 sig = document.getElementById("signaturetext");
	 sig.value = val;
}

var setConfigPath = function (domNode) {
    var node = ox.widgets.configTree.nodeIndex[currentpath2.join("/")];
    var path = node.name instanceof I18nString ? node.name : _(node.name);
    while (node.parentNode) {
        node = node.parentNode;
        path = _(node.name) + " / " + path;
    }
    domNode.firstChild.nodeValue = path;
};

var deleteFolderConfig = function () {
    // get folder
    ox.api.folder.get({
        folder: configfolder,
        success: function (data) {
            if (ox.api.folder.can("delete", data)) removeFolder(configfolder);
        }
    });
};

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

function ConfigCategories() {
	this.grid, this.selection = new Selection();
    this.storage = new Storage(0, [], 0, 0, 0, 0, function(data) { return data.name; }); 
}

ConfigCategories.prototype = {
	initGrid : function() {
		var self = this;
		this.grid = new LiveGrid([
		      { 
		          text: "Color", /*i18n*/
		          width: "6em",
		          i18n: true,
		          clear: function(div) {
			    	  if (div.firstChild)
		                  div.firstChild.className = "";
		              else
		                  div.appendChild(
		                		  newnode("div", 0, { className: "colorLabelCont bg hb" }));
		      	  },
		          set: function(div, data) {
		              if (div.firstChild)
		                  div.firstChild.className = "colorLabelCont bg hb colorLabel"+data.color;
		              else
		                  div.appendChild(
		                		  newnode("div", 0, 
		                				  { className: "colorLabelCont bg hb colorLabel" + data.color }));
		          }
		      },
		      {
		          text: "Name", /*i18n*/
		          i18n: true,
		          clear: LiveGrid.makeClear(""),		          
		          set: function(div, data) {        	
		              if (div.firstChild)
		                  div.firstChild.data = data.name;
		              else
		                  div.appendChild(document.createTextNode(data.name));
		          }
		      }
	      ], this.selection);
		
		this.grid.emptylivegridtext = "";
		this.grid.events.register("Selected", function() {
	    	// get selected signature
	    	var ids = self.grid.selection.getSelected();
	    	ox.ToolBarController.processSelection("categories", false, ids);
	    });
		this.grid.events.register("Activated", function(ids) {           
	            if (ids && ids.length > 0) {
	                triggerEvent("OX_Configuration_Edit_Tags");
	            }
	        }
	    );
		this.grid.events.register("Delete", 
	        function (ids){
	            // todo
	        }
	    );
	    
	    $("cms_tags_header").appendChild(this.grid.getHeader());
	    this.grid.getTable($("cms_tags_grid"));
	},
	
	enableGrid : function() {
		cnf_Categories.storage.remove(0, cnf_Categories.storage.ids.length);
		this.storage.append(ox.categories.list());
		this.grid.enable(this.storage);
	}, 
	
	disableGrid : function() {
		this.grid.disable();
	},
	
	addCategory : function() {
		ox.categories.ui.add.open(null, cnf_Categories.storeCategory);
	},
	
	editCategory : function() {
		var id = cnf_Categories.grid.selection.getSelected()[0];
		if (id) {
			var obj = cnf_Categories.grid.storage.data.data[id];
			if (obj) {
				ox.categories.ui.add.open(obj, cnf_Categories.storeCategory);
			}
		}
	},
		
	storeCategory : function(category) {
		if (!category) return;
				
		// either edit or new!?
		if (category.id) {
			cnf_Categories.grid.storage.localUpdate([category.id], function(index, object) {
	    		return category;
        	});
		} else {
			if (ox.categories.exists(category.name) ||
					cnf_Categories.grid.storage.indices[category.name]) return;
			category.active = true;			
			cnf_Categories.grid.storage.append([category]); // append to grid
		}
		configuration_changed_fields["gui"] = true;
	},
	
	removeCategory : function() {
		var ids = cnf_Categories.grid.selection.getSelected();
		if (ids && ids.length) {
			cnf_Categories.grid.storage.removeIDs(ids);
			configuration_changed_fields["gui"] = true;
		}
	},
		
	saveConfiguration : function() {
		if (configuration_changed_fields["gui"] && cnf_Categories.grid) {
			var grid = cnf_Categories.grid, selCat = [];
			// iterate through storage and get selected cats 
			grid.storage.newIterate(grid.storage.ids, emptyFunction, function(id, obj) {
				delete(obj.id);
				delete(obj.active);
				selCat.push(obj);
			}, function() {
				ox.categories.setCache(selCat);
				ox.categories.save(true);
			});			
		}
	},
	
	cancelConfiguration : function() {
		configuration_changed_fields["gui"] = false;
	}
		
}
var cnf_Categories = new ConfigCategories();

registerView("configuration/tags",
	function() { 
		showNode("config_tags"); 
		$("config_tags").style.display="block"; 
        
        // toolbar
        if (!configToolbars.categories) {
            configToolbars.categories =
                temporary.configuration.newToolbar(_("Categories"), [
                    temporary.configuration.saveButton,
                    { title: _("Categories"), buttons: [
                        {
                            title: _("Add"),
                            icons: ["img/menu/add_category.gif",
                                    "img/menu/add_category_d.gif"],
                            event: "OX_Configuration_Categories_Add"
                        }, {
                            title: _("Edit"),
                            icons: ["img/menu/edit.gif", "img/menu/edit_d.gif"],
                            event: "OX_Configuration_Categories_Edit",
                            selection: "categories",
                            requires: ["one"]
                        }, {
                            title: _("Remove"),
                            icons: ["img/menu/remove_category.gif",
                                    "img/menu/remove_category_d.gif"],
                            event: "OX_Configuration_Categories_Remove",
                            selection: "categories",
                            requires: ["some"]
                        }
                    ] }
                ], "categories");
            ox.ToolBarController.processSelection("categories", false, []);
        }
        temporary.configuration.showToolbar(configToolbars.categories);
	},
	function() { 
		setConfigPath($("config_tags_header"));
 	    register("OX_SAVE_OBJECT", cnf_Categories.saveConfiguration);
		register("OX_Cancel_Object", cnf_Categories.cancelConfiguration);
		register("OX_Configuration_Categories_Add", cnf_Categories.addCategory);
		register("OX_Configuration_Categories_Edit", cnf_Categories.editCategory);
		register("OX_Configuration_Categories_Remove", cnf_Categories.removeCategory);
		if (!cnf_Categories.grid) {
			cnf_Categories.initGrid();
		}
		cnf_Categories.enableGrid();
	},
	function() { 
 	    unregister("OX_SAVE_OBJECT", cnf_Categories.saveConfiguration);
		unregister("OX_Cancel_Object", cnf_Categories.cancelConfiguration);
		unregister("OX_Configuration_Categories_Add", cnf_Categories.addCategory);
		unregister("OX_Configuration_Categories_Edit", cnf_Categories.editCategory);
		unregister("OX_Configuration_Categories_Remove", cnf_Categories.removeCategory);
		cnf_Categories.disableGrid();
	},
	function() { 
		hideNode("config_tags"); 
		$("config_tags").style.display="none"; 
	},
	function() { }
);

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

register("OX_Configuration_Settings_Changed_Language",cs_changedLanguage);
register("OX_Configuration_Settings_Changed_Timezone",cs_changedTimezone);
register("OX_Configuration_Settings_Changed_UI", cs_changedUI);
register("OX_Configuration_Settings_Changed_GUI", cs_changedGui);
register("OX_Configuration_Settings_Changed_Mail",cs_changedMail);
register("OX_Configuration_Settings_Changed_Modules",cs_changedModules);
register("OX_Configuration_Settings_Changed_Calendar_Notification",cs_changedCalendarNotification);
register("OX_Configuration_Settings_Changed_Task_Notification",cs_changedTaskNotification);
register("OX_Configuration_Settings_Changed_Region_Date", cs_region_date_changed);
register("OX_Configuration_Settings_Changed_Tree", function() {
    configuration_changed_fields["modules"] = true;
});

function cs_changedMail() {
	configuration_changed_fields["mail"]=true;
}
function cs_changedModules() {
	configuration_changed_fields["modules"]=true;
}
function cs_changedUI() {
	configuration_changed_fields["ui"]=true;
}
function cs_changedGui() {
    configuration_changed_fields["gui"]=true;
}
function cs_changedTimezone() {
	configuration_changed_fields["timezone"]=true;
}
function cs_changedLanguage() {
	configuration_changed_fields["language"]=true;
}
function cs_changedCalendarNotification() {
	configuration_changed_fields["calendarnotification"]=true;
}
function cs_changedTaskNotification() {
	configuration_changed_fields["tasknotification"]=true;
}
function getBoolofInt(myint) {
	if(myint!=0) 
		return true;
	return false;
}
function getValueofRadioBox(nameofradios) {
	var allelements = document.getElementsByName(nameofradios);
	var returnvalue = 0;
	for (var i=0; i<allelements.length; i++) {
		if (allelements[i].checked) {
			return parseInt(allelements[i].value);
		} 
	}
}
function getStringofRadioBox(nameofradios) {
	var allelements = document.getElementsByName(nameofradios);
	var returnvalue = 0;
	for (var i=0; i<allelements.length; i++) {
		if (allelements[i].checked) {
			return allelements[i].value;
		} 
	}
}
function setIntofRadioBox(nameofradios,value){
	var allelements = document.getElementsByName(nameofradios);
	for (var i=0; i<allelements.length; i++) {
		if (parseInt(allelements[i].value) == value) {
			allelements[i].checked=true;
			break;
		} 
	}
}
function setValueofRadioBox(nameofradios,value) {
	if(value==true) { value=1; }
	if(value==false) { value=0; }
	var allelements = document.getElementsByName(nameofradios);
	for (var i=0; i<allelements.length; i++) {
		if (parseInt(allelements[i].value) == value) {
			allelements[i].checked=true;
			break;
		} 
	}
}
function setStringofRadioBox(nameofradios,value) {
	if(value==true) { value=1; }
	if(value==false) { value=0; }
	var allelements = document.getElementsByName(nameofradios);
	for (var i=0; i<allelements.length; i++) {
		if (allelements[i].value == value) {
			allelements[i].checked=true;
			break;
		} 
	}
}

var applyConfigurableFlag = function (selector, key) {
    // is configurable?
    var flag = configGetKey(key + ".configurable");
    // not defined?
    if (flag === null && configGetKey(key) !== null) {
        // make it configurable
        configSetKey(key + ".configurable", true);
    }
    if (flag === false) {
        jQuery(selector).hide();
    } else {
        jQuery(selector).show();
    }
};

registerView("configuration/settings",
	function() { 
		showNode("config"); 
		$("config").style.display="block";
        
        // toolbar
        if (!configToolbars.settings) {
            configToolbars.settings = temporary.configuration.newToolbar(
                _("Options"), [temporary.configuration.saveButton], "options");
        }
        temporary.configuration.showToolbar(configToolbars.settings);
        
        // configurable: expert mode
        applyConfigurableFlag("#configurable-expert", "ui.global.expert.mode");
        // configurable: embedded mode
        applyConfigurableFlag("#configurable-windows", "ui.global.windows.mode");
        // configurable: toolbar
        applyConfigurableFlag("#configurable-toolbar", "ui.global.toolbar.mode");
	},
		
	function() { 
 	    register("OX_SAVE_OBJECT",cs_saveConfiguration);
		register("OX_Cancel_Object",cs_cancelConfiguration);
		register("LanguageChanged",cs_changeHeader);
		//init config
		cs_enter(); 
        changeTab('tabConfiguration1', 'panelConfiguration1');
        $("panelConfiguration1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";        
		cs_region_enter();
	},
	function() { 
		//configuration_askforSave();
 	    unregister("OX_SAVE_OBJECT",cs_saveConfiguration);
		unregister("OX_Cancel_Object",cs_cancelConfiguration);
		unregister("LanguageChanged",cs_changeHeader);
		cs_leave();
	},
	function() { 
		hideNode("config"); 
		$("config").style.display="none";
		$("tabConfiguration1").style.display="none";
		$("panelConfiguration1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";
	
	},
	function() { 
		cs_enter();
		cs_region_enter(); 
	}
);

function cs_changeHeader() {
	if(currentpath2.join("/") == "configuration/settings") {
		setConfigPath($("cs_header"));
	}
}

var configSettingsTabsList = new Array('tabConfiguration1','tabConfiguration2');
var configSettingsPanelsList = new Array('panelConfiguration1','panelConfiguration2');
var configSettingsEventList = null;

var cc_actualTree = null;

function cs_saveConfiguration() {
    var languageChanged = false;
	if (configuration_changed_fields["timezone"]) {
		configSetKey("timezone",cs_timezone.getKey());
	}
	if(configuration_changed_fields["language"]) {
		configSetKey("language",cs_language.getKey());
		languageChanged = true;
	}
    if (configuration_changed_fields["modules"]) {
        if (cc_actualTree === null) {
            cc_actualTree = configGetKey("modules.folder.tree");
        }
        if (cc_actualTree !== null) {
            var selectedTree = cs_tree.getKey();
            if (selectedTree != cc_actualTree) {
                ox.JSON.put(AjaxRoot + "/config/modules/folder/tree?session=" +
                    session, selectedTree, function() {
                        actualTree = selectedTree;
                        ox.UINotifier.info(_("The new folder tree setting will take effect after a new login."/*i18n*/));
                    }, null, true);
            }
        }
    }
    
    if (configuration_changed_fields.ui) {
        
        // windows
        var val = getStringofRadioBox("cs_windows");
        configSetKey("ui.global.windows.mode.value", val);
        if (val === "embedded") {
            embeddedWindows.enable(); // embedded
        } else {
            embeddedWindows.disable(); // popups
        }
        
        // toolbar
        val = getStringofRadioBox("cs_toolbar");
        if (val !== configGetKey("ui.global.toolbar.mode.value")) {
            configSetKey("ui.global.toolbar.mode.value", getStringofRadioBox("cs_toolbar"));
            ox.UINotifier.info(_("The panel setting will take effect after a new login."/*i18n*/));
        }
        
    }
    
    if (configuration_changed_fields["gui"]) {
        
        // switch theme?
        var selectedTheme = cs_theme.getKey();
        if (configContainsKey(["modules", "themes", selectedTheme])) {
            // update (out of following if!)
            var themeName = configGetKey("modules.themes")[selectedTheme];
            configSetKey("gui.theme", { name: themeName, path: selectedTheme });
            // don't switch on-the-fly
            if (selectedTheme != oxThemeStyle.path) {
                // notify
                ox.UINotifier.info(
                    _("Theme will be applied after a new login."/*i18n*/)
                );
            }
        }
        
		// langing page
		var selectedPage = cs_landingPage.getKey();
		if (selectedPage) {
			configSetKey("gui.global.landing_page", { module: selectedPage });
		}
		
		// expert tree?
		var useExpert = getValueofRadioBox("cs_expert");
		if (useExpert != configGetKey("gui.global.expert_tree")) {
		    configSetKey("gui.global.expert_tree", useExpert);
		    ox.UIController.setExpertTree(useExpert == 1 ? true : false);
		}

 		configSetKey("gui.global.save",getValueofRadioBox("cs_saveconfig"));
		configSetKey("gui.global.autorefresh",cs_autorefresh.getKey());
		configSetKey("gui.effects.fading",getBoolofInt(getValueofRadioBox("cs_enableeffects")));
		configSetKey("gui.effects.global",getBoolofInt(getValueofRadioBox("cs_enableeffects")));
		configSetKey("gui.effects.hover.portal",getBoolofInt(getValueofRadioBox("cs_enablehoverportal")));
		configSetKey("gui.effects.hover.mail",getBoolofInt(getValueofRadioBox("cs_enablehovermail")));
		configSetKey("gui.effects.hover.calendar",getBoolofInt(getValueofRadioBox("cs_enablehovercalendar")));
		configSetKey("gui.effects.hover.contacts",getBoolofInt(getValueofRadioBox("cs_enablehovercontacts")));
		configSetKey("gui.effects.hover.tasks",getBoolofInt(getValueofRadioBox("cs_enablehovertasks")));
		configSetKey("gui.effects.hover.infostore",getBoolofInt(getValueofRadioBox("cs_enablehoverinfostore")));
		configSetKey("gui.effects.hover.speed",getValueofRadioBox("cs_hoverspeed"));	
		configSetKey("gui.global.region.time.predefined",getValueofRadioBox("cs_time_predefined"));
		if(getValueofRadioBox("cs_time_predefined") == 0) {
			if($("cs_time_userdefined:0").checked) {
				configSetKey("gui.global.region.time.format", "hh:mm a");
				configSetKey("gui.global.region.time.format_hour", "hh a");
				configSetKey("gui.global.region.time.format_suffix", true);
			}
			else {				
				configSetKey("gui.global.region.time.format", "HH:mm");
				configSetKey("gui.global.region.time.format_hour", "HH:mm");
				configSetKey("gui.global.region.time.format_suffix", false);
			}
		}
		configSetKey("gui.global.region.date.predefined",getValueofRadioBox("cs_date_predefined"));
		if(getValueofRadioBox("cs_date_predefined") == 0) {
			configSetKey("gui.global.region.date.format_selected_index", cs_dateformat.getSelectedIndex());
			configSetKey("gui.global.region.date.separator", cs_date_separator.getKey());
			var current_date_separator = cs_date_separator.getKey();
			var current_date_format = cs_dateformat.getKey();
			if(current_date_separator && current_date_separator != "default") {
				current_date_format = current_date_format.replace(/\W/g,current_date_separator);
			}
			configSetKey("gui.global.region.date.format", current_date_format);
		}
	}
    triggerEvent("OX_Save_Configuration", false, false, function() {
        if (languageChanged) {
            setLanguage(configGetKey("language"), function() {
                cs_region_enter();
            });
        }
    });
}

function cs_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	configuration_changed_fields["language"]=false;
	configuration_changed_fields["timezone"]=false;
    configuration_changed_fields["modules"] = false;
	cs_enter();	
}

function cs_region_enter() {
	/* time format */
	if(configContainsKey("gui.global.region.time.predefined") && configGetKey("gui.global.region.time.predefined")==0) {
		$("cs_time_userdefined:0").disabled = false;
		$("cs_time_userdefined:1").disabled = false;
		$("cs_time_predefined:0").checked = true
		var current_time_format = configGetKey("gui.global.region.time.format");
	} else {
		$("cs_time_userdefined:0").disabled = true;
		$("cs_time_userdefined:1").disabled = true;
		$("cs_time_predefined:1").checked = true
		var current_time_format = expectI18n(_("HH:mm"));
	}
	if(current_time_format.indexOf("a") != -1) {
		$("cs_time_userdefined:0").checked = true;
	} else {
		$("cs_time_userdefined:1").checked = true;
	}
	$("cs_region_time_sample").value = formatDate(new Date(now()), "time");
	
	
	/* date format */
	if(configContainsKey("gui.global.region.date.predefined") && configGetKey("gui.global.region.date.predefined")==0) {
		$("cs_date_predefined:0").checked = true
		var triggerNoEvent = true;
		cs_dateformat.setSelectedIndex(configGetKey("gui.global.region.date.format_selected_index"),triggerNoEvent);
		cs_date_separator.setKey(configGetKey("gui.global.region.date.separator"),triggerNoEvent);
		cs_dateformat.enable();
		cs_date_separator.enable();
	} else {
		cs_dateformat.disable();
		cs_date_separator.disable();
		$("cs_date_predefined:1").checked = true
	}
	$("cs_region_date_sample").value = formatDate(new Date(now()), "date");
}

function cs_region_set_time_format() {
	if($("cs_time_predefined:0").checked == true) {
		$("cs_time_userdefined:0").disabled = false;
		$("cs_time_userdefined:1").disabled = false;	
		var current_time_format = ($("cs_time_userdefined:0").checked) ? "hh:mm a" : "HH:mm";
		
	} else {
		$("cs_time_userdefined:0").disabled = true;
		$("cs_time_userdefined:1").disabled = true;
		var current_time_format = _("HH:mm");
		if(current_time_format.indexOf("a") != -1) {
			$("cs_time_userdefined:0").checked = true;
		} else {
			$("cs_time_userdefined:1").checked = true;
		}
	}
	$("cs_region_time_sample").value = formatDateTime(current_time_format, new Date(now()));
}

function cs_region_set_date_format() {
	if($("cs_date_predefined:0").checked == true) {
		cs_dateformat.enable();
		cs_date_separator.enable();
		var current_date_format = cs_dateformat.getKey();	
		var current_date_separator = cs_date_separator.getKey();	
	} else {
		cs_dateformat.disable();
		cs_date_separator.disable();
        //#. Default date format string
		var current_date_format = _("yyyy-MM-dd");
		var current_date_separator = false;
	}
	if(current_date_separator && current_date_separator != "default") {
		current_date_format = current_date_format.replace(/\W/g,current_date_separator);
	}
	$("cs_region_date_sample").value = formatDateTime(current_date_format, new Date(now()));
}

function cs_region_date_changed() {
	triggerEvent('OX_Configuration_Settings_Changed_GUI');
	cs_region_set_date_format()
}

function cs_enter() {	
	if(!cs_init_bool) {
		cs_init();
		cs_init_bool=true;
	}
	if(configContainsKey("language")) {
		cs_language.setKey(configGetKey("language"));
		configuration_changed_fields["language"]=false;
	}	
	if(configContainsKey("timezone")) {
		cs_timezone.setKey(configGetKey("timezone"));
		configuration_changed_fields["timezone"]=false;
	}
    if (configContainsKey("modules.folder.tree")) {
        cs_tree.setKey(configGetKey("modules.folder.tree"));
        configuration_changed_fields["modules"] = false;
    } else {
        $("cs_tree").parentNode.parentNode.style.display = "none";
    }
	if(configContainsKey("gui.theme")) {
		cs_theme.setKey(configGetKey("gui.theme").path);
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.global.landing_page")) {
		cs_landingPage.setKey(configGetKey("gui.global.landing_page").module);
		configuration_changed_fields["gui"]=false;
	}
	
	// expert tree
    if (configContainsKey("gui.global.expert_tree")) {
        setIntofRadioBox("cs_expert", configGetKey("gui.global.expert_tree"));
        configuration_changed_fields["gui"] = false;
    }
    
    // embedded windows
    if (configContainsKey("ui.global.windows.mode.value")) {
        setStringofRadioBox("cs_windows", configGetKey("ui.global.windows.mode.value"));
        configuration_changed_fields["ui"] = false;
    }
    
    // toolbar
    if (configContainsKey("ui.global.toolbar.mode.value")) {
        setStringofRadioBox("cs_toolbar", configGetKey("ui.global.toolbar.mode.value"));
        configuration_changed_fields["ui"] = false;
    }
    
	cs_autorefresh.setKey(configGetKey("gui.global.autorefresh"));
	if (configContainsKey("gui.global.save")) {
		var id = configGetKey("gui.global.save");
		setIntofRadioBox("cs_saveconfig", id);
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.global")) {
		setIntofRadioBox("cs_enableeffects",configGetKey("gui.effects.global"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.portal")) {
		setIntofRadioBox("cs_enablehoverportal",configGetKey("gui.effects.hover.portal"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.mail")) {
		setIntofRadioBox("cs_enablehovermail",configGetKey("gui.effects.hover.mail"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.calendar")) {
		setIntofRadioBox("cs_enablehovercalendar",configGetKey("gui.effects.hover.calendar"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.contacts")) {
		setIntofRadioBox("cs_enablehovercontacts",configGetKey("gui.effects.hover.contacts"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.tasks")) {
		setIntofRadioBox("cs_enablehovertasks",configGetKey("gui.effects.hover.tasks"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.infostore")) {
		setIntofRadioBox("cs_enablehoverinfostore",configGetKey("gui.effects.hover.infostore"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.speed")) {
		setIntofRadioBox("cs_hoverspeed",configGetKey("gui.effects.hover.speed"));
		configuration_changed_fields["gui"]=false;
	}
	setConfigPath($("cs_header"));
	setTabLists(configSettingsTabsList, configSettingsPanelsList, null);
} 

function cs_enableallhover() {
		setIntofRadioBox("cs_enablehoverportal",1);
		setIntofRadioBox("cs_enablehovermail",1);
		setIntofRadioBox("cs_enablehovercalendar",1);
		setIntofRadioBox("cs_enablehovercontacts",1);
		setIntofRadioBox("cs_enablehovertasks",1);
		setIntofRadioBox("cs_enablehoverinfostore",1);
		configuration_changed_fields["gui"]=true;
}

function cs_disableallhover() {
		setIntofRadioBox("cs_enablehoverportal",0);
		setIntofRadioBox("cs_enablehovermail",0);
		setIntofRadioBox("cs_enablehovercalendar",0);
		setIntofRadioBox("cs_enablehovercontacts",0);
		setIntofRadioBox("cs_enablehovertasks",0);
		setIntofRadioBox("cs_enablehoverinfostore",0);
		configuration_changed_fields["gui"]=true;
}

// (re-)draw timezone combo
function cs_drawTimezoneCombo(timezones) {
    var timezones = timezones || configGetKey("availableTimeZones");
    jQuery("#cs_timezone").empty();
    cs_timezone = new ComboBox3(window, "cs_timezone", "25em", 1, 
            true, "OX_Configuration_Settings_Changed_Timezone", 8);
    var tzarray = [];
    for (var i in timezones) tzarray.push({key: i, value: timezones[i] });
    tzarray.sort(function(a, b) {
        return a.value < b.value ? -1 : a.value > b.value ? 1 : 0;
    });
    for (var i = 0; i < tzarray.length; i++) {
        cs_timezone.addElement(noI18n(tzarray[i].value), tzarray[i].key);
    }
    cs_timezone.getDomNode();
    cs_timezone.setKey(configGetKey("timezone"));
}

function cs_init() {
    var modules = ox.api.ui.listModules();
    // disable module specific settings if disabled
    for (var i=0; i < modules.length; i++) {
        if (modules[i].disabled === true && $("cs_" + modules[i].name + "_hover")) {
            $("cs_" + modules[i].name + "_hover").style.display="none";
        }
    }
	
	var myarray=configGetKey("reloadtimes");
	cs_autorefresh = new ComboBox3(window, "cs_autorefresh", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
    cs_autorefresh.addElement(_("Never"), 0);
	if(configContainsKey("reloadtimes")) {
		for(var i=0;i<myarray.length;i++) {
			if(!myarray[i]== 0) {
				cs_autorefresh.addElement(getInterval(myarray[i]),
				                          myarray[i]/60000);
			}
		}
	}
	cs_autorefresh.getDomNode();
	
	cs_language = new ComboBox3(window, "cs_language", "15em", 0, true, "OX_Configuration_Settings_Changed_Language", 3);
	for(var i in corewindow.all_languages) {
	    if (!i) continue;
	    var lang = corewindow.all_languages[i];
	    if (typeof lang == "string") lang = noI18n(lang);
        cs_language.addElement(lang, i);
	}
	if (lang === undefined) cs_language.addElement(noI18n("\xa0"), "en_US");
	cs_language.getDomNode();
	
	// set timezone combo-box
	cs_drawTimezoneCombo(configGetKey("availableTimeZones"));
	
	cs_dateformat = new ComboBox3(window, "cs_dateformat", "9em", 0, true, "OX_Configuration_Settings_Changed_Region_Date", 8);
	cs_dateformat.addElement(_("M/d/yyyy"),   "M/d/yyyy");
	cs_dateformat.addElement(_("M/d/yy"),     "M/d/yy");
	cs_dateformat.addElement(_("MM/dd/yy"),   "MM/dd/yy");
	cs_dateformat.addElement(_("MM/dd/yyyy"), "MM/dd/yyyy");
	cs_dateformat.addElement(_("yy/MM/dd"),   "yy/MM/dd");
	cs_dateformat.addElement(_("dd/MM/yyyy"), "dd/MM/yyyy");
	cs_dateformat.addElement(_("dd/MM/yy"),   "dd/MM/yy");
	cs_dateformat.addElement(_("dd.MM.yyyy"), "dd.MM.yyyy");	
	cs_dateformat.addElement(_("dd.MM.yy"),   "dd.MM.yy");
	cs_dateformat.addElement(_("d.MM.yy"),    "d.MM.yy");
	cs_dateformat.addElement(_("d.M.yy"),     "d.M.yy");
	cs_dateformat.addElement(_("d.M.yyyy"),   "d.M.yyyy");
	//#. normal translation. replace letters only (e.g. jjjj-MM-tt)
	//#. not to be confused with the default format
	cs_dateformat.addElement(pgettext("label", "yyyy-MM-dd"), "yyyy-MM-dd");
	cs_dateformat.addElement(_("dd-MMM-yy"),  "dd-MMM-yy");
	cs_dateformat.getDomNode();
	
	cs_date_separator = new ComboBox3(window, "cs_dateseparator", "9em", 0, true, "OX_Configuration_Settings_Changed_Region_Date", 3);
	cs_date_separator.addElement(_("default"), "default");
	cs_date_separator.addElement(noI18n("/"),  "/");
	cs_date_separator.addElement(noI18n("."),  ".");
	cs_date_separator.addElement(noI18n("-"),  "-");
	cs_date_separator.getDomNode();
    
    var themes = [];
    var themeconfig = configGetKey("modules.themes");
    if (themeconfig) {
    	for (i in themeconfig) {
    		themes.push({ name: themeconfig[i], path: i });
    	}
        themes.sort(function(a, b) { 
        	   return (a.name.toUpperCase() < b.name.toUpperCase() ? -1 : 1); 
        	});
    } else {
        themes.push({ name: _("Default"), path: "default" });
    }
    
	cs_theme = new ComboBox3(window, "cs_theme", "30em", 0, true, "OX_Configuration_Settings_Changed_GUI", 3);
	for(var i=0;i<themes.length;i++) {
        cs_theme.addElement(
            themes[i].name instanceof I18nString ? themes[i].name
                                                 : noI18n(themes[i].name),
            themes[i].path);	
	}	
    cs_theme.getDomNode();
    
    
	cs_landingPage = new ComboBox3(window, "cs_landing_page", "30em", 0, true, "OX_Configuration_Settings_Changed_GUI", 3);
	var modules = ox.api.ui.listModules();
	for(var i in modules) {
		if (modules[i].disabled == false && modules[i].name != "configuration") {
			cs_landingPage.addElement(modules[i].title, modules[i].name);
		}
	}	
	cs_landingPage.getDomNode();
	
	cs_tree = new ComboBox3(window, "cs_tree", "15em", 0, true,
	    "OX_Configuration_Settings_Changed_Tree", 2);
	cs_tree.addElement(_("Classic"), 0);
	cs_tree.addElement(_("New"), 1);
	cs_tree.getDomNode();
}

function cs_leave() { }
var cs_init_bool=false;
var cs_language;
var cs_autorefresh;
var cs_timezone;
var cs_theme;
var cs_landingPage;
var cs_dateformat;
var cs_date_separator;
var cs_tree;

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/mail/preferences",
	function () { 
		showNode("config_mail"); 
		$("config_mail").style.display="block";
        
        // toolbar
        temporary.configuration.showToolbar(
            temporary.configuration.defaultToolbar);
	},
	function() {
		register("OX_SAVE_OBJECT",cm_saveConfiguration);
		register("OX_Cancel_Object",cm_cancelConfiguration);
		cm_enter();
        changeTab('contentMailConfigCommon', 'tabMailConfigCommon');
        $("tabMailConfigCommon").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";        
	},
	function() { 
		//configuration_askforSave();	
		unregister("OX_SAVE_OBJECT",cm_saveConfiguration);
		unregister("OX_Cancel_Object",cm_cancelConfiguration);
		cm_leave(); 
	},
	function () { 
		hideNode("config_mail"); 
		$("config_mail").style.display="none";
		$("tabMailConfigCommon").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";		 
	},
	function () { 
		cm_enter(); 
	}
);

function cm_saveConfiguration() {
	if (configuration_changed_fields["gui"]) {
		configSetKey("gui.mail.view", cm_default_level1.getKey());
        menulastviews.mail = cm_default_level1.getKey();
		configSetKey("gui.mail.view_spam", cm_default_level2.getKey());
		configSetKey("gui.mail.notifyacknoledge",getBoolofInt(getValueofRadioBox("cm_notifyacknoledge")));
		configSetKey("gui.mail.formatmessage",getStringofRadioBox("cm_formatmessage"));
		configSetKey("gui.mail.autocomplete",getBoolofInt(getValueofRadioBox("cm_autocomplete")));
		configSetKey("gui.mail.auto_save_drafts", cm_auto_save_mail_drafts.getKey());
		configSetKey("gui.mail.defaul_mail_font", cm_default_mail_font.getKey());
		configSetKey("gui.mail.defaul_mail_font_size", cm_default_mail_font_size.getKey());
		configSetKey("gui.effects.hover.mail",getBoolofInt(getValueofRadioBox("cm_enablehovermail")));
		configSetKey("gui.mail.select_first_message",getBoolofInt(getValueofRadioBox("cm_emailSelectFirstMessage")));
		configSetKey("gui.mail.editor_featureset", cm_editor_featureset.getKey());
		configSetKey("gui.mail.showname", getBoolofInt(getValueofRadioBox("cm_showname")));
	}
	if (configuration_changed_fields["mail"]) {
		configSetKey("mail.vcard",getBoolofInt(getValueofRadioBox("cm_appendvcard")));		
		configSetKey("mail.deletemail",getBoolofInt(getValueofRadioBox("cm_deletemail")));
		configSetKey("mail.appendmailtext",getBoolofInt(getValueofRadioBox("cm_appendmailtext")));
		configSetKey("mail.inlineattachments",getBoolofInt(getValueofRadioBox("cm_inlineattachments")));
		configSetKey("mail.colorquoted",getBoolofInt(getValueofRadioBox("cm_colorquoted")));
		configSetKey("mail.emoticons",getBoolofInt(getValueofRadioBox("cm_emoticons")));
		configSetKey("mail.forwardmessage",getStringofRadioBox("cm_forwardmessage"));
		configSetKey("mail.linewrap",$("cm_linewrap").value);
		configSetKey("mail.sendaddress", cm_default_sendaddress.getKey());
	}
	if (configuration_changed_fields["modules"]) {
		configSetKey("modules.mail.allowhtmlimages", getBoolofInt(getValueofRadioBox("cm_preloadimages")));
		if (configContainsKey("modules.mail.contactCollectEnabled") && configContainsKey("modules.mail.contactCollectFolder")) {			
			configSetKey("modules.mail.contactCollectOnMailTransport", getBoolofInt(getValueofRadioBox("cm_contactCollectOnMailTransport")));
			configSetKey("modules.mail.contactCollectOnMailAccess", getBoolofInt(getValueofRadioBox("cm_contactCollectOnMailAccess")));
		}
		configSetKey("modules.mail.replyallcc", getBoolofInt(getValueofRadioBox("cm_replyallcc")));
	}
    if (configuration_changed_fields.ui) {
        configSetKey("ui.mail.showContactImage.value",
            getBoolofInt(getValueofRadioBox("cm_showimage")));
    }
	
	triggerEvent("OX_Save_Configuration",false,false);
}

function cm_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	configuration_changed_fields["mail"]=false;
	configuration_changed_fields["modules"]=false;
	cm_enter();	
}

var cm_default_level1, cm_default_level2;
var cm_default_sendaddress, cm_auto_save_mail_drafts, cm_default_mail_font, cm_default_mail_font_size, cm_editor_featureset;
var cm_init_bool=false;

register("OX_Configuration_Loaded",cm_onconfigload);
function cm_onconfigload() {
    addDefaultView("mail/list/unthreaded", _("List view"));
    addDefaultView("mail/hsplit/unthreaded", _("H-split view"));
    addDefaultView("mail/vsplit/unthreaded", _("V-split view"));
}

function cm_leave() { }

function cm_enter() {
	if(!cm_init_bool) {
		cm_init();
		cm_init_bool=true;
	}
	if(configContainsKey("gui.mail.view")) {
		cm_default_level1.setKey(configGetKey("gui.mail.view"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.mail.view_spam")) {
		cm_default_level2.setKey(configGetKey("gui.mail.view_spam"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.mail.select_first_message")) {
        setValueofRadioBox("cm_emailSelectFirstMessage",configGetKey("gui.mail.select_first_message"));
        configuration_changed_fields["gui"]=false;
    }
	if(configContainsKey("mail.deletemail")) {
		setValueofRadioBox("cm_deletemail",configGetKey("mail.deletemail"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("gui.mail.notifyacknoledge")) {
		setValueofRadioBox("cm_notifyacknoledge",configGetKey("gui.mail.notifyacknoledge"));
		configuration_changed_fields["gui"]=false;
	}
    if (configContainsKey("ui.mail.showContactImage")) {
        setValueofRadioBox("cm_showimage", configGetKey("ui.mail.showContactImage.value"));
        configuration_changed_fields["ui"]=false;
    }
	if(configContainsKey("mail.appendmailtext")) {
		setValueofRadioBox("cm_appendmailtext",configGetKey("mail.appendmailtext"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.inlineattachments")) {
		setValueofRadioBox("cm_inlineattachments",configGetKey("mail.inlineattachments"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.vcard")) {
		setValueofRadioBox("cm_appendvcard",configGetKey("mail.vcard"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("gui.mail.autocomplete")) {
		setValueofRadioBox("cm_autocomplete",configGetKey("gui.mail.autocomplete"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("mail.colorquoted")) {
		setValueofRadioBox("cm_colorquoted",configGetKey("mail.colorquoted"));
		configuration_changed_fields["mail"]=false;
	}
    if(configContainsKey("mail.emoticons")) {
        setValueofRadioBox("cm_emoticons",configGetKey("mail.emoticons"));
        configuration_changed_fields["mail"]=false;
    }
	if (configContainsKey("gui.mail.showname")) {
		setValueofRadioBox("cm_showname", configGetKey("gui.mail.showname"));
		configuration_changed_fields.mail = false;
	}
	if(configContainsKey("gui.mail.formatmessage")) {
		setStringofRadioBox("cm_formatmessage",configGetKey("gui.mail.formatmessage"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.mail.defaul_mail_font")) {
		cm_default_mail_font.setKey(configGetKey("gui.mail.defaul_mail_font"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.mail.defaul_mail_font_size")) {
		cm_default_mail_font_size.setKey(configGetKey("gui.mail.defaul_mail_font_size"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.mail.editor_featureset")) {
		cm_editor_featureset.setKey(configGetKey("gui.mail.editor_featureset"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.mail.auto_save_drafts")) {
		cm_auto_save_mail_drafts.setKey(configGetKey("gui.mail.auto_save_drafts"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("mail.forwardmessage")) {
		setStringofRadioBox("cm_forwardmessage",configGetKey("mail.forwardmessage"));
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.linewrap")) {
		$("cm_linewrap").value=configGetKey("mail.linewrap");
		configuration_changed_fields["mail"]=false;
	}
	if(configContainsKey("mail.sendaddress")) {
		cm_default_sendaddress.setKey(configGetKey("mail.sendaddress"));
		configuration_changed_fields["mail"]=false;
	}	
	if(configContainsKey("gui.effects.hover.mail")) {
		setIntofRadioBox("cm_enablehovermail",configGetKey("gui.effects.hover.mail"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("modules.mail.allowhtmlimages")) {
		setIntofRadioBox("cm_preloadimages",configGetKey("modules.mail.allowhtmlimages"));
		configuration_changed_fields["modules"]=false;
	}
	var emailCollectEnabled = false;
    if (   configContainsKey("modules.mail.contactCollectOnMailTransport")
        && configContainsKey("modules.mail.contactCollectOnMailAccess"))
    {
        setIntofRadioBox("cm_contactCollectOnMailTransport", configGetKey("modules.mail.contactCollectOnMailTransport"));
        setIntofRadioBox("cm_contactCollectOnMailAccess", configGetKey("modules.mail.contactCollectOnMailAccess"));
        configuration_changed_fields["modules"]=false;        
        if (   configContainsKey("modules.mail.contactCollectFolder")
            && configGetKey("modules.mail.contactCollectFolder") != 0)
        {
            ox.api.folder.get({
                folder: configGetKey("modules.mail.contactCollectFolder"),
                success: function (data) { 
                    //#. %s is the folder name.
                    //#, c-format
                    $("cm_emailCollection_text").firstChild.nodeValue = format(
                        _("Automatically collect contacts in the folder \"%s\""),
                        [data.title]);
                }
            });
        } else {
            $("cm_emailCollection_text").firstChild.nodeValue =
                _("Automatically collect contacts");
        }
        emailCollectEnabled=true;        
    }
	$("cm_emailCollectionContent0").style.display=emailCollectEnabled ? "" : "none";
	$("cm_emailCollectionContent1").style.display=emailCollectEnabled ? "" : "none";
	$("cm_emailCollectionContent2").style.display=emailCollectEnabled ? "" : "none";

    if(configContainsKey("modules.mail.replyallcc")) {
        setIntofRadioBox("cm_replyallcc",configGetKey("modules.mail.replyallcc"));
        configuration_changed_fields["gui"]=false;
    }
	setConfigPath($("cm_header"));
	
    // configurable: show image contact
    applyConfigurableFlag("#configurable-showContactImage", "ui.mail.showContactImage");
	
	// register tabs
	setTabLists(new Array('contentMailConfigCommon','contentMailConfigCompose','contentMailConfigDisplay'),
		new Array('tabMailConfigCommon','tabMailConfigCompose','tabMailConfigDisplay'), null);	
}

function cm_init() {
	cm_default_level1= new ComboBox3(window, "cm_default_level1", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	var mailviews=getDefaultSubviews("mail");
	for (var i in mailviews) {
		cm_default_level1.addElement(mailviews[i],i);
	}
	cm_default_level1.getDomNode();
	
	cm_default_level2= new ComboBox3(window, "cm_default_level2", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	for (var i in mailviews) {
		cm_default_level2.addElement(mailviews[i],i);
	}
	cm_default_level2.getDomNode();	
	$("cm_default_level2_parent").style.display = configGetKey("mail.folder.spam") ? "" : "none";
	
	cm_default_sendaddress= new ComboBox3(window, "cm_default_sendaddress", "30em", 0, true,"OX_Configuration_Settings_Changed_Mail", 3);
	var aliases = configContainsKey("mail.addresses") ? configGetKey("mail.addresses") : new Array();
	for (a=0; a < aliases.length; a++) {
        cm_default_sendaddress.addElement(noI18n(aliases[a]), aliases[a]);
	}
	cm_default_sendaddress.getDomNode();
	
	// pre-fill with default parameter if not set in config
	if (!configContainsKey("gui.mail.auto_save_drafts"))
		configSetKey("gui.mail.auto_save_drafts",5);
	
	var myarray=[60000,180000,300000,600000,900000,1800000];
	cm_auto_save_mail_drafts = new ComboBox3(window, "cm_auto_save_mail_drafts", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
    cm_auto_save_mail_drafts.addElement(_("Disabled"), 0);
	for(var i=0;i<myarray.length;i++) {
		if(!myarray[i]== 0) {
            cm_auto_save_mail_drafts.addElement(getInterval(myarray[i]),
                                                myarray[i] / 60000);
		}
	}
	cm_auto_save_mail_drafts.getDomNode();
	
	cm_default_mail_font = new ComboBox3(window, "cm_default_mail_font", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 5);
    cm_default_mail_font.addElement(_("Default"), "default");
    cm_default_mail_font.addElement(noI18n("Andale Mono"), "andale mono,times");
    cm_default_mail_font.addElement(noI18n("Arial"), "arial,helvetica,sans-serif");
    cm_default_mail_font.addElement(noI18n("Arial Black"), "arial black,avant garde");
    cm_default_mail_font.addElement(noI18n("Book Antiqua"), "book antiqua,palatino");
    cm_default_mail_font.addElement(noI18n("Comic Sans MS"), "comic sans ms,sans-serif");
    cm_default_mail_font.addElement(noI18n("Courier New"), "courier new,courier");
    cm_default_mail_font.addElement(noI18n("Georgia"), "georgia,palatino");
    cm_default_mail_font.addElement(noI18n("Helvetica"), "helvetica");
    cm_default_mail_font.addElement(noI18n("Impact"), "impact,chicago");
    cm_default_mail_font.addElement(noI18n("Symbol"), "symbol");
    cm_default_mail_font.addElement(noI18n("Tahoma"), "tahoma,arial,helvetica,sans-serif");
    cm_default_mail_font.addElement(noI18n("Terminal"), "terminal,monaco");
    cm_default_mail_font.addElement(noI18n("Times New Roman"), "times new roman,times");
    cm_default_mail_font.addElement(noI18n("Trebuchet MS"), "trebuchet ms,geneva");
    cm_default_mail_font.addElement(noI18n("Verdana"), "verdana,geneva");
    cm_default_mail_font.addElement(noI18n("Webdings"), "webdings");
    cm_default_mail_font.addElement(noI18n("Wingdings"), "wingdings,zapf dingbats");
	cm_default_mail_font.getDomNode();
	
	cm_default_mail_font_size = new ComboBox3(window, "cm_default_mail_font_size", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
    cm_default_mail_font_size.addElement(_("Default"), "default");
    cm_default_mail_font_size.addElement(noI18n("1 (8pt)"), 1);
    cm_default_mail_font_size.addElement(noI18n("2 (10pt)"), 2);
    cm_default_mail_font_size.addElement(noI18n("3 (12pt)"), 3);
    cm_default_mail_font_size.addElement(noI18n("4 (14pt)"), 4);
    cm_default_mail_font_size.addElement(noI18n("5 (18pt)"), 5);
    cm_default_mail_font_size.addElement(noI18n("6 (24pt)"), 6);
    cm_default_mail_font_size.addElement(noI18n("7 (36pt)"), 7);
	cm_default_mail_font_size.getDomNode();
	
	cm_editor_featureset = new ComboBox3(window, "cm_editor_featureset", "15em", 0, true,"OX_Configuration_Settings_Changed_GUI", 3);
	cm_editor_featureset.addElement(_("Minimized"),'3');
	cm_editor_featureset.addElement(_("Default"),'1');
	cm_editor_featureset.addElement(_("Enhanced"),'2'); 
	cm_editor_featureset.getDomNode();
	
}

function cm_linewrap_changed() {
	var newvalue=trimStr($("cm_linewrap").value);
	if (newvalue == "")
		newvalue=0;
	newvalue=parseInt(newvalue, 10);
	if(isNaN(newvalue) || newvalue < 0) {
		newvalue=configGetKey("mail.linewrap");
	}
	$("cm_linewrap").value=newvalue;
	configuration_changed_fields["mail"]=true;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

// global var which holds a common storage with all accounts
// needed later for folder subscribe and updates
// SHOULD be used as a LOCAL var - from now on!
var mail_accounts;

function new_mail_account() {}

register("OX_Configuration_Loaded", function () {
    
    // init account storage
	mail_accounts = new Storage(0, [], 0, 0, 0, 0, function(data) { return data.id; });
		
    var account_folders = {};
    function updateAccountFolders() {
        account_folders = {};
        mail_accounts.newIterate(mail_accounts.ids, emptyFunction,
            function(index, account) {
                for (var i in { trash: 1, sent: 1, drafts: 1, spam: 1 }) {
                    var fullname = account[i + "_fullname"];
                    if (fullname) account_folders[fullname] = i;
                }
            });
    }
    
    /*
     * fix some properties
     */
    function fixObject (data) {
        // fix
        var copy = ox.util.clone(data);
        copy.password = null;
        copy.pop3_expunge_on_quit = !copy.pop3_expunge_on_quit;
        if (copy.transport_login) {
        	copy.transport_credentials = true;
        }
        return copy;
    }
	
	function loadAccounts(cb) {
	    // load all mail accounts
	    ox.api.account.all(function (data) {
            mail_accounts.remove(0, mail_accounts.ids.length);
            var nData = [];
            for (var i in data) {
            	nData.push(fixObject(data[i]));
            }
            mail_accounts.append(nData);
            updateAccountFolders();
            var oldStdFolder = window.isStdFolder || function() {
                return false;
            };
            window.isStdFolder = corewindow == window ? function(type) {
                return account_folders[activefolder] == type || oldStdFolder(type);
            } : function(type) {
                return account_folders[url.folder] == type || oldStdFolder(type);
            };
            ox.util.call(cb);
        });
	}
	
	// load
	if (configGetKey("modules.mail.module") != null) {
		loadAccounts(null);
	}

	// if not enabled we won't continue
	if (configGetKey("modules.mail.module") == null) return;
		
	var node = new ox.Configuration.LeafNode("configuration/mail/accounts", _("E-Mail Accounts"));
	var split = new ox.Configuration.VSplit(node, _("E-Mail Accounts"), 0.28);
	
	// toolbar
    if (!configToolbars.mailaccounts) {
        configToolbars.mailaccounts = temporary.configuration.newToolbar(
            _("E-Mail Accounts"), [
                {
                    title: _("New"),
                    id: "new",
                    buttons: [{
                        title: _("New"),
                        id: "new",
                        icons: ["img/new.png"],
                        big: true,
                        action: function() { 
                            if (split.onNew) split.onNew();
                        },
                        mousedown: function (options, e) {
                            if (ox.api.config.get("modules.mailaccount.module") !== true) {
                                corewindow.triggerEvent("Feature_Not_Available", 
                                        "configuration/mail/accounts/new", window);
                            }
                        }
                    }]
                }
            ], "mailaccounts");
    }
    split.toolbar = configToolbars.mailaccounts;
    
    // disabled when mailaccounts not available
    if (ox.widgets.toolBar.menuItems["mailaccounts-new-new"]) {
        ox.widgets.toolBar.menuItems["mailaccounts-new-new"].setEnabled(
            ox.api.config.get("modules.mailaccount.module") === true
        );
    }
    
    var unifiedCheckbox;
    
	/** Init function **/
	split.init = function() {
	    var selection = new Selection();
	    
	    var fields = [
            //Acount name
            { 
                text: _("Account name"),
                clear: LiveGrid.makeClear(""),
                set: function(div, data) {
                    if (div.firstChild)
                        div.firstChild.data = data.name || "";
                    else
                        div.appendChild(document.createTextNode(data.name || ""));
                }
            }
	    ];
	    
	    // unified inbox is disabled
	    if (ox.api.config.get("modules.mailaccount.unifiedMail", false) === true) {
	        fields.push(
	            // Unified INBOX flag
                {
                    text: _("Unified Mail")/* i18n */,
                    width: "12em",
                    clear: emptyFunction,
                    set: function(div, data) {
                        if (!div.firstChild) {
                            jQuery(div).append(
                                    jQuery("<input/>").attr({type: "checkbox", "oxid": data.id }).
                                    click(function(data) {
                                        var accountId = jQuery(this).attr("oxid");
                                        if (typeof(accountId) != "undefined") {
                                            // talk with server
                                            var data = { "id": accountId, "unified_inbox_enabled": !!jQuery(this).attr("checked") };
                                            // update
                                            ox.api.account.update({
                                                data: data,
                                                success: function (reply) {
                                                    // update right checkbox (only)
                                                    var enabled = reply.unified_inbox_enabled;
                                                    unifiedCheckbox.set(enabled);
                                                    // stop asking if nothing was changes
                                                    split.original.unified_inbox_enabled = enabled;
                                                    // thx to preuss' "brilliant" idea
                                                    mail_accounts.data.data[accountId].unified_inbox_enabled = enabled;
                                                    updateAccountFolders();
                                                }
                                            });
                                        }
                                    })
                            );
                        } else {
                            jQuery("input", div).attr({ "oxid": data.id });
                        }
                        div.firstChild.checked = data.unified_inbox_enabled || false;
                    }
                }
	        );
	    } 
	    
	    var grid = new LiveGrid(fields, selection);
	    fields = null;
	    grid.emptylivegridtext = _("No accounts available");
	    
	    split.list = grid;
	    
	    split.enableList = function() {
	    	loadAccounts(
	    			function() {
		            	grid.enable(mail_accounts);
	    			}
	    	);
	    };
	    
	    split.save = function(data, cont) {
	    	var nData = clone(data);
	    	
	    	// remove some fields if required
	    	if (!trimStr(nData.password).length) {
	    		delete(nData.password);
	    	}
	    	
	    	if (nData.transport_credentials === false) {
	    	    nData.transport_login = null;
	    		nData.transport_password = null;
	    	} else if (nData.transport_credentials !== true) {
	    	    delete(nData.transport_login);
                delete(nData.transport_password);
	    	}
	    	delete(nData.transport_credentials);
	    	
            if ("pop3_expunge_on_quit" in nData) {
                nData.pop3_expunge_on_quit = !nData.pop3_expunge_on_quit;
            }
            if ("mail_port" in nData) {
                nData.mail_port = parseInt(nData.mail_port);
            }
            if ("transport_port" in nData) {
                nData.transport_port = parseInt(nData.transport_port);
            }
            nData.transport_protocol = "smtp";
	    	if (nData["mail_protocol"] == "pop3") {
	    		nData.pop3_storage = "mailaccount";
	    	}
	    	
	    	if ("id" in data) {
	    		for (var i in nData) {
	        		if (nData[i] == undefined || nData[i] == "undefined") nData[i]=null; //delete(nData[i]);
	        	}
	    		
	    		// fields to be removed for account 0 (default) 
	    		if (nData.id == 0) {
	    		    delete nData.transport_protocol;
	    		}
	    		
	    		// update account
	    		ox.api.account.update({
	    		    data: nData,
	    		    success: function (reply) {
	    		        // fix data
	    		        var fixed = fixObject(reply);
	    		        // local update
        				mail_accounts.localUpdate([data.id], function (old) {
        				    return fixed;
                        });
        				updateAccountFolders();
                        ox.Configuration.info(_("Your settings have been saved."));
                        track({
                            type: "update",
                            what: "mail_account",
                            data: { id: data.id },
                            text: "Updated mail-account " + data.id
                        });
        	            cont(fixed);
                    }
	    		});
	        } else {
	        	nData.spam_handler = "NoSpamHandler";
	        	// create account
	        	ox.api.account.create({
	        	    data: nData,
	        	    success: handleNew
	        	});
	        }
	    	
	    	function handleNew(data) {
	    	    track({
                    type: "new",
                    what: "mail_account",
                    data: { id: data.id },
                    text: "Added mail-account " + data.id
                });
	    	    // add
	    		mail_accounts.append([fixObject(data)]);
	            ox.Configuration.info(_("Your settings have been saved."));
	            newAlert(_("Info"), _("You have set up an external E-Mail account. The sole responsibility for the availability of the external E-Mail account lies with the service provider."),
	            		function() {
	                        updateAccountFolders();
		            		globalalert.SHOWAGAIN=null;
		            		cont(data);
		            		split.onNew();
	            		}
	            );
	        }
	    };
	    
	    split.load = function(cont) {
	    	split.right.scrollTop = 0;
	    	mail_accounts.newIterate(selection.getSelected(), emptyFunction,
	            function(i, data) {
	                if (data.errormsg) return cont();
	                var d = clone(data);
	                cont(d);
	            });
	    };
	    
	    split.onNew = function() {	    	
            if (configGetKey("modules.mailaccount.module")) {
                split.right.scrollTop = 0;
                this.addNew({ name: _("New account") });
            } else {
                triggerEvent("Feature_Not_Available", "configuration/mail/accounts/new", window);
            }
	    };
	    
	    new_mail_account = function(data) {
	        if (!data.name) data.name = _("New account");
	        split.addNew(data);
        };
	    
	    
	    /*** menu items ***/
	    //menuarrows[node.id] = {};
	    
	    var accountsmenu = MenuNodes.createSmallButtonContext("mail.accounts",
	        _("Accounts"));
	    MenuNodes.createSmallButton(accountsmenu, "mail.accounts.delete",
	        _("Delete"), getFullImgSrc("img/menu/delete.gif"),
	        getFullImgSrc("img/menu/delete.gif"), confirmDelete);
	    function confirmDelete() {
	        if (!selection.count) return;
	        newConfirm(ngettext("Delete Account", "Delete Accounts", selection.count),
	            ngettext("Are you sure you want to delete the selected account?",
	                     "Are you sure you want to delete the selected accounts?",
	                     selection.count),
	            AlertPopup.YES | AlertPopup.NO, null, null, handleYes);
	    }
	    function handleYes() {
	    	mail_accounts.newIterate(selection.getSelected(), emptyFunction, handleDelete);
	    }
	    function handleDelete(idx, data) {
	        // cont
	        var cont = function () {
                grid.deleteIDs([data.id]);
            };
	        // remove account
	        ox.api.account.remove({
	            id: data.id,
	            success: cont
	        });
	        
	    }
	    addMenuNode(accountsmenu.node, MenuNodes.FIXED, 31);
	    changeDisplay(node.id, "mail.accounts");
	    
	    register("OX_SELECTED_ITEMS_CHANGED", function() {	    	
	        var deleteenabled = selection.count >= 1;
	        if (!configGetKey("modules.mailaccount.module")) {
	        	deleteenabled = false;
	        }
	        if (grid.storage) {
	            grid.storage.newIterate(selection.getSelected(), emptyFunction, emptyFunction, updateMenu);
	        } else updateMenu();	        
	        function updateMenu() {
	            menuglobalzaehler = 0;
	            //menuarrows[node.id]["mail.accounts"] = [];
	            menu_display_contents(node.id, "mail.accounts", deleteenabled, "mail.accounts.delete");
	        }
	    });
	    
	    /*** new/edit fields on the right side ***/
	    
	    /*** blank line ***/
	    var lb = function() { ox.UI.Widget.call(this); };
	    lb.prototype = extend(ox.UI.Widget, {
	        addContent: function() {
	           this.node = this.parent.addRow(newnode("br", null, false));
            }
	    });
        
        function disabler(widget) {
            return {
                get: ox.Configuration.Group.NoField.get,
                set: function(data) {
                    widget.setEnabled(data.id !== 0);
                    return data;
                }
            };
        }
        
        /*** ACCOUNT SETTINGS ***/
	    var account = new ox.Configuration.Group(_("Account Settings"));
	    var name = new ox.UI.Input(_("Account Name"));
	    account.addWidget(name, "name");
	    var primary_address = new ox.UI.Input(_("E-Mail Address"));
	    account.addWidget(primary_address, "primary_address");
	    var reply_to = new ox.UI.Input(_("Reply-to Address"));
	    if (ox.api.config.get("ui.mail.replyTo.configurable") === true) {
	        account.addWidget(reply_to, "reply_to");
	    }
	    var personal = new ox.UI.Input(_("Your name"));
	    account.addWidget(personal, "personal");
	    
	    // unified inbox is disabled
	    if (ox.api.config.get("modules.mailaccount.unifiedMail", false) === true) {
	        unifiedCheckbox = new ox.UI.CheckBox(_("Use Unified Mail for this account"));
	        account.addWidget(unifiedCheckbox, "unified_inbox_enabled");
	    }
	    
	    account.addWidget(new lb());
        split.addWidget(account, {
            get: ox.Configuration.Group.NoField.get,
            set: function(data) {
                name.setEnabled(data.id !== 0);
                primary_address.setEnabled(data.id !== 0);
                return data;
            }
        });
	    
	    /*** SERVER SETTINGS ***/
	    var mail = new ox.Configuration.Group(_("Server Settings")); 
        split.addWidget(mail, disabler(mail));
	    
	    function changePort() {
	    	switch(mail_protocol.get()) {
	        	case "imap": 
	        		if (mail_secure.get()) {
	    	    		mail_port.set("993");
	    	    	} else {
	    	    		mail_port.set("143");
	    	    	}
	        		mail_pop_note.setVisible(false);
	        		pop_refresh_rate.setVisible(false);
	        		pop_expunge_on_quit.setVisible(false);
	        		pop_delete_write_through.setVisible(false);
	        		break;
	        	case "pop3":
	        		if (mail_secure.get()) {
	    	    		mail_port.set("995");
	    	    	} else {
	    	    		mail_port.set("110");
	    	    	}
	        		mail_pop_note.setVisible(true);
	        		pop_refresh_rate.setVisible(true);
	        		pop_expunge_on_quit.setVisible(true);
	        		pop_delete_write_through.setVisible(true);
	        		break;
	    	}
	    }

	    
	    var mail_protocol = new ox.UI.ComboBox(_("Server Type"));
	    mail_protocol.width = "18.5em";
	    var protocols = [["imap"],[_("IMAP Mail Server")]];
	    if (ox.api.config.contains("modules.mail.protocols") === false
	            || jQuery.inArray("pop3", ox.api.config.get("modules.mail.protocols", [ ])) !== -1) {
	        protocols[0].push("pop3");
	        protocols[1].push(_("POP3 Mail Server"));
	    }
	    mail_protocol.setEntries(protocols[0], protocols[1]); 
	    mail_protocol.changed = changePort;
	    mail_protocol.default_value = "imap";
	    mail.addWidget(mail_protocol, {
	        get: function(data, value) { data.mail_protocol = value; },
	        set: function(data) {
	            mail_protocol.setEnabled(data.id === undefined);
	            return data.mail_protocol;
	        }
	    });
	    
	    var mail_pop_note = new ox.UI.Text(_("Please note: All messages received from the POP3 account will be stored to a folder on your local IMAP account."));
	    mail_pop_note.disable();
	    mail_pop_note.setVisible(false);
	    mail.addWidget(mail_pop_note, ox.Configuration.Group.NoField);
	    
	    var mail_secure = new ox.UI.CheckBox(_("Use SSL connection"));
	    mail.addWidget(mail_secure, "mail_secure");
	    mail_secure.changed = changePort;
	    
	    var mail_server = new ox.UI.Input(_("Server Name")); 
	    mail.addWidget(mail_server, "mail_server");
	    var mail_port = new ox.UI.Input(_("Server Port"));
	    mail_port.default_value = "143";
	    mail.addWidget(mail_port, "mail_port");
	    
	    var login = new ox.UI.Input(pgettext("username", "Login"));
	    mail.addWidget(login, "login");
	    var password = new ox.UI.Password(_("Password"));
	    mail.addWidget(password, "password");
	    
	    var pop_refresh_rate = new ox.UI.ComboBox(_("Check for new messages every 'n' minutes"));
	    pop_refresh_rate.width = "5em";	    
	    pop_refresh_rate.setEntries(["3","5","10","15","30","60","360"], ["3","5","10","15","30","60","360"]);
	    pop_refresh_rate.setVisible(false);
	    mail.addWidget(pop_refresh_rate, "pop3_refresh_rate"); 
	    
	    var pop_expunge_on_quit = new ox.UI.CheckBox(_("Leave messages on server"));
	    pop_expunge_on_quit.setVisible(false);
	    pop_expunge_on_quit.changed = function() {
	    	pop_delete_write_through.setEnabled(pop_expunge_on_quit.get());
	    };
	    mail.addWidget(pop_expunge_on_quit, "pop3_expunge_on_quit");
	    
	    var pop_delete_write_through = new ox.UI.CheckBox(_("Deleting messages on local storage also deletes them on server"));
	    pop_delete_write_through.setEnabled(false);
	    mail.addWidget(pop_delete_write_through, "pop3_delete_write_through");
	    
	    mail.addWidget(new lb());
	    
	    /*** TRANSPORT SETTINGS ***/
	    var transport_login, transport_password;
	    var transport = new ox.Configuration.Group(_("Outgoing Server Settings (SMTP)"));
	    split.addWidget(transport, {
            get: ox.Configuration.Group.NoField.get,
            set: function(data) {
                transport.setEnabled(data.id !== 0);
		    	var bool = Boolean(data.transport_credentials);
				transport_login.setEnabled(bool);
				transport_password.setEnabled(bool);
				return data;
            }
        });
	    
	    var transport_secure = new ox.UI.CheckBox("Use SSL connection");
	    transport.addWidget(transport_secure, "transport_secure");
	    transport_secure.changed = function() {
	    	if (transport_secure.get()) transport_port.set("465");
	    	else transport_port.set("25");
	    };
	    
	    transport.addWidget(new ox.UI.Input(_("Server Name")), "transport_server");
	    
	    var transport_port  = new ox.UI.Input(_("Server Port"));
	    transport_port.default_value = "25";
	    transport.addWidget(transport_port, "transport_port");
	    
	    var transport_credentials = new ox.UI.CheckBox(_("Use username and password"));
	    transport.addWidget(transport_credentials, "transport_credentials");
	    transport_credentials.changed = function(bool) {
	    	var bool = transport_credentials.get();
	    	transport_login.setEnabled(bool);
	    	transport_password.setEnabled(bool);
	    	if (bool === false) {
	    		transport_login.set(null);
	    		transport_password.set(null);
	    	}
	    };
	    
	    transport_login = new ox.UI.Input(pgettext("username", "Login"));
		transport.addWidget(transport_login, "transport_login");		
		transport_login.disable();
		
		transport_password = new ox.UI.Password(_("Password"));
		transport.addWidget(transport_password, "transport_password");
		transport_password.disable();
		
		
	    split.addWidget(new lb());
	    
	    /*** FOLDER SETTINGS ***/	    
	    var folder = new ox.Configuration.Group(_("Folder Settings"));
	    split.addWidget(folder, {
            get: ox.Configuration.Group.NoField.get,
            set: function(data) {
                folder.setVisible(Boolean(data.id));
                return data;
            }
        });
	    
	    // helper to find proper root node
	    var getRoot = function () {
	        // get value
	        var val = this.get() || "default0";
            var accountId = getMailAccountIdByFolder(val);
            return "default" + accountId;
	    };
	    
	    var selectionWidth = "30em";
	    var sent_fullname = new temporary.MailFolderSelection(_("Sent folder"), getRoot);
	    sent_fullname.width = selectionWidth;
	    folder.addWidget(sent_fullname, "sent_fullname");
        
        var trash_fullname = new temporary.MailFolderSelection(_("Trash folder"), getRoot);
        trash_fullname.width = selectionWidth;
        folder.addWidget(trash_fullname, "trash_fullname");
        
        var drafts_fullname = new temporary.MailFolderSelection(_("Drafts folder"), getRoot);
        drafts_fullname.width = selectionWidth;
        folder.addWidget(drafts_fullname, "drafts_fullname");
        
        var spam_fullname = new temporary.MailFolderSelection(_("Spam folder"), getRoot);
        spam_fullname.width = selectionWidth;
        folder.addWidget(spam_fullname, "spam_fullname");
	    
        folder.addWidget(new lb());
        
        /*** BUTTONS ***/
	        
	    var buttons = new ox.Configuration.HLayout();
	    
	    var check_button = new ox.UI.Button(_("Check connection"));
	    check_button.click = function () {
	        // pending...
	    	newAlert(_("Info"), _("Please wait while checking the connection ... This may take a while ..."));
	    	$(globalalert.visibleButtons[0].id).style.display="none";
	    	var data = clone(split.get());
	    	if (selection.getSelected().length == 1) {
	    		data.id = selection.getSelected()[0];
	    		if ("password" in data === false 
	    		        || trimStr(data.password).length === 0) {
	    		    delete(data.password);
	    		}
	    	}
	    	data.mail_protocol = mail_protocol.get();
	    	data.transport_protocol = "smtp";
	    	data.tree = false;
	    	
	    	// validate account data
	    	ox.api.account.validate(
	    	    data,
	    	    // success
    			function (reply) {
    				newAlert(_("Info"), reply.data ? _("The connection was successful.") : _("Connection failed! Please check your settings."));
                },
                // error
                function (reply) {
                	newAlert(_("Error"), _("Connection failed! Please check your settings: ") + formatError(reply));
                	return true;
                }
            );
	    };
        buttons.addWidget(check_button);
        split.addWidget(buttons, {
            get: emptyFunction,
            set: function(data) { check_button.setEnabled(data.id !== 0); }
        });
	    
	    var save_button = new ox.UI.Button(_("Save"));
	    save_button.click = function(data, pata) {
	    	function fail(field) {
	    		setTimeout(function() { 
	    		    //#. %1$s is the field name.
	    		    //#, c-format
	    			triggerEvent("OX_New_Error", 4, format(_("The mandatory field %1$s is not defined."), field)); 
	    		}, 0);
	    		return;
	    	}
	    	if (name.get() == "") {
	    		name.formnode.focus();
	    		return fail(_("Account Name"));
	    	} else if (primary_address.get() == "") {	  
	    		primary_address.formnode.focus();
	    		return fail(_("E-Mail Address"));	 
	    	} else if (mail_server.get() == "") {
	    		mail_server.formnode.focus();
	    		return fail(_("Server Name"));
    		} else if (login.isEnabled && login.get() == "") {
	    		login.formnode.focus();
	    		return fail(_("Login"));
    		} else if (!split["id"] && password.isEnabled && password.get() == "") {
    			password.formnode.focus();
	    		return fail(_("Password"));
    		} else if (transport_login.isEnabled && transport_login.get() == "") {
                transport_login.formnode.focus();
                return fail(_("Login"));
            } else if (!split["id"] && transport_password.isEnabled && transport_password.get() == "") {
                transport_password.formnode.focus();
                return fail(_("Password"));
            }
	    	split.saveView();
	    };
	    buttons.addWidget(save_button);
	
	    var cancel_button = new ox.UI.Button(_("Cancel"));
	    cancel_button.click = function() { split.cancelView(); };
	    buttons.addWidget(cancel_button);
	    
	    //split.disable();
	}
});
/**
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 */

var messagingServices = {
    callbacks: [],
    updateCallbacks: [],
    value: undefined,
    get: function(callback, updateCallback) {
        if (updateCallback) this.updateCallbacks.push(updateCallback);
        if (this.callbacks) {
            this.callbacks.push(callback);
        } else {
            callback(this.value);
        }
    },
    set: function(value) {
        this.value = value;
        if (this.callbacks) {
            for (var i = 0; i < this.callbacks.length; i++) {
                this.callbacks[i](value);
            }
            this.callbacks = null;
        } else {
            for (var i = 0; i < this.updateCallbacks.length; i++) {
                this.updateCallbacks[i](value);
            }
        }
    }
};

function getServices() {
    ox.JSON.get(
        AjaxRoot + "/messaging/service?action=all&session=" + session,
        function(reply) {
            var services = {};
            for (var i = 0; i < reply.data.length; i++) {
                services[reply.data[i].id] = reply.data[i];
            }
            messagingServices.set(services);
        });
}

register("OX_Configuration_Loaded_Complete", function() {
    
    if (!configGetKey("modules.messaging.module")) return;
    
    // VSplit
    register("LanguageChanged", getServices);
    getServices();
    
    var node = new ox.Configuration.LeafNode("configuration/messaging", _("Messaging"));
    var split = new ox.Configuration.VSplit(node,
        _("Social Messaging accounts"), 0.3);
    split.init = function() {
        
        split.list = new LiveGrid([{
            text: _("Account"),
            clear: LiveGrid.makeClear(""),
            set: function(div, data) {
                var name = data.displayName;
                if (trimStr(name) === "") {
                    name = data.messagingService;
                }
                div.firstChild.data = name;
            }
        }], new Selection());
        split.list.emptylivegridtext = _("No Messaging accounts configured.");

        var name = new ox.UI.Input(_("Enter a name"));
        split.addWidget(name, "displayName");
        var form = new ox.Configuration.DynamicForm(_("Select a type"),
            "messagingService", "configuration");
        form.immutableType = true;
        split.addWidget(form, ox.Configuration.Group.NoField);
        messagingServices.get(initForm, initForm);
        function initForm(services) {
            form.setMetadata(services);
        }
        
        // Menu
        
        //menuarrows[node.id] = {};
        var menu = MenuNodes.createSmallButtonContext("messaging.account",
            _("Accounts"));
        MenuNodes.createSmallButton(menu, "messaging.account.add", _("Add"),
            getFullImgSrc("img/menu/add_category.gif"),
            getFullImgSrc("img/menu/add_category_d.gif"),
            function() {
                split.addNew({ displayName: _("New messaging service")
                                });
                setFocus(name.formnode);
            });
        MenuNodes.createSmallButton(menu, "messaging.account.remove",
            _("Remove"),
            getFullImgSrc("img/menu/remove_category.gif"),
            getFullImgSrc("img/menu/remove_category_d.gif"), confirmDelete);
        addMenuNode(menu.node, MenuNodes.FIXED, 31);
        changeDisplay(node.id, "messaging.account");
        
        register("OX_SELECTED_ITEMS_CHANGED", function() {
            var deleteenabled = split.list.selection.count > 0;
            menuglobalzaehler = 0;
            //menuarrows[node.id]["messaging.account"] = [];
            menu_display_contents(node.id, "messaging.account", true,
                "messaging.account.add");
            menu_display_contents(node.id, "messaging.account", deleteenabled,
                "messaging.account.remove");
        });

        function confirmDelete() {
            if (!split.list.selection.count) return;
            //#. Social Messaging accounts
            newConfirm(ngettext("Delete Account", "Delete Accounts",
                                split.list.selection.count),
                //#. Social Messaging accounts
                ngettext(
                    "Are you sure you want to delete the selected account?",
                    "Are you sure you want to delete the selected accounts?",
                    split.list.selection.count),
                AlertPopup.YES | AlertPopup.NO, null, null, handleDelete);
        }
        function handleDelete() {
            var accounts = split.list.selection.getSelected();
            var data = new Array(accounts.length);
            for (var i = 0; i < accounts.length; i++) {
                data[i] = {
                    module: "messaging/account", action: "delete",
                    messagingService: accounts[i].messagingService,
                    id: accounts[i].id
                };
            }
            
            ox.JSON.put(AjaxRoot + "/multiple?session=" + session, data,
                function(reply) {
                    split.list.storage.removeIDs(accounts);
                    ox.api.folder.getSubFolders({ folder: 1, cache: false, success: function() {
                        ox.api.folder.dispatcher.trigger("modify");
                    }});
                });
        }
      
    };
    
    function jsonToData(json) {
        return {
            id: { id: json.id, messagingService: json.messagingService },
            messagingService: json.messagingService,
            displayName: json.displayName,
            configuration: json.configuration
        };
    }
    
    function dataToJson(data) {
        var json = {
            messagingService: data.messagingService,
            displayName: data.displayName,
            configuration: data.configuration
        };
        if (data.id) {
            json.id = data.id.id;
            json.messagingService = data.id.messagingService;
        }
        return json;
    }
    
    function load(id, cont) {
        ox.JSON.get(AjaxRoot +
            "/messaging/account?action=get&messagingService=" +
            id.messagingService + "&id=" + id.id + "&session=" + session,
            function(reply) { cont(jsonToData(reply.data)); });
    }
    
    split.enableList = function() {
        ox.JSON.get(
            AjaxRoot + "/messaging/account?action=all&session=" + session,
            function(reply) {
                var storage = new Storage(0, [], 0, 0, 0,
                    function(id) { return id.messagingService + "/" + id.id; },
                    function(data) { return data.id; });
                var data = new Array(reply.data.length);
                for (var i = 0; i < data.length; i++) {
                    data[i] = jsonToData(reply.data[i]);
                }
                storage.append(data);
                split.list.enable(storage);
            });
    };
        
    split.load = function(cont) {
        messagingServices.get(function(services) {
            load(split.list.selection.getSelected()[0], cont);
        });
    };
    
    split.save = function(data, cont) {
        // check empty fields
        if (data && data.displayName === "") {
            this.children[0].formnode.focus();
            //#. %1$s is the field name.
            //#, c-format
            triggerEvent("OX_New_Error", 4, format(_("The mandatory field %1$s is not defined."), _("Name")));
            cont(data);
            return;
        }
        
        var storage = split.list.storage;
        if ("id" in data) {
            ox.JSON.put(AjaxRoot +
                "/messaging/account/?action=update&session=" + session,
                dataToJson(data),
                function(reply) {
                    load(data.id, function(loadedData) {
                        storage.localUpdate([loadedData.id],
                            function(old) { return loadedData; });
                        ox.api.folder.getSubFolders({ folder: 1, cache: false, success: function() {
                            ox.api.folder.dispatcher.trigger("modify");
                        }});
                        track({
                            type: "update",
                            what: "social_account",
                            data: { id: data.id,
                                messagingService: data.messagingServices,
                                displayName: data.displayName },
                            text: "Updated social-account " + data.id
                        });
                        cont(loadedData);
                    });
                });
        } else {
            ox.JSON.put(AjaxRoot + "/messaging/account/?action=new&session=" +
                session, dataToJson(data),
                function(reply) {
                    load({
                        id: reply.data,
                        messagingService: data.messagingService
                    }, function(loadedData) {
                        storage.append([loadedData]);
                        ox.api.folder.getSubFolders({ folder: 1, cache: false, success: function() {
                            ox.api.folder.dispatcher.trigger("modify");
                        }});
                        track({
                            type: "new",
                            what: "social_account",
                            data: { id: data.id,
                                messagingService: data.messagingServices,
                                displayName: data.displayName },
                            text: "Added social-account " + data.id
                        });
                        cont(loadedData);
                    });
                });
        }
    };
    
});
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var cms_init_bool=false;
var cms_currentsignature=-1;
var cms_signatures=new Array();
var cms_signatureposition;

function ConfigSignatures() {
	this.cbok;
	this.cbcancel;
	this.grid;
	this.storage;
	this.selection = new Selection();
    this.storage = new Storage(0, [], 0, 0, 0, 0, function(data) { return data.id; });    
}
ConfigSignatures.initGrid = function() {
	configsignatures.grid = new LiveGrid([
    { 
        text: "Name",/*i18n*/
        i18n: true,
        clear: LiveGrid.makeClear(""),
        set: function(div, data) {
            if (div.firstChild)
                div.firstChild.data = data.name;
            else
                div.appendChild(document.createTextNode(data.name));
        }
    },
    {
        text: "Place",/*i18n*/
        i18n: true,
        clear: LiveGrid.makeClear(""),
        width: "6em",
        set: function(div, data) {
        	var place = data.place.match(/below/) ? _("below") : _("above");
            if (div.firstChild)
                div.firstChild.data = place;
            else
                div.appendChild(document.createTextNode(place));
        }
    },
    {
        text: "Default",/*i18n*/
        i18n: true,
        clear: LiveGrid.makeClear(""),
        width: "6em",
        set: function(div, data) {
            if (div.firstChild)
                div.firstChild.data = data.isDefault ? _("Yes") : "";
            else
                div.appendChild(document.createTextNode(data.isDefault ? _("Yes") : ""));
        }
    }
    ], configsignatures.selection);
    configsignatures.grid.emptylivegridtext = "";
    configsignatures.grid.events.register("Selected", function() {
    	// get selected signature
    	var ids = configsignatures.grid.selection.getSelected();
    	// clear current preview
    	removeChildNodes($("cms_signatures_preview"));
    	if (ids.length != 0) {
    		var signature_text = cms_signatures[ids[0]].signature_text;
    		// cleanup spaces
    		signature_text = replaceSpaces(signature_text, true);
    		// set content
    		$("cms_signatures_preview").innerHTML = signature_text;
    		// parse links in preview
    	   	parseDirectLinksInMails($("cms_signatures_preview"));
    	}
        ox.ToolBarController.processSelection("signatures", false, ids);
    });
    configsignatures.grid.events.register("Activated", function(ids) {           
            if (ids && ids.length > 0) {
                triggerEvent("OX_Configuration_Edit_Signature");
            }
        }
    );
    
    // add livegrid header and content to dom node
    $("cms_signatures_header").appendChild(configsignatures.grid.getHeader());
    configsignatures.grid.getTable($("cms_signatures_grid"));
}
ConfigSignatures.open = function () {
    ox.api.setModal(true);
	//showNode("modal-dialog");
	//$("modal-dialog").style.display="block";
	showNode("config_popups_win");
	$("config_popups_win").style.display="block";
	showNode("window_signature");
	centerPopupWindow($("window_signature"));
	$("window_signature").style.display="block";
}
ConfigSignatures.close = function () {
	if (this.closecb) { globalalert.cbclose(); }
	hideNode("window_signature");
	$("window_signature").style.display="none";
	hideNode("config_popups_win");
	$("config_popups_win").style.display="none";
	ox.api.setModal(false);
	//hideNode("modal-dialog");
	var childs=	$("modal-dialog").childNodes;
	var closeall=true;
	for(var i=0;i<childs.length;i++) {
		if(childs[i].tagName && childs[i].tagName == "DIV") {
			if(childs[i].style.display && childs[i].style.display!= "none" ) {
				closeall=false;
			}
		}
	}
	if(closeall) {
	    ox.api.setModal(false);
		//$("modal-dialog").style.display="none";
	}
	if (configsignatures.grid && configsignatures.grid.focus != undefined) {
		setFocus($("cms_signatures_grid"));
		configsignatures.grid.selection.click(configsignatures.grid.focus);
		configsignatures.grid.showFocus();
	}
}
ConfigSignatures.commitcancel = function () {
	if(configsignatures.cbcancel) { 
		if(configsignatures.cbcancel()) {
			ConfigSignatures.close();
		}
	} else { 
		ConfigSignatures.close(); 
	}
}
ConfigSignatures.commitok = function () {
	if(configsignatures.cbok) { 
		if(configsignatures.cbok()) {
			ConfigSignatures.close();
		}
	} else { 
		ConfigSignatures.close(); 
	}
}

register("Loaded", function () {
	addOnClose($("window_signature"), 
	   function() {
	   	   ConfigSignatures.close() 
	   }
	); 
});

var configsignatures=new ConfigSignatures();

function openSignatureWindow(sig_name,sig_place,sig_signature,sig_default,cbok,cbcancel) {
	$("signature_window_signature_name").value=sig_name;
	setFocus($("signature_window_signature_name"));	
	cms_signatureposition.setKey(sig_place);
	$("cms_signaturetext").value=sig_signature;
	$("signature_default").checked=sig_default;
	configsignatures.cbok=cbok;
	configsignatures.cbcancel=cbcancel;
	ConfigSignatures.open();
} 

registerView("configuration/mail/signatures",
	function () { 
		showNode("config_mail_signatures"); 
		$("config_mail_signatures").style.display="block";
        
        // toolbar
        if (!configToolbars.signatures) {
            configToolbars.signatures = temporary.configuration.newToolbar(
                _("Signatures"), [
                    temporary.configuration.saveButton,
                    {
                        title: _("Signatures"),
                        id: "signatures",
                        buttons: [{
                            title: _("Add"),
                            id: "add",
                            icons: ["img/menu/add_signature.gif",
                                    "img/menu/add_signature_d.gif"],
                            event: "OX_Configuration_Add_Signature"
                        }, {
                            title: _("Edit"),
                            id: "edit",
                            icons: ["img/menu/edit.gif", "img/menu/edit_d.gif"],
                            event: "OX_Configuration_Edit_Signature",
                            selection: "signatures",
                            requires: ["one"]
                        }, {
                            title: _("Remove"),
                            id: "remove",
                            icons: ["img/menu/remove_signature.gif",
                                    "img/menu/remove_signature_d.gif"],
                            event: "OX_Configuration_Remove_Signature",
                            selection: "signatures",
                            requires: ["some"]
                        }]
                    }
                ], "signatures");
        }
        temporary.configuration.showToolbar(configToolbars.signatures);
    },
	function() { 
		register("OX_Configuration_Add_Signature",cms_addSignature);
		register("OX_Configuration_Edit_Signature",cms_editSignature);
		register("OX_Configuration_Remove_Signature",cms_removeSignature);
 		register("OX_SAVE_OBJECT",cms_saveConfiguration);
		register("OX_Cancel_Object",cms_cancelConfiguration);
		cms_enter();
		if (!configsignatures.grid) {
			ConfigSignatures.initGrid();
		}
		configsignatures.grid.enable(configsignatures.storage);
	},
	function() {
		//configuration_askforSave();
		unregister("OX_Configuration_Add_Signature",cms_addSignature);
		unregister("OX_Configuration_Edit_Signature",cms_editSignature);
		unregister("OX_Configuration_Remove_Signature",cms_removeSignature);
 		unregister("OX_SAVE_OBJECT",cms_saveConfiguration);
		unregister("OX_Cancel_Object",cms_cancelConfiguration);
		configsignatures.grid.disable();
		cms_leave();
	},
	function () { 
		hideNode("config_mail_signatures"); 
		$("config_mail_signatures").style.display="none"; 
	},
	null
);

function checkDuplicateSignatures(myname) {
	for(var i=0;i<cms_signatures.length;i++) {
		if(cms_signatures[i].signature_name==myname) return true;
	}
	return false;
}
function cms_enter() {
	if(!cms_init_bool) {
		cms_init();
		cms_init_bool=true;
	}
	cms_signatures = new Array();
	// prevent JS error when signature isn't an array, try to reconvert it
    if (ox.api.config.contains("gui.mail.signatures")) {
        cms_signatures = ox.api.config.get("gui.mail.signatures");
        if (jQuery.isArray(cms_signatures) === false) {
            cms_signatures = ObjectToArray(cms_signatures);
        }
    }
	cms_fillSignature();	
	setConfigPath($("cms_header"));
}
function cms_init() {
	cms_signatureposition= new ComboBox3(window, "cms_signatureposition", "95%", 1, true,"OX_Configuration_Mail_Signatures_Position_Changed", null);
	var key="below";
	var key2="above"
    cms_signatureposition.addElement(_("Above the text"), key2);
    cms_signatureposition.addElement(_("Below the text"), key);
	cms_signatureposition.getDomNode();
}
function cms_fillSignature() {
	configsignatures.storage.remove(0, configsignatures.storage.ids.length);
	for (var i=0; i<cms_signatures.length; i++) {
        var sig_name = cms_signatures[i].signature_name.length == 0 ? _("Unnamed signature")  : cms_signatures[i].signature_name;       
        configsignatures.storage.append([{ id: i, name: sig_name, place: cms_signatures[i].position, isDefault: cms_signatures[i].signature_default }]);     
    }
    ox.ToolBarController.processSelection("signatures", false, []);
}
function cms_editSignature() {	
	cms_currentsignature = configsignatures.grid.selection.getSelected()[0];	
	openSignatureWindow(cms_signatures[cms_currentsignature].signature_name,cms_signatures[cms_currentsignature].position,cms_signatures[cms_currentsignature].signature_text,cms_signatures[cms_currentsignature].signature_default,cms_changeSignature);
}
function cms_changeSignature() {
	var myobject=new Object();
	if (trimStr($("signature_window_signature_name").value).length == 0) {
        newAlert(_("Invalid Signature"),_("Please enter a name")); /*i18n*/
        $("signature_window_signature_name").focus();
        return false;
    } else if (checkDuplicateSignatures(trimStr($("signature_window_signature_name").value))) {
		if(cms_signatures[cms_currentsignature].signature_name != trimStr($("signature_window_signature_name").value)) {
			newAlert(_("Invalid Signature"),_("This Signature name already exists")); /*i18n*/
			$("signature_window_signature_name").focus();
			return false;		
		}
	}
	myobject.signature_name=trimStr($("signature_window_signature_name").value);
	myobject.position=cms_signatureposition.getKey();
	myobject.signature_text=$("cms_signaturetext").value;
	myobject.signature_default=$("signature_default").checked;
	if(myobject.signature_default) {
		for(var i=0;i<cms_signatures.length;i++) {
			cms_signatures[i].signature_default=false;
		}	
	}
	cms_signatures[cms_currentsignature]=myobject;
	configuration_changed_fields["gui"]=true;
	cms_fillSignature();
	return true;
	
}
function cms_addSignature() {	
	var zaehler=0;
	var sig_name=_("New Signature");
	if (checkDuplicateSignatures(sig_name)) { zaehler=2; }
	while (checkDuplicateSignatures(sig_name+" ("+zaehler+")")) {
		zaehler ++;
	}
	if(zaehler!=0) {
		sig_name=sig_name+" ("+zaehler+")";
	}
	var sig_place="below";
	var sig_signature="";
	var sig_default=false;
	openSignatureWindow(sig_name,sig_place,sig_signature,sig_default,cms_newSignature);
	configuration_changed_fields["gui"]=true;
}
function cms_newSignature() {	
	var myobject=new Object();
	if (trimStr($("signature_window_signature_name").value).length == 0) {
        newAlert(_("Invalid Signature"),_("Please enter a name")); /*i18n*/
        $("signature_window_signature_name").focus();
        return false;
    } else if (!checkDuplicateSignatures(trimStr($("signature_window_signature_name").value))) {
		myobject.signature_name=trimStr($("signature_window_signature_name").value);
		myobject.position=cms_signatureposition.getKey();
		myobject.signature_text=$("cms_signaturetext").value;
		myobject.signature_default=$("signature_default").checked;
		if(myobject.signature_default) {
			for(var i=0;i<cms_signatures.length;i++) {
				cms_signatures[i].signature_default=false;
			}	
		}
	} else {
		newAlert(_("Invalid Signature"),_("This Signature name already exists"));
		$("signature_window_signature_name").focus();
		return false;
	}
	cms_signatures.push(myobject);
	configuration_changed_fields["gui"]=true;
	cms_fillSignature();
	return true;
}
function cms_removeSignature() {
	for (var i=0; i<configsignatures.grid.selection.getSelected().length; i++) {
	   cms_signatures.splice(configsignatures.grid.selection.getSelected()[i], 1);
	}
	cms_fillSignature();
	configuration_changed_fields["gui"]=true;
}
function cms_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
		configSetKey("gui.mail.signatures",cms_signatures);
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function cms_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cms_enter();	
}
function cms_leave() { }
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/calendar/preferences",
	function () { 
		showNode("config_calendar"); 
		$("config_calendar").style.display="block";
        
		// toolbar
        temporary.configuration.showToolbar(
            temporary.configuration.defaultToolbar);
    },
	function () { 
		register("OX_SAVE_OBJECT",cc_saveConfiguration);
		register("OX_Cancel_Object",cc_cancelConfiguration);
		cc_enter(); 
		},
	function () { 
		unregister("OX_SAVE_OBJECT",cc_saveConfiguration);
		unregister("OX_Cancel_Object",cc_cancelConfiguration);
		},
	function () { 
		hideNode("config_calendar"); 
		$("config_calendar").style.display="none";
    },
	cc_enter
);

function cc_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
		configSetKey("gui.calendar.interval",cc_interval.getKey());
		
		configSetKey("gui.calendar.default_reminder",cc_default_reminder.getKey());
		
		configSetKey("gui.calendar.starttime",cc_work_start.getKey());
		configSetKey("gui.calendar.endtime",cc_work_end.getKey());
        cc_default_view_data.view = cc_default_view.getKey();
        cc_default_view_data.calendar = cc_calendar_time_range.getKey();
        cc_default_view_data.team = cc_team_time_range.getKey();
        cc_default_view_data.list = cc_list_time_range.getKey();
        cc_default_view_data.shared = getValueofRadioBox("cc_shared_time_range") ? true : false;
		configSetKey("gui.calendar.views", cc_default_view_data);
		configSetKey("gui.calendar.view", getDefaultCalendarView());
		configSetKey("gui.global.confirmpopup",getBoolofInt(getValueofRadioBox("cs_confirmpopup")));
		
		configSetKey("gui.calendar.day.numberofappointments",cc_countappointmentday.getKey());
		configSetKey("gui.calendar.workweek.numberofappointments",cc_countappointmentww.getKey());
		configSetKey("gui.calendar.workweek.startday",cc_startdayofworkweek.getKey());
		configSetKey("gui.calendar.workweek.countdays",cc_daysinworkweek.getKey());
		configSetKey("gui.calendar.custom.countdays",cc_daysincustom.getKey());
		configSetKey("gui.calendar.custom.numberofappointments",cc_countappointmentcustom.getKey());

		configSetKey("gui.calendar.autoadd_participant_public",getBoolofInt(getValueofRadioBox("cs_calendar_add_participant_public")));	

		configSetKey("gui.effects.hover.calendar",getBoolofInt(getValueofRadioBox("cc_enablehovercalendar")));	

		// Hide non-working time in teamview
		configSetKey("gui.calendar.teamview.workingTimeOnly", getBoolofInt(getValueofRadioBox("cc_teamWorkingTimeOnly")));
		
		menulastviews.calendar = getDefaultCalendarView();
        lastCalendarTimeRanges.calendar = cc_default_view_data.calendar;
        lastCalendarTimeRanges.team = cc_default_view_data.team;
        lastCalendarTimeRanges.list = cc_default_view_data.list;
	}
	if (configuration_changed_fields["modules"]) {
		configSetKey("modules.calendar.defaultStatusPrivate",cc_defaultstatusprivate.getKey());
		configSetKey("modules.calendar.defaultStatusPublic",cc_defaultstatuspublic.getKey());
	}

	/*
     * store notification settings to config, if changed 
     */
    if (configuration_changed_fields["calendarnotification"]) {
        configSetKey("modules.calendar.notifyNewModifiedDeleted",getBoolofInt(getValueofRadioBox("cs_calendarnotification_0")));   
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsCreator",getBoolofInt(getValueofRadioBox("cs_calendarnotification_1")));
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant",getBoolofInt(getValueofRadioBox("cs_calendarnotification_2")));
    }
	
	triggerEvent("OX_Save_Configuration",false,false);
}
function cc_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cc_enter();
}
var cc_init_bool=false;
var cc_interval;
var cc_default_reminder;
var cc_work_start;
var cc_work_end;
var cc_countappointmentww,cc_countappointmentday,cc_countappointmentcustom,cc_daysinworkweek,cc_daysincustom,cc_startdayofworkweek,cc_defaultstatusprivate,cc_defaultstatuspublic;
var cc_default_view_data;
var cc_default_view;
var cc_calendar_time_range, cc_team_time_range, cc_list_time_range;

function cc_team_view_upsell() {
    if (!configGetKey('modules.calendar.calendar_teamview')) {
        triggerEvent("Feature_Not_Available", "modules/calendar/team", window);
    }
}

function cc_enter() {
	if(!cc_init_bool) {
		cc_init();
		cc_init_bool=true;
	}
	if(configContainsKey("gui.calendar.interval")) {
		cc_interval.setKey(configGetKey("gui.calendar.interval"));
		configuration_changed_fields["gui"]=false;
	}
	
	if(configContainsKey("gui.calendar.default_reminder")) {
		cc_default_reminder.setKey(configGetKey("gui.calendar.default_reminder"));
		configuration_changed_fields["gui"]=false;
	}
	
	if(configContainsKey("gui.calendar.starttime")) {
		cc_work_start.setKey(configGetKey("gui.calendar.starttime"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.endtime")) {
		cc_work_end.setKey(configGetKey("gui.calendar.endtime"));
		configuration_changed_fields["gui"]=false;
	}
	if(   configContainsKey("gui.calendar.views")
	   || configContainsKey("gui.calendar.view"))
	{
        cc_default_view_data = configGetKey("gui.calendar.views");
        if (!cc_default_view_data) {
            cc_default_view_data = configGetKey("gui.calendar.view");
            if (   !cc_default_view_data
                || typeof cc_default_view_data != "object")
            {
                var match = /^calendar\/([^\/]+)\/([^\/]+)$/.exec(
                    cc_default_view_data) || [, "calendar", "day"];
                cc_default_view_data = { view: match[1], calendar: match[2],
                    team: match[2], list: match[2], shared: true };
            }
        }
        cc_default_view.setKey(cc_default_view_data.view);
        cc_calendar_time_range.setKey(cc_default_view_data.calendar);
        cc_team_time_range.setKey(cc_default_view_data.team);
        cc_list_time_range.setKey(cc_default_view_data.list);
        setValueofRadioBox("cc_shared_time_range", cc_default_view_data.shared);
        configuration_changed_fields["gui"]=false;
        var hasTeam = configGetKey('modules.calendar.calendar_teamview');
        ox.UI.Widget.setDisabledClass($("cc_team_time_range_label"), !hasTeam);
        cc_team_time_range[hasTeam ? "enable" : "disable"]();
	}
	if(configContainsKey("gui.global.confirmpopup")) {
		setValueofRadioBox("cs_confirmpopup",configGetKey("gui.global.confirmpopup"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.interval")) {
		cc_interval.setKey(configGetKey("gui.calendar.interval"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.day.numberofappointments")) {
		cc_countappointmentday.setKey(configGetKey("gui.calendar.day.numberofappointments"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.workweek.numberofappointments")) {
		cc_countappointmentww.setKey(configGetKey("gui.calendar.workweek.numberofappointments"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.workweek.startday")) {
		cc_startdayofworkweek.setKey(configGetKey("gui.calendar.workweek.startday"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.workweek.countdays")) {
		cc_daysinworkweek.setKey(configGetKey("gui.calendar.workweek.countdays"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.custom.countdays")) {
		cc_daysincustom.setKey(configGetKey("gui.calendar.custom.countdays"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.calendar.custom.numberofappointments")) {
		cc_countappointmentcustom.setKey(configGetKey("gui.calendar.custom.numberofappointments"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("modules.calendar.defaultStatusPrivate")) {
		cc_defaultstatusprivate.setKey(configGetKey("modules.calendar.defaultStatusPrivate"));
		configuration_changed_fields["modules"]=false;
	}
	if(configContainsKey("modules.calendar.defaultStatusPublic")) {
		cc_defaultstatuspublic.setKey(configGetKey("modules.calendar.defaultStatusPublic"));
		configuration_changed_fields["modules"]=false;
	}

	if(configContainsKey("gui.effects.hover.calendar")) {
		setIntofRadioBox("cc_enablehovercalendar",configGetKey("gui.effects.hover.calendar"));
		configuration_changed_fields["gui"]=false;
	}
	
    if(configContainsKey("gui.calendar.teamview.workingTimeOnly")) {
        setIntofRadioBox("cc_teamWorkingTimeOnly", configGetKey("gui.calendar.teamview.workingTimeOnly"));
        configuration_changed_fields["gui"] = false;
    }
    
	if(configContainsKey("gui.calendar.autoadd_participant_public")) {
		setIntofRadioBox("cs_calendar_add_participant_public",configGetKey("gui.calendar.autoadd_participant_public"));
		configuration_changed_fields["gui"]=false;
	}
	if (configContainsKey("modules.calendar.notifyNewModifiedDeleted")) {
        setValueofRadioBox("cs_calendarnotification_0",configGetKey("modules.calendar.notifyNewModifiedDeleted"));
        configuration_changed_fields["calendarnotification"]=false;
    }
    if (configContainsKey("modules.calendar.notifyAcceptedDeclinedAsCreator")) {
        setValueofRadioBox("cs_calendarnotification_1",configGetKey("modules.calendar.notifyAcceptedDeclinedAsCreator"));
        configuration_changed_fields["calendarnotification"]=false;
    }
    if (configContainsKey("modules.calendar.notifyAcceptedDeclinedAsParticipant")) {
        setValueofRadioBox("cs_calendarnotification_2",configGetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant"));
        configuration_changed_fields["calendarnotification"]=false;
    }
	setConfigPath($("cc_header"));	
}

register("OX_Configuration_Loaded",cc_onconfigload);
function cc_onconfigload() {
    addDefaultView("calendar/calendar/day", true);
    addDefaultView("calendar/calendar/workweek", true);
    addDefaultView("calendar/calendar/month", true);
    addDefaultView("calendar/calendar/week", true);
    addDefaultView("calendar/calendar/custom", true);
    if (   configGetKey("modules.calendar.calendar_freebusy")
        && configGetKey("modules.calendar.calendar_teamview"))
    {
        addDefaultView("calendar/team/day", true);
        addDefaultView("calendar/team/workweek", true);
        addDefaultView("calendar/team/month", true);
        addDefaultView("calendar/team/week", true);
        addDefaultView("calendar/team/custom", true);
    }
    addDefaultView("calendar/list/day", true);
    addDefaultView("calendar/list/workweek", true);
    addDefaultView("calendar/list/month", true);
    addDefaultView("calendar/list/week", true);
    addDefaultView("calendar/list/custom", true);
}

 
function cc_init() {
	cc_interval= new ComboBox3(window, "cc_interval", "11em", 1, true,"OX_Configuration_GUI_Changed", null);
	cc_interval.addElement(noI18n("5"),5);
	cc_interval.addElement(noI18n("10"),10);
	cc_interval.addElement(noI18n("15"),15);
	cc_interval.addElement(noI18n("20"),20);
	cc_interval.addElement(noI18n("30"),30);
	cc_interval.addElement(noI18n("60"),60);
	cc_interval.getDomNode();	
	
	var timearray=["00:00","01:00","02:00","03:00","04:00","05:00","06:00","07:00","08:00","09:00","10:00","11:00","12:00","13:00","14:00","15:00","16:00","17:00","18:00","19:00","20:00","21:00","22:00","23:00"];
	
	var h = 60, d = 1440, w = 10080; // minutes per hour, day and week
    var cc_reminder_intervals = [0, 15, 30, 45, 1*h, 2*h, 4*h, 6*h, 8*h, 12*h,1*d, 2*d, 3*d, 4*d, 5*d, 6*d, 1*w, 2*w, 3*w, 4*w];
	cc_default_reminder = new ComboBox3(window, "cc_reminder_status", "11em", 2, true, "OX_Configuration_GUI_Changed", 5);
	cc_default_reminder.addElement(_("no reminder"), "-1");
    for (var i = 0; i < cc_reminder_intervals.length; i++) {
        cc_default_reminder.addElement(
            getInterval(cc_reminder_intervals[i] * 6e4), // ms / min
            cc_reminder_intervals[i]);
    }
    cc_default_reminder.getDomNode();
	
	
	cc_work_start= new ComboBox3(window, "cc_work_start", "11em", 1, true,"cf_wtimechanged", 5, "start");
	for(var i=0;i<timearray.length;i++) {
        cc_work_start.addElement(
            formatDate(new Date(Date.UTC(2000,1,1,i,0,0)), "time"), i);
	}
	cc_work_start.getDomNode();	
	cc_work_end= new ComboBox3(window, "cc_work_end", "11em", 1, true,"cf_wtimechanged", 5, "end");
	for(var i=0;i<timearray.length;i++) {
        cc_work_end.addElement(
            formatDate(new Date(Date.UTC(2000,1,1,i,0,0)), "time"), i);
	}
	cc_work_end.getDomNode();
	
	// adjust working start and end time
	register("cf_wtimechanged", function(value, type) {
	    var start = cc_work_start.getKey();
	    var end = cc_work_end.getKey();
	    if (type == "start")  {
	        if (start == 23) {
	            cc_work_start.setKey(22);
	        } else if (start > end) {
	            cc_work_end.setKey(start+1);
	        }
	    } else {
	        if (end == 0) {
                cc_work_end.setKey(1);
            } else if (end < start) {
                cc_work_start.setKey(end-1);
            }
	    }
	    triggerEvent("OX_Configuration_GUI_Changed");
	});
	
    cc_default_view = new ComboBox3(window, "cc_default_view", "11em", 1, true, "OX_Configuration_GUI_Changed", 3);
    cc_default_view.addElement(_("Calendar"), "calendar");
    cc_default_view.addElement(_("Team"), "team");
    cc_default_view.addElement(_("List"), "list");
    cc_default_view.getDomNode();
    cc_calendar_time_range = new ComboBox3(window, "cc_calendar_time_range", "11em", 1, true, "OX_Configuration_GUI_Changed", 5);
    cc_team_time_range = new ComboBox3(window, "cc_team_time_range", "11em", 1, true, "OX_Configuration_GUI_Changed", 5);
    cc_list_time_range = new ComboBox3(window, "cc_list_time_range", "11em", 1, true, "OX_Configuration_GUI_Changed", 5);
	var time_ranges = ["day", "workweek", "month", "week", "custom"];
    var range_names = [_("Day"), _("Work Week"), _("Month"), _("Week"),
                       _("Custom")];
    for (var i = 0; i < time_ranges.length; i++) {
        cc_calendar_time_range.addElement(range_names[i], time_ranges[i]);
        cc_team_time_range.addElement(range_names[i], time_ranges[i]);
        cc_list_time_range.addElement(range_names[i], time_ranges[i]);
	}
    cc_calendar_time_range.getDomNode();
    cc_team_time_range.getDomNode();
    cc_list_time_range.getDomNode();
    
	cc_countappointmentww= new ComboBox3(window, "cc_countappointmentww", "11em", 1, true,"OX_Configuration_GUI_Changed", 5);
	cc_countappointmentday= new ComboBox3(window, "cc_countappointmentday", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_countappointmentcustom= new ComboBox3(window, "cc_countappointmentcustom", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_daysinworkweek= new ComboBox3(window, "cc_daysinworkweek", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_daysincustom= new ComboBox3(window, "cc_daysincustom", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	cc_startdayofworkweek= new ComboBox3(window, "cc_startdayofworkweek", "11em",1, true,"OX_Configuration_GUI_Changed", 5);
	for (var i2=1;i2<=8;i2++) {
        cc_countappointmentcustom.addElement(noI18n(i2),i2);
        cc_countappointmentww.addElement(noI18n(i2),i2);
        cc_countappointmentday.addElement(noI18n(i2),i2);
	}
	for (var i2=1;i2<=7;i2++) {
        cc_daysinworkweek.addElement(noI18n(i2),i2);
        cc_daysincustom.addElement(noI18n(i2),i2);
	}
	for (var i2=0;i2<weekdays.untranslated.length;i2++) {
		cc_startdayofworkweek.addElement(_(weekdays.untranslated[i2]), i2);
	}
	
	cc_defaultstatusprivate= new ComboBox3(window, "cc_defaultstatusprivate", "11em",1, true,"OX_Configuration_Settings_Changed_Modules", 3);
	cc_defaultstatuspublic= new ComboBox3(window, "cc_defaultstatuspublic", "11em",1, true,"OX_Configuration_Settings_Changed_Modules", 3);
	
    cc_defaultstatusprivate.addElement(_("waiting"), 0);
    cc_defaultstatusprivate.addElement(_("accepted"), 1);
    cc_defaultstatusprivate.addElement(_("tentative"), 3);
    
    cc_defaultstatuspublic.addElement(_("waiting"), 0);
    cc_defaultstatuspublic.addElement(_("accepted"), 1);
    cc_defaultstatuspublic.addElement(_("tentative"), 3);

	
	cc_countappointmentday.getDomNode();
	cc_daysinworkweek.getDomNode();
	cc_startdayofworkweek.getDomNode();
	cc_countappointmentww.getDomNode();
	cc_daysincustom.getDomNode();
	cc_countappointmentcustom.getDomNode();
	cc_defaultstatusprivate.getDomNode();
	cc_defaultstatuspublic.getDomNode();	
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

var oCi_import_data = null;
var importDataFolderTree = null;
var importFolderId = -1;
var importFolderDestination = null;

register("Loaded", function () {
	addOnClose($("window_import_status"), function() { oCi_import_data.closeWindow(); }); 
});

registerView("configuration/import",
	function () { 
		showNode("config_import"); 
		$("config_import").style.display="block";
        
        // toolbar
        if (!configToolbars.configImport) {
            configToolbars.configImport = temporary.configuration.newToolbar(
                _("Import"),
                [{
                    title: _("Import"),
                    id: "import",
                    buttons: [{
                        title: _("Import"),
                        id: "import",
                        icons: ["img/menu/img_import.gif"],
                        big: true,
                        event: "OX_SAVE_OBJECT"
                    }]
                }], "import"
            );
        }
        temporary.configuration.showToolbar(configToolbars.configImport);
    },
	function() { 		
        oCi_import_data = new Ci_import_data();
        oCi_import_data.createCombobox();
        oCi_import_data.init();
		register("OX_SAVE_OBJECT",uploadImportData);
	},
	function() {
		unregister("OX_SAVE_OBJECT",uploadImportData);
		unregister("cb_importComboChanged",cb_importComboChanged);
		unregister('cb_importComboCSVChanged', cb_importComboCSVChanged);
	},
	function () {
		hideNode("config_import"); 
		$("config_import").style.display="none"; 
		oCi_import_data.closeWindow();
	},
	null
);

function uploadImportData() {
	if (!oCi_import_data.process) {
	    oCi_import_data.uploadData();
	}
}

function Ci_import_data() {
	this.action = "ICAL";
	this.folder = configGetKey("folder.calendar");
	this.combobox = null;
	this.process = false;
	$("fileImportInput").disabled = false;
	setConfigPath($("cimp_header"));
}

function cb_importComboChanged() {
	if (oCi_import_data.action == "ICAL") {
		oCi_import_data.changeStatus("ical");
	}
}

function cb_importComboCSVChanged() {
	if (oCi_import_data.action == "CSV" 
	    || oCi_import_data.action == "OUTLOOK_CSV") {
		oCi_import_data.changeStatus("csv");
	}
}

Ci_import_data.prototype = {
        
    init: function() {
        // when no task or calendar module is available it needs to be disabled
        if (ox.api.config.get("modules.calendar.module", false) === false
                && ox.api.config.get("modules.tasks.module", false) === false) {
            $("cs_import_ical").disabled = "disabled";
            // select vcard then
            oCi_import_data.changeStatus("vcard");
            
        } else {
            // default
            oCi_import_data.changeStatus("ical");
            
            // anything else we should pre-select?
            if ("module" in (importFolderDestination || {})) {
                var module = importFolderDestination.module;
                var type = importFolderDestination.file_type;
                if (module === "contacts") {
                    if (type === "csv") {
                        oCi_import_data.changeStatus("csv");
                    } else {
                        oCi_import_data.changeStatus("vcard");
                    }
                }
            }
        }
        oCi_import_data.form = $('form_config_import');
        oCi_import_data.form.file.value = "";
    },
    
	uploadData : function() {	
		this.form = $('form_config_import');
		this.uri = AjaxRoot + "/import?action=" + this.action + "&session=" + session + "&folder=" + importFolderId;	
		this.form.action = this.uri; 
		this.form.target="dlIframe";
		if(this.form.file.value=="") {
			triggerEvent("OX_New_Error", 4, _("Please select a file to import"));
		} else {
			this.process = true;
			this.form.submit();
			$("fileImportInput").disabled = true;
		}
	},
	
	createCombobox : function() {
		var cbText = new Array();
        cbText[0] = _("Appointments");
        cbText[1] = _("Tasks");
        cbText[2] = _("Comma Separated");
        cbText[3] = _("Outlook file");
		this.combobox = new ComboBox3(window, "import.combobox.module", "20em", 
			0, true, "cb_importComboChanged", null);
		if (ox.api.config.get("modules.calendar.module", false) === true) {
		    this.combobox.addElement(cbText[0],"calendar");
		}
		if (ox.api.config.get("modules.tasks.module", false) === true) {
		    this.combobox.addElement(cbText[1],"tasks");
		}
		// disable if both modules are not available
		if (ox.api.config.get("modules.calendar.module", false) === false
		        && ox.api.config.get("modules.tasks.module", false) === false) {
		    this.combobox.addElement(cbText[0],"calendar"); // fake item so it is not empty
		    this.combobox.disable();
		}
		this.combobox.getDomNode();
		register('cb_importComboChanged', cb_importComboChanged);
		this.comboboxCSV = new ComboBox3(window, "import.combobox.csv", "20em", 
			0, true, "cb_importComboCSVChanged", null);
		this.comboboxCSV.addElement(cbText[2],"CSV");
		this.comboboxCSV.addElement(cbText[3],"OUTLOOK_CSV");
		this.comboboxCSV.getDomNode();
		this.comboboxCSV.disable();
		register('cb_importComboCSVChanged', cb_importComboCSVChanged);
		
		if ("id" in (importFolderDestination || {})) {
			setFolder(importFolderDestination.id);
		} else {
			setFolder(configGetKey("folder.calendar") || configGetKey("folder.contacts"));
		}
	},
	
	openWindow: function() {
	    ox.api.setModal(true);
		//showNode("modal-dialog");
		//$("modal-dialog").style.display="block";
		showNode("config_popups_win");
		$("config_popups_win").style.display="block";
		showNode("window_import_status");
		centerPopupWindow($("window_import_status"),610, 320);
		$("window_import_status").style.display="block";
	}, 
	
	closeWindow: function() {
		hideNode("window_import_status");
		$("window_import_status").style.display="none";
		hideNode("config_popups_win");
		$("config_popups_win").style.display="none";
		ox.api.setModal(false);
		//hideNode("modal-dialog");
		var childs=	$("modal-dialog").childNodes;
		var closeall=true;
		for(var i=0;i<childs.length;i++) {
			if(childs[i].tagName && childs[i].tagName == "DIV") {
				if(childs[i].style.display && childs[i].style.display!= "none" ) {
					closeall=false;
				}
			}
		}
		if(closeall) {
		    ox.api.setModal(false);
			//$("modal-dialog").style.display="none";
		}
		$("cms_import_status").firstChild.data = "";
		$("cms_import_log").value = "";
		oCi_import_data.init();
	},
	
	changeStatus : function(suffix) {
		var Self = this;
		$('cs_import_' + suffix).checked = true;
		
		switch(suffix) {
			case 'ical'		 	: 	Self.action = "ICAL";
									
									Self.combobox.enable();
									Self.comboboxCSV.disable();
									
									Self.folder = configGetKey("folder." + Self.combobox.getKey());
									
									break;
				
			case 'vcard' 		: 	Self.action = "VCARD";
									
									Self.combobox.disable();
									Self.comboboxCSV.disable();
									
									Self.folder = configGetKey("folder.contacts");
									
									break;
			
			case 'csv' 			:   Self.action = Self.comboboxCSV.getKey();
									
									Self.comboboxCSV.enable();
									Self.combobox.disable();
									
									Self.folder = configGetKey("folder.contacts");
									
									break;
		}
		
		if (importFolderDestination != null) {
		    if (importFolderDestination.id) {
	            setFolder(importFolderDestination.id);
	        }
		    var module = importFolderDestination.module;
            if (module && module !== "contacts") {
                oCi_import_data.combobox.setKey(module);
            }
            module = null;
		} else {
		    setFolder(Self.folder);
		}
	}
};

function import_getWarningsAsString(warnings) {
    var retVal = [];
    for (var i = 0; i < warnings.length; i++) {
        //#. Format string for warnings. The difference to the default
        //#. is that it doesn't have "Error:" at the beginning.
        //#. %1$s is the error code.
        //#. %2$s is the formatted error message.
        //#. %3$s is the unique error ID.
        //#, c-format
        retVal.push(formatError(warnings[i], "%2$s (%1$s, %3$s)"/*i18n*/) + "\n");
    }
    return retVal.join();
}

var callback_import = callback_ICAL = callback_VCARD = callback_CSV = callback_OUTLOOK_CSV = function (arg) {
	oCi_import_data.process = false;
	$("fileImportInput").disabled = false;
	if ($("cms_import_status")) $("cms_import_status").firstChild.data = "";
	if (arg.error) {
		newServerError(arg);
	} else if (arg.data && arg.data.length != 0) {
		var successfullImported = 0;
		var importLog = "";
		
		for (var i=0; i<arg.data.length; i++) {
			if (arg.data[i].error) {
	            //#. Format string for warnings. The difference to the default
			    //#. is that it doesn't have "Error:" at the beginning.
                //#. %1$s is the error code.
                //#. %2$s is the formatted error message.
                //#. %3$s is the unique error ID.
                //#, c-format
				importLog += formatError(arg.data[i], "%2$s (%1$s, %3$s)"/*i18n*/) + "\n";
				if (arg.data[i].warnings && arg.data[i].warnings.length) {
					importLog += import_getWarningsAsString(arg.data[i].warnings);
				}
				if (arg.data[i].category && arg.data[i].category == 13){
				    successfullImported++;
				}
			} else if (arg.data[i].warnings && arg.data[i].warnings.length) {
                importLog += import_getWarningsAsString(arg.data[i].warnings);
            } else {
				successfullImported++;
			}
		}
		
		$("cms_import_log").value = importLog.length != 0 ? importLog : _("None");
		//#. %d is the number of successfully imported data records
		//#, c-format
		$("cms_import_status").firstChild.data = format(_("Successfully imported: %d"), successfullImported);
		oCi_import_data.openWindow();
		
		// invalidating caches to force an update only
		// if at least one object successfully imported
		if (importFolderId != successfullImported != 0) {
		    // interating through all collections trying to find
	        // anything bound to the destination folder
            for (var i in OXCache.cachedCollections.cache) {
                var col = OXCache.cachedCollections.cache[i].data;
                if (col.criteria && col.criteria.folder_id === importFolderId)  {
                    col.modified=true;
                    col.check=true;
                }
            }
		}
	} else {
		oCi_import_data.closeWindow();
		triggerEvent("OX_New_Error", 4, _("Internal Error: The server didn't provide any data."));
	}
}

function toggleConfigTree(){
	if (document.getElementsByName('cs_import_type')[0].checked == true){
		clickedItem = configGetKey("folder.calendar");
	} else {
		clickedItem = configGetKey("folder.contacts");
	}
	
	initImportTree();
	
	if ($("TreeDialogImportForlder").style.display == "none"){
		centerPopupWindow($("TreeDialogImportForlder"));
		$("TreeDialogImportForlder").style.display = "block";
		$("TreeDialogImportForlder").style.top = "230px";
		$("TreeDialogImportForlder").style.left = "420px";
	}else{
		$("TreeDialogImportForlder").style.display = "none";
	}
		
}

function initImportTree() {
	importDataFolderTree = null;
	removeChildNodes($("folder_tree_info"));
	
	var type = "contacts";
	if (document.getElementsByName('cs_import_type')[0].checked == true){
		if (oCi_import_data.combobox.getKey() == "calendar"){
			type = "calendar";
		} else {
			type = "tasks";
		}
	}

	ox.api.ui.selectFolder({
    	type: type,
    	id: "select-folder-popup-" + type,
    	callback: folderConfigAction,
    	node: $('folder_tree_info'),
    	minPerms: 2 // create objects
    });

}

function cb_getpath(sPath) {
    var nodes = document.getElementsByName('importFolderInput');
    if (nodes && nodes.length > 0) {
        nodes[0].value = sPath;
    }
}

function setFolder(fId){
	importFolderId = fId;
	ox.api.folder.getPathString({
	    folder: fId,
	    success: cb_getpath
	});
}

function folderConfigAction (data) {
	importFolderDestination = data;
	toggleConfigTree();
	clickedItem = data.id;
	setFolder(clickedItem);
}

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

function ConfigTeams() {
	this.teams=new Array();
	this.cbok;
	this.cbcancel;
}
ConfigTeams.open = function () {
    ox.api.setModal(true);
	//showNode("modal-dialog");
	//$("modal-dialog").style.display="block";
	showNode("config_popups_win");
	$("config_popups_win").style.display="block";
	showNode("window_teams");
	centerPopupWindow($("window_teams"));
	$("window_teams").style.display="block";
}
ConfigTeams.close = function () {
	if(this.closecb) { globalalert.cbclose(); }
	hideNode("window_teams");
	$("window_teams").style.display="none";
	hideNode("config_popups_win");
	$("config_popups_win").style.display="none";
	var childs=	$("modal-dialog").childNodes;
	var closeall=true;
	for(var i=0;i<childs.length;i++) {
		if(childs[i].tagName && childs[i].tagName == "DIV") {
			if(childs[i].style.display && childs[i].style.display != "none") {
				closeall=false;
			}
		}
	}
	if(closeall) {
	    ox.api.setModal(false);
		//hideNode("modal-dialog");
		//$("modal-dialog").style.display="none";
	}
}
ConfigTeams.commitcancel = function () {
	if(configteams.cbcancel) { 
		if(configteams.cbcancel()) {
			ConfigTeams.close();
		}
	}
	else { ConfigTeams.close(); }
}
ConfigTeams.addMember = function() {
	cct_addPermanentMembers();
}
ConfigTeams.removeMember = function () {
	cct_removePermanentMembers();
}
ConfigTeams.commitok = function () {
	if(configteams.cbok) { 
		if(configteams.cbok()) {
			ConfigTeams.close();
		} 
	}
	else { ConfigTeams.close(); }
}
register("Loaded", function () {
	addOnClose($("window_teams"),function() { ConfigTeams.close() }); 
	}
);
var configteams=new ConfigTeams();

function openTeamsWindow(team_name,team_members,team_default,cbok,cbcancel) {
	if(team_members) {
		configteams.teams=clone(team_members);
	} else {
		configteams.teams=new Array();
	}
	$("team_window_team_name").value=team_name;
	$("team_default").checked=team_default;
	configteams.cbok=cbok;
	configteams.cbcancel=cbcancel;
	ConfigTeams.open();
	cct_fillMembers();
	if(configteams.teams.length>0) {
		cct_selectMember(document.getElementById("Member-"+configteams.teams[0].id));
		
	}
	
} 
var cct_beforeenter=false;
registerView("configuration/calendar/teams",
	function () {
		showNode("config_calendar_team"); 
		if(cct_participant_window == null)
			cct_createParticipants_PopUp();
		$("config_calendar_team").style.display="block";
		
		// toolbar
		if (!configToolbars.calendarTeams) {
		    configToolbars.calendarTeams = temporary.configuration.newToolbar(
		        _("Teams"), [
                    temporary.configuration.saveButton,
                    {
                        title: _("Team"),
                        id: "team",
                        buttons: [{
                            title: _("Add"),
                            id: "add",
                            icons: ["img/menu/userrights.gif",
                                    "img/menu/userrights_d.gif"],
                            event: "OX_Configuration_Teams_Add_Team"
                        }, {
                            title: _("Edit"),
                            id: "edit",
                            icons: ["img/menu/edit.gif", "img/menu/edit_d.gif"],
                            event: "OX_Configuration_Teams_Edit_Team",
                            selection: "configuration-team",
                            requires: ["one"]
                        }, {
                            title: _("Remove"),
                            id: "remove",
                            icons: ["img/menu/remove_userrights.gif",
                                    "img/menu/remove_userrights_d.gif"],
                            event: "OX_Configuration_Teams_Remove_Team",
                            selection: "configuration-team",
                            requires: ["some"]
                        }]
                    }
                ], "teams");
		}
		temporary.configuration.showToolbar(configToolbars.calendarTeams);
	},
	function () { 
				  register("OX_Configuration_Teams_Add_Team",cct_addnewTeam);
				  register("OX_Configuration_Teams_Edit_Team",cct_editTeam);
				  register("OX_Configuration_Teams_Remove_Team",cct_removenewTeam);
				  register("OX_SAVE_OBJECT",cct_saveConfiguration);
				  register("OX_Cancel_Object",cct_cancelConfiguration);
				  cct_enter();	
				},
	function()  { 
				 //configuration_askforSave();
 				 cct_leave();
				 unregister("OX_Configuration_Teams_Add_Team",cct_addnewTeam);
 				 unregister("OX_Configuration_Teams_Edit_Team",cct_editTeam);
	    	     unregister("OX_Configuration_Teams_Remove_Team",cct_removenewTeam);
	    	     unregister("OX_SAVE_OBJECT",cct_saveConfiguration);
				 unregister("OX_Cancel_Object",cct_cancelConfiguration);
				 
				},
	function () { 
		hideNode("config_calendar_team"); 
		$("config_calendar_team").style.display="none"; },
	function () { cct_enter(); }
);

function cct_saveConfiguration() {
	configSetKey("gui.calendar.teams",cct_tempteams);
	triggerEvent("OX_Save_Configuration",false,false);
}
function cct_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cct_enter();	
}
function checkDuplicateTeams(myname) {
	for(var i=0;i<cct_tempteams.length;i++) {
		if(cct_tempteams[i].name==myname) return true;
	}
	return false;
}

var cct_currentteam=-1;
var cct_currentmember=-1;
var cct_tempteams=new Array();
var cct_participant_window = null;
function cct_enter() {
	cct_beforeenter=configuration_changed_fields["gui"];
	cct_tempteams = new Array()
    // prevent JS error when team isn't an array, try to reconvert it
    if (ox.api.config.contains("gui.calendar.teams")) {
        cct_tempteams = ox.api.config.get("gui.calendar.teams");
        if (jQuery.isArray(cct_tempteams) === false) {
            cct_tempteams = ObjectToArray(cct_tempteams);
        }
    }
	cct_fillTeams();
	if(cct_tempteams.length>0) {
		cct_selectTeam(document.getElementById("Team-0"));
	}
	setConfigPath($("cct_header"));		
}
function cct_addnewTeam() {
	var zaehler=0;
	var myobject=new Object();
	teamname=_("New Team");
	if(checkDuplicateTeams(teamname)) { zaehler=2; }
	while(checkDuplicateTeams(teamname+"("+zaehler+")")) {
		zaehler ++;
	}
	if(zaehler!=0) {
		teamname=teamname+"("+zaehler+")";
	}
	openTeamsWindow(teamname,new Array(),false,cct_createTeam);
	configuration_changed_fields["gui"]=true;
}
function cct_editTeam() {
	openTeamsWindow(cct_tempteams[cct_currentteam].name,cct_tempteams[cct_currentteam].children,cct_tempteams[cct_currentteam].team_default,cct_changeTeam);	
	configuration_changed_fields["gui"]=true;
}
function cct_createTeam() {
	var myobject=new Object();
	if(!checkDuplicateTeams($("team_window_team_name").value)) {
		myobject.name=$("team_window_team_name").value;
		myobject.team_default=$("team_default").checked;
		if(myobject.team_default) {
			for(var i=0;i<cct_tempteams.length;i++) {
				cct_tempteams[i].team_default=false;
			}	
		}
		myobject.children=clone(configteams.teams);
	} else {
		newAlert(_("Invalid Team"),_("This Team name already exists"));
		return false;
	}
	cct_tempteams.push(myobject);
	configuration_changed_fields["gui"]=true;
	cct_fillTeams();
	cct_selectTeam(document.getElementById("Team-"+(cct_tempteams.length-1)));
	return true;
}
function cct_changeTeam() {
	var myobject=new Object();
	if(checkDuplicateTeams($("team_window_team_name").value)) {
		if($("team_window_team_name").value != cct_tempteams[cct_currentteam].name) {
			newAlert(_("Invalid Team"),_("This Team name already exists"));
			return false;		
		}
	}
	myobject.name=$("team_window_team_name").value;
	myobject.team_default=$("team_default").checked;
	if(myobject.team_default) {
		for(var i=0;i<cct_tempteams.length;i++) {
			cct_tempteams[i].team_default=false;
		}	
	}
	myobject.children=clone(configteams.teams);
	cct_tempteams[cct_currentteam] = myobject;
	configuration_changed_fields["gui"]=true;
	cct_fillTeams();
	cct_selectTeam(document.getElementById("Team-"+(cct_tempteams.length-1)));
	return true;
}

function cct_fillTeams() {
	removeChildNodes($("cct_teams"));
	for(var i=0;i<cct_tempteams.length;i++) {
		var newteam=$("ctd_template_one_row").cloneNode("false");
		var textnode=document.createTextNode(cct_tempteams[i].name);
		newteam.id="Team-"+i;
		newteam.appendChild(textnode);
		$("cct_teams").appendChild(newteam);	
	}
    ox.ToolBarController.processSelection("configuration-team", false, []);
}
function cct_selectTeam(param) {
	var allteams=param.parentNode.getElementsByTagName("div");
	for (var i=0;i<allteams.length;i++) {
		allteams[i].className = "background-color-content font-color-default";
		if(cct_tempteams[i].team_default) {
			allteams[i].style.fontStyle="italic";
			allteams[i].style.fontWeight="bold";
		} 
	}
	param.className = "background-color-PMG-selection-elements font-color-default";
	cct_currentteam=param.id.split("-")[1];
//	fillMembers();
    ox.ToolBarController.processSelection("configuration-team", false,
                                          [cct_currentteam]);
}
function cct_fillMembers() {
	removeChildNodes($("cct_members"));
	for(var i=0;i<configteams.teams.length;i++) {
		var newmember=$("ctd_template_one_member").cloneNode("false");
		var textnode=document.createTextNode(configteams.teams[i].display_name);
		newmember.id="Member-"+configteams.teams[i].id;
		newmember.appendChild(textnode);
		$("cct_members").appendChild(newmember);	
	}
	triggerEvent("SubSelectedTeamMember",0);
}

function cct_removenewTeam() {
	cct_tempteams.splice(cct_currentteam,1);
	cct_fillTeams();
    ox.ToolBarController.processSelection("configuration-team", false, []);
	if(cct_tempteams.length>0) {
		cct_selectTeam(document.getElementById("Team-0"));
	}
	configuration_changed_fields["gui"]=true;
}
function cct_addPermanentMembers() {
	cct_participant_window.openAddParticipantsWindow(); 
}
function cct_removePermanentMembers() {
	for(var z=0;z<configteams.teams.length;z++) {
		if(configteams.teams[z].id==cct_currentmember) {
			configteams.teams.splice(z,1);
			break;
		}
	}
	cct_fillMembers();
	if(configteams.teams.length>0) {
		cct_selectMember(document.getElementById("Member-"+configteams.teams[0].id))		
	} else {
		cct_currentmember=-1;
	}
}
function cct_team_name_changed() {
	var cct_inputfield=$("team_name_field");
	cct_tempteams[cct_currentteam].name=cct_inputfield.value;
	document.getElementById("Team-"+cct_currentteam).firstChild.nodeValue=cct_inputfield.value;
	configuration_changed_fields["gui"]=true;
}
function cct_createParticipants_PopUp() {
	cct_participant_window = new ParticipantsSmall(null,newPermanentUsers,true,true,true,false,_("Select Users"), /*i18n*/
							null,null,true,true);
	function newPermanentUsers(response) {
		for(i in response) {
		    delete response[i].contactID;
			var available=false;
			for(var z=0;z<configteams.teams.length;z++) {
				if(configteams.teams[z].id==response[i].id) {
					available=true;
					configteams.teams[z]==response[i];
					break;
				}
			}
			if(!available) {
				configteams.teams.push(response[i]);
			}
		}
		cct_fillMembers();
		if(configteams.teams.length>0) {
			cct_selectMember(document.getElementById("Member-"+configteams.teams[0].id))		
		} else {
			cct_currentmember=-1;
		}		
	}
}

function cct_leave() {
}
function cct_selectMember(param) {
	var allmembers=param.parentNode.getElementsByTagName("div");
	for (var i=0;i<allmembers.length;i++) {		
		allmembers[i].className = removeClass(allmembers[i].className,"background-color-PMG-selection-elements");
	}

	param.className += " background-color-PMG-selection-elements";
	cct_currentmember=param.id.split("-")[1];
	triggerEvent("SubSelectedTeamMember",1);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/contacts/preferences",
	function () { 
		showNode("config_contact"); 
		$("config_contact").style.display="block";
        
        // toolbar
        temporary.configuration.showToolbar(
            temporary.configuration.defaultToolbar);
    },
	function() { 
		register("OX_SAVE_OBJECT",ccon_saveConfiguration);
		register("OX_Cancel_Object",ccon_cancelConfiguration);
		ccon_enter();
	},
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",ccon_saveConfiguration);
		unregister("OX_Cancel_Object",ccon_cancelConfiguration);
		ccon_leave();
		
	},
	function () { 
		hideNode("config_contact"); 
		$("config_contact").style.display="none"; },
	function() {
		ccon_enter();
	}
);

var ccon_init_bool=false;
var ccon_default_level1;
var ccon_rows_cardview;
register("OX_Configuration_Loaded",ccon_onconfigload);
function ccon_onconfigload() {
    addDefaultView("contacts/phonelist", _("Phone list"));
    addDefaultView("contacts/cards", _("Cards"));
}
function ccon_init() {
	ccon_default_level1= new ComboBox3(window, "ccon_default_level1", "16em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var conviews=getDefaultSubviews("contacts");
	for (var i in conviews) {
		ccon_default_level1.addElement(conviews[i],i);
	}
	ccon_default_level1.getDomNode();
	
	ccon_rows_cardview= new ComboBox3(window, "ccon_rows_cardview", "16em", 0, true,"OX_Configuration_GUI_Changed", 5);
    ccon_rows_cardview.addElement(_("auto"), "auto");
    ccon_rows_cardview.addElement(noI18n("4"), 4);
    ccon_rows_cardview.addElement(noI18n("5"), 5);
    ccon_rows_cardview.addElement(noI18n("6"), 6);
    ccon_rows_cardview.addElement(noI18n("7"), 7);
	ccon_rows_cardview.getDomNode();
}
function ccon_enter() {
	if(!ccon_init_bool) {
		ccon_init();
		ccon_init_bool=true;
	}
	if(configContainsKey("gui.contacts.view")) {
		ccon_default_level1.setKey(configGetKey("gui.contacts.view"));
		ccon_rows_cardview.setKey(configGetKey("gui.contacts.cardsToViewPerColumn"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.contacts")) {
		setIntofRadioBox("ccon_enablehovercontacts",configGetKey("gui.effects.hover.contacts"));
		configuration_changed_fields["gui"]=false;
	}	
	setConfigPath($("ccon_header"));		
}
function ccon_saveConfiguration() {
	if(configuration_changed_fields["gui"]==true) {
		configSetKey("gui.contacts.view",ccon_default_level1.getKey());
		configSetKey("gui.contacts.cardsToViewPerColumn",ccon_rows_cardview.getKey());
		configSetKey("gui.effects.hover.contacts",getBoolofInt(getValueofRadioBox("ccon_enablehovercontacts")));
		menulastviews["contacts"]=ccon_default_level1.getKey();
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function ccon_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	ccon_enter();
}
function ccon_leave() {
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/tasks/preferences",
	function () { 
		showNode("config_tasks"); 
		$("config_tasks").style.display="block";
        
        // toolbar
        temporary.configuration.showToolbar(
            temporary.configuration.defaultToolbar);
	},
	function() {
	    register("OX_SAVE_OBJECT",ct_saveConfiguration);
		register("OX_Cancel_Object",ct_cancelConfiguration);
		ct_enter();
	},
	function() {
		//configuration_askforSave();
	    unregister("OX_SAVE_OBJECT",ct_saveConfiguration);
		unregister("OX_Cancel_Object",ct_cancelConfiguration);
		ct_leave();
	},
	function () { 
		hideNode("config_tasks"); 
		$("config_tasks").style.display="none"; },
	function() { ct_enter();}
);

var ct_init_bool=false;
var ct_default_level1;
var ct_interval;
register("OX_Configuration_Loaded",ct_onconfigload);
function ct_onconfigload() {
    addDefaultView("tasks/list", _("List view"));
    addDefaultView("tasks/split", _("H-split view"));
}
function ct_init() {
	ct_default_level1= new ComboBox3(window, "ct_default_level1", "16em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var tasviews=getDefaultSubviews("tasks");
	for (var i in tasviews) {
		ct_default_level1.addElement(tasviews[i],i);
	}
	ct_default_level1.getDomNode();
	ct_interval = new ComboBox3(window, "ct_interval", "16em", 1, true,"OX_Configuration_GUI_Changed", null);
    ct_interval.addElement(noI18n("5"), 5);
    ct_interval.addElement(noI18n("10"), 10);
    ct_interval.addElement(noI18n("15"), 15);
    ct_interval.addElement(noI18n("20"), 20);
    ct_interval.addElement(noI18n("30"), 30);
    ct_interval.addElement(noI18n("60"), 60);
	ct_interval.getDomNode();

}
function ct_enter() {
	if(!ct_init_bool) {
		ct_init();
		ct_init_bool=true;
	}
	if(configContainsKey("gui.tasks.view")) {
		ct_default_level1.setKey(configGetKey("gui.tasks.view"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.tasks.interval")) {
		ct_interval.setKey(configGetKey("gui.tasks.interval"));
		configuration_changed_fields["gui"]=false;
	}	
	if(configContainsKey("gui.effects.hover.tasks")) {
		setIntofRadioBox("ct_enablehovertasks",configGetKey("gui.effects.hover.tasks"));
		configuration_changed_fields["gui"]=false;
	}
    if(configContainsKey("modules.tasks.notifyNewModifiedDeleted")) {
        setValueofRadioBox("cs_tasknotification_0",configGetKey("modules.tasks.notifyNewModifiedDeleted"));
        configuration_changed_fields["tasknotification"]=false;
    }
	if(configContainsKey("modules.tasks.notifyAcceptedDeclinedAsCreator")) {
        setValueofRadioBox("cs_tasknotification_1",configGetKey("modules.tasks.notifyAcceptedDeclinedAsCreator"));
        configuration_changed_fields["tasknotification"]=false;
    }
    if(configContainsKey("modules.tasks.notifyAcceptedDeclinedAsParticipant")) {
        setValueofRadioBox("cs_tasknotification_2",configGetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant"));
        configuration_changed_fields["tasknotification"]=false;
    }
	setConfigPath($("ct_header"));		
		
}
function ct_saveConfiguration() {
	if(configuration_changed_fields["gui"]==true) {
		configSetKey("gui.tasks.view",ct_default_level1.getKey());
		configSetKey("gui.tasks.interval",ct_interval.getKey());
		menulastviews["tasks"]=ct_default_level1.getKey();
		configSetKey("gui.effects.hover.tasks",getBoolofInt(getValueofRadioBox("ct_enablehovertasks")));
	}
	/*
	 * store notification settings to config, if changed 
	 */
	if (configuration_changed_fields["tasknotification"]) {
		configSetKey("modules.tasks.notifyNewModifiedDeleted",getBoolofInt(getValueofRadioBox("cs_tasknotification_0")));	
		configSetKey("modules.tasks.notifyAcceptedDeclinedAsCreator",getBoolofInt(getValueofRadioBox("cs_tasknotification_1")));
		configSetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant",getBoolofInt(getValueofRadioBox("cs_tasknotification_2")));
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function ct_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	ct_enter();
}
function ct_leave() {
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/infostore/preferences",
	function () { 
		showNode("config_infostore"); 
		$("config_infostore").style.display="block";
        
        // toolbar
        temporary.configuration.showToolbar(
            temporary.configuration.defaultToolbar);
	},
	function() { 
		register("OX_SAVE_OBJECT",ci_saveConfiguration);
		register("OX_Cancel_Object",ci_cancelConfiguration);
		ci_enter(); },
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",ci_saveConfiguration);
		unregister("OX_Cancel_Object",ci_cancelConfiguration);
		ci_leave();
	},
	function () { 
		hideNode("config_infostore"); 
		$("config_infostore").style.display="none"; },
	function() {
		ci_enter();
	}
);

var ci_init_bool=false;
var ci_default_level1;
register("OX_Configuration_Loaded",ci_onconfigload);
function ci_onconfigload() {
    addDefaultView("infostore/list", _("List view"));
    addDefaultView("infostore/split", _("H-split view"));
}
function ci_init() {
	ci_default_level1= new ComboBox3(window, "ci_default_level1", "16em", 1, true,"OX_Configuration_GUI_Changed", 5);
	var conviews=getDefaultSubviews("infostore");
	for (var i in conviews) {
		ci_default_level1.addElement(conviews[i],i);
	}
	ci_default_level1.getDomNode();
}
function ci_enter() {
	if(!ci_init_bool) {
		ci_init();
		ci_init_bool=true;
	}
	if(configContainsKey("gui.infostore.view")) {
		ci_default_level1.setKey(configGetKey("gui.infostore.view"));
		configuration_changed_fields["gui"]=false;
	}
	if(configContainsKey("gui.effects.hover.infostore")) {
		setIntofRadioBox("ci_enablehoverinfostore",configGetKey("gui.effects.hover.infostore"));
		configuration_changed_fields["gui"]=false;
	}
	setConfigPath($("ci_header"));		
		
}
function ci_saveConfiguration() {
	if(configuration_changed_fields["gui"]==true) {
		configSetKey("gui.infostore.view",ci_default_level1.getKey());
		menulastviews["infostore"]=ci_default_level1.getKey();
		configSetKey("gui.effects.hover.infostore",getBoolofInt(getValueofRadioBox("ci_enablehoverinfostore")));
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function ci_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	ci_enter();
}
function ci_leave() {
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

registerView("configuration/portal/layout",
	function () { 
		showNode("config_portal"); 
		$("config_portal").style.display="block";
        
        // toolbar
        if (!configToolbars.layout) {
            configToolbars.layout = temporary.configuration.newToolbar(
                _("Layout"), [temporary.configuration.saveButton], "layout");
        }
        temporary.configuration.showToolbar(configToolbars.layout);
    },
	function() { 
		register("OX_SAVE_OBJECT",cp_saveConfiguration);
		register("OX_Cancel_Object",cp_cancelConfiguration);
		
		cp_enter();
	},
	function() {
		//configuration_askforSave();
		unregister("OX_SAVE_OBJECT",cp_saveConfiguration);
		unregister("OX_Cancel_Object",cp_cancelConfiguration);		
		cp_leave();
	},
	function () { 
		hideNode("config_portal"); 
		$("config_portal").style.display="none"; },
	function () { cp_enter();}
);

var cp_init_bool=false;
var cp_internalcontents=new Object();
var config_portal_mail;
var config_portal_calendar;
var config_portal_infostore;
var config_portal_tasks;
var config_portal_contacts;

function cp_saveConfiguration() {
	if(configuration_changed_fields["gui"]) {
		config_portal_fillContents();
		configSetKey("gui.portal.internalcontents",cp_internalcontents);
		configSetKey("gui.effects.hover.portal",getBoolofInt(getValueofRadioBox("config_portal_enablehoverportal")));
	}
	triggerEvent("OX_Save_Configuration",false,false);
}
function cp_cancelConfiguration() {
	configuration_changed_fields["gui"]=false;
	cp_enter();	
}
function cp_init() {
    var modules = ox.api.ui.listModules();
    // disable module specific settings if disabled
    for (var i=0; i < modules.length; i++) {
        if (modules[i].disabled === true && $("cs_" + modules[i].name + "_hover")) {
            $("cs_" + modules[i].name + "_portal").style.display="none";
        }
    }
    
	config_portal_mail=new ComboBox3(window, "config_portal_mail", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
    config_portal_mail.addElement(_("Hide"), -1);
    config_portal_mail.addElement(_("Show 5 elements"), 5);
    config_portal_mail.addElement(_("Show 10 elements"), 10);
    config_portal_mail.addElement(_("Show 15 elements"), 15);
    config_portal_mail.addElement(_("Show 20 elements"), 20);
	config_portal_mail.getDomNode();
	if(!configGetKey("modules.mail.module")) {
		config_portal_mail.disable();
	}
	
	config_portal_calendar=new ComboBox3(window, "config_portal_calendar", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
    config_portal_calendar.addElement(_("Hide"), -1);
    config_portal_calendar.addElement(_("Elements of this week only"), -2);
    config_portal_calendar.addElement(_("Hide later elements"), 0);
    config_portal_calendar.addElement(_("Show 5 elements"), 5);
    config_portal_calendar.addElement(_("Show 10 elements"), 10);
    config_portal_calendar.addElement(_("Show 15 elements"), 15);
    config_portal_calendar.addElement(_("Show 20 elements"), 20);
	config_portal_calendar.getDomNode();
	if(!configGetKey("modules.calendar.module")) {
		config_portal_calendar.disable();
	}
	
	config_portal_infostore=new ComboBox3(window, "config_portal_infostore", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
    config_portal_infostore.addElement(_("Hide"), -1);
    config_portal_infostore.addElement(_("Show 5 elements"), 5);
    config_portal_infostore.addElement(_("Show 10 elements"), 10);
    config_portal_infostore.addElement(_("Show 15 elements"), 15);
    config_portal_infostore.addElement(_("Show 20 elements"), 20);
	config_portal_infostore.getDomNode();
	if(!configGetKey("modules.infostore.module")) {
		config_portal_infostore.disable();
	}

	config_portal_tasks=new ComboBox3(window, "config_portal_tasks", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
    config_portal_tasks.addElement(_("Hide"), -1);
    config_portal_tasks.addElement(_("Elements of this week only"), -2);
    config_portal_tasks.addElement(_("Hide later elements"), 0);
    config_portal_tasks.addElement(_("Show 5 elements"), 5);
    config_portal_tasks.addElement(_("Show 10 elements"), 10);
    config_portal_tasks.addElement(_("Show 15 elements"), 15);
    config_portal_tasks.addElement(_("Show 20 elements"), 20);
	config_portal_tasks.getDomNode();
	if(!configGetKey("modules.tasks.module")) {
		config_portal_tasks.disable();
	}
	
	config_portal_contacts=new ComboBox3(window, "config_portal_contacts", "20em", 0, true,"OX_Configuration_Settings_Changed_GUI", null);
    config_portal_contacts.addElement(_("Hide"), -1);
    config_portal_contacts.addElement(_("Show"), 0);
    config_portal_contacts.getDomNode();
    if(!configGetKey("modules.contacts.module")) {
        config_portal_contacts.disable();
    }
}
function cp_leave() {	
}
register("OX_Configuration_Loaded",function() {
	var cp_internalcontents=new Array();
    if(configContainsKey("gui.portal.internalcontents")) {
		cp_internalcontents=configGetKey("gui.portal.internalcontents");
		if(!cp_internalcontents.push) {
			cp_internalcontents=new Array();
		}		
	}
	for(var i in modulesview) {
		var temp1=false;
		for(var i2=0;i2<cp_internalcontents.length;i2++) {
			if(cp_internalcontents[i2].module==modulesview[i].name) {
				if (!cp_internalcontents[i2].adj) {
				    cp_internalcontents[i2].adj = {
				        x: modulesview[i].adj.x,
				        y: modulesview[i].adj.y
				    };
				}
				temp1 = true;
			}
		}
		if(!temp1) {
			var tmp =new Object();
			tmp.external=false;
			tmp.module=modulesview[i].name;
			tmp.header=modulesview[i].text;
			tmp.visible=(tmp.module != "contacts");
			tmp.params=new Object();
			tmp.params.limit=modulesview[i].limit;	
			tmp.adj=modulesview[i].adj;
			cp_internalcontents.push(tmp);
		}
	}
	
	// remove widgets if modules are not available
	var indx = 0, obj;
	for (; indx < cp_internalcontents.length;) {
	    obj = cp_internalcontents[indx];
	    if (obj.module !== "custom" && !configGetKey("modules." + obj.module + ".module")) {
	        cp_internalcontents.splice(indx, 1);
	    } else {
	        indx++;
	    }
	}
	
	configSetKey("gui.portal.internalcontents", cp_internalcontents);
});

function cp_enter() {

    if (!cp_init_bool) {
        cp_init();
        cp_init_bool = true;
    }

    cp_internalcontents = [];
    if (configContainsKey("gui.portal.internalcontents")) {
        cp_internalcontents = configGetKey("gui.portal.internalcontents");
        if (!cp_internalcontents.push) {
            cp_internalcontents = [];
        }
    }

    // loop over widgets/modules
    var i = 0, $i = cp_internalcontents.length, obj, module;
    for (; i < $i; i++) {
        obj = cp_internalcontents[i];
        module = obj.module;
        // module enabled?
        if (configGetKey("modules." + module + ".module")) {
            // set key
            window["config_portal_" + module].setKey(obj.params.limit);
        }
    }

    if (configContainsKey("gui.effects.hover.portal")) {
        setIntofRadioBox("config_portal_enablehoverportal", configGetKey("gui.effects.hover.portal"));
    }

    configuration_changed_fields.gui = false;
    setConfigPath($("config_portal_header"));
}

function config_portal_fillContents() {
    
	var mailvalue=config_portal_mail.getKey();
	var calendarvalue=config_portal_calendar.getKey();
	var contactsvalue=config_portal_contacts.getKey();
	var infostorevalue=config_portal_infostore.getKey();
	var tasksvalue=config_portal_tasks.getKey();
	
	var oldconf=configGetKey("gui.portal.internalcontents");
	for(var i=0;i<oldconf.length;i++) {
		switch(oldconf[i].module) {
			case "calendar":
			    oldconf[i].visible = (calendarvalue >= 0 || calendarvalue === -2);
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=calendarvalue;
				break;
			case "tasks":
	            oldconf[i].visible = (tasksvalue >= 0 || tasksvalue === -2);
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=tasksvalue;
				break;
			case "contacts":
                oldconf[i].visible = contactsvalue >= 0;
                if(!oldconf[i].params) { oldconf[i].params=new Object(); }
                oldconf[i].params.limit=contactsvalue;
                break;
            case "infostore":
			    oldconf[i].visible = infostorevalue >= 0;
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=infostorevalue;
				break;
			case "mail":
			    oldconf[i].visible = mailvalue >= 0;
				if(!oldconf[i].params) { oldconf[i].params=new Object(); }
				oldconf[i].params.limit=mailvalue;
				break;

		}
	}
	var myobject=new Object();
	myobject.params=new Object();
	myobject.external=false;
	cp_internalcontents=oldconf;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

function ConfigPortalExternal() {
    this.grid, this.selection = new Selection();
    this.storage = new Storage(0, [], 0, 0, 0, 0, function(data) { return data.id; }); 
}

ConfigPortalExternal.prototype = {
        initGrid : function() {
            var self = this;
            var _selection = new Selection();
            _selection.oldToggle = _selection.toggle;
            _selection.selectable = function(index) {
                var data = this.storage.data.get(this.storage.getSID(index));
                // fake selection, disabled when protected
                return Boolean(!data["protected"]);
            };
            _selection.toggle = function(index) {
                return this.selectable(index) && this.oldToggle(index);
            };
            _selection.select = function(from, to) {
                for (var i = from; i < to; i++) {
                    if (!this.get(i) && this.selectable(i)) {
                        this.oldToggle(i);
                    }
                }
            };
            this.selection = _selection;
            
            // grid columns
            var gridColumns = [];
            // Title
            gridColumns.push({ 
                i18n: "description", /*i18n context*/
                text: "Title", /*i18n*/
                width: "25%",
                set: function (div, data) {
                    removeChildNodes(div);
                    div.appendChild(document.createTextNode(data.title || ""));
                    // protected, then text is silver
                    jQuery(div).parent().css({ color: (data["protected"] ? "silver" : "") });
                },
                clear: LiveGrid.makeClear("")
            });
            // URI - don't show if custom widgets are disabled
            if (ox.api.config.get("ui.portal.customUWA", true) === true) {
                gridColumns.push({
                    text: "URI", /*i18n*/
                    i18n: true,
                    set: function (div, data) {
                        removeChildNodes(div);
                        div.appendChild(document.createTextNode(data.url || ""));
                    },
                    clear: LiveGrid.makeClear("")
                });
            }
            // Visibility
            gridColumns.push({
                text: "Visibility", /*i18n*/
                i18n: true,
                width: "9em",
                set: function  (div, data) {
                    removeChildNodes(div);
                    div.appendChild(document.createTextNode(data.visible ? _("enabled") :_("disabled")));
                },
                clear: LiveGrid.makeClear("")
            });
            
            this.grid = new LiveGrid(gridColumns, this.selection);
            
            this.grid.emptylivegridtext = "";
            this.grid.events.register("Selected", function(ids2) {
                var ids = self.grid.selection.getSelected();
                ox.ToolBarController.processSelection("portal-external", false, ids);
            });
            
            this.grid.events.register("Activated", function(ids) {
                if (ox.api.config.get("ui.portal.customUWA", true) === true 
                		&& ids && ids.length > 0) {
                    triggerEvent("OX_Configuration_Edit_External");
                }
            });
            
            $("lg_header_uwa_modules").appendChild(this.grid.getHeader());
            this.grid.getTable($("lg_uwa_modules"));
    },
    
    enableGrid : function() {
        var Self = this;
        cnf_PE.storage.remove(0, cnf_PE.storage.ids.length);
        ox.uwa.list(function(data) {
            Self.storage.append(data);
            Self.grid.enable(Self.storage);
        });
    }, 
    
    disableGrid : function() {
        this.grid.disable();
    },
    
    addUWA : function() {
        cnf_PE.dialog.open(null, cnf_PE.storeUWA);
    },
    
    editUWA : function(isNew) {
        if (!isNew && ox.api.config.get("ui.portal.customUWA", true) === true) {
            var id = cnf_PE.grid.selection.getSelected()[0];
            if (id) {
                var obj = cnf_PE.grid.storage.data.data[id];
                if (obj) {
                    cnf_PE.dialog.open(obj, cnf_PE.storeUWA);
                }
            }
        }
    },
    
    activate: function(visible) {
        if (visible == undefined) {
            visible = true;
        }
        var selected = cnf_PE.grid.selection.getSelected();
        if (selected.length != 0) {
            cnf_PE.grid.storage.newIterate(selected, emptyFunction, function(id, obj) {
                obj.visible = visible;
                cnf_PE.storeUWA(obj);
            });
        }
    }, 
    
    deactivate: function() {
        cnf_PE.activate(false);
    },
    
    dialog : (function() {
        var final_cb;
        
        return {
            open : function(uwa, cb) {
                var color;
                final_cb = cb;
                
                if (uwa) {
                    $("external_window_uwa_id").value = uwa.id || uwa.name || "";
                    $("external_window_uwa_name").value = uwa.title || "";
                    $("external_autorefresh").checked = Boolean(uwa.autorefresh);
                    $("external_window_uwa_uri").value = uwa.url || "";
                    $("external_window_uwa_params").value = ox.uwa.util.convertParameters(uwa.parameters) || "";
                    $("external_standalone").checked = Boolean(uwa.standalone);
                }
                
                if (!ox.api.isModal()) {
                    ox.api.setModal(true);
                    showNode("config_popups_win");
                    $("config_popups_win").style.display="block";
                }
                
                showNode("window_external_module");
                centerPopupWindow($("window_external_module"));
                $("window_external_module").style.display="block";
                $("external_window_uwa_name").focus();
            },
            
            close : function(cancel) {
                if (!cancel && final_cb) {
                    var title = $("external_window_uwa_name").value;
                    var url =  $("external_window_uwa_uri").value;
                    if (trimStr(title).length == 0 || trimStr(url).length == 0) {
                        // invalid input
                        return;
                    }
                    
                    var parameters = ox.uwa.util.convertParameters($("external_window_uwa_params").value);
                    
                    final_cb({
                        id: $("external_window_uwa_id").value,
                        title: title,
                        autorefresh: $("external_autorefresh").checked,
                        url: url,
                        standalone: $("external_standalone").checked,
                        parameters: parameters || ""
                    });
                }
                // reset to default
                $("external_window_uwa_id").value = "";
                $("external_window_uwa_name").value = "";
                $("external_autorefresh").checked = false;
                $("external_window_uwa_uri").value = "";
                $("external_standalone").checked = false;
                $("external_window_uwa_params").value = "";
                delete(final_cb);
                
                if (this.closecb) { 
                    globalalert.cbclose(); 
                }
                hideNode("window_external_module");
                $("window_external_module").style.display="none";
                hideNode("config_popups_win");
                $("config_popups_win").style.display = "none";
                var childs = $("modal-dialog").childNodes;
                var closeall = true;
                for (var i=0; i < childs.length; i++) {
                    if (childs[i].tagName && childs[i].tagName == "DIV") {
                        if (childs[i].style.display && childs[i].style.display!= "none" ) {
                            closeall=false;
                        }
                    }
                }
                if (closeall) {
                    ox.api.setModal(false);
                }
            }
        };
    }()),
        
    storeUWA : function(uwa) {
        if (!uwa) return;
                
        // either edit or new!?
        if (uwa.id) {
            cnf_PE.grid.storage.localUpdate([uwa.id], function(index, object) {
                uwa.visible = object.visible || false;
                return uwa;
            });
            ox.uwa.update(uwa);
        } else {
            uwa.visible = true;
            ox.uwa.add(uwa);
            // append to grid
            cnf_PE.grid.storage.append([uwa]);
        }
        configuration_changed_fields["gui"] = true;
    },
    
    removeUWA : function() {
        var ids = cnf_PE.grid.selection.getSelected();
        if (ids && ids.length) {
            cnf_PE.grid.storage.removeIDs(ids);
            ox.uwa.remove(ids);
            configuration_changed_fields["gui"] = true;
        }
    },
        
    saveConfiguration : function() {
        if (ox.uwa.toStore && isEmpty(ox.uwa.toStore) === false) {
            // timing issue, view switch comes before the save
            // so we need to trigger a refresh first
            if ("oPortal" in window === true) {
                oPortal.refresh();
            }
            ox.uwa.save(function() {
                triggerEvent("OX_Configuration_Changed");
                configuration_changed_fields["gui"] = false;
                triggerEvent("OX_New_Info", 4, _("Your settings have been saved"));
            });
        }
    },
    
    cancelConfiguration : function() {
        // reset cache and temp storages
        ox.uwa.reset();
        configuration_changed_fields["gui"] = false;
    }
};

var cnf_PE = new ConfigPortalExternal();

registerView("configuration/portal/external",
        function () {

            showNode("config_external");
            $("config_external").style.display="block";
            
            // custom UWA allowed?
            var customUWA = ox.api.config.get("ui.portal.customUWA", true) === true;
            
            if (customUWA) {
                // set link
                $("config.external.description").innerHTML = format(
                    _(uwaLink.text), ["<a href=\"" + uwaLink.link.format() + "\" target=\"_blank\">", "</a>"]
                );
            } else {
                // remove node
                jQuery("#config\\.external\\.description").parent().remove();
            }

            // sections
            var sections = [];
            
            // save section
            sections.push(temporary.configuration.saveButton);
            
            // UWA section
            if (customUWA) {
                sections.push({
                    title: _("UWA Modules"),
                    id: "modules",
                    buttons: [{
                        title: _("Add"),
                        id: "add",
                        icons: ["img/menu/add_extview.gif",
                                "img/menu/add_extview.gif"],
                        event: "OX_Configuration_External_Portalview_Add"
                    }, {
                        title: _("Edit"),
                        id: "edit",
                        icons: ["img/menu/externalview_edit_n.gif",
                                "img/menu/externalview_edit_d.gif"],
                        event: "OX_Configuration_Edit_External",
                        selection: "portal-external",
                        requires: ["one"]
                    }, {
                        title: _("Remove"),
                        id: "remove",
                        icons: ["img/menu/remove_extview.gif",
                                "img/menu/remove_extview_d.gif"],
                        event: "OX_Configuration_External_Portalview_Remove",
                        selection: "portal-external",
                        requires: ["some"]
                    }]
                });
            }
            
            // visibility section
            sections.push({
                title: _("Visibility"),
                id: "visibility",
                buttons: [{
                    title: _("Enable"),
                    id: "enable",
                    icons: ["img/menu/externalview_activate_n.gif",
                            "img/menu/externalview_activate_d.gif"],
                    event: "OX_Configuration_Enable_External",
                    selection: "portal-external",
                    requires: ["some"]
                }, {
                    title: _("Disable"),
                    id: "disable",
                    icons: ["img/menu/externalview_deactivate_n.gif",
                            "img/menu/externalview_deactivate_d.gif"],
                    event: "OX_Configuration_Disable_External",
                    selection: "portal-external",
                    requires: ["some"]
                }]
            });
            
            // toolbar
            if (!configToolbars.UWAModules) {
                configToolbars.UWAModules = temporary.configuration.newToolbar(
                    _("UWA Modules"), sections, "portal-external"
                );
                ox.ToolBarController.processSelection("portal-external", false, []);
            }
            temporary.configuration.showToolbar(configToolbars.UWAModules);
        },
        function() { 
            setConfigPath($("cext_header"));
            register("OX_SAVE_OBJECT", cnf_PE.saveConfiguration);
            register("OX_Cancel_Object", cnf_PE.cancelConfiguration);
            register("OX_Configuration_External_Portalview_Add", cnf_PE.addUWA);
            register("OX_Configuration_Edit_External", cnf_PE.editUWA);
            register("OX_Configuration_External_Portalview_Remove", cnf_PE.removeUWA);
            register("OX_Configuration_Enable_External", cnf_PE.activate);
            register("OX_Configuration_Disable_External", cnf_PE.deactivate); 
            if (!cnf_PE.grid) {
                cnf_PE.initGrid();
            }
            cnf_PE.enableGrid();
        },
        function() {
            unregister("OX_SAVE_OBJECT", cnf_PE.saveConfiguration);
            unregister("OX_Cancel_Object", cnf_PE.cancelConfiguration);
            unregister("OX_Configuration_External_Portalview_Add", cnf_PE.addUWA);
            unregister("OX_Configuration_Edit_External", cnf_PE.editUWA);
            unregister("OX_Configuration_External_Portalview_Remove", cnf_PE.removeUWA);
            unregister("OX_Configuration_Enable_External", cnf_PE.activate);
            unregister("OX_Configuration_Disable_External", cnf_PE.deactivate); 
            cnf_PE.disableGrid();
        },
        function() { 
            hideNode("config_external"); 
            $("config_external").style.display="none"; 
        },
        function() { }
    );

register("Loaded", function () {
    addOnClose($("window_external_module"), function() { 
        cnf_PE.dialog.close(true);
    }); 
});
/**
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 *
 */

function hookDeferred(deferred, callback) {
    var done = deferred.done;
    deferred.done = function() {
        deferred.done = done;
        callback();
        return done.apply(this, arguments);
    };
}

var OAuthAccounts = new jQuery.Deferred();
hookDeferred(OAuthAccounts, function() {
    ox.JSON.get(AjaxRoot + "/oauth/accounts?action=all&session=" + session,
        function(reply) { OAuthAccounts.resolve(reply.data); });
});

/**
 * Creates a new OAuth account.
 * @param {Object} data The account description with either the field id or
 * the fields serviceId and displayName.
 * @param {Function} callback A callback function which is called with the data
 * of the new account, if the authorization was successful.
 */
function createOAuthAccount(data, callback) {
    var params = "id" in data ?
            "id=" + encodeURIComponent(data.id) :
            "serviceId=" + encodeURIComponent(data.serviceId) +
            "&displayName=" + encodeURIComponent(data.displayName),
        action = "id" in data ? "callback_reauthorize" : "callback_create",
        // open window now to avoid popup blocking (same target; better than just not getting any popup!)
        win = window.open("newInfoItemHidden.html", "oauth", "resizable=0");
    // get data
    ox.JSON.get(AjaxRoot + "/oauth/accounts?action=init&" + params + "&session=" + session,
        function (reply) {
            var oldHandler, hasOldHandler = window[action] !== undefined;
            if (hasOldHandler) oldHandler = window[action];
            window[action] = function (reply) {
                win.close();
                if (hasOldHandler) {
                    window[action] = oldHandler;
                } else {
                    window[action] = undefined;
                }
                if (!("id" in data)) {
                    var data2 = ox.util.clone(reply.data);  // IE8 requires clone
                    OAuthAccounts.then(function(accounts) {
                        accounts.push(data2);
                        track({
                            type: "add",
                            what: "oauth_account",
                            data: { id: data2.id, displayName: data2.displayName },
                            text: "Added oauth-account " + data2.id
                        });
                        callback(data2);
                    });
                }
            };
            // set proper URL
            win.location.href = reply.data.authUrl;
        });
}

if (requireOAuth.required) enableOAuth(); else requireOAuth = enableOAuth;

register("OX_Configuration_Loaded_Complete", function() {
    var messaging = configGetKey("modules.messaging");
    if (   messaging
        && !(typeof messaging == "object" && messaging.module === false))
    {
        requireOAuth();
    }
});

function enableOAuth() {
    requireOAuth = emptyFunction;
    new ox.Configuration.InnerNode("configuration/oxsocial",_("My Social Configuration"));
    var node = new ox.Configuration.LeafNode("configuration/oxsocial/oauth",
        _("Accounts"));
    var split = new ox.Configuration.VSplit(node, _("Accounts"), 0.28);

    var services = new jQuery.Deferred();
    hookDeferred(services, function() {
        ox.JSON.get(AjaxRoot + "/oauth/services?action=all&session=" + session,
            function(reply) {
                var map = {};
                for (var i = 0; i < reply.data.length; i++) {
                    var service = reply.data[i];
                    map[service.id] = service.displayName;
                }
                services.resolve(map, reply.data);
            });
    });

    var grid, selection;
    split.init = function() {
        selection = new Selection();
        grid = new LiveGrid([{
            text: _("Service"),
            index: "serviceId",
            id: "serviceId",
            sortable: true,
            clear: LiveGrid.makeClear(""),
            set: function(div, serviceId) {
                services.then(function(map) {
                    LiveGrid.defaultSet(div, map[serviceId]);
                });
            }
        }, {
            text: _("Account name"),
            index: "displayName",
            id: "displayName",
            sortable: true,
            clear: LiveGrid.makeClear(""),
            set: LiveGrid.defaultSet
        }], selection);
        grid.sort = LiveGrid.localSort;
        grid.emptylivegridtext = _("No accounts created");
        split.list = grid;
        split.enableList = enableList;
        split.load = load;
        split.save = save;
        split.onNew = onNew;
        split.toolbar = temporary.configuration.newToolbar(_("Accounts"),
            [temporary.configuration.saveButton, {
                title: _("Accounts"),
                buttons: [{
                    title: _("Add"),
                    icons: ["img/menu/add_category.gif",
                            "img/menu/add_category_d.gif"],
                    action: function() { split.onNew(); }
                }, {
                    title: _("Delete"),
                    icons: ["img/menu/delete.gif", "img/menu/delete_d.gif"],
                    action: confirmDelete
                }]
            }]);

        var servicesCB = new ox.UI.ComboBox(_("Service"));
        services.then(function(map, array) {
            var ids = [], names = [];
            for (var i = 0; i < array.length; i++) {
                ids.push(array[i].id);
                names.push(noI18n(array[i].displayName));
            }
            servicesCB.setEntries(ids, names);
        });
        split.addWidget(servicesCB, {
            get: function(data, value) { data.serviceId = value; },
            set: function(data) {
                servicesCB.setEnabled(split.isNew);
                return data.serviceId;
            }
        });
        split.addWidget(new ox.UI.Input(_("Name")), "displayName");
        var text1 = new ox.UI.Text(format(
            //#. %s is the product name (default 'Open-Xchange Server')
            _("You need to authorize %1$s to use your account. Please click on the button below and the authorization will proceed in a separate window."),
            oxProductInfo.product_name));
        split.addWidget(text1, {
            get: emptyFunction,
            set: function(data) { text1.setVisible(split.isNew); }
        });
        var text2 = new ox.UI.Text(format(
            _("If the authorization expired or was revoked, you can repeat the authorization process by clicking on the button below. The authorization will proceed in a separate window."),
            oxProductInfo.product_name));
        split.addWidget(text2, {
            get: emptyFunction,
            set: function(data) { text2.setVisible(!split.isNew); }
        });
        var authorize = new ox.UI.Button(_("Authorize"));
        authorize.click = authorizeClick;
        split.addWidget(authorize);
    };

    var storage = new Storage(0, [], 0, 0, 0, 0,
        function(account) { return account.id; });
    function enableList() {
        ox.JSON.get(AjaxRoot + "/oauth/accounts?action=all&session=" + session,
            function(reply) {
                storage.remove(0, storage.ids.length);
                storage.append(reply.data);
                grid.enable(storage);
                grid.setSort(grid.sort_id, grid.sort_order);
                if (!reply.data.length) split.onNew();
                if (OAuthAccounts.isResolved()) {
                    OAuthAccounts.then(function(accounts) {
                        accounts.length = reply.data.length;
                        for (var i = 0; i < reply.data.length; i++) {
                            accounts[i] = reply.data[i];
                        }
                    });
                } else {
                    OAuthAccounts.resolve(reply.data);
                }
            });
    }

    function load(cont) {
        storage.newIterate(selection.getSelected(), emptyFunction,
            function(i, data) { cont(data); });
    }

    function save(data, cont) {
        // check empty fields
        if (data && data.displayName === "") {
            this.children[1].formnode.focus();
            //#. %1$s is the field name.
            //#, c-format
            triggerEvent("OX_New_Error", 4, format(_("The mandatory field %1$s is not defined."), _("Name")));
            cont(data);
            return;
        }
        
        ox.JSON.put(AjaxRoot + "/oauth/accounts?action=update&id=" + data.id +
            "&session=" + session, { displayName: data.displayName },
            function(reply) {
                storage.localUpdate([data.id], function(i, old) {
                    old.displayName = data.displayName;
                    return old;
                });
                track({
                    type: "update",
                    what: "oauth_account",
                    data: { id: data.id, displayName: data.displayName },
                    text: "Updated oauth-account " + data.id
                });
                cont(data);
            });
    }

    function onNew() { split.addNew({}); }

    function authorizeClick() {
        var data = split.get();
        createOAuthAccount(split.isNew ? { serviceId: split.children[0].get(),
                                           displayName: data.displayName }
                                       : { id: split.id },
            function(data) {
                storage.append([data]);
                split.set(data);
                split.original = split.get();
            });
    }

    function confirmDelete() {
        var count = split.list.selection.count;
        if (!count) return;
        newConfirm(
            ngettext("Delete account", "Delete accounts", count),
            ngettext("Are you sure you want to delete the selected account?",
                "Are you sure you want to delete the selected accounts?",
                count),
            AlertPopup.YES | AlertPopup.NO, null, null, handleDelete);
    }

    function handleDelete() {
        var ids = split.list.selection.getSelected();
        var request = new Array(ids.length);
        for (var i = 0; i < ids.length; i++) {
            request[i] = { module: "oauth/accounts", action: "delete",
                           id: ids[i] };
        }
        ox.JSON.put(AjaxRoot + "/multiple?continue=true&session=" + session, request,
            function(reply) {
                var deleted = [];
                for (var i = 0; i < reply.length; i++) {
                    if (reply[i].error) {
                        newServerError(reply[i]);
                    } else {
                        deleted.push(ids[i]);
                    }
                }
                if (deleted.length) {
                    split.list.deleteIDs(deleted);
                    OAuthAccounts.then(function(accounts) {
                        for (var i = 0; i < deleted.length; i++) {
                            for (var j = 0; j < accounts.length; j++) {
                                if (deleted[i] == accounts[j].id) {
                                    accounts = accounts.splice(j, 1);
                                    break;
                                }
                            }
                        }
                    });
                }
            });
    }
}
