/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var printviews=new Object();
function registerPrintView(printview) {
	printviews[printview]=true;
}
function isPrintableView(printview) {
	return printview in printviews;
}

function Print(windowtitle) {
	this.printName = windowtitle;
	this.width="1024px";
	this.height="768px";
}
Print.createContent = function (key,value,isimage) {
	if(isimage) {
		return { title: key, name : value, type: "content", "isimage": isimage };
	} else {
		return { title: key, name : value, type: "content", "isimage": false };
	}
}
Print.createLine = function(myheight, isimage) {
	if(isimage) {
		return { type: "line", height: myheight, "isimage": isimage };
	} else {
		return { type: "line", height: myheight, "isimage": false };
	}
}
Print.createTitle = function(value,isimage) {
	if(isimage) {
		return { type: "title", title : value, "isimage": isimage };
	} else {
		return { type: "title", title : value, "isimage": false };		
	}
}
Print.createHeader = function(header,isimage) {
	if(isimage) {
		return { type: "header", title : header, "isimage": isimage };
	} else {
		return { type: "header", title : header, "isimage": false };
	}
}
Print.createEmpty = function(isimage) {
	if(isimage) {
		return { type: "empty" ,"isimage": isimage } ;
	} else {
		return { type: "empty" ,"isimage": false } ;
	}

}
Print.createPicture = function (srcpathofimage) {
	return { type: "image", src : srcpathofimage, "width" : "76px", "height" : "76px" }
}

Print.createPriority = function (prio, isimage) {
	if(isimage) {
		return { type: "prio", src : getFullImgSrc("img/tasks/taskprio" + prio + ".gif"), "width" : "35px", "height" : "11px", "isimage": isimage }
	} else {
		return { type: "prio", src : getFullImgSrc("img/tasks/taskprio" + prio + ".gif"), "width" : "35px", "height" : "11px", "isimage": false }
	}
}
Print.createMail = function (mail,isimage) {
	if(isimage) {
		return { type: "mailtext", "mailtext" : mail, "isimage": isimage }
	} else {
		return { type: "mailtext", "mailtext" : mail, "isimage": false }
	}
}

Print.prototype = 
{
	setTitle : function (title) {
		this.printName=title;
	},
	
	printDetail: function (detailarray, closer) {
	    
	    var self = this;
	    
        // open native popup window
	    if (IE) {
	        this.printwindow = newWindow("newInfoItemHidden.html","width="+this.width+",height="+this.height+",left=50,top=50,resizable=yes,scrollbars=yes,menubar=yes,toolbar=yes,status=yes");
	        self.printDetailCont(detailarray);
	    } else {
    	    ox.api.window.open("newInfoItemHidden.html", {
    	        options: {
    	            width: parseInt(self.width),
    	            height: parseInt(self.height),
    	            resizable: "yes",
    	            menubar: "yes",
    	            toolbar: "no",
    	            location: "no",
    	            status: "yes",
    	            scrollbars: "yes"
    	        },
    	        closer: closer !== undefined && closer !== jQuery.noop ? closer : function (opt) {
    	            ox.api.window.close(opt.guid);
    	        },
    	        success: function (win, guid) {
    	            self.printwindow = win;
    	            self.printDetailCont(detailarray);
    	         }
    	    });
	    }
	},
	
	printDetailCont: function (detailarray) {

        // write document
        var printdoc = this.printwindow.document;
		printdoc.open();
		printdoc.write("<html style=\"overflow:auto\"><head><title>" + this.printName + "</title>");
		printdoc.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"print.css\"/>");
		printdoc.write("</head><body style=\"width:95%; height:95%\">");
		printdoc.write("<table class=\"detailprint\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%\">");

        function tryToPlugTheGapingSecurityHole(s) {
           return String(s).replace(/[<>"\n]/g, function(c) {
                return {
                    "<": "&lt;",
                    ">": "&gt;",
                    "\"": "&quot;",
                    "\n": "<br>"
                }[c];
            });
        }

		for(var i=0;i<detailarray.length;i++) {
			if(!detailarray[i]) { continue; }
			switch(detailarray[i].type) {
				case "content":
					printdoc.write("<tr class=\"printcontent\"><td class=\"printcontenttitle\" valign=\"top\" style=\"white-space: nowrap; "+(detailarray[i].title || "")+"\">"+detailarray[i].title+"</td><td class=\"printcontentname\">"+tryToPlugTheGapingSecurityHole(detailarray[i].name)+"</td>");
					break;
				case "title":
					printdoc.write("<tr><td class=\"printtitle\" colspan=\"2\">"+tryToPlugTheGapingSecurityHole(detailarray[i].title)+"</td>");
					break;
				case "line":
					printdoc.write("<tr><td class=\"printline\" colspan=\"2\" style=\"height:"+detailarray[i].height+";\"></td>");
					break;
				case "empty":
					printdoc.write("<tr><td colspan=\"2\">&nbsp;</td>");					
					break;
				case "prio":
					printdoc.write("<tr class=\"printcontent\"><td class=\"printcontenttitle\">" + _('Priority:') + "</td><td class=\"printcontentname\"><img src=\"" + detailarray[i].src + "\" style=\"width:" + detailarray[i].width + ";height:" + detailarray[i].height + "\"/></td>");
					break;
				case "header":
					printdoc.write("<tr><td colspan=\"2\" class=\"printheader\">"+tryToPlugTheGapingSecurityHole(detailarray[i].title)+"</td>");					
					break;
				case "mailtext":
					printdoc.write("</table><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%\"><tr><td colspan=\"2\" class=\"printmailcontent\">");
					var iframe = newnode("iframe",{display: "none"});
					body.appendChild(iframe);
					iframe.contentWindow.document.open();
					iframe.contentWindow.document.write(detailarray[i].mailtext);
					iframe.contentWindow.document.close();
					var str = iframe.contentWindow.document.body.innerHTML;
					// clean up html
			        var div = jQuery("<div/>").html(str);
			        div.find("*").contents()
    		            .filter(function () {
    		                return this.nodeType === 3;
    		            })
    		            .each(function () {
    		                var t = this.nodeValue, l = t.length;
    		                if (l > 80) {
    		                    t = t.replace(/(\\S{80})/g, "$1\u200b");
    		                    this.nodeValue = t;
    		                }
    		            });
			        // write mail content
					printdoc.write(div.html());
					body.removeChild(iframe);
					div = str = iframe = null;
					printdoc.write("</td>");
					break;
				case "mailattachments":
				    printdoc.write("<tr><td colspan=\"2\" align=\"center\"><br>");
				    for (var ia=0; ia<detailarray[i].mailattachments.length; ia++) {				    	
				    	var attach = detailarray[i].mailattachments[ia];
                        printdoc.write("<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\" style=\"width:70%; margin-top:10px\">");
                        printdoc.write("<tr>");
                        printdoc.write("<td class=\"printmailcontent\" align=\"center\"\"><b>" + attach.filename + "</b></td>");
                        printdoc.write("<td class=\"printmailcontent\">" 
                                + "<b>" + _("Content-Type:") + "</b> " + attach.content_type 
                                + (attach.size ? "<br><b>" + _("Size:") + "</b> " + bytesToString(attach.size) : "")
                                + "</td>");
                        printdoc.write("</tr>");
                		printdoc.write("</table>");	
				    }
				    printdoc.write("</td>");
				    break;
			}
			if(!detailarray[i]["isimage"]) {
				printdoc.write("</tr>");
			} else {
				for(var i2=0;i2<detailarray.length;i2++) {
					if(detailarray[i2].type == "image") {
						printdoc.write("<td style=\"width:90px\"><div class=\"printimage\"><img src=\""+detailarray[i2].src+"\" style=\"width:"+detailarray[i].width+";height:"+detailarray[i2].height+"\"/></div></td></tr>");
					}
				}
			}
		}
		printdoc.write("</table>");
		printdoc.write("</body>");
		printdoc.write('<script type="text/javascript">window.setTimeout(function() { window.focus(); window.print(); }, 10);</script>');
		printdoc.write("</html>");
		printdoc.close();
	},
	printLiveGrid : function(livegrid, printAll) {
		var Self=this;
		this.printdiv=document.createElement("div");
		this.printdiv.style.width="100%";
		if (printAll !== true && menucountselected !=0) {
			livegrid.print(this.printdiv,function () { Self.printWindow(); },true);
		} else {
			livegrid.print(this.printdiv,function () { Self.printWindow(); },false);
		}
	},
	printWindow : function() {
		this.printwindow = newWindow("newInfoItemHidden.html","width="+this.width+",height="+this.height+",left=50,top=50,resizable=yes,menubar=yes,toolbar=yes,status=yes");
		var printdoc =this.printwindow.document;
		printdoc.open();
		printdoc.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">");
		printdoc.write("<html><head><title>"+this.printName+"</title><link rel=\"stylesheet\" type=\"text/css\" href=\"print.css\"/></head>");
		printdoc.write("<body style=\"width:95%;height:95%\">");
		printdoc.write(this.printdiv.innerHTML);
		printdoc.write("</body>");
		printdoc.write('<script type="text/javascript">window.setTimeout(function() { window.focus(); window.print(); window.close(); }, 500);</script>');
		printdoc.write("</html>");
		printdoc.close();
	}
}
var globalprint = new Print("");
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * 
 */

  //////////////////
 //   LiveGrid   //
//////////////////

/**
 * The LiveGrid constructor.
 * @constructor
 * @param {Array} columns An array with column definitions.
 * Each column definition is an object with the following fields:
 * <ul><li>text is used as the column header,</li>
 * <li>i18n specifies whether the text is translated or used directly as
 * innerHTML (if text is an I18nString, i18n should be false),</li>
 * <li>index is used to extract the value of this column from an item object.
 * If not specified, the entire object is passed to {@link #set}.</li>
 * <li>width specifies the width of the column as a CSS length value,</li>
 * <li>style specifies an object with style attributes as elements,</li>
 * <li>sortable specifies whether sorting based on this column is supported,</li>
 * <li>id specifies the column ID,</li>
 * <lI>clear specifies a function which is called with an HTML DIV element as
 * parameter whenever the content of that DIV must be fetched from
 * the server. In the case of a static text in every row, {@link #makeClear}
 * can be used to create a function for this field.</li>
 * <li>set specifies a function which is called with an HTML DIV element and
 * the contents of that DIV whenever new contents must be displayed in the DIV.
 * In the case of pure text content, {@link #defaultSet} can be used
 * directly.</li></ul>
 * @param {Selection} selection The selection to use.
 * @param {String} module The name of a module for which to register Drag'n'Drop
 * functions.
 */
function LiveGrid(columns, selection, module) {
	this.disablehover=false;
	this.emptylivegridtext = _("This folder is empty");

	/**
	 * @private
	 */
	this.columns = columns;
	
	/**
	 * @private
	 */
	this.clickprocessed=false;

	/**
	 * The selection displayed in this LiveGrid.
	 */
	this.selection = selection || console.error("LiveGrid without Selection");
	
	/**
	 * @private
	 */
	this.module = module;

	/**
	 * Index of the anchor row.
	 * The anchor is used for multiple-selects with the Shift key.
	 * 0&nbsp;&lt;=&nbsp;anchor&nbsp;&lt;&nbsp;rowCount.
	 * @private
	 */
	this.anchor = 0;
	
	/**
	 * Index of the focus row.
	 * The focus is used for all selects.
	 * 0&nbsp;&lt;=&nbsp;focus&nbsp;&lt;&nbsp;rowCount.
	 * @private
	 */
	this.focus = 0;
	
	/**
	 * @private
	 * Sort order. Either "asc" or "desc".
	 */
	this.sort_order = "asc";
	
	/**
	 * @private
	 * ID of the column used for sorting. null if sorting is disabled.
	 */
	this.sort_id = null;
	
	for (var i = 0; i < columns.length; i++)
		if (!this.sort_id && columns[i].sortable) this.sort_id = columns[i].id;

	this.lineHeight = 1.6;
	
	/**
	 * @private
	 */
	this.from = 0;

	/**
	 * @private
	 */
	this.to = 0;
	
	/**
	 * @private
	 */
	this.rowcache = [];
	
	/**
	 * @private
	 * {Int: true}
	 */
	this.unfetched = {};

	var Self = this;

	/**
	 * @private
	 */
	this.fullRedraw = true;
	
	/**
	 * @private
	 */
	this.scroll_cb = function() { Self.scroll(); };
	
	/**
	 * @private
	 */
	this.key_cb = function(e) { return Self.key(e); };

	/**
	 * @private
	 */
	this.keydown_cb = function(e) {
		this.keydown = true;
		return Self.key(e);
	};
	
	/**
	 * @private
	 */
	this.keypress_cb = function(e) {
		if (this.keydown)
			this.keydown = false;
		else
			return Self.key(e);
	};
	
	/**
	 * @private
	 */
	this.mousedown_cb = function(e) { Self.mousedown(e); };
	
	/**
	 * @private
	 */
	this.ctxtmenu_cb = function(e) { Self.ctxtmenu(e); };
	
	/**
	 * @private
	 */
	this.click_cb = function(e) { Self.click(e); };
	
	this.language_cb = function(e) { Self.scroll(true); };
	/**
	 * @private
	 */
	this.dblclick_cb = function (e) {
	    // not top element?
        if (e.target !== Self.parent) {
            Self.dblclick(e);
        }
	};
	
	/**
	 * @private
	 */
	this.focus_cb = function() {
		focusedElement = Self.parent;
		Self.updateStyles();
	};
	
	/**
	 * @private
	 */
	this.blur_cb = function() {
		if (focusedElement == Self.parent)
			focusedElement = null;
		Self.updateStyles();
	};
	
	/**
	 * @private
	 */
	this.change_cb = function(from, to) {
		Self.rowCount = Self.storage.ids.length;
		from = Math.max(from, Self.from);
		to = Math.min(to, Self.to);
		for (var i = from; i < to; i++) Self.unfetched[i] = true;
		Self.doScroll();
		Self.updateStyles();
		Self.events.trigger("Changed", Self.storage);
	};
	
	/**
	 * @private
	 */
	this.selected_cb = function(count, e) {
		Self.updateStyles();
		Self.events.trigger("Selected", count, e);
	};
	
	/**
	 * Events triggered by this LiveGrid.
	 * <dl><dt>Selected</dt><dd>The selection has changed. Triggered only when
	 * this grid is enabled. Parameters:
	 * <ul><li>Number of selected elements.</li></ul></dd>
	 * <dt>Activated</dt><dd>One or more elements have been activated.
	 * Parameters:
	 * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
	 * <dt>Delete</dt><dd>One or more elements should be deleted.
	 * Parameters:
	 * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
	 * </dl>
	 */
	this.events = new Events();
	
	// update width (hack for portal refactoring; live grids grow endlessly)
	this.autoWidth = true;
}

function getRowIndex(e) {
	var n = e.target || e.srcElement;
	while (n.oxRowIndex == undefined && n.parentNode) n = n.parentNode;
	return n.oxRowIndex;
}

LiveGrid.prototype = {
	/**
	 * How many additional invisible rows to create to allow flicker-free
	 * scrolling at faster speeds.
	 */
	preview: 20,
	
	/**
	 * Granularity of row fetches.
	 */
	granularity: 1,
	
    /**
     * Recreates the LiveGrid, taking into account updated column definitions
     * etc.
     */
	recreate: function() {
        var storage = this.storage;
        var oldHeader = this.headerNode;
        this.disable();
        for (var i in this.rows) this.deleteRow(i);
        this.rowcache = [];
        this.from = 0;
        this.to = 0;
        this.ruWidth = 0;
        var header = this.getHeader();
        if (oldHeader && oldHeader.parentNode) {
            oldHeader.parentNode.replaceChild(header, oldHeader);
        }
        if (this.parent) {
            this.parent.removeChild(this.heightDiv);
            this.parent.removeChild(this.emptyMessage);
            this.getTable(this.parent);
        }
        if (this.hoverNode) {
            this.addHover(this.hoverNode, this.hoverCallback);
            if (this.hoverSizeNode) this.hover.setSize(this.hoverSizeNode);
        }
        if (storage) this.enable(storage);
    },
	
	/**
	 * Creates a DOM tree for the headers of the LiveGrid.
	 * The returned DOM tree must be inserted in its place in the document.
	 * @type Object
	 * @return A DOM tree which displays the headers of the LiveGrid.
	 * @see #getTable
	 */
	getHeader: function() {
		var Self = this;
		this.headers = new Array(this.columns.length);
		this.outer_headers = new Array(this.columns.length);
		this.arrows = new Array(this.columns.length);
		this.arrow_events = new Array(this.columns.length);
		for (var i in this.columns) this.arrow_events[i] = sortHandler(i);
		function sortHandler(i) {
			return function(e) {
				Self.setSort(Self.columns[i].id,
					(Self.sort_id == Self.columns[i].id &&
					 Self.sort_order == "asc") ? "desc" : "asc");
				stopEvent(e);
			}
		}
		this.ids = {};
		for (var i in this.columns) this.ids[this.columns[i].id] = i;
		var colgroup = this.getColGroup();
		colgroup.appendChild(this.ruCorner = newnode("col", {width: "0"}));
		var tbody = newnode("tbody",{verticalAlign : "top"});
		var table = this.headerNode = newnode("table", {tableLayout: "fixed"},
		                    {cellPadding: "0", cellSpacing: "0", className: "livegrid"},
		                    [colgroup, tbody]);
		var row = newnode("tr", {height: this.lineHeight + "em"},
		                  {className: "th"});
		for (var i = 0; i < this.columns.length; i++) {
			var outerCell, innerCell;
            var headerClassName = this.columns[i].name
                ? "header livegrid-column-" +
                      this.columns[i].name.join(" livegrid-column-")
                : "header";
			if (this.columns[i].sortable) {
				outerCell = this.outer_headers[i] =
					newnode("th", this.columns[i].style, {className: headerClassName}, [
						newnode("table", 0, {cellPadding: "0", cellSpacing: "0"}, [
							newnode("tbody", 0, 0, [
								newnode("tr", 0, 0, [
									innerCell = this.headers[i] = newnode("th", {whiteSpace: "nowrap"}),
									newnode("th", 0, 0, [
										this.arrows[i] = newnode("img", {verticalAlign: "middle"}, {src: getFullImgSrc("img/dummy.gif"), width: "16", height: "16"})
									])
								])
							])
						])
					]);
			} else
				innerCell = outerCell = this.headers[i] = this.outer_headers[i] =
					newnode("th", this.columns[i].style, {className: headerClassName});
			if (this.columns[i].text instanceof I18nString) {
                innerCell.appendChild(addTranslated(this.columns[i].text));
            } else if (this.columns[i].i18n) {
			    var ctx = this.columns[i].i18n;
                if (ctx === true) ctx = "";
				var node = new I18nNode(pgettext(ctx, this.columns[i].text));
				node.parent = innerCell;
				node.update = function() {
					this.parent.title = this.node.data = this.callback();
				};
				innerCell.appendChild(node.node);
				node.update();
			} else switch (typeof this.columns[i].text) {
                case "string":
				    innerCell.innerHTML = this.columns[i].text;
                    break;
                case "function":
                    innerCell.appendChild(addTranslated(this.columns[i].text));
                    break;
                default:
                    innerCell.appendChild(this.columns[i].text);
            }
			row.appendChild(outerCell);
		}
		row.appendChild(newnode("th"));
        var index = this.ids[this.sort_id];
		if (this.sort_id && this.arrows[index]) {
			this.arrows[index].src = 
				this.sort_order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
				this.sort_order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
				getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid.setSortClass(this.outer_headers[index], true);
        }
		tbody.appendChild(row);
		return table;
	},
	
	/**
	 * Adds the scrollable area of the LiveGrid to the specified parent node.
	 * The parent node should have an explicit size and "overflow: auto".
	 */
	getTable: function(parent) {
	    parent.onselectstart = function() { return false; };
		this.rows = {};
		var last = this.columns.length - 1;
		this.parent = parent;
		this.heightDiv = newnode("div", {height: "0em"}, {className: "livegrid"});
		parent.appendChild(this.heightDiv);
		parent.tabIndex = 0;
		parent.style.outline = "none";
		parent.style.overflowX = "hidden";
		parent.hideFocus = true;
		var emptyText = addTranslated(this.emptylivegridtext);
		this.emptyMessage = newnode("div",
			{display: "none", position: "absolute", textAlign: "center", 
			 width: "100%", marginTop: "5px"}, 0,
			[emptyText]);
		parent.appendChild(this.emptyMessage);
		var tr = newnode("tr");
		for (var i = 0; i < this.columns.length; i++)
			tr.appendChild(newnode("td", this.columns[i].style,
			                       {className: "cell"}));
		this.rowTemplate = newnode("table", 0,
			{cellPadding: "0", cellSpacing: "0", className: "tr"},
			[this.getColGroup(), newnode("tbody", 0, 0, [tr])]);
	},
	
	/**
	 * Adds a hover to the LiveGrid.
	 * This method should be called between getTable() and the first enable(). 
	 * @param {Object} hover A DOM node which serves as a hover. It should be
	 * attached directly to the body and have the CSS style
	 * "position: absolute".
     * @param {Function} callback A callback function which is called when
     * the hover is shown. As parameters, it receives the ID of
     * the entry over which the mouse is hovering and whether the hover was
     * triggered manually.
	 * @type {Object}
	 * @return A new Hover object. The enable and disable methods of the hover
	 * object will be called automatically by the LiveGrid.
	 */
	addHover: function(hover, callback) {
        this.hoverNode = hover;
	    this.hoverCallback = callback;
		this.hover = new Hover(this.heightDiv, hover);
		var Self = this;
        this.hover.setSize = function(node) {
            Self.hoverSizeNode = node;
            return Hover.prototype.setSize.call(this, node);
        }
		this.hover.onShow = function(node, manual) {
			var i = node.oxRowIndex;
			if (i !== undefined)
				callback(Self.storage.ids[i], manual);
			else
				return false;
		}
		return this.hover;
	},
	
	/**
	 * @private
	 */
	getColGroup: function() {
		var colgroup = newnode("colgroup");
		for (var i = 0; i < this.columns.length; i++) {
			var w = this.columns[i].width;
			colgroup.appendChild(newnode("col", w ? {width: w} : 0));
		}
		return colgroup;
	},
	
	/**
	 * Appends the contents either of the entire grid or of selected rows to
	 * the specified node.
	 * @param {Object} parent The node to append the data to.
	 * @param {Function} cb The callback to call after all data is appended.
	 * @param {Boolean} selected True if only selected rows should be appended.
	 * Otherwise, all rows are appended.
	 */
	print: function(parent, cb, selected) {
		var doc = parent.ownerDocument;
		var tr = doc.createElement("tr");
		for (var i = 0; i < this.columns.length; i++) {
			var th = doc.createElement("th");
			if (this.columns[i].i18n)
				th.appendChild(doc.createTextNode(_(this.columns[i].text)) || "\u00a0");
			else
				th.innerHTML = this.columns[i].text || "\u00a0";
			tr.appendChild(th);
		}
		var table = newnode("table", {width: "100%"}, {border: 1},
			[newnode("thead", 0, 0, [tr], doc)], doc);
		var trs = [];
		var Self = this;
		function set(n, obj) {
			trs[n] = doc.createElement("tr");
			for (var i = 0; i < Self.columns.length; i++) {
				var td = doc.createElement("td");
				trs[n].appendChild(td);
				var col = Self.columns[i];
				col.set(td, col.index ? obj[col.index] : obj, obj);
			}
		}
		function final_() {
			var tbody = newnode("tbody", 0, 0, 0, doc);
			for (var i = 0; i < trs.length; i++) 
				if (trs[i]) tbody.appendChild(trs[i]);
			table.appendChild(tbody);
			parent.appendChild(table);
			if(trs.length==0) {
				//return; 
			} 
			cb();
		}
		this.storage.newIterate(
			selected ? this.selection.getSelected() : this.storage.ids,
			emptyFunction, set, final_);
	},
	
	/**
	 * Displays the specified sort order as an arrow in the headers.
	 * @param {String} id The column ID used for sorting, or null for no
	 * sorting.
	 * @param {String} order The sort order. One of "asc", "desc" or null for no
	 * sorting.
	 */
	setSort: function(id, order) {
		if (this.sort_id && id != this.sort_id) {
            var index = this.ids[this.sort_id];
			this.arrows[index].src =
                getFullImgSrc("img/dummy.gif");
            LiveGrid.setSortClass(this.outer_headers[index], false);
        }
        var index = this.ids[id];
        if ((index || index === 0) && this.arrows[index] !== undefined) {
    		this.arrows[index].src = 
    			order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
    			order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
    			getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid.setSortClass(this.outer_headers[index], true);
        }
		this.sort_id = id;
		this.sort_order = order;
		if (this.storage) this.sort(id, order);
	},
	
	/**
	 * Callback function which changes the displayed data.
	 * Should be overridden in each instance.
	 * @param {String} id The column ID used for sorting, or null for no
	 * sorting.
	 * @param {String} order The sort order. Either "asc" or "desc".
	 */
	sort: emptyFunction,

	getSelectedIDs: function() {
		return this.selection.getSelected();
	},
	
	/**
	 * Deletes items with specified object IDs from the storage and from
	 * the selection. If the entire selection was deleted, the first unselected
	 * item at or after the focus is selected.
	 */
	deleteIDs: function (ids) {
	    if (this.storage) {
    		var sids = {};
    		for (var i = 0; i < ids.length; i++)
    			sids[this.storage.serialize(ids[i])] = true;
    		while (this.storage.getSID(this.focus) in sids) this.focus++;
    		var newID = this.storage.ids[this.focus];
    		this.storage.removeIDs(ids);
    		this.selection.deselectSIDs(sids);
    		this.focus = newID ? this.storage.getIndex(newID) : 0;
    		if (!this.selection.count)
    			this.selection.click(this.focus);
	    }
	},
	
	updateSelected: function(callback) {
		if (this.storage) {
			this.storage.localUpdate(this.selection.getSelected(), callback);
		}
	},

	/**
	 * Initializes the LiveGrid.
	 * The DOM tree must have been created by {@link #getHeader} and
	 * {@link #getTable}.
	 * @see #getHTML
	 */
	enable: function(storage) {
		if (this.storage) {
			this.storage.events.unregister("Changed", this.change_cb);
		} else {
			for (var i in this.arrows)
				addDOMEvent(this.outer_headers[i], "click", this.arrow_events[i]);
			addDOMEvent(this.parent, "scroll", this.scroll_cb);
			addDOMEvent(this.parent, "keydown", this.keydown_cb);
			addDOMEvent(this.parent, "keypress", this.keypress_cb);
			addDOMEvent(this.parent, "mousedown", this.mousedown_cb);
			addDOMEvent(this.parent, "click", this.click_cb);
			// bind double click via jQuery (due to bug #14560)
            jQuery(this.parent).bind("dblclick", this.dblclick_cb);
			addDOMEvent(this.parent, "focus", this.focus_cb);
			addDOMEvent(this.parent, "blur", this.blur_cb);
            if (this.contextmenu)
                addDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
			if (this.hover && !this.disablehover) this.hover.enable();
			resizeEvents.register("Resized", this.scroll_cb);
			register("LanguageChanged",this.language_cb);
			if (this.module && (this.module != "links")) {
				var Self = this;
				var disabled;
				var validfield;
				switch(this.module) {
					case "calendar": disabled=calendardefaultdisabled;	validfield=5; break;
					case "tasks":	disabled=taskdefaultdisabled; validfield=3; break;
					case "contacts": disabled=contactdefaultdisabled; validfield=2; break;
					case "infostore": disabled=infostoredefaultdisabled; validfield=3; break;
					case "mail": disabled=maildefaultdisabled; validfield=5; break;
				}
				this.dragEvent = registerSource(this.heightDiv, this.module, function() {
					var myelements=clone(Self.selection.getSelected());
					if(myelements.length==1) {
						Self.storage.newIterate(myelements,emptyFunction,function (index,id) {
							myelements[0].livegridfield=id[validfield];
						})
					}
					objMoveCopy.begin(Self.module,myelements);
					return objMoveCopy;
					
				},null,null,disabled,defaultdisabledremove);
			}
		}
		storage.events.register("Changed", this.change_cb);
		this.storage = storage;
		this.rowCount = storage.ids.length;
		this.selection.setStorage(storage);
		this.selection.events.register("Selected", this.selected_cb);
		this.scroll(true);
	},
	
	disable: function() {
		if (!this.storage) return;
		this.selection.events.unregister("Selected", this.selected_cb);
		this.storage.events.unregister("Changed", this.change_cb);
		this.storage = null;
		this.selection.setStorage(null);
		for (var i in this.arrows)
			removeDOMEvent(this.outer_headers[i], "click", this.arrow_events[i]);
		removeDOMEvent(this.parent, "scroll", this.scroll_cb);
		removeDOMEvent(this.parent, "keydown", this.keydown_cb);
		removeDOMEvent(this.parent, "keypress", this.keypress_cb);
		removeDOMEvent(this.parent, "mousedown", this.mousedown_cb);
		removeDOMEvent(this.parent, "click", this.click_cb);
		jQuery(this.parent).unbind("dblclick", this.dblclick_cb);
		removeDOMEvent(this.parent, "focus", this.focus_cb);
		removeDOMEvent(this.parent, "blur", this.blur_cb);
        if (this.contextmenu)
            removeDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
		if (this.hover) this.hover.disable();
		resizeEvents.unregister("Resized", this.scroll_cb);
		unregister("LanguageChanged",this.language_cb);
		if (this.module) {
			unregisterSource(this.parent, this.dragEvent);
		}
	},
	
	/**
	 * @private
	 */
	createRow: function() {
		var last = this.columns.length - 1;
		var row = {tr: this.rowTemplate.cloneNode(true),
		           cells: new Array(this.columns.length)};
		for (var i = 0, cell = row.tr.lastChild.firstChild.firstChild; cell;
		     i++, cell = cell.nextSibling)
		{
			row.cells[i] = cell;
			this.columns[i].clear(cell);
		}
		this.heightDiv.appendChild(row.tr);
		if (!this.rowHeight) this.rowHeight = row.tr.offsetHeight;
		return row;
	},

	/**
	 * To be removed.
	 * @private
	 */
	updateStyles: function() {
		for (var i in this.rows) {
			var newclass = this.selection.get(i) ? "tr selected" : i%2 ? "tr_h " : "tr ";
			if (focusedElement == this.parent && i == this.focus)
				newclass += "focused";
			var tr = this.rows[i].tr;
			if (tr.className != newclass) tr.className = newclass;
		}
	},

	/**
	 * @private
	 */
	deleteRow: function(index) {
		var row = this.rows[index];
		row.tr.style.display = "none";
		this.rowcache.push(row);
		delete this.rows[index];
		delete this.unfetched[index];
	},

	/**
	 * @private
	 */
	insertRow: function(index) {
		var row = this.rows[index] =
			this.rowcache.length ? this.rowcache.pop() : this.createRow();
		row.tr.className = this.selection.get(index) ? "tr selected" : index%2 ? "tr_h" : "tr";
		row.tr.style.display = "";
		row.tr.style.top = (index * this.rowHeight) + "px";
		row.tr.oxRowIndex = index;
		this.unfetched[index] = true;
	},

	/**
	 * @private
	 */
	scroll: function(fullRedraw) {
		if (fullRedraw) this.fullRedraw = true;
		if (this.scrollTimeout) clearTimeout(this.scrollTimeout);
		var Self = this;
		this.scrollTimeout = setTimeout(function() {
			Self.scrollTimeout = null;
			Self.doScroll();
		}, 0);
	},
	
	/**
	 * @private
	 */
	calculateRowHeight: function() {
		var row = this.createRow();
		row.tr.style.display = "none";
		this.rowcache.push();
	},

	/**
	 * @private
	 */
	doScroll: function() {
		var newruWidth = this.parent.offsetWidth - this.parent.clientWidth;
		if (newruWidth > 0 && newruWidth != this.ruWidth) {
			this.ruCorner.style.width = newruWidth + "px";
			this.ruWidth = newruWidth;
		}
		if (!this.rowHeight) this.calculateRowHeight();
		this.height = Math.floor(this.parent.clientHeight / this.rowHeight);
		var len = this.storage ? this.storage.ids.length : 0;
		var newHeight = (len * this.rowHeight) + "px"
		var hDivStyle = this.heightDiv.style;
		if (newHeight != hDivStyle.height) hDivStyle.height = newHeight;
		var Self = this;
		// update width?
		if (this.autoWidth) {
		    if (this.heightDiv.offsetWidth != this.parent.clientWidth) {
		        hDivStyle.width = Self.parent.clientWidth + "px";
		    }
		}
		var scrolltop = this.parent.scrollTop;
		var from2 = Math.max(0, Math.floor(                           scrolltop  / this.rowHeight / this.granularity) * this.granularity - this.preview);
		var to2 = Math.min(len, Math.ceil((this.parent.clientHeight + scrolltop) / this.rowHeight / this.granularity) * this.granularity + this.preview);
		var Self = this;
		if (this.fullRedraw || from2 != this.from || to2 != this.to) {
			if (this.fullRedraw || from2 > this.to || this.from > to2) {
				for (var i = this.from; i < this.to; i++) this.deleteRow(i);
				for (var i = from2; i < to2; i++) this.insertRow(i);
			} else {
				for (var i = this.from; i < from2; i++) this.deleteRow(i);
				for (var i = to2; i < this.to; i++) this.deleteRow(i);
				for (var i = from2; i < this.from; i++) this.insertRow(i);
				for (var i = this.to; i < to2; i++) this.insertRow(i);
			}
			this.from = from2;
			this.to = to2;
		}
		this.fullRedraw = false;
        this.emptyMessage.style.display = (!this.storage || len) ? "none"
                                                                : "block";
		var ids = [];
		for (var i in this.unfetched) ids.push(this.storage.ids[i]);
		if (ids.length) {
			if (this.iterateRequest) this.storage.cancel(this.iterateRequest);
			this.iterateRequest = this.storage.newIterate(ids, function(n) {
				if (!(n in Self.unfetched)) return;
				var cellrow = Self.rows[n].cells;
				for (var i in cellrow) Self.columns[i].clear(cellrow[i]);
			}, function(n, obj) {
				if (!(n in Self.unfetched)) return;
				delete Self.unfetched[n];
                var cellrow = Self.rows[n].cells;
				for (var i in cellrow) {
					var col = Self.columns[i];
					col.set(cellrow[i], col.index ? obj[col.index] : obj, obj);
				}
			}, function() { Self.iterateRequest = null; }, 20);
		}
	},
	
	/**
	 * @private
	 */
	scrollTo: function(y) {
		var parent = this.parent;
		setTimeout(function() { parent.scrollTop = y; }, 0);
	},
	
	/**
	 * Scrolls if necessary to display the currently focused row.
	 */
	showFocus: function() {
		var scrolltop = this.parent.scrollTop;
		if (!this.rowHeight) this.calculateRowHeight();
		if (this.focus < scrolltop / this.rowHeight)
			this.scrollTo(this.focus * this.rowHeight);
		else {
			var height = this.parent.clientHeight;
			if (this.focus + 1 > (scrolltop + height) / this.rowHeight)
				this.scrollTo((this.focus + 1) * this.rowHeight - height);
		}
	},

	/**
	 * @private
	 */
	key: function(e) {
		if (!this.storage) return;
		switch (e.keyCode || e.which) {
		case 13: // enter
			this.events.trigger("Activated", this.selection.getSelected());
			break;
		case 32: // spacebar
			this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 46: // delete
		case 108: // numpad delete
			this.events.trigger("Delete", this.selection.getSelected());
			break;
		case 38: // arrow up
			if (this.focus > 0) this.focus--;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 40: // arrow down
			if (this.focus < this.rowCount - 1) this.focus++;
			if (!(Mac ? e.metaKey : e.ctrlKey)) {
				this.selection.click(this.focus, e);
			}
			this.showFocus();
			break;
		case 33: // page up
			this.focus -= this.height;
			if (this.focus < 0) this.focus = 0;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 34: // page down
			this.focus += this.height;
			if (this.focus >= this.rowCount) this.focus = this.rowCount - 1;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 35: // end
			this.focus = this.rowCount - 1;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 36: // home
			this.focus = 0;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 65: // A
		case 97: // a
			if (e.ctrlKey)
				this.selection.select(0, this.storage.ids.length);
			break;
		default:
			return;
		}
		this.updateStyles();
		stopEvent(e);
		return false;
	},
	
    /**
     * @private
     */
    mousedown: function(e) {
        this.clickprocessed = false;
        var focus = getRowIndex(e);
        if (this.storage.ids.length < this.height) {
            if (focus === undefined) focus = -1; else this.focus = focus;
            if(!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        } else if (focus !== undefined) {
            this.focus = focus;
            if(!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        }
        setFocus(this.parent);
    },

	/**
	 * @private
	 */
	ctxtmenu: function(e) {
		stopEvent(e);
        this.contextmenu.display(e.clientX, e.clientY, this.selection);
	},
	
	/**
	 * @private
	 */
	click: function(e) {
		if (this.clickprocessed) return;
		var focus = getRowIndex(e);
		if (this.storage.ids.length < this.height) {
			if (focus === undefined) focus = -1; else this.focus = focus;
			this.selection.click(focus, e);
		} else if (focus !== undefined) {
			this.focus = focus;
			this.selection.click(focus, e);
		}
		setFocus(this.parent);
	},
	
	/**
	 * @private
	 */
	dblclick: function(e) {
		if (!this.storage) return;
		this.focus = getRowIndex(e) || 0;
		this.events.trigger("Activated", this.selection.getSelected());
	}
};

LiveGrid.setSortClass = classNameSetter("livegrid-th-sorted");


/**
 * Default set function for use in the second parameter of the constructor.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified content value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} text The text to set in the DIV element.
 */
LiveGrid.defaultSet = function(div, text) {
	text = text || "\u00a0";
	if (div.firstChild)
		div.firstChild.data = text;
	else
		div.appendChild(document.createTextNode(text));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid.dateSet = function(div, date) {
	var dateString = "\u00a0";
	if (null != date) dateString = formatDate(date, "date");
	if (div.firstChild)
		div.firstChild.data = dateString;
	else
		div.appendChild(document.createTextNode(dateString));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid.dateSetTime = function(div, date) {
    var dateString = "\u00a0";
    if (null != date) dateString = formatDate(date, "datetime");
	if (div.firstChild)
		div.firstChild.data = dateString
	else
		div.appendChild(document.createTextNode(dateString));
};

/**
 * Creates a clear function for use in the second parameter of the constructor.
 * This function creates a function which sets all DIV elements of the LiveGrid
 * to the text which is specified as parameter to this function.
 * @param {String} text The text to set in DIV elements.
 * @type Function
 * @return A function which takes a HTML DIV element as parameter, adds a text
 * node to it, and sets the text to a constant value.
 */
LiveGrid.makeClear = function(text) {
	return function(div) {
		if (div.firstChild)
			div.firstChild.data = text;
		else
			div.appendChild(document.createTextNode(text));
	};
};

/**
 * Sort function for use with purely local storages.
 */
LiveGrid.localSort = function(id, order) {
    var a = [];
    var Self = this;
    this.storage.newIterate(this.storage.ids, emptyFunction,
        function(div, data) { a.push(data); }, function() {
            Self.storage.remove(0, Self.storage.ids.length);
            a.sort(order == "asc" ? function(a, b) {
                return a[id] > b[id] ? 1 : a[id] < b[id] ? -1 : 0;
            } : function(b, a) {
                return a[id] > b[id] ? 1 : a[id] < b[id] ? -1 : 0;
            });
            Self.storage.append(a);
        });
};















function LiveGrid2(columns, selection, module) {
    this.disablehover=false;
    this.emptylivegridtext = _("This folder is empty");

    /**
     * @private
     */
    this.columns = columns;
    
    /**
     * @private
     */
    this.clickprocessed=false;

    /**
     * The selection displayed in this LiveGrid2.
     */
    this.selection = selection || console.error("LiveGrid2 without Selection");
    
    /**
     * @private
     */
    this.module = module;
    this.dndModule = module;
    /**
     * Index of the anchor row.
     * The anchor is used for multiple-selects with the Shift key.
     * 0&nbsp;&lt;=&nbsp;anchor&nbsp;&lt;&nbsp;rowCount.
     * @private
     */
    this.anchor = 0;
    
    /**
     * Index of the focus row.
     * The focus is used for all selects.
     * 0&nbsp;&lt;=&nbsp;focus&nbsp;&lt;&nbsp;rowCount.
     * @private
     */
    this.focus = 0;
    
    /**
     * @private
     * Sort order. Either "asc" or "desc".
     */
    this.sort_order = "asc";
    
    /**
     * @private
     * ID of the column used for sorting. null if sorting is disabled.
     */
    this.sort_id = null;
    
    for (var i = 0; i < columns.length; i++)
        if (!this.sort_id && columns[i].sortable) this.sort_id = columns[i].sort;

    this.lineHeight = 1.6;
    this.rowHeight = 0;
    this.rowMargin = 0;
    
    /**
     * @private
     */
    this.from = 0;

    /**
     * @private
     */
    this.to = 0;
    
    /**
     * @private
     */
    this.rowcache = [];
    
    /**
     * @private
     * {Int: true}
     */
    this.unfetched = {};

    var Self = this;

    /**
     * @private
     */
    this.fullRedraw = true;
    
    /**
     * @private
     */
    this.scroll_cb = function() { Self.scroll(); };
    
    /**
     * @private
     */
    this.key_cb = function(e) { return Self.key(e); };

    /**
     * @private
     */
    this.keydown_cb = function(e) {
        this.keydown = true;
        return Self.key(e);
    };
    
    /**
     * @private
     */
    this.keypress_cb = function(e) {
        if (this.keydown)
            this.keydown = false;
        else
            return Self.key(e);
    };
    
    /**
     * @private
     */
    this.mousedown_cb = function(e) { Self.mousedown(e); };
    
    /**
     * @private
     */
    this.ctxtmenu_cb = function(e) { Self.ctxtmenu(e); };
    
    /**
     * @private
     */
    this.click_cb = function(e) { Self.click(e); };
    
    /**
     * @private
     */
    this.dblclick_cb = function (e) {
    	Self.dblclick(e);
    };
    
    /**
     * @private
     */
    this.focus_cb = function() {
        focusedElement = Self.parent;
        Self.updateStyles();
    };
    
    this.language_cb = function(e) { Self.scroll(true); }
    
    /**
     * @private
     */
    this.blur_cb = function() {
        if (focusedElement == Self.parent)
            focusedElement = null;
        Self.updateStyles();
    };
    
    /**
     * @private
     */
    this.change_cb = function(from, to) {
        Self.rowCount = Self.collection.objects.length;
        from = Math.max(from, Self.from);
        to = Math.min(to, Self.to);
        for (var i = from; i < to; i++) Self.unfetched[i] = true;
        Self.doScroll();
        Self.updateStyles();
    };
    
    /**
     * @private
     */
    this.selected_cb = function(count,e ) {
    	Self.updateStyles();
        Self.events.trigger("Selected", count, e);
    };
    
    /**
     * Events triggered by this LiveGrid2.
     * <dl><dt>Selected</dt><dd>The selection has changed. Triggered only when
     * this grid is enabled. Parameters:
     * <ul><li>Number of selected elements.</li></ul></dd>
     * <dt>Activated</dt><dd>One or more elements have been activated.
     * Parameters:
     * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
     * <dt>Delete</dt><dd>One or more elements should be deleted.
     * Parameters:
     * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
     * </dl>
     */
    this.events = new Events();
}

LiveGrid2.prototype = {
    constructor : "LiveGrid2",
    /**
     * How many additional invisible rows to create to allow flicker-free
     * scrolling at faster speeds.
     */
    preview: 15,
    
    /**
     * Granularity of row fetches.
     */
    granularity: 15,
    
    /**
     * Recreates the LiveGrid, taking into account updated column definitions
     * etc.
     */
    recreate: function() {
        var enabled = Boolean(this.collection);
        var oldHeader = this.headerNode;
        this.disable();
        for (var i in this.rows) this.deleteRow(i);
        this.rowcache = [];
        this.from = 0;
        this.to = 0;
        this.ruWidth = 0;
        var header = this.getHeader();
        if (oldHeader && oldHeader.parentNode) {
            oldHeader.parentNode.replaceChild(header, oldHeader);
        }
        if (this.parent) {
            this.parent.removeChild(this.heightDiv);
            this.parent.removeChild(this.emptyMessage);
            this.getTable(this.parent);
        }
        if (this.hoverNode) {
            this.addHover(this.hoverNode, this.hoverCallback);
            if (this.hoverSizeNode) this.hover.setSize(this.hoverSizeNode);
        }
        if (enabled) this.enable(this.collectiondata.criteria,
                                 this.collectiondata.search);
    },
    
    /**
     * Creates a DOM tree for the headers of the LiveGrid2.
     * The returned DOM tree must be inserted in its place in the document.
     * @type Object
     * @return A DOM tree which displays the headers of the LiveGrid2.
     * @see #getTable
     */
    getHeader: function() {
        var Self = this;
        this.headers = new Array(this.columns.length);
        this.outer_headers = new Array(this.columns.length);
        this.arrows = new Array(this.columns.length);
        this.arrow_events = new Array(this.columns.length);
        for (var i in this.columns) this.arrow_events[i] = sortHandler(i);
        function sortHandler(i) {
            return function(e) {
                Self.setSort(Self.columns[i].sort,
                    (Self.sort_id == Self.columns[i].sort &&
                     Self.sort_order == "asc") ? "desc" : "asc");
                stopEvent(e);
            }
        }
        this.ids = {};
        for (var i in this.columns) {
			if(this.columns[i].sort) {
		        this.ids[this.columns[i].sort] = i;		
			}
		}
        this.listColumns = function() {
        	var colSet = {};
            for(var i = 0; i < this.columns.length; i++) {
                var name = this.columns[i].name;
                for(var j = 0; j < name.length; j++) colSet[name[j]] = true;  
            }
            var plainColumns = [], eavColumns = [];
            for (var i in colSet) {
                (i.indexOf("/") < 0 ? plainColumns : eavColumns).push(i);
            }
            eavColumns.sort();
            return plainColumns.concat(eavColumns);
        };
        
        var colgroup = this.getColGroup();
        colgroup.appendChild(this.ruCorner = newnode("col", {width: "0"}));
        var tbody = newnode("tbody",{verticalAlign : "top"});
        var table = this.headerNode = newnode("table", {tableLayout: "fixed"},
                            {cellPadding: "0", cellSpacing: "0", className: "livegrid"},
                            [colgroup, tbody]);
        var row = newnode("tr", {height: this.lineHeight + "em"},
                          {className: "th"});
        for (var i = 0; i < this.columns.length; i++) {
            var outerCell, innerCell;
            var headerClassName = this.columns[i].name
                ? "header livegrid-column-" +
                      this.columns[i].name.join(" livegrid-column-")
                : "header";
            if (this.columns[i].sortable) {
                outerCell = this.outer_headers[i] =
                    newnode("th", this.columns[i].style, {className: headerClassName}, [
                        newnode("table", 0, {cellPadding: "0", cellSpacing: "0"}, [
                            newnode("tbody", 0, 0, [
                                newnode("tr", 0, 0, [
                                    innerCell = this.headers[i] = newnode("th", {whiteSpace: "nowrap"}),
                                    newnode("th", 0, 0, [
                                        this.arrows[i] = newnode("img", {verticalAlign: "middle"}, {src: getFullImgSrc("img/dummy.gif"), width: "16", height: "16"})
                                    ])
                                ])
                            ])
                        ])
                    ]);
            } else
                innerCell = outerCell = this.headers[i] = this.outer_headers[i] =
                    newnode("th", this.columns[i].style, {className: headerClassName});
            if (this.columns[i].text instanceof I18nString) {
                innerCell.appendChild(addTranslated(this.columns[i].text));
            } else if (this.columns[i].i18n) {
                var ctx = this.columns[i].i18n;
                if (ctx === true) ctx = ""; 
                var node = new I18nNode(pgettext(ctx, this.columns[i].text));
                node.parent = innerCell;
                node.update = function() {
                    this.parent.title = this.node.data = this.callback();
                };
                innerCell.appendChild(node.node);
                node.update();
            } else switch (typeof this.columns[i].text) {
                case "string":
                    innerCell.innerHTML = this.columns[i].text;
                    break;
                case "function":
                    innerCell.appendChild(addTranslated(this.columns[i].text));
                    break;
                default:
                    innerCell.appendChild(this.columns[i].text);
            }
            row.appendChild(outerCell);
        }
        row.appendChild(newnode("th"));
        var index = this.ids[this.sort_id];
        if (this.sort_id && index && this.arrows[index]) {
            this.arrows[index].src = 
                this.sort_order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
                this.sort_order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
                getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid2.setSortClass(this.outer_headers[index], true);
         }
        tbody.appendChild(row);
        return table;
    },
    
    /**
     * Adds the scrollable area of the LiveGrid2 to the specified parent node.
     * The parent node should have an explicit size and "overflow: auto".
     */
    getTable: function(parent) {
        parent.onselectstart = function() { return false; };
        this.rows = {};
        var last = this.columns.length - 1;
        this.parent = parent;
        this.heightDiv = newnode("div", {height: "0em"}, {className: "livegrid"});
        parent.appendChild(this.heightDiv);
        parent.tabIndex = 0;
        parent.style.outline = "none";
        parent.style.overflowX = "hidden";
        parent.hideFocus = true;
        var emptyText = addTranslated(this.emptylivegridtext);
        this.emptyMessage = newnode("div",
            {display: "none", position: "absolute", textAlign: "center", 
             width: "100%", marginTop: "5px"}, 0,
            [emptyText]);
        parent.appendChild(this.emptyMessage);
        var tr = newnode("tr");
        for (var i = 0; i < this.columns.length; i++)
            tr.appendChild(newnode("td", this.columns[i].style,
                                   {className: "cell"}));
        this.rowTemplate = newnode("table", 0,
            {cellPadding: "0", cellSpacing: "0", className: "tr"},
            [this.getColGroup(), newnode("tbody", 0, 0, [tr])]);
    },
    
    /**
     * Adds a hover to the LiveGrid2.
     * This method should be called between getTable() and the first enable(). 
     * @param {Object} hover A DOM node which serves as a hover. It should be
     * attached directly to the body and have the CSS style
     * "position: absolute".
     * @param {Function} callback A callback function which is called when
     * the hover is shown. As parameters, it receives the ID of
     * the entry over which the mouse is hovering and whether the hover was
     * triggered manually.
     * @type {Object}
     * @return A new Hover object. The enable and disable methods of the hover
     * object will be called automatically by the LiveGrid2.
     */
    addHover: function(hover, callback) {
        this.hoverNode = hover;
        this.hoverCallback = callback;
		this.hover = new Hover(this.heightDiv, hover);
        var Self = this;
        this.hover.setSize = function(node) {
            Self.hoverSizeNode = node;
            return Hover.prototype.setSize.call(this, node);
        }
        this.hover.onShow = function(node, manual) {
            var i = node.oxRowIndex;
            if (i !== undefined)
                callback(Self.collection.objects[i], manual);
            else
                return false;
        }
        return this.hover;
    },
    
    /**
     * @private
     */
    getColGroup: function() {
        var colgroup = newnode("colgroup");
        for (var i = 0; i < this.columns.length; i++) {
            var w = this.columns[i].width;
            colgroup.appendChild(newnode("col", w ? {width: w} : 0));
        }
        return colgroup;
    },
    
    /**
     * Appends the contents either of the entire grid or of selected rows to
     * the specified node.
     * @param {Object} parent The node to append the data to.
     * @param {Function} cb The callback to call after all data is appended.
     * @param {Boolean} selected True if only selected rows should be appended.
     * Otherwise, all rows are appended.
     */
    print: function(parent, cb, selected) {
        var doc = parent.ownerDocument;
        var tr = doc.createElement("tr");
        for (var i = 0; i < this.columns.length; i++) {
            var th = doc.createElement("th");
            if (this.columns[i].i18n)
                th.appendChild(doc.createTextNode(_(this.columns[i].text) || "\u00a0"));
            else
                th.innerHTML = this.columns[i].text || "\u00a0";
            tr.appendChild(th);
        }
        var table = newnode("table", {width: "100%"}, {border: 1},
            [newnode("thead", 0, 0, [tr], doc)], doc);
        var trs = [];
        var Self = this;
        function set(n, obj) {
            trs[n] = doc.createElement("tr");
            for (var i = 0; i < Self.columns.length; i++) {
                var td = doc.createElement("td");
                trs[n].appendChild(td);
                var col = Self.columns[i];
                col.set(td, col.index ? obj[col.index] : obj, obj);
            }
        }
        function final_() {
            var tbody = newnode("tbody", 0, 0, 0, doc);
            for (var i = 0; i < trs.length; i++) 
                if (trs[i]) tbody.appendChild(trs[i]);
            table.appendChild(tbody);
            parent.appendChild(table);
            if(trs.length==0) {
                return; 
            }
            cb();
        }
		var selection = (selected) ? this.selection.getSelected() : this.collection.objects;
        OXCache.newRequest(null,this.module,{
                objects : selection,
                columns : this.listColumns()
            },null,function callback(data) {
				if (!data || !data.objects) {
					//return;
				}
				for(var i=0;i<data.objects.length;i++) {
					var obj=data.objects[i];
					var tr = doc.createElement("tr");
					for (var i2 = 0; i2 < Self.columns.length; i2++) {
                        var td = doc.createElement("td");
                        tr.appendChild(td);
					    var col = Self.columns[i2];
                        if(col.name.length==1) {
						  col.set(td, obj[col.name[0]], obj);
						} else {
					      col.set(td, obj, obj);
						}
  				    }
				    trs.push(tr); 
                 }
				 var tbody = newnode("tbody", 0, 0, 0, doc);
                 for (var i = 0; i < trs.length; i++) {
				 	if (trs[i]) {
						tbody.appendChild(trs[i]);
					}
				 }
                 table.appendChild(tbody);
                 parent.appendChild(table);
                 if(trs.length==0) {
                    //return; 
                 }
                 cb();
            }
		);    
    },
    
    /**
     * Displays the specified sort order as an arrow in the headers.
     * @param {String} id The column ID used for sorting, or null for no
     * sorting.
     * @param {String} order The sort order. One of "asc", "desc" or null for no
     * sorting.
     */
    setSort: function(name, order) {
        if (this.sort_id && name != this.sort_id) {
            var index = this.ids[this.sort_id];
			if(index || index === 0) {
			    this.arrows[index].src = getFullImgSrc("img/dummy.gif");
                LiveGrid2.setSortClass(this.outer_headers[index], false);
			}
		}
        var index = this.ids[name];
        if(index || index === 0) {
            this.arrows[index].src = 
                order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
                order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
                getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid2.setSortClass(this.outer_headers[index], true);
        }
		this.sort_id = name;
        this.sort_order = order;
        if (this.collection) this.sort(name, order);
    },
    
    /**
     * Callback function which changes the displayed data.
     * Should be overridden in each instance.
     * @param {String} id The column ID used for sorting, or null for no
     * sorting.
     * @param {String} order The sort order. Either "asc" or "desc".
     */
    sort: function() {
		if(!this.collection) {
			return
		}
		this.enable(this.collection.criteria, this.collection.search);
	},
    getSelectedIDs: function() {
        return this.selection.getSelected();
    },
    
    /**
     * Deletes items with specified object IDs from the collection and from
     * the selection. If the entire selection was deleted, the first unselected
     * item at or after the focus is selected.
     */
    deleteIDs: function(ids) {
		/*
        var sids = {};
        for (var i = 0; i < ids.length; i++)
            sids[this.storage.serialize(ids[i])] = true;
        while (this.storage.getSID(this.focus) in sids) this.focus++;
        var newID = this.storage.ids[this.focus];
        this.storage.removeIDs(ids);
        this.selection.deselectSIDs(sids);
        this.focus = newID ? this.storage.getIndex(newID) : 0;
        if (!this.selection.count)
            this.selection.click(this.focus);
        */
    },
    
    updateSelected: function(callback) {
        //if (this.collection)
            //this.storage.localUpdate(this.selection.getSelected(), callback);
    },

    /**
     * Initializes the LiveGrid2.
     * The DOM tree must have been created by {@link #getHeader} and
     * {@link #getTable}.
     * @see #getHTML
     */
	enable : function(criteria,search,force) {
		var Self=this;
		this.collectiondata = {
             "criteria" : criteria,
             columns : []
        };
		if (this.sort_id) {
            this.collectiondata.order = [{ sort : this.sort_id,
                                           order : this.sort_order }];
		}
		if(search) {
			this.collectiondata["search"]=search;
		}
		if(this.uniqueName) {
		    OXCache.unregister(this.uniqueName);
            delete this.uniqueName;
        }
		if(this.listRequest) {
            OXCache.unregister(this.listRequest.uniqueName);
            delete this.listRequest;
        }   
        if(!this.collection && this.collection !== false) {
            this.collection = false;
			for (var i in Self.arrows) {
                addDOMEvent(Self.outer_headers[i], "click", Self.arrow_events[i]);
			}
            addDOMEvent(Self.parent, "scroll", Self.scroll_cb);
            addDOMEvent(Self.parent, "keydown", Self.keydown_cb);
            addDOMEvent(Self.parent, "keypress", Self.keypress_cb);
            addDOMEvent(Self.parent, "mousedown", Self.mousedown_cb);
            addDOMEvent(Self.parent, "click", Self.click_cb);
            // bind double click via jQuery (due to bug #14560)
            jQuery(this.parent).bind("dblclick", this.dblclick_cb);
            addDOMEvent(Self.parent, "focus", Self.focus_cb);
            addDOMEvent(Self.parent, "blur", Self.blur_cb);
            if (this.contextmenu)
                addDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
            if (Self.hover && !Self.disablehover) Self.hover.enable();
            resizeEvents.register("Resized", Self.scroll_cb);
            register("LanguageChanged",Self.language_cb);
            if (Self.dndModule && (Self.dndModule != "links")) {
                var disabled;
                var validfield;
                switch(Self.dndModule) {
                    case "calendar": disabled=calendardefaultdisabled;  validfield="title"; break;
                    case "tasks":   disabled=taskdefaultdisabled; validfield="title"; break;
                    case "contacts": disabled=contactdefaultdisabled; validfield="display_name"; break;
                    case "infostore": disabled=infostoredefaultdisabled; validfield="title"; break;
                    case "mail": disabled=maildefaultdisabled; validfield="subject"; break;
                }
                Self.dragEvent = registerSource(Self.heightDiv, Self.dndModule, function() 
                {
                    var myelements=clone(Self.selection.getSelected());
                    objMoveCopy.begin(Self.dndModule,myelements);
                    return objMoveCopy;
                },null,null,disabled,defaultdisabledremove);
            }
        }
        var oldFocus = 0, fallbackSelection;
        var returnObject=OXCache.newRequest(null, this.module,
            this.collectiondata, {
                before: function() {
                    oldFocus = Self.focus;
                    if (!Self.collection || !Self.selection.collection) return;
                    while (Self.selection.get(oldFocus)) oldFocus++;
                    fallbackSelection = Self.collection.objects[oldFocus];
                },
                fn: function modifiedCallback(data) {
                    Self.collection=data;
                    Self.rowCount = data.objects.length;
                    var index;
                    if (fallbackSelection) {
                        index = Self.collection.getIndex(fallbackSelection) - 1;
                    }
                    if (isNaN(index)) {
                        index = Math.min(oldFocus, Self.rowCount - 1);
                    }
                    if (Self.selection.setCollection(Self.collection,
                            Self.selection.count ? index : undefined))
                    {
                        Self.focus = index;
                    }
                    Self.change_cb(0,data.objects.length); 
                    Self.events.trigger("Changed", data, true);
                }
            },
			function callback(data) {
				Self.collection=data;
	            Self.rowCount = data.objects.length;
	            Self.selection.setCollection(Self.collection, Self.selection.selectedIndex);
	            Self.scroll(true);
				Self.events.trigger("Changed", data, false);
			},force);
		this.uniqueName=returnObject.uniqueName;
		Self.selection.events.register("Selected", Self.selected_cb);
	},
    disable: function() {
        if (!this.collection) return;
        this.selection.events.unregister("Selected", this.selected_cb);
        if(this.uniqueName) {
			OXCache.unregister(this.uniqueName);
            delete this.uniqueName;
		}
		if(this.listRequest) {
            OXCache.unregister(this.listRequest.uniqueName);
            delete this.listRequest;
        }
		this.collection = null;
        this.selection.setCollection(null);
        for (var i in this.arrows)
            removeDOMEvent(this.outer_headers[i], "click", this.arrow_events[i]);
        removeDOMEvent(this.parent, "scroll", this.scroll_cb);
        removeDOMEvent(this.parent, "keydown", this.keydown_cb);
        removeDOMEvent(this.parent, "keypress", this.keypress_cb);
        removeDOMEvent(this.parent, "mousedown", this.mousedown_cb);
        removeDOMEvent(this.parent, "click", this.click_cb);
        jQuery(this.parent).unbind("dblclick", this.dblclick_cb);
        removeDOMEvent(this.parent, "focus", this.focus_cb);
        removeDOMEvent(this.parent, "blur", this.blur_cb);
        if (this.contextmenu)
            removeDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
        unregister("LanguageChanged",this.language_cb);
        if (this.hover) this.hover.disable();
        resizeEvents.unregister("Resized", this.scroll_cb);
        if (this.dndModule) {
            unregisterSource(this.parent, this.dragEvent);
        }
    },
    
    /**
     * @private
     */
    createRow: function() {
        var last = this.columns.length - 1;
        var row = {tr: this.rowTemplate.cloneNode(true),
                   cells: new Array(this.columns.length)};
        for (var i = 0, cell = row.tr.lastChild.firstChild.firstChild; cell;
             i++, cell = cell.nextSibling)
        {
            row.cells[i] = cell;
            this.columns[i].clear(cell);
        }
        this.heightDiv.appendChild(row.tr);
        if (!this.rowHeight) this.rowHeight = row.tr.offsetHeight + this.rowMargin;
        return row;
    },

    /**
     * To be removed.
     * @private
     */
    updateStyles: function() {
    	// return if the selection has no collection
    	if (!this.selection.collection) return;
        for (var i in this.rows) {
            var newclass = this.selection.get(i) ? "tr selected" : i%2 ? "tr_h " : "tr ";
            if (focusedElement == this.parent && i == this.focus)
                newclass += "focused";
            var tr = this.rows[i].tr;
            if (tr.className != newclass) tr.className = newclass;
        }
    },

    /**
     * @private
     */
    deleteRow: function(index) {
        var row = this.rows[index];
        row.tr.style.display = "none";
        this.rowcache.push(row);
        delete this.rows[index];
        delete this.unfetched[index];
    },

    /**
     * @private
     */
    insertRow: function(index) {
        var row = this.rows[index] =
            this.rowcache.length ? this.rowcache.pop() : this.createRow();
        row.tr.className = this.selection.get(index) ? "tr selected" : index%2 ? "tr_h" : "tr";
        row.tr.style.display = "";
        row.tr.style.top = (index * this.rowHeight) + "px";
        row.tr.oxRowIndex = index;
        this.unfetched[index] = true;
    },

    /**
     * @private
     */
    scroll: function(fullRedraw) {
        if (fullRedraw) this.fullRedraw = true;
        if (this.scrollTimeout) {
			clearTimeout(this.scrollTimeout);
		}
        var Self = this;
        this.scrollTimeout = setTimeout(function() {
            Self.scrollTimeout = null;
            Self.doScroll();
        }, 0);
    },
    
    /**
     * @private
     */
    calculateRowHeight: function() {
        var row = this.createRow();
        row.tr.style.display = "none";
        this.rowcache.push();
    },

    /**
     * @private
     */
    doScroll: function() {
		var Self=this;       
        if (!this.rowHeight) this.calculateRowHeight();
        this.height = Math.floor(this.parent.clientHeight / this.rowHeight);
        var len = this.collection ? this.collection.objects.length : 0;
        var newHeight = (len * this.rowHeight) + "px"
        var hDivStyle = this.heightDiv.style;
        if (newHeight != hDivStyle.height) hDivStyle.height = newHeight;
        var newruWidth = this.parent.offsetWidth - this.parent.clientWidth;
        if (newruWidth > 0 && newruWidth != this.ruWidth) {
            this.ruCorner.style.width = newruWidth + "px";
            this.ruWidth = newruWidth;
        }
        var Self = this;
        if (this.heightDiv.offsetWidth != this.parent.clientWidth)
            hDivStyle.width = Self.parent.clientWidth + "px";
        var scrolltop = this.parent.scrollTop;
        var from2 = Math.max(0, Math.floor(                           scrolltop  / this.rowHeight / this.granularity) * this.granularity - this.preview);
        var to2 = Math.min(len, Math.ceil((this.parent.clientHeight + scrolltop) / this.rowHeight / this.granularity) * this.granularity + this.preview);
		if (this.fullRedraw || from2 != this.from || to2 != this.to) {
            if (this.fullRedraw || from2 > this.to || this.from > to2) {
                for (var i = this.from; i < this.to; i++) this.deleteRow(i);
                for (var i = from2; i < to2; i++) this.insertRow(i);
            } else {
                for (var i = this.from; i < from2; i++) this.deleteRow(i);
                for (var i = to2; i < this.to; i++) this.deleteRow(i);
                for (var i = from2; i < this.from; i++) this.insertRow(i);
                for (var i = this.to; i < to2; i++) this.insertRow(i);
            }
            this.from = from2;
            this.to = to2;
        }
        this.fullRedraw = false;
        this.emptyMessage.style.display = (!this.collection || len) ? "none"
                                                                    : "block";
        var ids = [];
        for (var i in this.unfetched) ids.push(this.collection.objects[i]);
        if (ids.length) {        	
            if(this.listRequest) {
				OXCache.unregister(this.listRequest.uniqueName);
				delete this.listRequest;
			}
            var collection = this.collection;
		    this.listRequest=OXCache.newRequest(null,this.module,{
                objects : ids,
                columns : this.listColumns()
            },null,function cb(data) {
                for(var i=0;i<data.objects.length;i++) {
                    var objIndex=collection.map_objects.get(data.objects[i]);
                    if(!Self.rows[objIndex-1]) return;
                    delete Self.unfetched[objIndex-1];
                    var cellrow = Self.rows[objIndex-1].cells;
                    for (var i2 in cellrow) {
                        var col = Self.columns[i2];
                        if(col.name.length==1 && col.name[0].indexOf("/") < 0) {
                            col.set(cellrow[i2], data.objects[i][col.name[0]],
                                data.objects, Self);
                        } else {
                            col.set(cellrow[i2], data.objects[i], data.objects,
                                Self);
                        }
                    }
                }
                delete Self.listRequest;
            },false);
			if(this.listRequest) {
				for(var i in this.listRequest.clear) {
                    var objIndex=this.collection.map_objects.get(this.listRequest.clear[i]);
                    var cellrow = Self.rows[objIndex-1].cells;
                    for (var i in cellrow) Self.columns[i].clear(cellrow[i]);
                }
				for(var i in this.listRequest.set) {
                	var objIndex=this.collection.map_objects.get(this.listRequest.set[i]);
					var cellrow = Self.rows[objIndex-1].cells;
                    for (var i2 in cellrow) {
                        var col = Self.columns[i2];
                        if(col.name.length==1 && col.name[0].indexOf("/") < 0) {
                            col.set(cellrow[i2],
                                this.listRequest.set[i][col.name[0]], null,
                                Self);
                        } else {
                            col.set(cellrow[i2], this.listRequest.set[i], null,
                                  Self);
                        }
                    }
                }
            }
        }
    },
    
    /**
     * @private
     */
    scrollTo: function(y) {
        var parent = this.parent;
        setTimeout(function() { parent.scrollTop = y; }, 0);
    },
    
    /**
     * Scrolls if necessary to display the currently focused row.
     */
    showFocus: function() {
        var scrolltop = this.parent.scrollTop;
        if (!this.rowHeight) this.calculateRowHeight();
        if (this.focus < scrolltop / this.rowHeight)
            this.scrollTo(this.focus * this.rowHeight);
        else {
            var height = this.parent.clientHeight;
            if (this.focus + 1 > (scrolltop + height) / this.rowHeight)
                this.scrollTo((this.focus + 1) * this.rowHeight - height);
        }
    },

    /**
     * @private
     */
    key: function(e) {
        if (!this.collection) return;
        switch (e.keyCode || e.which) {
        case 13: // enter
            this.events.trigger("Activated", this.selection.getSelected());
            break;
        case 32: // spacebar
            this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 46: // delete
        case 108: // numpad delete
            this.events.trigger("Delete", this.selection.getSelected());
            break;
        case 38: // arrow up
            if (this.focus > 0) this.focus--;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 40: // arrow down
            if (this.focus < this.rowCount - 1) this.focus++;
            if (!(Mac ? e.metaKey : e.ctrlKey)) {
                this.selection.click(this.focus, e);
            }
            this.showFocus();
            break;
        case 33: // page up
            this.focus -= this.height;
            if (this.focus < 0) this.focus = 0;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 34: // page down
            this.focus += this.height;
            if (this.focus >= this.rowCount) this.focus = this.rowCount - 1;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 35: // end
            this.focus = this.rowCount - 1;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 36: // home
            this.focus = 0;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 65: // A
        case 97: // a
            if (e.ctrlKey)
                this.selection.select(0, this.collection.objects.length);
            break;
        default:
            return;
        }
        this.updateStyles();
        stopEvent(e);
        return false;
    },
    
    /**
     * @private
     */
    mousedown: function(e) {
        this.clickprocessed = false;
        var focus = getRowIndex(e);
        // might be undefined (timing issue): this.collection.objects - so check that
        if (this.collection.objects && this.collection.objects.length < this.height) {
            if (focus === undefined) {
                focus = -1;
            } else {
                this.focus = focus;
            }
            if (!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        } else if (focus !== undefined) {
            this.focus = focus;
            if (!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        }
        setFocus(this.parent);
    },
    
    /**
     * @private
     */
    ctxtmenu: function(e) {
        stopEvent(e);
        this.contextmenu.display(e.clientX, e.clientY, this.selection);
    },
    
    /**
     * @private
     */
    click: function(e) {
        if (this.clickprocessed) {
            return;
        }
        var focus = getRowIndex(e);
        // might be undefined (timing issue): this.collection.objects - so check that
        if (this.collection.objects && this.collection.objects.length < this.height) {
            if (focus === undefined) focus = -1; else this.focus = focus;
            this.selection.click(focus, e);
        } else if (focus !== undefined) {
            this.focus = focus;
            this.selection.click(focus, e);
        }
        cancelDefault(e);
        if (!IE6 && corewindow.hasFocus) setFocus(this.parent);
    },
    
    /**
     * @private
     */
    dblclick: function(e) {
        if (!this.collection) return;
        this.focus = getRowIndex(e) || 0;
        this.events.trigger("Activated", this.selection.getSelected());
    }
};

LiveGrid2.setSortClass = classNameSetter("livegrid-th-sorted");

/**
 * Default set function for use in the second parameter of the constructor.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified content value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} text The text to set in the DIV element.
 */
LiveGrid2.defaultSet = function(div, text) {
    text = text || "\u00a0";
    if (div.firstChild)
        div.firstChild.data = text;
    else
        div.appendChild(document.createTextNode(text));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid2.dateSet = function(div, date) {
    var dateString = "\u00a0";
    if (null != date) dateString = formatDate(date, "date");
    if (div.firstChild)
        div.firstChild.data = dateString;
    else
        div.appendChild(document.createTextNode(dateString));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid2.dateSetTime = function(div, date) {
    if (div.firstChild)
        div.firstChild.data = formatDate(date, "datetime");
    else
        div.appendChild(document.createTextNode(formatDate(date, "datetime")));
};

/**
 * Creates a clear function for use in the second parameter of the constructor.
 * This function creates a function which sets all DIV elements of the LiveGrid2
 * to the text which is specified as parameter to this function.
 * @param {String} text The text to set in DIV elements.
 * @type Function
 * @return A function which takes a HTML DIV element as parameter, adds a text
 * node to it, and sets the text to a constant value.
 */
LiveGrid2.makeClear = function(text) {
    return function(div) {
        if (div.firstChild)
            div.firstChild.data = text;
        else
            div.appendChild(document.createTextNode(text));
    };
};




fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 */

  ///////////////////////
 //   Drag and Drop   //
///////////////////////

/**
 * Registers a drag source.
 * @param {Object} node A DOM element which serves as drag source.
 * @param {String} type The type of the dragged object. The object can be
 * dropped only on targets which accept this type.
 * @param {Function} callback A function which creates a dragged object.
 * This function may be called without a real drag operation; the returned
 * object should therefore be small and inexpensive to create.
 * @param {String} icon URI of the drag icon which is displayed when the object
 * can be dropped.
 * @param {String} disabledIcon URI of the drag icon which is displayed when
 * the object can not be dropped.
 * @type Function
 * @return A value which must be passed to {@link unregisterSource} to
 * unregister the drag source.
 */
var registerSource;

/**
 * Unregisters a previously registered drag source.
 * @param {Object} node A DOM element which served as drag source.
 * @param {Function} event A value previously returned by {@link registerSource}
 * for the same DOM node.
 */
var unregisterSource;

/**
 * Registers a drop target.
 * @param {Object} node A DOM element which serves as drag target.
 * @param {Object} callbacks An object with a field for every accepted type.
 * The value of each field is a callback function which is called when a drag
 * object of the corresponding type is dropped on the target.
 * @type Function
 * @return A value which must be passed to {@link unregisterTarget} to
 * unregister the drag target.
 */
var registerTarget;

/**
 * Unregisters a previously registered drag target.
 * @param {Object} node A DOM element which served as drag target.
 * @param {Function} event A value previously returned by {@link registerTarget}
 * for the same DOM node.
 */
var unregisterTarget;

/**
 * Returns true during a drag operation. Useful in mouse event handlers not
 * directly associated with drop targets.
 * @type Boolean
 * @return true during a drag operation, false otherwise.
 */
var isDragging;

/**
 * Stops event bubbling which was allowed by the 9th parameter to
 * registerTarget.
 * @param {Event} event The DOM mousemove event to stop.
 */
var stopDnDPropagation;

var dragThreshold = 7;

var iconOffset = 8;
var cancelfunc = true;
var draggingdisable=false;
(function() {
    var dragging = false;
    var dropCallback;
    var dropNode;
    var draggedObjects;
    var dragType;
    var iconNode;
    var iconURI;
    var disabledIconURI;
    var savelocal; //REMOVE TIMEOUT EXPAND FOLDERS
    var disabled;
    var disabledRemove;
    var mouseposition = {};
    var targetNode;
    var fnOutNode = function (){};
    var handleDnDEvent = false;
    
    stopDnDPropagation = function(e) {
        if (handleDnDEvent) cancelBubbling(e);
    };
    
    var cancel2 = function (e) {
        // fix event
        e = jQuery.event.fix(e || window.event);
        // is input field
        if (jQuery(e.target).is("input")) {
            return true;
        } else {
            if (cancelfunc) {
                stopEvent(e);
            }
            return !cancelfunc;
        }
    };
    var cancel = function() { return false; };

    registerSource = function(node, type, callback, icon, disabledIcon,fnDisabled2,disabledRemove2) {
        addDOMEvent(node, "mousedown", down);
        if ("onselectstart" in node) addDOMEvent(node, "selectstart", cancel2);
        if ("ondrag" in node) addDOMEvent(node, "drag", cancel2);
        return down;
        
        var startX, startY;
        var cursor;
        function disabled2(e) {
            fnDisabled2(e,dragType,draggedObjects,mouseposition,targetNode);
        }
        function down(e) {            
            if(draggingdisable) return;
            cancelfunc=true;
            if (e.button != LeftButton) return;
            draggingdisable=true;
            startX = e.clientX;
            startY = e.clientY;
            mouseposition = {};
            mouseposition.clientX=startX;
            mouseposition.clientY=startY;
            cancelDefault(e);
            addDOMEvent(document, "mousemove", move);
            addDOMEvent(document, "mouseup", up);
            return false;
            
        }
        function move(e) {
            // passed threshold?
            if (Math.abs(e.clientX - startX) + Math.abs(e.clientY - startY) <= dragThreshold) return;
            // get objects
            draggedObjects = callback();
            if (draggedObjects === false) {
                // cancel drag
                removeDOMEvent(document, "mousemove", move);
                removeDOMEvent(document, "mouseup", up);
                draggingdisable = false;
            } else {
                if(window.setHoverActive) {
                    setHoverActive(false);
                }
                disabled = fnDisabled2 && disabled2;
                disabledRemove=disabledRemove2;
                dragType = type;
                dragging = true;            
                cursor = setMouseCursor("move");
                hideIFrames();
                removeDOMEvent(document, "mousemove", move);
                if(fnDisabled2) {
                    addDOMEvent(document, "mousemove", disabled);
                    disabled(e);
                } else {
                    addDOMEvent(document, "mousemove", move2);
                }
                //TMPSTART
                iconURI=icon;
                disabledIconURI=disabledIcon;
                //TMPEND
                stopEvent(e);
                return false;
            }
        }        
        function move2(e) {
            if(!iconNode) {
                iconNode = newnode("img", {position: "absolute",left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
                 {src: disabledIcon, alt: ""});
                body.appendChild(iconNode);
            }
            iconNode.style.left = (e.clientX + iconOffset) + "px";
            iconNode.style.top = (e.clientY + iconOffset)+ "px";
            stopEvent(e);
            return false;
        }

        function up(e) {
            if (e.button != LeftButton) return;
            draggingdisable=false;
            if(!disabled) {
                removeDOMEvent(document, "mousemove", dragging ? move2 : move);
            } else {
                removeDOMEvent(document, "mousemove", dragging ? disabled : move);
            }
            if(window.setHoverActive) {
                setHoverActive(true);
            }
            removeDOMEvent(document, "mouseup", up);
            if (dragging) {
                showIFrames();
                if(!disabledRemove) {
                    if(iconNode) {
                        body.removeChild(iconNode);
                        iconNode = null;
                    }
                } else {
                    disabledRemove(e,dragType,draggedObjects,mouseposition,targetNode);
                }
                removeMouseCursor(cursor);
                dragging = false;
                //if (dropCallback) dropCallback(draggedObjects,e,mouseposition,targetNode);
                if (dropCallback) dropCallback(e,dragType,draggedObjects,mouseposition,targetNode,dropNode);
                dropCallback = null;
                dropNode=null;
            }
            draggedObjects = null;
        }
    };
    unregisterSource = function(node, myfunc) {
        removeDOMEvent(node, "mousedown", myfunc);
        if ("onselectstart" in node) removeDOMEvent(node, "selectstart", cancel2);
        if ("ondrag" in node) removeDOMEvent(node, "drag", cancel2);
    };
    
    function tOut(e) {
        if (!dragging) return;
        var target = e.currentTarget;
        target.className = removeClass(target.className, "dndOver");
        
        if(!iconNode) {
            iconNode = newnode("img", {position: "absolute",left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
            {src: disabledIconURI, alt: ""});
            body.appendChild(iconNode);
        }
        iconNode.src = disabledIconURI;
        dropCallback = null;
        dropNode=null;
        fnOutNode(savelocal);
    }
    
    registerTarget = function(node, callbacks,fn_Over,fnOutParam,fn_In,fn_Move,fn_Out,holdsourcedisabled, allowPropagation) {
        var mymove = function(e) {
            if (!dragging) return;
            dropCallback = callbacks[dragType];
            dropNode=node;
            handleDnDEvent = Boolean(dropCallback);
            if (handleDnDEvent) {
                targetNode=node;
                if(fn_Move) {
                    fn_Move(e,dragType,draggedObjects,mouseposition);
                }
                if(disabledRemove && !holdsourcedisabled) {
                    disabledRemove(e,dragType,draggedObjects,mouseposition,targetNode);
                }
                cancelDefault(e);
                if (!allowPropagation) cancelBubbling(e);
            }
        };
        var myout = function(e) {
            if (!dragging) return;
            if(!realMouseOutIn(e,true)) return;
            dropCallback = callbacks[dragType];
            dropNode = node;
            
            if(dropCallback) {
                targetNode=undefined;
                if(fn_Out) {
                    fn_Out(e,dragType,draggedObjects,mouseposition,savelocal);
                } 
                dropCallback=null;
                dropNode=null;
                stopEvent(e);
            }
            if (disabled) disabled(e);
        };
        var myin = function(e) {
            if (!dragging) return;
            if(!realMouseOutIn(e,false)) return;
            dropCallback = callbacks[dragType];
            if(dropCallback) {
                targetNode=node;
                if(fn_In) {
                    savelocal=fn_In(e,dragType,draggedObjects,mouseposition);
                } else {
                    event(e,dragType,draggedObjects,mouseposition);
                }
                stopEvent(e);
            }
            
        };
        
        var event = function(e) {
            if (fn_Over) savelocal = fn_Over(draggedObjects, node.id);
            dropCallback = callbacks[dragType];
            if(dropCallback)
                node.className += " dndOver";
                if(!iconNode) {
                    iconNode = newnode("img", {position: "absolute",left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
                    {src: "", alt: ""});
                    body.appendChild(iconNode);
                }
                if(dropCallback && iconURI) {
                    iconNode.src = iconURI;
                } else if(disabledIconURI) {
                    iconNode.src = disabledIconURI;
                } 
                

        };
        addDOMEvent(node, "mouseout", myout);
        addDOMEvent(node, "mouseover", myin);
        addDOMEvent(node, "mousemove", mymove);

        return event;
    };
    
    unregisterTarget = function(node,myin,mymove,myout) {
        if(myin) removeDOMEvent(node, "mouseover", myin);
        if(myout) removeDOMEvent(node, "mouseout", myout);
        if(mymove) removeDOMEvent(node, "mouseover", mymove);            
    };

    isDragging = function() { return dragging; };

})();

function realMouseOutIn(event, isout) {
    var node = event.currentTarget || event.srcElement || false;
    if(isout) {
        var toElement = event.relatedTarget || event.toElement || false;
    } else {
        var toElement = event.relatedTarget || event.fromElement || false;
    }
    if(!node || !toElement) return true;
    if(node == toElement) return false;
    var oParent=null;
    try {
       oParent = toElement.parentNode;
    } catch (e) { }
    while(oParent != null) {
        if(oParent == node) {
            return false;
        }
        oParent=oParent.parentNode; 
    }
    return true;
}

var dnd_defaultNode;
//*
function createDefaultNode() {
    if (dnd_defaultNode) return dnd_defaultNode.cloneNode(true);    
    dnd_defaultNode = newnode("div", null,
    { className : "dragdropdefaultnode background-color-default border-color-design", id: "dragdrop_default_node"},[
        newnode("table",{ width:"100%" , height: "100%" },{ cellPadding:"0" , cellSpacing :"0" , border : "0" },[
            newnode("tbody",null,null,[
                newnode("tr",null,null,[
                    newnode("td",{ width: "22px", lineHeight: "0px", verticalAlign: "middle"},null,[
                        newnode("div",{ width: "22px",overflow: "hidden" },null,[
                            newnode("img",{},{ src : getFullImgSrc("img/dnd_disabled.gif") },[]),
                            newnode("img",{ display : "none" },{ src : getFullImgSrc("img/dnd.gif") },[])
                        ])                
                    ]),
                    newnode("td",{ fontSize : "8pt", padding : "0px 5px 0px 5px" , whiteSpace : "nowrap", textAlign: "left" },null,[
                        newnode("div",{ overflow: "hidden" },null,[addTranslated(_("No subject"))])
                    ])
                ])
            ])
        ])
    ]);    
    return dnd_defaultNode;
}
function setDefaultNodeType(node,active) {
    node.getElementsByTagName("td")[0].className = active?" dnd_possibleBG":" dnd_NOTpossibleBG";
    if(active) {
        node.getElementsByTagName("img")[0].style.display="none";
        node.getElementsByTagName("img")[1].style.display="block";
    } else {
        node.getElementsByTagName("img")[1].style.display="none";
        node.getElementsByTagName("img")[0].style.display="block";
    }
}
function nodeSetSubjectDefault(node,title) {
    node.getElementsByTagName("div")[1].firstChild.data= (title) ? title : "";
}
function defaultdisabled(e, dragType, draggedObjects, mouseposition, targetNode,
                         getstring, field)
{    
    var iconNode = document.getElementById("dragdrop_default_node");
    if (iconNode == undefined) {
        iconNode=createDefaultNode();
        iconNode.style.left = (e.clientX + iconOffset) + "px";iconNode.style.top = (e.clientY + iconOffset)+ "px";
        body.appendChild(iconNode);
        
        setDefaultNodeType(iconNode,false);
        
        // set default text
        var count = draggedObjects.currentObjects.length;
        var text = count <= 1 ? "" : format(getstring(count), count);
        nodeSetSubjectDefault(iconNode,text);
        
        if (draggedObjects.currentObjects.length == 1) {
            var module = draggedObjects.currentModule;
            
            // do we have some data to display?! if not, try to get it from the object cache            
            if (draggedObjects.currentObjects[0][field] || draggedObjects.currentObjects[0]["livegridfield"]) {
                nodeSetSubjectDefault(iconNode, draggedObjects.currentObjects[0][field] || draggedObjects.currentObjects[0]["livegridfield"]);
                
            } else if (typeof OXCache.moduleMappings[module] == "function") {
                var collection={};
                var mapping = OXCache.moduleMappings[module];           
                collection.columns = [ field ];
                collection.objects = [mapping.createKeyFromObject(
                          { module: module, 
                            folder_id: draggedObjects.currentObjects[0].folder || 
                                   draggedObjects.currentObjects[0].folder_id, 
                            id: draggedObjects.currentObjects[0].id }
                      )];
                
                OXCache.newRequest(null,module,collection,null,          
                    function(daten) {
                        if (daten.objects[0]) {             
                            var text=daten.objects[0][field] || draggedObjects.currentObjects[0]["livegridfield"];
                            nodeSetSubjectDefault(iconNode,text);
                        }
                    });
            }
        }
    } else {
        setDefaultNodeType(iconNode,false);
    }
    
    iconNode.style.left = (e.clientX + iconOffset) + "px";
    iconNode.style.top = (e.clientY + iconOffset)+ "px";    
    stopEvent(e);
    
    return false;
}
function mailaddressdefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
    var iconNode = document.getElementById("dragdrop_default_node");
    if(iconNode == undefined) {
        iconNode=createDefaultNode();
        iconNode.style.left = (e.clientX + iconOffset) + "px";iconNode.style.top = (e.clientY + iconOffset)+ "px";
        body.appendChild(iconNode);
    }
    iconNode.style.left = (e.clientX + iconOffset) + "px";
    iconNode.style.top = (e.clientY + iconOffset)+ "px";
    setDefaultNodeType(iconNode,false);
    var text=draggedObjects.email1;
    nodeSetSubjectDefault(iconNode,text);
    stopEvent(e);
    return false;
}
function calendardefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
    defaultdisabled(e, dragType, draggedObjects, mouseposition, targetNode,
        function(n) {
            //#. %d is the number of appointments.
            //#, c-format
            return ngettext("%d appointment", "%d appointments", n);
        }, "title");
}
function taskdefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
    defaultdisabled(e, dragType, draggedObjects, mouseposition, targetNode,
        function (n) {
            //#. %d is the number of tasks.
            //#, c-format
            return ngettext("%d task", "%d tasks", n);
        }, "title");
}
function contactdefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
    defaultdisabled(e, dragType, draggedObjects, mouseposition, targetNode,
        function (n) {
            //#. %d is the number of contacts.
            //#, c-format
            return ngettext("%d contact", "%d contacts", n);
        }, "display_name");
}
function infostoredefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
    defaultdisabled(e, dragType, draggedObjects, mouseposition, targetNode,
        function(n) {
            //#. %d is the number of info items.
            //#, c-format
            return ngettext("%d info item", "%d info items", n);
        }, "title");
}
function maildefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
    defaultdisabled(e, dragType, draggedObjects, mouseposition, targetNode,
        function(n) {
            //#. %d is the number of e-mails.
            //#, c-format
            return ngettext("%d E-Mail", "%d E-Mails", n);
        }, "subject");
}
function foldertreeenable(e, dragType, draggedObjects, mouseposition, targetNode, folder) {
    var iconNode = document.getElementById("dragdrop_default_node");
    if (iconNode == undefined) {
        iconNode=createDefaultNode();
        iconNode.style.left = (e.clientX + iconOffset) + "px";
        iconNode.style.top = (e.clientY + iconOffset)+ "px";
        body.appendChild(iconNode);
    } else {
        iconNode.style.left = (e.clientX + iconOffset) + "px";
        iconNode.style.top = (e.clientY + iconOffset)+ "px";
    }
    var tmp_module = folder.module;
    if (dragType == tmp_module
            && ox.api.folder.can("write", folder) === true
            && !(folder.type == 3 && tmp_module == "tasks")) {
        // final callback after we have all object information
        function finalCb (objects) {
            var enabled = true;
            // iterate through objects and do module specific checks
            for (var i=0; i < objects.length; i++) {
                var obj = objects[i];
                // disallow moving private objects to public folder (type 2)
                if (folder.type == 2 && obj.private_flag == true) {
                    enabled = false;
                    break;
                }
            }
            setDefaultNodeType(iconNode, enabled);
        }
        
        // obviously we need more information of each object than we get out of draggedObjects
        // as this function will be called a thousand times we ask the cache only once
        // and only if this is a cache enabled module (of course)
        if ((tmp_module == "contacts" || tmp_module == "tasks")
                && draggedObjects.fetchedFromCache !== true 
                && typeof OXCache.moduleMappings[tmp_module] == "function"
                && jQuery.isArray(draggedObjects.currentObjects)) {
            // right now we use a 'static' collection. we may have to seperate that
            // for each module. at least when we need additional data or a module
            // without the field private_flag
            var collection = { columns: [ "id", "folder_id", "private_flag" ],
                    objects: draggedObjects.currentObjects };
            var mapping = OXCache.moduleMappings[tmp_module];
            OXCache.newRequest(null, tmp_module, collection, null,
                function(daten) {
                    // overwrite currentObjects. this can be evil as soon as we 
                    // need more information as requested in the current static collection
                    draggedObjects.currentObjects = daten.objects;
                    draggedObjects.fetchedFromCache = true;
                    finalCb(draggedObjects.currentObjects);
                }
            );
        } else {
            // already cached. hopefully the object holds every 
            // information we need
            finalCb(draggedObjects.currentObjects);
        }
        
    } else if (dragType=="folder/1" || dragType=="folder/2" || dragType=="folder/3" || dragType=="folder/7") {
        // get folder
        ox.api.folder.get({
            folder: draggedObjects,
            success: function (source) {
                nodeSetSubjectDefault(iconNode, source.title);
                ox.api.folder.canMove(source, folder, function() {
                    setDefaultNodeType(iconNode,true);
                }, function() {
                    setDefaultNodeType(iconNode,false);
                });
            }
        });
    } else if (dragType == "mailaddress" && folder.module == "contacts") {
        myrights = computePerm(folder.own_rights, 0);
        if(myrights >= 2) {
            setDefaultNodeType(iconNode,true);
        } else {
            setDefaultNodeType(iconNode,false);
        }
    } else {
        setDefaultNodeType(iconNode,false);
    }
    iconNode.style.left = (e.clientX + iconOffset) + "px";
    iconNode.style.top = (e.clientY + iconOffset)+ "px";
}

function minicalenable(e,dragType,draggedObjects,mouseposition,targetNode,node) {
    var iconNode = document.getElementById("dragdrop_default_node");
    if (iconNode == undefined) {
        iconNode=createDefaultNode();
        body.appendChild(iconNode);
    }
    iconNode.style.left = (e.clientX + iconOffset) + "px";
    iconNode.style.top = (e.clientY + iconOffset)+ "px";
    setDefaultNodeType(iconNode, false);

    if (draggedObjects && draggedObjects.currentObjects) {
        if (dragType === "contacts") {
            OXCache.newRequest(null,"contacts", {
                objects: draggedObjects.currentObjects,
                columns: ["folder_id", "id", "display_name", "first_name", "last_name","email1","email2"]
            }, null, function (data) {
                if (!data || !data.objects) {
                    setDefaultNodeType(iconNode, false);
                    return false;
                }
                var found = false;
                for (var i=0; i < data.objects.length; i++) {
                    var obj = data.objects[i];
                    if (obj["email1"] || obj["email2"]) {
                        found = true;
                        break;
                    }
                    obj = null;
                }
                setDefaultNodeType(iconNode, found);
            });
        } else if (dragType === "mail") {
            setDefaultNodeType(iconNode, true);
        }
    }
}

function foldertreedisable(e,dragType,draggedObjects,mouseposition,targetNode) {
    var iconNode = document.getElementById("dragdrop_default_node");
    if(iconNode == undefined) {
        iconNode=createDefaultNode();
        iconNode.style.left = (e.clientX + iconOffset) + "px";iconNode.style.top = (e.clientY + iconOffset)+ "px";
        body.appendChild(iconNode);
    }
    iconNode.style.left = (e.clientX + iconOffset) + "px";
    iconNode.style.top = (e.clientY + iconOffset)+ "px";
    setDefaultNodeType(iconNode,false);
    ox.api.folder.get({
        folder: draggedObjects,
        success: function (data) {
            nodeSetSubjectDefault(iconNode, data.title);
        }
    });
}
function defaultdisabledremove(e) {
    if(document.getElementById("dragdrop_default_node")) {
        document.getElementById("dragdrop_default_node").parentNode.removeChild(document.getElementById("dragdrop_default_node"));
    }
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

var globalclickdisable2=true;
var activeComboBox = null;

function changePopUpMenuText3(obj, n, noevent)
{
    var myValues = [];
    myValues = obj.elements[n];
    
    if (myValues.callback.nodeType || typeof myValues.callback == "function") {
        obj.currentI18nNode.callback = myValues.callback;
    } else {
        obj.currentI18nNode.callback = function() {
            return String(myValues.callback);
        };
    }
    obj.currentI18nNode.update();
            
    obj.selected = n;
     var key = myValues.key;
    
    if (obj.targetDiv) {
        if(obj.form) {
            obj.targetDiv.value = key;
        } else {
            if(!obj.valueIsHTML) {
                if(obj.targetDiv && obj.targetDiv.firstChild) {
                    obj.targetDiv.firstChild.data = key;
                }
            }
            else {
                removeChildNodes(obj.targetDiv);
                if(key) {
                    obj.targetDiv.appendChild(key);
                }
            }
                
        }        
    }
    if (obj.onChange && !noevent) {
        obj.onChange(key, obj.currentResult);
    }
        
    obj.currentResult = key;
}

function createComboBoxOverlay(scope) {
    // overlay - combo-box may block - not unusual
    return jQuery("<div/>")
        .addClass("oxStretch")
        .css({
            display: "none",
            opacity: 0.01,
            zIndex: 40000,
            backgroundColor: "white"
        })
        .bind("click", function (e) {
            scope.overlay.hide();
            showHideBox3(scope, e);
        })
        .appendTo(document.body);
}

/**
 * Make ComboBox
 * @param {object} current Window where the combobox is called
 * @param {String} id of rootDiv, to append the combobox
 * @param {String} width from the combobox
 * @param {int} index of selected item from the elements
 * @param {boolean} default Style, should be used ore not
 * @param {String} eventname to trigger an event onChange
 * @param {int} scrollbar should be shown after n items
 * example:
 * new ComboBox3(window, "start_time", "15em", myElements, 0, false, changetime, 6);
 */

function ComboBox3(window, elementid, width, selected, style, eventname, maxscrollbar,eventParam) {
    return new ComboBox3.impl(window, ($ALL(elementid) || newnode("div")), width, selected, style,
        maxscrollbar,
        function(key) { triggerEvent(eventname, key, eventParam); } );
}

ComboBox3.impl = function (window, rootDiv, width, selected, style, maxscrollbar, onchange, onshow, onhide) {
    this.window = window;
    this.selected = selected;
    this.elements = [];
    this.width=width;
    this.maxscrollbar=maxscrollbar;
    this.style = style;
    this.targetDiv = null;
    this.valueIsHTML = false; //the value is a node
    this.form = false;
    this.viewValue = false;
    this.disabled = false;        
    this.rowHeight;    
    this.childOffsetTop;
    var Self = this;
    this.rootDiv = rootDiv;
    this.rootDiv.tabIndex = 0;
    this.rootDiv.style.outline = "none";
    this.keydown_cb = function(e) {
        return Self.key(e);
    };
    addDOMEvent(this.rootDiv, "keydown", this.keydown_cb);
    this.rootDiv.innerHTML = "";
    this.headTable = newnode('table',0,{
                     cellPadding: 0, cellSpacing: 0, border: 0});
    this.headTable.style.tableLayout="fixed";
    this.headTableBody = document.createElement("tbody");
    this.headTableRow = document.createElement("tr");
    this.headTableColumn1 = document.createElement("td");    
    this.headTableColumn1.setAttribute("nowrap","nowrap");
    this.headTableColumn1.style.whiteSpace = "nowrap";
    this.headTableColumn1div = document.createElement("div");    
    this.headTableColumn1.appendChild(this.headTableColumn1div);
    this.headTableColumn1div.style.width = "92%";    
    this.headTableColumn1div.style.paddingRight = "3px";        
    this.headTableColumn1div.style.overflow = "hidden";    
    this.headTableColumn2 = document.createElement("td");
    this.headTableColumn2.setAttribute("width","14");
    this.myboxComboDiv = document.createElement("div");
    jQuery(this.myboxComboDiv).click(function(evt) {
    	// handle click on combo layer
        showHideBox3(Self, evt);
        return false;
    });
    this.keySearch = {};
    
    if(this.style) {
        this.headTable.className="smallpopupborder border-color-design smallpopupnotactive background-color-content font-color-default";
        this.headTableColumn1.className="smallpopupborderright border-color-design comboboxColumn1 cursorPointer";
        this.headTableColumn2.className="comboboxColumn2 borderLeftDefault border-color-design";
    }
    this.rootDiv.style.width=this.width;
    this.rootDiv.className="dropdownbox";
    
    this.currentValues = [];
    
    this.currentResult = "";
    
    this.onChange = onchange;
    this.onShow = onshow;
    this.onHide = onhide;
        
    if(maxscrollbar) {  
        this.scrollbar=maxscrollbar;
    } else { 
        this.scrollbar=null;
    }
        
    this.setFirstDiv();
    
    // overlay
    this.overlay = createComboBoxOverlay(this);
};

ComboBox3.impl.prototype = {
    sort: function () {
        function fn(a,b) {
            if(a.value < b.value) {
                return -1;
            } else {
                return 1;
            }
        }
        this.elements.sort(fn);
    },
    sorti18nValue: function () {
        function fn(a,b) {
            //if(a.i18nNode.node.nodeValue < b.i18nNode.node.nodeValue)
            if(a.key == "" ) {
                return -1;
            } else if(b.key == "" ) { 
                return 1;
            } else {
                return a.i18nNode.node.nodeValue.localeCompare( b.i18nNode.node.nodeValue ) ;
            }
        }
        this.elements.sort(fn);
    },
    sortKeys: function () {
        function fn(a,b) {
            if(a.key < b.key) {
                return -1;
            } else {
                return 1;
            }
        }
        this.elements.sort(fn);
    },
    getValue : function () {
        this.currentValues = this.elements[this.selected];
        this.currentValue = this.currentValues.value;
        return this.currentValue;
    },
    setEnabled : function (value) {
        //TODO DISABLED;
    },
    getKey : function () {
        this.currentValues = this.elements[this.selected];
        this.currentResult = this.currentValues.key;
        return this.currentResult;
    }, 
    getSelectedIndex : function () {
        return this.selected;
    },
    setSelectedIndex : function (n, noevent) {
        changePopUpMenuText3(this, n, noevent);
    },
    disable : function () {
        var Self = this;
        Self.headTable.className = Self.headTable.className.replace(/font-color-default/, "font-color-disabled");
        Self.disabled = true;
        Self.headTableColumn2.style.cursor = "default";
        //Self.window.removeDOMEvent(Self.headTable,"click", Self.clickOnCombobox);
    },
    enable : function () {
        var Self = this;
        Self.disabled = false;            
        Self.headTable.className = Self.headTable.className.replace(/font-color-disabled/, "font-color-default");
        Self.headTableColumn2.style.cursor = "pointer";
        //Self.window.addDOMEvent(Self.headTable,"click", Self.clickOnCombobox);  
    },
    setKey : function (key,noevent) {
        var myElValues = [];
        var newIndex = key;
        var bFound = false;
        for(i=0; i<this.elements.length;i++) {
            myElValues = this.elements[i];
                    if (key == myElValues.key) {
                        key = myElValues.key;
                        newIndex = i;
                        bFound = true;
                        break;
                    }               
        }
        if(!bFound) {
            return false;
        }
        if(this.elements[newIndex]) {
            changePopUpMenuText3(
                    this,
                    newIndex,
                    noevent
            );
        }                    
        return true;        
    },    
    setValue : function (value,noevent) {
        var myElValues = [];
        var newIndex = value;
        var bFound = false;
        for(i=0; i<this.elements.length;i++) {
            myElValues = this.elements[i];
            
            if(myElValues.i18nNode && myElValues.i18nNode.node && myElValues.i18nNode.node.nodeValue) {
                myi18nValue = myElValues.i18nNode.node.nodeValue;
            } else {
                myi18nValue = this.elements[i];
            }
                
             if (value == myElValues.value || value == myi18nValue) {
                 value = myElValues.value;
                 newIndex = i;
                 bFound = true;
                 break;
             }         
        }
        if(!bFound) {
            return false;
        }
        if(this.elements[newIndex]) {
            changePopUpMenuText3(
                    this,
                    newIndex,
                    noevent
            );
        }                    
        return true;        
    },    
    setUnknownKey : function(key) {                    
        this.targetDiv.firstChild.data = key;
    },
    scrollToSelected: function (tmpIndex) {
        if (this.scrollbar) {
            // vars
            var index, node, top;
            // get index
            index = tmpIndex !== undefined ? tmpIndex : this.selected;
            // get position & scroll
            node = jQuery(this.myboxComboDiv);
            top = (node.scrollTop() + node.children().eq(index).position().top) >> 0;
            node.scrollTop(top);
        }
    },
    
    key: function(e) {
        switch (e.keyCode || e.which) {
        case 13: // enter
            break;
        case 32: // spacebar
            break;
        case 38: // arrow up
            break;
        case 40: // arrow down
            break;
        case 65: // A
        case 97: // a        
            if (this.keySearch["a"]) {
                this.scrollToSelected(this.keySearch["a"][0]);
            }
            break;
        case 66: // B
        case 98: // b    
            if (this.keySearch["b"]) {    
                this.scrollToSelected(this.keySearch["b"][0]);
            }
            break;
        case 67: // C
        case 99: // c    
            if (this.keySearch["c"]) { 
                this.scrollToSelected(this.keySearch["c"][0]);
            }
            break;
        case 68: // D
        case 100: // d        
            if (this.keySearch["d"]) {
                this.scrollToSelected(this.keySearch["d"][0]);
            }
            break;
        case 69: // E
        case 101: // e        
            if (this.keySearch["e"]) {
                this.scrollToSelected(this.keySearch["e"][0]);
            }
            break;
        case 70: // F
        case 102: // f        
            if (this.keySearch["f"]) {
                this.scrollToSelected(this.keySearch["f"][0]);
            }
            break;
        case 71: // G
        case 103: // g        
            if (this.keySearch["g"]) {
                this.scrollToSelected(this.keySearch["g"][0]);
            }
            break;
        case 72: // H
        case 104: // h        
            if (this.keySearch["h"]) {
                this.scrollToSelected(this.keySearch["h"][0]);
            }
            break;
        case 73: // I
        case 105: // i        
            if (this.keySearch["i"]) {
                this.scrollToSelected(this.keySearch["i"][0]);
            }
            break;
        case 74: // J
        case 106: // j        
            if (this.keySearch["j"]) {
                this.scrollToSelected(this.keySearch["j"][0]);
            }
            break;
        case 75: // K
        case 107: // k        
            if (this.keySearch["k"]) {
                this.scrollToSelected(this.keySearch["k"][0]);
            }
            break;
        case 76: // L
        case 108: // l        
            if (this.keySearch["l"]) {
                this.scrollToSelected(this.keySearch["l"][0]);
            }
            break;
        case 77: // M
        case 109: // m        
            if (this.keySearch["m"]) {
                this.scrollToSelected(this.keySearch["m"][0]);
            }
            break;
        case 78: // N
        case 110: // n        
            if (this.keySearch["n"]) {
                this.scrollToSelected(this.keySearch["n"][0]);
            }
            break;
        case 79: // O
        case 111: // o    
            if (this.keySearch["o"]) {
                this.scrollToSelected(this.keySearch["o"][0]);
            }
            break;
        case 80: // P
        case 112: // p        
            if (this.keySearch["p"]) {
                this.scrollToSelected(this.keySearch["p"][0]);
            }
            break;
        case 81: // Q
        case 113: // q        
            if (this.keySearch["q"]) {
                this.scrollToSelected(this.keySearch["q"][0]);
            }
            break;
        case 82: // R
        case 114: // r        
            if (this.keySearch["r"]) {
                this.scrollToSelected(this.keySearch["r"][0]);
            }
            break;
        case 83: // S
        case 115: // s        
            if (this.keySearch["s"]) {
                this.scrollToSelected(this.keySearch["s"][0]);
            }
            break;
        case 84: // T
        case 116: // t        
            if (this.keySearch["t"]) {
                this.scrollToSelected(this.keySearch["t"][0]);
            }
            break;
        case 85: // U
        case 117: // u        
            if (this.keySearch["u"]) {
                this.scrollToSelected(this.keySearch["u"][0]);
            }
            break;
        case 86: // V
        case 118: // v        
            if (this.keySearch["v"]) {
                this.scrollToSelected(this.keySearch["v"][0]);
            }
            break;
        case 87: // W
        case 119: // w        
            if (this.keySearch["w"]) {
                this.scrollToSelected(this.keySearch["w"][0]);
            }
            break;
        case 88: // X
        case 120: // x        
            if (this.keySearch["x"]) {
                this.scrollToSelected(this.keySearch["x"][0]);
            }
            break;
        case 89: // Y
        case 121: // y        
            if (this.keySearch["y"]) {
                this.scrollToSelected(this.keySearch["y"][0]);
            }
            break;
        case 90: // Z
        case 122: // z        
            if (this.keySearch["z"]) {
                this.scrollToSelected(this.keySearch["z"][0]);
            }
            break;
        default:
            return;
        }
        stopEvent(e);
        return false;
    },
    
    setFirstDiv: function () {
        var Self = this;
                        
        Self.clickOnCombobox = function (e) { 
            if(!Self.disabled) {
                showHideBox3(Self,e);
                cancelBubbling(e);
            }
            cancelDefault(e);
        };
        
        Self.headTable.style.width=this.width;    
        setTimeout(function () {
            var tmpW = Self.headTable.offsetWidth - 16;
                
            Self.headTableColumn2.style.width="16px";
            Self.headTableColumn2.style.textAlign="center";
        
            Self.image=document.createElement("img");
            Self.image.className="cursorPointer";
            Self.image.setAttribute("src",getFullImgSrc("img/arrows/arrow_white_down.png"));
            Self.headTableColumn2.appendChild(Self.image);
            Self.headTableRow.appendChild(Self.headTableColumn1);    
            Self.headTableRow.appendChild(Self.headTableColumn2);
            Self.headTableBody.appendChild(Self.headTableRow);
            Self.headTable.appendChild(Self.headTableBody);
            
            Self.window.addDOMEvent(Self.headTable,
                "click", Self.clickOnCombobox);  
                
               Self.window.addDOMEvent(Self.headTable,
                "mouseover", function() { globalclickdisable2=true; }); 
                
               Self.window.addDOMEvent(Self.headTable,
                "mouseout", function() { globalclickdisable2=false; });  
        }, 0);        
        
        Self.rootDiv.appendChild(Self.headTable);
        
    },
    
    clickOnCombobox: function (e) { 
        showHideBox3(this,e);
    },
    
    addElement: function (value, key, callback) {
        if (typeof value == "string") {
            if(value.length > 0) {
                var indexKeySearchSingle = value.substr(0,1).toLowerCase();
                if (typeof this.keySearch[indexKeySearchSingle] == "undefined") {
                    this.keySearch[indexKeySearchSingle] = [];
                }
                this.keySearch[indexKeySearchSingle].push(this.elements.length);
            }
            /*
             * for later implemantation
            if(key.length > 1) {
                var indexKeySearchDuo = key.substr(0,2).toLowerCase();
                if(typeof this.keySearch[indexKeySearchDuo] == "undefined") this.keySearch[indexKeySearchDuo] = new Array();
                this.keySearch[indexKeySearchDuo].push(this.elements.length);
            }
            */
        }
        this.elements.push({
            value: value,
            key: key,
            callback: callback || value
        });
    },
    
    getElement: function (key) {
        for (var i in this.elements) {
            if (this.elements[i].key == key)  {
                return this.elements[i];
            }
        }
    },
    
    getDomNode: function (sortedAfterTranslation) {    
        
        function fakeI18n(callback) {
            this.callback = callback;
            this.node = newnode("div",0,0,[callback.cloneNode(true)]);
            this.update = function() {
                removeChildNodes(this.node);
                this.node.appendChild(this.callback.cloneNode(true));
            };
        }
        
        while (this.myboxComboDiv.childNodes.length > 0) {
            this.myboxComboDiv.removeChild(this.myboxComboDiv.firstChild);
        }

        this.currentValues = this.elements[this.selected];
        this.currentValue = this.currentValues.value;
        this.currentResult = this.currentValues.key;    
        while (this.headTableColumn1div.childNodes.length > 0) {
            this.headTableColumn1div.removeChild(this.headTableColumn1div.firstChild);
        }
        if (this.currentValues.value.nodeType) {
            this.currentI18nNode = new fakeI18n(this.currentValues.callback);            
        } else {
            this.currentI18nNode = new I18nNode(this.currentValues.callback);
        }
        this.headTableColumn1div.appendChild(this.currentI18nNode.node);
        var Self = this;            
        Self.myboxComboDiv.className="smallpopupborder smallpopuplist background-color-content font-weight-default font-color-default border-color-design";
        Self.myboxComboDiv.style.display="none";
        Self.myboxComboDiv.style.textAlign="left";
        Self.myboxComboDiv.style.whiteSpace = "nowrap";    
               
        for(var el1 in Self.elements) {
            (function (n) {
                var myValues = [];                                     
                   myValues = Self.elements[n];
                   if (myValues.value.nodeType) {
                       myValues.i18nNode = new fakeI18n(myValues.callback);
                   } else {
                       myValues.i18nNode = new I18nNode(myValues.callback);
                   }
            })(el1);
        }
        
        if (sortedAfterTranslation) {
            this.sorti18nValue();    
               Self.keySearch = {};
               Self.indexForKeySearch = 0;        
        }
        
        
        for(var el in Self.elements)
        {
            (function (n) {
                var childDiv = null;
                var myValues = [];
                childDiv = newnode("div",0,{className:"height16 background-color-content cursorDefault"});
                //childDiv.style.overflow="hidden";
                childDiv.style.padding="3px 0 0 4px";
                Self.window.addDOMEvent(childDiv,
                    "click", function() { 
                             changePopUpMenuText3(Self,n);
                             Self.rootDiv.blur(); 
                         }
                   );
                   
                Self.window.addDOMEvent(childDiv,
                    "mouseover", function() { changePopUpMenuStatus3(childDiv, true, Self); });
                    
                Self.window.addDOMEvent(childDiv,
                    "mouseout", function() { changePopUpMenuStatus3(childDiv, false, Self); });
                                 
                    myValues = Self.elements[n];
                    
                    if (sortedAfterTranslation) {
                        if(typeof myValues.i18nNode.node.nodeValue == "string" && myValues.value != "please select") {
                            if(myValues.i18nNode.node.nodeValue.length > 0) {
                                var indexKeySearchSingle = myValues.i18nNode.node.nodeValue.substr(0,1).toLowerCase();
                                if (typeof Self.keySearch[indexKeySearchSingle] == "undefined") {
                                    Self.keySearch[indexKeySearchSingle] = [];
                                }
                                Self.keySearch[indexKeySearchSingle].push(Self.indexForKeySearch);
                            }
                        }
                        Self.indexForKeySearch++;
                    }
                    
                    if (Self.viewValue) {
                        if (myValues.key != "") {
                            childDiv.className = "height16 font-color-default background-color-content";
                        } else {
                            childDiv.className = "height16 font-color-disabled background-color-content";
                        }
                   }
                   if (!myValues.i18nNode) {
                       if (myValues.value.nodeType) {
                           myValues.i18nNode = new fakeI18n(myValues.callback);
                       } else {                           
                           myValues.i18nNode = new I18nNode(myValues.callback);
                       }
                   }
                   childDiv.appendChild(myValues.i18nNode.node);
                
                if (!Self.rowHeight) {
                    var tmpnode=childDiv.cloneNode(true);
                    tmpnode.style.display="block";
                    tmpnode.style.zIndex=-1;
                    body.appendChild(tmpnode);                
                    Self.rowHeight=tmpnode.offsetHeight;
                    body.removeChild(tmpnode);
                }
                    
                Self.myboxComboDiv.appendChild(childDiv);
            })(el);
        }
        if(this.scrollbar && this.scrollbar != "" && typeof this.scrollbar != "undefined") {
            var tempHeight = Math.floor(this.scrollbar*this.rowHeight);
            Self.myboxComboDiv.style.height=tempHeight+"px";
        }
        
        document.body.appendChild(Self.myboxComboDiv);
        
        if (this.maxscrollbar) {
            Self.myboxComboDiv.style.overflowX="hidden";
        } else {
            Self.myboxComboDiv.style.overflow="hidden";
        }
        
        return Self.rootDiv;
    }
};

function ComboBoxSpecial(window, element, width, selected, style, eventname, maxscrollbar,eventParam) {
    var Self = this;
    this.window = window;
    this.selected = selected;
    this.elements = [];
    this.width=width;
    this.style = style;
    this.targetDiv = null;
    this.valueIsHTML = false; //the value is a node
    this.form = false;
    this.viewValue = false;
    this.disabled = false;
    this.optWidth;
    this.show_buttons = false;
    this.special = true;
    this.keySearch = {};
    
    this.rootDiv = element;
    this.rootDiv.innerHTML = "";
    this.headTable = newnode('table',0,{
                     cellPadding: 0, cellSpacing: 0, border: 0});
                     
    this.headTable.style.tableLayout="fixed";
    this.headTableBody = document.createElement("tbody");
    this.headTableRow = document.createElement("tr");
    this.headTableColumn1 = document.createElement("td");    
    this.headTableColumn1.setAttribute("nowrap","nowrap");
    this.headTableColumn1.style.whiteSpace = "nowrap";
    this.headTableColumn1div = newnode("div",{textAlign:"center"});    
    this.headTableColumn1.appendChild(this.headTableColumn1div);
    this.headTableColumn1div.style.overflow = "hidden";    
    this.myboxComboDiv = newnode("div");
    jQuery(this.myboxComboDiv).click(function(evt){
    	// handle click on combo layer
        showHideBox3(Self,evt);
        return false;
    });
    
    if (this.style) {
        this.headTable.className="smallpopupborder smallpopupnotactive background-color-content font-color-default";
        this.headTableColumn1.className="smallpopupborderright border-color-design comboboxColumn1";
    }
    this.rootDiv.style.width=this.width;
    this.rootDiv.className="dropdownbox";
    
    this.currentValues = [];
    
    this.currentResult = "";
    
    if(eventname) {
        this.onChange = function(key, key_before) {
            triggerEvent(eventname, key, eventParam);
        };
    }
    
    if(maxscrollbar) {
        this.scrollbar=maxscrollbar;
    } else { 
        this.scrollbar=null;
    }
        
    this.setFirstDiv();

//extends.. Combobox3
    this.scrollToSelected = ComboBox3.impl.prototype.scrollToSelected;    
    this.setKey = ComboBox3.impl.prototype.setKey;        
    this.addElement = ComboBox3.impl.prototype.addElement;    
    this.sort = ComboBox3.impl.prototype.sort;
    
    // overlay
    this.overlay = createComboBoxOverlay(this);
}
ComboBoxSpecial.prototype = {
    setDynamicKey: function (key,noevent) {
        this.elements = [];
        for(var nIndx=-3;nIndx< 3;nIndx++) {
            this.addElement(noI18n(nIndx+key), nIndx+key);
        }
        this.getDomNode();        

        var myElValues = [];
        var newIndex = key;
        var bFound = false;
        for(i=0; i<this.elements.length;i++) {
            myElValues = this.elements[i];
                    if (key == myElValues.key) {
                        key = myElValues.key;
                        newIndex = i;
                        bFound = true;
                        break;
                    }               
        }
        if(!bFound) {
            return false;
        }
        if(this.elements[newIndex]) {
            changePopUpMenuText3(
                    this,
                    newIndex,
                    noevent
            );
        }                    
        return true;        
    },        
    setFirstDiv:function () {
        var Self = this;
                                
        Self.clickOnCombobox = function (e) { 
                    if (!Self.disabled) {
                        showHideBox3(Self,e);
                    }
                    stopEvent(e);
        };
        Self.headTable.style.width=this.width;    
        setTimeout(function () {
            var tmpW = Self.headTable.offsetWidth - 16;
            Self.headTableRow.appendChild(Self.headTableColumn1);    
            Self.headTableBody.appendChild(Self.headTableRow);
            Self.headTable.appendChild(Self.headTableBody);
             
            Self.window.addDOMEvent(Self.headTable,
             "click", Self.clickOnCombobox);  
             
             Self.window.addDOMEvent(Self.headTable,
             "mouseover", function() { globalclickdisable2=true; }); 
             
             Self.window.addDOMEvent(Self.headTable,
             "mouseout", function() { globalclickdisable2=false; });  
        }, 0);        
        
        Self.rootDiv.appendChild(Self.headTable);        
    },    
    scrollElements : function (sDirection){
        if(sDirection == "up") {
            var nOldVal = this.elements[0].value-6;
            this.elements = [];
            for ( var nIndx = 0; nIndx < 6; nIndx++) {
                this.addElement(noI18n(nOldVal + nIndx), nOldVal + nIndx);
            }
            this.getList();                
        }
        else {
            var nOldVal = this.elements[this.elements.length-1].value;
            this.elements = [];
            for(var nIndx=1;nIndx<= 6;nIndx++) {
                this.addElement(noI18n(nOldVal+nIndx), nOldVal+nIndx);
            }
            this.getList();                            
        }            
    },
    
    getDomNode: function () {
        this.currentValues = this.elements[this.selected];
        this.currentValue = this.currentValues.value;
        this.currentResult = this.currentValues.key;    
        while (this.headTableColumn1div.childNodes.length>0) {
            this.headTableColumn1div.removeChild(this.headTableColumn1div.firstChild);
        }
        this.currentI18nNode = new I18nNode(this.currentValues.callback);
        this.headTableColumn1div.appendChild(this.currentI18nNode.node);

        var Self = this;        
        if (this.optWidth) {
            this.myboxComboDiv.style.width = this.optWidth;
        }
        
        Self.myboxComboDiv.className="smallpopupborder smallpopuplist background-color-content font-color-default";
        Self.myboxComboDiv.style.display="none";
        Self.myboxComboDiv.style.textAlign="left";            
        
        Self.getList();
        document.body.appendChild(Self.myboxComboDiv);
        Self.myboxComboDiv.style.overflowX="hidden";
                        
    },
    getList: function () {
        var Self = this;
        if(this.scrollbar && this.scrollbar != "" && typeof this.scrollbar != "undefined") {
            if (Self.show_buttons) {
                var nfactor = 17;
            } else {
                var nfactor = 19.5;
            }
            var tempHeight = Math.floor(this.scrollbar*nfactor);

        }        
        while (this.myboxComboDiv.childNodes.length > 0) {
            this.myboxComboDiv.removeChild(this.myboxComboDiv.firstChild);
        }
        if(Self.show_buttons) {
            Self.myboxComboDiv.style.overflow = "hidden";
            Self.myboxComboDiv.style.height=(tempHeight + 22)/pxPerEm + "em";        
            var oDomUp = newnode("div",0,{className:"height10 background-color-content"});
            oDomUp.style.paddingBottom ="2px";            
            oDomUp.style.overflow="hidden";
            oDomUp.style.textAlign = "center";    
            oDomUp.style.height = "10px";            
            oDomUp.style.lineHeight = "10px";            
            oDomUp.appendChild(newnode('img',{marginBottom:"2px"},{src : getFullImgSrc("img/arrows/sort_up.gif")}));
            //select on mouse over
            Self.window.addDOMEvent(oDomUp,
                "mouseover", function() { changePopUpMenuStatus3(oDomUp, true, Self); });                        
                
            Self.window.addDOMEvent(oDomUp,
                "mouseout", function() { changePopUpMenuStatus3(oDomUp, false, Self); });             
               
            Self.rowHeight = oDomUp.offsetHeight;
            Self.window.addDOMEvent(oDomUp,"click",function (e){Self.scrollElements("up");stopEvent(e);return false;});
            Self.myboxComboDiv.appendChild(oDomUp);
            
        } else {
            Self.myboxComboDiv.style.height=tempHeight + "px";
        }
        for (var el in Self.elements) {
            (function (n) {
                var childDiv = null;
                var myValues = [];
                childDiv = newnode("div", {overflow : "hidden"});
                childDiv.style.paddingLeft ="2px";        
                childDiv.style.paddingRight ="2px";        
                childDiv.style.width="96%";
                if (Self.show_buttons) {
                    childDiv.className="height14 background-color-content";
                } else {
                    childDiv.className="height16 background-color-content";
                }
                
                Self.rowHeight = childDiv.offsetHeight;
                Self.window.addDOMEvent(childDiv,
                    "click", function() { 
                             changePopUpMenuText3(Self,n);                                                    
                         }
                   );                        
                    
                Self.window.addDOMEvent(childDiv,
                    "mouseover", function() { changePopUpMenuStatus3(childDiv, true, Self); });                        
                    
                Self.window.addDOMEvent(childDiv,
                    "mouseout", function() { changePopUpMenuStatus3(childDiv, false, Self); });      
                                         
                   myValues = Self.elements[n];
                   if(Self.viewValue) {
                        if (myValues.key != "") {
                            childDiv.className = "height16 font-color-default background-color-content";
                        } else {
                            childDiv.className = "height16 font-color-disabled background-color-content";
                        }
                   }
                myValues.i18nNode = new I18nNode(myValues.callback);
                childDiv.appendChild(myValues.i18nNode.node);
                    
                Self.myboxComboDiv.appendChild(childDiv);
                 
            })(el);
        }
        if(Self.show_buttons) {                
            var oDomDown = newnode("div",{textAlign:"center"}, {className : "background-color-content"});
            oDomDown.style.paddingBottom ="2px";        
            oDomDown.style.height = "10px";                                                                    
            oDomDown.style.lineHeight = "10px";                        
            oDomDown.appendChild(newnode('img',{marginBottom:"2px",marginTop:"2px"},{src : getFullImgSrc("img/arrows/arrow-down.gif")}));            
            //select on mouse over
            Self.window.addDOMEvent(oDomDown,
                "mouseover", function() { changePopUpMenuStatus3(oDomDown, true, Self); });                        
                
            Self.window.addDOMEvent(oDomDown,
                "mouseout", function() { changePopUpMenuStatus3(oDomDown, false, Self); });             
                   
            Self.window.addDOMEvent(oDomDown,"click",function (e){Self.scrollElements("down");stopEvent(e);return false;});        
            Self.myboxComboDiv.appendChild(oDomDown);
        }        
    }
    
};

function showHideBox3(Self, e) {
    
    if (activeComboBox) {
        
        // hide
        Self.overlay.hide();
        Self.myboxComboDiv.style.display="none";
        jQuery(activeComboBox.myboxComboDiv).hide();
        if (Self.onHide) {
            Self.onHide();
        }
        activeComboBox = null;
        
    } else {
        
        // show
        Self.overlay.show();
        
        if (jQuery(Self.rootDiv).outerWidth() > jQuery(Self.myboxComboDiv).innerWidth()) {
            jQuery(Self.myboxComboDiv).width(jQuery(Self.rootDiv).outerWidth());
        } else if (!Self.resizedWidth){
            jQuery(Self.myboxComboDiv).width(jQuery(Self.myboxComboDiv).innerWidth() + 25);
        }
        Self.resizedWidth = true;
        
        if (!document.all) {
            Self.myboxComboDiv.style.marginLeft = -1 + "px";
        }
        
        // open properly
        // box
        var box = jQuery(Self.rootDiv),
            // drop-down
            drop  = jQuery(Self.myboxComboDiv),
            // box height
            bh = box.outerHeight(),
            // box position
            pos = box.offset(),
            // height of drop-down
            h = drop.outerHeight(),
            // drop's offset parent
            p = jQuery("body"),
            // offset parent's height
            ph = p.height();
        
        // adjust position
        drop.css({
            zIndex: 40001,
            margin: "0px",
            left: (pos.left) + "px"
        });
        
        // enough space to appear below?
        if (ph > (pos.top + bh + h)) {
            drop.css("top", (pos.top + bh) + "px");
        } else {
            drop.css("top", Math.max(0, pos.top - h) + "px");
        }
        
        drop.show();
        
        // attach current active object to global object
        activeComboBox = Self;
        Self.scrollToSelected();
        
        if (Self.onShow) {
            Self.onShow();
        }
    }
}

function changePopUpMenuStatus3(element,activated, Self) {
    //if(!IE6) return;
    if(activated) {
        element.className = element.className.replace(/background-color-content/,"background-color-PMG-selection-elements");
    } else { 
        element.className = element.className.replace(/background-color-PMG-selection-elements/,"background-color-content");
    }
}

var globalclickdisable=false;

function changePopUpMenuStatus(elementid,activated) {
    var d=document.getElementById(elementid);
    if (activated) {
        d.className="background-color-PMG-selection-elements border-color-PMG-selection-elements font-color-default";
    } else {
        d.className="smallpopupnotactive background-color-content font-color-default";
    }
}
fileloaded();
/*
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <Viktor.Pracht@open-xchange.org>
 */

/**
 * Hover timing control for multiple object with a common container.
 * A new hover is disabled by default and must be enabled with the method
 * enable(). Before enabling, the width and height methods of the new object
 * must be overwritten (@see Hover.px and Hover.em).
 * @param {Object} parent The DOM node which contains all the nodes that need
 * a hover.
 * @param {Object} hover The DOM node of the hover. The node will be absolutely
 * positioned relative to the document body.
 */

function Hover(parent, hover) {
    Hover.instances.push(this);
	this.parent = parent;
	this.hover = this.node = hover;
	var Self = this;
	var manualDisplay, manualHide;
	
	with (FSM) this.fsm = FSM("start", [
		Trans("start", "initial", Event(parent, "mousemove", parentmove)),
		Trans("initial", "initial", Event(parent, "mousemove", parentmove)),
		Trans("initial", "start", Event(parent, "mouseout", parentout)),
		Trans("initial", "display", Reset(Timeout(Hover.getInitialDelay,
			function() {
				if (Hover.disabled || MousePopup.active) return false;
				show(false);
			}))),
		Trans("display", "final", Event(parent, "mouseout", parentout)),
		Trans("display", "hover", Event(hover, "mouseover", emptyFunction)),
		Trans("final", "hover", Event(hover, "mouseover", emptyFunction)),
		Trans("final", "final", Event(parent, "mousemove", parentmove)),
		Trans("final", "final", Event(parent, "mouseout",
			function(e) {
				try {
					for (var n = e.relatedTarget || e.toElement; n; n = n.parentNode)
						if (n == parent) return false;
					Self.movetarget = null;
				} catch (ex) {}
			})),
		Condition("final",
			function() { return Self.movetarget ? 0 : 1; },
			["initial", "start"],
			Timeout(Hover.getFinalDelay, hide)),
		Trans("hover", "display", Event(parent, "mouseover", emptyFunction)),
		Trans("hover", "final", Event(hover, "mouseout", function(e) {
			try {
				for (var n = e.relatedTarget || e.toElement; n; n = n.parentNode)
					if (n == hover) return false;
			} catch (ex) {}
		})),
		manualDisplay = Trans("start", "manual", Callback(showManual)),
		manualHide = Trans("manual", "start", Callback(hide))
	]);

    function showManual() { show(true); }
	
	function show(manual) {
        if (Hover.current && Hover.current != Self) Hover.current.enable();
        if (Self.movetarget) {
            Self.target = Self.getTarget(Self.movetarget);
            Self.movetarget = null;
        }
        if (!Self.target || Self.onShow(Self.target, manual) === false)
            return false;
        hover.style.visibility = "hidden";
        hover.style.display = "";
        setTimeout(function() {
            var width = Self.width();
            var height = Self.height();
            var x = Self.clientX + 16;
            if (x + width > body.clientWidth)
                x = Math.max(0, Self.clientX - 16 - width);
            var y = Self.clientY + 16;
            if (y + height > body.clientHeight)
                y = Math.max(0, Self.clientY - 16 - height);
            hover.style.visibility = "";
            Self.hover.style.left = x + "px";
            Self.hover.style.top = y + "px";
            Self.show();
        }, 0);
        Self.displayed = true;
        Hover.current = Self;
    }
    
	function hide() {
		if (Self.onHide(Self.target) === false) return false;
		Self.hide();
		Self.displayed = false;
		Hover.current = null;
	};
	
	this.enabled = false;
	
	this.reset = function () {
	    if (this.enabled) {
	        this.enable();
	    }
	};
	
	/**
	 * Enables the hover and hides it if necessary.
	 */
	this.enable = function() {
		if (this.displayed) hide();
		this.fsm.reset();
		this.enabled = true;
	};

	/**
	 * Disables and hides the hover.
	 */
	this.disable = function() {
		if (this.displayed) hide();
		this.fsm.disable();
		this.enabled = false;
	};
    
    /**
     * Manually displays the hover, i. e. without a timeout.
     * If displayed by this method, the hover can only be hidden by calling
     * manualHide.
     * @param {Object} e An object with clientX, clientY and target
     * properties, usually a mousemove Event object.
     */
	this.manualDisplay = function(e) {
	    if (this.manualEnabled === undefined) this.manualEnabled = this.enabled;
	    this.enable();
        parentmove(e);
        manualDisplay.fire();
    };
    
    /**
     * Hides the hover after it has been displayed by manualDisplay.
     */
    this.manualHide = function() {
        manualHide.fire();
        if (!this.manualEnabled) this.disable();
        this.manualEnabled = undefined;
    };
    
	function parentmove(e) {
		Self.clientX = e.clientX;
		Self.clientY = e.clientY;
		Self.movetarget = e.target || e.srcElement;
	}
	
	function parentout(e) {
		if (!("target" in Self)) Self.target = Self.getTarget(Self.movetarget);
		return Self.getTarget(e.relatedTarget || e.toElement) != Self.target;
	}
}

/**
 * @private
 */
Hover.instances = [];

/**
 * Resets all instances
 */
Hover.reset = function () {
    var i = 0, $i = Hover.instances.length;
    for (; i < $i; i++) {
        Hover.instances[i].reset();
    }
};
    
/**
 * @private
 */
Hover.disabled = false;

/**
 * Temporarily disabled all hovers. Must be followed by a call to
 * Hover.enable().
 */
Hover.disable = function() { Hover.disabled++; };

/**
 * Reenables hovers after a call to Hover.disabled().
 */
Hover.enable = function() { Hover.disabled--; };

Hover.prototype = extend(Popup, {});

/**
 * Adjusts the position of an already displayed hover when its size changed.
 * The actual size of the hover is measured, therefore (at least in IE) this
 * function should be called after any manual layout changes take effect
 * (e. g. after a zero timeout).
 */
Hover.prototype.sizeChanged = function() {
	if (this.hover.offsetTop + this.hover.offsetHeight > body.clientHeight)
		this.hover.style.top = Math.max(0, body.clientHeight - this.hover.offsetHeight) + "px";
	if (this.hover.offsetLeft + this.hover.offsetWidth > body.clientWidth)
		this.hover.style.left = Math.max(0, body.clientWidth - this.hover.offsetWidth) + "px";
};

/**
 * A callback which is called before the hover is shown.
 * @param {Object} node The return value of the getTarget method when called on
 * the DOM node (or one of its descendants) for which the hover is displayed.
 * By default, it is the target DOM node itself.
 * @param {Boolean} manual Whether the hover is opened via manualDisplay
 * (if true) or by mouse hovering (if false).
 * @return false to prevent the displaying of the hover. No type conversion is
 * performed, so only a real Boolean value false will cancel the displaying.
 * Values of any other type (in particular, the default of undefined when there
 * is no or an empty return statement) are interpreted as true.
 */
Hover.prototype.onShow = emptyFunction;

/**
 * A callback which is called before the hover is hidden.
 * @param {Object} node The return value of the getTarget method when called on
 * the DOM node (or one of its descendants) for which the hover is displayed.
 * By default, it is the target DOM node itself. 
 * @return false to prevent the hiding of the hover. No type conversion is
 * performed, so only a real Boolean value false will cancel the hiding. Values
 * of any other type (in particular, the default of undefined when there is no
 * or an empty return statement) are interpreted as true.
 */
Hover.prototype.onHide = emptyFunction;

/**
 * A calback which is called to determine the actual hover target from one of
 * its descendants. This function may be called relatively often, so it should
 * return quickly.
 * @param {Object} node One of the direct or indirect descendants of the hover
 * container.
 * @type Object
 * @return The target DOM node or null. Overwriting methods can return pretty
 * much anything, as long as two calls on descendants of the same target (or
 * the target itself) return values which compare as equal when using ==, and
 * two calls on descendants of different targets return values which are not
 * equal. When called on anything but a target or a descendant of a target,
 * an overriding method should return something that converts to false and is
 * not equal to any value returned for a valid target.
 */
Hover.prototype.getTarget = function(node) {
    try {
    	while (node) {
    		var p = node.parentNode;
    		if (p == this.parent) return node;
    		node = p;
    	}
    } catch (e) {
    	// Stupid Firefox likes to pass the scroll bar as event.relatedTarget
        // and then complain about JavaScript not having the permission
        // to access it.
    }
    return null;
};

/**
 * Couples the size of the hover to the size of a DOM node.
 * @param {DOM node} node the DOM node which has the same size as the hover.
 */
Hover.prototype.setSize = function(node) {
    this.width = function() { return node.offsetWidth; };
    this.height = function() { return node.offsetHeight; };
};

/**
 * The delay in milliseconds, during which the mouse pointer must hover over
 * the same point before a hover is displayed.
 */
Hover.initial_delay = 1000;
Hover.getInitialDelay = function () { return Hover.initial_delay; };
/**
 * The delay in milliseconds, before a hover is hidden. This gives the user
 * an opportunity to move the mouse into the hover to interact with it.
 */
Hover.final_delay = 400;
Hover.getFinalDelay = function () { return Hover.final_delay; };
/**
 * Returns a helper function which converts a constant em size to pixel
 * depending on the current value of pxPerEm. This is useful for overriding
 * the width and height methods when the hover has a constant em size.
 * @param {Number} em The size of the hover in em.
 * @type Function
 * @return A function without parameters which returns the size in px.
 */
Hover.em = function(em) {
    return function() { return pxPerEm * em; };
};

/**
 * Returns a helper function which returns a constant.
 * This is useful for overriding the width and height methods when the hover has
 * a constant pixel size.
 * @param {Number} px The size of the hover in px.
 * @type Function
 * @return A function which returns the size in px.
 */
Hover.px = function(px) {
    return function() { return px; };
};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Markus Wagner <markus.wagner@open-xchange.com>
 * 
 */

  ////////////////////
 //  Participants  //
////////////////////

/**
 * Constructor for the participants dialog
 * 
 * @param {String} attachpoint The id of the div where the big livegrid should be inserted
 * @param {function} cbFunction A callback function which is called when you close the participants search window
 * @param {boolean} showUser show or don't show users in the participants search window
 * @param {boolean} showGroup show or don't show groups in the participants search window
 * @param {boolean} showResource show or don't show resources in the participants search window
 * @param {boolean} showFolder enable od disable the possibility to switch the folder. When false is given, only internal user are shown
 * @param {String} title The title of the participants search window
 * @param {Number} id The id of the user which should be initial be inserted into participants
 */
 
function Participants(attachpoint, cbFunction, showUser, showGroup, showResource, showFolder, title, id, singleFolderSearch){
	/**
	 * @private
	 */
	this.attachpoint = attachpoint;
	/**
	 * @private
	 */
	this.setFullParticipants = true;
	/**
	 * @private
	 */
	this.selGroups = [];
	/**
	 * @private
	 */
	this.selContacts = [];
	/**
	 * @private
	 */
	this.selResources = [];
	/**
	 * @private
	 */
	this.internalStorage;
	/**
	 * @private
	 */
	this.showUser = showUser || true;
	/**
	* @private
	*/
	this.showGroup = showGroup || false;

	/**
	* @private
	*/
	this.showResource = showResource || false;
	/**
	* @private
	*/
	this.showFolder = showFolder || false;
	/**
	* @private
	*/
	this.cbFunction = cbFunction;
	/**
	* @private
	*/
	this.title = title || null;		
	/**
	* @private
	*/
	this.id = id || null;		
	/**
	 * @private
	 */
	this.internalStorage2 = new Storage(0, [], "", 0, 0,  null, 
			function(x){ 
				return x[0] + "." + x[1] + "." + x[8] || 0;
			}
	);
	/**
	 * @private
	 */
	this.selectedParticipants = new Array();
	/**
	 * @private
	 */
	this.selectionObject = new Selection();	
	/**
	 * @private
	 */
	this.selectedResource = new Array();
	/**
	 * @private
	 */
	this.participantsGridBig;
	/**
	 * @private
	 */
	this.enabled = false;
	/**
	 * @private
	 */
	this.userData;
	/**
	 * @private
	 */
	this.changedParticipants;
	/**
	 * @private
	 */
	this.contact2user = [];
	/**
	 * @private
	 */
	this.initalFilled;		
	/**
	 * @private
	 */

	this.selPartsStorage  = null;
	this.selRessStorage = null;
	this.groupMemberLiveGrid = null;
	this.groupResolution = new Object();
	
	this.bUserHead = false;
	this.participantsGridSmall;
	this.smallParticipantsInit = false;
	this.singleFolderSearch = singleFolderSearch || false;
	
	var treeVisible = false;
	
	this.getHTML();
	this.emptySearchText = _("Please enter your search");
	this.searchField = jQuery($("searchpattern_participants"));
    this.searchpattern="";
    this.blurTimer;
	var Self = this;
	
	register("OX_Object_Add_Participant", function(){ Self.openAddParticipantsWindow(); });
	register("OX_Object_Add_Ressource", function(){ Self.openAddParticipantsWindow(); });	
	register("closeParticipantsWindowOK", function(){ if(Self.enabled) Self.closeParticipantsWindowOK(); });
	register("closeParticipantsWindowCancel", function(){ if(Self.enabled) Self.closeParticipantsWindowCancel(); });
	register("addToParticipantsList", function(){ if(Self.enabled) Self.addToParticipantsList(); });
	register("addToResourceList", function(){ if(Self.enabled) Self.addToResourceList(); });
	register("searchParticipants", function(){ if(Self.enabled) Self.searchParticipants(); });
	register("OX_Object_Participant_Delete", function(){ Self.deleteParticipants(); });
	
	register("delParticipantsList", function(){ Self.delSelParticipants(); });	
	register("delResourceList", function(){ Self.delSelRessources(); });		
	
	addOnClose($("floatingdivParticipants"), function() { 
		  if (Self.enabled) Self.closeParticipantsWindowCancel(); 
		});
	
	if(!this.showResource){
		$("selectedResourceTr").style.display = "none";
	}
	
    // remove dom events first
    if (Participants.inE) {
        Self.searchField.unbind("keypress click", Participants.inE);
    }
    if (Participants.inB) {
        Self.searchField.unbind("blur", Participants.inB);
    }
	// wrapper functions for key and click events on search field
	Participants.inE = function(e) {
		if (Self.blurTimer != undefined) {
			clearTimeout(Self.blurTimer);
			delete(Self.blurTimer);
		}
		Self.searchParticipantsEnter(e, Self);
	}
    Participants.inB = function(e) {
        Self.blurTimer = setTimeout(function() { 
            Self.searchParticipantsBlur(e, Self); 
        }, 100);
    }
    // re-add dom events
    Self.searchField.bind("keypress click", Participants.inE);
    Self.searchField.bind("blur", Participants.inB);
}

function ParticipantsSmall(attachpoint, cbFunction, showUser, showGroup, showResource, showFolder, 
											title,id,bUserHead,bUserMember, singleFolderSearch){
	/**
	 * @private
	 */
	this.showUser = showUser || false;
	/**
	* @private
	*/
	this.showGroup = showGroup || false;
	/**
	* @private
	*/
	this.showResource = showResource || false;
	/**
	* @private
	*/
	this.showFolder = showFolder || false;
	/**
	 * @private
	 */
	this.attachpoint = attachpoint;
	/**
	 * @private
	 */
	this.setFullParticipants = false;
	/**
	 * @private
	 */
	this.selGroups = [];
	/**
	 * @private
	 */
	this.selContacts = [];
	/**
	 * @private
	 */
	this.selResources = [];
	/**
	 * @private
	 */
	this.internalStorage;
	/**
	 * @private
	 */
	this.internalStorage2 = new Storage(0, [], "", 0, 0,  null, 
			function(x){ 
				return x[0] + "." + x[1] + "." + x[8] || 0;
			}
	);
	/**
	 * @private
	 */
	this.selectedParticipants = new Array();
	/**
	 * @private
	 */
	this.selectedResource = new Array();	
	/**
	 * @private
	 */
	this.cbFunction = cbFunction;
	/**
	* @private
	*/
	this.title = title || null;	
	/**
	 * @private
	 */
	this.enabled = false;	
	/**
	 * @private
	 */
	this.changedParticipants;
	/**
	 * @private
	 */
	this.contact2user = [];
	/**
	 * @private
	 */
	this.initalFilled;				
	/**
	 * @private
	 */
	this.bUserHead = bUserHead;
	this.bUserMember = bUserMember;
	
	this.groupResolution = new Object();
	this.groupMemberLiveGrid = null;
	this.selectedParticipantsGrid = null;
	this.selectedRessourcesGrid = null;
	this.singleFolderSearch = singleFolderSearch || false;

	this.selPartsStorage  = null;
	this.selRessStorage = null;
	this.participantsGridSmall;
	this.smallParticipantsInit = false;
	this.emptySearchText = _("Please enter your search");
	this.searchField = jQuery($("searchpattern_participants"));
	this.searchpattern="";
	this.blurTimer;
	this.allEmailAddresses = false;
	this.getHTML(); 
	var Self = this;

	register("closeParticipantsWindowOK", function() { if (Self.enabled) Self.closeParticipantsWindowOK(); });
	register("closeParticipantsWindowCancel", function(){ if(Self.enabled) Self.closeParticipantsWindowCancel(); });
	register("addToParticipantsList", function(){ if(Self.enabled) Self.addToParticipantsList(); });
	register("addToResourceList", function(){ if(Self.enabled) Self.addToResourceList(); });
	
	register("delParticipantsList", function(){ if(Self.enabled) Self.delSelParticipants(); });	
	register("delResourceList", function(){if(Self.enabled) Self.delSelRessources(); });			
	
	register("searchParticipants", function(){ if(Self.enabled) Self.searchParticipants(); });
	if (!this.showResource) $("selectedResourceTr").style.display = "none";
	
	addOnClose($("floatingdivParticipants"), function(){ if(Self.enabled) Self.closeParticipantsWindowCancel(); });
	
	
    // remove dom events first
    if (Participants.inE) {
        this.searchField.unbind("keypress click", Participants.inE);
    }
    if (Participants.inB) {
        this.searchField.unbind("blur", Participants.inB);
    }
    // wrapper functions for key and click events on search field
    Participants.inE = function(e) {
        if (Self.blurTimer != undefined) {
            clearTimeout(Self.blurTimer);
            delete(Self.blurTimer);
        }
        Self.searchParticipantsEnter(e, Self);
    }
    Participants.inB = function(e) {
        Self.blurTimer = setTimeout(function() { 
            Self.searchParticipantsBlur(e, Self); 
        }, 100);
    }
    
    // re-add dom events
    this.searchField.bind("keypress click", Participants.inE);
    this.searchField.bind("blur", Participants.inB);
}



Participants.prototype = {
		
	// helper for event handling
	f_addParticipant: function(e) { triggerEvent('addToParticipantsList'); },
	f_deleteParticipant: function(e) { triggerEvent('delParticipantsList'); },
	f_addResource: function(e) { triggerEvent('addToResourceList'); },
	f_deleteResource: function(e) { triggerEvent('delResourceList'); },
	// helper: enable button
	f_enableButton: function(nodeId, handler) {
		$(nodeId+"-button").className = "fakeButtonBottomRight";
		$(nodeId).style.cursor = "pointer";
		addDOMEvent($(nodeId), "click", handler);
	},
	// helper: disable button
	f_disableButton: function(nodeId, handler) {
		$(nodeId+"-button").className = "fakeButtonBottomRight font-color-disabled";
		$(nodeId).style.cursor = "default";
		removeDOMEvent($(nodeId), "click", handler);
	},
	// helper: toggle button (via boolean flag)
	f_toggleButton: function(flag, nodeId, handler) {
		var Self = this;
		if (flag) {
			Self.f_enableButton(nodeId, handler);
		} else {
			Self.f_disableButton(nodeId, handler);
		}
	},
	
	getHTML: function() {
		var Self=this;
		if (this.setFullParticipants) {
			var sel = this.selectionObject;

			sel.toggle2 = sel.toggle;
			sel.select2 = sel.select;
			
			sel.toggle = function(index){
				if(this.storage.groups && this.storage.groups[index]){
					return this.select2(index - this.storage.groups[index].before,  index + this.storage.groups[index].after + 1);
				} else {
					return this.toggle2(index);
				}
			}
			
			sel.select = function(from, to){
				for(var i = from; i < to; i++){
					if(this.storage.groups && this.storage.groups[i]){
						this.select2(i - this.storage.groups[i].before,  i + this.storage.groups[i].after + 1);
						i += this.storage.groups[i].after;
					} else {
						this.toggle2(i);
					}
				}
			}
			
			sel.changed_cb2 = sel.changed_cb;
			sel.changed_cb = function(from, to) {
				if (sel.storage.groups)
					filterArray(sel.storage.groups,
						function(group, i) { return !sel.get(1); }, from);
				sel.changed_cb2(from, to);
			};

			this.participantsGridBig = new LiveGrid([
			  {	
					text: "",
					sortable: true,
					width: "16px",
					style: {padding: 0, textOverflow: "clip" },
					set: function(div, text) {
						switch (text[6]) {
							case "contact":
								var userImgSrc = (text[7]) ? getFullImgSrc("img/calendar/user.gif") : getFullImgSrc("img/calendar/user_extern.gif");
								if(div.firstChild.src)
									div.firstChild.src = userImgSrc;
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: userImgSrc, alt: "User", align: "absmiddle"}));
								}
								break;
							case "group":
								if(div.firstChild.src)
									div.firstChild.src = getFullImgSrc("img/calendar/group.gif");
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/group.gif"), alt: "Group", align: "absmiddle"}));
								}
								break;
							case "resource":
								if(div.firstChild.src)
									div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif");
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/ressourcen.gif"), alt: "Resource", align: "absmiddle"}));
								}
								break;								
							default:
								if(div.firstChild.src)
									div.firstChild.src = getFullImgSrc("img/empty16x16.gif");
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/empty16x16.gif"), alt: "Group Member", align: "absmiddle"}));
								}
								break;
						}
					},
					clear: LiveGrid.makeClear("...")
				},	{	
					text: ((this.showUser || this.showGroup) && this.showResource)? "Participants/Resources":/*i18n*/
																				    "Participants", /*i18n*/
					i18n: true,
					sortable: true,
					width: "30%",
					set: function(div, text) {
						removeChildNodes(div);
						var dn = text[2] || text[5] || _("unknown"); /*i18n*/
						if (text[6] == "groupMember"){
							div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/user.gif"), alt: _("Group Member"), title: _("Group Member"), align: "absmiddle"}));
							div.appendChild(document.createTextNode("\u00a0" + dn));
						} else {
						    if (text[2] && text[5]) {
						        dn = text[2] + " <" + text[5] + ">";
						    }
							div.appendChild(document.createTextNode(dn));
						}
					},
					clear: LiveGrid.makeClear("...")
				}, {
					text: "Status", /*i18n*/
					i18n: true,
					sortable: true,
					width: "20%",
					set: function(div, text){
						if(text[6] == "groupMember"){
							removeChildNodes(div);
							div.appendChild(document.createTextNode("\u00a0\u00a0\u00a0\u00a0" + text[3]));
						} else {
							removeChildNodes(div);
							div.appendChild(document.createTextNode(text[3]));
						}
					},
					clear: LiveGrid.makeClear("...")
				}, {
					text: "Comment", /*i18n*/
					i18n: true,
					/* sortable: true, */
					set: function(div, text){
						if(text[6] == "groupMember"){
							removeChildNodes(div);
							div.appendChild(document.createTextNode("\u00a0\u00a0\u00a0\u00a0" + text[4]));
						} else {
							removeChildNodes(div);
							div.appendChild(document.createTextNode(text[4]));
						}
					},
					clear: LiveGrid.makeClear("...")
				}
			], this.selectionObject);
			$(this.attachpoint + "Header").appendChild(this.participantsGridBig.getHeader());
			this.participantsGridBig.getTable($(this.attachpoint));
			
			
			
			this.participantsGridBig.events.register("Selected", function(ids){
				triggerEvent("SubSelected", Self.participantsGridBig.selection.count);
                ox.ToolBarController.processSelection("participants", false,
                    Self.participantsGridBig.selection.getSelected(), true);
			});
			this.participantsGridBig.events.register("Activated", function(ids){
				if(ids[0] && ids[0].split('_')[0]=="group")
				{
					if(Self.groupResolution[ids[0].split('.')[0]])
						Self.openGroupMembersPopup(Self.groupResolution[ids[0].split('.')[0]],ids[0]);	
				}
			});
				
		}
		
		if(!this.smallParticipantsInit) {
			var sel_ = new Selection();
			sel_.oldToggle = sel_.toggle;
			function getTyp(id){ return id.substring(0, id.indexOf("_")); }
			sel_.selectable = function(index) {
				var data = this.storage.data.get(this.storage.getSID(index));
				if(getTyp(data[0]) == "group")
					return Boolean(data[4] != "m_mail")
				else
					return Boolean(data[3] || (getTyp(data[0]) != "contact" && getTyp(data[0]) != "user"));
			}
			sel_.toggle = function(index) {
				return this.selectable(index) && this.oldToggle(index);
			};
			sel_.select = function(from, to) {
				for (var i = from; i < to; i++)
					if (!this.get(i) && this.selectable(i)) this.oldToggle(i);
			}
			
			// live grid in popup
			this.participantsGridSmall = new LiveGrid([
				{	
					text: "&#160;",
					sortable: true,
					width: "20px",
					style: {padding: 0, textOverflow: "clip" },
					set: function(div, text) {
							var color = "";							
							var item_type = getTyp(text[0]);
							switch (item_type) {
								case "contact":
									// nobreak
								case "user":
									// different icons for contacts/users
									var img = item_type == "user" ? "user.gif" : "user_extern.gif";
									// has email?
									if (!text[3]) {
										color = "silver"; 
										img = "user_d.gif";
									}
									// draw node
									if(div.firstChild.src)
										div.firstChild.src = getFullImgSrc("img/calendar/" + img);
									else{
										removeChildNodes(div);
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/" + img), alt: _("User"), title: _("User"), align: "absmiddle"}));
									}
									break;
								case "group":
									color = (Self.bDisableG== -1 || text[4] == "m_mail")?"silver":""; 
									if(div.firstChild.src)								
										div.firstChild.src = (Self.bDisableG!= -1)?getFullImgSrc("img/calendar/group.gif"):getFullImgSrc("img/calendar/user_d.gif");
									else{
										removeChildNodes(div);
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/group.gif"), alt: _("Group"), title: _("Group")}));
									}
									break;
								case "resource":
									if(div.firstChild.src)
										div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif");
									else{
										removeChildNodes(div);
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/ressourcen.gif"), alt: "User"}));
									}
									break;								
								default:
									if(div.firstChild)
										div.firstChild.src = getFullImgSrc("img/empty16x16.gif");
									else
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/empty16x16.gif"), alt: ""}));
									break;
							}
							div.parentNode.style.color = color;
						},
					clear: LiveGrid.makeClear("...")
				}, {	
					text: _("Name"),
					/* sortable: true, */
					width: "40%",
					//set: LiveGrid.defaultSet,
					//index:2
					set: function(div, data) {
						removeChildNodes(div);
						div.appendChild(document.createTextNode(data[2] || data[3] || _("unknown")));
					},
					clear: LiveGrid.makeClear("...")
				}, {
					text: _("E-Mail"),
					/* sortable: true, */
					set: LiveGrid.defaultSet,
					clear: LiveGrid.makeClear("..."),
					index:3
				}
			], sel_);			
			
			this.participantsGridSmall.events.register("Selected", function(ids) {
				// flags
				var canAddParticipant = false;
				var canAddResource = false;
				// current selection
				var items = Self.participantsGridSmall.selection.getSelected();
				// loop selection
				for (i = 0; i < items.length; i++) {
					// get type (e.g. contact, resource, group)
					var type = items[i].split('_')[0];
					switch(type) {
						case "user":
							// internal contacts (users) can be a resource
							canAddParticipant = true;
							//canAddResource = true; // NO LONGER!
							break;
						case "contact":
							// external contacts cannot be a resource
							canAddParticipant = true;
							break;
						case "group": 
							canAddParticipant = true;
							break;
						case "resource": 
							canAddResource = true;
							break;
					}
				}
				
				// participant(s) selected?
				Self.f_toggleButton(canAddParticipant, "buttonAddToParticipantsList", Self.f_addParticipant);
				// resource(s) selected?
				Self.f_toggleButton(canAddResource, "buttonAddToResourcesList", Self.f_addResource);
			});

			this.participantsGridSmall.events.register("Activated", function(ids) {				
				if (ids[0] == undefined && Self.bDisableG == -1 && 
						ids[0].split('_')[0] == 'group') {
					return;
				}
				Self.participantsGridSmall.selection.select(ids[0]);
								
				if (ids[0].split('_')[0] == 'resource')
					triggerEvent('addToResourceList');				
				else	
					triggerEvent('addToParticipantsList');				

			});					
			this.attach_lg_header = newnode("div", { display: "none" },
                { className: "innerTableContainerAddAddresseesHeader" });
            this.attach_lg = newnode("div", { display: "none" },
                { className: "innerTableContainerAddAddressees" });
            $("tableContainerAddParticipants").appendChild(this.attach_lg_header);
            $("tableContainerAddParticipants").appendChild(this.attach_lg);
            this.attach_lg_header.appendChild(this.temp_storage_head = this.participantsGridSmall.getHeader());
			this.participantsGridSmall.getTable(this.attach_lg);
			this.smallParticipantsInit = true;
		}
		if(this.showFolder){
			$("newParticipant_folder").style.display = ""; 
		}
		else{
			$("newParticipant_folder").style.display = "none";		
		}
        
        if (!configGetKey("modules.contacts.singleFolderSearch") && !this.singleFolderSearch) {
            var setDisabled = classNameSetter("font-color-disabled");
            var checkbox = $("participants-search-all-folders");
            checkbox.parentNode.parentNode.parentNode.style.display = "";
            checkbox.checked = true;
            setDisabled($("participants-folder-button"), true);
            checkbox.onclick = function() {
                setDisabled($("participants-folder-button"), checkbox.checked);
            };
        }
	},
	openGroupMembersPopup: function (memberArray,group_id) {
		var sGroupIdSplitDot = group_id.split(".")[0];
		internalCache.getGroups([sGroupIdSplitDot.split('_')[1]],function (res){
            //#. %s is the name of a group.
		    //#, c-format
		    $('memberPopup-h-c').innerHTML = format(_("Members of %s"), /*i18n*/
                res[sGroupIdSplitDot.split('_')[1]].display_name);			
        });

		var Self = this;
		if(typeof memberArray != "object")
			return;
		centerPopupWindow($("memberPopup"));
		$("memberPopup").style.display = "block";
		internalCache.getUsers(memberArray, function(cbObj){
			if(Self.groupMemberLiveGrid == null)
			{	
				Self.groupMemberLiveGrid = new LiveGrid([ 
					{
						text:"",
						index: 1,
						width: "20px",
						style: { textOverflow: "clip" },
						set: function (div, content){
							if (!div.firstChild)
								div.appendChild(newnode("img", null, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16"}));
							switch(content)
							{
								 case "contact": 	
								 		div.firstChild.src = getFullImgSrc("img/calendar/user.gif")
								 		break;
								 case "group": 	
								 		div.firstChild.src = getFullImgSrc("img/calendar/group.gif")
								 		break;							 					
								 case "resource": 
								 		div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif")
								 		break;							 												 					
							}
						},
						clear: function(div) {
							if (!div.firstChild)
								div.appendChild(newnode("img", null, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16"}));
						}
					}, {
						text:_("Group Members"),				
						index: 2,	
						set: LiveGrid.defaultSet,					
						clear: LiveGrid.makeClear("")
					}
				],new Selection());

				Self.groupMemberLiveGrid.emptylivegridtext =_("No Members");
				Self.groupMemberLiveGrid.getHeader();		
				Self.groupMemberLiveGrid.getTable($("member_lg"));
			}					
			var showMember = new Array();

			for(var nId in cbObj)
			{
				showMember.push(["contact_" + cbObj[nId].id,"contact",cbObj[nId].display_name]);
			}	
			var memberStorage = new Storage(0, []);		
			showMember.sort(function(a,b){
				if (a[2] && b[2])
					return a[2].toUpperCase() < b[2].toUpperCase() ? -1 : 1;
				else
					return -1;
			});			
			memberStorage.append(showMember);
			Self.groupMemberLiveGrid.enable(memberStorage);
		});
	},
	openAddParticipantsWindow: function(bDisableG) {
		if (this.opened) {
		    return;
		}
		var Self = this; //bind
		
		// disable all buttons now
		Self.f_disableButton("buttonAddToParticipantsList", Self.f_addParticipant);
		Self.f_disableButton("buttonAddToResourcesList", Self.f_addResource);
		Self.f_disableButton("buttonDeleteFromParticipantsList", Self.f_deleteParticipant);
		Self.f_disableButton("buttonDeleteFromResourcesList", Self.f_deleteResource);

		$("tableContainerAddParticipants").style.display = "block";
		this.attach_lg_header.style.display = "block";
		this.attach_lg.style.display = "block";		
		this.opened = true;
		//clear search
		this.bDisableG = bDisableG;
		this.firstIn = true;
		this.searchField.attr("value", "");
		this.searchField.focus();
		
		if(this.bUserMember) {
			$("headerSelPartAndRes").style.display ="none";
			$("headerSelUser").style.display ="none";						
			$("headerSelPart").style.display ="none";		
			$("headerSelPart2").style.display ="none";	
			$("headerSelUser2").style.display ="none";
			$("headerSelMember").style.display ="";
			$("headerSelMember2").style.display ="";
		}
		else if((this.showUser || this.showGroup) && this.showResource)
		{
			$("headerSelPartAndRes").style.display ="";
			$("headerSelUser").style.display ="none";						
			$("headerSelPart").style.display ="none";		
			$("headerSelPart2").style.display ="";	
			$("headerSelUser2").style.display ="none";	
			$("headerSelMember").style.display ="none";
			$("headerSelMember2").style.display ="none";
		}
		else if((this.showUser || this.showGroup) && this.bUserHead)
		{
			$("headerSelUser").style.display =""			
			$("headerSelPartAndRes").style.display ="none";						
			$("headerSelPart").style.display ="none";			
			$("headerSelPart2").style.display ="none";	
			$("headerSelUser2").style.display ="";
			$("headerSelMember").style.display ="none";
			$("headerSelMember2").style.display ="none";							
		}
		else if(this.showUser || this.showGroup)
		{
			$("headerSelPart").style.display =""			
			$("headerSelPartAndRes").style.display ="none";						
			$("headerSelUser").style.display ="none";			
			$("headerSelPart2").style.display ="";	
			$("headerSelUser2").style.display ="none";
			$("headerSelMember").style.display ="none";
			$("headerSelMember2").style.display ="none";										
		}
        if ($("modal-dialog")) {
            ox.api.setModal(true);
//            showNode("modal-dialog");
//            $("modal-dialog").style.display = "block";
        }
		showNode("floatingdivParticipants");
		centerPopupWindow($("floatingdivParticipants"));
		$("floatingdivParticipants").style.display = "block";	
		if(this.internalStorage){
			this.enable_small_grid(this.internalStorage);
		}
		if(this.title)
			$("floatingdivParticipants-h-c").firstChild.data = this.title.toString();
		this.selectedParticipants = new Array();
		this.selectedResource = new Array();
		this.enabled = true;
		this.changedParticipants = new Array();
        this.changedResources = [];
		if (!this.internalStorage2.groups) {
			this.internalStorage2.groups = new Array();
		}
		removeChildNodes($("selectedParticipants"));
		removeChildNodes($("selectedResource"));
		triggerEvent("searchParticipants");
		this.selPartsStorage = new Storage(0, []);		
		this.selRessStorage = new Storage(0, []);		
		this.selectedParticipantsGrid = null;		
		this.selectedRessourcesGrid = null;		
	},
	
	attachpoint: function() {
		
	},
	
	getParticipants: function(onlyInternal) {
		var parts = [];
		if (this.internalStorage2.data.data) {
			for (var i in this.internalStorage2.data.data) {
			    var part = this.internalStorage2.data.data[i];
			    if (!!onlyInternal || part[4] == null) {
			        continue;
			    }
			    var tmpObj = { id: getID(part[0]) };
                if (part[2]) {
                    tmpObj.display_name = part[2];
                }
                switch (getTyp(part[0])) {
                    case "contact":
                        if (part[1] == 6) {
                            tmpObj.type = 1;
                            tmpObj.id = part[7];
                        } else {
                            tmpObj.type = 5;
                            tmpObj.mail = part[5];
                        }
                        break;
                    case "group":
                        tmpObj.type = 2;
                        break;
                    case "resource":
                        tmpObj.type = 3;
                        break;
                    default:
                        break;
                }
                var found = false, tId = (tmpObj.id + "" + tmpObj.type);
                // search for duplicates in already added list
                for (var a=0; a < parts.length; a++) {
                    var tp = parts[a];
                    if ((tp.id + "" + tp.type) === tId) {
                        // found a duplicate. note: id may be the same
                        // for internal and external addresses so duplicate
                        // check must include the type
                        found = true;
                        break;
                    }
                }
                // no duplicates found
                if (found === false) {
                    // external doesn't have an id
                    if (tmpObj.type == 5) {
                        tmpObj.id = 0;
                    }
                    parts.push(tmpObj);
                }
			}
		}
		//we need empty participants array!!!
		//if(parts.length > 0) 		
		return parts;
		
		function getID(id){ return id = id.substring(id.indexOf("_")+1); }
		function getTyp(id){ return id = id.substring(0, id.indexOf("_")); }
	},
	
	getChangedParticipants: function() {
		return this.changedParticipants;
	},
	
	containsParticipants: function() {
		if(this.userData)
			return true;
		if(this.internalStorage2 && this.internalStorage2.data.data) {
			for (i in this.internalStorage2.data.data) {
				return true;
			} 
		}
		return false;
	},
	
    searchParticipantsBlur : function(event, Self) {
        if (trimStr(Self.searchField.attr("value")).length == 0) {
            Self.searchField.attr("value", Self.emptySearchText);
            Self.searchField.css({ color : "silver" });
        }
    },
    
    searchParticipantsEnter: function (event, Self){
        if (Self.searchField.attr("value") == Self.emptySearchText) {
            Self.searchField.attr("value", "");
            Self.searchField.css({ color : "" });
        } else if (event && event.keyCode == 13) {
            Self.searchpattern = Self.searchField.attr("value");
            triggerEvent("searchParticipants");
        }
    },
    
    displayError: function(msg) {
    	$("participantsSearchError").style.display="";
    	$("participantsSearchError").getElementsByTagName("DIV")[0].firstChild.data=msg;
    },
	
	/**
	 * @private
	 */	
	searchParticipants: function() {
		var Self = this; // bind
		this.searchpattern="";
        var inVal=this.searchField.attr("value");
        if (trimStr(inVal).length == 0 ||
            inVal == this.emptySearchText) {
            setTimeout(function() {
                if (Self.firstIn) {
                    // bug #18925
                    Self.searchField.css({ color: "" });
                    Self.searchField.focus();
                    delete Self.firstIn;
                } else {
                    Self.searchField.attr("value", Self.emptySearchText);
                    Self.searchField.css({ color: "silver" });
                    Self.searchField.blur();
                }
            }, 0);
            
            if (configContainsKey("participants.autoSearch") &&
                configGetKey("participants.autoSearch") == false) {
                this.searchpattern = "";
                //if(this.enabled) this.resetGrid();
                return; 
            } else if (configContainsKey("minimumSearchCharacters") &&
                configGetKey("minimumSearchCharacters") != 0) {
            	this.displayError(
            	   //#. %s is the number of characters.
            	   //#, c-format
            	   format(_("The search pattern requires at least %s characters."), 
            	       configGetKey("minimumSearchCharacters")));
            	return;
            } else {
                this.searchstring="";
            }
        } else if (configContainsKey("minimumSearchCharacters") &&
            trimStr(inVal).length < configGetKey("minimumSearchCharacters")) {
            this.displayError(
                //#. %s is the number of characters.
                //#, c-format
                format(_("The search pattern requires at least %s characters."), 
                    configGetKey("minimumSearchCharacters")));
            return;
        } else {
            this.searchField.css({ color: "" });
            this.searchpattern=inVal;
        }
        
		//if no folder set, use the default
        if(clickedItemParticipant == null || clickedItemParticipant == "") {
            clickedItemParticipant = defaultParticipantFolder;
        }
        var pattern = trimStr(this.searchpattern) ? this.searchpattern : "*";
        var patternObj = { pattern: pattern };
        var userPatternObj = { display_name: pattern, email1: pattern,
            email2: pattern, email3: pattern, last_name: pattern,
            first_name: pattern, orSearch: true };
        if (!$("participants-search-all-folders").checked) {
            patternObj.folder = clickedItemParticipant;
            userPatternObj.folder = clickedItemParticipant;
        }
		
		this.internalStorage = new Storage(0, [], "", 0, 0,  null, 
				function(x){ 
					return x[0] + "." + x[1] + "." + x[5] || 0;
				}
		);		
		
		var oObj;
		var aRequests = new Array();
		var oRequestObj = new Object();

		if(this.showUser){
			oRequestObj['module'] = "contacts";
			oRequestObj['action'] = "search";	
			oRequestObj['columns'] = "1,20,500,555,602,524,556,557,501,502";	
			oRequestObj['sort'] = "500";
			oRequestObj['order'] = "asc";
			oRequestObj['data'] = userPatternObj;
			aRequests.push(oRequestObj);
		}
		if (this.showGroup && clickedItemParticipant == defaultParticipantFolder){		
			var oRequestObj = new Object();		
			oRequestObj['module'] = "group";
			oRequestObj['action'] = "search";		
			oRequestObj['data'] = patternObj;
			aRequests.push(oRequestObj);
		}
		if (this.showResource  && clickedItemParticipant == defaultParticipantFolder){
			var oRequestObj = new Object();		
			oRequestObj['module'] = "resource";
			oRequestObj['action'] = "search";		
			oRequestObj['data'] = patternObj;
			aRequests.push(oRequestObj);		
		}

		// disable for concurrent searches, see bug #17194
		var buton = $("participants_button_go");
		buton.style.color = "#c0c0c0";
		buton.onclick = null;
		Self.searchField.unbind("keypress", Participants.inE);
		
		json.put(AjaxRoot + "/multiple?" + "session=" + session,aRequests,null,function (arg){
			for(var indx=0;indx<aRequests.length;indx++) {
				switch (aRequests[indx].module){
					case "contacts": 
						var tmpArray = new Array();
						for (var i=0; i<arg[indx].data.length; i++){
							// Add a user only when it is not a Distributionlist
							// and either the user has a mail address or admin enabled
							// displaying of participants without email.
							var cb = arg[indx].data[i];
							
							// ignore distribution list
							if (cb[4]) {
								continue; 
							}
							
							var displayname = "";
							if (cb[2]) {
								displayname = cb[2];
							} else if (cb[8] || cb[9]) {
								displayname = (cb[9] || "") + ", " + (cb[8] || ""); 
							} else {
								displayname = cb[3];
							}
							
							if (!cb[3] && !cb[6] && !cb[7] && configGetKey("participants.showWithoutEmail")) {
								// contact do not have any e-mail address but config says show it anyway
								// but we just want to have it once								
								tmpArray.push(["contact_" + cb[0], cb[1], displayname, null, cb[5], 0]);
							} else {
								function isUser(user) {
									return user && user > 0;
								}
							
								// iterate through addresses
								for (var ia=0; ia<3; ia++) {
									var mailaddr = cb[[ 3, 6, 7][ia]];
									// do not add if noaddress available
									if (!mailaddr) continue; 
									
									tmpArray.push([( isUser(cb[5]) ? "user_" : "contact_") + cb[0], cb[1], displayname, mailaddr, cb[5], ia]);
									// we don't want all of the users addresses so we
									// break after adding the first one
									if (!Self.allEmailAddresses) break;
								}		
							}
							
							// remember contact-user-relation of any seen contact
							Self.contact2user[cb[0]] = cb[5];							
						}							
						Self.internalStorage.append(tmpArray);
						break;
					case "group": 
						var tmpArray = new Array();		
						for(var i = 0; i< arg[indx].data.length; i++){
							var cb = arg[indx];		
							var foldertype = (("comboboxProps" in window) && comboboxProps && (comboboxProps.getKey() == "m_mail")) ?	"m_mail" : "";									
							tmpArray[i] = ["group_" + cb.data[i].id, 0, cb.data[i].display_name, "", foldertype, 0];
						}
						tmpArray.sort(function(a,b){
							if (a[2] && b[2]) 
								return a[2].toUpperCase() < b[2].toUpperCase() ? -1 : 1;
							else
								return -1;
						});				
						Self.internalStorage.append(tmpArray);					
						break;							
					case "resource": 
						var tmpArray = new Array();							
						for(var i = 0; i< arg[indx].data.length; i++){
							var cb = arg[indx];			
							tmpArray[i] = ["resource_" + cb.data[i].id, 0, cb.data[i].display_name, "", 0, 0];
						}
						tmpArray.sort(function(a,b){
							if (a[2] && b[2])
								return a[2].toUpperCase() < b[2].toUpperCase() ? -1 : 1;
							else
								return -1;
						});
						Self.internalStorage.append(tmpArray);								
						break;														
				}
			}
			//removeChildNodes($("addParticipantsTableHeader"));
			Self.enable_small_grid(Self.internalStorage);
		}, function(){
			// reenable button if error occures
			var buton = $("participants_button_go");
			buton.style.color = "";
			buton.onclick=function(e) {
				triggerEvent('searchParticipants');
	    	};
	    	Self.searchField.bind("keypress", Participants.inE);
		});
	},
	
	enable_small_grid : function (storage) {
	    // change grid message to standard if it's not a search
        if (this.searchpattern === "") {
            this.participantsGridSmall.emptyMessage.firstChild.data = _("This folder is empty").toString();
        } else if (storage.ids.length === 0) {
            //#. Shown if a search has no result, e.g. in the 'Add participant' dialog
            this.participantsGridSmall.emptyMessage.firstChild.data = _("No search result found for the string provided").toString();
        }
	    
		this.participantsGridSmall.enable(storage);
		if (this.participantsGridSmall && this.participantsGridSmall.selection) {
			this.participantsGridSmall.selection.reset();
		}
		
		var buton = $("participants_button_go");
		buton.style.color = "";
		buton.onclick=function(e) {
			triggerEvent('searchParticipants');
    	};
    	this.searchField.bind("keypress", Participants.inE);
	},
	
	disable_small_grid : function (){
		this.participantsGridSmall.disable();		
        this.searchField.unbind("keypress", Participants.inE);
	},
	
	/**
	 * @private
	 */	
	closeParticipantsWindowOK: function() {
		var Self = this; // bind
		this.opened = false;
		
        if ($("modal-dialog")) {
        	var childs = $("modal-dialog").childNodes;
        	var closeall=true;
		    for (var i=0;i<childs.length;i++) {
		        if(childs[i].tagName && childs[i].tagName == "DIV") {
		            if(childs[i].style.display && childs[i].style.display != "none") {
		                closeall=false;
		            }
		        }
		    }
		    if (closeall) {
		        ox.api.setModal(false);
//                hideNode("modal-dialog");
//                $("modal-dialog").style.display = "none";
		    }
        }
		hideNode("floatingdivParticipants");
		$("floatingdivParticipants").style.display = "none";
		this.attach_lg_header.style.display = "none";
		this.attach_lg.style.display = "none";		
		this.disable_small_grid();
		if(this.selectedParticipantsGrid)
			this.selectedParticipantsGrid.disable();
		if(this.selectedRessourcesGrid)
			this.selectedRessourcesGrid.disable();			
		
		// clear
		this.selGroups = []; this.selContacts = []; this.selResources = [];		
		this.changedParticipants =  new Array();
		
		// copy selected contacts, groups, and resources
		// resources first (higher priority)
		
		if (this.selectedResource && this.selectedResource.length > 0) {
			// loop selected resources
			for(var i = 0; i < this.selectedResource.length; i++) {
				var resource = parseItem(this.selectedResource[i]);
				// distinguish type
				switch (resource.type) {
					case "user":
						var user_as_contact = parseItem(
							"contact_" + resource.id + "." + resource.folder + ".0"
							);
						var contact_as_resource = parseItem(
							"resource_" + this.contact2user[resource.id] + ".0.0"
							);
						// not in grid?
						if ( !inGrid(contact_as_resource.key) ) {
							// in grid as contact?
							if ( inGrid(user_as_contact.key) ) {
								// remove as contact
								this.internalStorage2.removeIDs([user_as_contact.key]);
							}
							// add contact as resource
							this.selResources.push({
								id: contact_as_resource.id,
								folder: contact_as_resource.folder,
								key: contact_as_resource.key
							});
						}
						break;
					case "resource":
						// not in grid?
						if ( ! inGrid(resource.key) ) {
							// add resource
							this.selResources.push({ 
								id: resource.id,
								folder: 0,
								key: resource.key
							});
						}
						break;
				}
			}
		}
		
		// for cache request
		var collection_contact = { 
				objects: [],
				columns: ["display_name", "email1", "email2", "email3", "internal_userid"]
			};
		
		this.enabled = false;
		
		// fill grid now
		
		// join three callbacks
		var joint = new Join(function() {
			// callback
			Self.cbFunction(Self.changedParticipants);
			// enable grid
			if(Self.setFullParticipants) {
				Self.participantsGridBig.enable(Self.internalStorage2);
			}
		});
		
		var cb_resources = joint.add(function(items) {
			var tmpArray = new Array();
			// loop resources
			for (key in items) {
				var item = items[key];
				tmpArray.push([
				               "resource_" + item.id, 0, item.display_name, 
				               _("not sent"), "", "", "resource", 0, 0
				               ]);
				// add as changed
				Self.changedParticipants.push({
					"id": item.id, "display_name": item.display_name,
					"type": 3
				});
			}				
			// add to grid
			Self.internalStorage2.append(tmpArray);
			
			// contacts / groups in second run
	        if (Self.selectedParticipants && Self.selectedParticipants.length > 0) {
	            // loop selected contacts
	            for (var i = 0; i < Self.selectedParticipants.length; i++) {
	                var participant = parseItem(Self.selectedParticipants[i]);
	                // distinguish type
	                switch (participant.type) {
	                    case "user":
	                        // no conflict with resource?
	                        var contact_as_resource = parseItem(
	                                "resource_" + Self.contact2user[participant.id] + ".0.0"
	                                );
	                        // not in grid?
	                        var user_as_contact = parseItem(
	                                "contact_" + participant.id + "." + participant.folder + "." + participant.recurrence
	                                );
	                        if ( inGrid(contact_as_resource.key) || inGrid(user_as_contact.key) ) break;
	                        // nobreak
	                    case "contact":
	                        // not in grid (neither as contact nor as resource)
	                        if ( !inGrid(participant.key) ) {
	                            // add contact
	                            Self.selContacts.push({
	                                id: participant.id,
	                                folder: participant.folder,
	                                recurrence: participant.recurrence,
	                                email: participant.email
	                            });
	                            collection_contact.objects.push({
	                                module: "contacts",
	                                id: participant.id,
	                                folder_id: participant.folder,
	                                recurrence: participant.recurrence,
	                                email: participant.email
	                            });
	                        }
	                        break;
	                    case "group":
	                        // not in grid?         
	                        if ( !inGrid(participant.key) ) {
	                            // add group
	                            Self.selGroups.push({ 
	                                id: participant.id
	                            });
	                        }
	                        break;
	                }
	            }
	        }
			
			// fetch contacts via cache
	        corewindow.OXCache.newRequest(
	            null, "contacts", 
	            corewindow.clone(collection_contact, window), // don't ask (IE7)
	            null, cb_fetch_contacts
	        );
		});
		
		var cb_fetch_contacts = joint.add(function(data) {
			var tmpArray = new Array();
			// loop objects
			for(i = 0; i < data.objects.length; i++) {				
				// shortcut
				var item = data.objects[i];
							
				// needed later to map email addresses
				var map_item = collection_contact.objects[i];				
				
				// look for email address
				item.email = item.email1 || item.email2 || item.email3;
				
				// setting a valid display name, if not given (bug #
				if (!item.display_name) {
					if (item.last_name || item.first_name) {
						item.display_name = (item.last_name || "") + ", " + (item.first_name || "");
					} else {
						item.display_name = item.email;
					}
				}
				
				// add
				tmpArray.push([
						        "contact_" + item.id, item.folder_id,
					            item.display_name, _("not sent"), "",
					            item.email, "contact", item.internal_userid,
					            (map_item.recurrence || 0)
					            ]);
				
				var recurrence = 0, mail = item.email;
				// really bad hack to provide ALL email addresses of a user
				// recurrence is the number of the email [email1, email2 or email3]
				if ( Self.allEmailAddresses ) {
					recurrence = map_item.recurrence ? map_item.recurrence : 0;					
					if (map_item.recurrence != 0) {
						mail = item["email" + (parseInt(map_item.recurrence)+1)];
					}
				}
				
				// add as changed
				var participant = {
                    "contactID": item.id, 
                    "display_name": item.display_name,
                    "mail": mail, "type": 5, "recurrence": recurrence 
                };
                if ( item.internal_userid && item.internal_userid > 0 ) {
                    participant.type = 1;
                    participant.id = item.internal_userid;
                }
                Self.changedParticipants.push(participant);
			}
			// add to grid (via storage)
			Self.internalStorage2.append(tmpArray);
			
			// fetch groups via cache
	        internalCache.getGroups(flattenIds(Self.selGroups), cb_fetch_groups);
		});
		
		var cb_fetch_groups = joint.add(function(items) {
			var tmpArray = new Array();
			// loop resources
			for (key in items) {
				var item = items[key];
				tmpArray.push([
				               "group_" + item.id, 0, item.display_name, 
				               _("not sent"), "", "", "group"
				               ]);
				// add as changed
				Self.changedParticipants.push({
					"id": item.id, "display_name": item.display_name, 
					"type": 2
				});
			}
			// add to grid
			Self.internalStorage2.append(tmpArray);
		});
		
		// fetch resources via cache
		internalCache.getResources(flattenIds(this.selResources), cb_resources);
		
		function flattenIds(objects) {
			var ids = new Array();
			for (i = 0; i < objects.length; i++) { ids.push(objects[i].id); }
			return ids;
		}
		
		function inGrid(key) {
			// either in small mode (i.e., someone else takes care of duplicates)
			// or actually not in grid)
			if (!Self.setFullParticipants) {
				return false;
			} else {
				return typeof(Self.internalStorage2.indices[key]) != "undefined";
			}
		}
		
		function parseItem(str) {
			// use regular expression
			var reg = /^([^\_]+)\_(\w+)\.(\w+)\.(\w+)$/;
			var matches = reg.exec(str);
			return { key: matches[0], type: matches[1], id: matches[2], folder: matches[3], recurrence: matches[4] };
		}
	},
	
	initalFillBigGrid: function(obj, callback) {
	    
	    if (obj.organizerId !== 0) {
	        this.organizerId = obj.organizerId;
	    } else if (obj.organizer) {
	        this.organizer = obj.organizer;
	    }
	    
		if (this.initalFilled)
			this.internalStorage2 = new Storage(0, [], "", 0, 0,  null, 
					function(x) {
						return x[0] + "." + x[1] + ".0";
					}
		);
		
		if (!this.internalStorage2.groups) {
			this.internalStorage2.groups = new Array();
		}
			
		this.part = obj.participants;
		if (obj.users) {
			this.users = obj.users;
		} else {
			this.users = [];
		}
		this.stati = ["waiting"/*i18n*/, "accepted"/*i18n*/,
		              "declined"/*i18n*/, "tentative"/*i18n*/];

		var Self = this;
		
		this.userToReq = new Array();
		this.groupToReq = new Array();
		this.resourceToReq = new Array();
		var externalUser = new Array();
		
		this.tmpArrayContact = new Array();
		this.tmpArrayGroup = new Array();
		this.tmpArrayResource = new Array();
		
		for (var k = 0; k < this.part.length; k++) {
			switch (this.part[k].type) {
				case 1:
					this.userToReq.push({id : this.part[k].id, type : 1});
					break;
				case 2:
					this.groupToReq.push({id : this.part[k].id, type : 2});
					break;
				case 3:
					this.resourceToReq.push({id : this.part[k].id, type : 3});
					break;
				case 5:
					externalUser.push({id : this.part[k].mail, type : 5,
					    display_name : this.part[k].display_name, 
					    mail:this.part[k].mail});
					break;
				default:
					break;
			}
		}
		
		var joint = new Join(function() {
		    // mark as filled
		    Self.initalFilled = true;
		    // call back
		    if (callback) callback();
		});
		var outerJoin = joint.add(emptyFunction);
        
		// users
		if (Self.userToReq.length > 0) {
		    // define callback
		    var user2reqCB = joint.add(function(cb) {
	            var count = 0;
	            for(i in cb){
	                var userstatus = "";
	                var message = "";
	                for (var j = 0; j < Self.users.length; j++) {
	                    if (Self.users[j].id == i) {
	                        if (Self.users[j].confirmation > -1 && Self.users[j].confirmation < 4)
	                            userstatus = _(Self.stati[Self.users[j].confirmation]);
	                        if( Self.users[j].confirmmessage)
	                            message = Self.users[j].confirmmessage;
	                        if (Self.users[j].id === Self.organizerId) {
	                            userstatus = _("Organizer");
	                        }
	                        break;
	                    }
	                }
	                // type 1 = internal user
	                var folder = cb[i].type === 1 ? 6 : 0;
	                Self.tmpArrayContact[count++] = ["contact_" + cb[i].user_id, 
	                                                 folder, cb[i].display_name, userstatus, 
	                                                 message, "", "contact", i, 0];
	                Self.internalStorage2.groups.push(false);
	            }
	            Self.tmpArrayContact.sort(function(a,b){
	                if (a[2] && b[2])
	                    return a[2] < b[2] ? -1 : 1;
	                else
	                    return -1;
	            });
	            Self.internalStorage2.append(Self.tmpArrayContact);
	        });
		    // go!
			internalCache.getObjects(Self.userToReq, user2reqCB);
		}
		
		// groups
		if(Self.groupToReq.length > 0) {
		    // define callback
	        var groupToReqCB = joint.add(function(cb) {
	            var count = 0;
	            var tmpArray = new Array();
	            var toGetTmp = new Array();
	            for (i in cb) {
	                for (k in cb[i].members) {
	                    toGetTmp[cb[i].members[k]] = cb[i].members[k];
	                }
	            }
	            var toGet = new Array();
	            for(var ho = 0; ho < toGetTmp.length; ho++){
	                if(toGetTmp[ho])
	                    toGet.push({id : toGetTmp[ho], type : 1});
	            }
	            
	            internalCache.getObjects(toGet, function(cbObj){
	                for(t in cb){
	                    Self.tmpArrayGroup.push(["group_" + cb[t].id, 6, cb[t].display_name, "", "", "", "group"]);
	                }

	                Self.internalStorage2.append(Self.tmpArrayGroup);
	            });
	        });
	        // go!
			internalCache.getObjects(Self.groupToReq, groupToReqCB);
		}

        // resources
		if (Self.resourceToReq.length > 0){
		    // define callback
	        var resourceToReqCB = joint.add(function(cb) {
	            var count = 0;
	            for(i in cb){
	                Self.tmpArrayResource[count++] = ["resource_" + i, 6, cb[i].display_name, "", "", "", "resource"];
	                Self.internalStorage2.groups.push(false);
	            }
	            Self.internalStorage2.append(Self.tmpArrayResource);
	        });
	        // go!
			internalCache.getObjects(Self.resourceToReq, resourceToReqCB);
		}
		
		if(externalUser.length > 0){
			var tmpArrayExternal = new Array();
			var count = 0;
			var confirmations = {};
			for (var i in obj.confirmations) {
			    var confirmation = obj.confirmations[i];
			    confirmations[confirmation.mail] = confirmation;
			}
			for(i in externalUser) {
			    var confirmation = confirmations[externalUser[i].mail] ||
                    { status: 0, message: "" };
                var stati = _(this.stati[confirmation.status || 0]);
                if (externalUser[i].mail === Self.organizer) {
                    stati = _("Organizer");
                }
				tmpArrayExternal[count++] = [
				    "contact_" + externalUser[i].id, 0,
				    externalUser[i].display_name,
				    stati,
				    confirmation.message || "",
				    externalUser[i].mail, "contact"];
				Self.internalStorage2.groups.push(false);
			}
			Self.internalStorage2.append(tmpArrayExternal);
		}
		
		// complete join
		outerJoin();
	},
	
	enableTheGrid: function(){
		this.participantsGridBig.enable(this.internalStorage2);		
	},
	
	disableTheGrid: function(){
		this.participantsGridBig.disable();
	},
	
	/**
	 * @private
	 */	
	closeParticipantsWindowCancel: function() {	
		this.opened = false;
		var Self = this;
        if ($("modal-dialog")) {
            var childs = $("modal-dialog").childNodes;
            var closeall=true;
            for(var i=0;i<childs.length;i++) {
                if(childs[i].tagName && childs[i].tagName == "DIV") {
                    if(childs[i].style.display && childs[i].style.display != "none") {
                        closeall=false;
                    }
                }
            }
            if (closeall) {
                ox.api.setModal(false);
//                hideNode("modal-dialog");
//                $("modal-dialog").style.display = "none";
            }
        }
		hideNode("floatingdivParticipants");
		$("floatingdivParticipants").style.display = "none";
		this.attach_lg_header.style.display = "none";
		this.attach_lg.style.display = "none";		
		$("selectedParticipants").value = "";
		Self.enabled = false;
		Self.disable_small_grid();
		if(Self.selectedParticipantsGrid)
			Self.selectedParticipantsGrid.disable();
		if(Self.selectedRessourcesGrid)
			Self.selectedRessourcesGrid.disable();			
	},
	
	/**
	 * @private
	 */		
	addToParticipantsList: function() {
		var Self = this; // bind
		var tmpSelected = this.participantsGridSmall.selection.getSelected();
		var currAdded = new Array();
		
		for(var i = 0; i < tmpSelected.length; i++){
			var drin = false;
			if(this.selectedParticipants){
				for(var j = 0; j < this.selectedParticipants.length; j++){
					if(tmpSelected[i] == this.selectedParticipants[j]){
						drin = true;
						break;
					}
				}
			}
			if(!drin && this.selectedParticipants){
				currAdded.push(tmpSelected[i]);
				this.selectedParticipants.push(tmpSelected[i]);
				this.changedParticipants.push(tmpSelected[i]);
			}
		}
	
		var selPartData = new Array();
		if(this.selectedParticipantsGrid == null)
		{
			this.selectedParticipantsGrid = new LiveGrid([ 
				{
					text: "",
					width: "20px",
					style: { textOverflow: "clip" },
					set: function (div, content){
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
							
						switch(content[1])
						{
							 case "contact":
							 		div.firstChild.src = (content[4] && content[4] > 0 ) ? getFullImgSrc("img/calendar/user.gif") : getFullImgSrc("img/calendar/user_extern.gif");
							 		break;
							 case "group": 		
							 		div.firstChild.src = getFullImgSrc("img/calendar/group.gif")
							 		break;							 					
							 case "resource": 	
							 		div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif")
							 		break;							 												 					
						}
					},
					clear: function(div) {
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
					}
				}, {
					text:"",				
					//index: 2,	
					//set: LiveGrid.defaultSet,
					set: function(div,data) {
						removeChildNodes(div);
						div.appendChild(document.createTextNode(data[2] || data[3] || _("unknown")));
					},
					clear: LiveGrid.makeClear("")
				}
			],new Selection());		
			
			// enable/disable delete button?
			this.selectedParticipantsGrid.events.register("Selected", function(count) {
				// at least one item selected?				
				Self.f_toggleButton(count > 0, "buttonDeleteFromParticipantsList", Self.f_deleteParticipant);
			});

			var select = $("selectedParticipants");
			this.selectedParticipantsGrid.emptylivegridtext ="";
			this.selectedParticipantsGrid.getHeader();		
			this.selectedParticipantsGrid.getTable(select);
			this.selectedParticipantsGrid.enable(this.selPartsStorage);	
		}
		
		// add
		var tmpSel = new Array();
		// loop through current selection
		for(var i = 0; i< currAdded.length; i++) {
			// get type
			var typ = currAdded[i].substring(0, currAdded[i].indexOf("_"));			
			tmpSel.push(this.selectedParticipantsGrid.storage.ids.length+i);
			switch(typ) {
				case "group":
					selPartData.push([
					                  currAdded[i], "group",
					                  this.internalStorage.data.data[currAdded[i]][2]
					                                                               ]);
					break;
				case "user":
					// nobreak
				case "contact":
					selPartData.push([
					                  currAdded[i], "contact",
					                  this.internalStorage.data.data[currAdded[i]][2],
					                  this.internalStorage.data.data[currAdded[i]][3],
					                  this.internalStorage.data.data[currAdded[i]][4]
					                                                               ]);
					break;
			}
		}
		this.selPartsStorage.append(selPartData);						
		this.selectIDs(this.selectedParticipantsGrid, tmpSel);
		
	},
		
	deleteParticipants: function() {
	    var Self = this;
	    var selected = this.participantsGridBig.selection.getSelected();
	    
	    var _cb =function() {
	        // nothing to do
	        if (selected.length === 0) {
	            return;
	        }
	        with (Self.participantsGridBig) deleteIDs(selected);
	        if ($("countParticipantsNewAppointment"))
	            $("countParticipantsNewAppointment").firstChild.data = Self.getParticipants().length;
	        if ($("partCounterTasksNew"))
	            $("partCounterTasksNew").firstChild.data = Self.getParticipants().length;
	    };
	    
	    if (Self.folder_id) {
	        ox.api.folder.get({
	            folder : Self.folder_id,
                success : function(data) {
                    if (data.created_by) {
                        var found = function() {
                            if (!Self.internalStorage2) return false;
                            for (var i = 0; i < selected.length; i++) {
                                var contact = Self.internalStorage2.data.data[selected[i]];
                                if (contact && contact[1] === 6 && contact[7] === String(Self.id)) {
                                    selected = selected.splice(i+1, selected.length);
                                    return true;
                                }
                            }
                        };
                        if (ox.api.folder.is("private|shared", data)) {
                            if (found()) {
                                newAlert(_("Info"), ox.api.folder.is("private", data)
                                        ? _("You cannot remove yourself from this appointment.")
                                                : _("You cannot remove the owner of the shared folder from this appointment."));
                            }
                            _cb();
                        } else if (ox.api.folder.is("public", data) 
                                && Self.getParticipants().length - selected.length < 1) {
                            newAlert(_("Info"), _("In a public folder there must be at least one participant."), function() {
                                if (!found()) {
                                    Self.initalFillBigGrid(
                                        {
                                            users: [ { id: Self.id, type: 1 } ],
                                            participants: [ { id: Self.id, type: 1 } ]
                                        }
                                    );
                                    Self.enableTheGrid();
                                }
                                _cb();
                            });
                        } else {
                            _cb();
                        }
                    }
                }
            });
	    } else {
	        _cb();
	    }
	},
	
	 /**
	 * @private
	 */		
	addToResourceList: function() {
		var Self = this; // bind
		var tmpSelected = this.participantsGridSmall.selection.getSelected();
		var currAdded = new Array();
		for(var i = 0; i < tmpSelected.length; i++){
			var drin = false;
			if(this.selectedResource){
				for(var j = 0; j < this.selectedResource.length; j++){
					if(tmpSelected[i] == this.selectedResource[j]){
						drin = true;
						break;
					}
				}
			}
			if(!drin && this.selectedResource){
				currAdded.push(tmpSelected[i]);
				this.selectedResource.push(tmpSelected[i]);
                this.changedResources.push(tmpSelected[i]);          
			}
		}


		var selRessData = new Array();
		if(this.selectedRessourcesGrid == null)
		{	
			this.selectedRessourcesGrid = new LiveGrid([ 
				{
                    text: "",
					index: 1,
					width: "20px",
					style: { textOverflow: "clip" },
					set: function (div, content){						
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
						switch(content)
						{
							 case "user":
							 		div.firstChild.src = getFullImgSrc("img/calendar/user.gif")
							 		break;
							 case "group": 		
									div.firstChild.src = getFullImgSrc("img/calendar/group.gif")
							 		break;							 					
							 case "resource": 	
							 		div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif")
							 		break;							 												 					
						}
					},
					clear: function(div) {
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
					}
				}, {			
					text: "",
                    //index: 2,	
					//set: LiveGrid.defaultSet,		
					set: function(div,data) {
						removeChildNodes(div);
						div.appendChild(document.createTextNode(data[2] || data[3] || _("unknown")));
					},			
					clear: LiveGrid.makeClear("")					
				}
			],new Selection());
			
			// enable/disable delete button?
			this.selectedRessourcesGrid.events.register("Selected", function(count) {
				// at least one item selected?				
				Self.f_toggleButton(count > 0, "buttonDeleteFromResourcesList", Self.f_deleteResource);
			});
			
			var select = $("selectedResource");			
			this.selectedRessourcesGrid.emptylivegridtext ="";
			this.selectedRessourcesGrid.getHeader();		
			this.selectedRessourcesGrid.getTable(select);
			this.selectedRessourcesGrid.enable(this.selRessStorage);	
		}
		
		// add
		var tmpSel = new Array();
		// loop through selected items
		for(var i = 0; i< currAdded.length; i++){
			var typ = currAdded[i].substring(0, currAdded[i].indexOf("_"));
			tmpSel.push(this.selectedRessourcesGrid.storage.ids.length+i);
			if (typ === "resource") { // NO LONGER typ === "user"
				selRessData.push([currAdded[i], typ,
						this.internalStorage.data.data[currAdded[i]][2],
						this.internalStorage.data.data[currAdded[i]][3]]);
			}
		}
		this.selRessStorage.append(selRessData);		
		this.selectIDs(this.selectedRessourcesGrid, tmpSel);	
		
	},
	delSelParticipants: function (){
		//if nothing selected
		if(this.selectedParticipantsGrid == null)
			return;
		var aItemsToDelete = this.selectedParticipantsGrid.selection.getSelected();
		var aNewPartArr = new Array();		
		var aNewChPartArr = new Array();			
		for(var j = 0; j < this.selectedParticipants.length; j++){
			var bFound = false;
			for( var indx in aItemsToDelete)
			{
				if(this.selectedParticipants[j] == aItemsToDelete[indx])
				{
					var bFound = true;					
					break;
				}				
			}
			if(!bFound){
				aNewPartArr.push(this.selectedParticipants[j]);			
				aNewChPartArr.push(this.selectedParticipants[j]);			
			}			
		}
//		this.selectedParticipantsGrid.selection.removeSelected();
		this.selectedParticipantsGrid.selection.storage.removeIDs(this.selectedParticipantsGrid.selection.getSelected());

		this.changedParticipants = aNewChPartArr;
		this.selectedParticipants = aNewPartArr;		
	},
	delSelRessources: function (){
		//if nothing selected
		if(this.selectedRessourcesGrid == null)
			return;		
		var aItemsToDelete = this.selectedRessourcesGrid.selection.getSelected();
		var aNewRessArr = new Array();
        var aNewChRessArr = [];
		for(var j = 0; j < this.selectedResource.length; j++){
			var bFound = false;
			for( var indx in aItemsToDelete)
			{
				if(this.selectedResource[j] == aItemsToDelete[indx])
				{
					var bFound = true;					
					break;
				}				
			}
			if(!bFound){
				aNewRessArr.push(this.selectedResource[j]);
                aNewChRessArr.push(this.selectedResource[j]);
			}			
		}
		
		this.selectedResource = aNewRessArr;
        this.changedResources = aNewChRessArr;
//		this.selectedRessourcesGrid.selection.removeSelected();
		this.selectedRessourcesGrid.selection.storage.removeIDs(this.selectedRessourcesGrid.selection.getSelected());
	},
	selectIDs: function(grid, sids) {
		grid.selection.reset();
		for (var ia = 0; ia < sids.length; ia++) {
			grid.selection.toggle(sids[ia]);
			if (ia == sids.length-1) {
				grid.focus = sids[ia];
				grid.showFocus();
			}
		}
	}	
}

ParticipantsSmall.prototype = Participants.prototype;

/*
 * 
 * Search in Addressbook (Recources, Groups)
 * Participant
 * 
 */

var contactAddressbookTreeParticipantLoaded = false;
var currentDivIdForAddressbook = "";
var defaultParticipantFolder = corewindow.defaultParticipantFolder || 6;
var clickedItemParticipant = corewindow.clickedItemParticipant;
register("OX_Configuration_Loaded_Complete", function() {
    ox.api.folder.exists({
        folder: "6", 
        success: function (GAL) {
            defaultParticipantFolder = GAL ? 6 : configGetKey("folder.contacts");
            if (clickedItemParticipant === undefined) {
                clickedItemParticipant = defaultParticipantFolder;
            }
        }
    });
});


function initParticipantContent() {
	setTimeout('participantsFolderPath()',100);
}


function hideAddressbookParticipantsTree(divId){
	$("treeDialogNewParticitpantList").style.display = "none";
}

/*
function toggleAddressbookParticipantsTree(divId){
	currentDivIdForAddressbook = divId;
	if($(divId).style.display == "none"){
		$(divId).style.display = "block";
	} else{
		$(divId).style.display = "none";
	}
}
*/

function toggleAddressbookParticipantsTree(){
	if($("treeDialogNewParticitpantList").style.display === "none"){
		centerPopupWindow($("treeDialogNewParticitpantList"));
		$("treeDialogNewParticitpantList").style.display = "block";
		$("treeDialogNewParticitpantList").style.top = "50px";
		//$("treeDialogNewParticitpantList").style.left = "70px";

	}
	else{
		$("treeDialogNewParticitpantList").style.display = "none";
	}
}

function participantsFolderPath() {
	var folderViewSettingsNewContact = new Object();
	var folderViewSettingsNewContactById = new Object();
	//Disable Email... 
	folderViewSettingsNewContactById["default"] = 4;
	folderViewSettingsNewContact["contacts"] = 8;
	folderViewSettingsNewContact["calendar"] = 4;
	folderViewSettingsNewContact["tasks"] = 4;
	folderViewSettingsNewContact["infostore"] = 4;
//	if(corewindow)
//		var oLocalState = corewindow.optFolderState.getState('folderAddressbookParticipant_tree_info');
//	else
//	var oLocalState = new Object();
	
	ox.api.ui.selectFolder({
    	type: "contacts",
    	id: "select-folder-popup-contacts",
    	callback: folderParticipantAction,
    	node: $('folderAddressbookParticipantTreeInfo'),
    	minPerms: 1 << 7, // read own objects
    	destroy: false
    });			

	if(!contactAddressbookTreeParticipantLoaded)
	{
		contactAddressbookTreeParticipantLoaded = true;	
	}
	
	ox.api.folder.getPathString({
	    folder: clickedItemParticipant,
	    success: cb_AddressbookGetpath
	});
}

function cb_AddressbookGetpath(sPath)
{
	var tmpSlash = sPath.substr(sPath.length-1);
	
	if(tmpSlash == "/")
		sPath = sPath.substr(0, sPath.length-1);
	
	var tmpIndex = sPath.lastIndexOf("/") + 1;
	var finalFolderName = sPath.substr(tmpIndex);
	
	$('newParticipant_folderText').value = finalFolderName;
}

function folderParticipantAction(data) {
	hideAddressbookParticipantTree(currentDivIdForAddressbook);
	clickedItemParticipant = data.id;
	ox.api.folder.getPathString({
	    folder: clickedItemParticipant,
	    success: cb_AddressbookGetpath
	});
	triggerEvent("searchParticipants");
}
/*
function cb_AddressbookGetpath(sPath)
{
	var tmpSlash = sPath.substr(sPath.length-1);
	
	if(tmpSlash == "/")
		sPath = sPath.substr(0, sPath.length-1);
	
	var tmpIndex = sPath.lastIndexOf("/") + 1;
	var finalFolderName = sPath.substr(tmpIndex);
	
	document.getElementsByName('newParticipant_folder')[0].value = finalFolderName;
}
*/
function hideAddressbookParticipantTree(divId){
	$("treeDialogNewParticitpantList").style.display = "none";	
	treeAddressbookVisible = false;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var ExecAfterUpload =  function (){};
var ExecErrorAfterUpload = null;

function attachmentDialog(sDialogNum, fkt_On_OK) {
    this.template_id = 'attachPopupTemplate';
    this.popup = $('attachPopupTemplate');
    this.popup.id = this.template_id + '_' + this.dialog_num;
    this.dialog_num = sDialogNum;
    this.att_server_rem = [];    
    this.callOnOK = fkt_On_OK;
    this.form_name = 'attFile_' + this.dialog_num;
    this.form =  document.attFile;
    this.form.name = this.form_name;
    
    //this.sel_files_area = $("selectedFilesArea");
    this.files_area_id = "selectedFilesArea" + '_' + this.dialog_num;
    //this.sel_files_area.id = this.files_area_id;
    this.live_grid_container = $("sel_files_area");
    this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];});
    this.file_input_count = 0; 
    this.attachmentsChanged = false;
    
    var Self = this;
    register("OX_Attachment_Dialog_Cancel", function(){Self.closePopup();});
    addOnClose (this.popup,function(){
          triggerEvent("OX_Attachment_Dialog_Cancel");
        });
    register("OX_Object_Add_Attachment", function(){Self.openPopup();});
    register("OX_Attachments_Add_File", function(){Self.addFile();});
    register("OX_Attachments_Remove_File", function(){Self.removeFile();});
    register("OX_Attachment_Dialog_OK", function(){Self.commitPopup();});
    
    this.all_input_fields = [];
    this.file_name_list = [];
    this.temp_list = [];
    
    this.last_input = null;
    
    this.curr_file_input_id;
    
    this.open = false;    
}

attachmentDialog.prototype = {
    attach_changed: function () {
        return (this.att_server_rem.length > 0 || this.file_input_count > 0 || this.attachmentsChanged);
    },
    do_post: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload) {
        if(this.att_server_rem.length > 0) {
            var aAttIds = [];

            for (var indx2=0;indx2<this.att_server_rem.length;indx2++) {
                aAttIds.push(this.att_server_rem[indx2].attid);
            }

            var sAction = AjaxRoot + "/attachment?action=detach" + "&session="+session + "&attached=" 
                        + this.att_server_rem[0].item_id + "&module=" 
                                + this.att_server_rem[0].module + "&folder=" + (this.att_server_rem[0].folder || this.att_server_rem[0].folder_id);                                                 
            this.att_server_rem = [];    
            var attJson = new JSONX();
            var Self = this;
            function cb_deleted(arg) {
                if (arg && arg.error) {
                    alert(arg.error);
                } else {
                    Self.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
                }                
            }
            attJson.put(sAction,aAttIds,null,cb_deleted);
        } else {
            this.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
        }
        return;
    },
    post_new: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload) {
        ExecAfterUpload = fn_exec_afterupload;
        ExecErrorAfterUpload = fn_error_exec_afterupload;
        if(sActionParam) {
            this.form.action = sActionParam;
        } else {
            this.form.action = AjaxRoot + "/attachment?action=attach&session=" + session;
        }
        if (sTargetParam) {
            this.form.target = sTargetParam;
        }
        var  sObj = JSONX.serialize(obj);
        if (this.file_input_count === 0) {
            var oNodeJson;
            if (this.form["json_0"] === undefined) {
                var oNodeJson;
                if (this.form["json_0"] === undefined) {
                    var id = this.createFileInput();
                    this.file_input_count++;
                    jQuery("#" + id).parent().remove();
                }
            }
            if (sObj) {
                this.form["json_0"].value = sObj;
            }
        }        
        else {
            for (var nCount=0;nCount<this.file_input_count;nCount++) {
                if(this.form['json_'+nCount]) {
                    this.form['json_'+nCount].value = sObj;
                }
            }
        }
        this.attachmentsChanged = true;
        this.form.submit();
    },
    createFileInput: function () {
        var sId = 'file_' + (this.file_input_count);
        var oNode = newnode('input',0,{
                                        type:"file",
                                        size:"40",
                                        name:sId,
                                        id:sId,
                                        className:"inputElementAttachment"
                                        });
        var oNodeJson = newnode('input',0,{
                                        type:"hidden",
                                        name:'json_'+(this.file_input_count),
                                        id:'json_'+(this.file_input_count)
                                        });
        if (IE) {
            // prevent entering file path manually
            jQuery(oNode).keypress(function(event){
                event.preventDefault();
            });
        }
        // auto-add file on change
        var self = this;
        jQuery(oNode).bind("change", function (e) {
            self.addFile();
        });
        this.last_input = oNode;
        var outerDiv1 = newnode("div");
        var outerDiv2 = newnode("div");        
        outerDiv1.appendChild(oNode);
        outerDiv2.appendChild(oNodeJson);
        this.form.appendChild(outerDiv1);
        this.form.appendChild(outerDiv2);
        this.all_input_fields.push(oNode);
        this.all_input_fields.push(oNodeJson);        
        return sId;
    },
    openPopup: function () {
        if(!this.open) {
            this.curr_file_input_id = this.createFileInput();
        }
        this.open = true;
        this.temp_list = [];
        if ($("modal-dialog")) {
            ox.api.setModal(true);
//            showNode("modal-dialog");
//            $("modal-dialog").style.display = "block";
        }
        centerPopupWindow(this.popup);
        this.popup.style.display = 'block';        
        //create
        if(this.live_grid === null || this.live_grid === undefined) {
            this.live_grid = new LiveGrid([ 
                {
                    text:" ",                
                    index: 1,    
                    style: {overflowX:"auto"},
                    set: function(div, text) {
                        text = text || "\u00a0";
                        if (div.firstChild) {
                            div.firstChild.data = text;
                        } else {
                            div.appendChild(document.createTextNode(text));
                        }
                    },                    
                    clear: LiveGrid.makeClear("")
                }
            ],new Selection());            
    
            this.live_grid.emptylivegridtext ="";
            this.live_grid.getHeader();        
            this.live_grid.getTable(this.live_grid_container);
            this.live_grid_container.style.overflowX = "auto";
            //this.live_grid_container.firstChild.style.width = "";            
            //this.live_grid_container.firstChild.style.overflowX = "auto";            
        } else {
            this.live_grid.enable(this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];}));
        }

    },
    closePopup: function () {
        //this.form.reset();
        //var oNode;
        //empty lg
        //removeChildren(this.sel_files_area);        
        /*
        while(oNode = this.all_input_fields.pop())
        {
            if(oNode)
            {
                this.form.removeChild(oNode);
            }
        }*/
        this.popup.style.display = 'none';
        if ($("modal-dialog")) {
            ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display = "none";
        }
        /*
        this.file_input_count = 0;    
        */
        this.open = false;
        var aToDel = [];
        for (var indxTd in this.temp_list) {
            aToDel.push(this.temp_list[indxTd].id);
        }
        this.removeFiles(aToDel);
        this.temp_list = [];        
        this.live_grid.disable();
        if (this.last_input !== null) {
            this.form.removeChild(this.last_input.parentNode);
        }
        this.last_input = null;
        this.file_input_count++;
    },    
    commitPopup: function () {
        this.popup.style.display = 'none';
        if ($("modal-dialog")) {
            ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display = "none";
        }
        this.file_name_list = this.file_name_list.concat(this.temp_list);
        this.callOnOK(this.file_name_list);    
        this.live_grid.disable();
    },
    showAttachedFiles: function () {
        return this.file_name_list;
    },
    addFile: function () {    
        //ie7 bugfix
        //var currFileInput = this.form.elements[this.curr_file_input_id];
        
        var currFileInput = document.getElementById(this.curr_file_input_id);
        
        if(currFileInput.value.length === 0) {
            return;
        }
        var fileName = separateFilenameFromPath(currFileInput.value);        
        var file = {id:fileName+'_'+this.file_input_count,filename:fileName};
        this.temp_list.push(file);
        
        //add file to lg
        var aFileObjects =  [[file.id,fileName]];
        this.file_storage.append(aFileObjects);
        this.live_grid.enable(this.file_storage);
        
        //update styles here (IE BUG FIX horizontal scroll bar)
        this.live_grid.rowTemplate.style.tableLayout = "auto";
        
        //this.sel_files_area.appendChild(newnode("option", 0,
        //    {value: file.id}, [document.createTextNode(fileName)]));

        currFileInput.style.display = "none";
        
        this.file_input_count++;
        this.curr_file_input_id = this.createFileInput();            
    },
    removeFile: function() {    
        //var files = this.sel_files_area.childNodes;
//        var len = files.length;
//        var selected = [];
//        for (var i = 0; i < len; i++)
//            if (files[i].selected) selected.push(files[i].value);
        var aSelItems = this.live_grid.selection.getSelected();
        if(aSelItems.length > 0) {
            this.removeFiles(aSelItems);
        }
//        removSelected;
    },
    getLocalPath:function (sId) {
            sFileName = sId.split('_')[0]; 
            for(var nField=0;nField<this.all_input_fields.length;nField++) {
                if((this.all_input_fields[nField].name == 'file_' + sId.split('_')[1])) {
                    return this.all_input_fields[nField];
                }
            }
    },
    removeFiles:function (aFiles) {
        function removeFileNameFromString(sStr,sFileName) {
            sFileName += '; ';
            var sReturnStr = sStr.replace(sFileName,'');
            return sReturnStr;
        }
        var Self = this;
        function removeFileNameFromList(sId) {
            for (var indx in Self.file_name_list) {
                if (Self.file_name_list[indx].id == sId) {
                    Self.file_name_list.splice(indx,1);
                    break;
                }
            }
            for (var indx in Self.temp_list) {
                if (Self.temp_list[indx].id == sId) {
                    Self.temp_list.splice(indx,1);
                    break;
                }
            }
        }
        //aFiles
        //get files from lg
        //var options = this.sel_files_area.childNodes;
        if( this.live_grid && this.live_grid.storage !== undefined) {
            this.live_grid.deleteIDs(aFiles);
        }
        for (var nIndex=0;nIndex<aFiles.length;nIndex++) {
            var filename = aFiles[nIndex];
            removeFileNameFromList(filename);
            for(var nField = this.all_input_fields.length - 1; nField >= 0; --nField) {
                if(((this.all_input_fields[nField].name == 'file_' + expandIDS(filename))
                            || (this.all_input_fields[nField].name == 'json_' + expandIDS(filename))) 
                                            && this.all_input_fields[nField].name != 'json_0')
                {
                    this.form.removeChild(this.all_input_fields[nField].parentNode);
                    this.all_input_fields.splice(nField, 1);
                }
            }
        }
    }
};

function expandIDS(sFileWithId) {
    var aTempArray = sFileWithId.split('_');
    return aTempArray[(aTempArray.length-1)];
}

/*
 * remove is possible in new/edit window only
 * */
function attachmentGrid(sContainerId,nId,nFolder,sModule,oDialog) {
    this.container = $(sContainerId);
    this.containerHeader = $(sContainerId + "Header");
    this.module  = sModule;
    this.nItemId = nId;
    this.folder = nFolder;    
    this.liveGrid = null;
    this.viewGrid();
    this.attachmentStorage;// = new Storage(0, []);
    this.bDetailAttachmentsLoaded = false;
    
    this.selection_dialog = (oDialog)?oDialog:false;
    
    this.timestamp = 0;
    
    this.addData = [];
    this.selectedRtfFlag = false;
    this.selectedId = null;
    this.selectedFilename = null;    
    
    this.numberOfAttachments = 0;
    
    Self = this;
    this.openAttachedFile = function () {
                if(Self.selectedRtfFlag) {
                    return;
                }
                var sURL = 
                AjaxRoot + "/attachment/" + encodeURIComponent(Self.selectedFilename) 
                    + "?action=document&session="
                    + session + "&attached=" + Self.nItemId  + "&module=" + Self.module + "&folder="
                    + activefolder + "&id=" + Self.selectedId;
                newWindow(sURL, getWindowOptions(null, null, "scrollbars=yes"));
    };
    this.saveAttachedFile = function () {

                if(Self.selectedRtfFlag) {
                    return;
                }
                var sContentType = 'application%2Foctet-stream';    
                var sURL = 
                AjaxRoot + "/attachment/" + encodeURIComponent(Self.selectedFilename) 
                    + "?action=document&session="
                    + session + "&attached=" + Self.nItemId  + "&module=" + Self.module + "&folder="
                    + activefolder + "&id=" + Self.selectedId + '&content_type=' +sContentType;
                if (IE6) {
                    newWindow(sURL, getWindowOptions());
                } else {
                    var frame = $ALL("dlIframe") ? getFrameElement('dlIframe') : parent.frames['dlIframe'];
                    frame.location.href = sURL;
                }
    };
    this.saveAttachInInfoStore = function () {
        if (Self.selectedRtfFlag) {
            return;
        }
        if (activemodule === "mail") {
            return;
        }
        var nNumModule = -1;
        switch (activemodule) {
            case "calendar":     nNumModule = 1;
                                break;
            case "tasks":     nNumModule = 4;
                                break;
            case "contacts":     nNumModule = 7;
                                break;
        }
        
        // use new api
        ox.api.infostore.compose({
            params: {
                attachmodule: nNumModule,
                filename: Self.selectedFilename,
                attid: Self.selectedId,
                attobjid: Self.nItemId,
                attobjfolder: Self.folder || Self.folder_id,
                folder: configGetKey("folder.infostore")
            },
            id: [ Self.selectedId, Self.nItemId, (Self.folder || Self.folder_id)]
        });
    };
    
    var Self = this;
    this.remAttachedFile  = function () {
        if(Self.selectedRtfFlag) return;        
        function cbyes() {
            Self.remove(Self.liveGrid.selection.getSelected(), function() {
                Self.updateGrid(Self.selection_dialog.file_name_list);
            });                                        
        }
        newConfirm(_("Delete Attachment"),_('Are you sure you want to delete the selected attachment?'),AlertPopup.YESNO,null,null,cbyes,null);
                                        
    };
                                        
    register("OX_Attachment_Open", this.openAttachedFile);        
    register("OX_Attachment_Save", this.saveAttachedFile);        
    register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);    
    
    if(this.selection_dialog) {
        register("OX_Object_Attachment_Delete", this.remAttachedFile);
    }
}

attachmentGrid.prototype = {
updateGrid: function (data) {    
    var aNewData = [];
    for(var indx in data) {
        var bFound = false;
        for(var indx2=0;indx2<this.addData.length;indx2++) {    
            if (data[indx].id == this.addData[indx2].id) {
                bFound = true;
                break;
            }
        }
        if(!bFound) {
            aNewData.push(data[indx]);
        }
    }    
    for(var indx2=0;indx2<this.addData.length;indx2++) {
        var bFound = false;
        for (var indx in data) {
            if (data[indx].id == this.addData[indx2].id) {
                bFound = true;
                break;                
            }
        }
        if(!bFound) {
            //IE7 bugfix
            //this.attachmentStorage.remove(this.attachmentStorage.ids.indexOf(this.addData[indx2].id));
            var indexToDelete = -1;
            var aIds = this.attachmentStorage.ids;
            for (var i = 0; i < aIds.length; i++) {
                if (aIds[i] == this.addData[indx2].id) {
                    this.liveGrid.deleteIDs([this.addData[indx2].id]);
                    indexToDelete = i; 
                }
            }
//            if(indexToDelete != -1)
//                this.attachmentStorage.remove(indexToDelete);
            this.addData.splice(indx2,1);
        }
    }
    this.addData = this.addData.concat(aNewData);
    var aNewObj =  [];
    for (var i in aNewData) {
        sFileName = aNewData[i].filename;
        aNewObj.push(new Array(aNewData[i].id,sFileName,'','',''));
        this.numberOfAttachments++;
        triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
    }
    if(aNewObj.length == 0) {
        triggerEvent("SubSelected", 0);
    } else {
        this.attachmentStorage.append(aNewObj);
    }
    this.enableGrid();

},
remove: function (ids, callback) {
    var local = [], remote = [];
    for (var i = 0; i < ids.length; i++) {
        var id = ids[i];
        if (typeof id === "string" && id.indexOf("_") >= 0) {
            local.push(id);
        } else {
            remote.push(id);
            this.selection_dialog.att_server_rem.push({
                attid: id, item_id: this.nItemId, module: this.module,
                folder: this.folder || this.folder_id
            });
        }    
    }
    if (local.length) {
        this.selection_dialog.removeFiles(local);
    }
    if (remote.length) {
        this.attachmentStorage.removeIDs(remote);
    }
    this.numberOfAttachments -= ids.length;        
    triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
    if (callback) {
        callback();
    }
},
enableGrid: function () {
    this.liveGrid.enable(this.attachmentStorage);        
    register("OX_Attachment_Open", this.openAttachedFile);        
    register("OX_Attachment_Save", this.saveAttachedFile);    
    register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);        
},
disableGrid: function () {
        this.liveGrid.disable();
        unregister("OX_Attachment_Open", this.openAttachedFile);        
        unregister("OX_Attachment_Save", this.saveAttachedFile);
        unregister("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);
},
getAttachments: function (nId,nFolder,fn_update_opt) {
    var  Self = this;    
    this.attachmentStorage = new Storage(0, []);
    if (this.nItemId === false) {
        return;
    }
    function cb_attachments(arg) {
        var aData = [];
        Self.numberOfAttachments = 0;
        //check rtf_flags here
        for (var indx in arg.data) {
            aData.push(arg.data[indx]);
            Self.numberOfAttachments++;        
        }
        
        triggerEvent("OX_Attachments_Changed_InGrid",Self.numberOfAttachments);
        Self.attachmentStorage.append(aData);
        Self.attachmentStorage.timestamp = arg.timestamp;
        Self.liveGrid.enable(Self.attachmentStorage);
        Self.bDetailAttachmentsLoaded = true; 
        if(fn_update_opt)
            fn_update_opt();            
    }
    if(nId != 0 && nId !== undefined &&  nFolder != 0 && nFolder !== undefined) {
        this.nItemId = nId;
        this.folder = nFolder;        
    }        
    this.doAjaxFetchAllAttachments(cb_attachments);
},
viewGrid: function () {
        var Self = this;
        var clear = LiveGrid.makeClear("...");
        function setAttachmentsTest1 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            div.appendChild(document.createTextNode(text[1]));        
        }
        function setAttachmentsTest2 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            div.appendChild(document.createTextNode(text[2]));        
        }    
        function setAttachmentsTest3 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            div.appendChild(document.createTextNode( text[3] && text[3].length != 0 ? bytesToString(text[3]) : "") );        
        }            
        function setAttachmentsTest4 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            if (text[4].length==0) {
                div.appendChild(document.createTextNode(""));
            } else {
                div.appendChild(document.createTextNode(formatDate(text[4], "date")));
            }
        }                                
        this.liveGrid = new LiveGrid([ 
            {
                text: "File name", /*i18n*/
                i18n: true,
                sortable: true,
                set: setAttachmentsTest1,
                clear: clear
            }, {
                text: "Mime type", /*i18n*/
                i18n: true,                
                sortable: true,
                width: "20%",
                set: setAttachmentsTest2,
                clear: clear
            }, {
                text: "Size", /*i18n*/
                i18n: true,                
                sortable: true,
                width: "15%",
                set: setAttachmentsTest3,
                clear: clear
            }, {
                text: "Last modified", /*i18n*/
                i18n: true,                    
                sortable: true,
                width: "15%",
                set: setAttachmentsTest4,
                clear: clear
            }
        ], new Selection());
        this.liveGrid.emptylivegridtext="No Attachments available";/*i18n*/
        this.containerHeader.appendChild(this.liveGrid.getHeader());
        this.liveGrid.getTable(this.container);
                
        this.liveGrid.events.register("Activated", function(ids){
            if (!ids || ids == 0) {
                return;
            }
            (menucheckRight("WRITE")) ? triggerEvent("OX_Object_Delete_Attachment") :
                triggerEvent("OX_New_Error", 4, _("You're not allowed to delete this attachment!"));
        });
    
        var aIds = Self.liveGrid.selection.getSelected();
        var Self = this;        
        function fn_triggerSubSel(ids){
            triggerEvent("SelectedAttachment",ids);
            ox.ToolBarController.processSelection("attachments", false,
                Self.liveGrid.selection.getSelected(), true);
            if (ids == 1) {                
                var aIDS = Self.liveGrid.getSelectedIDs();
                Self.selectedId = aIDS[0];
                Self.selectedFilename = Self.liveGrid.storage.data.get(Self.selectedId)[1];        
                Self.selectedRtfFlag = !(Self.liveGrid.storage.data.get(Self.selectedId)[5] == false);
                if(Self.liveGrid.storage.data.get(Self.selectedId)[5] === undefined) {
                    Self.selectedRtfFlag = false;
                }
                triggerEvent("SubSelected", ids,Self.selectedRtfFlag);                
            }          

        }
        this.liveGrid.events.register("Selected", fn_triggerSubSel);
},
doAjaxFetchAllAttachments:function (cb)
{
    json.get(AjaxRoot + "/attachment?action=all&session=" + session + "&folder=" +
            (this.folder || this.folder_id) + "&attached=" + this.nItemId + "&module="+this.module+"&" + 
            "columns=1%2C803%2C805%2C804%2C4%2C806&sort=803&order=asc", null,cb);        
}
}

function callback_attach(cb) {
    if(typeof savePending != "undefined" && savePending) {
        savePending = false;
    }
    if (!cb.error) {
        ExecAfterUpload();    
    }
    else {
        //triggerEvent("OX_New_Error", 4, cb.toString());
    }
}

function callback_document(cb) {
    if(typeof savePending != "undefined" && savePending) {
        savePending = false;
    }
    if (cb.error) {
        newServerError(cb);
    }
}
function callback_error(arg)
{
    if(typeof savePending != "undefined" && savePending) {
        savePending = false;
    }
    if(ExecErrorAfterUpload && typeof ExecErrorAfterUpload != "undefined") {
        ExecErrorAfterUpload(arg);
    } else {
        newServerError(arg);
    }
}
fileloaded();


/* 
 * +++++++++++++++++
 * Infostore Attachment Load 
 * +++++++++++++++++
 */

function infostoreDialog(number, callback) {
	var Self = this;
    this.popup = $('attachInfostorePopupTemplate');
    this.open = false;
    this.attachLiveGrid;
    this.gridSelectedElements = new Selection2();
    this.gridSelectedElements.oldToggle = this.gridSelectedElements.toggle;
    // overwrite toggle to prevent selection of non files
    this.gridSelectedElements.toggle = function(index) {
        var data = Self.attachLiveGrid.collection.objects;
        if (data && data[index] && !data[index].filename) {
            return false;
        } else {
            this.oldToggle(index);
        }
    }
    
    this.gridAddedElements = $("selectedFilesInfostore");
    this.miniGrid;
    this.file_storage;
    this.callback = callback || jQuery.noop;
    
    register("OX_AttachInfostore_Dialog_Cancel", function(){Self.closePopup();});
    addOnClose (this.popup,function(){
          triggerEvent("OX_AttachInfostore_Dialog_Cancel");
        });
    register("OX_Object_Add_Attachment_Infostore", function(){Self.openPopup();});
    register("OX_AttachInfostore_OK", function(){ Self.commitPopup(); });
}

infostoreDialog.prototype = {
	commitPopup: function () {
		var Self = this, attachments = [];
    	// get selected files from the top grid 
    	if (this.gridSelectedElements.count > 0){
    		jQuery(this.gridSelectedElements.getSelected()).each(function(index) {
    			var file = jQuery(this)[0];
    			// pre-fill object for callback
    			attachments.push({ id: file.id, filename: file.title, size: null, 
    			        content_type: file.file_mimetype || null, msgref: null, 
    			        selected: false, infostore: true });
    		});
    	}
        // trigger callback with infostore objects
        Self.callback(attachments);
    	Self.closePopup();
	},
    openPopup: function () {
    	this.loadFolderTree();
    	
    	// get the grid header and body div from the template
    	var gridHeader = $("attachInfostorGridHeader");
    	var gridContent = $("attachInfostorGridContent");
    	
    	// clear a old grid if available
    	if (this.attachLiveGrid) {
    		removeChildNodes(gridContent);
    		removeChildNodes(gridHeader);
    		this.attachLiveGrid = null;
    	}
    	
    	//fix some css
    	jQuery("#folder_tree_attachment #select-folder-popup-infostore").removeClass("oxStretch");
    	jQuery("#folder_tree_attachment #select-folder-popup-infostore").css("overflow", "visible");
    	
    	// create the grid
    	this.attachLiveGrid = new LiveGrid2([
            {
  				name : ["title"],
                i18n: "description", /*i18n context*/
  				text: "Title", /*i18n*/
  				sortable: true,
  				sort : "title",
  				set: LiveGrid.defaultSet,
  				clear: LiveGrid.makeClear("")
  			}, {
  				name : ["file_size", "file_mimetype", "filename"],
  				text: "Size", /*i18n*/
  				i18n: true,
  				sortable: true,
  				width: "20%",
  				sort : "file_size",
  				set: function (div, object) {
                    // mark non-files as greyed-out
                    jQuery(div).parent().css("color", object.filename ? "" : "silver");
                    // calculate size
  					var sDisplayString = object.file_size ? bytesToString(object.file_size) : "-";
  					if (div.firstChild) {
  						div.firstChild.data = sDisplayString;
  					} else {
  						div.appendChild(document.createTextNode(sDisplayString));
  					}
  				},
  				clear: LiveGrid.makeClear("")
  			}, {
  				name : ["created_by"],
  				text: "Created by", /*i18n*/
  				i18n: true,
  				sortable: true,
  				sort : "created_by",
  				width: "25%",			
  				set: function  (div, text) {
  					var nId = parseInt(text);											
  					function cb_fetchUserFromCache(){
  						return function (arg) {
  							if (div.firstChild) {
  								div.firstChild.data = arg[nId].display_name;
  							} else {
  								div.appendChild(document.createTextNode(arg[nId].display_name));
  							}
  						}
  					}
  					internalCache.getUsers([nId],cb_fetchUserFromCache());		
  				},
  				clear: LiveGrid.makeClear("")
  			}
  		], this.gridSelectedElements);
    	this.attachLiveGrid.module="infostore";

    	// add grid to header and body divs
    	gridHeader.appendChild(this.attachLiveGrid.getHeader());
    	this.attachLiveGrid.getTable(gridContent);
    	    	
    	// start the popup
	    if ($("modal-dialog")) {
	        ox.api.setModal(true);
	    }
		this.open = true;
		
		// center popup
    	centerPopupWindow(this.popup);
    	this.popup.style.display = 'block';
    	
    },
    closePopup: function () {
    	// disable the big grid
    	this.attachLiveGrid.disable();
        
    	// clode popup
    	this.open = false;
    	this.popup.style.display = 'none'; 
        if ($("modal-dialog")) {
            ox.api.setModal(false);
        }
    },
    loadFolderTree: function() {
    	var Self = this;
    	
    	// load the folder and draw the grid
    	function loadFolderContent(data) {
        	var criteria= { "folder_id" : data.id };
        	Self.attachLiveGrid.disablehover=true;
        	Self.attachLiveGrid.enable(criteria,false);
        }
    	
    	// the left side folder tree
    	ox.api.ui.selectFolder({
        	type: "infostore",
        	destroy: false,
        	id: "select-folder-popup-infostore",
        	root: "9",
        	open: ["9", "10", ox.api.config.get("folder.infostore")],
        	callback: loadFolderContent,
        	node: $('folder_tree_attachment'),
        	minPerms: 1 << 7 // read own objects
        });
    }
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var key= "appointments"; /*i18n*/
key= "tasks"; /*i18n*/
SeriesObject.NOSERIES= 0;
SeriesObject.DAILY= 1;
SeriesObject.WEEKLY= 2;
SeriesObject.MONTHLY= 3;
SeriesObject.YEARLY= 4;

SeriesObject.SUNDAY=1;
SeriesObject.MONDAY=2;
SeriesObject.THUESDAY=4;
SeriesObject.WEDNESDAY=8;
SeriesObject.THURSDAY=16;
SeriesObject.FRIDAY=32;
SeriesObject.SATURDAY=64;

SeriesObject.JANUARY=1;
SeriesObject.FEBRUARY=2;
SeriesObject.MARCH=3;
SeriesObject.APRIL=4;
SeriesObject.MAY=5;
SeriesObject.JUNE=6;
SeriesObject.JULY=7;
SeriesObject.AUGUST=8;
SeriesObject.SEPTEMBER=9;
SeriesObject.OCTOBER=10;
SeriesObject.NOVEMBER=11;
SeriesObject.DECEMBER=12;

function SeriesObject (object,createseries) {
	this.disabled=false;
	this.old_recurrence_type=null;
	this.old_days=null;
	this.old_day_in_month=null;
	this.old_month=null;
	this.old_interval=null;
	this.old_until=null;
	this.old_occurrences=null;
	/*
	 * NOSERIES= 0 ; DAILY= 1; WEEKLY= 2; MONTHLY= 3; YEARLY= 4;
	 */
	this.recurrence_type = 0;
	/*
	 * Null not set.
	 * Add up integer of in week days; or the day of series in monthview;
	 */
	this.days=null; //WEEK,MONTH,YEAR
	/*
	 * Null not set.
	 * which day of a month is part of the sequence. Counting starts with 1. counting all days set in days or if days not set all days.
	 */	
	this.day_in_month=null; //MONTH,YEAR
	 /*
	  * Null not set.
	  * Month of series
	  */
	this.month=null; //YEAR
	 /*
	  * Interval of series each number week,month,day 
	  */
    this.interval=null; //DAY,WEEK,MONTH || YEAR=1
    /*
     * Null not set 
     * End date of the series, if not set and occcurences not set series is unlimited
     */
     this.until=null; //DATE OF END
     /*
      * Null not set
      * Count of series not set
      */
     this.occurrences=null; //COUNT OF OCCURENCES
     
     if(object) {
     	this.setParameters(object,createseries);
     }
}
SeriesObject.prototype = {
	hasNoChanges : function () {
		if(this.old_recurrence_type != this.recurrence_type) { return false; }
		else if(this.old_days != this.days) { return false; }
		else if(this.old_day_in_month != this.day_in_month) { return false; }
		else if(this.old_month != this.month) { return false; }
		else if(this.old_interval != this.interval) { return false; }
		else if(this.old_until != this.until) { return false; }
		else if(this.old_occurrences != this.occurrences) { return false; }
		return true;		
	},
	setParameters : function(responseobject,createseries, forceNew) {
		if(!responseobject) {
			return;
		}
		if(responseobject.recurrence_position && !createseries) {
			this.disabled=true;
			//REMOVE IF IS VALID TO CREATE SERIES
			return;
		}
		if(responseobject.recurrence_type != undefined) {
			if (!forceNew) this.old_recurrence_type=parseInt(responseobject.recurrence_type);
			this.recurrence_type=parseInt(responseobject.recurrence_type);
		}
		if(responseobject.days != undefined) {
		    if (!forceNew) this.old_days=parseInt(responseobject.days);
			this.days=parseInt(responseobject.days);
		}
		if(responseobject.day_in_month != undefined) {
		    if (!forceNew) this.old_day_in_month=parseInt(responseobject.day_in_month);
			this.day_in_month=parseInt(responseobject.day_in_month);
		}
		if(responseobject.month != undefined) {
		    if (!forceNew) this.old_month=parseInt(responseobject.month);
			this.month=parseInt(responseobject.month);
		}
		if(responseobject.interval != undefined) {
		    if (!forceNew) this.old_interval=parseInt(responseobject.interval);
			this.interval=parseInt(responseobject.interval);
		}
		if(responseobject.until != undefined) {
		    if (!forceNew) this.old_until=responseobject.until;
			this.until=responseobject.until;
		}
		if(responseobject.occurrences != undefined) {
		    if (!forceNew) this.old_occurrences=parseInt(responseobject.occurrences);
			this.occurrences=parseInt(responseobject.occurrences);
		}
	},
	getSeriesString : function() {
		function getCountString (countint) {
			switch (countint) {
				case 1:
					return _("first");
				case 2:
					return _("second");
				case 3:
					return _("third");
				case 4:
					return _("fourth");
				case 5:
				case -1:
					return _("last"); 
			}
		}
		function getMonthString(monthint) {
			var mymonth=[_("January"),_("February"),_("March"),_("April"),_("May"),_("June"),_("July"),_("August"),_("September"),_("October"),_("November"),_("December")];
			return mymonth[monthint];
		}
		function getDayString(daysint) {
			var daystring="";
			switch (daysint) {
				case 62:
				    daystring=_("Work Day");
				    break;
				case 65:
                    daystring=_("Weekend Day");
                    break;
                case 127:
                    daystring=_("Day");
                    break;
				default:
					if (((daysint % SeriesObject.MONDAY) / SeriesObject.SUNDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Sunday") : daystring=daystring + ", "+_("Sunday"); 
					}					
					if (((daysint % SeriesObject.THUESDAY) / SeriesObject.MONDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Monday") : daystring=daystring + ", "+_("Monday"); 
					}					
					if (((daysint % SeriesObject.WEDNESDAY) / SeriesObject.THUESDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Tuesday") : daystring=daystring + ", "+_("Tuesday"); 
					}					
					if (((daysint % SeriesObject.THURSDAY) / SeriesObject.WEDNESDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Wednesday") : daystring=daystring + ", "+_("Wednesday"); 
					}					
					if (((daysint % SeriesObject.FRIDAY) / SeriesObject.THURSDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Thursday") : daystring=daystring + ", "+_("Thursday"); 
					}					
					if (((daysint % SeriesObject.SATURDAY) / SeriesObject.FRIDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Friday") : daystring=daystring + ", "+_("Friday"); 
					}					
					if ((daysint / SeriesObject.SATURDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Saturday") : daystring=daystring + ", "+_("Saturday"); 
					}
			}
			return daystring;
		}
		var returnstring;
		var interval=this.interval;
		var recurrence_type=this.recurrence_type;
		var days=this.days;
		var day_in_month=this.day_in_month;
		var month=this.month;
		var until=this.until;
		var occurences=this.occurences;
		if(this.hasNoChanges()) {
			interval=this.old_interval;
			recurrence_type=this.old_recurrence_type;
			days=this.old_days;
			day_in_month=this.old_day_in_month;
			month=this.old_month;
			until=this.old_until;
			occurrences=this.old_occurrences;
		}
		switch (this.recurrence_type) {
			case 0:
				returnstring = _("No recurrence");
				break;
			case 1:	
				returnstring = format(_("Each %s Day"),interval);
				break;
			case 2:
				returnstring = format(_("Each %s Week(s) on %s"),[interval, getDayString(days)]);
				break;
	  		case 3:
	  			if(this.days==null) {
	  				returnstring = format(_("On day %s every %s month(s)"),[day_in_month,interval]);
	  			} else {
	  				returnstring = format(_("On %s %s each %s months"),[getCountString(day_in_month),getDayString(days),interval]);
	  			}
	  			break;
	  		case 4:
	  			if(this.days==null) {
	  				returnstring = format(_("Each %s %s"),[day_in_month,getMonthString(month)]);
	  			} else {
	  				returnstring = format(_("On %s %s in %s"),[getCountString(day_in_month), getDayString(days),getMonthString(month)]);
	  			}
			    break;
		}
		return returnstring;
	}
}
function SeriesView () {
	this.seriesobject=new SeriesObject();
	this.series_content_month_day_in_month1;
	this.series_content_month_days1;
	this.series_content_year_month0;
	this.series_content_year_month1;
	this.series_content_year_days1;
	this.series_content_year_day_in_month1;
	this.sequenceStart;
	this.sequenceEnd;
	this.actualnode;
}
SeriesView.prototype = {
	toggleMiniSequenceStart : function() {
		var tmp = $("series_duration_calendar_start");
		if(tmp.style.display!="block") {
			centerPopupWindow(tmp);
			tmp.style.height = 210 + "px";
			tmp.style.width = 228 + "px";
			tmp.style.display = "block";
		} else {
			tmp.style.display = "none";
		}
	},
	toggleMiniSequenceEnd : function() {
		var tmp = $("series_duration_calendar_end");
		if(tmp.style.display!="block") {
			centerPopupWindow(tmp);
			tmp.style.height = 210 + "px";
			tmp.style.width = 228 + "px";
			tmp.style.display = "block";
			if ($("series_ending_date_2")) {
			    $("series_ending_date_2").checked = "checked";
		    }
		} else {
			tmp.style.display = "none";
		}
	},
	setParameters : function(responseobject, forceNew) {
		this.seriesobject.setParameters(responseobject, false, forceNew);
		triggerEvent("OX_Series_Data_Init", this.getSeriesString());
	},
	getParameters : function(responseobject, moduleCase) {
		if (!responseobject) {
			responseobject=new Object();
		}
		if (!this.seriesobject.hasNoChanges() || (moduleCase && moduleCase == "duplicate")) {
			if (this.seriesobject.recurrence_type != null) { 
				responseobject["recurrence_type"]= this.seriesobject.recurrence_type; 
			}
			if (this.seriesobject.days != null) { 
				responseobject["days"]=this.seriesobject.days; 
			} else if (this.seriesobject.old_days != null) {
				responseobject["days"]=null;
			}
			if (this.seriesobject.day_in_month != null) { 
				responseobject["day_in_month"]=this.seriesobject.day_in_month; 
			}
			if (this.seriesobject.month != null) { 
				responseobject["month"]=this.seriesobject.month; 
			}
			if (this.seriesobject.interval != null) { 
				responseobject["interval"]=this.seriesobject.interval; 
			}
			if (this.seriesobject.occurrences != null) { 
				responseobject["occurrences"]=this.seriesobject.occurrences; 
			} else {
			    delete responseobject.occurrences;
			}
			if (this.seriesobject.until != null) { 
				var tmpdate=new Date(this.seriesobject.until);
				tmpdate=new Date(Date.UTC(tmpdate.getUTCFullYear(),tmpdate.getUTCMonth(),tmpdate.getUTCDate(),0,0,0));
				responseobject["until"]=tmpdate.getTime(); 
			} else {
			    delete responseobject.until;
			}
			if (this.seriesobject.until == null && this.seriesobject.occurrences == null) {
	            if (this.seriesobject.old_until != null) {
	                responseobject["until"] = null;
	            } else if (this.seriesobject.old_occurrences != null) {
	                responseobject["occurrences"] = null;
	            }
            }
		}
		return responseobject;
	},
	initView : function() {
		var Self=this;
		function createCalendar() {
			Self.sequenceStart = new cMiniCalendar(	$("begin_header_sequence"),$("begin_sequence"), 
									series_setSequenceStartDate,false,'seq_begin',$("seq_begin_header_month"),$("seq_begin_header_year"));

			Self.sequenceEnd = new cMiniCalendar(	$("end_header_sequence"), $("end_sequence"), 
										series_setSequenceEndDate,false,'seq_end',$("seq_end_header_month"),$("seq_end_header_year"));
		}
		function createCombos() {
			Self.series_content_month_day_in_month1 = new ComboBox3(window, "series_content_month_day_in_month:1", "7em", 0, true, null, 4);
			Self.series_content_month_day_in_month1.addElement(_("first"),1);
			Self.series_content_month_day_in_month1.addElement(_("second"),2);
			Self.series_content_month_day_in_month1.addElement(_("third"),3);
			Self.series_content_month_day_in_month1.addElement(_("fourth"),4);
			Self.series_content_month_day_in_month1.addElement(_("last"),5);
			Self.series_content_month_day_in_month1.getDomNode();
			Self.series_content_month_days1 = new ComboBox3(window, "series_content_month_days:1", "9em", 0, true, null, 4);
			Self.series_content_month_days1.addElement(_("Monday"),2);
			Self.series_content_month_days1.addElement(_("Tuesday"),4);
			Self.series_content_month_days1.addElement(_("Wednesday"),8);
			Self.series_content_month_days1.addElement(_("Thursday"),16);
			Self.series_content_month_days1.addElement(_("Friday"),32);
			Self.series_content_month_days1.addElement(_("Saturday"),64);
			Self.series_content_month_days1.addElement(_("Sunday"),1);
			Self.series_content_month_days1.addElement(_("Day"),127);
			Self.series_content_month_days1.addElement(_("Weekend Day"),65);
			Self.series_content_month_days1.addElement(_("Work Day"),62);
			Self.series_content_month_days1.getDomNode();
			Self.series_content_year_month0 = new ComboBox3(window, "series_content_year_month:0", "9em", 0, true, null, 4);
			Self.series_content_year_month0.addElement(_("January"),0);
			Self.series_content_year_month0.addElement(_("February"),1);
			Self.series_content_year_month0.addElement(_("March"),2);
			Self.series_content_year_month0.addElement(_("April"),3);
			Self.series_content_year_month0.addElement(_("May"),4);
			Self.series_content_year_month0.addElement(_("June"),5);
			Self.series_content_year_month0.addElement(_("July"),6);
			Self.series_content_year_month0.addElement(_("August"),7);
			Self.series_content_year_month0.addElement(_("September"),8);
			Self.series_content_year_month0.addElement(_("October"),9);
			Self.series_content_year_month0.addElement(_("November"),10);
			Self.series_content_year_month0.addElement(_("December"),11);
			Self.series_content_year_month0.getDomNode();
			Self.series_content_year_month1 = new ComboBox3(window, "series_content_year_month:1", "9em", 0, true, null, 4);
			Self.series_content_year_month1.addElement(_("January"),0);
			Self.series_content_year_month1.addElement(_("February"),1);
			Self.series_content_year_month1.addElement(_("March"),2);
			Self.series_content_year_month1.addElement(_("April"),3);
			Self.series_content_year_month1.addElement(_("May"),4);
			Self.series_content_year_month1.addElement(_("June"),5);
			Self.series_content_year_month1.addElement(_("July"),6);
			Self.series_content_year_month1.addElement(_("August"),7);
			Self.series_content_year_month1.addElement(_("September"),8);
			Self.series_content_year_month1.addElement(_("October"),9);
			Self.series_content_year_month1.addElement(_("November"),10);
			Self.series_content_year_month1.addElement(_("December"),11);
			Self.series_content_year_month1.getDomNode();
			Self.series_content_year_days1 = new ComboBox3(window, "series_content_year_days:1", "9em", 0, true, null, 4);
			Self.series_content_year_days1.addElement(_("Monday"),2);
			Self.series_content_year_days1.addElement(_("Tuesday"),4);
			Self.series_content_year_days1.addElement(_("Wednesday"),8);
			Self.series_content_year_days1.addElement(_("Thursday"),16);
			Self.series_content_year_days1.addElement(_("Friday"),32);
			Self.series_content_year_days1.addElement(_("Saturday"),64);
			Self.series_content_year_days1.addElement(_("Sunday"),1);
			Self.series_content_year_days1.addElement(_("Day"),127);
			Self.series_content_year_days1.addElement(_("Weekend Day"),65);
			Self.series_content_year_days1.addElement(_("Work Day"),62);
			Self.series_content_year_days1.getDomNode();
			Self.series_content_year_day_in_month1 = new ComboBox3(window, "series_content_year_day_in_month:1", "7em", 0, true, null, 4);
			Self.series_content_year_day_in_month1.addElement(_("first"),1);
			Self.series_content_year_day_in_month1.addElement(_("second"),2);
			Self.series_content_year_day_in_month1.addElement(_("third"),3);
			Self.series_content_year_day_in_month1.addElement(_("fourth"),4);
			Self.series_content_year_day_in_month1.addElement(_("last"),5);
			Self.series_content_year_day_in_month1.getDomNode();
		}

		createCombos();
		createCalendar();
	},
	showView : function (module,startdate,enddate) {
		if(!this.seriesobject.disabled) {
		    ox.api.setModal(true);
//			showNode("modal-dialog");
//			$("modal-dialog").style.display="block";
			showNode("series_window");
			centerPopupWindow($("series_window"));
			$("series_window").style.display="block";
			this.openView(module,startdate,enddate);
		} else {
			triggerEvent("OX_New_Error",4,_("You can't create a new recurrence in a modified appointment."));
		}
		
		
		
	},
	openView : function (module,startdate,enddate) {
		this.seriesobject.tmp_recurrence_type=this.seriesobject.recurrence_type;
		this.recurrenceType(this.seriesobject.recurrence_type,startdate);
		switch(parseInt(this.seriesobject.recurrence_type)) {
			case 0:
				break;
			case 1:
				$("series_interval_day").value=parseInt(this.seriesobject.interval);
				break;
			case 2:
				$("series_interval_week").value=parseInt(this.seriesobject.interval);
				setCheckBoxinWeek(parseInt(this.seriesobject.days));
				break;
			case 3:
				if(this.seriesobject.days == null) {
					$("series_content_month_option:0").checked=true;
					if(this.seriesobject.day_in_month != null) $("series_content_month_day_in_month:0").value=parseInt(this.seriesobject.day_in_month);
					if(this.seriesobject.interval != null) $("series_interval_month:0").value=	parseInt(this.seriesobject.interval);
				} else  {
					$("series_content_month_option:1").checked=true;
					if(this.seriesobject.day_in_month != null) this.series_content_month_day_in_month1.setKey(parseInt(this.seriesobject.day_in_month));
				  	if(this.seriesobject.days != null) this.series_content_month_days1.setKey(parseInt(this.seriesobject.days));
				   	if(this.seriesobject.interval != null) $("series_interval_month:1").value=	parseInt(this.seriesobject.interval);
				}
			    break;
			case 4:	
				if(this.seriesobject.days == null) {	
					$("series_content_year_option:0").checked=true;			
					if(this.seriesobject.day_in_month != null) $("series_content_year_day_in_month:0").value=parseInt(this.seriesobject.day_in_month);
					if(this.seriesobject.month != null) this.series_content_year_month0.setKey(parseInt(this.seriesobject.month));
				} else {
					$("series_content_year_option:1").checked=true;			
					if(this.seriesobject.days != null) this.series_content_year_days1.setKey(parseInt(this.seriesobject.days));
					if(this.seriesobject.day_in_month != null) this.series_content_year_day_in_month1.setKey(parseInt(this.seriesobject.day_in_month));
					if(this.seriesobject.month != null) this.series_content_year_month1.setKey(parseInt(this.seriesobject.month));			
				} 
				break;
		}
		if(this.seriesobject.recurrence_type != 0) {
			setRadioBoxEndingDate(this.seriesobject.occurrences,this.seriesobject.until);
			var mytype=getRadioBoxValue($("series_window_form").ending_date);
			switch(mytype) {
				case 1:
					$("series_duration_endsafter").value=this.seriesobject.occurrences;
					break;
				case 2:
					var mydate=new Date(this.seriesobject.until);
					globalseries.sequenceEnd.setSelectedByDate(mydate.getUTCFullYear(),mydate.getUTCMonth(),mydate.getUTCDate());
					$("series_duration_enddate").value= formatDate(mydate, "date");
					break;
			}
		}
		if(enddate && !this.seriesobject.until) { 
			$("series_duration_enddate").value= formatDate(enddate, "date");
			globalseries.sequenceEnd.setSelectedByDate(enddate.getUTCFullYear(),enddate.getUTCMonth(),enddate.getUTCDate()); 
		} else {
			$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
		}
		if(startdate) {	
			$("series_duration_startdate").value= formatDate(startdate, "date"); 
			globalseries.sequenceStart.setSelectedByDate(startdate.getUTCFullYear(),startdate.getUTCMonth(),startdate.getUTCDate()); 
		} else {
			$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date"); 
		}
		if(module) {
			$("endsAfterType").firstChild.data=_(module);
		}
		
		if (this.seriesobject.days == null) {
			var prefill_date = parseDateString($("series_duration_startdate").value, "date");

			/* Pre Fill Weekly View */
			var prefill_dayOfWeek = prefill_date.getDay();				
			if(prefill_dayOfWeek) {	
				switch(parseInt(prefill_dayOfWeek)) {
				case 0:
					this.series_content_month_days1.setKey(parseInt(1));
					this.series_content_year_days1.setKey(parseInt(1));
					setCheckBoxinWeek(1);
					break;
				case 1:
					this.series_content_month_days1.setKey(parseInt(2));
					this.series_content_year_days1.setKey(parseInt(2));
					setCheckBoxinWeek(2);
					break;
				case 2:
					this.series_content_month_days1.setKey(parseInt(4));
					this.series_content_year_days1.setKey(parseInt(4));
					setCheckBoxinWeek(4);				
					break;
				case 3:
				this.series_content_month_days1.setKey(parseInt(8));
					this.series_content_year_day_in_month1.setKey(parseInt(8));
					setCheckBoxinWeek(8);
				    break;
				case 4:
					this.series_content_month_days1.setKey(parseInt(16));
					this.series_content_year_days1.setKey(parseInt(16));
					setCheckBoxinWeek(16);
				    break;
				case 5:
					this.series_content_month_days1.setKey(parseInt(32));
					this.series_content_year_days1.setKey(parseInt(32));
					setCheckBoxinWeek(32);
				    break;
				case 6:
					this.series_content_month_days1.setKey(parseInt(64));
					this.series_content_year_days1.setKey(parseInt(64));
					setCheckBoxinWeek(64);
				    break;
				}									
			}
			
			/* Pre Fill Monthly View */
			
			var prefill_dayOfMonth = prefill_date.getUTCDate();
			if ($("series_content_month_day_in_month:0") && prefill_dayOfMonth){
				$("series_content_month_day_in_month:0").value = parseInt(prefill_dayOfMonth);
			}
			
			if (prefill_dayOfMonth){
				if (prefill_dayOfMonth <= 7){						
					this.series_content_month_day_in_month1.setKey(parseInt(1));
					this.series_content_year_day_in_month1.setKey(parseInt(1));
				} else if (prefill_dayOfMonth <= 14 && prefill_dayOfMonth > 7){
					this.series_content_month_day_in_month1.setKey(parseInt(2));
					this.series_content_year_day_in_month1.setKey(parseInt(2));
				} else if (prefill_dayOfMonth <= 21 && prefill_dayOfMonth > 14){
					this.series_content_month_day_in_month1.setKey(parseInt(3));
					this.series_content_year_day_in_month1.setKey(parseInt(3));
				} else if (prefill_dayOfMonth <= 28 && prefill_dayOfMonth > 21){
					this.series_content_month_day_in_month1.setKey(parseInt(4));
					this.series_content_year_day_in_month1.setKey(parseInt(4));
				} else if (prefill_dayOfMonth > 28){
					this.series_content_month_day_in_month1.setKey(parseInt(5));
					this.series_content_year_day_in_month1.setKey(parseInt(5));
				}				
			}
		}
	},
	hideView : function () {
		hideNode("series_window");
		$("series_window").style.display="none";
		hideNode("series_window");
		ox.api.setModal(false);
//		$("modal-dialog").style.display="none";
	},
	cancelView : function() {
		this.seriesobject.recurrence_type=this.seriesobject.tmp_recurrence_type;
		this.hideView();
	},
	closeView : function () {
		switch (this.seriesobject.recurrence_type) {
			case 0:
				this.seriesobject.days=null;
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
    			this.seriesobject.interval=null;
                break;
			case 1:
				this.seriesobject.days=null;
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
    			this.seriesobject.interval=parseInt($("series_interval_day").value, 10);
			    break; 	
			case 2:
				this.seriesobject.days=getCheckBoxInt($("series_window_form").series_days);	
				if(this.seriesobject.days == 0) {
					//TODO SHOW ERROR
					return;
				}
				this.seriesobject.interval=parseInt($("series_interval_week").value, 10);
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
			    break;
			case 3:
			  	var myoption=getRadioBoxValue($("series_window_form").series_content_month_option);
			   	this.seriesobject.interval =parseInt($("series_interval_month:"+myoption).value, 10);
				this.seriesobject.month=null;
				if(myoption==0) {
					this.seriesobject.day_in_month=parseInt($("series_content_month_day_in_month:"+myoption).value, 10);
				  	this.seriesobject.days=null;
				} else if(myoption == 1) {
					this.seriesobject.day_in_month=parseInt(this.series_content_month_day_in_month1.getKey());
				  	this.seriesobject.days=parseInt(this.series_content_month_days1.getKey());
				} else {
					return;
				}
			    break;
			case 4:	
				var myoption=getRadioBoxValue($("series_window_form").series_content_year_option);
				if(myoption == 0) {
					this.seriesobject.day_in_month=parseInt($("series_content_year_day_in_month:"+myoption).value, 10);
					this.seriesobject.days=null;
					this.seriesobject.month=parseInt(this.series_content_year_month0.getKey());
				} else if(myoption == 1) {
					this.seriesobject.days=parseInt(this.series_content_year_days1.getKey());
					this.seriesobject.day_in_month=parseInt(this.series_content_year_day_in_month1.getKey());
					this.seriesobject.month=parseInt(this.series_content_year_month1.getKey());			
				} else {
					//TODO THROW ERROR
					return;
				}
				this.seriesobject.interval=1;
				break;
		}
		if(this.seriesobject.recurrence_type != 0) {
			var mytype=getRadioBoxValue($("series_window_form").ending_date);
			switch(mytype) {
				case 0:
					 this.seriesobject.until=null; 
				     this.seriesobject.occurrences=null; 
					break;
				case 1:
					this.seriesobject.until=null;
					this.seriesobject.occurrences=parseInt($("series_duration_endsafter").value, 10);
					break;
				case 2:
					this.seriesobject.until=this.sequenceEnd.selectedTime;
					this.seriesobject.occurrences=null;
					break;
			}
		}
		triggerEvent("OX_Series_Data_Changed", this.getSeriesString()); 
		this.hideView();
	},
	recurrenceType : function (type) {		
		type=parseInt(type);
		this.seriesobject.recurrence_type=type;
		if(type == 4) {
			var tmp = parseDateString($("series_duration_startdate").value, "date");
			
			if(this.seriesobject.day_in_month == null) $("series_content_year_day_in_month:0").value=tmp.getUTCDate();
			if(this.seriesobject.month == null) this.series_content_year_month0.setKey(tmp.getUTCMonth());
			if(this.seriesobject.month == null) this.series_content_year_month1.setKey(tmp.getUTCMonth());
			else this.series_content_year_month1.setKey(parseInt(this.seriesobject.month));
		}
		for(var i=0;i<5;i++) {
			if(this.seriesobject.recurrence_type != i) {
				$("series_content:"+i).style.display= "none";
			} else {
				$("series_content:"+i).style.display= "block";
				$("series_recurrence_type:"+i).checked=true;
			}
		}
		for (var i = 0; i < 3; i++) {
	       $("series_ending_date_" + i).parentNode.parentNode.style.visibility =
	           type ? "" : "hidden";
		}
	},
	getSeriesString : function() {
		return this.seriesobject.getSeriesString();
	},
	getStartDate : function() {
		return new Date(this.sequenceStart.selectedTime);	
		
	}
}
function series_parseValue(value,type) {
	var returnvalue;
	switch (type) {
		case "integer":
			returnvalue=parseInt(value, 10);
			if(isNaN(value) || returnvalue < 1 || (value == "") ) {
				returnvalue=1;
			}
			break;
	}
	return returnvalue;	
}
function getCheckBoxInt(checkboxarray) {
	var returnvalue = 0;
	for (var i=0; i<checkboxarray.length; i++) {
		if (checkboxarray[i].checked) {
			returnvalue = returnvalue + parseInt(checkboxarray[i].value);
		} 
	}
	return returnvalue;	
}
function getRadioBoxValue(radioboxarray) {
	var returnvalue = 0;
	for (var i=0; i<radioboxarray.length; i++) {
		if (radioboxarray[i].checked) {
			return parseInt(radioboxarray[i].value);
		} 
	}
	return returnvalue;	
}

function setRadioBoxEndingDate(occurence,until) {
	if(!occurence && !until) {
		$("series_ending_date_0").checked=true;
	} else if (occurence) {
		$("series_ending_date_1").checked=true;
	} else {
		$("series_ending_date_2").checked=true;
	}
}
function setCheckBoxinWeek(mydays) {
	var tmpdays=mydays;
	if(tmpdays>=SeriesObject.SATURDAY) {
		$("series_days_"+SeriesObject.SATURDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.SATURDAY;
	} else {
		$("series_days_"+SeriesObject.SATURDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.FRIDAY) {
		$("series_days_"+SeriesObject.FRIDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.FRIDAY;
	} else {
		$("series_days_"+SeriesObject.FRIDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.THURSDAY) {
		$("series_days_"+SeriesObject.THURSDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.THURSDAY;
	} else {
		$("series_days_"+SeriesObject.THURSDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.WEDNESDAY) {
		$("series_days_"+SeriesObject.WEDNESDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.WEDNESDAY;
	} else {
		$("series_days_"+SeriesObject.WEDNESDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.THUESDAY) {
		$("series_days_"+SeriesObject.THUESDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.THUESDAY;
	} else {
		$("series_days_"+SeriesObject.THUESDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.MONDAY) {
		$("series_days_"+SeriesObject.MONDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.MONDAY;
	} else {
		$("series_days_"+SeriesObject.MONDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.SUNDAY) {
		$("series_days_"+SeriesObject.SUNDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.SUNDAY;
	} else {
		$("series_days_"+SeriesObject.SUNDAY).checked=false;
	}
}
function series_setSequenceStartDate () {
	globalseries.sequenceStart.setSelected(this.id);
	$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date");
	$("series_duration_calendar_start").style.display = "none";
}
function series_setSequenceEndDate () {
	globalseries.sequenceEnd.setSelected(this.id);
	$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
	$("series_duration_calendar_end").style.display = "none";
}
function setSequenceStartDateOnBlur(){
	var tmp = parseDateString($("series_duration_startdate").value, "date");
	if(tmp) {
		globalseries.sequenceStart.setSelectedByDate(tmp.getUTCFullYear(), tmp.getUTCMonth(), tmp.getUTCDate());
	} else {
		$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date");	
	}
}
function setSequenceEndDateOnBlur(){
	var tmp = parseDateString($("series_duration_enddate").value, "date");
	if(tmp) {
		globalseries.sequenceEnd.setSelectedByDate(tmp.getUTCFullYear(), tmp.getUTCMonth(), tmp.getUTCDate());
	} else {
		$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
	}
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com> 
 * 
 */

function MoveCopy() {
    this.currentObjects = null;
    this.timestamp = "";
    this.objId = "";
    this.oldFolderid = "";
    this.newFolderid = "";
    this.ajaxUrl = "";
    this.objForUpdate = {};
    this.currentModule = "";
    this.finalObjects = [];
}

MoveCopy.prototype = {
    begin: function(currentModule, objects) {
        this.currentModule = currentModule || activemodule;
        if(objects) { 
            this.currentObjects=objects;
        } else { 
            this.currentObjects = menuselectedobjects; 
        }
        this.module = activemodule;
        // reset cache flag used in dnd.js to 
        // minimize ObjectCache calls 
        this.fetchedFromCache = null;
    },
    endMoving: function(selectedfolderid) {
        var Self=this;
        if(this.currentModule == "mail" || this.currentModule == "contacts" || this.currentModule == "tasks" || this.currentModule == "infostore") {
            var newfolder=selectedfolderid;
            var request=[];
            this.finalObjects = [];
            var mapping = OXCache.moduleMappings[this.currentModule];
            for(var i in this.currentObjects) {
                var tmpKey=this.currentObjects[i];
                var tmpTime = tmpKey.timestamp;
                var tmpObj_Hashed = {
                    module: this.currentModule,
                    id: tmpKey.id,
                    folder_id: tmpKey.folder || tmpKey.folder_id
                };
                tmpObj_Hashed = mapping.createKeyFromObject(tmpObj_Hashed);
                if(!tmpTime) {
                    var tmpObj=OXCache.cachedObjects.get(tmpObj_Hashed);
                    tmpTime=tmpObj.timestamp;
                }
                if(tmpKey.folder_id != newfolder) {
                    request.push({
                       action    : "update", 
                       module    : tmpKey.module, 
                       id        : tmpKey.id,
                       folder    : tmpKey.folder_id,
                       timestamp : tmpTime,
                       data      : { folder_id: newfolder }
                    });
                    this.finalObjects.push(tmpObj_Hashed);
                } 
            }
            if (request.length) {
                json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true", request, null, function (reply) {
                    var cacheObject = [];
                    for (var i = 0; i < reply.length; i++) {
                        if (reply[i].error) {
                            newServerError(reply[i]);
                        } else {
                            cacheObject.push(Self.finalObjects[i]);
                        }
                    }
                    mapping.deleteObjectsInternal(cacheObject);
                    mapping.createObjectsInternal(
                        [{ folder_id : selectedfolderid }]);
                    // updating the unread counters
                    if (Self.currentModule == "mail") {
                        var folderMap = {};
                        for (var i = 0; i < cacheObject.length; i++) {
                            folderMap[cacheObject[i].folder_id] = true;
                        }
                        folderMap[newfolder] = true;
                        var folders = [];
                        for (var i in folderMap) folders.push(i);
                        ox.api.folder.refresh({ folders: folders,
                                                success: setMailHeaderLabel });
                    }
                    //TODO REMOVE FROM NEW AND CREATE IN NEW MAIL AND CHECK DETAIL
                    //TODO don't forget Unified Mail
                });
            }
            return;
        }
        Self.newFolderid = selectedfolderid;
        Self.objForUpdate.folder_id = Self.newFolderid;
        Self.updateTimestamp();
        var request = [], items = [];
        for (var i in Self.currentObjects) {
            var item = Self.currentObjects[i];
            var myfolder =item.folder;
            if(!myfolder) {
                myfolder=item.folder_id;
            }
            //DAYVIEW 
            if(!myfolder) {
                myfolder=item.folderID;
            }
            if(myfolder != Self.objForUpdate.folder_id) {
                request.push({action: "update", module: Self.module,
                    id: item.id, folder: myfolder, timestamp: Self.timestamp,
                    data: {folder_id: selectedfolderid}});
                items.push(item);
            }
        }
        if(request.length > 0) {
           json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true",
               request, null, function(updatedFields) {
                   var updateview=false;
                   var iserror = false;
                   var conflictingrequests=[];
                   var sendconflicts=[];
                   function success() {
                       switch (Self.currentModule) {
                           case "calendar":
                               if (currentpath2[1] == "detail") {
                                   selectedAppointment.folder = selectedfolderid;
                                   detailAppointmentOnload();
                               } else if (currentpath2[1] != "list" && calendarGrid && calendarGrid.storage) {
                                   if(!configGetKey("gui.calendar.allfolders")) {
                                       calendarGrid.deleteIDs(Self.currentObjects);
                                   }
                               } else {
                                   setTimeout(function() { storageCache.update(); }, 0);
                               }
                               // notify via event
                               triggerEvent("OX_After_MoveCopy_Appointment");
                               break;
                       }
                   }
                   function newignore(myrequest) {
                       return function() {
                           myrequest.data.ignore_conflicts=true;
                           sendconflicts.push(myrequest);
                       };
                   }
                   function doConflict(myindex) {
                       return function() {
                           if (conflictingrequests.length>myindex) {
                               ConflictsPopup.open(
                                   conflictingrequests[myindex].object,
                                   conflictingrequests[myindex].conflicts,
                                   doConflict(myindex+1), null,
                                   newignore(conflictingrequests[myindex].request));
                           } else {
                               json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true", sendconflicts, null, function() {
                                   success();
                               });
                           }
                       };
                   }
                   for(var i=0;i<updatedFields.length;i++) {
                       if(updatedFields[i].error) {
                           newServerError(updatedFields[i]);
                           iserror = true;
                       } else {
                           updateview=true;
                           if(Self.currentModule == "calendar" && updatedFields[i].data && updatedFields[i].data.conflicts) {
                               conflictingrequests.push({
                                   object: items[i],
                                   request: request[i],
                                   conflicts : updatedFields[i].data.conflicts
                               }); 
                           }
                       }
                   }
                   if(updateview) {
                       if(conflictingrequests.length>0) {
                           doConflict(0)();
                       } else {
                           success();
                       }
                   }
               }
           );
        }
    },
    endCopy: function(selectedfolderid) {
        var Self = this;
        if (this.currentModule == "mail" || this.currentModule == "contacts" 
            || this.currentModule == "tasks" || this.currentModule == "infostore") {
            var newfolder=selectedfolderid;
            var request=[];
            for(var i in this.currentObjects) {
                var tmpKey=this.currentObjects[i];
                request.push({
                    action: "copy", 
                    module: tmpKey.module, 
                    id: tmpKey.id,
                    folder: tmpKey.folder_id, 
                    timestamp: tmpKey.timestamp,
                    data: { folder_id: selectedfolderid }
                });
            }
            if (request.length) {
               json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true",request, 
               null, function(reply) {
                   var requiresUpdate = false;
                   for (var i = 0; i < reply.length; i++) {
                       if (reply[i].error) {
                           newServerError(reply[i]);
                       } else {
                           requiresUpdate = true;
                       }
                   }
                   // do it really requires an update?
                   if (requiresUpdate) {
                       var mapping = OXCache.moduleMappings[Self.currentModule];
                       mapping.createObjectsInternal([{ folder_id : selectedfolderid }]);
                       if (Self.currentModule == "mail") {
                           ox.api.folder.refresh({ folders: [newfolder] });
                       }
                      //TODO REMOVE FROM NEW AND CREATE IN NEW MAIL AND CHECK DETAIL
                      //TODO don't forget Unified Mail
                   }
                });
            }
            return; // we are finished here
        }
        
        // copy in calendar
        Self.newFolderid = selectedfolderid;
        Self.objForUpdate.folder_id = Self.newFolderid;
        Self.updateTimestamp();
        var request = [];
        for (var i in Self.currentObjects) {
            var item = Self.currentObjects[i];
            request.push({action: "copy", module: Self.module, id: item.id,
                folder: item.folder, timestamp: Self.timestamp,
                data: {folder_id: selectedfolderid}});
        }
        json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true",
            request, null, function(reply) {
                for (var i = 0; i < reply.length; i++) {
                    if (reply[i].error) {
                        newServerError(reply[i]);
                    } else {
                        // nothing to do!?!?
                    }
                }
            });
    },
    updateTimestamp: function() {
        if(currentpath2[0] == "mail" && currentpath2[1]=="detail") {
            // mail/detail: from global var
            this.timestamp = mailFetchTimestamp;
        }
        else if (currentfullpath == "calendar/team/day") {
            // we have no better data (free-busy return zero)
            // workaround: now plus 1 hour
            this.timestamp = (new Date()).getTime() + 1000 * 60 * 60;
        }
        else {
            // default action: use cache timestamp
            this.timestamp = storageCache.current.timestamp;
        }
    }
};

var objMoveCopy = new MoveCopy();

/*
 * Register Events for MOVE
 * */
register('OX_Mail_Move', 
    function() {
        objMoveCopy.begin();
    }
);

register('OX_Calendar_Move', 
    function() {
        objMoveCopy.begin();
    }
);

register('OX_Contact_Move', 
    function() {
        objMoveCopy.begin();
    }
);


register('OX_InfoStore_Move', 
    function() {
        objMoveCopy.begin('infostore');
    }
);

register('OX_Task_Move', 
    function() {
        objMoveCopy.begin('tasks');
    }
);

register('OX_Object_Move', 
    function(selectedfolderid) {
        objMoveCopy.endMoving(selectedfolderid);
    }
);


/*
 * Register Events for COPY
 * */
register('OX_Mail_Copy', 
    function() {
        objMoveCopy.begin();
    }
);

register('OX_Contact_Copy', 
    function() {
        objMoveCopy.begin();
    }
);

register('OX_Object_Copy', 
    function(selectedfolderid) {
        objMoveCopy.endCopy(selectedfolderid);
    }
);

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
 /**
 * Inplace editing functionality.
 * @param {Object} content The DOM node which will be replaced by input tag
 * @param {Object} content The DOM node which contains editable text
 * @param {Function} which saves new text and call the update function. 
 */
function inplaceEdit(div, text, fn_save) {
	this.container_edit = div;
	this.old_content = [];
	this.input_elem = null;
	this.old_text = text;
	this.really_edit_check = true;
	this.style = { fontSize: "9pt", color: "black", height: "1.3em", margin: "0", padding: "0", 
			width:"100%", borderWidth: "0px", background: "transparent" };
	this.fn_save = fn_save;
	this.mode = "off";
}

inplaceEdit.prototype = {
	
	setSelection: function(bool) {
		this.container_edit.style.MozUserSelect = bool ? "text" : null;
	},

	on: function() {
		var Self = this;
		if (this.mode=="on") {
			return;
		}
		triggerEvent("OX_Clear_All_Edit_Lines");
		
		function save_checkTarget(event) {		
			if (Self.mode!="on" || event.target == Self.input_elem || 
				event.srcElement == Self.input_elem) {
				return true;
			}
			save();
		}
		
		function save(event) {
		    var close = true;
			if (Self.input_elem.value != Self.old_text || !Self.really_edit_check) {
				close = Self.fn_save(Self.input_elem.value);
			}
			if (close !== false) {
			    clear_input(event);
			}
		}
		
		function stop_click_bubbl(evtt) {
			cancelBubbling(evtt);
		}
		
		//catch esc. event on body
		function on_key_body(event) {
			if (event && event.keyCode == 27) {
				clear_input(event);
			}
			return event;
		}
			
		//replace contect of the container div with old content
		function clear_input(e) {
			Self.mode = "off";
			Self.setSelection(false);
			if (typeof(Self.input_elem) != "object") {
				return;
			}
			removeDOMEvent(Self.input_elem,"blur",save);
			removeDOMEvent(body,"click",save_checkTarget);
			removeDOMEvent(body,'keydown',on_key_body);
			removeDOMEvent(Self.input_elem,'keydown',on_key);
			removeDOMEvent(Self.input_elem,'keypress',on_key);
			removeDOMEvent(Self.container_edit,"click",stop_click_bubbl);
			removeDOMEvent(Self.container_edit,"mousedown",stop_click_bubbl);
			if (Self.input_elem.parentNode.parentNode == Self.container_edit) {
				Self.container_edit.removeChild(Self.input_elem.parentNode);
			}
			for (var nIndx in Self.old_content) {
				Self.container_edit.appendChild(Self.old_content[nIndx]);
			}
			unregister("OX_Clear_All_Edit_Lines",clear_input);	
			cancelfunc=true;		
			draggingdisable = false;
			triggerEvent("OX_Dummy", e);
		}
		
		//store old content
		for(var nIndx in this.container_edit.childNodes) {
			if(typeof(this.container_edit.childNodes[nIndx]) == "object") {
				this.old_content[nIndx] = this.container_edit.childNodes[nIndx].cloneNode(true);
			}
		}
		
		//replace old content
		removeChildNodes(this.container_edit);
		this.setSelection(true);
		
		//create input element		
		this.input_elem = newnode('input', this.style, { type:'text', value: this.old_text });
		var oDiVtest = newnode("div", 
			   { overflow: "hidden", position: "relative", width:"100%" }, null,
			   [ this.input_elem ]);
		this.container_edit.appendChild(oDiVtest);	
		addDOMEvent(oDiVtest, "selectstart", function() { menuselectstart=true; });
		addDOMEvent(oDiVtest, "mousedown", function() { menumousedown=true; });

		if (Self.input_elem && Self.mode != "on") {
			Self.input_elem.focus();
			Self.mode = "on";
			draggingdisable = true;
			cancelfunc=false;
			Self.input_elem.value = Self.old_text;
			Self.input_elem.select();
		}
	
		function on_key(event) {
			if (event.keyCode == 13) {
				if (Self.input_elem.value != Self.old_text || !Self.really_edit_check) {
					Self.input_elem.blur();
				}
			} else if (event.keyCode == 27) {
				clear_input(event);
			}
			cancelBubbling(event);
			return event;
		}

		addDOMEvent(this.input_elem,'keydown',on_key);
		addDOMEvent(this.input_elem,'keypress',on_key);
		addDOMEvent(this.input_elem,"blur",save);
		addDOMEvent(this.container_edit,"click", stop_click_bubbl);
		addDOMEvent(this.container_edit,"mousedown", stop_click_bubbl);
		addDOMEvent(body,"click",save_checkTarget);
		addDOMEvent(body,'keydown',on_key_body);
		register("OX_Clear_All_Edit_Lines",clear_input);
	}
};
fileloaded();
/*
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 */
 
/** 
 * @fileOverview Open-Xchange GUI Plugin API
 * @author Viktor Pracht <Viktor.Pracht@open-xchange.org>
 */

/**
 * @namespace
 */
ox.UI = {};
    
/**
 * @namespace
 */
ox.Configuration = {
    
    /**
     * Displays an error message to the user.
     * @param {I18nString} text The error message to display.
     */
    error: function(text) {
        setTimeout(function() {
            triggerEvent("OX_New_Error", 4, expectI18n(text));
        }, 0);
    },

    /**
     * Displays an information message to the user.
     * @param {I18nString} text The information message to display.
     */
    info: function(text) {
        triggerEvent("OX_New_Info", 4, expectI18n(text));
    },

    /**
     * Adds a new node to the configuration tree.
     * The parent node must already exist.
     * @class Leaf node in the configuration tree
     * @param {String} path The path in the configuration tree.
     * Must start with "configuration" and contain at least one more
     * element. Path elements are separated by a slash ("/"). There must be
     * no slash at the end. If the parent of the node does not already
     * exist, an Error exception is thrown.
     * @param {I18nString} name The name of the page.
     */
    LeafNode: function(path, name) {
        var Self = new ox.Configuration.Node(path, name, false, function() {
            if (Self.click) return Self.click();
        });
        return Self;
    },

    /**
     * This callback is called when the user clicks on the node.
     * @name ox.Configuration.LeafNode.prototype.click
     * @type Function
     */

    /**
     * Adds a new inner node to the configuration tree.
     * The parent node must already exist.
     * @class Inner node in the configuration tree.
     * @param {String} path The path in the configuration tree.
     * Must start with "configuration" and contain at least one more
     * element. Path elements are separated by a slash ("/"). There must be
     * no slash at the end. If the parent of the node does not already
     * exist, an Error exception is thrown.
     * @param {I18nString} name The name of the page.
     */
    InnerNode: function(path, name) {
        return new ox.Configuration.Node(path, name, true);
    },
    
    /**
     * @class
     * @private
     */
    Node: function(path, name, folder, click) {
        if (path in ox.Configuration.nodes)
            return ox.Configuration.nodes[path];
        var match = /^(.*)\/[^\/]+$/.exec(path);
        if (!match) throw Error("Invalid path: '" + path + "'");
        this.id = folder ? path
            : "configuration/modules/" + ox.Configuration.id++;
        var txtNode = (name instanceof I18nString) || typeof(name) == "string"
                    ? addTranslated(name) : name;
        var nodeObject = { parent: match[1], id: this.id,
                domNode: txtNode, innerNode: folder,
                onClick: click };
        if (name instanceof I18nString || typeof name === "string") {
            nodeObject.name = name;
        }
        var node = ox.widgets.configTree.add(nodeObject);
        ox.Configuration.nodes[path] = this;
    },

    /**
     * A map from paths to configuration tree nodes.
     * @private
     */
    nodes: {},
    
    /**
     * A counter for unique node IDs.
     * @private
     */
    id: 0,
    
    /**
     * An array with all created configuration pages.
     * @private
     */
    pages: []
    
};
    
/**
 * @namespace
 */
ox.JSON = {};

/**
 * Asynchronously requests a JSON object from the server.
 * This method retrieves a JSON object from the server by issuing an HTTP
 * GET request to the specified URI and calling the specified callback when
 * the retrieval is complete.
 * @param {String} uri The URI for the HTTP GET request.
 * @param {Function} ok A callback function which is called with the
 * received JSON object or raw data as parameter. If there was any error
 * then this function is not called.
 * @param {Function} error An optional callback function wihch is called when
 * the server returns an error. The function takes two parameters: result and
 * status. If the HTTP status code was 200, then result is the JSON object and
 * status is not set. If the HTTP status was not 200, then result is the status
 * string and status is the HTTP status code. The function should return true
 * when it handles the error. Otherwise, the default error handler specified by
 * JSON.errorHandler will be called after this function returns. If this
 * parameter is not specified, the default error handler is called directly.
 * @param {Boolean} raw Specifies whether the response data should be
 * passed to the callback as-is or first parsed as a JSON object. Defaults
 * to the latter.
 */
ox.JSON.get = function(uri, ok, error, raw) {
    (new JSONX()).get(uri, null, ok, error, raw);
};

/**
 * Asynchronously posts url-encoded data and retrieves a JSON object from
 * the server.
 * This method posts an object to the server by issuing an HTTP
 * POST request to the specified URI and calling the specified callback when
 * the reply arrives.
 * @param {String} uri The URI for the HTTP POST request.
 * @param {Object} data An object which is serialized using the
 * application/x-www-form-urlencoded encoding and sent as the body of the
 * request.
 * @param {Function} ok A callback function which is called with the received
 * JSON object or raw data as parameter. If there was any error then this
 * function is not called.
 * @param {Function} error An optional callback function wihch is called when
 * the server returns an error. The function takes two parameters: result and
 * status. If the HTTP status code was 200, then result is the JSON object and
 * status is not set. If the HTTP status was not 200, then result is the status
 * string and status is the HTTP status code. The function should return true
 * when it handles the error. Otherwise, the default error handler specified by
 * JSON.errorHandler will be called after this function returns. If this
 * parameter is not specified, the default error handler is called directly.
 * @param {Boolean} raw Specifies whether the response data should be
 * passed to the callback as-is or first parsed as a JSON object. Defaults
 * to the latter.
 */
ox.JSON.post = function(uri, data, ok, error, raw) {
    (new JSONX()).post(uri, data, null, ok, error, raw);
};

/**
 * Asynchronously sends a JSON object and retrieves a JSON object from
 * the server.
 * This method sends a JSON object to the server by issuing an HTTP
 * PUT request to the specified URI and calling the specified callback when
 * the reply arrives.
 * @param {String} uri The URI for the HTTP POST request.
 * @param {Object} data An object which is serialized using JSON syntax and
 * sent as the body of the request.
 * @param {Function} ok A callback function which is called with the received
 * JSON object or raw data as parameter. If there was any error then this
 * function is not called.
 * @param {Function} error An optional callback function wihch is called when
 * the server returns an error. The function takes two parameters: result and
 * status. If the HTTP status code was 200, then result is the JSON object and
 * status is not set. If the HTTP status was not 200, then result is the status
 * string and status is the HTTP status code. The function should return true
 * when it handles the error. Otherwise, the default error handler specified by
 * JSON.errorHandler will be called after this function returns. If this
 * parameter is not specified, the default error handler is called directly.
 * @param {Boolean} raw Specifies whether the response data should be
 * passed to the callback as-is or first parsed as a JSON object. Defaults
 * to the latter.
 */
ox.JSON.put = function(uri, data, ok, error, raw) {
    (new JSONX()).put(uri, data, null, ok, error, raw);
};

/**
 * @class Abstract base class of all widgets.
 */
ox.UI.Widget = function() {
    /**
     * Specifies whether the widget was already initialized.
     * @type Boolean
     * @default false
     */
    this.initialized = false;
};

/**
 * The default value of this widget, which is used when the model does
 * not contain the field for this widget.
 * @name ox.UI.Widget.prototype.default_value
 */

/**
 * The topmost DOM node of the widget. It is used by the default implementations
 * of {@link #show}, {@link #hide} and {@link #remove}.
 * @name ox.UI.Widget.prototype.node
 * @type DOM Node
 */

/**
 * A DOM node which is used by the default implementation of {@link #enable} and
 * {@link #disable} to control the disabled state of the widget. The DOM node
 * should have a property named "disabled". If the value equals false, disabling
 * will have no effect besides updating the {@link #enabled} field and applying
 * the disabled CSS.
 * @name ox.UI.Widget.prototype.formnode
 * @type DOM Node
 */

/**
 * The width of the widget as a CSS length specification.
 * If not specified, defaults to the {@link ox.UI.Container#childWidth} of
 * the parent.
 * @name ox.UI.Widget.prototype.width
 * @type String
 */

ox.UI.Widget.setDisabledClass = classNameSetter("font-color-disabled");

ox.UI.Widget.prototype = {

    /**
     * Adds the DOM nodes of this widget to its parent container.
     * @param {String} node_id The ID of the current page. This ID is required
     * for adding menu entries.
     */
    addContent: function(node_id) {
        this.initialized = true;
        if (!this.isEnabled) this.applyEnabled();
        if (!this.isVisible) this.applyVisible();
    },
    
    /**
     * Returns the current value of the widget. The returned type depends on
     * the actual widget class.
     */
    get: function() {},
    
    /**
     * Sets the value which is displayed by the widget.
     * @param value The new value of the widget. The type depends on the actual
     * widget class.
     */
    set: function(value) {},
    
    /**
     * Resizes the widget.
     */
    resize: function() {},
    
    /**
     * Removes the widget's DOM nodes from the form.
     */
    remove: function() {
        if (this.node) this.node.parentNode.removeChild(this.node);
    },
    
    /**
     * Displays the widget if it was previously hidden.
     */
    show: function() { this.setVisible(true); },
    
    /**
     * Hides the widget.
     */
    hide: function() { this.setVisible(false); },
    
    /**
     * Sets the visibility of the widget.
     * @param {Boolean} visible The new visibility status.
     */
    setVisible: function(visible) {
        this.visible = visible;
        visible = visible && (!this.parent || this.parent.isVisible);
        if (this.isVisible != visible) {
            this.isVisible = visible;
            if (this.initialized) this.applyVisible();
        }
    },
    
    /**
     * Applies the visibility status to the actual widget.
     * Only called when the widget is initialized.
     * @protected
     */
    applyVisible: function() {
        if (this.node) this.node.style.display = this.isVisible ? "" : "none";
    },
    
    /**
     * Specifies whether the widget is visible.
     * @type Boolean
     * @default true
     */
    visible: true,
    
    /**
     * The actual visibility of the widget, which can be false even if visible
     * is set to true, because the widget's container is invisible.
     */
    isVisible: true,

    /**
     * Enables the widget for user interaction.
     */
    enable: function() { this.setEnabled(true); },
    
    /**
     * Disables the widget for user interaction. 
     */
    disable: function() { this.setEnabled(false); },
    
    /**
     * Enables or disables the widget.
     * @param {Boolean} enabled The new enabled status.
     */
    setEnabled: function(enabled) {
        this.enabled = enabled;
        enabled = enabled && (!this.parent || this.parent.isEnabled);
        if (this.isEnabled != enabled) {
            this.isEnabled = enabled;
            if (this.initialized) this.applyEnabled();
        }
    },
    
    /**
     * Applies the value of this.isEnabled to the actual widget.
     * When this method is called, the widget is already initialized.
     * @protected
     */
    applyEnabled: function() {
        if (this.formnode) this.formnode.disabled = !this.isEnabled;
        if (this.node)
            ox.UI.Widget.setDisabledClass(this.node, !this.isEnabled);
    },
    
    /**
     * Specifies whether the widget is enabled.
     * @type Boolean
     * @default true
     */
    enabled: true,
    
    /**
     * The actual enabled state of the widget, which can be false even if
     * enabled is set to true, because the widget's container is disabled.
     */
    isEnabled: true,
    
    /**
     * Sets the widget's container.
     * @param {ox.UI.Container} parent The new parent container.
     */
    setParent: function(parent) {
        this.parent = parent;
        this.setEnabled(this.enabled);
        this.setVisible(this.visible);
    },
    
    /**
     * The widget which contains this widget. null if this widget is not a child
     * of another widget.
     * @default null
     */
    parent: null

};

/**
 * @class Static explanation text.
 * Do not specify a field name when adding instances of this class to
 * containers.
 * @augments ox.UI.Widget
 * @param {I18nString} text The displayed text.
 */
ox.UI.Text = function(text) {
    ox.UI.Widget.apply(this);
    this.text = text;
};

ox.UI.Text.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Text.prototype */
    {

        addContent: function(node_id) {
            this.node = this.parent.addRow(addTranslated(this.text), false);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        }

    });

/**
 * @class A text input field.
 * @param {I18nString} label The label for the input field.
 */
ox.UI.Input = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
};

ox.UI.Input.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Input.prototype */
    {

        /**
         * The default value of the input field, which is used when the model
         * does not contain the field for this input field.
         * @default an empty string
         */
        default_value: "",
    
        addContent: function (node_id) {
            this.formnode =
                newnode("input",
                        { width: this.width || this.parent.childWidth },
                        { type: this.inputType });
            this.node = this.parent.addCells(this.label, this.formnode);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
            // bind event
            var self = this;
            jQuery(this.formnode).bind("keydown paste cut", function (e) {
                var node = this;
                setTimeout(function () {
                    self.onChange.call(node, e);
                }, 10);
            });
        },
    
        /**
         * Change event
         */
        onChange: function (e) {
        },
        
        /**
         * Returns the current value of the input field.
         * @type String
         */
        get: function() { return this.formnode.value; },
    
        /**
         * Sets the value of the input field.
         * @param {String} value
         */
        set: function(value) { this.formnode.value = value; },
        
        /**
         * The type attribute of the HTML input element.
         * @type String
         * @default "text"
         */
        inputType: "text"
        
    });

/**
 * @class A password input field.
 * @augments ox.UI.Input
 * @param {I18nString} label The label for the input field.
 */
ox.UI.Password = function(label) {
    ox.UI.Input.apply(this, arguments);
};

ox.UI.Password.prototype = extend(ox.UI.Input,
    /** @lends ox.UI.Password.prototype */
    { inputType: "password" });

/**
 * @class a multi-line text input area.
 * @param {I18nString} label The label for the input field.
 */
ox.UI.TextArea = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
};

ox.UI.TextArea.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.TextArea.prototype */
    {
    
        default_value: "",
    
        addContent: function(node_id) {
            this.formnode = newnode("textarea",
                { width: this.width || this.parent.childWidth }, 0);
            if (this.height) this.formnode.style.height = this.height;
            this.node = this.parent.addCells(this.label, this.formnode);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * Returns the current value of the text area.
         * @type String
         */
        get: function() { return this.formnode.value; },
        
        /**
         * Sets the value of the text area.
         * @param {String} value
         */
        set: function(value) { this.formnode.value = value; }
        
    });

/**
 * @class A check box for a single boolean field.
 * @augments ox.UI.Widget
 * @param {I18nString} label The label for the checkbox.
 */
ox.UI.CheckBox = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
};

/**
 * @private
 */
ox.UI.CheckBox.id = 0;

/**
 * This callback is called when the user changes the state of the CheckBox.
 * @name ox.UI.CheckBox.prototype.changed
 * @type Function
 */

ox.UI.CheckBox.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.CheckBox.prototype */
    {
    
        addContent: function(node_id) {
            var Self = this;
            var id = "ox.UI.CheckBox." + ox.UI.CheckBox.id++;
            this.formnode = newnode("input", 0, { type: "checkbox", id: id });
            this.node = this.parent.addRow(newnode("label", 0, { htmlFor: id }, [
                this.formnode,
                document.createTextNode(" "),
                addTranslated(this.label)
            ]), true);
            addDOMEvent(this.formnode, "click", function() {
                if (Self.changed) Self.changed();
            });
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * Returns the current value of the CheckBox.
         * @type Boolean
         */
        get: function() { return this.formnode.checked; },
        
        /**
         * Sets the value of the CheckBox
         * @param {Boolean} value
         */
        set: function(value) { this.formnode.checked = value; }

    });

/**
 * @class Abstract base class of selection widgets.
 * This class handles the association between displayed objects and value
 * objects.
 * @augments ox.UI.Widget
 */
ox.UI.Selection = function() {
    ox.UI.Widget.apply(this);
    this.values = [];
    this.display_values = [];
};

/**
 * This callback is called when the user selects a different value.
 * @name ox.UI.Selection.prototype.changed
 * @type Function
 */

ox.UI.Selection.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Selection.prototype */
    {
    
        /**
         * Sets the list of possible values and the corresponding displayed
         * values.
         * The parameters are used directly, without copying. Therefore,
         * the arrays should not be modified after being passed to this method.
         * An exception is modifying the arrays and immediately calling this
         * method again to update the displayed widget.
         * @param {Array} values An array of possible values.
         * @param {Array} display_values An array of displayed values.
         * Each element represents the value in the values array with the same
         * index. The type of elements depends on the actual selection class.
         */
        setEntries: function(values, display_values) {
            this.values = values;
            this.display_values = display_values;
        }
    
    });

/**
 * @class A combination of a text input field and a drop-down list.
 * @augments ox.UI.Selection
 * @param {I18nString} label The label of the ComboBox.
 * @param {Boolean} editable Specifies whether the text input field can contain
 * values which are not in the drop-down list. Defaults to false.
 * Not implemented yet.
 *
 */
ox.UI.ComboBox = function(label, editable) {
    ox.UI.Selection.apply(this);
    this.label = label;
    this.editable = editable;
};

ox.UI.ComboBox.prototype = extend(ox.UI.Selection,
    /** @lends ox.UI.ComboBox.prototype */
    {
        
        /**
         * @private
         */
        recreate: function() {
            var nokey = {};
            var key = this.combobox ? this.combobox.getKey() : nokey;
            removeChildNodes(this.div);
            var Self = this;
            var numValues = this.values && this.values.length ? this.values.length : 0;
            this.combobox = new ComboBox3.impl(window, this.div,
                this.width || this.parent.childWidth, 0, true,
                Math.min(8, numValues),
                function(value) {
                    if (Self.changed) Self.changed(value);
                });
            if (numValues) {
                for (var i = 0; i < numValues; i++) {
                    this.combobox.addElement(this.display_values[i],
                                             this.values[i]);
                }
            } else {
                this.combobox.addElement(noI18n("\xa0"), null);
            }
            this.combobox.getDomNode();
            if (key != nokey) this.combobox.setKey(key);
            if (!this.enabled) this.combobox.disable();
        },

        addContent: function(node_id) {
            this.div = newnode("div");
            this.node = this.parent.addCells(this.label, this.div);
            this.recreate();
            ox.UI.Selection.prototype.addContent.apply(this, arguments);
        },
        
        resize: function() { this.recreate(); },
        
        /**
         * Sets the list of possible values and the corresponding displayed
         * textual descriptions.
         * The parameters are used directly, without copying. Therefore,
         * the arrays should not be modified after being passed to this method.
         * An exception is modifying the arrays and immediately calling this
         * method again to update the displayed widget.
         * @param {Array} values An array of possible values.
         * @param {I18nString[]} display_values An array of displayed texts.
         * Each element represents the value in the values array with the same
         * index.
         */
        setEntries: function(values, display_values) {
            ox.UI.Selection.prototype.setEntries.apply(this, arguments);
            if (this.initialized) this.recreate();
        },
        
        /**
         * Returns the current value of the ComboBox.
         */
        get: function() {
            return this.combobox.getKey();
        },
        
        /**
         * Sets the value of the ComboBox.
         */
        set: function(value) {
            this.combobox.setKey(value);
        },
        
        applyEnabled: function() {
            if (this.isEnabled)
                this.combobox.enable();
            else
                this.combobox.disable();
            ox.UI.Widget.setDisabledClass(this.node, !this.isEnabled);
        }

    });

/**
 * @class A group of radio buttons. Only one option can be selected at a time.
 * @augments ox.UI.Selection
 */
ox.UI.RadioButtons = function() {
    ox.UI.Selection.apply(this);
    this.name = ++ox.UI.RadioButtons.lastName;
};

ox.UI.RadioButtons.lastName = 0;

ox.UI.RadioButtons.prototype = extend(ox.UI.Selection,
    /** @lends ox.UI.RadioButtons.prototype */
    {
    
        /**
         * @private
         */
        recreate: function() {
            removeChildNodes(this.div);
            this.nodes = new Array(this.values.length);
            var Self = this;
            for (var i = 0; i < this.values.length; i++) {
                this.nodes[i] = newradio(0,
                    { type: "radio", name: this.name, value: this.values[i],
                      className: "noborder nobackground" });
                addDOMEvent(this.nodes[i], "click", function() {
                    if (Self.changed) Self.changed();
                });
                this.div.appendChild(newnode("label", 0,
                    { htmlFor: "ox.UI.RadioButtons." + this.name + "." + i },
                    [
                        this.nodes[i],
                        document.createTextNode(" "),
                        addTranslated(this.display_values[i])
                    ]));
                this.div.appendChild(newnode("br"));
            }
        },
        
        addContent: function(node_id) {
            this.div = newnode("div");
            this.node = this.parent.addRow(this.div, true);
            this.recreate();
            ox.UI.Selection.prototype.addContent.apply(this, arguments);
        },
    
        /**
         * Sets the list of possible values and the corresponding displayed
         * labels.
         * The parameters are used directly, without copying. Therefore,
         * the arrays should not be modified after being passed to this method.
         * An exception is modifying the arrays and immediately calling this
         * method again to update the displayed widget.
         * @param {Array} values An array of possible values.
         * @param {String[]} display_values An array of displayed labels.
         * Each element represents the value in the values array with the same
         * index.
         */
        setEntries: function() {
            ox.UI.Selection.prototype.setEntries.apply(this, arguments);
            if (this.initialized) this.recreate();
        },
        
        /**
         * Returns the current value of the RadioButtons.
         */
        get: function() {
            for (var i = 0; i < this.values.length; i++)
                if (this.nodes[i].checked) return this.values[i];
        },
        
        /**
         * Sets the value of the RadioButtons.
         */
        set: function(value) {
            for (var i = 0; i < this.values.length; i++)
                this.nodes[i].checked = this.values[i] == value;
        },
        
        applyEnabled: function() {
            for (var i = 0; i < this.nodes.length; i++)
                this.nodes[i].disabled = !this.isEnabled;
            ox.UI.Widget.setDisabledClass(this.node, !this.isEnabled);
        }
        
    });

/**
 * @class A button.
 * @augments ox.UI.Widget
 * @para {I18nStirng} text The text of the button.
 */
ox.UI.Button = function(text) {
    ox.UI.Widget.apply(this);
    this.text = text;
};

/**
 * A callback which is called when the button is clicked.
 * @name ox.UI.Button.prototype.click
 * @type Function
 */

ox.UI.Button.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Button.prototype */
    {
    
        addContent: function(node_id) {
            this.formnode = newnode("button", 0, 0, [addTranslated(this.text)]);
            var Self = this;
            addDOMEvent(this.formnode, "click", function() {
                if (Self.click) Self.click();
            });
            this.node = this.parent.addRow(this.formnode, false);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        }
    
    });

/**
 * @class Abstract base class of all controllers.
 * Controllers are responsible for connecting widgets to the data model.
 */
ox.UI.Controller = {};

/**
 * @class An exception object which can be thrown by ox.UI.Controller.set to
 * indicate an attempt to set an invalid value.
 * @param {String} message An optional message which, if specified, is assigned
 * to the property message of the created instance.
 */
ox.UI.Controller.InvalidData = function(message) {
    if (message != undefined) this.message = message;
},

ox.UI.Controller.InvalidData.prototype = new Error("Invalid data");
ox.UI.Controller.InvalidData.prototype.constructor =    
    ox.UI.Controller.InvalidData;
ox.UI.Controller.InvalidData.prototype.name = "ox.UI.Controller.InvalidData";

/**
 * Adds a child value to a container value. Optionally, a replacement value for
 * the entire container value may be returned. This is useful for composite
 * widgets which represent scalars (i. e. not objects) as values.
 * @name ox.UI.Controller.prototype.get
 * @function
 * @param data The value of the container.
 * @param value The value of the child widget.
 * @type Any
 * @return undefined if the data was modified in-place, or a new value of
 * the container.
 */

/**
 * Extracts a child value from a container value.
 * Throws ox.UI.Controller.InvalidData if the extracted data is invalid.
 * @name ox.UI.Controller.prototype.set
 * @function
 * @param data The value of the container.
 * @return The value of the child widget, or undefined if the default value of
 * the widget should be used.
 */

/**
 * @class Abstract base class of all containers.
 * @augments ox.UI.Widget
 */
ox.UI.Container = function() {
    ox.UI.Widget.apply(this);
    this.children = [];
    this.names = {};
};

/**
 * Adds a content row to the container.
 * @name ox.UI.Container.prototype.addRow
 * @function
 * @param {DOM Node} child A DOM node which is or contains the chlid widget.
 * @param {Boolean} table Specifies whether the contents of this row should
 * align themselves with the content of other rows (if true), or not (if false).
 * @type DOM node
 * @return The DOM TR or DIV element of the added row.
 */

/**
 * Adds a row consisting of two cells: a label and a form element.
 * The form element will align itself with other form elements 
 * @name ox.UI.Container.prototype.addCells
 * @function
 * @param {I18nString} label An optional label text for the form element.
 * @param {DOM node} input The DOM node which contains the form element. 
 * @type DOM node
 * @return The DOM TR element of the added row.
 */

ox.UI.Container.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Container.prototype */
    {
        addContent: function(node_id) {
            this.node_id = node_id;
            for (var i = 0; i < this.children.length; i++)
                this.children[i].addContent(node_id);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        default_value: {},
        
        /**
         * Adds a widget to this container as a new child.
         * The new widget appears behind all previously added widgets.
         * The value of the container is an object which contains the values of
         * all children. Each child value appears in the value of the container
         * as a field with the name specified by the parameter name.
         * @param {Widget} widget The widget to add.
         * @param {String or ox.UI.Controller} name If a string, the field name
         * under which the child value will appear in the container's value.
         * If an {@link ox.UI.Controller}, the controller which is responsible
         * for building and parsing the container value. If not specified,
         * the child value will not be connected to the container value.
         * @see ox.Configuration.Group.NoField
         */
        addWidget: function(widget, name) {
            if (name !== undefined) this.names[this.children.length] = name;
            this.children.push(widget);
            widget.setParent(this);
            if (this.initialized) widget.addContent(this.node_id);
        },
        
        /**
         * Removes a previously added widget.
         * @param {Widget} widget The widget to remove.
         */
        deleteWidget: function(widget) {
            for (var i = 0; i < this.children.length; i++) {
                if (this.children[i] == widget) {
                    this.children[i].remove(this);
                    this.children.splice(i, 1);
                    widget.setParent(null);
                    break;
                }
            }
        },
        
        /**
         * Returns an object with all child values.
         * Only children with specified field names are queried.
         * @type Object
         */
        get: function() {
            var data = {};
            for (var i = 0; i < this.children.length; i++) {
                if (i in this.names) {
                    var child = this.children[i];
                    if (child.visible && child.isEnabled) {
                        var value = child.get();
                        if (typeof this.names[i] == "string") {
                            data[this.names[i]] = value;
                        } else {
                            var newData = this.names[i].get(data, value);
                            if (newData !== undefined) data = newData;
                        }
                    }
                }
            }
            return data;
        },
        
        /**
         * Sets the values of all children.
         * @param {Object} data An object with a field for every child.
         * If a child was added with a field name, but the object does not
         * contain that field, the child will be set to its default value.
         */
        set: function(value) {
            value = value || {};
            for (var i = 0; i < this.children.length; i++) {
                if (i in this.names) {
                    if (typeof this.names[i] == "string") {
                        var val = value[this.names[i]];
                    } else {
                        var val = this.names[i].set(value);
                    }
                    if (val === undefined || val === null)
                        val = this.children[i].default_value;
                    this.children[i].set(val);
                }
            }
        },
        
        resize: function() {
            for (var i = 0; i < this.children.length; i++)
                this.children[i].resize();
        },
        
        applyVisible: function() {
            ox.UI.Widget.prototype.applyVisible.call(this);
            for (var i = 0; i < this.children.length; i++) {
                var child = this.children[i];
                child.setVisible(child.visible);
            }
        },
        
        applyEnabled: function() {
            ox.UI.Widget.prototype.applyEnabled.call(this);
            for (var i = 0; i < this.children.length; i++) {
                var child = this.children[i];
                child.setEnabled(child.enabled);
            }
        }

    });

registerView("configuration/modules",
    function() { showNode("modules"); },
    null, null,
    function() { hideNode("modules"); });

register("Loaded", function() {
    ox.Configuration.View.i18n = new I18nNode(noI18n(""));
    ox.Configuration.View.i18n.disable();
    $("modules.header").appendChild(ox.Configuration.View.i18n.node);
});

resizeEvents.register("Resized", function() {
    var current = ox.Configuration.View.current;
    if (current) setTimeout(function() { current.resize(); }, 0);
});

/**
 * Attaches a content page to a leaf node in the configuration tree.
 * The order of events for a view is <ol>
 * <li>{@link #init} (first time only),</li>
 * <li>{@link #addContent} (first time only),</li>
 * <li>{@link #enter},</li>
 * <li>user edits the view,</li>
 * <li>{@link #viewModified}</li>
 * <li>optionally, either {@link #saveView} or {@link #cancelView},</li>
 * <li>{@link #leave}.</li></ol>
 * @class Abstract base class of configuration pages.
 * @augments ox.UI.Container
 * @param {ox.Configuration.LeafNode} node A {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 */
ox.Configuration.View = function(node, title) {
    ox.UI.Container.apply(this);
    var Self = this;
    var view = node.id;
    var old_configuration_changed;
    registerView(view, function() {
        if (!Self.initialized) {
            if (Self.init) Self.init();
            if (!Self.toolbar) {
                Self.toolbar = temporary.configuration.newToolbar(title, []);
            }
            ox.widgets.toolBar.views[view] = Self.toolbar;
            changeDisplay.update(view);
            Self.addContent(view);
        }
        
        var i18n = ox.Configuration.View.i18n;
        if (title instanceof I18nString) {
            var path = title;
            var treeNode = ox.widgets.configTree.get(node.id);
            if (treeNode.data && treeNode.data.name) {
                path = treeNode.data.name instanceof I18nString
                    ? treeNode.data.name : _(treeNode.data.name);
            }
            while (treeNode.parentNode) {
                treeNode = treeNode.parentNode;
                path = (treeNode.data.name instanceof I18nString
                    ? treeNode.data.name : _(treeNode.data.name))
                        + " / " + path;
            }
            i18n.callback = function() { return String(path); };
        } else if (debug) {
            (console.warn || console["log"] || alert)(format(
                "The string \"%s\" is not internationalized!",
                title));
            if (typeof title != "function") {
                i18n.callback = function() { return String(_(title)); };
            } else {
                i18n.callback = title;
            }
        }
        i18n.update();
        i18n.enable();
        $("modules.content").appendChild(Self.content);
        temporary.configuration.showToolbar(Self.toolbar);
    }, function() {
        ox.Configuration.View.current = Self;
        old_configuration_changed = configuration_changed;
        configuration_changed = modified;
        register("OX_SAVE_OBJECT", save);
        register("OX_Cancel_Object", cancel);
        Self.enter();
    }, function() {
        Self.leave();
        unregister("OX_SAVE_OBJECT", save);
        unregister("OX_Cancel_Object", cancel);
        configuration_changed = old_configuration_changed;
        ox.Configuration.View.current = null;
    }, function() {
        $("modules.content").removeChild(Self.content);
        ox.Configuration.View.i18n.disable();
    });
    ox.Configuration.pages.push(this);
    node.click = function() {
        configuration_askforSave(function() {
            triggerEvent("OX_Switch_View", node.id); 
        });     
    };
    
    function modified() { return Self.viewModified(); }
    
    function save() { if (Self.viewModified()) Self.saveView(); }
    
    function cancel() { Self.cancelView(); }
};

/**
 * A callback which is called before the view is opened for the first time.
 * Usually, child elements are created and added here.
 * @name ox.Configuration.View.prototype.init
 * @type Function
 */

/**
 * DOM node with the content of the view.
 * @name ox.Configuration.View.prototype.content
 * @type DOM node
 */

/**
 * Returns whether the view contents were modified and may need to be saved.
 * @name ox.Configuration.View.prototype.viewModified
 * @function
 * @type Boolean
 * @return true if the view contents were modified.
 */

ox.Configuration.View.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.View.prototype */
    {
    
        /**
         * Performs initialization when the user enters the view.
         */
        enter: function() {},
        
        /**
         * Performs cleanup when the user leaves the view.
         */
        leave: function() {},
        
        /**
         * Saves view contents.
         * @param {Function} callback An optional callback functi which is
         * called after the view is saved. 
         */
        saveView: function(callback) {},
        
        /**
         * Reverts modifications made by the user.
         */
        cancelView: function() {},
        
        /**
         * Width of child widgets, as a CSS length value.
         * @type String
         * @default "20em"
         */
        childWidth: "20em"
        
    });

/**
 * @class Resizable vertical split view.
 * All sizes are specified as a fraction of the total available space.
 * @augments ox.Configuration.View
 * @param {ox.Configuration.LeafNode} node An {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 * @param {Number} size The width of the left panel.
 * @param {Boolean} new_button Specifies whether the big button in the menu
 * should be a "New" button instead of a "Save" button.
 */
ox.Configuration.VSplit = function(node, title, size, new_button) {
    ox.Configuration.View.call(this, node, title);

    /**
     * Current width of the left panel.
     * @type Number
     * @private
     */
    this.size = size;
    
    /**
     * Specifies whether the currently edited data is a new list entry.
     * @type Boolean
     * @private
     */
    this.isNew = false;
    
    var Self = this;
    this.toolbar = temporary.configuration.newToolbar(title,
        new_button ? [{
            title: _("New"),
            id: "new",
            buttons: [{
                title: _("New"),
                id: "new",
                icons: ["img/new.png"],
                big: true,
                action: function() { if (Self.onNew) Self.onNew(); }
            }]
        }] : [temporary.configuration.saveButton]);
};

/**
 * A callback which is called when the big "New" button in the menu is clicked.
 * @name ox.Configuration.VSplit.prototype.onNew
 * @type Function
 */

/**
 * The LiveGrid which is displayed in the left panel. It must be set before
 * the view is entered for the first time.
 * @name ox.Configuration.VSplit.prototype.list
 * @type LiveGrid
 * @deprecated
 */

/**
 * Specifies whether the list view was modified and needs to be saved.
 * @name ox.Configuration.VSplit.prototype.listModified
 * @type Boolean
 * @default false
 */

/**
 * Enables the list view when the view is entered. Disabling is done
 * automatically by calling the disable() method of the list. 
 * @name ox.Configuration.VSplit.prototype.enableList
 * @function
 */

/**
 * A callback which is called to get the data for the detail view.
 * It has a continuation function as parameter, which should be called with
 * the data as parameter when the data becomes available. If the continuation
 * function is called without a parameter, the detail view is set to the default
 * value and disabled.
 * @name ox.Configuration.VSplit.prototype.load
 * @type Function
 */

/**
 * A callback which is called to save the data of the detail view.
 * It has two parameters: data and cont. data is the data object to save.
 * cont is a continuation functions which should be called after the data was
 * saved successfully. If the continuation function is called with a parameter,
 * the value of the parameter is used as the new value.
 * @name ox.Configuration.VSplit.prototype.save
 * @type Function
 */

/**
 * An unmodified copy of the data object which is edited in the detail view.
 * @name ox.Configuration.VSplit.prototype.original
 */

ox.Configuration.VSplit.prototype = extend(ox.Configuration.View,
    /** @lends ox.Configuration.VSplit.prototype */
    {
    
        addContent: function(node_id) {
            var selection = this.list.selection;
            selection.events.register("Selected", function(count) {
                menuselectedfolders = [];
                triggerEvent("OX_SELECTED_ITEMS_CHANGED", selection.length);
                triggerEvent("OX_SELECTION_CHANGED", selection.length);
            });
            selection.events.trigger("Selected", 0);
            var list_parent = newnode("div", {
                position: "absolute", top: "1.6em", bottom: 0, overflow: "auto",
                width: "100%"
            });
            this.left = newnode("div", {
                position: "absolute", left: 0, top: 0, width: 0, height: "100%",
                overflow: "hidden"
            }, 0, [this.list.getHeader(), list_parent]);
            this.list.getTable(list_parent);
            this.split = newnode("div", {
                position: "absolute", left: 0, top: 0, height: "100%",
                width: this.split_size + "px", cursor: "e-resize"
            }, { className: "sizesplit-vline" }, [
                newnode("img", { top: "50%", marginTop: "-10px" },
                    { src: getFullImgSrc("img/split_grip_v.gif") })
            ]);
            addDOMEvent(this.split, "mousedown", d);
            this.right = this.table = newnode("div", {
                position: "absolute", right: 0, top: 0, height: "100%",
                left: this.split_size + "px", overflow: "auto"
            });
            this.content = newnode("div", {
                position: "absolute", left: 0, top: 0, width: "100%",
                height: "100%"
            }, 0, [this.left, this.split, this.right]);
            ox.Configuration.View.prototype.addContent.apply(this, arguments);

            var Self = this;

            function d(e) {
                hideIFrames();
                Self.content.style.cursor = "e-resize";
                addDOMEvent(body, "mousemove", m);
                addDOMEvent(body, "mouseup", u);
                var pxsize = Self.getPixel(Self.size);
                var offset = pxsize - e.clientX;
                if (!Self.animated) {
                    var movingSplit = Self.split.cloneNode(true);
                    movingSplit.style.left = pxsize + "px";
                    movingSplit.className = movingSplit.className + " moving";
                    Self.content.appendChild(movingSplit);
                }
                cancelDefault(e);
                
                function getFraction(x) {
                    return (x + offset) /
                           (Self.content.clientWidth - Self.split_size);
                }

                function m(e) {
                    stopEvent(e);
                    Self.size = getFraction(e.clientX);
                    if (Self.animated) {
                        Self.setSize(Self.size);
                    } else {
                        movingSplit.style.left = (e.clientX + offset) + "px";
                    }
                }
    
                function u(e) {
                    showIFrames();
                    removeDOMEvent(body, "mousemove", m);
                    removeDOMEvent(body, "mouseup", u);
                    Self.content.style.cursor = "";
                    if (!Self.animated) {
                        Self.content.removeChild(movingSplit);
                        movingSplit = null;
                        Self.setSize(Self.size);
                    }
                }
    
            }

        },
        
        /**
         * Computes the width of the left panel in pixels.
         * @param {Number} size The width of the left panel as a fraction of
         * the total available space.
         * @type Number
         * @return The width of the left panel in pixels.
         * @private
         */
        getPixel: function(size) {
            size = size < this.min ? this.min
                 : size > this.max ? this.max
                                   : size;
            return size * (this.content.clientWidth - this.split_size);
        },
        
        addRow: function(child, table) {
            if (table) {
                var row = newnode("tr", 0, 0, [
                    newnode("td", { paddingLeft: "20px" }, { colSpan: 2 },
                            child ? [child] : 0)
                ]);
                if (this.lastRow) {
                    this.lastRow.appendChild(row);
                } else {
                    this.lastRow = newnode("tbody", { vAlign: "top" }, 0,
                                           [row]);
                    this.table.appendChild(newnode("table", 0, 0,
                                                   [this.lastRow]));
                }
                return row;
            } else {
                var row = newnode("div", { paddingLeft: "20px" }, 0,
                                  child ? [child] : 0);
                this.table.appendChild(row);
                this.lastRow = null;
                return row;
            }
        },
        
        addCells: function(label, input) {
            var tr = this.addRow(label ? addTranslated(label) : null, true);
            tr.firstChild.colSpan = 1;
            tr.appendChild(newnode("td", { paddingLeft: "10px" }, 0,
                                   input ? [input] : 0));
            return tr;
        },

        viewModified: function() {
            return this.listModified || !equals(this.get(), this.original);
        },

        enter: function() {
            if (this.enableList) {
                var Self = this;
                this.selected_cb = selected;
                this.list.selection.events.register("Selected", selected);
                this.enableList();
                if (this.list.selection.count == 1) {
                    this.enable();
                } else {
                    this.set(this.default_value);
                    this.id = undefined;
                    this.disable();
                }
            }
            this.original = clone(this.get());

            function selected(count) {
                if (!count && Self.isNew) return;
                Self.isNew = false;
                var data = Self.get();
                if (Self.enabled && !equals(data, Self.original) && Self.save) {
                    Self.afterSave = saved;
                    configuration_askforSave();
                } else {
                    saved();
                }

                function saved() {
                    Self.afterSave = null;
                    if (count == 1) {
                        if (Self.load) {
                            try {
                                Self.load(function(data) {
                                    if (data == undefined) {
                                        Self.set(Self.default_value);
                                        Self.id = undefined;
                                        Self.disable();
                                    } else {
                                        Self.set(data);
                                        Self.enable();
                                        Self.id = data.id;
                                    }
                                    Self.original = clone(Self.get());
                                });
                            } catch (e) {
                                if (e instanceof ox.UI.Controller.InvalidData) {
                                    Self.set(Self.default_value);
                                    Self.id = undefined;
                                    Self.disable();
                                } else throw e;
                            }
                        } else {
                            Self.enable();
                            Self.original = clone(Self.get());
                        }
                    } else {
                        Self.set(Self.default_value);
                        Self.id = undefined;
                        Self.disable();
                        Self.original = clone(Self.get());
                    }
                }
            }
            
        },
        
        leave: function() {
            this.list.selection.events.unregister("Selected", this.selected_cb);
            this.list.disable();
        },
        
        saveView: function(callback) {
            this.isNew = false;
            if (this.save) {
                var data = this.get();
                var data2 = clone(data);
                if (this.id != undefined) data2.id = this.id;
                var Self = this;
                this.save(data2, function(data3) {
                    if (Self.afterSave) {
                        Self.afterSave();
                    } else if (data3) {
                        Self.set(data3);
                        Self.id = data3.id;
                        Self.original = clone(Self.get());
                    } else {
                        Self.original = clone(data);
                    }
                    if (callback) callback();
                });
            } else if (callback) {
                callback();
            }
        },

        cancelView: function() {
            this.isNew = false;
            if (this.afterSave) {
                this.afterSave();
            } else {
                this.set(this.original);
            }
        },

        /**
         * Changes the width of the left panel.
         * @param {Number} size The new width of the left panel.
         */
        setSize: function(size) {
            this.size = size;
            size = this.getPixel(size);
            this.left.style.width = size + "px";
            this.split.style.left = size + "px";
            this.right.style.left = (size + this.split_size) + "px";
            if (IE6) {
                var h = this.content.parentNode.clientHeight + "px";
                this.content.style.height = h;
                this.left.style.height = h;
                this.split.style.height = h;
                this.right.style.height = h;
                this.right.style.width =
                    (this.content.parentNode.clientWidth
                    - this.getPixel(this.size) - this.split_size) + "px";
            }
        },
        
        resize: function() {
            this.setSize(this.size);
        },
    
        /**
         * Width of the split handle in pixels.
         */
        split_size: 7,
        
        /**
         * Specifies whether resizing takes effect immediately during dragging
         * (true) or only at the end (false).
         * @type Boolean
         * @default true
         */
        animated: true,
    
        /**
         * Minimum width of the left panel.
         * @type Number
         * @default 0
         */
        min: 0,
        
        /**
         * Maximum width of the left panel.
         * @type Number
         * @default 1
         */
        max: 1,
        
        original: {},
        
        addNew: function(data) {
            this.isNew = true;
            this.list.selection.reset();
            this.set(data);
            this.enable();
            this.original = clone(this.get());
            this.id = data.id;
        }
        
    });

/**
 * @class A configuration page with a single form.
 * @augments ox.Configuration.View
 * @param {ox.Configuration.LeafNode} node A {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 * @param {Boolean} save_button Whether the default save button should be
 * displayed in the menu. Defaults to true. Without the save button,
 * viewModified always returns false. 
 */
ox.Configuration.Page = function(node, title, save_button) {
    ox.Configuration.View.apply(this, arguments);
    if (save_button == undefined) save_button = true;
    if (save_button) {
        this.toolbar = temporary.configuration.newToolbar(title,
            [temporary.configuration.saveButton]);
    } else {
        this.viewModified = ox.Configuration.IFrame.prototype.viewModified;
    }
};

/**
 * A callback which is called to get the data for the view.
 * It has a continuation function as parameter, which should be called with
 * the data as parameter when the data becomes available. If the continuation is
 * called without a parameter, the view is set to the default value and
 * disabled.
 * @name ox.Configuration.Page.prototype.load
 * @type Function
 */

/**
 * A callback which is called to save the page's data.
 * It has two parameters: data and cont. data is the data object to save.
 * cont is a continuation functions which should be called after the data was
 * saved successfully. If the continuation function is called with a parameter,
 * the value of the parameter is used as the new value.
 * @name ox.Configuration.Page.prototype.save
 * @type Function
 */

/**
 * An unmodified copy of the currently edited data object.
 * @name ox.Configuration.Page.prototype.original
 */

ox.Configuration.Page.prototype = extend(ox.Configuration.View,
    /** @lends ox.Configuration.Page.prototype */
    {

        addContent: function(node_id) {
            // TODO: Framework above Page
            this.content = this.table = newnode("div");
            ox.Configuration.View.prototype.addContent.apply(this, arguments);
        },
        
        resize: function() {},
    
        addRow: ox.Configuration.VSplit.prototype.addRow,
        
        addCells: ox.Configuration.VSplit.prototype.addCells,
        
        viewModified: function() {
            return !equals(this.get(), this.original);
        },

        enter: function() {
            if (this.load) {
                var Self = this;
                this.load(function(data) {
                    if (data == undefined) {
                        Self.set(Self.default_value);
                        Self.disable();
                    } else {
                        Self.set(data);
                        Self.enable();
                    }
                    Self.original = clone(Self.get());
                });
            } else {
                this.original = clone(this.get());
            }
        },

        saveView: function(callback) {
            if (this.save) {
                var data = this.get();
                var Self = this;
                this.save(data, function(updated) {
                    if (updated) {
                        Self.set(updated);
                        Self.original = clone(Self.get());
                    } else {
                        Self.original = clone(data);
                    }
                    if (callback) callback();
                });
            }
        },

        cancelView: function() {
            this.set(this.original);
        }

    });

/**
 * Creates a new widget group for a configuration page.
 * @class A widget group in a configuration page.
 * @augments ox.UI.Container
 * @param {I18nString} title The title of the group.
 */
ox.Configuration.Group = function(title) {
    ox.UI.Container.apply(this);
    this.title = title;
};

ox.Configuration.Group.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.Group.prototype */
    {
    
        addContent: function(node_id) {
            if (this.title) {
                this.node = this.parent.addRow(addTranslated(this.title), true);
                this.node.style.paddingTop = "1.6em";
                this.node.className = "height16 font-color-default " +
                                      "font-weight-high font-style-low";
            }
            this.childWidth = this.parent.childWidth;
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        addRow: function(child, table) {
            return this.parent.addRow(child, table);
        },
        
        addCells: function(label, input) {
            return this.parent.addCells(label, input);
        }
        
    });

/**
 * A pre-defined controller object for use as the second parameter to
 * ox.UI.Container#addWidget. It inserts child values directly into the parent's
 * value object, without a nested object.
 */
ox.Configuration.Group.NoField = {
    get: function(data, value) {
        if (typeof value == "object" && value !== null) {
            for (var i in value) data[i] = value[i];
        } else {
            return value;
        }
    },
    set: function(data) { return data; }
};

/**
 * @class A group which contains an array as value. Children are usually added
 * and remoevd at runtime by the user.
 * @augments ox.UI.Container
 * @param {I18nString} title An optional title of the group.
 */
ox.Configuration.ArrayGroup = function(title) {
    ox.UI.Container.apply(this);
    this.title = title;
};

/**
 * A callback which is caled to add the widget for a new array element.
 * @name ox.Configuration.ArrayGroup.prototype.addElement
 * @type Function
 */

ox.Configuration.ArrayGroup.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.ArrayGroup */
    {
    
        default_value: [],
    
        addContent: function(node_id) {
            if (this.title) {
                this.tnode = this.parent.addRow(
                    this.title ? addTranslated(this.title) : null, true);
                this.tnode.style.paddingTop = "1.6em";
                this.tnode.className = "height16 font-color-default " +
                                       "font-weight-high font-style-low";
            }
            this.childWidth = this.parent.childWidth;
            this.tbody = newnode("tbody");
            this.node = this.parent.addRow(newnode("table", 0, 0, [this.tbody]),
                                           false);
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        remove: function() {
            if (this.tnode) this.tnode.parentNode.removeChild(this.tnode);
            this.node.parentNode.removeChild(this.node);
        },
        
        applyVisible: function() {
            if (this.tnode)
                this.tnode.style.display = this.isVisible ? "" : "none";
            this.node.style.display = this.isVisible ? "" : "none";
        },
        
        addRow: function(child, table) {
            var row = newnode("tr", 0, 0, [
                newnode("td", { paddingLeft: "20px" }, { colSpan: 2 },
                        child ? [child] : 0)
            ]);
            this.tbody.appendChild(row);
            return row;
        },
        
        addCells: ox.Configuration.VSplit.prototype.addCells,

        get: function() {
            var value = new Array(this.children.length);
            for (var i = 0; i < this.children.length; i++)
                value[i] = this.children[i].get();
            return value;
        },
        
        set: function(value) {
            for (var i = this.children.length - 1; i >= value.length; i--)
                this.deleteWidget(this.children[i]);
            for (var i = this.children.length; i < value.length; i++)
                this.addElement();
            for (var i = 0; i < this.children.length; i++)
                this.children[i].set(value[i]);
        }

    });

/**
 * @class A container which arranges its children horizontally.
 */
ox.Configuration.HLayout = function() {
    ox.UI.Container.apply(this);
};

/**
 * @private
 */
ox.Configuration.HLayout.id = 0;

ox.Configuration.HLayout.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.HLayout.prototype */
    {
    
        addContent: function(node_id) {
            this.tr = newnode("tr");
            this.node = this.parent.addRow(
                newnode("table", 0, { cellPadding: 0, cellSpacing: 0 },
                        [newnode("tbody", 0, 0, [this.tr])]),
                true);
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        applyVisible: ox.UI.Widget.prototype.applyVisible,
        
        addRow: function(child, table) {
            var td = newnode("td",
                this.tr.firstChild ? { paddingLeft: "5px" } : 0, 0, [child]);
            this.tr.appendChild(td);
            return td;
        },
        
        addCells: function(label, input) {
            var td = newnode("td", 0, 0, label
                ? [addTranslated(label), input]
                : [input]);
            this.tr.appendChild(td);
            return td;
        },
        
        childWidth: "10em"
    
    });

/**
 * @class An editable list with "Add" and "Remove" buttons in the menu.
 * @augments ox.UI.Widget
 * @param {I18nString} section Name of the menu section.
 * @param {String} height The height of the list as a CSS length.
 * @param {I18nString} label An optional label for the list.
 */
ox.Configuration.EditableList = function(section, height, label) {
    ox.UI.Widget.apply(this);
    this.section = section;
    this.height = height;
    this.label = label;
    this.storage = new Storage(0, []);
};

/**
 * @private
 */
ox.Configuration.EditableList.id = 31;

/**
 * This method is called when the "Add" button is clicked.
 * @name ox.Configuration.EditableList.prototype.add
 * @function
 * @param {Function} cont A callback function which should be called with
 * an array of new elements as parameter.
 */

/**
 * This method is called when the "Remove" button is clicked.
 * @name ox.Configuration.EditableList.prototype.onDelete
 * @function
 * @param {Array} removed An array with currently selected values.
 * @param {Function} cont A callback function which should be called after all
 * side effects have been performed. This function performs the actual removal.
 * If it is not called, no entries are removed from the list.
 * @param {Function} dontDelete A function which can be used to cancel
 * the removal of individual values. For each value which should be kept, this
 * function should be called with the index of the value in the array
 * <code>removed</code> as parameter.
 */

ox.Configuration.EditableList.prototype = extend(ox.UI.Widget,
    /** @lends ox.Configuration.EditableList.prototype */
    {
        
        addContent: function(node_id) {
            var selection = new Selection();
            this.grid = new LiveGrid([{
                text: addTranslated(this.label),
                index: 1,
                clear: LiveGrid.makeClear(""),
                set: LiveGrid.defaultSet
            }], selection);
            this.grid.emptylivegridtext = this.emptyText;
            this.head = newnode("div");
            this.body = newnode("div",
                { height: this.height, position: "relative" });
            this.head.appendChild(this.grid.getHeader());
            this.grid.getTable(this.body);
            this.applyEnabled();
            
            this.node = this.parent.addRow(newnode("div", 0, 0,
                [this.head, this.body]));
            var id = "ox.Configuration.EditableList."
                     + ox.Configuration.EditableList.id++;
            var menu = MenuNodes.createSmallButtonContext(id, this.section);
            var Self = this;
            MenuNodes.createSmallButton(menu, id + ".add", _("Add"),
                getFullImgSrc("img/dummy.gif"), getFullImgSrc("img/dummy.gif"),
                function() {
                    if (Self.add) Self.add(function(values) {
                        if (!values.length) return;
                        var oldlen = Self.values.length;
                        Self.values = Self.values.concat(values);
                        var data = new Array(values.length);
                        for (var i = 0; i < values.length; i++)
                            data[i] = [i + oldlen, Self.getText(values[i])];
                        Self.storage.append(data);
                        Self.grid.focus = oldlen;
                        Self.grid.showFocus();
                    });
                });
            MenuNodes.createSmallButton(menu, id + ".remove", _("Remove"),
                getFullImgSrc("img/dummy.gif"), getFullImgSrc("img/dummy.gif"),
                del);
            this.grid.events.register("Deleted", del);
            function del() {
                var indices = Self.grid.selection.getSelected();
                var deleted = {};
                var values = new Array(indices.length);
                for (var i = 0; i < indices.length; i++) {
                    deleted[indices[i]] = true;
                    values[i] = Self.values[indices[i]];
                }
                if (Self.onDelete) {
                    Self.onDelete(values, cont, dontDelete);
                } else {
                    cont();
                }
                function cont() {
                    for (var d = 0; d < Self.values.length && !deleted[d]; d++);
                    for (var s = d + 1; s < Self.values.length; s++) {
                        if (!deleted[s]) Self.values[d++] = Self.values[s];
                    }
                    Self.values.length = d;
                    Self.set(Self.values);
                }
                function dontDelete(index) { delete deleted[indices[index]]; }
            }
            addMenuNode(menu.node, MenuNodes.FIXED,
                        ox.Configuration.EditableList.id);
            changeDisplay(node_id, id);
            selection.events.register("Selected", function(count) {
                menuselectedfolders = [];
                triggerEvent("OX_SELECTED_ITEMS_CHANGED", count);
                triggerEvent("OX_SELECTION_CHANGED", count);
            });
            //menuarrows[node_id] = {};
            register("OX_SELECTED_ITEMS_CHANGED", function() {
                menuglobalzaehler = 0;
                //menuarrows[node_id][id] = [];
                menu_display_contents(node_id, id, true, id + ".add");
                menu_display_contents(node_id, id, selection.count > 0,
                    id + ".remove");
            });
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * The text which is displayed in the list when it contains no entries.
         * @type I18nString
         */
        emptyText: noI18n(""),
        
        default_value: [],
        
        get: function() { return this.values; },
        
        set: function(value) {
            this.values = new Array(value.length);
            var data = new Array(value.length);
            for (var i = 0; i < value.length; i++) {
                this.values[i] = value[i];
                data[i] = [i, this.getText(value[i])];
            }
            this.storage.remove(0, this.storage.ids.length);
            this.storage.append(data);
        },
        
        /**
         * A callback function which is used to extract a human-readable
         * description from an array element of the value. This description is
         * displayed in the list. The default implementation handles I18nString
         * objects and plain strings.
         * @param elem The array element from which to extract the description.
         * @type String
         * @return A textual description of the specified element.
         */
        getText: function(elem) {
            return typeof elem == "function" ? elem() : elem;
        },
        
        applyEnabled: function() {
            if (this.isEnabled) {
                this.grid.enable(this.storage);
            } else {
                this.grid.disable();
            }
        }
        
    });

/**
 * @class A group of widgets with a common caption (legend).
 * The group is represented by a &lt;fieldset&gt; element.
 * @param {I18nString} legend An optional legend text. If not specified,
 * #getLegend must be overwritten to return the legend as an array of DOM nodes.
 */
ox.UI.FieldSet = function(legend) {
    ox.UI.Container.apply(this);
    if (legend) this.legend = legend;
};

ox.UI.FieldSet.prototype = extend(ox.UI.Container,
    /** @lends ox.UI.FieldSet.prototype */
    {
        
        addContent: function(node_id) {
            this.table = this.fieldset = newnode("fieldset", 0, 0,
                [newnode("legend", 0, 0, this.getLegend())]);
            this.node = this.parent.addRow(this.fieldset, false);
            this.childWidth = this.parent.childWidth;
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * Builds the legend of the FieldSet. Descendants can overwrite this
         * method to create different legends.
         * @type Array
         * @return An array of DOM nodes which constitute the children of the
         * &lt;legend&gt; node.
         * @protected
         */
        getLegend: function() { return [addTranslated(this.legend)]; },
        
        applyVisible: ox.UI.Widget.prototype.applyVisible,
        
        addRow: ox.Configuration.VSplit.prototype.addRow,
        
        addCells: ox.Configuration.VSplit.prototype.addCells
/*
        addRow: function(child, table) {
            var td = newnode("td", 0, 0, [child]);
            this.tr.appendChild(td);
            return td;
        },
        
        addCells: function(label, input) {
            var td = newnode("td", 0, 0, label
                ? [addTranslated(label), input]
                : [input]);
            this.tr.appendChild(td);
            return td;
        }
*/
    });

/**
 * @class A FieldSet which can be enabled and disabled by a checkbox in
 * the legend.
 * @param {I18nString} legend The text of CheckBox in the legend.
 */
ox.UI.CheckedFieldSet = function(legend) {
    ox.UI.FieldSet.apply(this, arguments);
};

ox.UI.CheckedFieldSet.id = 0;

ox.UI.CheckedFieldSet.prototype = extend(ox.UI.FieldSet,
    /** @lends ox.UI.CheckedFieldSet.prototype */
    {
    
        getLegend : function() {
            var checkbox = newnode("input", 0, {
                type: "checkbox",
                id: "ox.UI.CheckedFieldSet." + ox.UI.CheckedFieldSet.id++
            });
            var Self = this;
            addDOMEvent(checkbox, "click", function() {
                Self.setEnabled(checkbox.checked);
            });
            return [checkbox, newnode("label", 0, { htmlFor: checkbox.id },
                                      [addTranslated(this.legend)])];
        }
        
    });

/**
 * Attaches an iframe page to a leaf node in the configuration tree.
 * @class A configuration page with external content in an iframe.
 * @augments ox.Configuration.View
 * @param {ox.Configuration.LeafNode} node A {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 * @param {String} src The URI of the iframe content.
 * @param {Boolean} save_button Whether the default save button should be
 * displayed in the menu.
 */
ox.Configuration.IFrame = function(node, title, src, save_button) {
    ox.Configuration.View.apply(this, [node, title]);
    this.src = src;
    if (save_button) {
        this.toolbar = temporary.configuration.newToolbar(title,
            [temporary.configuration.saveButton]);
    }
};

ox.Configuration.IFrame.prototype = extend(ox.Configuration.View,
    /** @lends ox.Configuration.IFrame.prototype */
    {
    
        addContent: function(node_id) {
            this.content = newnode("iframe",
                { position: "absolute", // stupid IE7
                  width: "100%", height: "100%", border: 0 },
                { src: this.src });
            initialized = true;
        },
        
        resize: function() {},
        
        viewModified: function() { return false; }
    
    });

/**
 * @name ox.Configuration.IFrame.prototype.addWidget
 * @private
 */
delete ox.Configuration.IFrame.prototype.addWidget;


/**
 * A form with dynamic contents created from a formDescription
 * @param {I18nString} title A title for the type selection.
 * @param {ox.UI.Controller or String} typeController a controller for
 * the type selection widget, as used for the second parameter to addWidget().
 * @param {ox.UI.Controller or String} dataController a controller for
 * the form contents, as use for the second parameter to addWidget().
 * @ignore
 */
ox.Configuration.DynamicForm = function(title, typeController, dataController) {
    this.meta = {};
    function makeDefault(controller) {
        if (typeof controller == "string") {
            return {
                get: function(data, value) { data[controller] = value; },
                set: function(data) { return data[controller]; }
            };
        } else {
            return controller;
        }
    }
    this.typeController = makeDefault(typeController);
    this.dataController = makeDefault(dataController);
    ox.UI.Container.call(this);
    this.select = new ox.UI.ComboBox(title);
    var Self = this;
    this.select.changed = function() {
        var type = Self.select.get();
        for (var i = Self.children.length - 1; i > 0; i--) {
            Self.deleteWidget(Self.children[i]);
        }
        if (type && (type in Self.meta)) {
            var defs = Self.meta[type].formDescription;
            for (var i = 0; i < defs.length; i++) {
                var def = defs[i];
                var widget = Self.widgets[def.widget](def);
                var controller = Self.controllers[def.widget];
                Self.addWidget(widget, controller ? controller(def.name)
                                                  : def.name);
                if ("defaultValue" in def) {
                    widget.default_value = def.defaultValue;
                    widget.set(def.defaultValue);
                }
            }
        }
    };
    this.addWidget(this.select);
};

ox.Configuration.DynamicForm.prototype = extend(ox.UI.Container, {
    addContent:  function(node_id) {
        this.childWidth = this.parent.childWidth;
        ox.UI.Container.prototype.addContent.apply(this, arguments);
    },
    addRow: ox.Configuration.Group.prototype.addRow,
    addCells: ox.Configuration.Group.prototype.addCells,
    /**
     * Sets the available form descriptions.
     * @param {Object} meta An object mapping types to formDescription objects.
     */
    setMetadata: function(meta) {
        this.meta = {};
        MetaLoop: for (var i in meta) {
            var defs = meta[i].formDescription;
            for (var j = 0; j < defs.length; j++) {
                if (!(defs[j].widget in this.widgets)) continue MetaLoop;
            }
            this.meta[i] = meta[i];
        }
        var ids = [], names = [];
        for (var i in this.meta) {
            ids.push(i);
            names.push(this.meta[i].displayName);
        }
        if (ids.length) this.select.default_value = ids[0];
        this.select.setEntries(ids, names);
    },
    set: function(value) {
        this.id = value.id;
        var type = this.typeController.set(value);
        if (type === undefined || type === null) {
            type = this.select.default_value;
        }
        this.select.set(type);
        this.select.setEnabled(!this.immutableType || !this.id); 
        ox.UI.Container.prototype.set.call(this,
            this.dataController.set(value));
    },
    get: function() {
        var type = this.select.get();
        if (!type) return;
        var value = {};
        if (this.id) value.id = this.id;
        this.typeController.get(value, type);
        this.dataController.get(value,
            ox.UI.Container.prototype.get.call(this));
        return value;
    },
    /**
     * A map of widget types to widget constructors.
     * Each constructor takes a widget definition from a formDescription object
     * as it single parameter and returns the created widget.
     */
    widgets: {
        input: function(def) {
            return new ox.UI.Input(noI18n(def.displayName));
        },
        password: function(def) {
            return new ox.UI.Password(noI18n(def.displayName));
        },
        checkbox: function(def) {
            return new ox.UI.CheckBox(noI18n(def.displayName));
        },
        text: function(def) {
            return new ox.UI.Text(noI18n(def.displayName));
        },
        link: function(def) {
            var link = new ox.UI.Widget();
            link.default_value = "";
            link.addContent = function() {
                this.anchor = newnode("a", 0,
                    { href: this.default_value, target: "_blank" },
                    [document.createTextNode(this.default_value)]);
                this.node = this.parent.addCells(noI18n(def.displayName),
                                                 this.anchor);
                ox.UI.Widget.prototype.addContent.apply(this, arguments);
            };
            link.set = function(value) {
                this.anchor.href = value;
                this.anchor.firstChild.data = value;
            };
            link.get = function() { return this.anchor.firstChild.data; };
            return link;
        },
        oauthAccount: function(def) {
            var account = new ox.Configuration.HLayout();
            account.addContent = function(node_id) {
                this.tr = newnode("tr");
                this.node = this.parent.addCells(noI18n(def.displayName),
                    newnode("table", 0, { cellPadding: 0, cellSpacing: 0 },
                            [newnode("tbody", 0, 0, [this.tr])]));
                ox.UI.Container.prototype.addContent.apply(this, arguments);
            };
            var combobox = new ox.UI.ComboBox();
            updateAccounts();
            function updateAccounts(cb) {
                OAuthAccounts.then(function(accounts) {
                    var ids = jQuery.map(accounts, function(a) {
                        return a.serviceId == def.options.type ? a.id : null;
                    });
                    var names = jQuery.map(accounts, function(a) {
                        return a.serviceId == def.options.type
                            ? noI18n(a.displayName) : null;
                    });
                    combobox.setEntries(ids, names);
                    if (cb) cb();
                });
            }
            account.addWidget(combobox, ox.Configuration.Group.NoField);
            var button = new ox.UI.Button(_("Add a new account..."));
            button.click = function() {
                function s(text) { return newtext(String(text)); }
                var input = newnode("input", { marginLeft: "0.5em" },
                                             { type: "text" });
                OAuthAccounts.then(function(accounts) {
                    for (var i = 0; i < accounts.length; i++) {
                        if (accounts[i].id == def.options.type) {
                            input.value = accounts[i].displayName;
                        }
                    }
                });
                var div = newnode("div", 0, 0, [
                    s(_("Account name")), input,
                    newnode("div", { marginTop: "0.5em" }, 0,
                        //#. %s is the product name (by default 'Open-Xchange Server')
                        [s(format(_("After pressing OK, a new window will open where you can authorize %s to access your account data."),
                                 oxProductInfo.product_name))])
                ]);
                newConfirm(String(_("Add a new account")), "",
                    AlertPopup.OK + AlertPopup.CANCEL, ok, 0, 0, 0, 0, 0, 0, 0,
                    0, div);
                setTimeout(function() { input.focus(); }, 0);
                function ok() {
                    createOAuthAccount(
                        {
                            serviceId: def.options.type,
                            displayName: input.value
                        },
                        function(data) {
                            updateAccounts(function() {
                                combobox.set(data.id);
                            });
                        });
                }
            };
            account.addWidget(button);
            return account;
        }
    },
    /**
     * Overrides for controllers for individual widget types.
     * Each override is a function which takes the field name as parameter
     * and returns either an ox.UI.Controller or a string for the second
     * parameter to addWidget().
     */
    controllers: {
        password: function(name) {
            return {
                get: function(data, value) { if (value) data[name] = value; },
                set: function(data) { return data[name]; }
            };
        }
    }
});

/**
 * A tabbed container. Only one child container is visible.
 * Should be used as the only top-level child of an ox.Configuration.View.
 * All direct children must be instances of ox.Configuration.Tab.
 * @class A tabbed container
 * @augments ox.UI.Container
 */
ox.Configuration.Tabs = function() { ox.UI.Container.apply(this); };

ox.Configuration.Tabs.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.Tabs.prototype */
    {
        addContent: function(node_id) {
            this.childWidth = this.parent.childWidth;
            this.headers = newnode("div", {
                position: "absolute", top: 0, left: 0, right: 0, height: "2.2em"
            }, {
                className: "cpbody-color tabPanelBackground " +
                    "background-color-additional-content border-color-design"
            });
            this.parent.addRow(this.headers, false);
            this.body = newnode("div", {
                position: "absolute", marginTop: "1px", top: "2.2em", left: 0,
                right: 0, bottom: 0
            });
            this.parent.addRow(this.body, false);
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        remove: function() {
            this.body.parentNode.removeChild(this.body);
            this.headers.parentNode.removeChild(this.headers);
        },
        
        applyVisible: function() {
            this.headers.style.display = this.body.style.display =
                this.isVisible ? "" : "none";
            for (var i = 0; i < this.children.length; i++) {
                var child = this.children[i];
                child.setVisible(child.visible);
            }
        },
        
        addWidget: function(widget, name) {
            widget.setVisible(!this.children.length);
            if (!this.current) this.current = widget;
            ox.UI.Container.prototype.addWidget.apply(this, arguments);
        },
        
        /** @private */
        addTab: function(header, body) {
            this.headers.appendChild(header);
            this.body.appendChild(body);
        }
    });

/**
 * The only valid child for ox.Configuration.Tabs.
 * @class A container representing a tab.
 * @augments ox.UI.Container
 * @param {I18nString} title The title of the tab.
 */
ox.Configuration.Tab = function(title) {
    this.title = title;
    ox.UI.Container.call(this);
};

ox.Configuration.Tab.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.Tab.prototype */
    {
        addContent: function(node_id) {
            var Self = this;
            this.childWidth = this.parent.childWidth;
            this.header = newnode("div", 0, {
                className: "tabPanel" + (this.index ? "First" : "") +
                    "Hi tabPanelHiColor background-color-content " +
                    "font-style-lable border-color-content-default"
            }, this.title instanceof I18nString
                ? [newnode("span", 0, 0, [addTranslated(this.title)])]
                : this.title);
            jQuery(this.header).click(function() { Self.show(); });
            this.node = this.table = newnode("div",
                { position: "absolute", left: 0, top: 0, right: 0, bottom: 0 });
            this.parent.addTab(this.header, this.table);
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        remove: function() {
            this.header.parentNode.removeChild(this.header);
            this.table.parentNode.removeChild(this.table);
        },
        
        setVisible: function(visible) {
            if (visible && this.parent) {
                var old = this.parent.current;
                if (old && old != this) old.hide();
                this.parent.current = this;
            }
            ox.UI.Container.prototype.setVisible.apply(this, arguments);
            this.visible = true;
        },

        applyVisible: function() {
            this.header.className = "tabPanel" + (this.index ? "First" : "") +
                (this.isVisible
                    ? "Hi tabPanelHiColor background-color-content " +
                      "font-style-lable border-color-content-default"
                    : " tabPanelColors font-color-disabled " +
                      "background-color-additional-content " +
                      "border-color-design font-weight-default");
            ox.UI.Container.prototype.applyVisible.call(this);
        },
        
        addRow: ox.Configuration.VSplit.prototype.addRow,
        
        addCells: ox.Configuration.VSplit.prototype.addCells
    });
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <Viktor.Pracht@open-xchange.org>
 * 
 */

var temporary = { lists: {} };

temporary.MakeList = function(list) {
    if (!list.addIcon) {
        list.addIcon = temporary.MakeList.addIcon;
    }
    if (!list.addColumn) {
        list.addColumn = function(column) {
            this.columns.push(column);
            this.updated();
        };
    }
    return list;
};

temporary.MakeList.addIcon = function(icon) {
    this.columns.splice(0, 0, {
        text: "&#x00a0;",
        name: icon.name,
        width: icon.width,
        style: { padding: 0, textAlign: "center" },
        set: function(div, data) {
            var src;
            if (icon.isVisible(data)) {
                src = icon.getIcon(data);
                src = src.charAt(0) == "/" ? urlify(src.substring(1))
                                           : getFullImgSrc(src); 
            } else {
                src = getFullImgSrc("img/dummy.gif");
            }
            if (!div.firstChild) {
                div.appendChild(newnode("img", 0, { src: src }));
            } else {
                if (div.firstChild.src != src) {
                    div.firstChild.src = src;
                }
            }
        },
        clear: function(div) {
            var src = getFullImgSrc("img/dummy.gif");
            if (!div.firstChild) {
                div.appendChild(newnode("img", 0, { src: src }));
            } else {
                if (div.firstChild.src != src) {
                    div.firstChild.src = src;
                }
            }
        }
    });
    this.updated();
};

temporary.services = {
    services: {},
    init: function(name) {
        var service = this.services[name];
        if (!service) {
            service = this.services[name] = { providers: [], consumers: [] };
        }
        return service;
    },
    provide: function(name, service) {
        this.init(name).providers.push(service);
    },
    consume: function(name, callback) {
        this.init(name).consumers.push(callback);
    },
    finish: function() {
        for (var i in this.services) {
            var service = this.services[i];
            for (var j = 0; j < service.consumers.length; j++) {
                try {
                    service.consumers[j](service.providers);
                } catch (e) {
                    if (window.console && console.exception) {
                        console.exception(e);
                    }
                }
            }
        }
    },
    getProviders: function(name) { return this.init(name).providers; }
};

temporary.Tabs = function() {
    ox.UI.Widget.call(this);
    this.labelParent = $("tabPanelsFDProps");
    this.tabParent = $("tabcontentsFDProps");
    this.tabs = [];
    var Self = this;
    
    registerView("configuration/folder",
        function() {            
            // sync'ed?
            Self.folder = ox.api.folder.get({ folder: activefolder });
            
            if (!Self.initialized) {
                if (Self.init) {
                    Self.init();
                }
                Self.addContent();
            }
            // done.
            if (Self.afterInit) {
                Self.afterInit();
            }
        },
        function() { Self.enter(); },
        function() { Self.leave(); },
        null,
        function(newfolder) {
            var tab = Number(currentpath2[2]) == currentpath2[2];
            $("tab_props3").style.display = tab ? "" : "none";
            if (!Self.folder || activefolder != Self.folder.id) {
                Self.leave();
                Self.folder = ox.api.folder.get({ folder: activefolder });
                Self.enter();
            }
        }
    );
};

temporary.Tabs.prototype = extend(ox.UI.Widget, {
    addContent: function() {
        var Self = this;
        ox.UI.Widget.prototype.addContent.call(this);
        for (var i = 0; i < this.tabs.length; i++) {
            this.realizeTab(this.tabs[i]);
        }
    },
    
    addTab: function(tab) {
        this.tabs.push(tab);
        tab.setParent(this);
        tab.setViewID("configuration/folder/" + this.tabs.length);
        if (this.initialized) {
            this.realizeTab(tab);
        }
    },
    
    labelClass: "tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default",

    activeLabelClass: "tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default",
    
    realizeTab: function(tab) {
        tab.labelNode = newnode("div", 0, { className: this.labelClass }, [
            newnode("span", 0, { className: "folderpropertiesTab" },
                [document.createTextNode("\xa0")]),
            newnode("span", 0, 0, [
                (tab.label instanceof I18nString) ||
                typeof(tab.label) == "function" ||
                typeof(tab.label) == "string"
                    ? addTranslated(tab.label) : tab.label
            ])
        ]);
        var Self = this;
        this.labelParent.insertBefore(tab.labelNode,
                                      $("temporary.folderTabs.cleaner"));
        registerView(tab.viewID, null, function() {
            ox.Configuration.View.current = tab;
            tab.labelNode.className = Self.activeLabelClass;
            $("tab_props3").appendChild(tab.content);
            temporary.configuration.showToolbar(tab.toolbar);
            tab.enter();
        }, function() {
            tab.leave();
            $("tab_props3").removeChild(tab.content);
            tab.labelNode.className = Self.labelClass;
            ox.Configuration.View.current = null;
        }, null, function() {
            tab.leave();
            tab.enter();
        });
        addDOMEvent(tab.labelNode, "click", function(e) {
            Self.current = tab;
            changeTab("tab_props3", "");
            triggerEvent("OX_Switch_View", tab.viewID);
        });
        if (tab.init) tab.init();
        if (!tab.toolbar) {
            tab.toolbar = temporary.configuration.newToolbar(tab.title,
                [temporary.configuration.saveButton]);
        }
        ox.widgets.toolBar.views[tab.viewID] = tab.toolbar;
        changeDisplay.update(tab.viewID);
        tab.addContent();
    },
    
    showTab: function(tab) {
        this.current = tab;
        changeTab("tab_props3", "");
        triggerEvent("OX_Switch_View", tab.viewID);
    },

    enter: function() {},
    
    leave: function() {},

    saveView: function(callback) { 
        if (this.current) {
            this.current.saveView(callback);
        } else {
            if (callback) {
                callback();
            }
        }
    },
    
    cancelView: function() { this.current.cancelView(); },
    
    viewModified: function() {
        for (var i = 0; i < this.tabs.length; i++) {
            if (this.tabs[i].viewModified()) {
                return true;
            }
        }
        return false;
    }
    
});

temporary.Tab = function(title, label) {
    this.title = title;
    this.label = label;
    ox.UI.Container.apply(this);
};

temporary.Tab.prototype = extend(ox.Configuration.Page, {
    applyVisible: function() {
        this.labelNode.style.display = this.isVisible ? "" : "none";
    },
    setViewID: function(viewID) { this.viewID = viewID; }
});

temporary.VTab = function(title, label, size) {
    this.title = title;
    this.label = label;
    this.size = size;
    ox.UI.Container.call(this);
};

temporary.VTab.prototype = extend(ox.Configuration.VSplit, {
    applyVisible: temporary.Tab.prototype.applyVisible,
    setViewID: temporary.Tab.prototype.setViewID
});


temporary.MailFolderSelection = function(label, findRoot) {
    ox.UI.Widget.apply(this);
    this.label = label;
    this.findRoot = findRoot;
};

temporary.MailFolderSelection.prototype = extend(ox.UI.Widget,
    {
    
    drawMyNode: function() {
         var Self = this;
         this.input = newnode("div",
             { height: "1.25em", overflow: "hidden", whiteSpace: "nowrap" },
             { className: "font-color-default background-color-content " +
                          "smallpopupborder border-color-design" },
             [document.createTextNode("")]);
         
         var justOpened = false;
         addDOMEvent(this.input, "click", function(e) {
             if (Self.folderpopup.style.display == "none") {
                 removeChildNodes(Self.folderpopup);
                 if (!Self.enabled || !Self.isEnabled) {
                     return;
                 }
                 
                 // select folder
                 var opt = {
                     type: "mail",
                     callback: function(data) {
                         Self.set(data.id);
                         Self.folderpopup.style.display = "none";
                     },
                     node: Self.folderpopup
                 };
                 // change root folder?
                 if (ox.util.isFunction(Self.findRoot)) {
                     opt.root = Self.findRoot.call(Self);
                 }
                 // open select dialog
                 ox.api.ui.selectFolder(opt);
                 
                 Self.folderpopup.style.display = "block";
                 justOpened = true;
                 addDOMEvent(body, "click", bodyClick);
             }
         });
         function bodyClick() {
             if (justOpened) {
                 justOpened = false;
                 return;
             }
             removeChildNodes(Self.folderpopup);
             Self.folderpopup.style.display = "none";
             removeDOMEvent(body, "click", bodyClick);
         }
         this.folderpopup = newnode("div",
             { position: "absolute", display: "none", zIndex: 21,
               height: "10em", width: this.width || this.parent.childWidth },
             { className: "background-color-content smallpopupborder " +
                          "border-color-design" });
         addDOMEvent(this.folderpopup, "click", function(e) {
             cancelBubbling(e);
         });
         this.node = this.parent.addCells(this.label, newnode("div",
             { width: this.width || this.parent.childWidth }, 0,
             [this.input, this.folderpopup]));        
         this.initialized = true;
    },
    
    addContent: function(node_id) {
         var Self = this;
         ox.UI.Widget.prototype.addContent.call(this);
         this.drawMyNode();
    },

    get: function() { return this.folderid; },

    set: function(value) {
        this.folderid = value;
        // set default value, then try to make it look more beautiful
        this.input.firstChild.data = value || "\u00a0";
        // vars
        var m, id, path, account;
        // regexp to cut off account id
        m = (value + "").match(/^default(\d+)\D(.+)$/);
        if (m && m.length) {
            // get account
            id = m[1];
            path = m[2];
            if ((account = ox.api.account.get(id))) {
                this.input.firstChild.data = account.name + ": " + path;
            }
        }
    },
    
    saveView: function(callback) { this.current.saveView(callback); },
    
    cancelView: function() { this.current.cancelView(); }
});

register("Loaded", function() {
    temporary.folderTabs = new temporary.Tabs();
});
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

function AutoComplete(oText, oDiv, nMaxSize, minChars, timeout) {    
    this.oText = oText;
    this.oDiv = oDiv;
    // minium characters a user has to enter before search will be executed
    this.minChars = minChars && minChars >= 2 ? minChars : 2;
    // maximum numbers of results which will be displayed
    this.nMaxSize = nMaxSize || 20;
    // timeout after the search results will be displayed
    this.timeout = timeout || 500;
    this.searchPattern = new Object();
    this.cancelRequest = false;
    
    /* to work with teamview (i.e. other use cases than new mail) */
    this.autoAdjustHeight = true;
    this.showDisplayNamesOnly = false;
    this.showSystemUsersOnly = false;
    this.includeResources = false;
    this.nameIndex = {};
    
    /*-- private variables --*/
    this.tt;
    this.cache = new AutoCompleteCache();
    this.currSelected = 0;
    this.currEntries = 0;
    var Self = this;
            
    // attach handlers to the text-box
    oText.AutoComplete = this;
    oText.onkeydown = AutoComplete.prototype.onTextChange;
    jQuery(oText).change(function(evt) {
        Self.onTextBlur(evt);
    });
    oDiv.onmousedown = function() { return false; };
}

AutoComplete.prototype.onTextBlur = function () {
	this.cancelRequest=true;
    this.clear();
    // remove last ending , if exists
    var value = trimStr(this.oText.value);
    if (value.charAt(value.length-1) == ",") {
       this.oText.value = value.substring(0, value.length-1);
    }
};

AutoComplete.prototype.onTextChange = function(evt) {
    var parent = this;
    if (!evt) evt = event;
    a = evt.keyCode;    
   this.AutoComplete.cancelRequest = false;
    switch (a) {
        case 27: //ESC
            parent.AutoComplete.clear();
            stopEvent(evt); 
            return false;
        case 38:    // UP
            parent.AutoComplete.keyUpDown(false);
            break;
        case 40:    // DOWN
            parent.AutoComplete.keyUpDown(true);
            break;
        case 16: case 17: case 18: case 35: case 36: case 37: case 39: 
           // ignore: SHIFT / CTRL / ALT / POS1 / END / LEFT / RIGHT;
            return true;
        case 13: case 9: // ENTER
            return parent.AutoComplete.keyEnter(a);
        default:
            setTimeout(function() {
                    var st = getCurrStr(parent.AutoComplete.oText.value, parent.AutoComplete.oText);
                    if (getSearchPatternLength(st) >= parent.AutoComplete.minChars) {
                        parent.AutoComplete.search(trimStr(st));
                    } else {
                        parent.AutoComplete.clear();
                    }
                },50);
            return;
    }
    if (this.AutoComplete.visible) stopEvent(evt);
};

AutoComplete.prototype.onDivMouseDown = function() {
    var st = this.AutoComplete.oText.scrollTop;
    this.AutoComplete.onSelect(this, st);
    this.AutoComplete.clear();
    return true;
};

AutoComplete.prototype.onDivMouseOver = function() {
    this.className = "PopupEntryDivActive border-color-PMG-selection-elements";
    this.AutoComplete.oText.currSelected = this.getAttribute("ono");
};

AutoComplete.prototype.onDivMouseOut = function() {
    this.className = "PopupEntryDiv";
};

AutoComplete.prototype.keyUpDown = function (up) {
    // top or bottom has been reached, so nothing to do    
    if ((up && this.currSelected >= this.currEntries) || (!up && this.currSelected == 0)) {
        return;
    }

    // disable old selection
    document.getElementById("ac_" + this.currSelected).className = "PopupEntryDiv";
    if (up)
        this.currSelected++;
    else
        this.currSelected--;
    
    // select new row
    var elem = document.getElementById("ac_" + this.currSelected);
    if (elem) {
        elem.className = "PopupEntryDivActive border-color-PMG-selection-elements";
        if (this.oDiv.scrollTop + this.oDiv.clientHeight
            < elem.offsetTop + elem.offsetHeight)
        {
            this.oDiv.scrollTop = elem.offsetTop + elem.offsetHeight
                - this.oDiv.clientHeight;
        }
        if (this.oDiv.scrollTop > elem.offsetTop)
            this.oDiv.scrollTop = elem.offsetTop;
    }
};

AutoComplete.prototype.keyEnter = function () {
    var _rb = true;
    var elem = document.getElementById("ac_" + this.currSelected);
    if (elem) {
        var st = this.oText.scrollTop;
        this.onSelect(elem, st);
        _rb = false;
    }
    this.clear();
    return _rb;
};

AutoComplete.prototype.onSelect = function (elem, st) {
    this.oText.value=replaceCurrStr(this.oText.value, this.oText, elem.getAttribute("oval"));
    setSelRange(this.oText, this.oText.value.length, this.oText.value.length, st);
};

AutoComplete.prototype.clear = function () {
    removeChildNodes(this.oDiv);
    if (this.autoAdjustHeight) {
        this.oDiv.style.height = "";
    }
    this.oDiv.style.visibility = "hidden";    
    this.currSelected = 0;
    this.currEntries = 0;
    this.visible = false;
};

AutoComplete.prototype.enableDiv = function() {
    // positioning the div and enable it
    var oTop = getAbsolutePositionTop(this.oText) + this.oText.offsetHeight;
    var oLeft = getAbsolutePositionLeft(this.oText);
    this.oDiv.style.top = oTop + "px";
    this.oDiv.style.left =  oLeft + "px";
    this.oDiv.scrollTop = "0";
    this.oDiv.style.visibility = "visible";
    this.visible = true;
};

AutoComplete.prototype.onchange = function(txt) {    
    // get all the matching strings from the AutoCompleteCache
    var aStr = new Array();
    this.cache.getResults(txt, aStr);
    this.currSelected = 0;

    // count the number of strings that match the text-box value
    var nCount = aStr.length > this.nMaxSize ? this.nMaxSize : aStr.length;
    this.currEntries = nCount-1;
            
    // if a suitable number then show the popup-div
    if (!this.cancelRequest && this.nMaxSize != -1 && nCount > 0) {
        //!(nCount == 1 && trimStr(txt) == aStr[0])
        
        // clear the popup-div.
        while ( this.oDiv.hasChildNodes() )
            this.oDiv.removeChild(this.oDiv.firstChild);
        
        for (var i = 0; i < nCount; i++ ) {
            var nobj = aStr[i];
            for (var ab in nobj) {                
                var myObj = nobj[ab];
                
                // add each string to the popup-div
                var nDiv = newnode("div", 
                    { overflow: "hidden", whiteSpace: "nowrap" }, null);
                getParsedNode(txt, ab, nDiv);
                nDiv.id = "ac_" + i;
                nDiv.setAttribute("oval", myObj.join(","));
                nDiv.setAttribute("ono", ab);
                nDiv.onmousedown = AutoComplete.prototype.onDivMouseDown;
                nDiv.onmouseover = AutoComplete.prototype.onDivMouseOver;
                nDiv.onmouseout = AutoComplete.prototype.onDivMouseOut;
                if (this.currSelected == i)
                    nDiv.className = "PopupEntryDivActive border-color-PMG-selection-elements";
                else 
                    nDiv.className = "PopupEntryDiv";
                nDiv.AutoComplete = this;
                this.oDiv.appendChild(nDiv);    
            }
        }
        //this.oDiv.style.height = "20em";
        if (this.autoAdjustHeight && this.oDiv.offsetHeight > 160) {
            this.oDiv.style.height = "160px";
        }
        this.enableDiv();
    } else {
        this.clear();
    }
};

AutoComplete.prototype.search = function(str) {
    var parent = this;
    
    // already in cache?
    if (this.cache.contains(trimStr(str)))
       return;
    
    for (var e in this.searchPattern) {
        var sp = new RegExp("^" + escapeRegExp(e));
        if (sp && str.match(sp)) {
            this.onchange(str);
            return;
        }
    }    
        
    // clear timer if already set
    if (this.tt) 
        window.clearTimeout(this.tt);
        
    if (this.oDiv.firstChild) 
        this.oDiv.removeChild(this.oDiv.firstChild);

    this.oDiv.appendChild(
        newnode("div", { textAlign: "center", width: "100%" }, null, [ 
            newnode("img",null,{src: getFullImgSrc("img/ox_animated_withoutbg.gif")},[])
        ])
    );        
        
    // set new timer with given timout
    this.tt = window.setTimeout(function() {
        
        if (parent.cancelRequest) return; // request aborted, so leave    
        parent.enableDiv();
        
        // fire-up search
        var pattern = str;
        if (pattern.charAt(pattern.length - 1) != "*") pattern += "*";
        
        ox.api.folder.exists({
            folder: "6",
            success: function (GAL) {
            
                // in which folder should be searched for autocomplete
                var allFolder = GAL ? [6] : [];
                allFolder.push(configGetKey("folder.contacts"));
                if (configGetKey("modules.mail.contactCollectFolder")) {
                    allFolder.push(configGetKey("modules.mail.contactCollectFolder"));
                }
                
                // default folder
                var defaultSearchFolder = configGetKey("folder.contacts") || 6;
                
                // create multiple request
                var multiple = [{
                    // search contacts
                    "action": "search",
                    "module": "contacts",
                    "columns": "1,500,555,556,557,524,602,592,20,524",
                    "sort": "609",
                    "data": {
                        display_name: pattern, email1: pattern,
                        email2: pattern, email3: pattern, last_name: pattern,
                        first_name: pattern, folder: allFolder, orSearch: true,
                        emailAutoComplete: true
                    }
                }];
                
                if (configGetKey("language") == "ja_JP") {
                    multiple[0].data.yomiFirstName = pattern;
                    multiple[0].data.yomiLastName = pattern;
                }
                
                if (configGetKey("modules.contacts.allFoldersForAutoComplete") == true) {
                    delete(multiple[0].data.folder);
                }
                
                // search for resource?
                if (parent.includeResources) {
                    multiple.push({
                        "action": "search",
                        "module": "resource",
                        "data": {
                            "pattern": pattern,
                            "folder": defaultSearchFolder
                        }
                    });
                }
    
                (new JSONX()).put(AjaxRoot + "/multiple?session=" + session, multiple, null, function(cb) {
                    // no response?
                    if (!cb || !cb.length) {
                        parent.clear();
                        return;
                    }
    
                    // process contacts
                    if (cb[0].error) {
                        newServerError(4, cb[0]);
                    } else {
                        var response = cb[0];
                        for (var i = 0; i < response.data.length; i++) {
                            var data = response.data[i];
                            // system users only? (folder_id=6)
                            if (parent.showSystemUsersOnly && data[8] != 6) continue;
                            // address prefix
                            var pn = data[1] || "";
                            // fill name cache (format: folder.id)
                            var name = quotePersonalAddr(pn);
                            var objectData = {
                                    type: 1, // user
                                    id: data[9], // internal user id
                                    folder: data[8],
                                    display_name: name
                            };
                            // names only?
                            if (parent.showDisplayNamesOnly) {
                                // add
                                var mailAddresses = [];
                                if (data[2]) mailAddresses.push("<"+data[2]+">");
                                if (data[3]) mailAddresses.push("<"+data[3]+">");
                                if (data[4]) mailAddresses.push("<"+data[4]+">");
                                var key = name + " " + mailAddresses.join(", ");
                                parent.cache.add(key, [key]);
                                parent.nameIndex[key] = objectData;
                            }
                            // distribution list?
                            else if (data[6] && data[7]) {
                                var addresses = [];
                                for (var ib in data[7]) {
                                    addresses.push(quotePersonalAddr(
                                        data[7][ib].display_name) +
                                        " <" + data[7][ib].mail + ">");
                                }
                                parent.cache.add(pn, addresses);
                            }
                            // normal users
                            else {
                                var em1 = data[2]; // email1
                                if (em1) {
                                    var key = quotePersonalAddr(pn) + " <" + em1 + ">";
                                    parent.cache.add(key, [key]);
                                    parent.nameIndex[key] = objectData;
                                }
                                var em2 = data[3]; // email2
                                if (em2) {
                                    var key = quotePersonalAddr(pn) + " <" + em2 + ">";
                                    parent.cache.add(key, [key]);
                                    parent.nameIndex[key] = objectData;
                                }
                                var em3 = data[4]; // email3
                                if (em3) {
                                    var key = quotePersonalAddr(pn) + " <" + em3 + ">";
                                    parent.cache.add(key, [key]);
                                    parent.nameIndex[key] = objectData;
                                }
                            }
                        }
                    }
    
                    // process resources
                    if (cb.length > 1 && !cb[1].error) {
                        var response = cb[1];
                        for (var i = 0; i < response.data.length; i++) {
                            var data = response.data[i];
                            var objectData = {
                                    type: 3, // resource
                                    id: data.id,
                                    folder: 0,
                                    display_name: data.display_name
                            };
                            var key = data.display_name + " <" + data.mailaddress + ">";
                            parent.cache.add(key, [key]);
                            parent.nameIndex[key] = objectData;
                        }
                    } else {
                        newServerError(4, cb[1]);
                    }
                    
                    // add search pattern
                    if (!parent.searchPattern[str]) {
                        parent.searchPattern[str] = str;
                    }
                    parent.onchange(str);
                });
            }
        });
    }, this.timeout);
};

function AutoCompleteCache() {
    this.aStr = new Object();
}

AutoCompleteCache.prototype.add = function(key, addresses) {
    if ( !this.aStr[key] ) 
        this.aStr[key] = new AutoCompleteCache();
    this.aStr[key] = addresses;
};

AutoCompleteCache.prototype.getResults = function(str, outStr) {
    for (var i in this.aStr) {
        // quote string for regex but fix wilcards
        // this reflects what the server does: the search pattern must start
        // at the begin or after whitespaces or "<" (email addresses)
        // additionally, display names might be quoted
        var resultRegex = "(^\"?|.*(\\s|<))"+escapeRegExp(str).replace(/\\\*/g, '.*').replace(/\\\?/g, '.');
        var re = new RegExp(resultRegex, "i");
        var obj = {};
        obj[i] = this.aStr[i];
        if (i.match(re)) outStr.push(obj);
    }
};

AutoCompleteCache.prototype.contains = function(str) {
    var tA = new Array();
    this.getResults(str, tA);
    return (tA && tA.length == 1 && tA[0] == str);
};

/******************* UTILS **********************/

/**
 * Constructs a single row with and mark matching text colored
 * @param str  The search String
 * @param oStr The original String (the address in this case)
 * @param oDiv The original div where the row will be appended
 */
var tmp_span = newnode("span", { margin:0 }, { className:"font-style-headline" }, [document.createTextNode("\xa0")]);
function getParsedNode (str, oStr, oDiv) {
    var regexp = new RegExp(escapeRegExp(str), "gi");
    var mpos, lIndex = 0;
    while (str != "" && (mpos = regexp.exec(oStr))) {        
        // everything before
       oDiv.appendChild(document.createTextNode(oStr.substring(lIndex,mpos.index)));
       lIndex = mpos.index + str.length;
       // match
       var mn = tmp_span.cloneNode(true);
       
       mn.firstChild.nodeValue = oStr.substring(mpos.index, lIndex)
       oDiv.appendChild(mn);
    }
    // everything else
    oDiv.appendChild(document.createTextNode(oStr.substring(lIndex, oStr.length)));
}

/**
 * Gets the current String within the carret position
 * @param str  The search String
 * @param obj The div
 */
function getCurrStr(str, obj) {
    var caretStart = getCaretStart(obj);
    var iLength = 0;
    var io=splitMails(str);
    for (var a = 0; a < io.length; a++) {
        iLength += io[a].length + 1;
        if (iLength > caretStart) {
            return io[a];
        }
    }
    return null;
}

function getSearchPatternLength(str) {
    // remove wildcards and whitespaces and return the number of characters
    return (str || "").replace(/[*?\s]/g, '').length;
}

function replaceCurrStr(oldstr,obj,newstr) {    
    var caretStart = getCaretStart(obj);
    var io = splitMails(oldstr);
    var iLength = 0;
    var stringnotfound=true;
    for (var a = 0; a < io.length; a++) {
        iLength += io[a].length + 1;
        if (iLength > caretStart && stringnotfound) {
            io[a]=newstr;
            stringnotfound=false;
        }
    }
    // rebuild string
    var nStr = "";
    for (var a = 0; a < io.length; a++) {
        if (trimStr(io[a]).length != 0) nStr += trimStr(io[a]) + ", ";
    }
     return nStr;
}

function getCaretStart(obj){
    if (typeof obj.selectionStart != "undefined") {
        return obj.selectionStart;
    } else if (document.selection && document.selection.createRange){
        var O = document.selection.createRange();
        try {
            var am = O.duplicate();
            am.moveToElementText(obj);
        } catch(e) {
            var am = obj.createTextRange();
        }
        am.setEndPoint("EndToStart", O);
        var rb=am.text.length;
        if (rb > obj.value.length) {
            return -1;
        }
        return rb;
    }
}

function setSelRange(obj, selStart, selEnd, sc) {
   if (obj.setSelectionRange) {
      obj.focus(); 
      obj.setSelectionRange(selStart, selEnd);
   } else if (obj.createTextRange) { 
      var range = obj.createTextRange(); 
      range.collapse(true); 
      range.moveEnd('character', selEnd); 
      range.moveStart('character', selStart); 
      range.select(); 
   }   
   setTimeout(function() { 
            obj.focus(); 
            obj.scrollTop = sc + 2 + pxPerEm;           
       }, 0);
}

function splitMails(str) {
    var quoted=str.split("\"");
    var noquotes=new Array();
    var holes=new Array();
    var removequotes="";
    var count=0;
    if(quoted.length) {
        for(var i=0;i<quoted.length;i++) {
            if(i%2==0) {
                noquotes.push(quoted[i]);
                count=count+quoted[i].length;
            } else {
                holes.push({count : count , size : quoted[i].length+1 , content : quoted[i] })
            }    
        }
        removequotes=noquotes.join("");
    } else {
        removequotes=str;
    }
    var mysplit=removequotes.split(new RegExp(";|,","g"));
    var newquote=new Array();
    var tmpcount=-1;
    for (var i=0; i<mysplit.length;i++) {
        tmpcount++;
        var tmpInt=mysplit[i].length+tmpcount;
        var tmpText=mysplit[i];
        for(var i2=0;i2<holes.length; i2++) {
            if(holes[i2].count>tmpInt)  { break;}
            if(holes[i2].count<tmpcount) { continue;}
            else {
                tmpText=tmpText.substring(0,holes[i2].count-tmpcount)+"\""+holes[i2].content+"\""+tmpText.substring(holes[i2].count-tmpcount,tmpText.length);
            }
        }
        tmpcount=tmpcount+mysplit[i].length;
        mysplit[i]=tmpText;
    }
    return mysplit;
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

// take care of new/edit windows. in this case the base object ox 
// doesn't exists so we have to create it
if (window && window.ox === undefined) {
    window.ox = {};
}

ox.categories = { cache: [], utils: {}, ui: { temp: {}, add: {} } };

ox.categories.setCache = function(categories) {
    ox.categories.cache = categories;
};

/**
 * Returns a list of categories available in the internal cache
 * @returns {Array} array of category objects
 */
ox.categories.list = function() {
    return ox.categories.cache;
};

/**
 * Gets a category by name
 * @param name of the category
 * @returns {object} the category object
 */
ox.categories.get = function(name) {    
    // get all categories
    var categories = ox.categories.list();
    // loop over
    for (var i=0; i<categories.length; i++) {        
        // compare case-insensitive
        if (categories[i].name.toLowerCase() == name.toLowerCase()) {
            delete(categories[i].active); // just in case
            return categories[i];
        }
    }
    return null;
};

/**
 * Checks if a category exists
 * @param the name of the category
 * @returns {object} the category object
 */
ox.categories.exists = function(name) {
    return ox.categories.get(name) ? true : false;
};

/**
 * Adds a new category to the internal cache
 * @param {String} name = the name, {int} color = the color id
 * @returns {object} the category object
 */
ox.categories.add = function(name, color) {
    name = trimStr(name);
    // do already exists or is name empty?
    if (ox.categories.exists(name) || !name.length) {
        return null;
    }
    var category = { name: name, color: (color || 0) };
    ox.categories.cache.push(category);    
    return category;
};

/**
 * Edits a category in the internal cache
 * @param {String} id = identifier of the category (likely the name), 
 *           {String} name = the name, {int} color = the color id
 * @returns {object} the category object
 */
ox.categories.edit = function(id, name, color) {
    name = trimStr(name || "");
    // name empty?
    if (!name.length && !ox.categories.exists(id)) {
        return null;
    }
    var category = ox.categories.get(id);
    if (category) {
        delete(category.active); // just in case
        category.name = name;
        category.color = color;
    }
    return category;
};

/**
 * Removes a set of categories from the cache
 * @param {Array} an array of names which should be removed from 
 *           the internal cache
 */
ox.categories.remove = function(names) {
    if (typeof names != "object") {
        names = [ names ];
    }
    $l1 = names.length;
    for (var i=0; i < ox.categories.list().length; i++) {
        for (var ia=0; ia<$l1; ia++) {
            if (ox.categories.cache[i] && ox.categories.cache[i].name == names[ia]) {
                ox.categories.cache.splice(i,1);                
            }
        }
    }
};

/**
 * Saves the current categories to the users configuration
 */
ox.categories.save = function(showConfirm) {
    // without corewindow we have to leave
    if (!corewindow) {
        return;
    }
    corewindow.configuration_changed_fields.gui = true;
//    var cats = (ox.categories.list() || []), $l = cats.length, categories = [];
//    for (var i=0; i < $l; i++) {
//        categories.push(corewindow.clone(cats[i]));
//    }
    var categories = corewindow.clone(ox.categories.list() || [], window);
    corewindow.configSetKey("gui.categories.local", categories);
    corewindow.triggerEvent("OX_Save_Configuration", false, !showConfirm ? true : false);
    
    // are we in a new/edit window? if so we are updating the cache in the 
    // corewindow. 
    // @todo: we should think about a smarter way to force an cache update at
    // the corewindow. could lead to problems if the user edit categories in the
    // corewindow at the same time!
//    if (corewindow.ox.Configuration) {
//        corewindow.ox.categories.cache = categories;
//    }
};

ox.categories.match = { ALL: 1, MATCH: 2, NON_MATCH: 4 };

ox.categories.getByString = function(names, match, noDuplicates) {    
    var list = [];
    var ids = names.split(","), $l = ids.length;
    for (var i=0; i < $l; i++) {
        var name = trimStr(ids[i]);        
        if (name != "" && (!noDuplicates || 
                !ox.categories.utils.existsInObject(name, list))) {
            var cat = ox.categories.get(name);
            switch (match) {
                case 4:
                    if (!cat) {
                        list.push({ name: name, color: 0 });
                    }
                    break;
                case 2:
                    if (cat === null){
                        break;
                    }
                    /* no break */
                default:
                    list.push(cat || { name: name, color: 0 });
                    break;
            }
        }
    }
//    list.sort(function(a,b) {
//        return (a.color < b.color ? 1 : -1);
//    });
    return list;
};

/**
 * Removes the given category out of the comma separated list of categories
 * @param {String} the name of the category which should be removed
 * @param {String} comma separated list of categories
 * @returns {String} a new list without the given category. note: any duplicated
 *             category will be filtered out as well!
 */
ox.categories.removeCategoryFromString = function(name, categories) {
    var cats = ox.categories.getByString(categories, ox.categories.match.ALL, true);
    var retVal = "";
    for (var i=0; i < cats.length; i++) {
        if (cats[i].name !== name) {
            retVal += cats[i].name + (i+1 < cats.length ? ", " : "");
        }
    }
    return retVal;
};

/**
 * Gets the first category from cache matching with one of the 
 * categories of the given string.
 * @param {String} single category name or likely a comma separated 
 *           list of categories 
 */
ox.categories.getFirstMatch = function(str) {
    var ids = (str || "").split(/,/);
    var i = 0, $l = ids.length;
    // loop over names
    for (; i < $l; i++) {
        var id = trimStr(ids[i]);
        if (ox.categories.exists(id)) {            
            return ox.categories.get(id); // match!
        }
    }    
    return { name: "", color: 0 }; // no match
};


/*** Categories Selection Dialog ***/

ox.categories.ui.open = function(tags, cb) {    
    var grid, color, tags = (tags || "");    
    ox.categories.ui.final_cb = cb;    
    
    // initiate grid
    if (!ox.categories.ui.grid) {
        ox.categories.ui._initGrid();
        
        // add handler on delete button
        addDOMEvent($("categories_sel_but_delete-button"), "click", function(e) {
            var ids = ox.categories.ui.grid.selection.getSelected();
            if (ids && ids.length) {
                ox.categories.ui.temp.changed = true;
                ox.categories.ui.grid.storage.removeIDs(ids);
            }
            return false;
        });
        
        // add handler on rename button
        addDOMEvent($("categories_sel_but_rename-button"), "click", function(e) {
            var ids = ox.categories.ui.grid.selection.getSelected();
            if (ids && ids.length == 1) {
                var inplace, self = this;
                var node = ox.categories.ui.grid.rows[ox.categories.ui.grid.focus].cells[2];
                if (!node || !node.firstChild) {
                    return;
                }
                inplace = new inplaceEdit(
                        node, 
                        node.firstChild.data, 
                        function(new_name) {
                            if (ox.categories.utils.isValidName(new_name, ids[0])) {
                                ox.categories.ui.grid.storage.localUpdate(ids, function(index, object) {
                                    if (object.name != new_name) {
                                        ox.categories.ui.temp.changed = true;
                                        object.name = new_name;
                                    }
                                    return object;
                                });
                                delete(self.inplace);
                            } else {
                                return false;
                            }
                        }
                );
                inplace.style.border = "1px black dotted";
                inplace.style.background = "white";
                inplace.on();
                cancelBubbling(e);
            }
            return false;
        });    
        
        // add handler on new button
        addDOMEvent($("categories_sel_but_new-button"), "click", function(e) {
            ox.categories.ui.add.open(null, function(category) {
                //does it exists in cache or in the grid? then return
                if (!category || ox.categories.exists(category.name) || 
                        ox.categories.ui.grid.storage.indices[category.name]) {
                    return;
                }
                category.active = true;
                ox.categories.ui.grid.storage.append([category]); // append to grid
                if (category.color !== 0) {
                    ox.categories.ui.temp.changed = true;
                }
            });
        });
    }
    
    // initiate color selection combo
    if (!ox.categories.ui.color) {
        var color = ox.categories.ui.getColorSelect();
        // color change event
        color.onChange = function(new_color, color_before) {
            var ids = ox.categories.ui.grid.selection.getSelected();
            // anything selected and new color is not 0
            if (ids && ids.length && new_color !== 0) {
                // updating grid storage
                ox.categories.ui.grid.storage.localUpdate(ids, function(index, object) {
                    if (object.color != new_color) {
                        object.color = new_color;
                        if (new_color !== 0) {
                            ox.categories.ui.temp.changed = true;
                        }
                    }
                    return object;
                });        
            } else if (new_color === 0) {
                // if color is 0 reset to the color before
                color.setKey(color_before, true);
            }
        };
        ox.categories.ui.color = color;
        $("categories_sel_color").appendChild(color.getDomNode());
    }
    // enable grid with storage
    grid = ox.categories.ui.grid;
    grid.enable(new Storage(0, [], 0, 0, 0, 0, function(data) { return data.name; }));
    //grid.storage.remove(0, grid.storage.ids.length);

    // find matching categories by the given list and mark them as selected
    var mCat = clone(ox.categories.getByString(tags, ox.categories.match.MATCH));
    var lCat = clone(ox.categories.list()), $l = lCat.length, $la = mCat.length;
    for (var i=0; i < $l; i++) {
        var t_cat = lCat[i];
        for (var ia=0; ia < $la; ia++) {
            var t_cat2 = mCat[ia];
            if (t_cat.name == t_cat2.name) {
                t_cat.active = true; // mark as active
                break;
            } else {
                delete(t_cat.active); // just in case
            }
        }
    }
    
    // getting non matching categories and mark them as active
    var nCat = clone(ox.categories.getByString(tags, ox.categories.match.NON_MATCH));
    var $l = nCat.length;
    for (var i=0; i < $l; i++) {
        nCat[i].active = true;
        lCat.push(nCat[i]);
    }
    
    // append concatenated tags to grid storage
    grid.storage.append(lCat);
        
    // show dialog
    ox.api.setModal(true);
//    showNode("modal-dialog");
//    $("modal-dialog").style.display="block";
    
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";
        
    showNode("window_categories");
    centerPopupWindow($("window_categories"));
    $("window_categories").style.display="block";
};

ox.categories.ui.close = function(cancel) {
    var selCat = [], finCat = [];
    // get selected categories and disable grid
    if (ox.categories.ui.grid) {
        var grid = ox.categories.ui.grid;
        // iterate through storage and get selected cats 
        grid.storage.newIterate(grid.storage.ids, emptyFunction, function(id, obj) {
            if (obj) {                
                if (obj.active) {
                    selCat.push(obj);
                }
                if (obj.color !== 0) {
                    finCat.push(obj);
                }
                delete(obj.active); // just temp so delete
            }
        });
        grid.disable();
    }
    
    // rearrange order of categories in the way the user selected them
    var order = (ox.categories.ui.temp.clickOrder || []), $l = order.length, $la = selCat.length;
    for (var i=$l-1; i >= 0; i--) {
        for (var ia=0; ia < $la; ia++) {
            var object = selCat[ia];
            if (object.name == order[i]) {
                selCat.splice(ia,1);
                selCat.unshift(object);
            }
        }
    }
    // remove instance here to prevent a save trigger later!
    delete(ox.categories.ui.temp.clickOrder);
    
    // do we have a action or did the user just pressed cancel?
    if (!cancel) {    
        if (ox.categories.ui.temp.changed) {
            ox.categories.setCache(finCat);
            ox.categories.save();
        }
        
        // trigger given callback
        if (ox.categories.ui.final_cb) {
            ox.categories.ui.final_cb(selCat, ox.categories.utils.paramToString(selCat, "name"));
        }
    }
    // clean-up
    delete(ox.categories.ui.final_cb);
    delete(ox.categories.ui.temp);
    ox.categories.ui.temp = {};
    
    // close modal window
    if (this.closecb) { 
        globalalert.cbclose(); 
    }
    hideNode("window_categories");
    $("window_categories").style.display="none";
        
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs=    $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0;i<childs.length;i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display!= "none" ) {
                closeall=false;
            }
        }
    }
    if (closeall) {
        ox.api.setModal(false);
//        hideNode("modal-dialog");
//        $("modal-dialog").style.display="none";
    }
};

/**
 * Creates a new color combobox
 * @return {ComboBox3} object 
 */
ox.categories.ui.getColorSelect = function() {
    var ncol = new ComboBox3(window, null, "10em", 0, true, null, 7);
    for (var i=0; i<=25; i++) {
        ncol.addElement(newnode("div", 0, 
                { className: "colorLabelCont bs ha colorLabel" + i }), i);
    }
    ncol.headTable.style.height="1.8em";
    return ncol;    
};

/*
 * Initiate a new grid for the category selection dialog
 * @private
 */
ox.categories.ui._initGrid = function() {
    // temporary store the click sequence to get the correct order 
    function changeOrder(id, action) {
        var order = (ox.categories.ui.temp.clickOrder || []), $l = order.length;
        for (var i=0; i < $l; i++) {
            if (order[i] == id) {
                order.splice(i,1);
                break;
            }
        }
        if (action) {
            order.push(id);
        }
        ox.categories.ui.temp.clickOrder = order;
    }
    function addCheckBox() {
        var checkbox = newnode("input", 0, { type: "checkbox", className: "noborder" });
        addDOMEvent(checkbox, "click", function() {
            // clicked on check-box 
            var ids = ox.categories.ui.grid.selection.getSelected();
            if (ids && ids.length) {
                // setting status in storage
                var obj = ox.categories.ui.grid.storage.data.data[ids[0]];
                if (obj.active) {
                    delete(obj.active);
                } else {
                    obj.active = true;
                }
                changeOrder(obj.name, obj.active);
            }
            return false;
        });
        return checkbox;
    }
    var self = this;
    var grid = new LiveGrid([
          {
              text: "&#xa0;",
              width: "2em",
              style: { paddingTop: "2px", textOverflow: "clip" },
              set: function (div, data) {
                    if (!div.firstChild) {
                        div.appendChild(addCheckBox());
                    }
                    div.firstChild.style.display = "";
                    div.firstChild.checked = data.active;
              },
              clear: function (div) {
                    if (!div.firstChild) {
                        div.appendChild(addCheckBox());
                    }
                    div.firstChild.style.display = "none";
              }
          },
          { 
              text: "&#xa0;",
              width: "2em",
              clear: function(div) {
                  if (div.firstChild) {
                      div.firstChild.className = "";
                  } else {
                      div.appendChild(
                              newnode("div", 0, { className: "colorLabelCont bg hb" }));
                  }
                },
              set: function(div, data) {
                  if (div.firstChild) {
                      div.firstChild.className = "colorLabelCont bg hb colorLabel"+data.color;
                  } else {
                      div.appendChild(
                              newnode("div", 0, 
                                      { className: "colorLabelCont bg hb colorLabel" + data.color }));
                  }
              }
          },
          {
              text: "Name",
              i18n: true,
              clear: LiveGrid.makeClear(""),
              set: function(div, data) {
                  if (div.firstChild) {
                      div.firstChild.data = data.name;
                  } else {
                      div.appendChild(document.createTextNode(data.name));
                  }
              }
          }
      ], new Selection());
    
    grid.lineHeight = 1.9;
    grid.rowHeight = 24;
    grid.emptylivegridtext = "";
    grid.events.register("Selected", function() {
        // get selected signature
        var ids = self.grid.selection.getSelected();        
        if (!ids || !ids.length) {            
            ox.categories.ui.color.setKey(0, true);
        } else {            
            var object = ox.categories.get(ids[0]);            
            if (ids.length && object) {
                ox.categories.ui.color.setKey(object.color, true);
            } else {                
                ox.categories.ui.color.setKey(0, true);
            }
        }        
    });
    grid.events.register("Activated", function(ids) {        
            if (ids && ids.length > 0) {
                ox.categories.ui.grid.storage.localUpdate(ids, function(index, object) {
                    if (object.active) {
                        delete(object.active);
                    } else {
                        object.active = true;
                    }
                    changeOrder(object.name, object.active);
                    return object;
                });
            }
        }
    );    
    $("categories_sel_grid_header").appendChild(grid.getHeader());
    grid.getTable($("categories_sel_grid"));
    ox.categories.ui.grid = grid;
};


/*** Categories Add/Edit Dialog ***/

ox.categories.ui.add.open = function(tag, cb) {
    var color;
    ox.categories.ui.add.final_cb = cb;
    
    // init color selection
    if (!ox.categories.ui.add.color) {
        color = ox.categories.ui.getColorSelect();
        $("categories_new_color").appendChild(color.getDomNode());
        color.setKey(0);
        ox.categories.ui.add.color = color;
    } else {
        color = ox.categories.ui.add.color;
    }
    
    if (tag) {
        color.setKey(tag.color || 0);
        $("categories_new_id").value = (tag.id || tag.name || "");
        $("categories_new_name").value = (tag.name || "");
    }
    
    if (!ox.api.isModal()) {
        ox.api.setModal(true);
//        showNode("modal-dialog");
//        $("modal-dialog").style.display="block";
        showNode("disable_confirm_window");
        $("disable_confirm_window").style.display="block";
    }
    
    showNode("window_categories_new");
    centerPopupWindow($("window_categories_new"));
    $("window_categories_new").style.display="block";
    $("categories_new_name").focus();
};

ox.categories.ui.add.close = function(cancel) {
    if (!cancel && ox.categories.ui.add.final_cb) {
        // get trimmed name
        var id = $("categories_new_id").value;
        var name = $("categories_new_name").value;
        if (ox.categories.utils.isValidName(name, id)) {
            // add
            ox.categories.ui.add.final_cb({
                id: id,
                name: name,
                color: ox.categories.ui.add.color.getKey()
            });
        } else {
            $("categories_new_name").focus();
            return;
        }
    }
    $("categories_new_id").value = "";
    $("categories_new_name").value = "";
    ox.categories.ui.add.color.setKey(0);
    delete(ox.categories.ui.add.final_cb);
    
    if (this.closecb) { 
        globalalert.cbclose(); 
    }
    hideNode("window_categories_new");
    $("window_categories_new").style.display="none";
    // hide background only if the main selection dialog isn't visible
    if ($("window_categories") && $("window_categories").style.display == "none") {
        hideNode("disable_confirm_window");
        $("disable_confirm_window").style.display="none";
        var childs=    $("modal-dialog").childNodes;
        var closeall=true;
        for (var i=0; i < childs.length; i++) {
            if (childs[i].tagName && childs[i].tagName == "DIV") {
                if (childs[i].style.display && childs[i].style.display!= "none" ) {
                    closeall=false;
                }
            }
        }
        if (closeall) {
            ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display="none";
        }
    }
};

/*
 * draws a list of category divs to a given DOM node
 * @param {Array} list of category objects
 * @param {DOM} node to attach category divs
 * @param {Boolean} true = show just only color divs, without names
 */
ox.categories.ui.drawCategoriesList = function(categories, node, withoutNames) {
    var $l = categories.length;
    removeChildNodes(node);
    var cNode = newnode("div", { flt: "left", border: "1px solid #c0c0c0", minHeight: "10px",
        padding: "0 4px 0 4px", margin: "1px 1px 0 0" }, { className: "colorLabelCont bs" }, 
        [ newtext("\u00a0") ]);    
    for (var i=0; i < $l; i++) {
        var category = categories[i];
        var tn = cNode.cloneNode(true);        
        tn.className += " colorLabel" + category.color;
        if (!withoutNames) {
            tn.firstChild.data = category.name;
        }
        tn.title = (category.name || "");
        tn.onselectstart = function() { return false; };
        node.appendChild(tn);
    }
};

/*
 * attach an inplace input field to the given DOM node. the developer
 * needs to take care that this node got removed afterwards. the callback 
 * will be triggered as soon the user leave the element and/or hit enter
 * or esc. 
 * @param {DOM} node to attach the inplace input
 * @param {function} callback which receive the input value. if the user
 *           hit ESC the value will be null
 */
ox.categories.ui.attachInplaceInput = function(node, callback) {
    if (!node || !callback) {
        return;
    }
    var key, blur;
    var bNode = newnode("div", { flt: "left", border: "1px solid #c0c0c0", 
        padding: "0 4px 0 4px", margin: "1px 1px 0 0", MozUserSelect: "normal" }, 
        { className: "colorLabelCont bs" });
    var input = newnode("input", { width: "15em", border: "none" });
    bNode.appendChild(input);
    node.appendChild(bNode);
    function finalCb(value) {
        removeDOMEvent(input, "blur", blur);
        removeDOMEvent(input, "keypress", key);
        callback(value);
    }
    key = function(e) {
        switch (e.keyCode || e.which) {
            // enter
            case 13:
                finalCb(input.value);
                break;
            // esc
            case 27:
                finalCb(null);
                break;
            default:
                return;
        }
        return false;
    };
    blur = function(e) {
        finalCb(input.value);
    };
    addDOMEvent(input, "blur", blur);
    addDOMEvent(input, "keypress", key);
    
    // set focus and select
    input.focus();
    input.select();
};

register("Loaded", function () {
    addOnClose($("window_categories"), function() { 
        ox.categories.ui.close(true);
    });
    addOnClose($("window_categories_new"), function() { 
        ox.categories.ui.add.close(true);
    });
    
    // need to init cache here in the new/edit windows
    if (!ox.Configuration) {
        ox.categories.setCache(clone(configGetKey("gui.categories.local"), corewindow));
    }
});

register("OX_Configuration_Loaded_Complete", function() {
    ox.categories.setCache(configGetKey("gui.categories.local"));
});

corewindow.register("OX_Configuration_Changed", function(location) {
    if (window && window.ox !== undefined) { // window might be null (cross-window issue)
        if (!ox.Configuration) {
            ox.categories.setCache(clone(configGetKey("gui.categories.local"), corewindow));
        } else {
            ox.categories.setCache(configGetKey("gui.categories.local"));
        }
    }
});


/*** Categories Utils ***/

ox.categories.utils.isValidName = function (name, old) {
    // get name
    name = jQuery.trim(name).toLowerCase();
    // empty name?
    if (name === "") {
        ox.UINotifier.warn(_("Categories must have a name") /*i18n*/ + "!"); 
        return false;
    } else if (old && name === old.toLowerCase()) {
        // change case does not lead to duplicates
        return true;
    } else {
        // build local hash to look for duplicates
        var hash = {}, id;
        // live grid #1
        if (ox.categories.ui.grid && ox.categories.ui.grid.storage) {
            for (id in ox.categories.ui.grid.storage.indices) {
                hash[id.toLowerCase()] = true;
            }
        }
        // live grid #2
        var cats = window.cnf_Categories;
        if (cats && cats.storage) {
            for (id in cats.storage.indices) {
                hash[id.toLowerCase()] = true;
            }
        }
        // check
        if (ox.categories.exists(name) || hash[name] !== undefined) {
            ox.UINotifier.warn(_("Category names must be unique") /*i18n*/ + "!");
            return false;
        } else {
            return true;
        }
    }
};

ox.categories.utils.migrateTags = function() {
    var categories = ox.api.config.get("gui.private_categories", null);
    if (categories === null || categories.length === 0) {
        // nothing to do but delete anyway
        delete config.gui.private_categories;
        delete config.gui.global_categories;
        return;
    }
    var tags = categories.split(","), color = 1;
    for (var i=0; i<tags.length; i++) {
        var name = trimStr(tags[i]);
        // only add tags where name not empty and if not exists 
        if (name.length !== 0 && ox.categories.exists(name) === false) {
            ox.categories.add(name, color++);
            if (color == 25) {
                color = 1;
            }
        }
    }
    delete config.gui.private_categories;
    delete config.gui.global_categories;
    ox.categories.save();
};

ox.categories.utils.paramToString = function(categories, parameter, delimeter) {
    var $l = categories.length, retVal = [];
    for (var i=0; i < $l; i++) {
        if (categories[i][parameter]) {
            retVal.push(categories[i][parameter]);
        }
    }
    return retVal.join(delimeter || ", ");
};

/**
 * Check if the given name already exists in the list of categories
 * @param {String} the name to check
 * @param {Array} list of category objects
 */
ox.categories.utils.existsInObject = function(name, categories) {
    var $l = categories.length;
    for (var i=0; i < $l; i++) {
        if (categories[i].name == name) {
            return true;
        }
    }
    return false;
};

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
/**
 * define day
 */
function cDay(nDateParam,nCurrMonthParam,bWeekendParam)
{
	this.nDate = nDateParam;
	this.nCurrMonth = nCurrMonthParam; 		 //flags: 0 last month, 1 current month, next month
	this.bWeekend = bWeekendParam;			 //true, false
}

/**
 * define week
 */
function cWeek()
{
	this.nKW;	
	this.aDays= new Array();	
	this.addDay = function (nDay,oDay)
	{
		this.aDays[nDay] = oDay;
	}
	this.setKW = function (nKWParam)	
	{
		this.nKW = nKWParam;
	}
}

/*
 * defines calender:
 */
function cCalendar(nMonthParam,nYearParam)
{
	this.nMonth = nMonthParam;
	this.nYear = nYearParam;
	this.aWeeks= new Array();
	/*
	 * compute Calendar
	 */
	this.addWeek = function (nNumWeek,oWeekParam)
	{
		this.aWeeks[nNumWeek] = oWeekParam;			
	};
	 
	this.init = function ()
	{
		var oCalendarTool = new calendarTool(this.nMonth, this.nYear);
		var nNumWeeks = oCalendarTool.getNumWeeks();
		var	startByDate = oCalendarTool.endDate - oCalendarTool.firstDay+1;			
		var nDayCounter = 0; var nDayNextMonth = 1;var nDayCurrMonth = 1;
		for(nWeek=0;nWeek < nNumWeeks;nWeek++)
		{			
			var oWeek = new cWeek();
			var oThDate = new Date(Date.UTC(this.nYear, this.nMonth));
			
			for(indexDay=0;indexDay<7;indexDay++)
			{				
				if(indexDay > 4)
				 	bWeekend = true;
				else				 	
				 	bWeekend = false;				 	
				if(nDayCounter<oCalendarTool.firstDay)
				{
					var oDay = new cDay(startByDate+nDayCounter,0,bWeekend);
					if(indexDay==3) //th
					{
						oThDate.setUTCDate(startByDate + nDayCounter);
						oThDate.setUTCMonth(oThDate.getUTCMonth() - 1);						
					}
				}				
				else if(nDayCounter>=(oCalendarTool.nDays+oCalendarTool.firstDay))
				{
					var oDay = new cDay(nDayNextMonth,2,bWeekend);
					if(indexDay==3) //Th
					{
						oThDate.setUTCDate(nDayNextMonth);
						oThDate.setUTCMonth(oThDate.getUTCMonth() + 1);		
					}
					nDayNextMonth++;
				}				
				else
				{
					var oDay = new cDay(nDayCurrMonth,1,bWeekend);
					if(indexDay==3)
					{					
						oThDate.setUTCDate(nDayCurrMonth);
					}
					nDayCurrMonth++;
				}	
				oWeek.addDay(indexDay,oDay);
				oWeek.setKW(getWeek(oThDate));
				nDayCounter++;
			}
			this.addWeek(nWeek,oWeek);
		}		
	};
	
	this.init();	

}

/*
 * tools for calendar computing
 */
function calendarTool(nMonthParam,nYearParam) {
	this.firstDay;
	this.startWeek;
	this.endDate;
	this.nDays;	
	
	this.nMonth = nMonthParam;	
	this.nYear = nYearParam;	
	this.init = function () {
        var currDate = new Date(Date.UTC(this.nYear, this.nMonth, 0));
        this.endDate = currDate.getUTCDate();
        currDate.setUTCDate(currDate.getUTCDate() + 1);
        
        this.startWeek = getWeek(currDate);
        this.firstDay = currDate.getUTCDay();
        if (this.firstDay > 0) this.firstDay -= 1;	
        else if (this.firstDay == 0) this.firstDay = 6;		
        //compute num days
        currDate.setUTCMonth(currDate.getUTCMonth() + 1, 0);
        this.nDays = currDate.getUTCDate();		
    };
	
	this.getNumWeeks = function() {	
		var fullWeeks = parseInt(this.nDays/7);
		var overflow = this.nDays - fullWeeks*7;
		if(this.firstDay > 0)
			fullWeeks++;
		if ((7 - this.firstDay) < overflow || (overflow>0 && this.firstDay==0)) {
			fullWeeks++;
		}
		return fullWeeks;
	}
	
	this.init();
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var oMiniCalendar;
var b3xViewLoaded;
var calendarMiniJson = new JSONX();

function cAnimMiniCalendar(actionFunction, oDOMHeader, nodes) {
		this.initDate = new Date(now());
		this.actionFunction = actionFunction;
		this.MiniRefer = null;
		this.selectedDate = this.initDate.getUTCDate();
		this.selectedMonth = this.initDate.getUTCMonth();
		this.selectedYear = this.initDate.getUTCFullYear();
		this.animationInProgress = false;
		this.todayYear = this.selectedYear;
		this.selectedTime = this.initDate.getTime();
		this.selectedId;
		this.header = oDOMHeader;
		this.header0;
		this.nodes = nodes;
		this.enable_action = configGetKey("modules.calendar.module");
		var bDisplayApps = configGetKey("modules.calendar.module");		
		if (!this.enable_action) {
			actionFunction = function () { 
				triggerEvent("Feature_Not_Available", "modules/calendar/mini_calender", window); 
			};
		}
		
		if (this.nodes == undefined) {
			this.nodes = [ $("container_mini"), $("header_mini_month"), $("header_mini_year") ];
		}
		
		this.MiniRefer = new cMiniCalendar(oDOMHeader,
				nodes[0], actionFunction,bDisplayApps,
				'mini_subcontainer_0', nodes[1], nodes[2], this.initDate);
		this.MiniRefer.dnd_enabled = true;
		this.MiniRefer.enable_action = this.enable_action;
		var Self = this;
		
		function fn_KWAction(arg) {
			var DOMTarget = (arg.target) ? arg.target : arg.srcElement;
			var sId = DOMTarget.id, aInf;
			for (var indx in Self.MiniRefer.miniCalendarAssoc) {
				aInf = Self.MiniRefer.miniCalendarAssoc[indx];
				if (aInf[3] == sId.split('_')[1]) {
					break;
				}
			}	
			var nDate = aInf[0];
            var oDate = new Date(Date.UTC(Self.MiniRefer.currentYear,
                                          Self.MiniRefer.currentMonth));
			if (aInf[1] == 0) {
				oDate.setUTCMonth(oDate.getUTCMonth() - 1);
			} else if (aInf[1] == 2) {
				oDate.setUTCMonth(oDate.getUTCMonth() + 1);
			}			
			oDate.setUTCDate(nDate);
				    
		    if (currentpath2[1] !== "team") {
		        activeDay = oDate.getUTCDate();
		        activeMonth = oDate.getUTCMonth();
		        activeYear = oDate.getUTCFullYear();
		        Self.MiniRefer.setSelectedByDate(activeYear, activeMonth, activeDay);
                ox.UIController.setModule({
                    module: "calendar", 
                    folder: "auto", 
                    view: "calendar/calendar/week",
                    force: "module",
                    succes: function() {
                      // notify via event
                      triggerEvent("OX_Mini_Calendar_Date_Picked", oDate.getUTCFullYear(),
                              oDate.getUTCMonth(), oDate.getUTCDate());
                    }
                });
                oDate = nDate = DOMTarget = sId = null;
		    }
		}
		function fn_DBLAction(arg) {
		    Self.MiniRefer.setSelectedByDate(Self.selectedYear, Self.selectedMonth, Self.selectedDate);
			triggerEvent("OX_Before_Create_Calendar");
		}
		// don't implement functions for CW clicks and double clicks; simple clicks are disabled in the constructor
		if (this.enable_action) {
			this.MiniRefer.setfnKWAction(fn_KWAction);
			this.MiniRefer.setfnDBLAction(fn_DBLAction);
		} else {
			this.MiniRefer.setfnKWAction(function() {
			    triggerEvent("Feature_Not_Available", "modules/calendar/mini_calender", window);
			});
		}
}
cAnimMiniCalendar.prototype = {
	destroy: function() {
		this.MiniRefer.destroy();
	},
	
	load: function() {
		this.MiniRefer.load(this.MiniRefer);		
	},
	
	setSelectedByDate: function (year, month, day) {
		this.MiniRefer.setSelectedByDate(year, month, day);
	},
	
	update: function () {
		this.MiniRefer.update();
		this.MiniRefer.setToday();
	},	
	
	setSelected: function(sId) {
		this.MiniRefer.setUnselected();	
		//find calendar where id is defined
		if (this.MiniRefer.miniCalendarAssoc[sId]) {
			this.MiniRefer.setSelected(sId);
			this.selectedDate = this.MiniRefer.selectedDate;
			this.selectedMonth = this.MiniRefer.selectedMonth;
			this.selectedYear  = this.MiniRefer.selectedYear;
			this.selectedTime = Date.UTC(this.MiniRefer.selectedYear,
												this.MiniRefer.selectedMonth,
														this.MiniRefer.selectedDate);		
		}
	},	
	
	checkloaded: function() {		
		return this.MiniRefer.loaded;		
	},
	
	scroll: function(nDirection,cb_fn) {		
		var Self = this;
		var nStart = jQuery(Self.nodes[0]).parent()[0].scrollLeft;
		function do_scroll(nStep) {
			if (nDirection > 0)
				jQuery(Self.nodes[0]).parent()[0].scrollLeft = Math.log(Math.pow(nStep,0.66))*66;
			else
				jQuery(Self.nodes[0]).parent()[0].scrollLeft = nStart - Math.log(Math.pow(nStep,0.66))*66;
		}
		animate((configGetKey("gui.effects.fading") ? 750 : 0), 245, do_scroll,cb_fn);
	},
	
	next: function(num) {
		var Self = this;		
		if (!this.checkloaded() || this.animationInProgress) return;
        var NextDate = new Date(Date.UTC(this.MiniRefer.currentYear,
                                         this.MiniRefer.currentMonth + num));
		Self.MiniRefer.set_header(NextDate);		
		this.MiniRefer.appointmentList = new Array();	
		Self.MiniRefer.currentMonth = NextDate.getUTCMonth();
		Self.MiniRefer.currentYear = NextDate.getUTCFullYear();																
		Self.MiniRefer.oCalendar = new cCalendar(NextDate.getUTCMonth(),NextDate.getUTCFullYear());		
		var oNextTable = this.MiniRefer.getTable(Self.MiniRefer.oCalendar);
		var switchsubContainer = newnode('div',{ left:"239px", position:"absolute" });
		switchsubContainer.appendChild(oNextTable);
		this.nodes[0].appendChild(switchsubContainer);
		this.animationInProgress = true;
		jQuery(this.nodes[0]).parent()[0].scrollLeft = 0;
		this.MiniRefer.subcontainer.style.left = "0px";		
		this.scroll(1, function(){
			Self.nodes[0].removeChild(Self.MiniRefer.subcontainer);
			Self.MiniRefer.subcontainer = switchsubContainer;
			Self.animationInProgress = false;
			if(Self.MiniRefer.displayAppointments)
				Self.MiniRefer.update();						
		});
	},
	
	back: function(num) {
		var Self = this;		
		if (!this.checkloaded() || this.animationInProgress) return;
        var NextDate = new Date(Date.UTC(this.MiniRefer.currentYear,
                                         this.MiniRefer.currentMonth - num));
		Self.MiniRefer.set_header(NextDate);	
		this.MiniRefer.appointmentList = new Array();	
		Self.MiniRefer.currentMonth = NextDate.getUTCMonth();								
		Self.MiniRefer.currentYear = NextDate.getUTCFullYear();																
		Self.MiniRefer.oCalendar = new cCalendar(NextDate.getUTCMonth(),NextDate.getUTCFullYear());		
		var oNextTable = this.MiniRefer.getTable(Self.MiniRefer.oCalendar);
		var switchsubContainer = newnode('div',{ left:"0px", position:"absolute" });
		switchsubContainer.appendChild(oNextTable);
		this.nodes[0].insertBefore(switchsubContainer, this.MiniRefer.subcontainer);
		this.animationInProgress = true;
		this.MiniRefer.subcontainer.style.left = "239px";
		jQuery(this.nodes[0]).parent()[0].scrollLeft = 245;
		this.scroll(-1,function (){
			Self.nodes[0].removeChild(Self.MiniRefer.subcontainer);
				Self.MiniRefer.subcontainer = switchsubContainer;
				Self.animationInProgress = false;
				if(Self.MiniRefer.displayAppointments)
					Self.MiniRefer.update();
			});
	},
	go_to: function(oDate){
		this.MiniRefer.go_to(oDate);
	},
	
	today: function() {
	    
	    if (!this.checkloaded() || this.animationInProgress) return;
        
		// get current date
	    var today = new Date(now());
	    // see Bug 17397 - [L3] 'Today' button in calendar only works for GMT
	    activeDay = today.getUTCDate();
        activeMonth = today.getUTCMonth();
        activeYear = today.getUTCFullYear();
        
        // notify via event
        triggerEvent("OX_Mini_Calendar_Date_Picked", activeYear, activeMonth, activeDay);
        
        if (currentpath2[0] == "calendar") {
        	switch(currentpath2[2]) {
        		case "week":
        		    objWeekCalendarTool.init(activeYear,activeMonth,activeDay);
	                objWeekCalendarTool.setKW();
	                break;
                case "month":
                    loadMonthView();
                    break;
        	}
            triggerEvent("OX_Switch_View", currentpath.join("/"));
            
        } else if (configContainsKey("folder.calendar")) {
	        ox.api.ui.setFolder(configGetKey("folder.calendar"), function () {
	            triggerEvent("OX_Switch_View","calendar/calendar/day"); 
	        });
        }
        this.setSelectedByDate(activeYear, activeMonth, activeDay);
		this.MiniRefer.go_to(today);		
	},
	
	addView: function() {
		this.initDate.setUTCMonth(this.initDate.getUTCMonth() + 1);		
		if(!this.header0)	
		{
			var oHeader0 = newnode('div',0,{id:'DOMHeaderMini0'});	
			this.header0  = oHeader0;
			this.MiniCalWidgets[0].header = oHeader0;			
			this.MiniCalWidgets[0].subcontainer.insertBefore(oHeader0,this.MiniCalWidgets[0].table);
			this.MiniCalWidgets[0].updateHeaderMini();	
			//this.header.innerHTML = this.MiniCalWidgets[0].currentYear;
		}
		var oHeader = newnode('div',0,{id:'DOMHeaderMini' + this.MiniCalWidgets.length});			
		var oMiniCalendarNext = new cMiniCalendar(oHeader,
	 			this.nodes[0], this.actionFunction,true,'mini_subcontainer_'+this.MiniCalWidgets.length,
	 			this.nodes[1],this.nodes[2],this.initDate);
		if (oMiniCalendarNext.table)	 
			oMiniCalendarNext.subcontainer.insertBefore(oHeader
															,oMiniCalendarNext.table);
		else
			oMiniCalendarNext.subcontainer.appendChild(oHeader);
		this.MiniCalWidgets.push(oMiniCalendarNext);
	},
	
	removeView: function() {
		if(this.header0) {
			this.MiniCalWidgets[0].subcontainer.removeChild(this.header0);			
			this.MiniCalWidgets[0].header = this.header;
			this.header0 = null;
			this.MiniCalWidgets[0].updateHeaderMini();				
		}
		this.initDate.setUTCMonth(this.initDate.getUTCMonth() - 1);
		var oMonthView = this.MiniCalWidgets.pop();
		if (oMonthView) {
			oMonthView.subcontainer.removeChild(oMonthView.header);
			oMonthView.destroy();
		}
	}	
}


function comboMonthChanged(param,minical)
{
    minical.go_to(new Date(Date.UTC(minical.currentYear, param)));
}
function comboYearChanged(param,minical)
{
    minical.go_to(new Date(Date.UTC(param, minical.currentMonth)));
}

/**
 * Our current mini-calendar
 * @param {DOMNode} displayPanelContainer Used by cAnimMiniCalendar.removeView,
 * which in turn is not used (anymore). 
 * @param {DOMNode} container The container for the calendar contents.
 * @param {Function} actionFunction A callback function which is called when
 * the user clicks on a day. It should call setSelected(this.id) to process
 * the selection.
 * @param {Boolean} bDisplayAppointments Specifies whether days with
 * appointments should be marked.
 * @param {String} subcontainerid Not used.
 * @param {DOMNode} displayPanelContainerM container of the month selection
 * ComboBox.
 * @param {DOMNode} displayPanelContainerY container of the year selection
 * ComboBox.
 * @param {Date} initDate Specifies a date to display initially.
 * Defaults to the current month.
 * @param {Date} selectedDate The selected date. Defaults to today.
 */
function cMiniCalendar(displayPanelContainer, container, actionFunction,
			bDisplayAppointments, subcontainerid, displayPanelContainerM,
				displayPanelContainerY, initDate, selectedDate) {
	this.enable_action = true;
	this.aMonthNames = [_("January"), _("February"), _("March"), _("April"),
        _("May"), _("June"), _("July"), _("August"), _("September"),
        _("October"), _("November"), _("December")];
	this.container = container;
	this.table;
	this.loaded = false;
	this.dnd_enabled = false;
	this.subcontainerid = subcontainerid || "min_subcontainer_default";
	this.subcontainer = newnode('div', { left:"0px", right:"0px",position:"absolute" });
	jQuery(this.container).parent()[0].scrollLeft = 0;
	this.container.appendChild(this.subcontainer);
	addTMPId(this.subcontainer);
	this.header = displayPanelContainer;
	this.header_month = displayPanelContainerM;
	this.header_year = displayPanelContainerY;	
	this.actionFN = actionFunction;
	this.displayAppointments = bDisplayAppointments;
	// get today (see bug #17397)
	var odat = new Date(now());
	this.todayYear = odat.getUTCFullYear();
	this.todayMonth = odat.getUTCMonth();
	this.todayDate = odat.getUTCDate();
	if (initDate) {
		this.currentMonth = initDate.getUTCMonth();
		this.currentYear = initDate.getUTCFullYear();
	} else {
		this.currentMonth = this.todayMonth;
		this.currentYear = this.todayYear;
	}
	this.selectedDate = (selectedDate)?selectedDate.getUTCDate():this.todayDate;
	this.selectedMonth = (selectedDate)?selectedDate.getUTCMonth():this.todayMonth;
	this.selectedYear = (selectedDate)?selectedDate.getUTCFullYear():this.todayYear;
	this.selectedTime = Date.UTC(this.todayYear,this.todayMonth,this.todayDate);
	this.appointmentList = new Array();	
	this.selectedID;
	this.miniCalendarAssoc = new Object();
	this.load(this);
	this.oCalendar;
	this.oComboMonth;
	this.oComboYear;	
	this.fnKWAction = null;
	this.actionDBLFN = null;
	
	this.open_in_calendar = newnode("img", { verticalAlign:"middle" }, 
			{ src:getFullImgSrc("img/toolbar/calnder.png"), 
			  alt: _("Show in Calendar"), title: _("Show in Calendar")});
	register("LanguageChanged",(function(Self) {
		return function() {
			Self.open_in_calendar.title = _("Show in Calendar");
			Self.open_in_calendar.alt = _("Show in Calendar");
		}
	})(this));
}	

cMiniCalendar.prototype = {
	/**
	 * Specifies a callback for the double-click on a day.
	 */
    setfnDBLAction: function (fn) {
		this.actionDBLFN = fn;
	},
	
	/**
	 * Specifies a callback for the click on a week number.
	 */
	setfnKWAction: function(fn) {
		this.fnKWAction = fn;
	},
	
	setDate: function (year, month, date) { },
	
	destroy: function() {	
		this.selectedID = undefined;	
		this.subcontainer.removeChild(this.table);
		removeTMPId(this.subcontainer.id+"_table");
		for (var i=0; $2(this.subcontainer.id+"mc_"+i+"_0"); i++) {
			for (var i2=0; $2(this.subcontainer.id+"mc_"+i+"_"+i2); i2++) {
				removeTMPId(this.subcontainer.id+"mc_"+i+"_"+i2);
			}
		}	
		for (var i=0; i<54; i++) {
			if ($2("kw_month_"+i)) {
				removeTMPId("kw_month_"+i);
			}
		}
		//TODO REMOVE FROM TMPIDS
		this.loaded = false;
	},
	
	/**
	 * Jumps to the next month.
     * Does not change the selection.
	 */
	next: function(num) {
		if(num == undefined) num = 1;
		if(!this.loaded) return;
		this.destroy();
		var oDateLoc = new Date(Date.UTC(this.currentYear,
		                                 this.currentMonth + num));
		this.oComboYear.setDynamicKey(oDateLoc.getUTCFullYear());		
		this.oComboMonth.setKey(oDateLoc.getUTCMonth());

		this.currentMonth = oDateLoc.getUTCMonth();
		this.currentYear = oDateLoc.getUTCFullYear();		
		this.load(this);
	},
	
    /**
     * Jumps to the previous month.
     * Does not change the selection.
     */
	back: function(num) {
		if(num == undefined) num = 1;
		if(!this.loaded) return;
		this.destroy();
		var oDateLoc = new Date(Date.UTC(this.currentYear,
		                                 this.currentMonth - num));
		this.oComboYear.setDynamicKey(oDateLoc.getUTCFullYear());
		this.oComboMonth.setKey(oDateLoc.getUTCMonth());
		
		this.currentMonth = oDateLoc.getUTCMonth();
		this.currentYear = oDateLoc.getUTCFullYear();		
		this.load(this);
	},
	
    /**
     * Jumps to the specified month.
     * Does not change the selection.
     */
	go_to: function(oDateLoc) {
		if (!this.loaded) return;
		this.destroy();
		this.set_header(oDateLoc);
		this.currentMonth = oDateLoc.getUTCMonth();
		this.currentYear = oDateLoc.getUTCFullYear();		
		this.load(this);
	},
	
	set_header: function(oDateLoc){
		unregister('OX_Select_MiniMonth',comboMonthChanged);
		unregister('OX_Select_MiniYear',comboYearChanged);
		this.oComboYear.setDynamicKey(oDateLoc.getUTCFullYear());
		this.oComboMonth.setKey(oDateLoc.getUTCMonth());		
		register('OX_Select_MiniMonth',comboMonthChanged);
		register('OX_Select_MiniYear',comboYearChanged);		
	},
	
	load: function(obj) {
		this.oCalendar = new cCalendar(this.currentMonth,this.currentYear);
		if (this.header_month && !this.oComboMonth && !this.oComboYear) {
			this.oComboMonth = new ComboBoxSpecial(
			    window, this.header_month, '7em', this.todayMonth, 
			    false, 'OX_Select_MiniMonth', 6, this
			);
			this.oComboYear = new ComboBoxSpecial(
			    window, this.header_year, '3em', 3, 
				false, 'OX_Select_MiniYear', 6, this
			);
			this.oComboYear.optWidth = "4em";
			this.oComboYear.show_buttons = true;
			for (var nKeyIndx=-3; nKeyIndx < 3; nKeyIndx++){
				this.oComboYear.addElement(noI18n(this.todayYear+nKeyIndx),
				                           this.todayYear+nKeyIndx);
			}
			for (var nKeyIndx=0;nKeyIndx<this.aMonthNames.length;nKeyIndx++) {
				this.oComboMonth.addElement(this.aMonthNames[nKeyIndx], nKeyIndx);
			}
			this.oComboYear.getDomNode();
			this.oComboMonth.getDomNode();
			register('OX_Select_MiniMonth', comboMonthChanged);
			register('OX_Select_MiniYear', comboYearChanged);			
		}
        var oFirstDayDate = new Date(Date.UTC(this.currentYear,
                                              this.currentMonth));
        var oLastDayDate = new Date(Date.UTC(this.currentYear,
                                             this.currentMonth));

		var aDay = this.oCalendar.aWeeks[0].aDays[0];
		var aDay2 = this.oCalendar.aWeeks[(this.oCalendar.aWeeks.length-1)].aDays[6];		

		if (aDay.nCurrMonth == 0) {
			oFirstDayDate.setUTCMonth(oFirstDayDate.getUTCMonth()-1);
		}
		if (aDay2.nCurrMonth == 2) {
			oLastDayDate.setUTCMonth(oLastDayDate.getUTCMonth()+1);
		}
			
		oFirstDayDate.setUTCDate(aDay.nDate);
		oLastDayDate.setUTCDate(aDay2.nDate);

		oLastDayDate.setUTCDate(oLastDayDate.getUTCDate()+1);
		
		if (!this.displayAppointments){
			this.create();
		} else {
			function cb_fkt_mc(cbobjCalendar)  {						
				if (cbobjCalendar && cbobjCalendar.data) {
					obj.appointmentList = cbobjCalendar.data;					
				} else if(cbobjCalendar && cbobjCalendar.error) {
					newServerError(cbobjCalendar,4);
				}
				obj.create();
			}
			this.getCalObjMC(oFirstDayDate,oLastDayDate,cb_fkt_mc);					
		}
	},
	
	getCalObjMC: function(oFirstDayDate,oLastDayDate,callback) {
		var start = oFirstDayDate.getTime();
		var end = oLastDayDate.getTime();		
		var sAjaxRequest = AjaxRoot + "/calendar?action=has&session=" + session +"&start=" + start + "&end=" + end;
		calendarMiniJson.get(sAjaxRequest, null, callback);
	},	
	
    /**
     * Updates the markings of days with appointments, if
     * the bDisplayAppointments parameter to the constructor was true.
     */
	update: function() {
		//TODO
        var oFirstDayDate = new Date(Date.UTC(this.currentYear,
                                              this.currentMonth));
        var oLastDayDate = new Date(Date.UTC(this.currentYear,
                                             this.currentMonth));		
		this.loaded = false;

		var aDay = this.oCalendar.aWeeks[0].aDays[0];
		var aDay2 = this.oCalendar.aWeeks[(this.oCalendar.aWeeks.length-1)].aDays[6];		
		
		if(aDay.nCurrMonth == 0)
			oFirstDayDate.setUTCMonth(oFirstDayDate.getUTCMonth()-1);
		if(aDay2.nCurrMonth == 2)
			oLastDayDate.setUTCMonth(oLastDayDate.getUTCMonth()+1);
			
		oFirstDayDate.setUTCDate(aDay.nDate);
		oLastDayDate.setUTCDate(aDay2.nDate);
		oLastDayDate.setUTCDate(oLastDayDate.getUTCDate()+1);		
		var Self = this;
		function fn_refreshCurrentMiniCal(cbobjCalendar) {
			if (cbobjCalendar && cbobjCalendar.data) {
				Self.appointmentList = cbobjCalendar.data;					
			} else if(cbobjCalendar && cbobjCalendar.error) {
				newServerError(cbobjCalendar);
			}
			Self.refreshView();
		}
		if (this.displayAppointments) {
			this.getCalObjMC(oFirstDayDate,oLastDayDate,fn_refreshCurrentMiniCal);
		}
	},	
	
	refreshView: function() {		
		var nAllDaysCount=0;
		//loop weeks
		for (var indexWeek=0; indexWeek<this.oCalendar.aWeeks.length; indexWeek++){
				var currentWeek = this.oCalendar.aWeeks[indexWeek];
				//loop days
				for (var indexDay=0; indexDay<7; indexDay++) {
					var bAppExist = false;
					if (this.displayAppointments) {
						bAppExist = this.appointmentList[nAllDaysCount];
					}
					var oTD = $2(this.subcontainer.id + 'mc_' + indexWeek + '_' + indexDay);
					oTD.className = removeClass(oTD.className,"font-style-lable");
	 				if(bAppExist) {
	 					oTD.className += " font-style-lable";		 			
	 				}
	 				nAllDaysCount++;
				}
				this.loaded = true;
		}	
	},	
	
	create: function() {
		var oCalminiMain = this.subcontainer;
		oCalminiMain.appendChild(this.getTable());
		this.updateHeaderMini();
	},
	
	getTable: function(oCalObj){
		var Self = this;
		var nAllDaysCount = 0;
		var oTable = newnode("table", {}, { 
			className: "CalMiniMainTable1", 
				cellPadding: 0, cellSpacing: 0, border: 0 });
		this.table = oTable;
		var oTableBody = newnode('tbody');	// IE specific
		var oTRHead = newnode('tr');
		var weekDays = [pgettext("monday", "M"), pgettext("tuesday", "T"),
                        pgettext("wednesday", "W"), pgettext("thursday", "T"),
                        pgettext("friday", "F"), pgettext("saturday", "S"),
                        pgettext("sunday", "S")];
        
		var _nTd = newnode('td', { height:"2em", padding:"0px" });
		oTRHead.appendChild(_nTd);
        if (this.fnKWAction && this.enable_action === true) {
            _nTd.className = "cursorPointer";
            _nTd.appendChild(Self.open_in_calendar);
            _nTd.onclick = function(e) {
                activeDay=1;
	            activeMonth=Self.currentMonth;
	            activeYear=Self.currentYear;
	            Self.setSelectedByDate(activeYear, activeMonth, activeDay);
                ox.UIController.setModule({module: "calendar", folder:"auto", view:"calendar/calendar/week",force: "module"});
            };
        }
        
        for (var i=0; i<weekDays.length; i++) {
            var HeadTD = newnode('td', { height:"2em", padding:"0px" }, 0,
                [addTranslated(weekDays[i])]);
			oTRHead.appendChild(HeadTD);
		}
		oTRHead.className = "miniCalendarTRHead dateCalendarFontSize background-color-additional-content font-style-headline";
		oTableBody.appendChild(oTRHead);
		var locCalObj = (oCalObj != undefined) ? oCalObj : this.oCalendar;
		//loop weeks
		for (var indexWeek=0; indexWeek<locCalObj.aWeeks.length; indexWeek++) {
				var oTR = newnode('tr', { border:"0" });
				var currentWeek = locCalObj.aWeeks[indexWeek];
				var oKWTD = newnode('td', 0, { height:"1.5em", padding:"0px", verticalAlign:"middle",
								className:"miniCalendarTDKW background-color-additional-content font-size-footer border-color-default",
								id:'kw_'+currentWeek.nKW });			
				var KWTDText = document.createTextNode(currentWeek.nKW);							
				oKWTD.appendChild(KWTDText);
				if (!this.enable_action || !this.fnKWAction) {
 					oKWTD.className += " cursorReset";		 			
 				}
				
				if (this.fnKWAction != null) {	
					addDOMEvent(oKWTD, "click", this.fnKWAction);
					
				}
				oTR.appendChild(oKWTD);
				addTMPId(oKWTD);
				//loop days
				for (var indexDay=0; indexDay<7; indexDay++) {
					var bAppExist = false;
					if(this.displayAppointments) {
						var bAppExist = this.appointmentList[nAllDaysCount];
					}
					var oTD = newnode('td', { height:"1.5em", padding:"0px" });
					sID = this.subcontainer.id+'mc_' + indexWeek + '_' + indexDay;				
	 				var cDay = currentWeek.aDays[indexDay];	
					var TDText = document.createTextNode(cDay.nDate);			
	 				oTD.appendChild(TDText);
	 				//save id, date  & appointments info in assoc array
					this.miniCalendarAssoc[sID] = new Array(cDay.nDate, cDay.nCurrMonth, bAppExist, currentWeek.nKW);
	 				if (cDay.nCurrMonth==0 || cDay.nCurrMonth==2) {
						oTD.className = "miniCalendarTDNotCurr dateCalendarFontSize font-color-disabled";
	 				} else {
						oTD.className = "miniCalendarTD dateCalendarFontSize";
	 				}
	 				if (bAppExist) {
	 					oTD.className += " font-style-lable";		 			
	 				}
	 				if (!this.enable_action) {
	 					oTD.className += " cursorReset";		 			
	 				}
	 				
                    var t = Date.UTC(this.currentYear,
                        this.currentMonth + cDay.nCurrMonth - 1, cDay.nDate);
                    
					if (t === Date.UTC(this.todayYear, this.todayMonth,
					                   this.todayDate))
					{
		 				oTD.className += " miniCalendarToday todaySelectionBorder";
		 			
		 			}
					if (t === Date.UTC(this.selectedYear, this.selectedMonth,
					                   this.selectedDate))										
	 				{
	 					oTD.className += ' background-color-PMG-selection-elements';
 						this.selectedID = sID;
	 				}	 				
					oTD.id = sID;
					if (this.actionDBLFN != null) {
						oTD.onselectstart = function() { return false; };
						oTD.style.MozUserSelect = "none";
						oTD.ondblclick = this.actionDBLFN;
					}

					oTD.onclick = this.actionFN;
								
					oTR.appendChild(oTD);
					addTMPId(oTD);
					function fnOver(node) {
						return function(e, dragType, draggedObjects, mouseposition, targetNode) {
							    minicalenable(e,dragType,draggedObjects,mouseposition,targetNode,node);
                                var mynode = e.currentTarget || e.srcElement || false;
								mynode.className += " dndOver";
							};
					}
					function clearOpenNOdeOver(e, dragType, draggedObjects, mouseposition, OutOpen, dropNode) {
						if (dropNode) {
							dropNode.className = removeClass(dropNode.className,'dndOver');
						} else if(e) {
							var mynode = e.currentTarget || e.srcElement || false;
							if (mynode) { 
								mynode.className = removeClass(mynode.className,'dndOver'); 
							}
						}
					}
					if (this.dnd_enabled) {
						var tObj = new Object();
						tObj["mail"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
								clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
								openMailToApp(Self.getDateByID(dropNode.id),draggedObjects.currentObjects,"mail");
						};
						tObj["contacts"] = function (event, dragType, draggedObjects, mouseposition, targetNode, dropNode) {
								clearOpenNOdeOver(event, dragType, draggedObjects, mouseposition, null, dropNode);
								if (draggedObjects && draggedObjects.currentObjects) {
								    OXCache.newRequest(null,"contacts", {
							            objects: draggedObjects.currentObjects,
							            columns: ["folder_id", "id", "display_name", "first_name", "last_name","email1","email2"]
							        }, null, function (daten) {
							            if (!daten || !daten.objects) {
							                return false;
							            }
							            var found = false;
							            for (var i=0; i < daten.objects.length; i++) {
							                var obj = daten.objects[i];
							                if (obj["email1"] || obj["email2"]) {
							                    found = true;
							                    break;
							                }
							                obj = null;
							            }
							            if (found === true) {
							                openMailToApp(Self.getDateByID(dropNode.id), daten.objects, "contacts");
							            }
							        });
							    }
						};
						tObj["calendar"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
							clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
							var collection={};     
							collection.columns = null;
				            collection.objects = [];
				            for (var i in draggedObjects.currentObjects) {
				            	var myObj = draggedObjects.currentObjects[i];
				            	collection.objects.push(
				            			OXCalendarMapping.createKeyFromObject(
					                      { module: "calendar", 
					                        folder_id: myObj.folder || myObj.folder_id, 
					                        id: myObj.id,
					                        recurrence_position: myObj.recurrence_position || 0 }
					                  )
				            	);
				            }
				            OXCache.newRequest(null, "calendar", collection, null,
				                function(daten) {
				                    for (var j in daten.objects) {
				                    	
				                    	var oDate = Self.getDateByID(dropNode.id);
				                    	var myObj = daten.objects[j];
				                    	myObj.start_date = new Date(myObj.start_date);
										myObj.end_date = new Date(myObj.end_date);
										oDate.setUTCHours(myObj.start_date.getUTCHours());
										oDate.setUTCMinutes(myObj.start_date.getUTCMinutes());
										var changes=oDate.getTime()-myObj.start_date.getTime();
										var oDateEnd=new Date(myObj.end_date.getTime()+changes);
										moveAppToNewStart(myObj, oDate, oDateEnd, function () { Self.update(); });
				                    }	
				                },
				                true
				            );
						};
						registerTarget(oTD, tObj,null,null,fnOver(oTD),fnOver(oTD),clearOpenNOdeOver,true);
					}
					nAllDaysCount++;
				}
				oTableBody.appendChild(oTR);
				this.loaded = true;
		}
		//display 6 rows in any case
		for(var indexWeek=0; indexWeek< 6; indexWeek++) {
			var oTR = newnode('tr');
			var oTD = newnode('td', { height:"1.5em", padding:"0px" }, { colspan:"8", className:"miniCalendarTDNotCurr dateCalendarFontSize font-color-disabled minicalendar6thline"});			
			oTD.innerHTML = '&#xa0;';
			oTR.appendChild(oTD);
			oTableBody.appendChild(oTR);
		}
		oTable.appendChild(oTableBody);		
		addTMPId(oTable);		
		return oTable;
	},
	
	/**
	 * Selects the specified day, switching to the appropriate month view if
	 * necessary.
	 * @param {Number} year The year of the day to select.
	 * @param {Number} month The month of the day to select.
	 * @param {Number} day The date of the day to select.
	 */
	setSelectedByDate: function(year, month, day) {
		this.selectedDate = day;
		this.selectedMonth = month;		
		this.selectedYear = year;
		this.selectedTime = Date.UTC(year,month,day);
		this.setUnselected(this.selectedID);
		if (this.selectedYear == this.currentYear && this.selectedMonth == this.currentMonth) {
			for (var sId in this.miniCalendarAssoc) {					
				var nCurrMonthFlag = this.miniCalendarAssoc[sId][1];
				var nDay = this.miniCalendarAssoc[sId][0];
                var t = Date.UTC(this.currentYear,
                    this.currentMonth + nCurrMonthFlag - 1, nDay);
                
                if (t === Date.UTC(this.selectedYear, this.selectedMonth,
                                   this.selectedDate))
				{
					this.selectedID = sId;
					var markTDSelected = $2(sId);
					if(markTDSelected != undefined)
						markTDSelected.className += " background-color-PMG-selection-elements";
					break;
				}
			}
		} else {
			this.go_to(new Date(Date.UTC(this.selectedYear,
			                             this.selectedMonth)));
		}
	},
	
	/**
	 * Updates the today marking.
	 * Just in case the user was logged in past midnight...
	 */
	setToday: function() {
		var todayDate = new Date(now());
		this.todayDate = todayDate.getUTCDate();
		this.todayMonth = todayDate.getUTCMonth();	
		this.todayYear = todayDate.getUTCFullYear();
		for(var sId in this.miniCalendarAssoc)
		{
			//deselect today selection
			var currDayDate = $2(sId);
			/*
			 * should not happen. however, results in some strange errors if not
			 * set and prevent executing updates within the calender views so we
			 * better check this.
			 */
			if (!currDayDate) {
				return;
			}
			currDayDate.className = removeClass(currDayDate.className,"todaySelectionBorder");
			currDayDate.className = removeClass(currDayDate.className,"miniCalendarToday");			
			
			var nCurrMonthFlag = this.miniCalendarAssoc[sId][1];
			var nDay = this.miniCalendarAssoc[sId][0];
            var t = Date.UTC(this.currentYear,
                this.currentMonth + nCurrMonthFlag - 1, nDay);
            
            if (t === Date.UTC(this.todayYear, this.todayMonth, this.todayDate))
			{
				currDayDate.className += " miniCalendarToday todaySelectionBorder";	
 			} 				 			
		}
	},	
	/**
	 * Selects a day by its internal DOM node ID.
	 * Used by the actionFunction constructor parameter to actually process
	 * the selection.
	 */
	setSelected: function (sId) {
		//deselect
		if (this.selectedID) {
		    this.setUnselected();
		}
		
		//select
		this.selectedID = sId;
        var back = this.miniCalendarAssoc[sId][1];
        var oDateOthMonth = new Date(Date.UTC(this.currentYear,
            this.currentMonth + back - 1, this.miniCalendarAssoc[sId][0]));
        this.selectedMonth = oDateOthMonth.getUTCMonth();
        this.selectedYear = oDateOthMonth.getUTCFullYear();
        this.selectedDate = oDateOthMonth.getUTCDate();
        this.selectedTime = oDateOthMonth.getTime();
		
		jQuery("#" + this.selectedID, this.subcontainer).addClass("background-color-PMG-selection-elements");
		
		if (back==0) {
		    this.back();
		} else if (back==2) {
		    this.next();
		}
	},
	
	/**
	 * Returns the date of the day with the specified internal DOM node ID.
	 * @protected
	 * @param {String} sId The internal DOM node ID of the day.
	 * @type Date
	 * @return A Date object with the date of the specified day and
	 * with the current time of day.
	 */
	getDateByID : function (sId)
	{
        return new Date(Date.UTC(this.currentYear,
            this.currentMonth + this.miniCalendarAssoc[sId][1] - 1,
            this.miniCalendarAssoc[sId][0]));
	},
	/**
	 * Hides the selection temporarily.
	 */
    // Bug: Navigation calls like next/back show the selection again.
	setUnselected: function ()
	{
		var oTD = $2(this.selectedID);
		if(!oTD) return;
		sClassName = oTD.className;
		var aSplited = sClassName.split(' ');
		var sDeseletedClassName = '';
		for(var nInd=0;nInd < aSplited.length;nInd++)
		{
			if(aSplited[nInd].length>0 && aSplited[nInd] != "background-color-PMG-selection-elements")
			{
				sDeseletedClassName += ' '+aSplited[nInd];
			}
		}			
		oTD.className = sDeseletedClassName;
	},
	
	updateHeaderMini: function ()
	{
		//var showHeader = _(this.aMonthNames[this.currentMonth]) + ' ' + this.currentYear;
		//this.header.innerHTML = showHeader;	
	}	
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

registerView("configuration/folder",
        function() { 
            showNode("folder_props");  
            jQuery("#folder_props").show();
            jQuery("#folder_tree").show();
        },
        function() {    
          register("OX_SAVE_OBJECT",cf_saveConfiguration);
          register("OX_Cancel_Object",cf_cancelConfiguration);      
          register("OX_Configuration_Delete_Folder",deleteFolderConfig);            
          
        },
        function() {
            unLoadFolderProps();
             unregister("OX_SAVE_OBJECT",cf_saveConfiguration);
            unregister("OX_Cancel_Object",cf_cancelConfiguration);
             unregister("OX_Configuration_Delete_Folder",deleteFolderConfig);            
            
        },
        function() { 
            hideNode("folder_props");  
            jQuery("#folder_props").hide(); 
            
            // hack to disable origin folder tree if we stay at the config
            if (currentpath2.join("/").match(/^configuration/)) {
                jQuery("#config_folder_tree").show();
                jQuery("#configComplete").show();
                jQuery("#folder_tree").hide();
            }
        },
        function() { }
    );

registerView("configuration/folder/overview",
        function() {
            $("tab_props1").style.display="block";
            $("panel_props1").className="tabPanelFirstHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";

            // toolbar
            if (!configToolbars.folderOverview) {
                configToolbars.folderOverview =
                    temporary.configuration.newToolbar(
                        _("Folder"), [
                            {
                                title: _("Save"),
                                id: "save",
                                buttons: [{
                                    title: _("Save"),
                                    id: "save",
                                    icons: ["img/menu/btn_save.gif"],
                                    big: true,
                                    event: "OX_SAVE_OBJECT"
                                }]
                            },
                            {
                                title: _("Folder"),
                                id: "folder",
                                buttons: [{
                                    title: _("Move"),
                                    id: "move",
                                    icons: ["img/menu/move_folder.gif",
                                            "img/menu/userrights_d.gif"],
                                    event: "OX_Configuration_Move_Folder"
                                }, {
                                    title: _("Delete"),
                                    id: "delete",
                                    icons: ["img/menu/delete_folder.gif",
                                            "img/menu/delete_folder_d.gif"],
                                    event: "OX_Configuration_Delete_Folder"
                                }]
                            }
                        ], "folder");
            }
            temporary.configuration.showToolbar(configToolbars.folderOverview);
        },
        function() { },
        null,
        function() {
            $("tab_props1").style.isplay="none";
            $("panel_props1").className="tabPanelFirst tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";
        },
        function() { }
    );

function cf_saveConfiguration() {
    triggerEvent("OX_Save_Configuration",false,false,null,null);
}

var oPermissionsLiveGrid = null;
var permStorage;

registerView(
    "configuration/folder/rights",
    function () {
        
        $("tab_props2").style.display="block";
        $("panel_props2").className="tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default";
        
        listUserMappingArray = [];

        temporary.configuration.showToolbar(configToolbars.folderPermissions);
        
        //Create Live Grid Here
        if (oPermissionsLiveGrid == null) {
            oPermissionsLiveGrid = new LiveGrid([ {
                index: 1,            
                text: "",
                i18n: true,
                width: "16px",
                style: {padding: 0},
                //using in infostore defined functions here
                set: function  (div, text) {
                    var sImgStr = (text.groupflag)?getFullImgSrc("img/calendar/group.gif"):getFullImgSrc("img/calendar/user.gif");
                    var sAlt = (text.groupflag)?"Group":"User";
                    if(div.firstChild.src)
                        div.firstChild.src = sImgStr;
                    else{
                        removeChildNodes(div);
                        div.appendChild(newnode("img", 0, {src:sImgStr, alt: sAlt}));
                    }
                },                
                clear: LiveGrid.makeClear("...")
            }, {
                index: 1,            
                text: "User", /*i18n*/
                i18n: true,
                //using in infostore defined functions here
                set: function  (div, text) {
                    jQuery(div).empty().text("...");
                    getDisplayName(text.groupflag, parseInt(text.id), div);
                },                
                clear: LiveGrid.makeClear("...")
            }, {
                index: 2,                
                text: "Folder admin", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                    removeChildNodes(div);
                    var sDisplayString =  (text == 1)?_("Yes"):_("No");            
                    div.appendChild(document.createTextNode(sDisplayString));        
                },            
                clear: LiveGrid.makeClear("...")
            }, {
                index: 3,    
                text: "Admin", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                    removeChildNodes(div);
                    var sDisplayString = expectI18n(text);
                    div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")
            }, {
                index: 4,    
                text: "Read objects", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                removeChildNodes(div);
                var sDisplayString = expectI18n(text);
                div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")
            }, {
                index: 5,                    
                text: "Modify objects", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                removeChildNodes(div);
                var sDisplayString = expectI18n(text);
                div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")
            }, {
                index: 6,                    
                text: "Delete objects", /*i18n*/
                i18n: true,                
                width: "15%",
                set: function  (div, text){
                removeChildNodes(div);
                var sDisplayString = expectI18n(text);
                div.appendChild(document.createTextNode(sDisplayString));    
                },
                clear: LiveGrid.makeClear("...")                
            }], new Selection());
            
            oPermissionsLiveGrid.emptylivegridtext = "";
            oPermissionsLiveGrid.events.register("Selected", fireSelected);
            $("userRightsHeadContainer").appendChild(oPermissionsLiveGrid.getHeader());
            oPermissionsLiveGrid.getTable($("userRightsTableContainer"));
        }
        permGridEnable();
        fireSelected(0);
        var haveadminrights, lastconfigfolder, privatefolder, lastEntity;
        function fireSelected(count) {
            editEntity = count != 1 ? '' :
                oPermissionsLiveGrid.selection.getSelected()[0];
            if (haveadminrights === undefined || lastconfigfolder != configfolder) {
                ox.api.folder.get({
                    folder: configfolder,
                    success: function (oFolder) {
                        haveadminrights = configparentfolder === -1 && 
                            ox.api.folder.can("changepermissions", oFolder); // admin flag
                        privatefolder = configfolder === 1 || oFolder.type === 1; 
                        handleSelection(count);
                    }
                });
                lastconfigfolder = configfolder;
            } else {
                handleSelection(count);
            }
        }
        function handleSelection (count) {
            var enabled = Boolean(count == 1 && haveadminrights);
            var bits = enabled ? aGlobalPermissions[editEntity].bitmask : 0;
            
            // get sections
            var main = ox.widgets.toolBar.tabs.permissionsMain.getChildren();
            // update section "main"
            updateSection(main[0], haveadminrights, (bits >> 28) & 1, []); // folder admin
            
            ox.api.folder.exists({
                folder: "6",
                success: function (GAL) {
                    // update "add button". Right now it doesn't make sense to allow it if GAL isn't enabled
                    ox.widgets.toolBar.menuItems["permissions-save-add"].setEnabled(GAL);
                    // update "remove button"
                    ox.widgets.toolBar.menuItems["permissions-save-remove"].setEnabled(count > 0 && enabled);
                }
            });
            
            var folders = ox.widgets.toolBar.tabs.permissionsForFolders.getChildren();
            var objects = ox.widgets.toolBar.tabs.permissionsForObjects.getChildren();
            // update section "admin"
            updateSection(folders[0], enabled && !privatefolder, (bits >> 28) & 1, [1, 0]); // folder admin
            // update section "folder permissions"
            updateSection(folders[1], enabled, bits, [0, 1, 2, 4, 64]); // admin
            // update section "read permissions"
            updateSection(objects[0], enabled, bits >> 7, [0, 1, 2, 64]); // read
            // update section "modify permissions"
            updateSection(objects[1], enabled, bits >> 14, [0, 1, 2, 64]); // write
            // update section "delete permissions"
            updateSection(objects[2], enabled, bits >> 21, [0, 1, 2, 64]); // delete
            // validate
            configToolbars.folderPermissions.validate();
            // show default tab
            if (editEntity !== lastEntity) {
                configToolbars.folderPermissions.setPosition(2);
                lastEntity = editEntity;
            }
        }
        function updateSection (section, enabled, value, values) {
            value &= 127;
            var items = section.getChildren();
            for (var i = 0; i < items.length; i++) {
                items[i].setEnabled(enabled);
                items[i].setChecked(enabled && value == values[i]);
            }
        }
    },
    function() {
        //TODO set Private flag and admin flag      
    },
    function() {
        //TODO set Private flag and admin flag  
        triggerEvent('Selected',0);
    },
    function() {
        oPermissionsLiveGrid.disable();
        $("tab_props2").style.display="none";
        $("panel_props2").className="tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default";
    },
    function() { }
);

function permGridEnable() {
    if(permStorage != null) {
        oPermissionsLiveGrid.enable(permStorage);
        return;
    }
    var aData = new Array();
    for (var indx in  aViewObjects) {
        var aSubData = new Array();
        var oEachObj = aViewObjects[indx];
        aSubData.push(oEachObj.entity + '_' + ((oEachObj.groupflag)?1:0));
        aSubData.push({id:oEachObj.entity,groupflag:oEachObj.groupflag});        
        aSubData.push(oEachObj.admin);
        aSubData.push(oEachObj.fr);
        aSubData.push(oEachObj.rr);
        aSubData.push(oEachObj.wr);        
        aSubData.push(oEachObj.dr);                
        aData.push(aSubData);
    }
    updateGrid(aData);
}

function updateGrid(aData) {
    permStorage = new Storage(0, [],null,null,null,null, 
       function (x) {
            return x[0];
       });    
    permStorage.append(aData);    
    oPermissionsLiveGrid.enable(permStorage);    
}

function avoidSubmitOnEnter(event) {
    registerFolderChange('title');
    if(event && event.keyCode == 13)
    {
        return false;
    }
}

function cf_cancelConfiguration() {
    configuration_changed_fields["folder"] = false;
}

register("OX_Configuration_Switch_Folder_View", function(param) { menuswitchConfigurationFolderView(param); });

var fdpropsTabsList = new Array('tab_props1','tab_props2');
var fdpropsPanelsList = new Array('panel_props1','panel_props2', 'panel_props3');
var fdpropsEventList = new Array( ['OX_Configuration_Switch_Folder_View','overview'],
                                      ['OX_Configuration_Switch_Folder_View','rights']
                                );
var bNew ;
var bParticipantsLoaded = false;
var bTableCreated = false;
var bValuesInit = false;
var bValuesLoaded = false;
var editEntity = '';

/////////////////////////////////////////////
// search and add users    
var participantObjects;
var selectedParticipants = new Array();
var oPartDialog = null;

function openAddUserDiv(oFolder) {    
    var bDisableGroup = true;
    if(oFolder.module == "mail")
        bDisableGroup = -1;
    if (!oPartDialog) {
        oPartDialog = new ParticipantsSmall(null,addToSelectedUser,true,true,false,false,_("Select Users"), /*i18n*/
                    null,true,false,true);
    }
    oPartDialog.openAddParticipantsWindow();
}    

function participantObj(objFromServer) {
    this.id = objFromServer.id;
    this.display_name = objFromServer.display_name;
    this.type = objFromServer.type;
    this.email = objFromServer.email;
}

var aChangedAttributes = new Object();
function registerFolderChange(sAttribute) {
    aChangedAttributes[sAttribute] = true;
    configuration_changed_fields["folder"]=true;
}

function addToSelectedUser(arg) {
    commitAddUser(arg);
    registerFolderChange("user");
    // if possible, select the last user in the grid (US5761)
    if (oPermissionsLiveGrid) {
        // get number of users (-1)
        var usr_length = (oPermissionsLiveGrid.storage.ids.length || 1) - 1;
        // manually set focus (not sure if required)
        oPermissionsLiveGrid.focus = usr_length;
        // trigger click in grid
        oPermissionsLiveGrid.selection.click(usr_length);
    }
}

function commitAddUser(selectedParticipants) {
    var aPermissionArrayForeign = new Array();
    var aPermissionArraySelf = new Array();    
        
    for (var nIndex = 0;nIndex<selectedParticipants.length;nIndex++) {
        if(selectedParticipants[nIndex].type == 2) {
            var bGroupFlag = true;        
        } else {
            var bGroupFlag = false;
        }
        if (selectedParticipants[nIndex].id == configGetKey("identifier")) {
                    aPermissionArraySelf[0] = {group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                            Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                    
                                           entity:configGetKey("identifier")};
        } else {
            aPermissionArrayForeign.push({group:bGroupFlag,bits:Math.pow(2,0)+Math.pow(2,8)+
                            Math.pow(2,15) + Math.pow(2,22),
                                            entity:selectedParticipants[nIndex].id});
        }
    }
    var aPermissionArray = aPermissionArraySelf.concat(aPermissionArrayForeign);
    selectedParticipants = new Array();
    var aViewObjects = permissionsToViewObjects(aPermissionArray);
    var aData = new Array();
    for (var indx in  aViewObjects) {
        var aSubData = new Array();
        var oEachObj = aViewObjects[indx];
        aSubData.push(oEachObj.entity + '_' + ((oEachObj.groupflag)?1:0));
        aSubData.push({id:oEachObj.entity,groupflag:oEachObj.groupflag});
        aSubData.push(oEachObj.admin);
        aSubData.push(oEachObj.fr);
        aSubData.push(oEachObj.rr);
        aSubData.push(oEachObj.wr);
        aSubData.push(oEachObj.dr);
        aData.push(aSubData);
    }
    //avoid duplicated entries here
    var aFinalArr = new Array();
    for (var indxUser=0;indxUser<aData.length;indxUser++) {
        if(permStorage.data.data[aData[indxUser][0]] == undefined) {
            aFinalArr.push(aData[indxUser]);
        }
    }
    permStorage.append(aFinalArr);
    oPermissionsLiveGrid.enable(permStorage);

}

function removeFolderUser() {        
    registerFolderChange("user");
    var aIdToDel = oPermissionsLiveGrid.selection.getSelected();
    oPermissionsLiveGrid.deleteIDs(aIdToDel);
    //fixed bug #10380
    oPermissionsLiveGrid.selection.reset();
    oPermissionsLiveGrid.focus=undefined;
    oPermissionsLiveGrid.updateStyles();
    for (var indx=0;indx<aIdToDel.length;indx++) {
        delete aGlobalPermissions[aIdToDel[indx]];
    }
}

function unLoadFolderProps() {
    editEntity = '';
    unregister("OX_Configuration_Remove_User",removeFolderUser);
    unregister("OX_Configuration_Add_User",openAddUserDiv);
    $('inFolderName').value = '';
    configuration_changed_fields["folder"] = false;
    bParticipantsLoaded = false;
    aChangedAttributes = new Object();
    bTableCreated = false;
    bValuesInit = false;
    bValuesLoaded = false;
    bconfigFolderUserChanges = false;
    aGlobalPermissions = new Object();
    $("folder.properties.caldav.url").style.display = "none";
    $('checkBoxSubscr').checked = false;
    $('checkBoxSubscr').disabled = false;        
    $('checkBoxSubscrDiv').style.display = "none";
}
    
function getFolderNameTranslated(folderObject) {
    var ids = configGetKey("folder");
    var replacedname = folderObject.title;
    switch (String(folderObject.id)) {
        case String(ids.tasks):
            replacedname = _("Tasks"); /*i18n*/
            break;
        case String(ids.calendar):
            replacedname = _("Calendar"); /*i18n*/
            break;
        case String(ids.contacts):
            replacedname = _("Contacts"); /*i18n*/
            break;
    }
    return replacedname;
}

var aViewObjects;
function loadFolderProps(bPermPropagation,bDisableScrollTo) {
    register("OX_Configuration_Remove_User",removeFolderUser);
    register("OX_Configuration_Add_User",openAddUserDiv);
    permStorage = null;
    bNew = (configparentfolder != -1);
    if(!bParticipantsLoaded) {
        if(!bNew) {
            // get folder
            ox.api.folder.get({
                folder: configfolder,
                success: function (OXFolder) {
                    if (oPermissionsLiveGrid && oPermissionsLiveGrid.selection) {
                        oPermissionsLiveGrid.selection.reset(); // bugfix #9991
                        triggerEvent("SubSelected",[]);
                    }
                    var replacedname = getFolderNameTranslated(OXFolder);
                    setPropsHeadLine(replacedname, false);
                    var aPermissionArray = OXFolder.permissions;
                    var sModule = OXFolder.module;
                    var sIdParam = OXFolder.id;
                    var oOwnRights = OXFolder.own_rights;
                    if (!bValuesInit) {        
                        $('inFolderName').value = replacedname;
                    }
                    configuration_changed_fields["folder"] = false;
                    bValuesInit = true;    
                    loadTabs(sModule,oOwnRights,sIdParam);
                    aViewObjects = permissionsToViewObjects(aPermissionArray);
                    //check acls enabled here
                    if((sModule == "mail" || String(sIdParam).match(/^default(\d+)?/))     //check capabilities here
                                             && !(OXFolder.capabilities & Math.pow(2,0))) 
                     {
                        $("panel_props2").style.display = "none";
                     }
                     else
                     {
                         $("panel_props2").style.display = "block";
                     }
                    if(sModule == "mail"     //check capabilities here
                                             && ox.api.folder.can("subscribe", OXFolder)) 
                    {
                        $('checkBoxSubscrDiv').style.display = "";
                        $('checkBoxSubscr').checked = (OXFolder.subscribed);
                        if(OXFolder.id == "default.INBOX")
                        {
                            $('checkBoxSubscr').disabled = true;
                        }
                    }
                    if (sModule == "calendar" &&
                        configGetKey("modules.caldav.active"))
                    {
                        $('folder.properties.caldav.url').style.display = "";
                        var link = $('folder.properties.caldav.link');
                        link.href = link.firstChild.data =
                            configGetKey("modules.caldav.url")
                                .replace("[hostname]", location.host)
                                .replace("[folderId]", sIdParam);
                    } else {
                        $('folder.properties.caldav.url').style.display = "none";
                    }
                }
            });
        } else {
            if (oPermissionsLiveGrid && oPermissionsLiveGrid.selection) {
                    oPermissionsLiveGrid.selection.reset(); // bugfix #9991
                    triggerEvent("SubSelected",[]);
            }
            // get folder
            ox.api.folder.get({
                folder: configparentfolder,
                success: function (OXFolder) {
    
                    setPropsHeadLine(getFolderNameTranslated(OXFolder),true);                    
    
                    var sModule = OXFolder.module;
                    
                    if((sModule == "mail" || String(OXFolder.id).match(/^default(\d+)?/))     //check capabilities here
                                             && !(OXFolder.capabilities & Math.pow(2,0))) 
                     {
                        $("panel_props2").style.display = "none";
                     }                                        
                     else
                     {
                         $("panel_props2").style.display = "block";
                     }
                         
                    if(!bValuesInit)
                    {
                        $('inFolderName').value = '';
                        configuration_changed_fields["folder"] = false;
                    }
                    bValuesInit = true;        
                    
                    var aPermissionArray = getNewFolderPerms(OXFolder,bPermPropagation);    
                    
                    var aViewObjects = permissionsToViewObjects(aPermissionArray);                    
                    var oOwnRights = aPermissionArray[0];                        
                    loadTabs(sModule,oOwnRights);
                    if(sModule == "mail")
                    {
                        $('checkBoxSubscrDiv').style.display = "";
                        $('checkBoxSubscr').checked = true;
                        $('checkBoxSubscr').disabled = true;
                    }
                    $('folder.properties.caldav.url').style.display = "none";
                }
            });
        }
    }
    triggerEvent("OX_Config_Folder_Changed");
}

function getNewFolderPerms(OXFolder, bPermPropagation) {
    var aPermissionArray = new Array();                    
    //shared folder permissions
    if (OXFolder.type == 3 && OXFolder.created_by != null 
           && OXFolder.created_by != configGetKey("identifier")) {
        aPermissionArray[0] = {group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                                                                    
                               entity:OXFolder.created_by};                        
        aPermissionArray[1] = {group:false,bits:Math.pow(2,0)+Math.pow(2,8)+
            Math.pow(2,15) + Math.pow(2,22),
                            entity:configGetKey("identifier")};
    } else {
        aPermissionArray[0] = {group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                    
                               entity:configGetKey("identifier")};
    }
    if (bPermPropagation) {
        var aPermissionArray = new Array();
        switch(OXFolder.id) {
            case 1: case 2: case 10:                            
                aPermissionArray = aPermissionArray.concat(OXFolder.permissions);                            
                aPermissionArray.push({group:false,bits:Math.pow(2,6)+Math.pow(2,13)+
                                    Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                    
                                   entity:configGetKey("identifier")});                                               
                break;
            default:
                aPermissionArray = OXFolder.permissions;
                break;
        }        
    }    
    return aPermissionArray;
}

function setPropsHeadLine(stitle, bNewFolderDia){
    removeChildNodes($("folder_prop_headline"));
    if(bNewFolderDia) {
        var oTextNodeDOM = new I18nNode(_("Folder Properties"));
        $("folder_prop_headline").appendChild(oTextNodeDOM.node);
    } else {
        //#. %s is the folder name.
        //#, c-format
        var oTextNodeDOM = new I18nNode(format(_("Folder Properties: %s"),
                                               stitle));
        $("folder_prop_headline").appendChild(oTextNodeDOM.node);
    }
}

function fn_ln2(val) {
    return Math.log(val)/Math.log(2);
}

function changeRights(sType,sRight) {
    registerFolderChange("user");
    var bits = 0;

    if(!aGlobalPermissions[editEntity])
        return;

    switch(sType) {
        case 'FOLDER':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 0);
                        aGlobalPermissions[editEntity]['obj'][0].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][0].string = ox.api.folder.derive("permissions", bits, 0).string;
                        break;
        case 'READ':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 7);
                        aGlobalPermissions[editEntity]['obj'][1].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][1].string = ox.api.folder.derive("permissions", bits, 7).string;    
                        break;
        case 'WRITE':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);                                                        
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 14);
                        aGlobalPermissions[editEntity]['obj'][2].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][2].string = ox.api.folder.derive("permissions", bits, 14).string;
                        break;
        case 'DELETE':
                bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                            Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14);
                        bits += (aGlobalPermissions[editEntity]['obj'][4]==0)?0:Math.pow(2,28);                    
                        bits += (sRight==0)?0:Math.pow(2,fn_ln2(parseInt(sRight)) + 21);
                        aGlobalPermissions[editEntity]['obj'][3].bit = parseInt(sRight);
                        aGlobalPermissions[editEntity]['obj'][3].string = ox.api.folder.derive("permissions", bits, 21).string;
                        break;
        case 'ADMIN':    bits =     Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][0].bit)) + 0) + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][1].bit)) + 7)  + 
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][2].bit)) + 14) +
                                Math.pow(2,fn_ln2(parseInt(aGlobalPermissions[editEntity]['obj'][3].bit)) + 21) ;
                        bits += (sRight==0)?0:Math.pow(2,28);                    
                        aGlobalPermissions[editEntity]['obj'][4] = parseInt(sRight);                                    
                        break;
        default:        bits;                
    }
    aGlobalPermissions[editEntity]['bitmask'] = bits;
    var oPermissions = aGlobalPermissions[editEntity]['obj'];    
    var aaA = new Array();    
    aaA.push([editEntity,{id:editEntity.entity,groupflag:editEntity.groupflag},
                                oPermissions[4],
                                    oPermissions[0].string,oPermissions[1].string,
                                                            oPermissions[2].string,oPermissions[3].string]);
    function cb_loc_updt (){
        return function (indx,data)
        {
            data[2] = oPermissions[4];
            data[3] = oPermissions[0].string;
            data[4] = oPermissions[1].string;
            data[5] = oPermissions[2].string;                        
            data[6] = oPermissions[3].string;    
            return data;                                
        };
    }
    oPermissionsLiveGrid.storage.localUpdate([editEntity],cb_loc_updt());
    oPermissionsLiveGrid.events.trigger("Selected",
        oPermissionsLiveGrid.selection.count);
    return bits;
}

var aGlobalPermissions = new Object();
function permissionsToViewObjects(aPermissionArray) {    
    var aViewObjects = new Array();
    if (!aPermissionArray) {
        return aViewObjects;
    }
    for (nEntity=0;nEntity < aPermissionArray.length;nEntity++) {
        var aEntityPermissions = aPermissionArray[nEntity];        
        var nBits = aEntityPermissions.bits;

        aViewObjects[nEntity] = new Object();
        aViewObjects[nEntity]['entity'] = aEntityPermissions.entity;                
        aViewObjects[nEntity]['groupflag'] = aEntityPermissions.group;                        
        
        oPerm = new Array();
        
        oPerm[0] = ox.api.folder.derive("permissions", nBits, 0);
        oPerm[1] = ox.api.folder.derive("permissions", nBits, 7);
        oPerm[2] = ox.api.folder.derive("permissions", nBits, 14);
        oPerm[3] = ox.api.folder.derive("permissions", nBits, 21);
        oPerm[4] = (nBits & Math.pow(2,28))?1:0;    
        
        aViewObjects[nEntity]['fr'] = oPerm[0].string;
        aViewObjects[nEntity]['rr'] = oPerm[1].string;
        aViewObjects[nEntity]['wr'] = oPerm[2].string;                                
        aViewObjects[nEntity]['dr'] = oPerm[3].string;                                                
        aViewObjects[nEntity]['admin'] = oPerm[4];
        
        var sKey = aEntityPermissions.entity + '_' + ((aEntityPermissions.group)?1:0);
        aGlobalPermissions[sKey] = new Object();
        aGlobalPermissions[sKey]['obj'] = oPerm;
        aGlobalPermissions[sKey]['bitmask'] = nBits;
        aGlobalPermissions[sKey]['groupflag'] = aEntityPermissions.group;
    }
    return aViewObjects;
}

var userPermQueue = [];
var userPermTimer;
function getDisplayName(group, id, node) {
    userPermQueue.push({ type: group ? 2 : 1, id: id, node: node });
    if (userPermTimer) {
        return;
    }
    function final_cb(userPermQueue) {
        internalCache.getObjects(userPermQueue, function(data) {
            for (var i=0; i < userPermQueue.length; i++) {
                var obj = userPermQueue[i];
                jQuery(obj.node).text(data[obj.id].display_name || "..."); 
            }
        });
    }
    userPermTimer = setTimeout(function() {
        final_cb(userPermQueue);
        userPermQueue = [];
        userPermTimer = undefined;
    }, 300);
}

function saveFolder(fn_opt) {
    
    var oFolderNEW = getFolderFromForm();

    ox.api.folder.get({
        
        folder: configfolder,
        success: function (oFolder) {
        
	        function success(arg) {

	            var cont = function () {
	                
	                // the folder id must be reseted after mail folder update
	                if (oFolder.module === "mail" && arg && arg.id) {
	                    activefolder = arg.id;
	                    configfolder = activefolder;
	                } else {
	                    activefolder = configfolder;
	                }
	                triggerEvent("OX_New_Info", 4, _("Your settings have been saved"));

	                // workaround for foldertree updates after permission changes to display
	                // shared icons on folders
	                ox.api.cache.folder0.clear();
	                ox.api.cache.folder1.clear();
	                ox.api.cache.folderFlat.clear();
	                
	                ox.api.folder.dispatcher.trigger("modify");

	                ox.util.call(fn_opt);
	            };

	            // got invisible?
	            ox.api.folder.get({
	                folder: configfolder,
	                cache: false,
	                success: cont,
	                error: function () {
	                    // set parent folder
	                    ox.UIController.setFolder({ folder: oFolder.folder_id });
	                    // continue
	                    cont();
	                    // suppress global error
	                    return true;
	                }
	            });
	        }

	        function error() {
	            ox.util.call(fn_opt);
	        }
	        
	        //check Folder default
	        var oFolderdefault = configGetKey("folder");
	        var isDefaultfolder = false;
	        for (var itemF in oFolderdefault) {
	            if (changedFolderId == oFolderdefault[itemF]) {
	                isDefaultfolder = true;
	            }
	        }
	        if (isDefaultfolder || !aChangedAttributes["title"]) {
	            delete oFolderNEW["title"];
	        }
	        if (!aChangedAttributes["user"]) {
	            delete oFolderNEW["permissions"];
	        }
	        if (oFolder != undefined) {
	            ox.api.folder.update({
	                folder: configfolder,
	                data: oFolderNEW,
	                success: success,
	                error: error,
	                event: false
	            });
	        }
	    } 
    });     
}

function getFolderFromForm() {
    var sName = document.forms.folderMainProps.inFolderName.value;
    var bSubscribed = document.forms.folderMainProps.checkBoxSubscr.checked;    
    var sType = "";
    if(!comboboxProps) return;
    changedFolderId = configfolder;        
    var sIDOpt  = comboboxProps.getKey();
    sType = sIDOpt.split("_")[1];
    
    var nPerNum = 0;
    var aPermissionArray = new Array();    
    for (sEnt in aGlobalPermissions) {
        var oPermission = new Object();
        oPermission['bits'] = parseInt(aGlobalPermissions[sEnt].bitmask);
        oPermission['entity'] = sEnt.split("_")[0]; //UserId
        oPermission['rights'] = '';
        oPermission['group'] = (sEnt.split("_")[1] == "0")?false:true;
        aPermissionArray[nPerNum] = oPermission;
        nPerNum++;
    }
    var oFolder  = new Object();
    oFolder['title'] = sName;
    oFolder['module'] = sType;    
    oFolder['permissions'] = aPermissionArray;    
    oFolder['subscribed'] = (bSubscribed)?1:0;        
    return oFolder;
}    

function loadTabs(sModule,oOwnRights,sIdParam){
    setTabLists(fdpropsTabsList, fdpropsPanelsList,fdpropsEventList);    
    if(!bValuesLoaded)
        loadValues(sModule,oOwnRights);    
    bValuesLoaded = true;
}

var comboboxProps = null;
function loadValues(sModule,oOwnRights) {
    // get folder
    var id = (bNew) ? configparentfolder : configfolder;
    ox.api.folder.get({
        folder: id, 
        success: function (folder) {
            var sMod = folder.module;
            var sId = folder.id;    
            var selectedItem = 'm_'+sMod;
            var inputNameField = $('inFolderName');
            var bPermFolderBit = ox.api.folder.derive("permissions", folder, 0).bit;
            if(!ox.api.folder.can("rename", folder) && !bNew) {
                inputNameField.disabled = true;
                inputNameField.className = "background-color-default border-color-design";
            } else {                    
                inputNameField.disabled = false;
                inputNameField.className = "";
            }
            if(bNew && sId != 'default' && sMod != 'infostore' && sMod != 'mail') {        
                if(selectedItem == 'm_system')
                    selectedItem = 'm_calendar';
                comboboxProps = new ComboBox3(window, "SelTypeFolder", "190px", 0, true, "OX_Folder_ModuleComboChanged", null);
                if(configGetKey("modules.calendar.module"))
                    comboboxProps.addElement(_("Calendar"),"m_calendar");    
                if(configGetKey("modules.contacts.module"))    
                    comboboxProps.addElement(_("Contacts"),"m_contacts");                
                if(configGetKey("modules.tasks.module"))
                    comboboxProps.addElement(_("Tasks"),"m_tasks");
                comboboxProps.addElement(_("Messaging"),"m_messaging");
                comboboxProps.addElement(_("System"),"m_system");
                comboboxProps.getDomNode();    
            } else { 
                comboboxProps = new ComboBox3(window, "SelTypeFolder", "190px", 0, true, "OX_Folder_ModuleComboChanged", null);
                comboboxProps.addElement(_("Calendar"),"m_calendar");        
                comboboxProps.addElement(_("Contacts"),"m_contacts");        
                comboboxProps.addElement(_("Tasks"),"m_tasks");                
                comboboxProps.addElement(_("E-Mail"),"m_mail");                        
                comboboxProps.addElement(_("InfoStore"),"m_infostore");
                comboboxProps.addElement(_("Messaging"),"m_messaging");
                comboboxProps.addElement(_("System"),"m_system");
                comboboxProps.getDomNode();
                comboboxProps.disable();
                if (sId == 'default' || ox.api.folder.is("account", folder)) {
                    selectedItem = 'm_mail';
                }
            }
            comboboxProps.setKey(selectedItem);
            
            // disable menu items if required
            ox.widgets.toolBar.menuItems["folder-save-save"].setEnabled(
                ox.api.folder.can("rename", folder));
            ox.widgets.toolBar.menuItems["folder-folder-move"].setEnabled(
                ox.api.folder.can("delete", folder));
            ox.widgets.toolBar.menuItems["folder-folder-delete"].setEnabled(
                ox.api.folder.can("delete", folder));
        }
   });
}

fileloaded();    
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * 
 */

/**
 * Updates reminders.
 * Called by child windows when an item with reminder was created or modified.
 */
var updateReminders;
register("Ready", function () {
    // put it into ready so we can disable it
    // todo: we should consider to implemenet an update event we
    // can unregister instead of overwriting the global var
    if (jQuery.isFunction(updateReminders)) {
        updateReminders();
        register("OX_Refresh", updateReminders);
    }
});

register("OX_Configuration_Loaded_Complete", function() {

	var queue = new LinkedList();
	var reminders = {};
	var json = new JSONX();
	var timer, timerSet = false;
	var status = {cancel: false};

	var m = 6e4, h = 36e5, d = 864e5, w = 6048e5; // ms per min, h, day and week
    var intervals = [5*m, 10*m, 15*m, 45*m, 1*h, 2*h, 4*h, 6*h, 8*h,
                     1*d, 2*d, 3*d, 4*d, 5*d, 6*d, 1*w, 2*w, 3*w, 4*w];
    var combobox = new ComboBox3(window, "remindAlarm", "12em", 0, true, null, 4);
    for (var i = 0; i < intervals.length; i++) {
        combobox.addElement(getInterval(intervals[i]), intervals[i]);
    }
	combobox.getDomNode();
	
	var startDateNode = new I18nNode(function() {
        if (this.node && this.node.parentNode && this.node.parentNode.parentNode)
            this.node.parentNode.parentNode.style.display = this.value ? ""
                                                                       : "none";
        return this.value ? formatDate(this.value, this.format || "datetime") : "";
    });
    $("reminderStartsRow").replaceChild(startDateNode.node,
                                        $("reminderStartsRow").firstChild);
    var endDateNode = new I18nNode(function() {
    	if (this.node && this.node.parentNode && this.node.parentNode.parentNode)
            this.node.parentNode.parentNode.style.display = this.value ? ""
                                                                       : "none";
        return this.value ? formatDate(this.value, this.format || "datetime") : "";
    });
    $("reminderEndsRow").replaceChild(endDateNode.node,
                                      $("reminderEndsRow").firstChild);
	function update() {
		if (ox.api.config.get("modules.calendar.module", false) === false
                && ox.api.config.get("modules.tasks.module", false) === false) {
		    return;
		}
		json.get(AjaxRoot + "/reminder?action=range&session=" + session
			+ "&end=" + encodeURIComponent(now() + 12*60*60*1000), null,
			updatereply);
		function updatereply(reply) {
			var data = reply.data;
			var newR = [];
			for (var i = 0; i < data.length; i++) {
				var n = data[i];
				var o = reminders[n.id];
				newR.push(o && o.last_modified == n.last_modified ? o : n);
			}
			newR.sort(function(x, y) { return x.alarm - y.alarm; });
			queue = new LinkedList();
			reminders = {};
			for (var i = 0; i < newR.length; i++) {
				var reminder = newR[i];
				queue.addLast(reminder);
				reminders[reminder.id] = reminder;
			}
			schedule();
		}
	}
	updateReminders = update;
	function schedule() {
		if (timerSet) {
			clearTimeout(timer);
			timerSet = false;
		}
		var reminder = queue.first;
		if (reminder) {
			timer = setTimeout(display, Math.max(0, reminder.alarm - now()));
			timerSet = true;
		}
		function display() {
			timerSet = false;
			status.cancel = true;
			var mystatus = status = {cancel: false};
			var modules = {
				1: {name: "calendar", columns: "200,201,202,400,401",
				    icon: getFullImgSrc("img/calendar/btnnew_calendar.gif"),
				    title: "Appointment", /*i18n*/
                    //#. Appointment reminder
                    //#. %s is the time, formatted using the messages with context "in"
                    //#, c-format
                    text: "You have the following appointment in %s:", /*i18n*/
				    text2: "The following appointment already started:", /*i18n*/
				    until: 1},
				4: {name: "tasks", columns: "200,201,202",
				    icon: getFullImgSrc("img/tasks/btnnew_task.gif"),
				    title: "Task", /*i18n*/
                    //#. Task reminder
                    //#. %s is the time, formatted using the messages with context "in"
                    //#, c-format
				    text: "The following task is due in %s:", /*i18n*/
				    text2: "The following task is already past due:", /*i18n*/
				    until: 2},
				137: {name: "infostore", columns: "700",
				      icon: getFullImgSrc("img/infostore/infostore.gif"),
				      title: "InfoItem", /*i18n*/
				      text: "You wanted to be reminded about the following InfoItem:"} /*i18n*/
			};
			var module = modules[reminder.module];
			var id = {id: reminder.target_id, folder: reminder.folder};
			if (reminder.recurrence_position)
				id.pos = reminder.recurrence_position;
			json.put(AjaxRoot + "/" + module.name + "?action=list&session=" + session
				+ "&columns=" + module.columns,
				[id], null, listreply, listerror);
			function listerror(reply, status) {
				if (status && reply.code != "TSK-0017"
				           && reply.code != "APP-0001") return false;
				// Deleted in the meantime
				queue.removeFirst();
				schedule();
				return true;
			}
			function listreply(reply) {
				if(!reply.data.length) {
					queue.removeFirst();
					schedule();
					return;
				}
				if (mystatus.cancel) return;
				var data = reply.data[0];
				function set(node, text) {
					node.parentNode.style.display = text ? "" : "none";
					if (text) node.firstChild.data = text;
				}
				$("reminderTitleRow").firstChild.data = data[0] || "";
                startDateNode.value = data[1];
                startDateNode.format = data[4] === true ? "date" : "datetime";
                startDateNode.update();
                endDateNode.value = data[2];
                endDateNode.format = data[4] === true ? "date" : "datetime";
                endDateNode.update();
				set($("reminderLocationRow"), data[3]);
				
				var text = module.text;
				if (module.text2) {
					var interval = data[module.until] - now();
					if (interval < 0)
						text = _(module.text2);
					else
						text = format(_(module.text), getInterval(interval, true));
				}
				$('reminderNotificationText').firstChild.data = text;
				addDOMEvent($("reminderOK"), "click", ok);
				addDOMEvent($("reminderAgain"), "click", again);
				addOnClose($("reminderWindow"), ok);
				showNode("reminderWindow");
				
				with ($('reminderModule')) {
                    src = module.icon;
                    alt = title = _(module.title);
                }
				
				centerPopupWindow($("reminderWindow"));
				$("reminderWindow").style.display = "block";
				function hide() {
					hideNode("reminderWindow");
					$("reminderWindow").style.display = "none";
					removeDOMEvent($("reminderOK"), "click", ok);
					removeDOMEvent($("reminderAgain"), "click", again);
					removeOnClose($("reminderWindow"), ok);
				}
				function again() {
					hide();
					if (mystatus.cancel) return;
					// get interval
					var dt = combobox.getKey();
					// inform server
					var reminder = queue.first;
					// get timestamp from reply
					var timestamp = reply.timestamp;
					if (reminder) {
						// taks and appointments must be treated differently
						switch (reminder.module) {
						case 4:
							// set new alarm
							var alarm = Math.floor(now() / (60*1000)) * 60*1000 + dt;
							// update task
							var changes = { alarm: alarm, notification: false }; // do not notify!
							var request = [{
								action: "remindAgain", module: "reminder",
								data: changes, id: reminder.id
//								id: reminder.target_id, folder: reminder.folder, // target_id (not id!)
//								data: changes, timestamp: timestamp
							}];
							new JSONX().put(AjaxRoot + "/multiple?session=" + session, request, null, function(response) {
								// update cache
								var ids = [{id: reminder.target_id, folder: reminder.folder}];
								OXTaskMapping.editObjects(ids, changes);
							});
							break;
						case 1: // appointment (TODO)
							break;
						}
					}
					// adjust UI timer
					reminder.alarm = Math.floor(now() / (60*1000)) * 60*1000 + dt;
					queue.removeFirst();
					sort: {
						for (var i = queue.first; i; i = i.next) {
							if (i.alarm > reminder.alarm) {
								queue.insertBefore(reminder, i);
								break sort;
							}
						}
						queue.addLast(reminder);
					}
					schedule();
				}
				function ok() {
					hide();
					if (mystatus.cancel) return;
					var id = { id: reminder.id };
					if (reminder.recurrence_position) {
					    id.recurrence_position = reminder.recurrence_position;
					}
					json.put(AjaxRoot + "/reminder?action=delete&session=" + session
						+ "&timestamp=" + encodeURIComponent(reminder.last_modified),
                        id, null, deletereply);
					function deletereply(reply) {
						if (reply.data.length || queue.first !== reminder) // Just in case
							update();
						else {
							queue.removeFirst();
							schedule();
						}
					}
				}
			}
		}
	}
});
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */


function RightsHandling () {
	this.rightshandling_module;
	this.realmodule;
	this.cbyes;
	this.cbno;
	this.newfolder;
	this.object;
	
}
RightsHandling.prototype = {
	checkRights : function(module,folder,object,cbyes,cbno) {

		var Self=this;
		this.cbyes=cbyes;
		this.cbno=cbno;
		this.object=object;
		this.rightshandling_module=module;
		this.realmodule=module;
		if(this.realmodule=="distributionlist") {
			this.realmodule="contacts";
		}
		function checkcreateRight(data) {
			if(data.module != Self.realmodule) {
				Self.newfolder=configGetKey("folder."+Self.realmodule);
				Self.commityes();			
			} 
			else {
				var myrights = ox.api.folder.derive("permissions", data, 0).bit;
				if(myrights>=2) {
					Self.newfolder=data.id;
					Self.commityes();					
				} else {
					Self.newfolder=configGetKey("folder."+Self.realmodule);
					Self.openWindow();					
				}
			}	
		}
		if(!folder) {
			if(object && object.folder_id) {
				folder=object.folder_id;
			}
			else if(!activefolder) {
				folder=configGetKey("folder."+Self.realmodule);
			} else {
				folder=activefolder;
			}
		}
		ox.api.folder.get({
		    folder: folder,
		    success: checkcreateRight
		});
	},
	openWindow : function() {
	    ox.api.setModal(true);
//		showNode("modal-dialog");
//		$("modal-dialog").style.display="block";
		showNode("rightshandling_window");
		centerPopupWindow($("rightshandling_window"));
		$("rightshandling_window").style.display="block";
	},
	commityes : function() {
		if(!this.object) {
			this.object = {};
		} 
		this.object.folder_id=this.newfolder;
		if(!this.cbyes) {
			triggerEvent("OX_Create_Object",this.rightshandling_module,this.newfolder,this.object);
		} else {
			this.cbyes(this.rightshandling_module,this.newfolder,this.object);
		}
		this.closeWindow();
	},
	commitno : function() {
		this.closeWindow();
	},
	closeWindow : function() {
		rightshandling_module=null;
		hideNode("rightshandling_window");
		$("rightshandling_window").style.display="none";
		var childs=	$("modal-dialog").childNodes;
		var closeall=true;
		for(var i=0;i<childs.length;i++) {
			if(childs[i].tagName && childs[i].tagName == "DIV") {
				if(childs[i].style.display && childs[i].style.display != "none" ) {
					closeall=false;
				}
			}
		}
		if(closeall) {
		    ox.api.setModal(false);
//			hideNode("modal-dialog");
//			$("modal-dialog").style.display="none";
		}
	}
};
var rightshandler=new RightsHandling();
register("Loaded",function() {
	addOnClose($('rightshandling_window'),function () { rightshandler.commitno(); });
});
register("Loaded",function() {
	if($('acceptdeny_object')) {
		addOnClose($('acceptdeny_object'),function () { rightshandler.commitno(); });
	}
});
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

function AcceptDenyObject(module,object) {
    this.title=object.title;
    this.location=object.location;
    this.startdate;
    this.enddate;
    this.folder_id=object.folder_id;
    this.created_by=object.created_by;
    if (object.organizer) {
        this.organizer = object.organizer;
    }
    if (object.organizerId) {
        this.organizerId = object.organizerId;
    }
    this.objectid=object.id;
    this.module=module;
    this.confirmation=-1;
    this.com="";

    if(object.start_date) {
        this.startdate=new Date(object.start_date);
    }
    if(object.end_date) {
        this.enddate=new Date(object.end_date);
    }
    for(var i=0;i<object.users.length;i++) {
        if(object.users[i].id == configGetKey("identifier")) {
            this.confirmation=object.users[i].confirmation;
            this.com=object.users[i].confirmmessage;
        }
    }
}
function AcceptDeny(showdetail) {
    this.showdetail=showdetail;
    var Self=this;

    function mkHandler(type) {
        return function () {
            if (Self.showdetail) {
                var objects = [];
                AcceptDeny.storage.newIterate(AcceptDeny.grid.getSelectedIDs(),
                    emptyFunction, function(i, o) { objects.push(o); },
                function() {
                    acceptdeny_updateConfirm(objects, type,
                        $("acceptdeny_comment3").value, function() {
                            var grid = AcceptDeny.grid;
                            grid.deleteIDs(grid.getSelectedIDs());
                            $("acceptdeny_comment3").value=""; // bug #15388
                            if (!grid.storage.ids.length) {
                                Self.removeDomEvents();
                                AcceptDeny.hide();
                            }
                        });
                });
            } else {
                Self.removeDomEvents();
                acceptdeny_updateConfirm(Self.objects, type,
                    $("acceptdeny_comment2").value, AcceptDeny.hide);
            }
        };
    }
    this.acceptdeny_accept = mkHandler(1);
    this.acceptdeny_decline = mkHandler(2);
    this.acceptdeny_tentative = mkHandler(3);

    this.acceptdeny_later = function () {
        Self.acceptdeny_close();
        if (contimestamp && contimestamp > 0) {
            configSetKey("gui.global.confirmtimestamp",contimestamp);
        }
    };
    
    this.acceptdeny_close = function () {
        Self.removeDomEvents();
        AcceptDeny.hide();
    };
    this.addDomEvents = function () {
        this.removeDomEvents();
        addOnClose($("acceptdeny_object"),Self.acceptdeny_close);
        addDOMEvent($("acceptdeny_accept"), "click", Self.acceptdeny_accept);
        addDOMEvent($("acceptdeny_decline"), "click", Self.acceptdeny_decline);
        addDOMEvent($("acceptdeny_tentative"), "click", Self.acceptdeny_tentative);
        addDOMEvent($("acceptdeny_later"), "click", Self.acceptdeny_later);
    };
    this.removeDomEvents = function () {    
        removeOnClose($("acceptdeny_object"),Self.acceptdeny_close);
        removeDOMEvent($("acceptdeny_accept"), "click", Self.acceptdeny_accept);
        removeDOMEvent($("acceptdeny_decline"), "click", Self.acceptdeny_decline);
        removeDOMEvent($("acceptdeny_tentative"), "click", Self.acceptdeny_tentative);
        removeDOMEvent($("acceptdeny_later"), "click", Self.acceptdeny_later);    
    };
}
AcceptDeny.visible = false;
AcceptDeny.hide = function() {
    hideNode("acceptdeny_object");
    $("acceptdeny_object").style.display="none";
    //ox.api.setModal(false);
//    hideNode("modal-dialog");
//    $("modal-dialog").style.display="none";
//    $("modal-dialog").style.width = "100%";
//    $("modal-dialog").style.height = "100%";
    AcceptDeny.visible = false;
};
AcceptDeny.prototype = {
    changeConfirm : function(acceptdenyobjectarray) {
        AcceptDeny.visible = true;
        this.objects = acceptdenyobjectarray;
        $("acceptdeny_nodetail").style.display="";
        $("acceptdeny_list").style.display = "none";
        var comment = this.showdetail ? $("acceptdeny_comment2")
                                      : $("acceptdeny_comment3");
        comment.value="";
        if(acceptdenyobjectarray && acceptdenyobjectarray.length == 1 && acceptdenyobjectarray[0].com) {
            comment.value=acceptdenyobjectarray[0].com;
        }
        //ox.api.setModal(true);
//        showNode("modal-dialog");
//        $("modal-dialog").style.display="block";
        showNode("acceptdeny_object");
        centerPopupWindow($("acceptdeny_object"));
        $("acceptdeny_object").style.display="block";
        this.addDomEvents();
        
    },
    showConfirmation : function (objects) {
        if (!objects.length) return;
        AcceptDeny.visible = true;
        this.objects = objects;
        if (this.showdetail) {
            $("acceptdeny_nodetail").style.display="none";
            $("acceptdeny_list").style.display = "";
            $("acceptdeny_list_message").style.display =
                objects[0].confirmation ? "none" : "";
            var messages = $("acceptdeny_list_message").
                getElementsByTagName("span");
            switch (objects[0].module) {
                case "tasks":
                    messages[0].style.display = "none";
                    messages[1].style.display = "";
                    $("acceptdeny_show").style.display = "none";
                    break;
                case "calendar":
                    messages[0].style.display = "";
                    messages[1].style.display = "none";
                    $("acceptdeny_show").style.display = "";
                    break;
                default:
                    messages[0].style.display = "none";
                    messages[1].style.display = "none";
                    $("acceptdeny_show").style.display = "none";
            }
            var grid = AcceptDeny.grid;
            if (!grid) {
                var defaultClear = LiveGrid.makeClear("");
                grid = AcceptDeny.grid = new LiveGrid([
                {
                    width: "30px",
                    style: { padding: 0, margin: 0 },
                    text: "&#x00a0;",
                    set: function(div, data) {
                        var src = getFullImgSrc("img/calendar/mod_calendar.gif");
                        if (data.module && data.module == "tasks") {
                            src = getFullImgSrc("img/tasks/mod_tasks.gif");
                        }
                        if (!div.firstChild) {
                            div.appendChild(newnode("img", {height : "24px", width : "24px"}, { src: getFullImgSrc("img/dummy.gif"), align: "absmiddle"}));
                        }
                        div.firstChild.src = src;
                    },
                    clear: function(div) {
                        if (!div.firstChild) {
                            div.appendChild(newnode("img", {height : "24px", width : "24px"}, { src: getFullImgSrc("img/dummy.gif"), align: "absmiddle"}));
                        } else {
                            div.firstChild.src = getFullImgSrc("img/dummy.gif");
                        }
                    }
                },{
                    i18n: "description"/*i18n context*/, text: "Title"/*i18n*/,
                    clear: function(div) {
                        if (!div.firstChild) {
                            div.appendChild(newnode("div", 0, 0,
                                [newtext("")]));
                            div.appendChild(newnode("div", 0, 0,
                                [newtext("")]));
                        } else {
                            div.firstChild.firstChild.data = "";
                            div.firstChild.nextSibling.firstChild.data = "";
                        }
                    },
                    set: function(div, data) {
                        var text = data.location
                            //#. Appointment description in the confirmation dialog.
                            //#. %1$s is the title.
                            //#. %2$s is the location.
                            //#, c-format
                            ? format("%1$s - %2$s", (data.title || ""),
                                                    data.location)
                            : (data.title || "");
                        if (!div.firstChild) {
                            div.appendChild(newnode("div", 0, 0,
                                [newtext(text)]));
                            div.appendChild(newnode("div", 0, 0,
                                [newtext("")]));
                        } else {
                            div.firstChild.firstChild.data = text;
                            div.firstChild.nextSibling.firstChild.data = "";
                        }
                        if (data.organizer && !data.organizerId) {
                            div.firstChild.nextSibling.firstChild.data = format(_("organized by %s"), data.organizer);
                        } else {
                            var user = data.organizerId || data.created_by;
                            internalCache.getUsers([ user ], function(u) {
                                var text = 
                                    //#. Second line in the grid of the notification dialog
                                    //#. %s is the name of the appointment creator or organizer
                                    //#, c-format
                                    format(_("created by %s"), u[user].display_name);
                                if (data.organizerId) {
                                    text = format(_("organized by %s"), u[user].display_name);
                                }
                                div.firstChild.nextSibling.firstChild.data = text;
                            });
                        }
                    }
                }, {
                    text: "Start"/*i18n*/, i18n: true, index: "startdate",
                    width: "11em", clear: defaultClear,
                    set: LiveGrid.dateSetTime
                }, {
                    text: "End"/*i18n*/, i18n: true, index: "enddate",
                    width: "11em", clear: defaultClear,
                    set: LiveGrid.dateSetTime
                }], new Selection());
                $("acceptdeny_list_header").appendChild(grid.getHeader());
                grid.columns[1].style = { height: "3.2em" };
                grid.getTable($("acceptdeny_list_body"));
                var setDisabled = classNameSetter("font-color-disabled");
                grid.events.register("Selected", function(count) {
                    $("acceptdeny_all").checked =
                        count == grid.storage.ids.length;
                    setDisabled($("acceptdeny_show"), count != 1);
                    setDisabled($("acceptdeny_accept"), count == 0);
                    setDisabled($("acceptdeny_decline"), count == 0);
                    setDisabled($("acceptdeny_tentative"), count == 0);
                    
                    // change button text - either it's an appointment or a task 
                    var ids = grid.getSelectedIDs();
                    if (ids.length != 1) return;
                    grid.storage.newIterate(ids, emptyFunction,
                        function(i, object) {
                            if (!object.module) return;
                            var butText = _("Show in calendar");
                            if (object.module == "tasks") {
                                butText = _("Show in task");
                            }
                            $("acceptdeny_show-button").firstChild.data = butText;
                        });
                });
                AcceptDeny.storage = new Storage(0, [], 0, 0, 0, 0,
                    function(x) { return x.objectid; });
                addDOMEvent($("acceptdeny_all"), "click", function() {
                    if ($("acceptdeny_all").checked) {
                        grid.selection.select(0, grid.storage.ids.length);
                    } else {
                        grid.selection.reset();
                    }
                });
                addDOMEvent($("acceptdeny_show"), "click", function() {
                    var ids = grid.getSelectedIDs();
                    if (ids.length != 1) return;
                    grid.storage.newIterate(ids, emptyFunction,
                        function(i, object) {
                    		var modulebefore = ox.api.ui.getActiveModule();
                    		
                            activemodule = object.module || "calendar";
                            if (activemodule == "calendar") {
                                activeDay = object.startdate.getUTCDate();
                                activeMonth = object.startdate.getUTCMonth();
                                activeYear = object.startdate.getUTCFullYear();
                            }
                            // change folder
                            ox.UIController.setFolder({
                                folder: object.folder_id,
                                module: "default",
                                success: function() {
                                    // if it's the same module we need to trigger view switch
                                    // to force a redraw
	                            	if (activemodule === modulebefore) {
	                                	triggerEvent("OX_Switch_View", currentpath.join("/"));
	                                }
                            	}
                            });
                        });
                });
            }
            var storage = AcceptDeny.storage;
            storage.remove(0, storage.ids.length);
            storage.append(objects)
            grid.enable(AcceptDeny.storage);
            grid.selection.click(0);
        } else {
            var acceptdenyobject = objects[0];
            $("acceptdeny_nodetail").style.display="";
            $("acceptdeny_list").style.display = "none";
            $("acceptdeny_notnew").style.display =
                acceptdenyobject.confirmation ? "none" : "";
        }
        //ox.api.setModal(true);
//        showNode("modal-dialog");
//        $("modal-dialog").style.display="block";
        showNode("acceptdeny_object");
        centerPopupWindow($("acceptdeny_object"));
        $("acceptdeny_object").style.display="block";
        this.addDomEvents();
    }
}

function acceptdeny_updateConfirm(objects, status, message, callback) {    
    var join = new Join(function() {
        json.put(AjaxRoot + "/multiple?session=" + session, requests, null,
                 finalCallback, finalCallback);
    });
    var last = join.add();
    var requests = new Array();
    for (var i = 0; i < objects.length; i++) {
        ox.api.folder.get({
            folder: objects[i].folder_id,
            success: join.add((function(object) {
                return function(folder) {
                    var owner = folder.type == 3 ?
                        folder.created_by :
                        configGetKey("identifier");
                    requests.push({
                        module: object.module, action: "confirm",
                        folder: object.folder_id, id: object.objectid,
                        data: { id: owner, confirmmessage: message,
                                confirmation: status }
                    });
                };
            })(objects[i]))
        });
    }
    last();
    function finalCallback(resp) {
        // TODO CHECK ERRORS
        
        acceptdeny_update_objects_in_cache(requests,
            acceptdeny_get_timestamp(resp));
        triggerEvent("OX_AcceptDeny_Changed");
        callback();
    }
}

function acceptdeny_get_timestamp(response) {
    return response.timestamp || response[0].timestamp || new Date().getTime();
}

function acceptdeny_update_objects_in_cache(objects, timestamp) {
    
    for (var i in objects) {
        var object = objects[i];
        if (object.module == "calendar") {
            if (storageCache && storageCache.current != null) storageCache.update();
            else lastUpdateOfCalendarTimestamp = timestamp;
            continue; // not implemented right now
            
        }
        
        ox.api.folder.get({
            folder: object.folder,
            success: function (folder) {
                var owner = folder.type == 3 ? folder.created_by : configGetKey("identifier");
                OXCache.moduleMappings[object.module].editObjects(
                      [ { "module": object.module, "folder": object.data.folder_id, "id": object.data.id } ],
                      { "users": 
                        [{ "confirmation": object.data.confirmation,
                           "confirmmessage": object.data.confirmmessage,
                           "id": owner 
                        }],
                        "timestamp": timestamp
                      }
                );
            }
        });
        
    }
}

function acceptdeny_start() {    
    function acceptdeny_fill(response) {
        var conarray=new Array();
        var constrings=new Object();
        for (var ia=0; ia<response.length; ia++) {
            if (!response[ia].data || !response[ia].data.length) continue;
            var data = response[ia].data;
            contimestamp = data.timestamp;
            for (var i=0; i<data.length; i++) {
                var newobject=new Object();
                newobject.id=data[i][0];
                newobject.folder_id=data[i][1];
                newobject.start_date=data[i][2];
                newobject.end_date=data[i][3];
                newobject.users=data[i][5];
                newobject.title=data[i][6];
                newobject.created_by=data[i][7];
                newobject.location=data[i][8];
                if (data[i][9]) {
                    newobject.organizer=data[i][9];
                    newobject.organizerId=data[i][10];
                }
                newobject.module = (ia == 0 ? "calendar" : "tasks");
                for(var i2=0; i2<newobject.users.length; i2++) {
                    if (newobject.users[i2].id == configGetKey("identifier")) {
                        if (newobject.users[i2].confirmation == 0) {
                            if(!constrings[newobject.folder_id+":"+newobject.id]) {
                                constrings[newobject.folder_id+":"+newobject.id]=true;
                                conarray.push(newobject);
                            }
                        }
                        break;
                    }
                }
            }    
        }
        showAllConfirmation(conarray);
    }
    var checkconfirmation=true;
    var columns="1,20,201,202,209,221,200,2";
    var confirmtimestamp=0;
    if (configContainsKey("gui.global.confirmtimestamp")) {
        confirmtimestamp = configGetKey("gui.global.confirmtimestamp");
    }
    if (configContainsKey("gui.global.confirmpopup") && 
            configGetKey("gui.global.confirmpopup") == true) {
        var startDate = new Date().getTime();
        var endDate = startDate+3600000*24*365*5;
        var requests = [];
        if (configGetKey("modules.calendar.module")) {
            requests.push( { module: "calendar", action: "updates", start: startDate, end: endDate, timestamp: confirmtimestamp, ignore: "deleted", columns: columns + ",400,224,227" } );
        }
        if (configGetKey("modules.tasks.module")) {
            requests.push( { module: "tasks", action: "updates", folder: configGetKey("folder.tasks"), start: startDate, end: endDate, timestamp: confirmtimestamp, ignore: "deleted", columns: columns } );
        }
        if (requests.length) {
            (new JSONX).put(AjaxRoot + "/multiple?session=" + session, requests, null, acceptdeny_fill);
        }
    }
}
var globalconfirm = new AcceptDeny(true);

register("Ready", function () {
    // put it into ready so we can disable it
    if (jQuery.isFunction(acceptdeny_start)) {
        acceptdeny_start();
        register("OX_Refresh", acceptdeny_start);
    }
});


var contimestamp;

function showAllConfirmation(acceptdenyarray) {    
    var a = new Array(acceptdenyarray.length);
    for (var i = 0; i < acceptdenyarray.length; i++) {
        a[i] = new AcceptDenyObject(acceptdenyarray[i].module || "calendar", acceptdenyarray[i]);
    }
    globalconfirm.showConfirmation(a);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var globalalert = new AlertPopup();
var globalcreate= new CreatePopup();
function AlertPopup() {    
    this.header;
    this.buttons;
    this.text;
    this.div;
    this.cbresize;
    this.closecb;
    this.cbok;
    this.cbcancel;
    this.cbyes;
    this.cbno;
    this.cbsave;
    this.cbseries;
    this.cbappointment;
    this.cbnocomment;
    this.visibleButtons=[];
}
AlertPopup.SERIESBUTTON=50;
AlertPopup.OK=1;
AlertPopup.CANCEL=2;
AlertPopup.YES=4;
AlertPopup.NO=8;
AlertPopup.APPOINTMENT=16;
AlertPopup.SERIES=32;
AlertPopup.NOCOMMENT=64;
AlertPopup.EDIT=128;
AlertPopup.CONTINUE=256;
AlertPopup.VERSION=67;
AlertPopup.OKCANCEL=3;
AlertPopup.YESNO=12;
AlertPopup.CONTINUECANCEL=258;
AlertPopup.SAVE=512;

if (init && init.i18n) delete init.i18n["alert_window-h-c"];

AlertPopup.open = function () {
    globalalert.visibleButtons = [];
    /*
     * remove keydown event just in case!
     */
    removeDOMEvent(body, "keydown", AlertPopup.key_down);
    if ("Hover" in window) Hover.disable();
    ox.api.setModal(true);
    //showNode("modal-dialog");
    //$("modal-dialog").style.display="block";
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";
    /*
     * enable / disable required buttons
     */
    if ((globalalert.buttons %  2) >= 1) { 
        $("alert_window_ok").style.display="block";
        setFocus($("alert_window_ok"));
        globalalert.visibleButtons.push({id: "alert_window_ok", evt: AlertPopup.commitok});
    } else { 
        $("alert_window_ok").style.display="none"; 
    }
    if ((globalalert.buttons %  4) >= 2) { 
        $("alert_window_cancel").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_cancel", evt: AlertPopup.commitcancel});
    } else { 
        $("alert_window_cancel").style.display="none"; 
    }
    if ((globalalert.buttons %  8) >= 4) { 
        $("alert_window_yes").style.display="block"; 
        setFocus($("alert_window_yes"));
        globalalert.visibleButtons.push({id: "alert_window_yes", evt: AlertPopup.commityes});
    } else { 
        $("alert_window_yes").style.display="none"; 
    }
    if ((globalalert.buttons % 16) >= 8) { 
        $("alert_window_no").style.display="block";
        globalalert.visibleButtons.push({id: "alert_window_no", evt: AlertPopup.commitno});
    } else { 
        $("alert_window_no").style.display="none"; 
    }    
    if ((globalalert.buttons % 64) >= 32) { 
        $("alert_window_series").style.display="block";
        globalalert.visibleButtons.push({id: "alert_window_series", evt: AlertPopup.commitseries});
    } else { 
        $("alert_window_series").style.display="none"; 
    }
    if ((globalalert.buttons % 32) >= 16) { 
        $("alert_window_appointment").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_appointment", evt: AlertPopup.commitappointment});
    } else { 
        $("alert_window_appointment").style.display="none"; 
    }
    if ((globalalert.buttons % 128) >= 64) { 
        $("alert_window_nocomment").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_nocomment", evt: AlertPopup.commitnocomment});
    } else { 
        $("alert_window_nocomment").style.display="none"; 
    }
    if ((globalalert.buttons % 256) >= 128) { 
        $("alert_window_edit").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_edit", evt: AlertPopup.commitedit});
    } else { 
        $("alert_window_edit").style.display="none"; 
    }
    if ((globalalert.buttons % 512) >= 256) { 
        $("alert_window_continue").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_continue", evt: AlertPopup.commitcontinue});
    } else { 
        $("alert_window_continue").style.display="none"; 
    }
    if ((globalalert.buttons % 1024) >= 512) { 
        $("alert_window_save").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_save", evt: AlertPopup.commitsave});
    } else { 
        $("alert_window_save").style.display="none"; 
    }
    if (globalalert.SHOWAGAIN) { 
        $("alert_window_showagain").style.display="block"; 
        globalalert.visibleButtons.push({id: "alert_window_showagain_value", evt: function() {}});
    } else { 
        $("alert_window_showagain").style.display="none"; 
    }
    showNode("alert_window");
    $("alert_window-h-c").firstChild.data = globalalert.header;
    removeChildNodes($("alert_window_text"));
    if (globalalert.div) {        
        $("alert_window_text").appendChild(globalalert.div);
    } else {
        var nText = globalalert.text.split("\n");
        for (var i in nText) {
            $("alert_window_text").appendChild(document.createTextNode(nText[i]));
            $("alert_window_text").appendChild(newnode("br"));
        }
    }
    centerPopupWindow($("alert_window"));    
    $("alert_window").style.display="block";
    addDOMEvent(body, "keydown", AlertPopup.key_down);
    // bind to resize
    if (!globalalert.cbresize) {
        globalalert.cbresize = function() {
            // bind to resize to prevent dialog moved out of view
            // bug #19950 - header offset needs to be checked as its top
            // position is -x :(
            var header = jQuery(".popup_border_lo", $("alert_window"));
            if (header && header.offset().top < 0) {
                jQuery($("alert_window")).css({ top: (header.height() + 1) + "px" });
            } 
        };
        jQuery(window).bind('resize', globalalert.cbresize);
    }
}
AlertPopup.close = function () {
    if ("Hover" in window) Hover.enable();
    removeDOMEvent(body, "keydown", AlertPopup.key_down);
    ox.api.setModal(false);
    hideNode("alert_window");
    $("alert_window").style.display="none";
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs = $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0;i<childs.length;i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display != "none" ) {
                closeall=false;
            }
        }
    }
    globalalert.visibleButtons = {};
    if (closeall === false) {
        ox.api.setModal(true);
    }
    if (globalalert.closecb) {
        globalalert.closecb();
    }
    // unbind resize
    if (globalalert.cbresize) {
        jQuery(window).unbind('resize', globalalert.cbresize);
        globalalert.cbresize = undefined;
    }
}
AlertPopup.commityes = function () {
    AlertPopup.close();
    if(globalalert.cbyes) { globalalert.cbyes(); }
}
AlertPopup.commitno = function () {
    AlertPopup.close();
    if(globalalert.cbno) { globalalert.cbno(); }
}
AlertPopup.commitcancel = function () {
    AlertPopup.close();
    if(globalalert.cbcancel) { globalalert.cbcancel(); }
}
AlertPopup.commitok = function () {
    if (!globalalert.leaveOpen) {
        AlertPopup.close();
    }
    if(globalalert.cbok) { globalalert.cbok(); }
}
AlertPopup.commitseries = function () {
    AlertPopup.close();
    if(globalalert.cbseries) { globalalert.cbseries(); }
}
AlertPopup.commitnocomment = function () {
    AlertPopup.close();
    if(globalalert.cbnocomment) { globalalert.cbnocomment(); }
}
AlertPopup.commitappointment = function () {
    AlertPopup.close();
    if(globalalert.cbappointment) { globalalert.cbappointment(); }
}
AlertPopup.commitedit = function () {
    AlertPopup.close();
    if(globalalert.cbedit) { globalalert.cbedit(); }
}
AlertPopup.commitsave = function () {
    AlertPopup.close();
    if(globalalert.cbsave) { globalalert.cbsave(); }
}
AlertPopup.key_down = function(e) {
    switch (e.keyCode || e.which) {
        case 27: // esc
            AlertPopup.close();
            break;
        case 9: // tab
            if (!globalalert.visibleButtons.length) break;
            if (focusedElement != null) {               
                for (var i=0; i<globalalert.visibleButtons.length; i++) {
                    if (globalalert.visibleButtons[i].id == focusedElement.id) {
                        if (i+1 < globalalert.visibleButtons.length) {
                            setFocus($(globalalert.visibleButtons[i+1].id));
                        } else {
                            setFocus($(globalalert.visibleButtons[0].id));
                        }
                        break;
                    }
                }
            } else {
                setFocus($(globalalert.visibleButtons[0].id));
            }
            break;
        case 13: // enter 
            if (!globalalert.visibleButtons.length) break;
            if (focusedElement != null) {               
                for (var i=0; i<globalalert.visibleButtons.length; i++) {
                    if (globalalert.visibleButtons[i].id == focusedElement.id) {
                        globalalert.visibleButtons[i].evt();
                        break;
                    }
                }
            }
            break;         
        default:
            return;        
    }
    stopEvent(e);
    return false;
}
AlertPopup.prototype = 
{
    setOK : function (cb) {
        this.cbok=cb;
    },
    setCancel : function (cb) {
        this.cbcancel=cb;
    },
    setYes : function (cb) {
        this.cbyes=cb;
    },
    setNo : function (cb) {
        this.cbno=cb;
    },
    setSeries: function (cb) {
        this.cbseries=cb;
    },
    setAppointment: function (cb) {
        this.cbappointment=cb;
    },
    setClose: function (cb) {
        this.closecb=cb;
    },
    setNoComment : function(cb) {
        this.cbnocomment=cb;
    },
    setEdit: function(cb) {
        this.cbedit=cb;
    },
    setSave: function(cb) {
        this.cbsave=cb;
    }
};

function CreatePopup() {    
    this.header;
    this.buttons;
    this.text;
    this.inputtext;
    this.inputvalue;
    this.closecb;
    this.cbok;
    this.cbcancel;
    this.cbadvanced;
    this.cbnocomment;
}
CreatePopup.OK=1;
CreatePopup.CANCEL=2;
CreatePopup.NOCOMMENT=4;
CreatePopup.VERSION=7;
CreatePopup.ADVANCED=64;
CreatePopup.ALL=67;

CreatePopup.open = function () {
    ox.api.setModal(true);
    //showNode("modal-dialog");
    //$("modal-dialog").style.display="block";
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";
    if ((globalcreate.buttons %  4) >= 2) { $("create_window_cancel").style.display="block"; } else { $("create_window_cancel").style.display="none"; }
    if ((globalcreate.buttons %  8) >= 4) { $("create_window_nocomment").style.display="block"; } else { $("create_window_nocomment").style.display="none"; }
    if ((globalcreate.buttons %  2) >= 1) { $("create_window_ok").style.display="block"; } else { $("create_window_ok").style.display="none"; }
    
    if ((globalcreate.buttons % 128) >= 64) { $("create_window_advanced").style.display="block"; } else { $("create_window_advanced").style.display="none"; }
    
    $("create_window-h-c").firstChild.data = globalcreate.header;
    $("create_window_text").firstChild.data = globalcreate.text;
    if(globalcreate.inputtype == "input") {
        $("create_window_table_textarea").style.display="none";
        $("create_window_table_text_input").style.display="block";
        if (globalcreate.inputtext) {
            $("create_window_text_input").style.display="";
            $("create_window_text_input").firstChild.data = globalcreate.inputtext;
        } else {
            $("create_window_text_input").style.display="none";
        }    
        $("create_window_text_field").value=globalcreate.inputvalue;
        setTimeout(function() { 
            if ($("create_window_text_field") && $("create_window_text_field").focus()) $("create_window_text_field").focus(); 
        },500);
    } else if(globalcreate.inputtype == "textarea") {
        $("create_window_table_textarea").style.display="block";
        $("create_window_table_text_input").style.display="none";
        $("create_window_textarea").firstChild.data = globalcreate.inputtext;    
        $("create_window_textarea_field").value=globalcreate.inputvalue;
        setTimeout(function() { 
            if ($("create_window_textarea_field") && $("create_window_textarea_field").focus()) $("create_window_textarea_field").focus(); 
        },500);
    }
    showNode("create_window");
    centerPopupWindow($("create_window"));
    $("create_window").style.display="block";
}
CreatePopup.close = function () {
    ox.api.setModal(false);
    hideNode("create_window");
    $("create_window").style.display="none";
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs= $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0;i<childs.length;i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display != "none" ) {
                closeall=false;
            }
        }
    }
    if (closeall === false) {
        ox.api.setModal(true);
    }
    if(globalcreate.closecb) { globalcreate.closecb(); }

}
CreatePopup.commitcancel = function () {
    CreatePopup.close();
    if(globalcreate.cbcancel) { globalcreate.cbcancel(); }
}
CreatePopup.commitok = function () {
    CreatePopup.close();
    if(globalcreate.cbok) { globalcreate.cbok(); }
}
CreatePopup.commitnocomment = function () {
    CreatePopup.close();
    if(globalcreate.cbnocomment) { globalcreate.cbnocomment(); }
}
CreatePopup.commitadvanced = function () {
    CreatePopup.close();
    if(globalcreate.cbadvanced) { globalcreate.cbadvanced(); }
}

CreatePopup.prototype = 
{
    setOK : function (cb) {
        this.cbok=cb;
    },
    setCancel : function (cb) {
        this.cbcancel=cb;
    },
    setAdvanced: function (cb) {
        this.cbadvanced=cb;
    },
    setClose: function (cb) {
        this.closecb=cb;
    },
    setNoComment : function (cb) {
        this.cbnocomment=cb;
    }
}
function newAlert(headertitle,alerttext,okcb,div) {
    globalalert.header=headertitle;
    globalalert.buttons=CreatePopup.OK;
    globalalert.text=alerttext;
    globalalert.div=div;
    globalalert.closecb=null;
    globalalert.cbok=okcb;
    globalalert.cbcancel=null;
    globalalert.cbnocomment=null;
    globalalert.cbyes=null;
    globalalert.cbno=null;
    globalalert.cbsave=null;
    AlertPopup.open();
}
function newConfirm(headertitle,contenttext,buttons,cbok,cbcancel,cbyes,cbno,cbseries,cbappointment,cbclose,cbnocomment,cbedit,div) {
    globalalert.header=headertitle;
    globalalert.buttons=buttons;
    globalalert.text=contenttext;
    globalalert.div=div;
    globalalert.closecb=cbclose;
    globalalert.cbok=cbok;
    globalalert.cbappointment=cbappointment;
    globalalert.cbseries=cbseries;
    globalalert.cbcancel=cbcancel;
    globalalert.cbedit=cbedit;
    globalalert.cbyes=cbyes;
    globalalert.cbno=cbno;
    globalalert.cbnocomment=cbnocomment;
    AlertPopup.open();    
}
function newInput(headertitle,contenttext,inputtext,inputvalue,buttons,cbok,cbcancel,cbadvanced,cbclose,
                                                                                    inputType,cbnocomment) {
    globalcreate.header=headertitle;
    globalcreate.text=contenttext;
    globalcreate.inputtext=inputtext;
    if(inputvalue)
        globalcreate.inputvalue=inputvalue;
    else
        globalcreate.inputvalue="";
    globalcreate.buttons=buttons;
    globalcreate.closecb=cbclose;
    globalcreate.cbok=cbok;
    globalcreate.cbcancel=cbcancel;
    globalcreate.cbnocomment=cbnocomment;
    globalcreate.cbadvanced=cbadvanced;
    if(inputType)
        globalcreate.inputtype=inputType;
    else
        globalcreate.inputvalue="input";
    CreatePopup.open();    
}
function newAppointmentObject(appointmentobject,myok,mycancel,myadvanced,myclose) {
    if(appointmentobject.start_date && appointmentobject.end_date) {
        var mystring=formatDate(appointmentobject.start_date,"datetime")+ " - "+formatDate(appointmentobject.end_date,"datetime"); 
        newInput(_("New Appointment"),mystring, pgettext("description", "Title"),"",CreatePopup.ALL,myok,mycancel,myadvanced,myclose);
    }
}
register("Loaded",function() {
    addOnClose($('alert_window'),function () {
    	delete(globalalert.leaveOpen);
        AlertPopup.close();
    });
    addOnClose($('create_window'),function () { 
        CreatePopup.close(); 
    });
});
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * @author Stefan Preuss <stefan.preuss@open-xchange.org>
 * 
 */

var globalconflicts = new ConflictsPopup();

function ConflictsPopup() {    
    this.object;
    this.conflicts;
    this.closecb;
    this.cbcancel;
    this.cbignore;
}

ConflictsPopup.tableTemplate;

ConflictsPopup.open = function (object,conflicts,closecb,cbcancel,cbignore) {
    globalconflicts.object = object;
    globalconflicts.conflicts = conflicts;
    globalconflicts.closecb = closecb;
    globalconflicts.cbcancel = cbcancel;
    globalconflicts.cbignore = cbignore;
    
    removeChildNodes($("conflict_window_appointments"));
    $("conflict_window_ignore").style.display = "block";
    $("conflict_recurrence_msg").style.display =
        object.recurrence_type ? "" : "none";
    
    // iterate trough each conflict and draw rows
    for (i in conflicts) {
        var table = newnode("tbody");
        var tmp = conflicts[i];
        var tr = document.createElement("tr");
        
        var img = newnode("img", { cursor:"pointer"}, { src: getFullImgSrc("img/minus.gif"), align:"absmiddle", width:16, height:16 });
        
        // draw each conflict in a seperate tr 
        tr.appendChild(newnode("td", 0, { className:"cell" },
                [ img ]));
        tr.appendChild(newnode("td", 0, { className:"cell" }, 
                [ document.createTextNode(tmp.title || _("Private")) ] ));
        var node_C = newnode("td", 0, { className:"cell" });      
        tr.appendChild(node_C);
        tr.appendChild(newnode("td", 0, { className:"cell" }, 
                [ tmp.start_date ? document.createTextNode(formatDate(tmp.start_date, isToday(tmp.start_date) ? "time" : "datetime")) : _("Private") ]));
                
        tr.appendChild(newnode("td", 0, { className:"cell" }, 
                [ tmp.end_date ? document.createTextNode(formatDate(tmp.end_date, isToday(tmp.end_date) ? "time" : "datetime")) : _("Private") ]));
        table.appendChild(tr);
        
        // resolving creator of appointment
        internalCache.getObjects([{ type:1, id:tmp.created_by }], (function(creator, node) {
            return function(user) {
                node.appendChild(document.createTextNode(user[creator.id].display_name || ""));
            };
        })({ type:1, id:tmp.created_by }, node_C));
            
        // creating participant rows
        var table_P = newnode("tbody");
        var tmp_T = ConflictsPopup.tableTemplate.cloneNode(true);
        tmp_T.style.padding="0px";
        tmp_T.appendChild(table_P);
        
        var tmp_TR = newnode("tr");
        img.onclick = (function(img, tr) {
            return function(e) {
                var isOpen = img.src.match(/minus.gif/gi);
                img.src = isOpen ? getFullImgSrc("img/plus.gif") : getFullImgSrc("img/minus.gif");
                tr.style.display = isOpen ? "none" : "";
            };
        })(img, tmp_TR);
        
        tmp_TR.appendChild(newnode("td",{padding:"0px"},{colSpan:5},[tmp_T])); 
        table.appendChild(tmp_TR);
        
        // using internal cache to resolve display names and append results to the given td node
        if (tmp.participants && tmp.participants.length) {
            internalCache.getObjects(tmp.participants, (function(cbObj, cb_node) {
                    return function(cb_participants) {
                        for (var ia=0; ia < cbObj.participants.length; ia++) {
                            var tmp_dn = cb_participants[cbObj.participants[ia].id].display_name || "";
                            var tr = newnode("tr");
                            
                            // draw each conflict in a seperate tr      
                            tr.appendChild(newnode("td", 0, { className:"cell" },
                                    [ newnode("img", null, { src:getFullImgSrc("img/dummy.gif"), align:"absmiddle", width:"16", height:"16" }) ]));

                            tr.appendChild(newnode("td", 0, { className:"cell" },
                                    [ 
                                        newnode("img", 0, 
                                            { src: getFullImgSrc("img/calendar/" + 
                                                (cb_participants[cbObj.participants[ia].id].type == 1 ? "user" : "ressourcen") + ".gif"), 
                                              align: "absmiddle", width: "16", height: "16" }),
                                        document.createTextNode(" " + tmp_dn) 
                                    ]));
                            
                            var confirmClass = "";
                            var confirmText = _("waiting");                        
                            switch(cbObj.participants[ia].confirmation) {
                                case 1:
                                   confirmClass = "appointmentACCEPTED";
                                   confirmText = _("accepted");
                                   break;
                                case 2:
                                   confirmClass = "appointmentDECLINED";
                                   confirmText = _("declined");
                                   break;
                                case 3:
                                   confirmClass = "appointmentTENTATIVE";
                                   confirmText = _("tentative");
                                   break;
                            }
                            confirmClass += " cell";
                            tr.appendChild(newnode("td", { colSpan:3 }, { className:confirmClass },
                                    [ document.createTextNode(confirmText) ]));
                            
                            cb_node.appendChild(tr);
                        }
                    };
                })(tmp, table_P));
        }
        
        // disable 'ignore conflict button' if any appointment hard conflicts 
        if (tmp.hard_conflict) {
            $("conflict_window_ignore").style.display = "none";
        }
        
        // finally append everything to container
        var finalNode = ConflictsPopup.tableTemplate.cloneNode(true);
        finalNode.style.borderBottom="1px dotted silver";
        finalNode.appendChild(table);
        $("conflict_window_appointments").appendChild(finalNode);
    }

    ox.api.setModal(true);
    //showNode("modal-dialog");
    //$("modal-dialog").style.display="block";
    
    
    showNode("disable_confirm_window");
    $("disable_confirm_window").style.display="block";

    showNode("conflict_window");
    centerPopupWindow($("conflict_window"));
    $("conflict_window").style.display="block";
    
};

ConflictsPopup.close = function () {
    if(globalconflicts.closecb) { 
        globalconflicts.closecb(globalconflicts.object); 
    }
    hideNode("conflict_window");
    $("conflict_window").style.display="none";    
    hideNode("disable_confirm_window");
    $("disable_confirm_window").style.display="none";
    var childs=    $("modal-dialog").childNodes;
    var closeall=true;
    for(var i=0; i<childs.length; i++) {
        if(childs[i].tagName && childs[i].tagName == "DIV") {
            if(childs[i].style.display && childs[i].style.display != "none" ) {
                closeall=false;
            }
        }
    }
    
    if(closeall) {
        ox.api.setModal(false);
        //hideNode("modal-dialog");
        //$("modal-dialog").style.display="none";
    }
};

ConflictsPopup.commitignore = function() {
    if (globalconflicts.cbignore) { 
        globalconflicts.cbignore(globalconflicts.object); 
    }
    ConflictsPopup.close();
};

ConflictsPopup.commitcancel = function() {
    if (globalconflicts.cbcancel) { 
        globalconflicts.cbcancel(globalconflicts.object); 
    }
    ConflictsPopup.close();
};

ConflictsPopup.prototype = {
    setIgnore : function (cb) {
        this.cbignore=cb;
    },
    setCancel : function (cb) {
        this.cbcancel=cb;
    },
    setClose: function (cb) {
        this.closecb=cb;
    }
};

register("Loaded",function() {
    addOnClose($("conflict_window"), function () { 
            ConflictsPopup.close(); 
        });
    
    // create table template for later use     
    ConflictsPopup.tableTemplate=newnode("table",{tableLayout:"fixed"},{width:"100%",cellPadding:0,cellSpacing:0},
        [
            newnode("colgroup",0,0,
                [
                    newnode("col",{width:"26px"},0),
                    newnode("col",0,0),
                    newnode("col",{width:"13em"},0),
                    newnode("col",{width:"11em"},0),
                    newnode("col",{width:"11em"},0)
                ])
        ]);
});

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Matthias Biggeleben <matthias.biggeleben@open-xchange.com>
 * 
 */

/*jslint white: false, browser: true, devel: true, evil: true, forin: true, undef: true, eqeqeq: true, immed: true */

/*global ox, window, jQuery, _, register, triggerEvent, addTranslated
*/

// namespace
ox.upsell = {};

(function () {

    // shortcut to jQuery
    var $ = jQuery,
        // namespace
        up = ox.upsell,
        // shortcut to config
        config = ox.api.config,
        // shortcut
        isFunction = ox.util.isFunction;
    
    /**
     * Permission matrix
     */
    up.matrix = {};
    
    (function () {
        
        // shortcut to matrix namespace
        var matrix = up.matrix,
            // permission levels (set of features)
            levels = {},
            // features
            features = {};
        
        /**
         * Add level
         */
        matrix.addLevel = function (id, fn) {
            if (id !== undefined && isFunction(fn)) {
                levels[String(id).toLowerCase()] = { id: id, check: fn };
            }
            return matrix; // chaining
        };
        
        /**
         * Check if user has a permission level
         */
        var l = matrix.hasLevel = function (id) {
            id = String(id).toLowerCase();
            return levels[id] !== undefined ? levels[id].check() : false;
        };
        
        /**
         * List levels
         */
        matrix.listLevels = function () {
            return levels;
        };
        
        /**
         * Add feature
         */
        matrix.addFeature = function (id, fn) {
            if (id !== undefined) {
                fn = isFunction(fn) ? fn : function () { return true; };
                features[String(id).toLowerCase()] = { id: id, check: fn };
            }
            return matrix; // chaining
        };
        
        /**
         * Remove feature
         */
        matrix.removeFeature = function (id) {
            delete features[String(id).toLowerCase()];
            return matrix; // chaining
        };
        
        /**
         * Check for feature
         */
        var f = matrix.hasFeature = function (str) {
            str = jQuery.trim(String(str)).toLowerCase().split(" ");
            var has = true, i = 0, $i = str.length, id,
                disabled = ox.api.config.get(["ui", "global", "disableFeature"], {});
            for (; has && i < $i; i++) {
                if ((id = str[i]) !== "") {
                    has = has && !disabled[id] && (features[id] !== undefined ? features[id].check() : false);
                }
            }
            return has;
        };
        
        /**
         * Get features
         */
        matrix.listFeatures = function () {
            return features;
        };
        
        // add features
        matrix
            .addFeature("configuration", function () {
                return true; // always - but in case someone checks that...
            })
            .addFeature("portal", function () {
                return config.get("modules.portal.module") === true;
            })
            .addFeature("mail", function () {
                return config.get("modules.mail.module") === true;
            })
            .addFeature("contacts", function () {
                return config.get("modules.contacts.module") === true;
            })
            .addFeature("calendar", function () {
                return config.get("modules.calendar.module") === true;
            })
            .addFeature("tasks", function () {
                return config.get("modules.tasks.module") === true;
            })
            .addFeature("usm", function () {
                return config.get(["modules", "com.openexchange.usm", "active"]) === true;
            })
            .addFeature("eas", function () {
                return config.get(["modules", "com.openexchange.usm.eas", "active"]) === true;
            })
            .addFeature("syncML", function () {
                return config.get(["modules", "com.openexchange.usm.syncml", "active"]) === true;
            })
            .addFeature("mobileApp", function () {
                return false;
            })
            .addFeature("infostore", function () {
                return config.get("modules.infostore.module") === true;
            })
            .addFeature("shared", function () {
                return config.get("modules.folder.read_create_shared_folders") === true;
            })
            .addFeature("public", function () {
                return config.get("modules.folder.public_folders") === true;
            })
            .addFeature("delegate", function () {
                return config.get("modules.tasks.delegate_tasks") === true;
            })
            .addFeature("teamview", function () {
                return f("shared") && f("public") && f("delegate");
            })
            .addFeature("olox", function () {
                return config.get("modules.olox20.active") === true;
            })
            .addFeature("subscribe", function () {
                return config.get(["modules", "com.openexchange.subscribe"]) === true;
            })
            .addFeature("freebusy", function () {
                return config.get("modules.calendar.calendar_freebusy") === true;
            })
            .addFeature("participants", function () {
                return config.get("participants.showDialog") === true;
            })
            // new folder
            .addFeature("mail-new-folder")
            .addFeature("contacts-new-folder")
            .addFeature("calendar-new-folder")
            .addFeature("tasks-new-folder")
            .addFeature("infostore-new-folder")
            
            // atomic features
            .addFeature("calendar-attachments")
            .addFeature("calendar-flags")
            .addFeature("calendar-copy-move")
            
            .addFeature("contacts-attachments")
            .addFeature("contacts-flags")
            .addFeature("contacts-copy-move")
            
            .addFeature("tasks-attachments")
            .addFeature("tasks-flags")
            .addFeature("tasks-copy-move")
            
            .addFeature("infostore-flags")
            .addFeature("infostore-copy-move")
        
            .addFeature("mail-flags")
            .addFeature("mail-copy-move");
        
        // levels
        matrix
            .addLevel("Webmail", function () {
                return f("contacts");
            })
            .addLevel("PIM", function () {
                return f("contacts") && f("calendar") && f("tasks");
            })
            .addLevel("PIM+Mobility", function () {
                return l("PIM") && f("usm") && (f("eas") || f("syncML") || f("mobileApp"));
            })
            .addLevel("PIM+Infostore", function () {
                return l("PIM") && f("infostore");
            })
            .addLevel("Standard", function () {
                return l("PIM+Infostore") && f("shared") && f("public") && f("delegate");
            })
            .addLevel("Premium", function () {
                return l("Standard") && f("usm") && (f("eas") || f("syncML") || f("olox") || f("mobileApp"));
            });
        
    }());
    
    // helper for visible checks
    var disabled = function (feature) {
        return ox.api.config.get(["ui", "global", "disableUpsell", feature], false) || ox.api.config.get("ui.global.disableUpsell.all", false);
    };

    /**
     * Visible for upsell?
     */
    up.visible = function (feature) {
        var hide;
        return function () {
            hide = hide !== undefined ? hide : disabled(feature);
            return hide === false || (up.matrix.hasFeature(feature) && String(url.disable).indexOf(feature) === -1);
        };
    };
    
    up.isVisible = function (feature) {
        return up.visible(feature)();
    };
    
    up.hasTrigger = function (feature) {
        return (!up.matrix.hasFeature(feature) || String(url.disable).indexOf(feature) > -1) && !disabled(feature);
    };
    
    /**
     * Default upsell action
     */
    up.defaultUpsellAction = function (id, win, trigger, e) {
        triggerEvent("Feature_Not_Available", id, win, trigger, e);
    };
    
    // helper
    var eq = function (type, id, bool) {
        if (type === "level") {
            return function () {
                return up.matrix.hasLevel(id) === bool;
            };
        } else if (type === "feature") {
            return function () {
                return up.matrix.hasFeature(id) === bool;
            };
        }
    };
    
    // default features
    var features = {
        
        "premium": {
            node: $.button({
                //#. Upsell: Premium upgrade. Must contain the ellipsis!
                title: _("Free trial..."),
                click: function (e) {
                    // trigger
                    triggerEvent("Feature_Not_Available", "premium", window, "sidepanel", e);
//                    // direct upgrade, no prompt
//                    up.external({
//                        id: "premium",
//                        trigger: "sidepanel",
//                        //#. Upsell
//                        title: _("Upgrade to premium"),
//                        src: "http://en.wikipedia.org/wiki/Loyalty_marketing"
//                    });
                }
            }).css({ "float": "right "}),
            visible: eq("level", "premium", false),
            forsale: true,
            module: "*",
            prio: 10000,
            upgrade: "premium"
        },
        "calendar.share": {
            //#. Upsell
            title: _("Share calendar"),
            visible: eq("level", "premium", false),
            forsale: eq("level", "premium", false),
            module: "calendar",
            tour: "Tour1",
            prio: 1000
        },
        "calendar.sync.mobile": {
            //#. Upsell
            title: _("Sync with mobile phone"),
            visible: true,
            forsale: eq("feature", "eas", false),
            module: "calendar",
            tour: "Tour1",
            prio: 100,
            action: function () {
                triggerEvent("Feature_SyncWithMobile");
            }
        },
        "sync.outlook": {
            //#. Upsell
            title: _("Synchronize with Outlook"),
            visible: true,
            forsale: eq("level", "premium", false),
            module: "mail calendar contacts",
            tour: "Tour1",
            prio: 50,
            action: function () {
                triggerEvent("Feature_MicrosoftOutlook");
            }
        },
        "contacts.share": {
            //#. Upsell
            title: _("Share your contacts"),
            visible: eq("level", "premium", false),
            forsale: eq("level", "premium", false),
            module: "contacts",
            tour: "Tour1",
            prio: 1000
        },
        "contacts.sync.mobile": {
            //#. Upsell
            title: _("Sync with mobile phone"),
            visible: true,
            forsale: eq("feature", "eas", false),
            module: "contacts",
            tour: "Tour1",
            prio: 100,
            action: function () {
                triggerEvent("Feature_SyncWithMobile");
            }
        },
        "contacts.subscribe": {
            //#. Upsell
            title: _("Subscribe contacts from LinkedIn, Facebook, Google..."),
            visible: true,
            forsale: eq("feature", "subscribe", false),
            module: "contacts",
            tour: "Tour1",
            prio: 101,
            action: function () {
                triggerEvent("Feature_Subscriptions");
            }
        },
        "tasks.share": {
            //#. Upsell
            title: _("Share tasks"),
            visible: eq("feature", "eas", false),
            forsale: eq("feature", "eas", false),
            module: "tasks",
            tour: "Tour1",
            prio: 1000
        }
    };
    
    // active features
    up.features = {};
    
    /**
     * Get feature
     */
    up.getFeature = function (id) {
        return up.features[id] || features[id];
    };
    
    /**
     * Enable default features
     */
    up.enableDefaultFeatures = function () {
        var id;
        for (id in features) {
            // copy
            features[id].id = id;
            up.features[id] = features[id];
        }
    };
    
    /**
     * Disable default features
     */
    up.disableDefaultFeatures = function () {
        var id;
        for (id in features) {
            // delete
            delete up.features[id];
        }
    };
    
    /**
     * Add custom feature
     */
    up.addFeature = function (id, options) {
        if (id !== undefined && options !== undefined) {
            options.id = id;
            up.features[id] = options;
        }
    };
    
    // internal helpers
    var sorterPrio = function (a, b) {
        return (a.prio || 100) - (b.prio || 100);
    };
    
    var evalState = function (flag) {
        // var
        var retVal;
        // is function?
        if (isFunction(flag)) {
            // get promise or boolean
            retVal = flag();
        } else {
            // get boolean
            retVal = !!flag;
        }
        // boolean?
        if (typeof retVal === "boolean") {
            // wrap boolean by deferred
            return $.Deferred().resolve(retVal).promise();
        } else {
            // return deferred
            return retVal;
        }
    };
    
    /**
     * Get features for module
     */
    up.getFeaturesByModule = function (module) {
        // loop over upgrades to get array
        var tmp = [], when = [];
        $.each(up.features, function (id) {
            // get
            var feature = up.features[id],
                m = String(feature.module);
            // proper module and for sale?
            if ((module === undefined || m === "*" || m.indexOf(module) > -1)) {
                // eval visible and wait for it
                when.push(
                    evalState(feature.visible)
                    .done(function (visible) {
                        if (visible) {
                            tmp.push(feature);
                        }
                    })
                );
            }
        });
        // new deferred
        var df = $.Deferred();
        $.when.apply(window, when)
        .then(function () {
            // sort by priority (asc)
            tmp.sort(sorterPrio);
            df.resolve(tmp);
        });
        return df;
    };
    
    /**
     * Call feature
     */
    up.callFeature = function (id, win, e) {
        // get feature
        var f = up.getFeature(id) || {};
        // is visible?
        evalState(f.visible).done(function (visible) {
            if (visible) {
                // is for sale?
                evalState(f.forsale).done(function (forsale) {
                    if (forsale) {
                        // custom/default upsell action?
                        var fn = isFunction(f.upsellAction) ? f.upsellAction : up.defaultUpsellAction;
                        // trigger upsell
                        fn(f.id, win, "sidepanel", e);
                    } else {
                        // call feature
                        if (isFunction(f.action)) {
                            f.action();
                        }
                    }
                });
            }
        });
    };
    
    // default paint methods
    var p = up.paint = {};
    
    /**
     * Common paint method
     */
    p.smartFeatures = function (node, opt, cont) {
        // vars
        var self = this,
            container,
            module = ox.UIController.getModule(),
            fnClick = function (e) {
                up.callFeature(e.data.id, window, e);
                e.preventDefault();
            };
        // get features
        up.getFeaturesByModule(module)
        .done(function (features) {
            // remember number of features
            self.numFeatures = features.length;
            // draw title?
            if (opt.title !== undefined) {
                node.append(
                    $("<div/>")
                        .addClass("sidepanelHeader upsell")
                        .append(addTranslated(opt.title))
                );
            }
            // add inner node
            container = $("<div/>").css("padding", "10px");
            // loop over features
            $.each(features, function (i, feature) {
                // create new node
                var div = $("<div/>").css({
                    lineHeight: "1em",
                    margin: "0 0 0.5em 0",
                    clear: "both"
                });
                // add custom node?
                if (feature.node !== undefined) {
                    div.append(feature.node.clone(true, true));
                } else {
                    div.append(
                        $("<a/>", { href: "#upgrade" })
                            .bind("click", feature, fnClick)
                            .append(addTranslated(feature.title))
                    );
                }
                // support customization
                p.smartFeaturesCustomize(div, feature);
                // add
                container.append(div);
            });
            // add tailing element
            container.append($("<div/>").css("clear", "both"));
            node.append(container);
            // continuation
            ox.util.call(cont);
        });
    };
    
    /**
     * Support for customized features
     */
    p.smartFeaturesCustomize = $.noop;
    
    /**
     * Extend sidepanel with custom widget
     */
    up.extendSidepanel = (function () {
    
        var defaultHeight = 50,
            guid = 0;
        
        var getHeight = function (opt, node) {
            return opt.height === "auto" ?
                $(node).children().first().outerHeight(true) :
                parseInt(opt.height, 10) || defaultHeight;
        };
        
        var applyModule = function (opt) {
            
            var module = ox.UIController.getModule(),
                self = this,
                validate = function () {
                    self.setLayoutParam("height", self.numFeatures > 0 ? getHeight(opt, self.dom.node) : 0);
                    ox.widgets.sidepanel.validate();
                };
            
            if (module !== "configuration" && (opt.module.indexOf(module) > -1 || opt.module === "*")) {
                // show
                // refresh first? (not for iframes)
                if (opt.refresh === true && opt.src === undefined) {
                    self.paint(function () {
                        validate();
                    });
                } else {
                    validate();
                }
            } else {
                // hide
                this.setLayoutParam("height", 0);
                ox.widgets.sidepanel.validate();
            }
        };
        
        return function (options) {
            
            // options
            var opt = $.extend({
                module: "*", // show for these modules (* = always)
                paint: $.noop, // paint method
                height: 50, // height in pixel
                css: {}, // custom css
                position: "below", // below/above mini calendar
                src: undefined, // external iframe
                refresh: false // refresh on module change
            }, options || {});
            
            // create widget
            var widget = new ox.gui.Custom(
                function (cont) {
                    // clear
                    var node = $(this.dom.node).empty();
                    // external page?
                    if (opt.src !== undefined) {
                        // add iframe
                        node.css({ padding: "0px" }).append(
                            $("<iframe/>", {
                                src: opt.src,
                                frameborder: "no",
                                scrolling: "no",
                                id: this.id + "-iframe"
                            }).css({
                                width: "100%",
                                height: opt.height
                            })
                        );
                    } else {
                        var div = $("<div/>")
                            .addClass("sidepanelContent upsell")
                            .css($.extend({}, opt.css))
                            .appendTo(node);
                        // call custom paint handler
                        $.proxy(opt.paint, this)(div, opt, cont);
                    }
                }, 
                "upsell-sidepanel-" + (guid++)
            );
            widget.addCSSClass("oxStretch")
                .css({
                    backgroundColor: "white"
                })
                .setLayoutParam({
                    position: "bottom",
                    height: 0
                });
                
            if (opt.position !== "below") {
                widget.css({ borderBottom: "1px solid #ccc" });
            }
            
            // add to sidepanel
            ox.widgets.sidepanel.insert(widget, opt.position === "below" ? 2 : 3);
            
            // extend widget
            widget.applyModule = applyModule;
            
            // pre-validate for auto height?
            if (opt.height === "auto") {
                ox.widgets.sidepanel.validate();
            }
            
            // apply current module
            widget.applyModule(opt);
            
            // bind to UIController
            ox.UIController.dispatcher.bind("modulechange", function (e) {
                // re-apply on module change
                widget.applyModule(opt);
            });
            
            return widget;
        };
    }());
    
    /**
     * Default source for external upsell processes
     */
    up.defaultSrc = "http://en.wikipedia.org/wiki/Upselling#feature=[id]&trigger=[trigger]&upgrade=[upgrade]";
    
    /**
     * Use default behavior
     */
    up.useDefaults = function (registerEvent) {
        // use default features
        up.enableDefaultFeatures();
        // extend side panel
        up.extendSidepanel({
            module: "*", // <-- all modules,
            paint: up.paint.smartFeatures,
            refresh: true, // refresh on module change
            height: "auto",
            css: {},
            //#. Upsell
            title: _("Premium features")
        });
        // register event?
        if (registerEvent !== false) {
            register("Feature_Not_Available", function (id, win, trigger, e) {
                up.prompt(id, trigger, function () {
                    // get feature
                    var f = up.getFeature(id) || {};
                    up.external({
                        id: id,
                        trigger: "sidepanel/" + trigger,
                        upgrade: f.upgrade || ""
                    });
                });
            });
        }
    };
    
    /**
     * Open external upsell process
     */
    up.external = function (options) {
        
        var opt, params, src, node;
        
        opt = $.extend({
            id: "",
            trigger: "",
            upgrade: "",
            src: up.defaultSrc,
            //#. Upsell
            title: _("Account upgrade")
        }, options);
        
        // format src
        params = {
            id: encodeURIComponent(opt.id),
            trigger: encodeURIComponent(opt.trigger || ""),
            upgrade: encodeURIComponent(opt.upgrade || "")
        };
        src = String(opt.src).format(params);
        
        node = $("<div/>")
            .addClass("busy-spinner-white")
            .append(
                $("<div/>")
                .css({ fontSize: "16pt", color: "#aaa", margin: "0 0 1em 0" })
                .text(String(opt.title))
            )
            .append(
                $("<iframe/>", {
                    src: src,
                    scrolling: "auto",
                    frameborder: "no"
                })
                .css({
                    height: "350px",
                    width: "100%"
                })
                .one("load", function () {
                    $(this).parent().removeClass("busy-spinner-white");
                })
            ).append(
                $("<div/>").css({
                    height: "30px",
                    margin: "10px 0 0 0"
                }).append(
                    $.button({
                        title: _("Close"),
                        click: function () {
                            node.popup("disable");
                            node = null;
                        }
                    }).css("float", "right")
                )
            )
            .popup($.extend({
                width: "850px",
                modal: true,
                left: Math.max(10, ($("body").width() - 850) / 2 >> 0),
                top: Math.max(10, ($("body").height() - 450) / 2 >> 0)
            }, options));
    };
    
    /**
     * Prompt for upsell
     */
    up.prompt = function (id, trigger, cont) {
        
        var controls, opt = up.getFeature(id) || {};
        
        var node = $("<div/>")
            .addClass("upsell-prompt")
            .append(
                $("<h2/>")
                    .css({ margin: "1em 0 2em 0"})
                    .text(
                        //#. Full sentence:
                        //#. This feature is not available but you can upgrade your account right now
                        _("This feature is not available") + " ..."
                    )
             )
            .append(
                $("<h1/>")
                    .css({
                        color: "#8BAD2D", width: "15em",
                        margin: "0 auto 2em auto", lineHeight: "1.2em",
                        textShadow: "5px 5px 10px #ddd", fontWeight: "normal"
                    })
                    .text(
                        //#. Full sentence:
                        //#. This feature is not available but you can upgrade your account right now.
                        "... " + _("but you can upgrade your account right now" + "!")
                    )
            )
            .append(
                controls = $("<div/>").css("textAlign", "right")
            );
            
            controls.append(
                $.button({
                    //#. Upsell
                    title: _("Yes, upgrade my account") + "...",
                    click: function (e) {
                        node.popup("disable");
                        node = null;
                        if (cont) {
                            cont(id, trigger);
                        }
                    }
                })
                .css({ fontWeight: "bold", margin: "0 1em 0 0" })
            );
            
            // add tour?
            if (opt.tour !== undefined && ox.api.help.Tour.exists(opt.tour)) {
                // add tour button
                controls.append(
                    $.button({
                        //#. Upsell
                        title: _("Tell me more..."),
                        click: function (e) {
                            node = null;
                            ox.api.help.Tour.load(opt.tour, function () {
                                up.prompt(id, trigger, cont);
                            });
                        }
                    })
                    .css({ margin: "0 1em 0 0" })
                );
            }
            
            controls.append(
                $.button({
                    //#. Upsell
                    title: _("No, not now"),
                    click: function (e) {
                        node.popup("disable");
                        node = null;
                    }
                })
            );
            
            node.popup({
                width: "500px",
                height: "200px",
                modal: true,
                left: Math.max(10, ($("body").width() - 500) / 2 >> 0),
                top: Math.max(10, ($("body").height() - 300) / 2 >> 0)
            });
    };
    
}());

/* ----------- Examples ------------ 

// "Hello World" upsell
ox.upsell.extendSidepanel({
    module: "mail", // <-- mail only
    paint: function (node, options) {
        node.html("Hello World!");
        // do whatever you want here (see http://api.jquery.com/)
        // "node" is a jQuery object referring to the widget's DOM node
    }
});

// "Hello World" upsell with different height & CSS
ox.upsell.extendSidepanel({
    module: "mail tasks", // <-- mail and tasks
    paint: function (node, options) {
        node.html("Hello World!");
    },
    height: 30,
    css: {
        backgroundColor: "lightyellow",
        border: "3px solid #fc0"
    }
});

// Upsell via external page -- show on ALL modules
ox.upsell.extendSidepanel({
    module: "*", // <-- all modules
    src: "http://www.open-xchange.com/en/node/1262/",
    height: 100
});

// Use common paint method
ox.upsell.enableDefaultFeatures();
ox.upsell.extendSidepanel({
    module: "*", // <-- all modules,
    paint: ox.upsell.paint.smartFeatures,
    refresh: true, // refresh on module change
    height: "auto",
    title: "Upgrade your account"
});

// Fast and easy upsell:
ox.upsell.useDefaults();

*/

/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 *
 */

var menulastviews = new Object();
var lastCalendarTimeRanges = { detail: "overview" }, configparentfolder = -1;
var menudisableattachment = false, menucountunlockable = 0;
var menucounteditable = 0, menucountselected = 0;
var menucountsubselected = 0, menunestedmessage = false;
var menuisdraftfolder = false, menuselectedobjects = new Array();
var menuselectedfolders = new Object(), menuglobalzaehler=0;
var menumailfoldertreecopy = false, menucountlockable = 0;

function initContents(modules) {
    if (modules !== "core") {
        return;
    }
    register("Loaded", function () {
        menumailloaded();
        menucalendarloaded();
        menucontactloaded();
        menuinfostoreloaded();
        menuregisterMailContents();
        menuregisterCalendarContents();
        menuregisterContactContents();
        menuregisterTaskContents();
        if (configGetKey("modules.infostore.module")) {
            menuregisterInfoStoreContents();
        }
        register("OX_Configuration_Move_Folder", function () {
            // get folder first in order to get its module
            ox.api.folder.get({
                folder: configfolder,
                success: function (data) {
                    createMenuPopUpTree("menu_configuration_folder_folderpopup",
                            data.module, function (data) {
                        jQuery("#menu_configuration_folder_folderpopup").hide();
                        ox.api.folder.get({
                            folder: configfolder,
                            success: function (folder) {
                                ox.api.folder.move(folder, data);
                            }
                        });
                    }, 4); // create subfolders
                    jQuery("#menu_configuration_folder_folderpopup").show();
                }
            });
        });
    });
}

function menumailloaded() {
    // create "Mark as" submenu
    var markas_submenu = new PopupMenu();
    var entries = {
            seen: _("Read"), unseen: _("Unread"),
            answer: _("Answered"), answered: _("Unanswered"),
            "delete": _("Deleted"), undelete: _("Undeleted")
    };
    (function fillItems(menu) {
        var items = {};
        for (var i in entries) {
            var item = items[i] = new MenuItem(entries[i], (function(flag) {
                return function() { triggerEvent("OX_Mail_Flag", flag); };
            })(i));
            menu.addItem(item);
        }
        menu.onShow = function() {
            var r = menucheckRight("READ");
            items.seen.setVisible(r);
            items.unseen.setVisible(r);
            var d = menucheckRight("DELETE");
            items["delete"].setVisible(d);
            items.undelete.setVisible(d);
            var w = menucheckRight("WRITE");
            items.answer.setVisible(w);
            items.answered.setVisible(w);
        };
    })(markas_submenu);

    var menu = globalContextMenus.mail = new ContextMenu();
    function one() { this.setEnabled(this.getContext().count == 1); }
    function many() { this.setEnabled(this.getContext().count > 0); }
    var items = [
    {
        text: _("Reply"), icon: "img/mail/reply",
        event: "OX_Mail_Reply", show: one
    }, {
        text: _("Reply all"), icon: "img/mail/reply_all",
        event: "OX_Mail_ReplyAll", show: one
    }, {
        text: _("Forward"), icon: "img/mail/forward",
        event: "OX_Mail_Forward", show: many
    }, {
        text: _("Delete"), icon: "img/menu/delete",
        event: "OX_Mail_Delete", show: function() {
            this.setEnabled(this.getContext().count > 0 && menucheckRight("DELETE"));
        }
    }, {
        text: _("Print"), icon: "img/menu/print",
        event: "OX_Print", show: many
    }, {
        //-----------------------
    }, {
        text: _("Mark as"), icon: "img/mail/mark_as",
        items: markas_submenu, show: many
    }, {
        //-----------------------
    }, {
        text: _("Save"), icon: "img/menu/save_as_link",
        event: "OX_Mail_SaveMail", show: many
    }, {
        text: _("Copy"), icon: "img/menu/copy_mail",
        event: "OX_Mail_Copy", show: function() {
            this.setVisible(ox.upsell.visible("mail-copy-move"));
            this.setEnabled(this.getContext().count > 0 && menucheckRight("DELETE"));
        }
    }, {
        text: _("Move"), icon: "img/menu/mail_move",
        event: "OX_Mail_Move", show: function() {
            this.setVisible(ox.upsell.visible("mail-copy-move"));
            this.setEnabled(this.getContext().count > 0);
        }
    }, {
        //-----------------------
    }, {
        text: _("Edit draft"), icon: "img/menu/edit_draft",
        icon_d: "img/dummy.gif", event: "OX_Mail_Edit_Draft",
        show: function() {
            this.setVisible(menuisdraftfolder);
            this.setEnabled(this.getContext().count == 1);
        }
    }, {
        text: _("Show source"), icon: "img/menu/view_emailsource",
        event: "OX_Mail_Show_Source", show: one
    }, {
        text: _("Spam"), icon: "img/mail/spam",
        event: "OX_Mail_Spam", show: function() {
            this.setVisible(   this.getContext().count > 0
                            && configGetKey("mail.spambutton")
                            && checkSpamFolder(true)
                            && getMailAccountIdByFolder(this.getContext().getSelected()[0].folder_id) == 0);
        }
    }, {
        text: _("Not Spam"), icon: "img/menu/ham",
        icon_d: "img/menu/ham.gif", event: "OX_Mail_Ham",
        show: function() {
            this.setVisible(   menucountselected > 0
                            && configGetKey("mail.spambutton")
                            && checkSpamFolder(false)
                            && getMailAccountIdByFolder(this.getContext().getSelected()[0].folder_id) == 0);
        }
    }];
    for (var i in items) {
        (function(def) {
            if (def.text) {
                var item = new MenuItem(def.text,
                        def.event ? function() { triggerEvent(def.event); } :
                            def.items
                );
                item.setIcon(def.icon + ".gif", def.icon_d || def.icon + "_d.gif");
                item.onShow = def.show;
            } else {
                var item = new MenuSeparator();
            }
            menu.addItem(item);
        })(items[i]);
    }
}
function menuregisterMailContents() {
    register("OX_Mail_Move",menumailmoveclicked);
    register("OX_Mail_Copy",menumailcopyclicked);
}

function menumailmoveclicked() {
    menumailfoldertreecopy=false;
    createMenuPopUpTree("menu_mail_move_foldertree","mail", doMailsFolder, 2); // create objects
    document.getElementById("menu_mail_move_foldertree").style.display="";
}

function menumailcopyclicked() {
    menumailfoldertreecopy=true;
    createMenuPopUpTree("menu_mail_move_foldertree","mail", doMailsFolder, 2); // create objects
    document.getElementById("menu_mail_move_foldertree").style.display="";
}

function doMailsFolder(data) {
    var selectedfolderid = data.id;
    if(menumailfoldertreecopy) {
        triggerEvent("OX_Object_Copy",selectedfolderid);
    } else {
        triggerEvent("OX_Object_Move",selectedfolderid);
    }
    document.getElementById("menu_mail_move_foldertree").style.display="none";
}

/**
 * Checks if all selected objects are outside/inside the spam folder.
 * Used to decide whether the Spam/Ham button should be displayed.
 * @param {Boolean} type Whether to check if all mails are outside (true, used
 * for the Spam button) or inside (false, used for the Ham button) the spam
 * folder.
 * @type Boolean
 * @return true if all selected objects are outside/inside the spam folder.
 * false if at least one selected object isn't, and therefore couldn't be moved
 * by the Spam/Ham button.
 */
function checkSpamFolder(type) {
    var spam = configGetKey("mail.folder.spam");
    for(var i in menuselectedobjects) {
        var folder = menuselectedobjects[i].folder;
        if(!folder) folder= menuselectedobjects[i].folder_id;
        if ((folder == spam) == type) return false;
    }
    return true;
}

/****************************************************************************************************/
/*** Calendar Function ******************************************************************************/
/****************************************************************************************************/
function menucalendarloaded() {
    var contextData = [];
    var count = Value(), writable = Value(), deletable = Value(), isPrivate = Value();
    var confirmable = Value(), acceptDenyVisible = Value();

    function drawCatsList(cats_sub, cats) {
        // remove all sub nodes first
        cats_sub.removeAllItems();

        // delete menu
        var del = new MenuItem(_("Delete all Categories"),
                function() { triggerEvent('OX_Delete_All_Categories'); }
        );
        del.setEnabledF(function() { return cats.length > 0; });
        cats_sub.addItem(del);

        // spacer
        cats_sub.addItem(new MenuSeparator());

        // category menu items (with color div)
        var categories = (ox.categories.list() || []);
        var $l = (categories.length > 10 ? 10 : categories.length);
        for (var i=0; i < $l; i++) {
            var item = new MenuItem(noI18n(categories[i].name),
                (function(category) {
                    return function() {
                        triggerEvent('OX_Add_Categories', [ category ]);
                    };
                })(categories[i].name));
            cats_sub.addItem(item);

            // drawing color divs and append as new menu item
            var node = item.node;
            var text = node.firstChild;
            removeChildNodes(node);
            node.appendChild(newnode("div",
                    { flt: "left", margin: "3px 5px 0 0" },
                    { className: "colorLabelCont bs ha colorLabel" + (categories[i].color || 0) }));
            node.appendChild(text);
        }

        // spacer
        cats_sub.addItem(new MenuSeparator());

        // all categories menu item (to open dialog)
        cats_sub.addItem(
                new MenuItem(_("All Categories..."),
                    function() { triggerEvent('OX_All_Categories'); }
                )
        );
    }

    var menu = globalContextMenus.calendar = new ContextMenu();

    var edit = new MenuItem(_("Edit"),
        function() { triggerEvent('OX_Calendar_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF(function() {
        return count() == 1 && writable() && !isPrivate();
    });
    menu.addItem(edit);

    var cats_s1 = new PopupMenu();
    cats_s1.onShow = function() {
        // getting selected apps
        var apps = contextData;
        // create consolidated list of categories
        var cats = [];
        for (var i in apps) {
            if (apps[i].categories) {
                cats.push(apps[i].categories);
            }
        }
        drawCatsList(cats_s1, cats);
    };

    var cats = new MenuItem(_("Categories"),
            cats_s1);
    cats.setIcon("img/mail/mark_as.gif", "img/mail/mark_as_d.gif");
    cats.setEnabledF(function() { return count() > 0 && !isPrivate(); });
    menu.addItem(cats);

    var del = new MenuItem(_("Delete"),
        function() { triggerEvent('OX_Calendar_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() { return count() > 0 && deletable() && !isPrivate(); });
    menu.addItem(del);

    menu.addItem(new MenuSeparator());

    var confirm = new MenuItem(_("Change confirmation"), function() {
        var objects = new Array(contextData.length);
        for (var i = 0; i < objects.length; i++) {
            objects[i] = new AcceptDenyObject("calendar", contextData[i]);
        }
        (new AcceptDeny(true)).showConfirmation(objects);
    });
    confirm.setIcon("img/menu/global_confirmation_change.gif",
                    "img/menu/global_conf_change_d.gif");
    confirm.setEnabledF(function() {
        return count() > 0 && !acceptDenyVisible() && confirmable() && !isPrivate();
    });
    menu.addItem(confirm);

    menu.onShow = function() {
        acceptDenyVisible.set(AcceptDeny.visible);
        var objects = clone(this.getContext().getSelected());
        count.set(objects.length);
        if (!objects.length) return;
        for (var i = 0; i < objects.length; i++) {
            objects[i].module = "calendar";
            objects[i].folder_id = objects[i].folder;
            delete objects[i].folder;
        }
        writable.clear();
        deletable.clear();
        confirmable.clear();
        isPrivate.clear();
        var collection = { columns: [ "created_by", "users", "title", "location",
                                     "start_date", "end_date", "categories", "private_flag" ],
                           objects: objects };

        OXCache.newRequest(null, "calendar", collection, null, responseData);

        function responseData(data) {
            contextData = data.objects;
            ox.api.folder.get({
                folder: activefolder,
                success: function(response){
                    handleResponse(response, contextData);
                }
            });
        }
        function handleResponse(folder, contextData) {
            writable.set(menuhasRight(contextData, "WRITE"));
            deletable.set(menuhasRight(contextData, "DELETE"));
            if (!writable.value) {
                confirmable.set(false);
            }
            isPrivate.set(false);
            var shared = folder.created_by != configGetKey('identifier');
            var tmpPrivate = false;
            var me = folder.type == 3 ? folder.created_by
                                      : configGetKey("identifier");
            for (var i in contextData) {
                var users = contextData[i].users;
                if (shared == true && contextData[i].private_flag == true) {
                    isPrivate.set(true);
                }
                CheckUsers: {
                    for(var j = 0; j < users.length; j++) {
                        if (users[j].id == me) {
                            confirmable.set(true);
                            break CheckUsers;
                        }
                    }
                    confirmable.set(false);
                    return;
                }
            }
        }
    };


    // Team view context menu
    var menu = globalContextMenus.teamview = new ContextMenu();

    // Edit
    var edit = new MenuItem(_("Edit"),
        function() { triggerEvent('OX_Calendar_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF(function() { return count() == 1; });
    menu.addItem(edit);

    var cats_s2 = new PopupMenu();
    cats_s2.onShow = function() {
        // getting selected apps
        var apps = clone(this.getContext().getSelectedItems());
        // create consolidated list of categories
        var cats = [];
        for (var i in apps) {
            if (apps[i].categories) {
                cats.push(apps[i].categories);
            }
        }
        drawCatsList(cats_s2, cats);
    };

    var cats = new MenuItem(_("Categories"),
            cats_s2);
    cats.setIcon("img/mail/mark_as.gif", "img/mail/mark_as_d.gif");
    cats.setEnabledF(function() { return count() > 0; });
    menu.addItem(cats);

    // Delete
    var del = new MenuItem(_("Delete"),
        function() { triggerEvent('OX_Calendar_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() { return count() > 0; });
    menu.addItem(del);

    menu.onShow = function() {
        // get number of selected appointments
        var c = this.getContext().numSelected();
        count.set(c);
    };
}

function menuregisterCalendarContents() {
    register("OX_Calendar_Move", menucalendarmoveclicked);
}
function menucalendarmoveclicked() {
    createMenuPopUpTree("menu_calendar_move_foldertree", "calendar",
        moveCalendarFolder, 2); // create objects
    jQuery("#menu_calendar_move_foldertree").show();
}
function moveCalendarFolder(data) {
    var selectedfolderid = data.id;
    triggerEvent("OX_Object_Move", selectedfolderid);
    jQuery("#menu_calendar_move_foldertree").hide();
}

/****************************************************************************************************/
/*** Task Function ******************************************************************************/
/****************************************************************************************************/
function menutasksloaded() {
    addOnClose($('menu_tasks_move_foldertree'), function () {
        $('menu_tasks_move_foldertree').style.display = "none";
    });
}

function menuregisterTaskContents() {
    register("OX_Task_Move", menutaskmoveclicked);
}

function menutaskmoveclicked() {
    createMenuPopUpTree("menu_tasks_move_foldertree","tasks",
        moveTasksFolder, 2); // create objects
    document.getElementById("menu_tasks_move_foldertree").style.display="";
}

function moveTasksFolder(data) {
    var selectedfolderid = data.id;
    triggerEvent("OX_Object_Move",selectedfolderid);
    document.getElementById("menu_tasks_move_foldertree").style.display="none";
}

/****************************************************************************************************/
/*** Contact Function ******************************************************************************/
/****************************************************************************************************/
var menucontactfoldertreecopy=false;
function menucontactloaded() {
    var menu = globalContextMenus.contacts = new ContextMenu();
    var count = Value(), writable = Value(), deletable = Value();

    // Edit contact
    var edit = new MenuItem(_("Edit"),
        function() { triggerEvent('OX_Contact_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF(function() { return count() == 1 && writable(); });
    menu.addItem(edit);

    // Delete contact
    var del = new MenuItem(_("Delete"),
        function() { triggerEvent('OX_Contact_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() { return count() > 0 && deletable(); });
    menu.addItem(del);

    menu.addItem(new MenuSeparator());

    // Copy contact
    var copy = new MenuItem(_("Copy"),
        function() { triggerEvent('OX_Contact_Copy'); });
    copy.setIcon("img/menu/contact_copy.gif", "img/menu/contact_copy_d.gif");
    copy.setEnabledF(function() { return count() > 0 && ox.upsell.visible("contact-copy-move"); });
    menu.addItem(copy);

    // Move contact
    var move = new MenuItem(_("Move"),
        function() { triggerEvent('OX_Contact_Move'); });
    move.setIcon("img/menu/contact_move.gif", "img/menu/contact_move_d.gif");
    move.setEnabledF(function() { return count() > 0 && deletable() && ox.upsell.visible("contact-copy-move"); });
    menu.addItem(move);

    // Use contact as template
    var template = new MenuItem(_("Use as template"),
        function() { triggerEvent('OX_Contact_Duplicate'); });
    template.setIcon("img/menu/duplicate_contacts.gif",
                     "img/menu/duplicate_contacts_d.gif");
    template.setEnabledF(function() { return count() == 1 && writable(); });
    menu.addItem(template);

    menu.addItem(new MenuSeparator());

    // Send email to contact
    var sendMailTo = new MenuItem(_("Send E-Mail"),
        function() { triggerEvent('OX_Contact_SendMail'); });
    sendMailTo.setIcon("img/mail/write_mail.gif", "img/mail/write_mail.gif");
    sendMailTo.setEnabledF(function() { return count() > 0; });
    menu.addItem(sendMailTo);

    // Send contact as vCard
    var sendVCard = new MenuItem(_("Send as vCard"),
        function() { triggerEvent('OX_Contact_SendVCard'); });
    sendVCard.setIcon("img/mail/forward.gif", "img/mail/forward_d.gif");
    sendVCard.setEnabledF(function() { return count() > 0; });
    menu.addItem(sendVCard);

    // context menu - onShow handler
    menu.onShow = function() {
        var collection = { columns: ["created_by"],
                           objects: this.getContext().getSelected() };
        count.set(collection.objects.length);
        if (!count.value) return;
        OXCache.newRequest(null, "contacts", collection, null, responseData);
        function responseData(data) {
            writable.set(menuhasRight(data.objects, "WRITE"));
            deletable.set(menuhasRight(data.objects, "DELETE"));
        }
    };
}

function menuregisterContactContents() {
    register("OX_Contact_Move",menucontactmoveclicked);
    register("OX_Contact_Copy",menucontactcopyclicked);
}
function menucontactmoveclicked() {
    createMenuPopUpTree("menu_contacts_move_foldertree", "contacts",
        doContactsFolder, 2); // create objects
    document.getElementById("menu_contacts_move_foldertree").style.display="";
    menucontactfoldertreecopy=false;
}

function menucontactcopyclicked() {
    createMenuPopUpTree("menu_contacts_move_foldertree", "contacts",
        doContactsFolder, 2); // create objects
    document.getElementById("menu_contacts_move_foldertree").style.display="";
    menucontactfoldertreecopy=true;
}

function doContactsFolder(data) {
    var selectedfolderid = data.id;
    if (menucontactfoldertreecopy) {
        triggerEvent("OX_Object_Copy",selectedfolderid);
    } else {
        triggerEvent("OX_Object_Move",selectedfolderid);
    }
    document.getElementById("menu_contacts_move_foldertree").style.display="none";
}

/****************************************************************************************************/
/*** InfoStore Function ******************************************************************************/
/****************************************************************************************************/

function menuinfostoreloaded() {
    var menu = globalContextMenus.infostore = new ContextMenu();
    var contextData = [];
    var count = Value(), readable = Value(), writable = Value();
    var editable = Value(), deletable = Value(), lockable = Value();
    var unlockable = Value(), hasFile = Value();;

    var edit = new MenuItem(_("Edit"),
        function() { triggerEvent('OX_InfoStore_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF( function() {
        return count() == 1 && writable() && editable();
    });
    menu.addItem(edit);

    var del = new MenuItem(_("Delete"),
        function() { triggerEvent('OX_InfoStore_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() {
        return count() > 0 && (lockable() || unlockable()) && deletable();
    });
    menu.addItem(del);

    menu.addItem(new MenuSeparator());

    var lock = new MenuItem(_("Lock"),
        function() { triggerEvent('OX_InfoStore_Lock'); });
    lock.setIcon("img/menu/sperren.gif", "img/menu/sperren_d.gif");
    lock.setEnabledF(function() {
        return count() > 0 && writable() && lockable();
    });
    menu.addItem(lock);

    var unlock = new MenuItem(_("Unlock"),
        function() { triggerEvent('OX_InfoStore_Unlock'); });
    unlock.setIcon("img/menu/entsperren.gif", "img/menu/entsperren_d.gif");
    unlock.setEnabledF(function() {
        return count() > 0 && writable() && unlockable();
    });
    menu.addItem(unlock);

    menu.addItem(new MenuSeparator());

    var attach = new MenuItem(_("Send as attachment"),
        function() { triggerEvent('OX_InfoStore_Send_Attachment'); });
    attach.setIcon("img/menu/alsanlagesenden.gif",
                   "img/menu/alsanlagesenden_d.gif");
    attach.setEnabledF(function() {
        return configGetKey("modules.mail.module") &&
            count() > 0 && readable() && hasFile();
    });
    menu.addItem(attach);

    var link = new MenuItem(_("Send as link"),
        function() { triggerEvent('OX_InfoStore_Send_Link'); });
    link.setIcon("img/menu/save_as_link.gif", "img/menu/save_as_link_d.gif");
    link.setEnabledF(function() {
        return ("infostore_sendLink" in window) && count() > 0 && readable();
    });
    menu.addItem(link);

    var open = new MenuItem(_("Open"), function() {
        triggerEvent('OX_InfoStore_Open_Attachment', contextData);
    });
    open.setIcon("img/mail/open_ISattachment.gif",
                 "img/mail/open_ISattachment_d.gif");
    open.setEnabledF(function() { return count() >= 1 && hasFile(); });
    menu.addItem(open);

    var save = new MenuItem(_("Save"), function() {
        triggerEvent("OX_InfoStore_Save_Attachment", contextData);
    });
    save.setIcon("img/menu/attachment_save.gif",
                 "img/menu/attachment_save_d.gif");
    save.setEnabledF(function() { return count() >= 1 && hasFile(); });
    menu.addItem(save);

    menu.onShow = function() {
        var collection = {
            columns: ["created_by", "modified_by", "locked_until", "file_size",
                      "filename"],
            objects: this.getContext().getSelected()
        };
        count.set(collection.objects.length);
        if (!count.value) return;
        readable.clear();
        writable.clear();
        editable.clear();
        deletable.clear();
        lockable.clear();
        unlockable.clear();
        hasFile.clear();
        OXCache.newRequest(null, "infostore", collection, null, responseData);
        function responseData(data) {
            contextData = data.objects;
            var l = true, ul = true, e = true;
            var me = configGetKey("identifier");
            for (var i in contextData) {
                var item = contextData[i];
                if (!item.locked_until) ul = false; else {
                    l = false;
                    if (item.modified_by != me) {
                        e = false;
                        if (item.created_by != me) ul = false;
                    }
                }
            }
            lockable.set(l);
            unlockable.set(ul);
            editable.set(e);
            menuhasRightandLoad(contextData, "READ",
                function(can) {
                    readable.set(can);
                    hasFile.set(can && hasAttachment(contextData));
                });
            menuhasRightandLoad(contextData, "WRITE",
                function(can) { writable.set(can); });
            menuhasRightandLoad(contextData, "DELETE",
                function(can) { deletable.set(can); });
        }
    };

    function hasAttachment(myobjects) {
        for(var i in myobjects) {
            if(!(myobjects[i]["file_size"]>0)) {
                return false;
            }
        }
        return true;
    };
}
function menuregisterInfoStoreContents() {
    register("OX_InfoStore_Move",menuinfostoremoveclicked);
    register("OX_Search_InfoStore",onmenusearchInfoStore);
}

function onmenusearchInfoStore() {
    var mysearchparam=document.getElementById("menu_search_infostore_searchfield").value;
    var mysearch=new Object();
    mysearch["pattern"]=mysearchparam;
    triggerEvent("OX_InfoStore_Search",mysearch);
}

function menuinfostoremoveclicked() {
    register("OX_InfoStore_Move",menuinfostoremoveclicked);
    createMenuPopUpTree("menu_infostore_move_foldertree", "infostore",
        moveInfoStoreFolder, 2); // create objects
    document.getElementById("menu_infostore_move_foldertree").style.display="";
}

function moveInfoStoreFolder(data) {
    var selectedfolderid = data.id;
    triggerEvent("OX_Object_Move",selectedfolderid);
    document.getElementById("menu_infostore_move_foldertree").style.display="none";
}

function menucheckRight(right) {
    return menuhasRight(menuselectedobjects,right);
}
function menuhasRightandLoad(selectedobjects,right,cbtrue,cbfalse) {
    var folders = {};
    for(var i in selectedobjects) {
        var folder = selectedobjects[i];
        var id = folder.folder || folder.folder_id;
        folders[id] = true;
    }
    var folderList = [];
    for (var i in folders) folderList.push(i);
    ox.api.folder.getMultiple({
        list: folderList,
        success: function (data) {
            if (menuhasRight(selectedobjects, right, data)) {
                if (cbtrue) cbtrue(true);
            } else {
                if (cbfalse) cbfalse(); else if (cbtrue) cbtrue(false);
            }
        }
    });
}

function menuhasRight(selectedobjects,right,resp) {
    right = { READ: 7, WRITE: 14, DELETE: 21, ADMIN: 28, USER: 29 }[right];
    if (!right) return false;
    function getFolder(folder) {
        return menuselectedfolders[folder] || resp && resp[folder];
    }
    var me = configGetKey("identifier");
    var rights = {};
    for (var i in selectedobjects) {
        var o = selectedobjects[i];
        var fid = o.folder || o.folder_id;
        if (!rights[fid]) {
            var folder = getFolder(fid);
            if (!folder) return false;
            switch (rights[fid] = computePerm(folder.own_rights, right)) {
                case 0:
                    return false;
                case 1:
                    if (right >= 28) rights[fid] = 2;
            }
        }
        if (rights[fid] == 1 && o.created_by != me) return false;
    }
    return true;
}

function createMenuPopUpTree(elementid, moduletype, executeFunction, minPerms) {
    ox.api.ui.selectFolder({
        type: moduletype,
        id: "select-folder-popup-" + moduletype,
        callback: executeFunction,
        node: $(elementid+"_content"),
        minPerms: minPerms
    });
}

function newServerError(args, level) {
	if (args.error) {
		var sizes = {
			"MSG-0028": [0, 2], "MSG-0029": [0], "NON-0005": [0, 1],
			"AJP-0006": [0], "FLS-0003": [0, 1, 2], "CON-0101": [1, 2],
			"AJP-0020": [0, 1]
		}[args.code];
		if (sizes) {
			for (var i = 0; i < sizes.length; i++) {
				args.error_params[sizes[i]] = bytesToString(args.error_params[sizes[i]]);
			}
		}
        triggerEvent("OX_New_Error", (level || 4), formatError(args), args);
	}
}

function loadDefaultModules() {
    var modules = ox.api.ui.listModules();
    for (var i in modules) {
        var configPath = "gui." + modules[i].name + ".view";
        if(!modules[i].disable && configContainsKey(configPath)) {
            var defaults = configGetKey(configPath);
            if (modules[i].name == "calendar") {
                defaults = configGetKey("gui.calendar.views");
                if (!configGetKey("modules.calendar.calendar_teamview") &&
                        defaults.view == "team") {
                    defaults.view = "calendar";
                    configSetKey("gui.calendar.views.view", "calendar");
                }
                menulastviews.calendar = getDefaultCalendarView();
                lastCalendarTimeRanges.calendar = defaults.calendar;
                lastCalendarTimeRanges.team = defaults.team;
                lastCalendarTimeRanges.list = defaults.list;
            } else {
                menulastviews[modules[i].name] = configGetKey(configPath);
            }
        } else {
            if (modules[i].name== "configuration") {
                menulastviews[modules[i].name] = "configuration/settings";
            } else {
                menulastviews[modules[i].name] = modules[i].name;
            }
        }
    }
}

function switchtoView(newview, param) {

    var elements = newview.split("/");
    var newmodule= elements[0];

    // continuation
    var cont = function () {
        if (isDefaultableView(newview)) {
            menulastviews[newmodule] = newview;
            if (newmodule === "calendar" && elements[1] !== "detail") {
                lastCalendarTimeRanges[elements[1]] = elements[2];
            }
        }
        changeView(newview, param, true);
        triggerEvent("OX_Switched");
        // toolbar resize fix
        // fixes: jump into folder props from portal (i.e. collapsed toolbar; but still in portal somehow)
        if (ox.ToolBarController && ox.ToolBarController.initialResize) {
            ox.ToolBarController.initialResize();
        }
    };

    // change module? (check for UIController since we might be in nested windows)
    // special case: configuration/folder|import does not change to configuration
    var isHybridConfig = /^configuration\/(folder|import)/.test(newview);
    if (ox.UIController && !isHybridConfig && newmodule !== ox.UIController.getModule()) {
        // set module
        ox.UIController.setModule({
            module: newmodule,
            success: cont
        });
    } else {
        cont();
    }
}

function menufollowLink(mymodule,object) {
    if (mymodule == "task") {
        mymodule = "tasks";
    }

    var view = mymodule + "/detail/overview";
    activefolder = object.folder;
    if (!object.folder_id && object.folder) {
        object.folder_id = object.folder;
    }
    if (!object.module) {
        object.module = mymodule;
    }
    menucountselected = 1;
    menucountsubselected = 0;
    var oArray = new Array();
    oArray.push(object);
    switch(mymodule) {
        case "infostore":
            view = menulastviews[mymodule] || mymodule+"/split/overview";
            if (object.id) {
                view = mymodule+"/split/overview";
                object["directLink"] = true;
                oLastSelectedInfoObject = new Array();
                oLastSelectedInfoObject[0] = object;
            }
            break;
        case "contacts":
            if (object.id) {
                object["directLink"] = true;
                contactDetailId = object;
            } else {
                view = menulastviews[mymodule] || configGetKey("gui.contacts.view");
            }
            break;
        case "calendar":
            if (object.id) {
                object["directLink"] = true;
                selectedAppointment = object;
            } else {
                view = getLastCalendarView();
            }
            break;
        case "tasks":
            view = menulastviews[mymodule] || configGetKey("gui.tasks.view");
            if (object.id) {
                view = mymodule+"/split/overview";
                object["directLink"] = true;
                activeTaskId = new Array();
                activeTaskId[0]=object;
            }
            break;
        case "mail":
            view = menulastviews[mymodule] || configGetKey("gui.mail.view");
            if (object.id) {
                if (view.match(/mail\/list/gi)) view = mymodule + "/hsplit/unthreaded";
                object["directLink"]=true;
                mail_lastSelectedId=object;
            }
    }
    var folderChanged = (activefolder == object.folder);
    // use new UI controller
    ox.UIController.setFolder({
        folder: object.folder,
        module: "default",
        view: view,
        force: "folder",
        success: function () {
            // selection only possible with id
            if (object.id) {
                triggerEvent("Selected", oArray);
            }
        }
    });
}

function folderUsersUpsell() {
    if (configGetKey("modules.folder.read_create_shared_folders")) return;
    ox.api.folder.get({
        folder: configparentfolder != -1 ? configparentfolder : configfolder,
        success: function (folder) {
            var haveadminrights = configparentfolder == -1
                ? folder.own_rights & (1 << 28) // admin flag
                : folder.own_rights & 127 >= 4; // folder permissions >= create subfolders
            var haveadminrights2 = folder.type == 5 &&
                configGetKey("modules.folder.public_folders");
            if (haveadminrights && !haveadminrights2) {
                triggerEvent("Feature_Not_Available", "modules/folders/users", window);
            }
        }
    });
}

function menuswitchConfigurationFolderView(param) {
    var newpath = currentpath2.slice(0);
    newpath[2] = param;
    newpath.length = 3;
    switchtoView(newpath.join("/"));
}

/**
 * Shows or hides a menu element in the specified view.
 * @param {String} name The name of the view as used for registerView.
 * @param {String} id The ID of the DOM node which will be shown in the view.
 * @param {Boolean} hide If true, a previously shown element will be hidden.
 */
function changeDisplay(name, id, hide) {
    var change = changeDisplay.changes[name];
    if (change) change = change[id];
    if (hide) {
        if (change) {
            delete changeDisplay.changes[name][id];
        } else {
            console.error("Invalid changeDisplay", name, id);
        }
    } else {
        if (change) {
        } else {
            var views = ox.widgets.toolBar.views;
            if (name in views) {
                MenuNodes.contexts[id].node.addTo(views[name].children[0]);
            } else {
                var changes = changeDisplay.changes[name];
                if (!changes) changes = changeDisplay.changes[name] = {};
                changes[id] = true;
            }
        }
    }
}
changeDisplay.changes = {};
changeDisplay.update = function(name) {
    if (name in changeDisplay.changes) {
        var tab = ox.widgets.toolBar.views[name].children[0];
        for (var id in changeDisplay.changes[name]) {
            MenuNodes.contexts[id].node.addTo(tab);
        }
        delete changeDisplay.changes[name];
    }
};

function menuswitchMailView(param) {
    var newpath = currentpath2.slice(0);
    newpath[1] = param;
    switch (param)  {
        case "list":
        case "vsplit":
        case "hsplit":
            if (newpath[2]) {
                if (newpath[2] != "unthreaded" && newpath[2] != "threaded") {
                    newpath.length = 3;
                    newpath[2] = "unthreaded";
                    break;
                }
            } else {
                newpath[2] = "unthreaded";
            }
            break;
    }
    switchtoView(newpath.join("/"));
}

function menuswitchCalendarView(param) {
    var range = lastCalendarTimeRanges[param];
    if (   param != "detail" && currentpath2[1] != "detail"
        && currentpath2[2] != "search"
        && configGetKey("gui.calendar.views.shared"))
    {
        range = currentpath2[2];
    }
    switchtoView("calendar/" + param + "/" + range);
}
function menuswitchCalendarTimerange(param) {
    var newpath = currentpath2.slice(0);
    newpath[2] = param;
    if (newpath[1] == "detail") {
        newpath[1] = "calendar";
        if (menulastviews["calendar"] !== undefined) {
            newpath[1] = menulastviews["calendar"].split("/")[1];
        }
    }
    newpath.length = 3;
    switchtoView(newpath.join("/"));
}

function menuswitchCalendarDetail(param) {
    var newpath = currentpath2.slice(0);
    newpath[2] = param;
    newpath.length = 3;
    switchtoView(newpath.join("/"));
}

function menuswitchContactView(param) {
    var newpath = currentpath2.slice(0);
    newpath[1] = param;
    switch (param)  {
        case "phonelist":
        case "cards":
            newpath.length = 2;
            break;
        case "detail":
            newpath[2] = "overview";
            newpath.length = 3;
            break;
    }
    switchtoView(newpath.join("/"));
}

function menuswitchContactDetail(param) {
    var newpath = currentpath2.slice(0);
    newpath[2] = param;
    newpath.length = 3;
    switchtoView(newpath.join("/"));
}

function menuswitchContactNew(param) {
    var newpath = currentpath2.slice(0);
    newpath[1] = param;
    newpath.length = 2;
    switchtoView(newpath.join("/"));
}

function menuswitchInfoStoreDetail(param) {
    var newpath = currentpath2.slice(0);
    newpath[2] = param;
    newpath.length = 3;
    switchtoView(newpath.join("/"));
}

function menuswitchTaskView(param) {
    var newpath = currentpath2.slice(0);
    newpath[1] = param;
    switch (param)  {
    case "list":
        case "split":
            newpath.length = 2;
            break;
        case "detail":
            newpath[2] = "overview";
            newpath.length = 3;
            break;
    }
    switchtoView(newpath.join("/"));
}
function menuswitchTaskDetail(param) {
    var newpath = currentpath2.slice(0);
    newpath[2] = param;
    newpath.length = 3;
    switchtoView(newpath.join("/"));
}

function menuswitchTaskNew(param) {
    var newpath = currentpath2.slice(0);
    newpath[1] = param;
    newpath.length = 2;
    switchtoView(newpath.join("/"));
}

register("OX_Configuration_Set_Empty", loadDefaultModules);
register("OX_Switch_View", switchtoView);
register("OX_Direct_Linking", function(modulename, object) {
    menufollowLink(modulename,object);
});

register("OX_Selected_Nested",function (nestedbool) {
    menunestedmessage = nestedbool;
});

register("OX_Selected_Draft",function (draftbool) {
    menuisdraftfolder = draftbool;
});

register("Selected",function (selected) {
    if(!equals(menuselectedobjects,selected)) {
        menucountselected = selected.length;
        menuselectedobjects = selected;
        var ids = {};
        for (var i = 0; i < menuselectedobjects.length; i++) {
            var object = menuselectedobjects[i];
            ids[object.folder || object.folder_id] = true;
        }
        var idList = [];
        for (var i in ids) idList.push(i);
        ox.api.folder.getMultiple({
            list: idList,
            success: function (folders) {
                menuselectedfolders = folders;
                triggerEvent("OX_SELECTED_ITEMS_CHANGED", menucountselected);
                triggerEvent("OX_SELECTION_CHANGED", menucountselected);
            }
        });
    }
});

register("SubSelected", function(selected,disable) {
    menucountsubselected = selected;
    if (disable) {
        menudisableattachment = true;
    } else {
        menudisableattachment = false;
    }
});

register("OX_Selected_Member", function(selected) {
    triggerEvent("SubSelected", selected.length);
});

register("OX_Lockable",function(lock, unlock, editlock) {
    menucountlockable = lock;
    menucountunlockable = unlock;
    menucounteditable = editlock;
});

function resizeToolbar() {
    try {
        if (ox.ToolBarController) {
            setTimeout(function() {
                ox.ToolBarController.initialResize();
            }, 0);
        }
   } catch (e) { }
}

register("OX_menu_Change_Height", resizeToolbar);

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
*/
var myfullname;

function getPersonalFullName() {
	return myfullname;
}
register("Preload",function () {
	initContents("core");	
});

register("OX_Configuration_Set_Empty", function() {
    var id = config.identifier;
	internalCache.getUsers([id], function (resp) {
	    myfullname = resp[id].display_name;
	});
});

function AboutPopup() {
}
AboutPopup.openWindow = function () {
    ox.api.setModal(true);
//	showNode("modal-dialog");
//	$("modal-dialog").style.display="block";
	showNode("global_about");
    
	centerPopupWindow($("global_about"));
	$("global_about").style.display="block";
	
	// do resize
	var height = jQuery($("global_about_content")).children().height() + 30;
    jQuery("#global_about").css("height",  height + "px");
    jQuery("#global_about_content").css("height",  height + "px");
};
AboutPopup.closeWindow = function () {
	hideNode("global_about");
	$("global_about").style.display="none";	
	ox.api.setModal(false);
//	hideNode("modal-dialog");
//	$("modal-dialog").style.display="none";
};

register("Loaded",function() {
	addOnClose($("global_about"),function() { AboutPopup.closeWindow() });
	addOnClose($("subscribe_folder"),function() { SubscribeFolder.closeWindow() });
	if(configGetKey("modules.calendar.module")) {	
		register("OX_Before_Create_Calendar",function(object) { rightshandler.checkRights("calendar",activefolder,object); });
		register("OX_Create_Object",default_calendar_create_object);
	}
	if(configGetKey("modules.contacts.module")) {	
		register("OX_Before_Create_Contact",function() { rightshandler.checkRights("contacts",activefolder); });
		register("OX_Before_Create_Distributionlist",function() { rightshandler.checkRights("distributionlist",activefolder); });
		register("OX_Create_Object",createNewContact);
	}
	if(configGetKey("modules.tasks.module")) {
		register("OX_Before_Create_Task",function() { rightshandler.checkRights("tasks",activefolder); });
	}
	if(configGetKey("modules.infostore.module")) {
		register("OX_Before_Create_InfoStore",function() { rightshandler.checkRights("infostore",activefolder); });
		register("OX_Create_Object",openNewInfoPopup);
	}
});
var corewindow=window;
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

/*global ox, $, config, internalCache, configGetKey, newnode, _, addDOMEvent,
addTranslated, format, removeDOMEvent, removeChildNodes, jQuery, getFullImgSrc,
ComboBox3, noI18n, register, showNode, centerPopupWindow, unregister,
hideNode, OXCache, OXMailMapping, fileloaded */

/*jslint devel: true, browser: true, forin: true, unparam: true, maxerr: 50, indent: 4 */

function computePerm(nBits, nOffset) {
    return (nBits >> nOffset) & (nOffset >= 28 ? 1 : 127);
}

function FolderPath(module) {
    this.module = module;
    this.folderId = null;
    this.nodeId = null;
    this.className = "linkstyle-headline";
    this.classNameD = "font-style-low";
    this.events = [];
    this.cb = function (module, folderId) {
        return function () {
            ox.api.ui.setModule(module, null, folderId);
        };
    };
    this._cancelDraw = false;
}

FolderPath.prototype = {
    
    setFolderId: function (folderId) {
        this.folderId = folderId;
    },
    
    drawDOMNode: function (nodeId, folderId) {
        
        var Self = this;
        
        if (!this.modify_cb) {
            this.modify_cb = function (e) {
                // not mail? not local update? (mail handles this differently)
                if (e.why !== "folder.update.local" && ox.UIController.getModule() !== "mail") {
                    Self.drawDOMNode();
                }
            };
            ox.api.folder.dispatcher.bind("modify", this.modify_cb);
        }
        if (nodeId) {
            this.nodeId = nodeId;
        }
        if (folderId) {
            this.folderId = folderId;
        }
        if (!$(this.nodeId) || !this.folderId || this._cancelDraw) {
            return;
        }
        this._cancelDraw = true;
        
        // get "myself" from user interface first (it is part of most paths and usually cached)
        var userId = config.identifier;
        internalCache.getUsers([userId], function (user) {
            
            // get display name
            var myName = String(user[userId].display_name);
            
            // get path
            ox.api.folder.getParents({
                folder: Self.folderId,
                success: function (list) {
                    
                    Self.clear();
                    
                    var $l = list.length, i = $l - 1, folder;
                    for (; i >= 0; i--) {
                        
                        folder = ox.util.clone(list[i]);
                        
                        if (folder.id === "1") {
                            // overwrite title
                            folder.title = myName;
                        }
                        var read = computePerm(folder.own_rights, 7) > 0;
                        var myNode = newnode("span", 0, { className: read && i > 0  ? Self.className : Self.classNameD },
                            [ document.createTextNode(folder.title) ]);
                        if (read && i > 0) {
                            var fcb = (Self.cb)(folder.module, folder.id);
                            addDOMEvent(myNode, "click", fcb);
                            Self.events.push(["click", fcb]);
                        } 
                        $(Self.nodeId).appendChild(myNode);
                        if (i > 0) {
                            $(Self.nodeId).appendChild(document.createTextNode(" / "));
                        } else if (Self.additionalNode !== undefined) {
                            $(Self.nodeId).appendChild(Self.additionalNode);
                        }
                    }
                    Self._cancelDraw = false;
                }
            });
        });
    },
    
    drawSearch: function (module, searchTerm) {
        if (!this.nodeId || this.module !== module) {
            return;
        }
        this.clear();
        //#. Title for search results (displayed instead of a folder name).
        //#. %s is the search term.
        //#, c-format
        var myNode = newnode("span", 0, 0, [ addTranslated(format(_("Results for \"%s\""), searchTerm)) ]);
        $(this.nodeId).appendChild(myNode);
    },
    clear: function () {
        if (!$(this.nodeId)) {
            return;
        }
        var i = 0, $i = this.events.length;
        for (; i < $i; i++) {
            removeDOMEvent($(this.nodeId), this.events[i][0], this.events[i][1]);
        }
        this.events = [];
        removeChildNodes($(this.nodeId));
        if (this.modify_cb) {
            ox.api.folder.dispatcher.unbind("modify", this.modify_cb);
            this.modify_cb = null;
        }
    }
};

/**
 * Constructor of the subscribe E-Mail folder dialog
 */

window.SubscribeFolder = (function () {
    
    var Class = function () {
        
        var self = this;
        this.changedFolders = []; // temp storage for changed items
        
        // ox.api.cache.mailSubscription.clear();
        
        this.listFolder = function (list, node) {
            // clear content
            jQuery(node).empty();
            // loop over folders
            var i = 0, $l = list.length, folder;
            for (; i < $l; i++) {
                folder = list[i];
                if (ox.api.folder.is("mail", folder)) {
                    self.addFolderToList(folder, node);
                }
            }
            // stop being busy
            jQuery("#subscribe_folder_status").hide();
        };
        
        this.addFolderToList = function (folder, contentNode) {
            
            var sNode = newnode("td", { width: "18px" }, 0, [
                newnode("img", { verticalAlign: "middle" }, {
                    className: folder.subfolders ? "tree-children" : "tree-nochildren",
                    src: folder.subfolders ? getFullImgSrc("img/folderplus.png") : getFullImgSrc("img/noplus.gif")
                })
            ]);
            
            var iNode;
            
            var tNode = newnode("div", {
                marginLeft: "18px", 
                whiteSpace: "nowrap",
                display: "none"
            }, 0);

            sNode.onclick = function () {
                
                if (!folder.subfolders) {
                    return;
                }
                
                if (sNode.firstChild.src.match(/folderplus.png/)) {
                    
                    // be busy
                    jQuery("#subscribe_folder_status").css("opacity", "0.75").show();
                    
                    // get subfolder
                    ox.api.folder.getSubFolders({
                        folder: folder.id,
                        all: true,
                        tree: "0",
                        storage: ox.api.cache.subscribe,
                        success: function (data) {
                            sNode.parentNode.parentNode.parentNode.parentNode.appendChild(tNode);
                            sNode.firstChild.src = getFullImgSrc("img/folderminus.png");
                            sNode.firstChild.className = "tree-nochildren";
                            tNode.style.display = "block";
                            self.listFolder(data, tNode);
                        }
                    });
                } else {
                    sNode.parentNode.parentNode.parentNode.parentNode.removeChild(sNode.parentNode.parentNode.parentNode.nextSibling);
                    sNode.firstChild.src = getFullImgSrc("img/folderplus.png");
                    sNode.firstChild.className = "tree-children";
                }
            };
            
            function checkAllCheckboxes(id, bool_flag) {
                var all_cb = jQuery("#subscribe_folder_content INPUT[type='checkbox']");
                jQuery.each(all_cb, function (i, val) {
                    if (val.id.indexOf(id + "/") !== -1 && val.id !== id) {
                        if (!all_cb[i].disabled) {
                            jQuery(all_cb[i]).attr("checked", bool_flag);
                            self.addChangedItem({ id: val.id.replace(/^sub_folder_/,""),
                                data: { subscribed: bool_flag } });
                        }
                    }
                });
            }
            
            if (folder.own_rights & 0x3f80) {
                iNode = newnode("input", 0, {
                    type: "checkbox",
                    id: "sub_folder_" + folder.id, 
                    oxid: folder.id,
                    className: "noborder",
                    disabled: !(folder.own_rights & 0x3f80)
                });
                /*
                 * setting checked attribute only if folder is subscribed
                 */ 
                if (folder.subscribed === true) {
                    iNode.setAttribute("checked", "checked");
                }  
                iNode.onchange = function () {
                    self.addChangedItem({ id: iNode.oxid, data: { subscribed: iNode.checked } });
                    checkAllCheckboxes("sub_folder_" + iNode.oxid, iNode.checked);
                };
            }
            contentNode.appendChild(
                newnode("div", 0, { className: "tree-div" }, [
                    newnode("table", { borderCollapse: "collapse", borderWidth: "0", borderSpacing: "0", width: "100%" }, 0, [
                        newnode("tbody", { width: "100%" }, 0, [
                            newnode("tr", 0, 0, [
                                sNode,
                                newnode("td", { width: "18px" }, 0, [
                                    newnode("img", { verticalAlign: "middle" }, { src: getFullImgSrc("img/folder/folder_closed.gif") })
                                ]),
                                newnode("td", 0, 0, [ document.createTextNode(folder.title) ]),
                                newnode("td", { width: "30px", verticalAlign: "middle" }, 0, iNode ? [iNode] : 0)
                            ])
                        ])
                    ])
                ])
            );
            /*
             * Workaround to fix checkbox selection bug in IE
             * As long as the node hasn't been appended to the DOM tree IE6 will ignore
             * setting the checked attribute. A timeout takes care that the node will be
             * appended first.
             */
            if (folder.subscribed === true) {
                setTimeout(function () {
                    if (iNode) {
                        iNode.setAttribute("checked", "checked");
                    }
                }, 10);
            }
        };
        
        this.addChangedItem = function (item) {
            var i = 0;
            for (; i < self.changedFolders.length; i++) {
                if (self.changedFolders[i].id === item.id) {
                    self.changedFolders.splice(i, 1);
                    break;
                }
            }
            item.module = "folders";
            item.action = "update";
            item.tree = configGetKey("modules.folder.tree") || 0;
            self.changedFolders.push(item);
        };
        
        this.saveChanges = function () {
            
            if (self.changedFolders.length === 0) {
                self.closeWindow();
                return;
            }
            
            // be busy
            jQuery("#subscribe_folder_status").css("opacity", "0.75").show();
            
            // update
            ox.api.http.PUT({
                module: "multiple",
                data: this.changedFolders,
                appendColumns: false,
                success: function (response) {
                    // some errors?
                    var i = 0, $i = (response || []).length;
                    for (; i < $i; i++) {
                        if (response[i].error) {
                            ox.UINotifier.error(formatError(response[i]));
                        }
                    }
                    // close & update
                    self.closeWindow();
                    ox.api.cache.subscribe.clear();
                    ox.api.folder.refresh({ tree: "0" });
                    ox.api.folder.refresh({ tree: "1" });
                }
            });
        };
        
        this.openWindow = function (options) {
            // get mail accounts
            ox.api.account.all(function (accounts) {
                // init 
                var scrollBar = accounts.length > 3 ? 4 : null;
                var accSel = new ComboBox3(window, "subscribe_folder_account", "20em", 0, true, "cb_subscribe_folder_acc_chd", scrollBar);
                var i = 0, $l = accounts.length;
                for (; i < $l; i++) {
                    accSel.addElement(noI18n(accounts[i].name),
                        "default" + accounts[i].id);
                }
                accSel.getDomNode();
                // select any other default account
                if (options && options.selected) {
                    accSel.setKey("default" + options.selected);
                }
                
                register("cb_subscribe_folder_acc_chd", function () {
                    self.changeAccount(accSel.getKey());
                });
                self.changeAccount(accSel.getKey());
            });
        };
        
        this.changeAccount = function (id) {
            
            // clear changed folders
            this.changedFolders = [];
            
            // set modal
            ox.api.setModal(true);
            
            // be busy
            jQuery("#subscribe_folder_status").css("opacity", "0.75").show();
            
            // get sub folders
            ox.api.folder.getSubFolders({
                folder: id,
                all: true,
                tree: "0", // tree 0 only!
                storage: ox.api.cache.subscribe,
                success: function (list) {
                    // show node
                    showNode("subscribe_folder");
                    // list top-level folders
                    self.listFolder(list, $("subscribe_folder_content"));
                    centerPopupWindow($("subscribe_folder"));
                    $("subscribe_folder").style.display = "block";
                },
                error: function () {
                    // stop being busy
                    jQuery("#subscribe_folder_status").hide();
                }
            });
        };
        
        this.closeWindow = function () {
            unregister("cb_subscribe_folder_acc_chd", window.SubscribeFolder.changeAccount);
            this.changedFolders = [];
            ox.api.folder.refresh({ tree: "0" });
            ox.api.folder.refresh({ tree: "1" });
            hideNode("subscribe_folder");
            $("subscribe_folder").style.display = "none";
            ox.api.setModal(false);
        };
    };
    
    return new Class();
    
}());

register("OX_Folder_Cleared", function (folder_id) {
    var tmpFn = OXCache.join.add(),
        allCollections = OXMailMapping.getSubCollectionsfromObject({ folder_id : folder_id }),
        i = 0;
    for (; i < allCollections.length; i++) {
        OXMailMapping.deleteObjectsInternal(allCollections[i].objects);
    }
    tmpFn();
});

// mark all mails in folder as read
register("OX_Folder_Mark_Read", function (folder_id) {
    ox.api.http.PUT({
        module: "mail",
        params: {
            action: "update",
            folder: folder_id
        },
        data: { flags: 32, value: true },
        success: function (daten) {
            var lock = OXCache.join.add(),
                map = OXMailMapping,
                col = map.getSubCollectionsfromObject({ folder_id: folder_id }),
                i = 0,
                $i = col.length;
            // loop over object & update
            for (; i < $i; i++) {
                map.editObjectsInternal(col[i].objects, null, true, [map.flagmapping.seen]);
            }
            lock();
            // this works fine on current folder -
            // not if user just right clicks on folder to mark as read, so...
            ox.api.folder.update({
                folder: folder_id,
                local: true, // triggers "modify" event which triggers folder tree repaint
                data: { unread: 0 }
            });
        }
    });
});

fileloaded();
